# UEDGE
A 2D time-dependent fluid simulation code of plasma and neutrals in magnetic fusion devices.
## Brief description 
UEDGE is an interactive suite of physics packages using the Python or BASIS scripting systems. 
The original (circa 2007) Python version was further developed under the FACETS SciDAC project 
[Cary 2008, McCourt 2012]. The plasma is described by time-dependent 2D plasma fluid equations 
that include equations for density, velocity, ion temperature, electron temperature, electrostatic 
potential, and gas density in the edge region of a magnetic fusion energy confinement device. slab, 
cylindrical, and toroidal geometries are allowed, and closed and open magnetic field-line regions 
are included. Classical transport is assumed along magnetic field lines, and anomalous transport 
is assumed across field lines.  Multi-charge state impurities can be included with the corresponding 
line-radiation energy loss. 

## Method of solution
A fully implicit numerical algorithm is used that allows both Newton-like iterations to steady state 
and time-dependent solutions with large time-steps.  A preconditioning matrix is obtained by approximate 
(ILUT) inversion of a numerical finite-difference Jacobian, which is then used in a Newton-Krylov 
solution algorithm. A finite-volume differencing algorithm is used. Over 95% of the coding is in 
Fortran with the remainder being C.

## Related and auxiliary software

Although UEDGE is written in Fortran, for efficient execution and analysis of results, it utilizes 
either Python or BASIS scripting shells. Python is easily available for many platforms 
(http://www.Python.org/). The features and availability of BASIS are described in "Basis Manual Set" 
by P.F. Dubois, Z.C. Motteler, et al., Lawrence Livermore National Laboratory report UCRL-MA-118541, 
June, 2002 and http://basis.llnl.gov/).  BASIS has been reviewed and released by LLNL for unlimited 
distribution. The Python version utilizes PYBASIS scripts developed by D.P. Grote, LLNL.  The Python 
version also uses MPPL code and MAC Perl script, available from the public-domain BASIS source above. 
The Forthon version of UEDGE uses the same source files but utilizes Forthon to produce a Python-compatible 
source.  Forthon has been developed by D.P. Grote (see http://hifweb.lbl.gov/Forthon/ and Grote et al. 
in the references below), and it is freely available. The graphics can be performed by any package importable 
to Python, such as PYGIST.  The parallel version of UEDGE available through Python also uses the PETSc linear 
algebra solver whose development has been led by ANL (https://www.mcs.anl.gov/petsc/).

UEDGE can also be coupled to other codes.  An excellent example is couplling to the DUSTT code from
UCSD (contact rsmirnov@eng.ucsd.edu) that follows the trajectories and ablation of dust particles in
the background UEDGE plasma and provides impurity sources to UEDGE.  For an example, see R. Smirnov
et al., Phys. Plasmas 22 (2015) 012506.

## Getting started 
The easiest way to try out UEDGE is to download a static executable that should run on any Linux system; see
the link to the executable [see uedge_executable file].  The second method is to download the UEDGE source files, and then build a Python
version or a Basis version [see uedge_source directory].

## How to get involved and contribute
Sent email to one of the developers listed below expressing your interest in modifying or developing packages 
for UEDGE.  Either new or improved physics models or numerical algorithms are most welcome.

## Authors contributing to V7 release
T.D. Rognlien, I. Joseph, W.H. Meyer, M.E. Rensink, and M.V. Umansky, LLNL  
(trognlien@llnl.gov, joseph5@llnl.gov, meyer8@llnl.gov, rensink1@llnl.gov, umansky1@llnl.gov)

## Acknowledgements to previous contributors
P.N. Brown, R.H. Cohen, D.P. Grote, A.C. Hindmarsh, L.L. LoDestro, J.L. Milovich, 
A. Pankin, G.D. Porter, and G.R. Smith, all presently or formerly at LLNL; M. McCourt, 
L.C. McInnes, and H. Zhang, ANL; J.R. Cary, A.H. Hakim, S.E. Kruger, and A. Pankin, Tech-X; 
D.A. Knoll, INEEL; D.P. Stotler, PPPL; B.J. Braams, retired, IAEA; A.Yu. Pigarov and 
R. Smirnov, UCSD; J.D. Elder, U. Toronto; M. Groth, Aalto Univ.; and R.B. Campbell, Sandia.

## References
**_UEDGE development_**   
T.D. Rognlien, J.L. Milovich, M.E. Rensink, and G.D. Porter, J. Nucl. Mat. 196-198 (1992) 347-351.  
G.R. Smith, P.N. Brown, R.B. Campbell, D.A. Knoll, P.R. McHugh, M.E. Rensink, and T.D. Rognlien, J. Nucl. Mater. 220-222 (1995) 1024.  
M.E. Rensink and T.D. Rognlien, J. Nucl. Mater. 266-269 (1999) 1180.  
T.D. Rognlien, D.D. Ryutov, N. Mattor, and G.D. Porter, Phys. Plasmas 6, (1999) 1851.  
T.D. Rognlien, M.E. Rensink, and G.R. Smith, "User manual for the UEDGE edge-plasma transport code," January 2000, LLNL Rpt. UCRL-ID-137121, lastest revision May 1, 2013.  

**_Forthon development_** 
D. P. Grote, A. Friedman, I. Haber, ``Methods used in WARP3d, a Three-Dimensional PIC/Accelerator Code'', Proceedings of the 1996 Computational Accelerator Physics Conference, AIP Conference Proceedings 391, p. 51.  
See also: http://hifweb.lbl.gov/Forthon/  .

**_FACETS project_**    
J.R. Cary, J. Candy, R.H. Cohen et al., J. Phys.: Conf. Ser. 125 (2008) 012040.  
A.H. Hakim, T.D. Rognlien, R.J. Groebner et al., Phys. Plasmas 19 (2012) 032505.  
M. McCourt, T.D. Rognlien, L.C. McInnes, and H. Zhang, Computational Science & Discovery 5 (2012) 014012.  

## Release 

UEDGE is released under an LGPL license.  For more details see the
NOTICE and LICENSE files.

``LLNL-CODE-759137``
------
--------

To build the FORTHON version of UEDGE, you need to do the following things.

1. Make sure that Python is on your system, along with the site-packages
Numeric, PyPDB, and a plotting package like PyGist or GnuPlot.  To install 
and use PyPDB, you also need to install PACT (see 2 below). You can get 
Numeric and PyGist links on hifweb.lbl.gov/forthon (see 3 below), and 
PyPDB and PACT are included as part of this distribution. Since installing
extra site-packages requires permission to write to the python directories,
it may be easier to build your own version of python on a public system where
you don't have root privileges.  After downloading a recent version of the
Python source, you can follow these simple steps to build your own Python:

./configure --prefix=[full path to the present directory]
gmake
gmake test (if you want to test things; not necessary)
gmake install

2. Installation of PACT: There is a README file that gives many details.  
A short summary of settings that work for PyUEDGE utilization are as 
follows (almost same as for Python above, but directory will be different):

./configure --prefix=[full path to the present directory]
gmake
gmake check  (if you want to test things; not necessary)
gmake install

Note that after the installation of PACT, the directory named in --prefix= 
should also be the path pacthome defined in the file PyPDB/install that
is used in the PyPDB installation.

3. Make sure you have Forthon installed on your system.  If you need
to build/install it, you can get it from hifweb.lbl.gov/forthon.  Check
compatibility of Fortran compilers before building (see 4).

4. Make sure you have a Fortran 90/95 compiler, and that it is one of 
the ones in Forthon/Lib/compilers.py. If you have multiple Fortran 
compilers, FORTHON will pick one based on the first one it recognizes in
your search path.  Presently, it is recommended that you download and use
g95, which has shown to work on both Linux machines and a Mac; put g95 path
first in your search path to ensure that Forthon uses it.
(The following is experimental: If you want to specify
a compiler you need to edit Makefile.Forthon, providing an argument for 
FCOMP and inserting "-F [compilername]" after "python setup.py" under "all".)

5. Make sure that uedge/pyscripts is in your python search path  
(SETENV PYTHONPATH .../uedge/pyscripts)

6. There are two places where presently you need to explicitly insert
the path to your version of python; (1), the first line of the 
Forthon/Forthon file, and (2), the variable MYPYTHON in the 
uedge/Makefile.Forthon file. Aliases don't work in these scripts and
makefiles.

7. The selection of machine precision (32 or 64 bit) is not automated.  
The precision is specified as WORDSIZE in mppl.h.  WORDSIZE needs to be
edited by hand for 64 bit; you can probably ignore this item.

8. You're now ready to build.  Run "make -f Makefile.Forthon" in the
uedge top directory.  This will create .f files from the mppl files
and compile.  On subsequent makes it will recreated .f's for any
mppl's that have been touched since the last make. (more precisely, 
since the last creation or touching of the .f.)
   On Linux, you may find that you get the following error at the 
very end of the build:

gcc: build/aphpymodule.o: No such file or directory
gcc: build/apipymodule.o: No such file or directory
gcc: build/bbbpymodule.o: No such file or directory
gcc: build/compymodule.o: No such file or directory
gcc: build/flxpymodule.o: No such file or directory
gcc: build/grdpymodule.o: No such file or directory
gcc: build/svrpymodule.o: No such file or directory
gcc: build/wdfpymodule.o: No such file or directory
error: command 'gcc' failed with exit status 1

If you do get this error, from the uedge directory, manually copy each 
missing files into the build directory as follows:
cp aph/aphpymodule.o build/.
cp api/apipymodule.o build/.
...

Then to "make -f Makefile.Forthon" a second time.  This problem is being
worked on and should be fixed soon (it does not occur on Macs).

9. When done, make a soft link of uedgeC.so from the top uedge
directory to the pyscripts subdirectory.

10. You should now be ready to run a couple of test cases.

   Go to uedge/test/Forthon_case1, startup a python session (just type
python) and read in the input file as follows:

>>> execfile("rd_forthon_case1.py")

after 30-60 seconds, you should have a set a numbers printed to the screen
that are the plasma variables; compare to the file output_case1.  You can
see the options used from the input file, rdforthon_case1.py.  This case
is a simple slab geometry and uses vodpk, a Newton-Krylov time integration 
to steady state. Note that installation of PACT and PyPDB should not be
required to run this test case.

   Next, you can go to uedge/test/Forthon_case2, which uses a real tokamak
magnetic equilibrium (contained in aeqdsk and geqdsk) and a direct Newton-
Krylov iteration to steady state.  This test case requires that PACT and 
PyPDB be installed for the version of Python being used. Again, start a 
python session, and then type

>>> execfile("rd_forthon_case2.py")

Here you will see an output line from each linear iteration, with the L2-norm
residual of the right-hand side decreasing to convergence of the system,
followed by some of the plasma variables at the outer midplane (This is a 
very easy case.) Compare with the output in the file output_forthon_case2.rtf.

############################################################################
##
## Instructions for building a uedge shared-object python module
## This is a major change from the pre-2019 version. 
##
##   $Id: README_Pyuedge,v 7.1 2019/06/17 21:51:34 meyer8 Exp $
##
###########################################################################

#### --- Read the Uedge README.disclaimer file in directory uedge. --- ####


I. Checking out and building the needed modules:

 1) The python module is now installed with the "pip" command. It is
    recommended that you have the Anaconda distribution installed. If
    so then "pip" is part of that distribution. 

    a) To just install the uedge module without having source do
       pip install uedge

    b) To install and have source do the following:
       pip download uedge
       tar -zxvf uedge.7.0.8.0.3.tgz 
       cd uedge-7.0.8.0.3
       python setup.py build
       python setup.py install
       python setup.py test

 2) If you have access to the LLNL/FEP cvs archives, then

       setenv CVS_RSH=ssh
       setenv CVSROOT :ext:<login-name>@singe.llnl.gov:/usr/local/cvsroot
       cvs co uedge
       cd uedge
       python setup.py build
       python setup.py install
       python setup.py test

                            LEGAL NOTICES

This work was performed at the University of California, Lawrence Livermore
National Laboratory (UC LLNL) under contract no.  W-7405-ENG-48 (Contract 48)
between the U.S. Department of Energy (DOE) and The Regents of the University
of California (the University) for the operation of UC LLNL.  The rights of
the Federal Government are reserved under Contract 48 subject to the
restrictions agreed upon by the DOE and University as allowed under DOE
Acquisition Letter 97-1.

UEDGE is released for DOE-related work, and recipients are required to contact
the author before further dissemination of the package or any of its
components.

This work was prepared as an account of work sponsored by an agency of the
United States Government.  Neither the United States Government nor the
University of California nor any of their employees makes any warranty,
express or implied, or assumes any liability or responsibility for the
accuracy, completeness, or usefulness of any information, apparatus, product,
or process disclosed, or represents that its use would not infringe privately
owned rights.  Reference herein to any specific commercial products, process,
or service by trade name, trademark, manufacturer, or otherwise, does not
necessarily constitute or imply its endorsement, recommendation, or favoring
by the United States Government or the University of California.  The views
and opinions of authors expressed herein do not necessarily state or reflect
those of the United States Government or the University of California, and
shall not be used for advertising or product endorsement purposes.

*****************************************************************************
This file was committed $Date: 2018/02/28 18:32:42 $ and tagged $Name: V7_07 $

Version 3.0	Corresponds to CVS archives as of 12/14/99

Version 3.1	Corresponds to CVS archives as of 01/13/00

Version 3.2	Corresponds to CVS archives as of 02/20/00
		- Fixes bug in visx flux-limit term msh
		- Allows boundary conditions to be properly relaxed with
		  stiff rate equations for svrpkg=nksol and isbcwdt=1

Version 3.3	Corresponds to CVS archives as of 08/07/00
		- Substantial changes to the parallel current at the plate
		  boundaries (including kappar,l) giving better ExB behavior
		- Force feex to always be into divertor plates
		- Remove guard-cell values of Te on plates for determining
		  parallel electron heat conductivity there
		- Include momentum sources from ionization, recomb., & cx
		  for multispecies equations if full momentum eqns. solved
		- Added option to use lgmax for flux limiting gas diffusion
		  using this scale-length - more robust
		- Change radial convective flux for ion momentum eqn to use
		  the harmonic average of two pairs of densities; can be
		  important for neutral momentum near ionization front
		- Added coeff. cfloye,i to change radial convective heat flux
		  from 5/2 to 3/2 for modeling ExB turbulence; default=5/2
		- Allow simultaneous albedo, chem sputtering, and recycling
		  for gas side-wall boundary conditions
		- Added model for wall impurity evaporation based on the input
		  temperature profile tvapo.
		- Allow gas outflow measured on inner wall to be injected on
		  outer wall, and vice versa
		- Fixed potential bug defining ixc=max(0,ixpt1+1) in bouncon
		- Fixed bug in definition of xcwi,o used in determining wall
		  source location; also in geometry.m, gradb2 had incorrect
		  cos(angfx) factor.

Version 3.4     Corresponds to CVS archives as of 11/28/00
                - changed the interpolation (for isgindx=1 default) to be 
                  independent in poloidal segments of leg, core, and then leg
                - changed variable for radial pressure-gradient velocity from
                  vycd to vycp
                - enabled the use of ADAS ionization and recombination rates
                  that can now depend on electron density even for impurities
                - corrected sign on nurlxe,i for iste,ipfc=0 boundary
                  condition - only affectd svrpkg="vodpk"
                - corrected iv indexing problem for isutcore B.C. for
                  isphibcc.ne.1
                - added time-dependent inertial radial-ion-current called
                  fqydt; comes from m*dv/dt term in perp. ion momentum eq.

(Below t_Ver... means a temporary version which is not saved on all platforms)
t_Version 3.41	Corresponds to minor modification to Version 3.4 where a call
		to the allocate routine is force on the first call to exmain
		- added variable icallall to indicate when allocate called once
		- initialize ifexmain to zero (previously unset)

t_Version 3.42	Only one change from V3.41; the default value of fvapi is
		changes from 1 to 0.  This can affect chemical sputtering on
		the inner (private-flux) wall and fvapi=0 should be used.
		V3.41 can still be used if one explicitly sets fvapi=0 before
		executing a run.

t_Version 3.43	Only changes from V3.42 are that chemical sputtering is now
		included on the wall regions even when matwallo,i=1, just as
		as the albedo is always included independent of matwallo,i;
		and the use of energy-transmission boundary conditions on the
		inner wall is not automatic for matwalli=1, but must be set
		by iste,ipfc = 3, if desired.

Version 3.44	May be the same as V3.43, but dervived from the CVS achieve
		dated 05/06/01, rather than the working files from Rognlien.

Version 3.45    From cvs archive on 06/08/01.  Corrects a bug when running on
                LINUX machines by placing the definition of ix_fl_bc to before
                the first do-loop in subroutine bouncon.  Also adds the outer
                midplane poloidal index, ixmp, to be available from the
                parser, and improves the accuracy of the ixmp calculation.
                Finally, replaces the default for the potential boundary
                condition on the core to be iphibcc=0.

Version 3.46    From CVS archive of 07/31/01.
		Only one change for V_3.45, where Takenaga's bug in jac_calc
                is corrected, i.e., ix and iy are now defined just before
                idxphi(ix,iy) if-test.  Probably has no impact, but
                possibly it does (read out-of-bounds problem)

Version 3.47	From CVS archive of 10/09/01.
		Corrected core boundary conditions to include the fact the
		diamagnetic surface fluxes can exits.  UEDGE only uses
		the grad_B portion of the diamagnetic drift velocity
		in the "body" of the computational region since the
		divergence of the other portion is identically zero.
		However, on the boundary surfaces, one must resort to
		the full diamagnetic expression for obtain particle
		and power fluxes.  The correction for the radial
		current is available in older UEDGE version, but
		requires proper setting of switches.  For cross-field drifts
		on, the recommended settings of the switches are:
		cfniybbo=0., cfniydbo=1., cfeeybbo=0., cfeeydbo=1.,
		cfqybbo=0.  cfqydbo=1. Also changed scale length B.C. for
		lyni (isnwconi,o = 2) to apply to niy0 and niy1 variables
		instead of ni(,ny) and ni(,ny+1); this is consistent with
		definition of fniy for nonorthogonal mesh.


Version 3.48	From CVS archive of 10/22/01.
		Corrected a bug in the grad_B velocity for bphi>0 (the
		standard DIII-D case has bphi<0).  Also corrected a bug
		in the nonorthogonal-mesh representation of the cross-field
		v2 velocities [mistakenly divided v2's by cos(angfx)].  Set
		the default of del2nksol=1e-14 (instead of zero, which then
		used machine-calculated round-off - sometime too small on 
		LINUX). Corrected classical parallel viscosity coefficient
		from 1.92 to 0.92, as given by Braginskii.

Version 4.0	Corresponds to CVS archive on 01/23/02.  This is a major
		upgrade that includes the capability of unbalanced double 
		nulls developed by M. Rensink.  A number of other improvements 
		have also been made; these are as follows:
		- refinement of the multispecies capability where one can
		  now have the impurity species be dominant over hydrogen
		- tritium can now run run as an impurity species
		- generalized boundary conditions allowing separate inner (pf)
		  and outer wall scale lengths; lyup added
		- allow fixed gas density at plate boundaries for BORIS comp.
		- corrected problems associated with using f90 on the SUNs;
                  must now use SUNWspro 5.0 compiler or higher.  Thus, BASIS12
		  and f90 is now be used on all platforms (SUN, LINUX, DEC).
		- Added background source to erliz ionization energy loss
		  using ngbackg; this changes vsoree and electron eng. eqn.

		Below is a compilation by Rensink of changes to variables
		in moving from Ver_3.48 to Ver_4.0:
	Input/output variables with changed names (and dimensions):

   		csin(nispmx)  -> csfaclb(nispmx,1)
   		csout(nispmx) -> csfacrb(nispmx,1)

   		fchemypi -> fchemylb(1)
   		fchemypo -> fchemyrb(1)

   		fphysypi -> fphysylb(1)
   		fphysypo -> fphysyrb(1)

   		recypi(0:ny+1,ngspmx) -> recylb(0:ny+1,ngspmx,1)
   		recypo(0:ny+1,ngspmx) -> recyrb(0:ny+1,ngspmx,1)

   		recycfi -> recycflb(1)
   		recycfo -> recycfrb(1)

   		ndati(ngspmx) -> ndatlb(ngspmx,1)
   		ndato(ngspmx) -> ndatrb(ngspmx,1)

   		ydati(ngspmx,50) -> ydatlb(ngspmx,50,1)
   		ydato(ngspmx,50) -> ydatrb(ngspmx,50,1)

  		rdati(ngspmx,50) -> rdatlb(ngspmx,50,1)
  		rdato(ngspmx,50) -> rdatrb(ngspmx,50,1)

  		albpi(0:ny+1,ngspmx) -> alblb(0:ny+1,ngspmx,1)
  		albpo(0:ny+1,ngspmx) -> albrb(0:ny+1,ngspmx,1)

 		fngxsi(0:ny+1,ngspmx) -> fngxslb(0:ny+1,ngspmx,1)
 		fngxso(0:ny+1,ngspmx) -> fngxsrb(0:ny+1,ngspmx,1)

 		adati(ngspmx,50) -> adatlb(ngspmx,50,1)
 		adato(ngspmx,50) -> adatrb(ngspmx,50,1)

 		ngplati(ngspmx) -> ngplatlb(ngspmx,1)
 		ngplato(ngspmx) -> ngplatrb(ngspmx,1)

  		sputti(0:ny+1,ngspmx) -> sputtlb(0:ny+1,ngspmx,1)
 		sputto(0:ny+1,ngspmx) -> sputtrb(0:ny+1,ngspmx,1)

 		albedopi(ngspmx) -> albedolb(ngspmx,1)
 		albedopo(ngspmx) -> albedorb(ngspmx,1)


	Input/Output variables with changed dimensions only:

   		newbcl -> newbcl(1)
   		newbcr -> newbcr(1)

   		phi0l(0:ny+1) -> phi0l(0:ny+1,1)
   		phi0r(0:ny+1) -> phi0r(0:ny+1,1)

   		yylb(0:ny+1) -> yylb(0:ny+1,1)
   		yyrb(0:ny+1) -> yyrb(0:ny+1,1)

   		upxpt(1:nusp)   -> upxpt(1:nusp,1)
  		nixpt(1:nusp)   -> nixpt(1:nusp,1)
  		visyxpt(1:nusp) -> visyxpt(1:nusp,1)
  		vyhxpt(1:nusp)  -> vyhxpt(1:nusp,1)
  		vyvxpt(1:nusp)  -> vyvxpt(1:nusp,1)
  		fmihxpt(1:nusp) -> fmihxpt(1:nusp,1)
  		fmivxpt(1:nusp) -> fmivxpt(1:nusp,1)

   		fdiaxlb(0:ny+1) -> fdiaxlb(0:ny+1,1)
   		fdiaxrb(0:ny+1) -> fdiaxrb(0:ny+1,1)

   		bcel(0:ny+1) -> bcel(0:ny+1,1)
  		bcer(0:ny+1) -> bcer(0:ny+1,1)
  		bcil(0:ny+1) -> bcil(0:ny+1,1)
   		bcir(0:ny+1) -> bcir(0:ny+1,1)
  		kappal(0:ny+1) -> kappal(0:ny+1,1)
   		kappar(0:ny+1) -> kappar(0:ny+1,1)

   		fqpsatlb(0:ny+1) -> fqpsatlb(0:ny+1,1)
   		fqpsatrb(0:ny+1) -> fqpsatrb(0:ny+1,1)

	NOTE on option isnfmiy=1:

	In previous versions of UEDGE, isnfmiy=1 had the effect of setting
	fmiy=0 for velocity cells straddling the x-point because the spatial
	factors gyhxpt,gyvxpt,sxyxpt were not calculated.  Now, these spatial
	factors are finite for all EFIT-based configurations, so in order to
	recover previous results you must set the new coefficient cfnfmiy=0
	when isnfmiy=1; the preferred (default) setting is cfnfmiy=1.

Version 4.1	Corresponds to CVS archive on 02/16/02. 
		- Added the additional flux limit for the neutral thermal
		  conductivity and viscosity via the input scale lengths 
		  lgtmax and lgvmax.
		- Slight change to pscx0 for first impurity charge state to
		  include niz_floor for consistency with Ver_3.48.
		- Corrected bug in Ver_4.0 only relating to the sign of
		  the albedo pumping (albrb) on the right plate.
		- Changed the radial gas scale length for isngcore=2 from
		  v_t**2/(nucx*nuiz) to v_t**2/(nuix*nuiz).
		- Corrected Ver_4.0 only bug in calculation of sygytotc in 
		  geometry.m; ixpt1,2(2) was referenced even if nxpt=1.
		- Corrected Ver_4.0 only bug in first definition of argo in
		  subroutine walsor; changed xnoti --> xnoto

Version 4.12	Corresponds to CVS archive of dce package on 05/08/02. 
                - Dce cvs -r1 - all routines are rpc. Connection established
                  via well know port (12100) first then portmapper second.
                - Dce cvs -r2 - routine rzxform, and supporting modules, linked
                  directly into Uedge instead of the client rpc stubb. 

Version 4.12_mds  Identical to Version 4.12 above but has package mds added.
                  This provides access to MDSPlus through which users may
                  access DIII-D equilibria, time series data, and profile
                  data to name but a few. (LINUX version only for now)

Version 4.13	Corresponds to CVS archieve of 05/08/02, except the dce file
		c_dce.c has be corrected (08/15/02) by Meyer and the routines
		wmodi and wmodo in boundary.m have corrected signs in the
		definition of fngysi,o used when gas is removed in one
		source region and injected in another (08/15/02).

Version 4.2	Corresponds to CVS archive of 08/26/02.  Changes include:
		- Add the ExB boundary velocity for plate flux which got lost
		  after Ver_3.48.
		- Now two options for phi on side walls; if iphibcwi,o=0, then
		  d(phi)/dy=0, or if iphibcwi,o=1, then phi=phintew,o*te/ev.
		- Allow diamagnetic and B x gradT heat flows for the plate
		  B.C. if cfeixdbo & cfeexdbo = 1.
		- Allow the density radial scale length to be poloidally
		  dependent by setting isulynix=1 & filling lynix(ix,2).
		- Corrected an error in the sign of re-injected gas on the
		  outer wall in routine wsmodo.
		- Corrected impurity isotope counter, nzsp_rt, so that it works
		  when turning off 1 of 2 or more isotopes through isnion=0.
		- New core density boundary condition isnicore=5 for dni/dy=0.
		- Allow modification of total convective gas flux at guard-cell
		  interface through gcfacgx,y; added (1-rrv**2) factor; similar
		  factor gcfacgtx,y only effects gradT convective gas flux.
		  New default has gcfacgx,y=1, but gcfacgtx,y=0 for robustness.
		- New callable subroutine pradpltwl calculates radiation power
		  flux on plates and wall; pwr_plth,z and pwr_wallh,z arrays.
		- Extend zero fluxes for geometry="dnbot" to ix=nxc+-1.
		- Change difpr meaning and add difp_use to give density diff
		  velocity prop_to (difpr+difp_use)(1/P)(dP/dr - 1.5ndTe/dr).
		- Generalized vy_use(ix,iy,ifld) to be species dependent.
	 	- New option for isbohmcalc=3 gives anomalous diffusion scaling
		  as (1/B)**inbdif with input coeff. difniv(iy), kyev(iy),etc.
		- Add array wjdote to hold the J_dot_E electron heating term.
		- Add routines write_profs_boris & read_profs_boris to exchange
		  profile data with the BORIS code.
		- Allow inclusion of only a radial portion of the inner core
		  region by setting nyomitmx > nysol.
		- Add a factor cffqpsat that scales the allowable saturation
		  current in the sheath-potential calculation.
                - Allow DCE package operation on all platforms.
		- Include kinetic Pastukhov correction to elec. particle loss
		  for sheath potential calc; set cfkincor=0 to omit.
		- Include flux limiting of parallel thermal force through
		  flalftf; default (1e20) is off, best guess is flalftf=1.

Version 4.21	Corresponds to CVS archive of 09/16/02.  Changes include:
		- Allow poloidal distribution of extra cells around x-point
		  (via non-zero nxxpt) to be manipulated independent above (u)
		  and below (l) the x-point via the parameters alfxptu,l and
		  alfxpt2u,l that replace alfxpt and alfxpt2.  Here alfxptu,l
		  controls the spacing of the nxxpt cells relative to each 
		  other, and alfxpt2u,l adjusts the spacing of the newly
		  refined region and the one adjacent poloidal cell.
		- The second "localized" boundary condition for phi on core 
		  boundary is now applied at the outer midplane rather than 
		  ixpt2; also, isutcore=2 now gives d^2(ey)/dy^2 = 0 at outer
		  midplane.
		- Allow the core boundary condition d^2(up)/dy^2=0 if
		  isupcore=2.
	 	- Add option to turn off radial cross-field drifts only at the
		  private flux and outer wall by setting isybdrywd=1.  This
		  gives only diffusive flux, for regions where matwallo,i=1, 
		  that is everwhere outward if a gradient scale-length option
		  is specified (isnwcono,i=3).
		- Set default for gas flux-limit flalfgy=1e10, which gives no
		  flux limit unless reduced by user; defaults for flalfgx,xy
		  are also 1e10.  All three should be set equal.
 
Version 4.22  Corresponds to CVS archive of 12/10/02.  Changes include:
                - Changed the defaults for background neutral and impurity
                  sources with the exponents now ingb=inzb=2 and
                  ngbackg(ngspmx)=1e14; these changes can have big impact
		  on previous converged solutions.
                - Changed the evaluation of the fqy current to include the
                  points iy=0 and ny; previously omitted because of 2 BC at
                  each wall. Some effect on the potential.
                - Added an option to set a constant value of zeff.  Use
                  iszeffcon as switch and value is zeffcon.
                - Added separate energy transmission factors for the walls,
                  called bceew & bceiw; used if iste,ipfc=4 or iste,iwc=4.
                - Generalized spatially dependent radial diffusion if 
                  isbohmcalc=3 to give, for example,
                  dif_use=(Btmid/Bt)**inbtdif*(Bpmid/Bp)**inbpdif. Also include
                  vy_use=vyconv(iy)*(Btmid/Bt)**inbtdif*(Bpmid/Bp)**inbpdif.
                - Changed the form of the E-dot-J heating term to use E & J
                  explicitly, instead of div(J*phi) form based on div(J)=0.
                  At ix=0 and nx, ex does not include bias-voltage effect.
                - Special case for recycrb,lb < -1 now gives plate neutral BC
                  with ng=nglfix or ngrfix.
 
Version 4.3  Corresponds to CVS archive of 06/30/03.  Changes include:
		- Added a CVS branch for making a PYTHON version of UEDGE;
		  contact authors.
		- Added the capability of making UEDGE with the BASIS MIO
		  software, instead of MMM
                - Joule heating can now be calculated two ways: jhswitch=1
		  gives old method where J.E=-div(J*phi) since div(J)=0; and
		  jhswitch=2 uses J.E directly, with correct BC for biasing.
                - Changed material-wall boundary conditions to apply for
		  matwalli,o > 0, rather than previous matwalli,o = 1.
		- Made electron velocity vey purely diffusive if isybdrywd=1,
		  just as the ion velocity vy has been.
		- Corrected array initialization of pwr_wallz,h with
		  ny+2 --> nx+2 (in pradpltwl)
		- Corrected ixv viewing index in subroutine pradpltwl to work
		  properly for full double nulls with 2 x-points.
		- Corrected re-injected neutral flux to be consistent with
		  pumped flux at iy=0 and iy=ny+1 (iy=0 & 1 inconsistency).
		- Corrected minor bug for kfeix at right boundary - only
		  affects isimpon=5 (Hirshman's reduced-ion impurities).
		- Removed INEL average-ion impurity model (isimpon=3,4).
		- Removed the svrpkg="lsode" solver option; use "vodpk"
		- Corrected flxlimf flux-limiting factor so that ltmax does
		  not appear in denominator, which can lead to divide by 0.
		- Omitted initialization of some arrays (te,iwalli,o; bctype;
		  capx; dphi_iy1; and cfvli) due to IBM SP problem
		- Added variable yloext and switch isyloext for external dyl/dt
		  to test coupling to turbulence
		- Added two user-specified radial velocities, vyte,i_use, 
		  which yield radial energy fluxes vyte,i_use*te,i*ni; used
		  for coupling external energy fluxes (e.g., from BOUT).
		- Moved some calculations from readefit to procefit to support
		  reading MHD data from files other than aeqdsk & neqdsk; 
		  target is MDSPLUS.
		- Removed all calls to allot and instead use gchange; 
		  facilitates PYTHON version
		- Added kypton to the ionization energy tables in fimp.m, so
		  multi-specie kyrpton calculations are possible.
		- Added two routines to calculate the line emissivities of
		  hydrogen and impurities based on scripts from Gary Porter.
		  Uses Isler data.  Subroutine readrates(apidir,fname) reads
		  data in path apidir having name fname.  Subroutine
		  calcrates(a,b,c) calculates emissivity c for density a and
		  electron temperature b.
		- Added a compiled function to calculate line integrals, called
		  lineintegral(arg_rz,rvertex,zvertex), which calculates the
		  integral of the pixel array arg_rz along a path given by the
		  vector (rvertex(1:2),zvertex(1:2)).  Similar in functionality
		  to Gary Porter's script lineintegral, but much faster.  Can
		  now be used in scripts such as write_fslw_H for hydrogen 
		  lines.
		- Changed names of startup files defining various paths and
		  initializations from aph_dir, uedge_path, init.bas to	
		  .aph_dir, .uedge_path, and .init.bas.  Now if absent, UEDGE
		  ignores them and proceeds.  Store in uedge/scripts.
		
Version 4.31  Temporary version with no public release, approximately 
		corresponds to CVS archive of 12/02/03.  Changes include:
		- Physical and chemical sputtering from hydrogen ions incident
 		  on the walls included.
		- The low-energy reduction factor in the Haas chemical
		  sputtering for isch_sput=7 is now an input variable called
		  redf_haas.
		New input variables for wall sputtering:
		  isi_sputw(igsp) # Determines the outer wall sputtering for
		  		  # ions for gas species igsp 
		  isi_sputpf(igsp) # Determines the private flux wall
		  		   # sputtering for ions for gas species igsp
		Options:
		  isi_sputw(igsp) = 0 # No ion sputtering (old case)
		  isi_sputw(igsp) = 1 # Includes physical sputtering from ions
  		  isi_sputw(igsp) = 2 # Adds chemical sputtering from ions
		  		      # using model isch_sput(igsp);  must set
				      # isch_sput to nonzero value (e.g., 7)
		  Normally, igsp=2 for the switches above to simulate carbon
		  in a hydrogen plasma.
		- Setting isch_sput=7 also turns on the chemical sputtering
		  from neutral gas as before; this can be scaled by the factor
		  fchemywo (outer wall) or fchemywi (for private flux region).
		  However the ion-induced chemical sputtering (from
		  isi_sputw=2) does not have a scaling factor.
		- The new sputtering fluxes, multiplied by the cell area, from
		  the ions are stored in the output arrays:
		  sputflxw(ix,igsp) # units of particles/sec (positive) 
		  sputflxpf(ix,igsp) # units of particles/sec (negative)
			where ix is the usual poloidal index.  These
			fluxes are added to the impurity gas flux at the wall,
			in addition to any recycling or pumping specified.
			Note that impurity sputtering is not included yet.
		- Also, the reduction factor in the Haas chemical sputtering
		  model for isch_sput=7 is now a parameter called redf_haas
		  that can be changed from the UEDGE prompt or in an input
		  file.  The default is the previous value of 0.2.

Version 4.32  Corresponds to CVS archive of 12/19/03.  Changes include:
		- All changes noted above in temporary version 4.31
		- A new LINUX branch for the PYTHON version is added, which
		  is accessible in uedge/Pyuedge/LINUX.  Requires MPPL and
		  MAC, but not BASIS; MMM or MIO BASIS builds also work
		- For istabon=3 (DEGAS tables), charge-exchange rate rcx
		  now assumes neutral temp = ion temp (before T_n=const)
		- Corrections, additions to the mesh generating routines:
		  > for inflx & inflx1, replace redundant nyflx, npsi with
		    nym, jdim
		  > other modifications to inflx1 to improve mesh generation
		  > modified grd/grdwrit & grdcomp.m to work for ishalfm=1, 
		    corresponding to a half-mesh
		  > other details from cvs log files flx/flx.v flxread.m 
		    flxwrit.m flxcomp.m and grd/grd.v grdread.m grdwrit.m
		    grdcomp.m
		  > different end-of-mesh test allowed for each plate
		  > made istcvon flag for controlling search directions in
		    mesh construction obsolete; use altsearch flag instead

Version 4.33  Corresponds to CVS archive of 02/20/04.  Changes include:
		- Pyuedge branch has been modified to include MAC (called mac2
		  to avoid confusion) in uedge/Pyuedge/Mac_scripts and
		  the pybasis source in uedge/Pyuedge/Pymac_scripts
		- Pyuedge Makefile cleaned up for LINUX
		- Updated pybasis with new scripts from Dave Grote, including
		  his more extensive pyBasis
		- Removed prefixes flx. from a couple of gallot calls, so
		  that EFIT files can be used with pyuedge
		- Change maximum scale lengths for flux limiting gas density
		  and temp fluxes, lgmax and lgtmax, to be vectors (igsp)

Version 4.34  Corresponds to CVS archive of 07/02/04.  Changes include:
		- Added user-input fluxes fniyos_use, feeyosn_use, and
		  feiyosn_use; to fix the fluxes fniy etc to these values,
		  added evolving vy_cft etc; for BOUT coupling
		- Added fixed convective components for feey and feiy called
		  vyte_use and vyti_use, added to kye,i_use for BOUT coupling
		- Added impurity-impurity collisions (CX & elastic) for large
		  impurity fractions.  New cross-section sigcxms and elastic
		  rate keligii; impact neutral diffusion & ion up and ti.
		  New collision frequencies nucxi, nueli, and nuelg.
		- New impurity-impurity friction turned on with cfupimpg and
		  ion temp (ti) cooling turned on with cftiimpg.
		- Modified subroutines writing DEGAS namelist input files to
		  account for extra poloidal x-point cells via nxxpt>0 and
		  different nxcore inside and outside.
		- Mapping of mesh from UEDGE to DEGAS now utilizes (rm,zm), 
		  not (cmeshx,cmeshy). Also, wall DEGAS construction now done
		  in subroutine degasgrid.

Version 4.35  Corresponds to CVS archive of 09/14/04.  Changes include:
		- Included three more options for hydrogen atomic rates from
		  D. Stotler (Aug. 2004):
		    -- istabon=11 for optically thin - same as istabon=10
		    -- istabon=12 for optically thick Lyman_Alpha
		    -- istabon=13 for optically thick to all lines
		- The new hydrogen rates also include diagnostic data for
		  coupling coefficients of n=4-9 hydrogen lines to the ground
		  state (called pneX1, where X=n) and to the continuum (pneX2).
		  Previous only n=2-3 line data was available.
		- Provided an option to make the toroidal magnetic field a 
		  constant at bcentrg; set isbphicon=1; used for approximating
		  stellartors.

Version 4.36  Corresponds to CVS archive of 10/11/04.  Changes include:
		- Included the escape-factor radiation transport model for
		  hydrogen Lyman-alpha radiation developed by H. Scott and M.
		  Adams for UEDGE.  Hydrogen ionization/recombination rates 
		  and energy loss are now a function of the minimum local 
		  optical depth for Lyman-alpha  to a boundary surface
		  [calculated as rtau(ix,iy)].  These use a new hydrogen table
		  from H. Scott called ehrtau.dat with rates a function of te, 
		  ne, and rtau. To access the model, set
		    -- rtauxfac=1 (or positive), and either:
		    -- istabon=14 gives linear intepolation in rtau, or
		    -- istabon=15 gives log interpolation in rtau
		  Note that these models may cause convergence problems
		  since they give nonlocal dependences for rtau, and no attempt
		  has yet been made to provide a "good" Jacobian for the 
  		  preconditioner.
		- A user-specified radial convective velocity, vyup_use(ix,iy)
		  has been included to convect parallel momentum energy density
		  radially.  In anology with vyte_use for Te, values can come
		  from BOUT in the UEDGE/BOUT coupling.

Version 4.37  Corresponds to CVS archive of 04/03/05.  Changes include:
		- Changed flags controlling plate temperature BC; ifluxl,r is
		  now replaced by ibctepl,r and ibctipl,r for electrons and 
 		  ions, with l,r denoting left and right plates; =0 for fixed
		  te=tepltl,r; =1 for sheath trans; =2 for dte,i/dx=0.
		- Added core density BC that allows user to specify radial
		  gradients if isnicore=5; lynicore is scale length and
		  ncoremin is minimum allowed density
		- For the core density BC isnicore = 3, added the neutral 
		  current through the core bdry to curcore, i.e., the net ion
		  current is now curcore-recycc*sum(fngy) over the bdry; 
		  NOTE: presently, this just applies to hydrogen (species 1).
		- Added variable core recycling coeff. recycc (=1 default)
		- NOTE: with Ver_4.34, small added cx scattering included for
		  impurity ions through sigcxms, but not initialized until 
		  Ver_4.35-6; thus, may need to set sigcxms=0. to agree with
		  older cases.

Version 4.38  Corresponds to CVS archive of 05/24/05.  Changes include:
		- Corrected a bug for reinjecting wall fluxes at remote
		  locations when iscpli,o = 1 (default=0); previously albedo 
		  sources were double-counted when remote reinjection used.
		- Generalized lynix from a 2D array to 3D with the third
		  index being for density species; used if isulynix=1
		  (default=0).
		- Added a third dimension to arrays (wsveh, wsveh0, welms1,
		  welms2) in subroutine readeh2 of aphread.m. For this routine,
		  the third index does not vary from unity, but now corrects 
		  some compiler complaints.
		- Update the dce/Package file to avoid "for" loops with	
		  RPC_GENERATED, which can cause compiler problems
		- Corrected a possible overflow problem on some machines
		  introduced by changes to bbb/boundary.m, Version 4.37,
                  concerning recoding the plate temperature boundary 
		  conditions.
 		- The pyuedge make system has been improved by L. LoDestro 
		  and is included here.  Only of interest for PYTHON users
		  going down the uedge/Pyuedge branch in the uedge tree; see
		  uedge/README_Pyuedge for details of how to use.
		- Added a volume source for diffusive neutrals.  Current is
		  ivolcurg(igsp); shape uses r,z0ng positions & r,zwng widths.

Version 4.39  Corresponds to CVS archive of 03/17/06.  Changes include:
		- Corrected a bug in the reinjection of neutral gas from one
		  "source/pumping" wall region to another.
		- Added a diagnostic section to jac_calc to stop UEDGE at
                  a specific Jacobian elements & compare yldot_pert and
		  yldot_unpt.
		- Included collisionality factors coll_fe,i for grad_B
		  drifts, reducing them by 
		  cfnus_e,i*nu_star_e,i/(1 + cfnus_e,i*nu_star_e,i).
		- Generalized connection length variable, lcon, to be 2D and
		  changed name to lconi,e; near separatrix, limit by banana
		  width defined through temperatures tibsep and tebsep.
		- Added option to use the neutral pressure, pg=ng*tg, as the
		  differenced variable for the neutral continuity equation.
		  This option turned on by ineudif=2 (the option to use 
		  log(ng) as the variable is now moved to ineudif=3.
		- Implemented substantial improvements to the Jacobian 
		  calculation that now captures all elements for orthogonal
		  meshes and most elements for nonorthogonal; set yinc=2 
		  as default "box" y-range for the Jacobian calculation. 
		- Changed to use tg instead of ti in the calculation
		  of one component of the nonothogonal gas flux (fngxy);
		  if istgcon=0 (default), tg=ti, and it makes no difference,
		  but otherwise it will.
		- Corrected upstream boundary condition to include iy=iysptrx
		  for the seldom-used isfixlb=1 case that forces the ix=0 BC
		  to be defined by nibprof, etc. profiles.
  		- Included potential boundary conditions for the guard cells
		  that along the limiter with islbcp if islimon=1.
		- Implemented neutral gas albedo on the core boundary; 
		  activated for isngcore=0 and pumped flux is
		  0.25*vtg_bar*ng*(1-albedoc), with albedoc user input.
		- Implemented a neutral "recycling" model at the core boundary
		  to account for the fraction of neutral flux into the core
		  that comes back as ions (should be unity).  This neutral
		  recycling coefficient, recycc, is activated if isnicore=3.
		  Note that all other recycling coefficients describe the
		  opposite process where an ion flux at the wall is returned
		  as an inward neutral flux.
		- Added an mhdgeo=2 option for the circular annulus geometry 
		  that is used for efficient BOUT/UEDGE coupling runs; these 
		  core-only cases treat ix=0 and ix=nx+1 cells as dummies and 
		  do not make the usual assignment of ex(0,)=ex(1,) nor 
		  ex(nx,)=ex(nx-1,).
		- Added two new variables to control reading the atomic physics
		  data for hydrogen (newaph=1 is the default) and newapi for 
		  impurities; prevents problem of too many files open for
		  time-dependent runs under PYTHON.
		- Added a switch (itrap_negni) to trap negative ni condition
		  with an error message rather the "yuck".
		- Added a coefficient (alftng) to turn on the neutral thermal-
		  force coefficient (Helander's value is 0.24, but default=0).
		- Added user-specified volume gas source, psgov_use [1/m**3 s].
		- Modified the BASIS-replacement routine basfilex in 
		  com/dummy_py.f to return the input argument instead of 
		  nothing, which fixes a problem with reading atomic physics 
		  data in PYTHON version.
		- For the PYTHON version, users must specify the directory name
		  aphdir in their input file with its full path.
		- Added variables rs_com and zs_com to flx.v to pass output of
		  subr. findstrike via common for python (argument list also
		  works for BASIS version).

Version 4.40  Corresponds to CVS archive of 08/05/06.  Changes include:
		- Removed remanent test xlinc<20 and yinc<4  for Jacobian
		  calculation; can interfere with Jacobian testing, but
		  had no effect on normal running.
		- Include the effect of neutral-neutral collisions in the 
		  definition of the neutral particle diffusivity by using 
		  rnn2cx in the definition of nucx (previously, rnn2cx term 
		  only included in thermal and viscous coeff).
		- Include exponential power factors flgamtg and flgamvg in 
		  the flux limit expression for the thermal and viscous 
		  diffusion coefficients.
		- Added the scaling factor cfloxiplt that multiples the 
  		  neutral convective energy component at the divertor plates 
		  through floxi.  Since neutrals move away from the plate, 
		  the energy contribution from them into the plasma should
		  be zero, and cfloxiplt=0 produces this effect (but initial 
		  default=1 for backward compatibility).
		- Added two indice arrays iym1a and iyp1a to carry the 
		  (trivial) values of iy-1 and iy+1 over the 2D domain.  
		  Used as a variable for the MDSPlus data-tree only.
		- Added a floor-density of 0.1*ngbackg for the isngcore=2 
		  option, which sets the neutral density on the core 
		  boundary using the sqrt(l_ioniz*l_cx) criterion.  The 
		  addition prevents negative boundary neutral densities.
		- Include the factor csfacti as a multiplier of ti in the 
		  definition of the plate Bohm speed, cs.
		- Changed the if-test on isphion to a test on  
		  isphion+isphiofft so as to calculate the poloidal 
		  electric field when the potential is temporarily off.  
		  This fixes a problem with the Jaacobian when trying to 
		  run with fixed potential.
		- Included MDSPlus configuration file linux_mds for MIO 
		  in directory uedge/builder/std; also copy packages_mds
		  to packages file to include MDSPlus in UEDGE build.
		- Introduced the spatially-dependent eqn-on-off arrays 
		  isnionxy(ix,iy,ifld), isuponxy, isteonxy, istionxy, 
		  isphionxy, and isngonxy. This has resulted in many small 
		  changes to if-tests for switching equations on and off.
		  User-specified arrays isnioffxy(ix,iy,ifld), isupoffxy,
		  isteoffxy, istioffxy, isphioffxy, and isngoffx together 
		  with the original eqn-on-off arrays isnion, etc. to set 
		  isnionxy, etc.  That is, isnion still functions as before, 
		  and the user can set isnioffxy(ix,iy,ifld) to unity to
		  turn of ni in specific spatial regions.

Version 4.41  Corresponds to CVS archive of 10/18/06.  Changes include:
		- Corrected some read out-of-bounds problems with help of
		  M. Rensink associated with the 4.40 version (isnioffxy) 
		  and more long-standing, e.g., the spline routine for the 
		  mesh generator.
                - Corrected another potential read out-of-bounds in 
		  subroutines nphygeo and nonorthg reported by UCSD where 
 	 	  ixlb(2) was used in an if-test if(nxpt=2 .and. ixlb(2)); 
		  the INTEL compiled code searches for ixlb(2) even when 
		  nxpt=1 whereas Portland compiled code tests the first 
		  condition (false) and doesn't cause a problem; use 
		  ixlb(nxpt) fixes this INTEL problem.
		- Documented more fully that the parameter MXMISO that sets
		  the maximum number of impurity isotopes must be set 
		  consistently in BOTH uedge/api/api.v AND uedge/com/com.v.
		  Presently, the default is MXMISO=5.
		- Added MIO configure files to uedge/builder/std provided and
		  used by UCSD for their Intel compiler.
		- Made adjustment relative to diffusive neutral model for
		  hydrogen (rarely used); corrected dimension of cngmom & 
		  cmwall from ngspmx to nispmx, and use cmwall(ifld) instead 
		  of cmwall(1) for loss term of radial momentum, but only for 
		  diffusive hydrogen neutrals; only cngmom(1) and cmwall(1)
		  should ever be non-zero.
		- For spatial variation of diffusion coefficients using
		  isbohmcalc=3, change exponent inbtdif (D,chi~1/Bt**inbtdif)
		  from an integer to a real, allowing incremental variation.
		- Added the factor cftaud for scaling the hydrogen-impurity
		  drag time for the impurity force-balance equation.


Version 4.41_mds_shl  Identical to Version 4.41 above but has packages mds  and shl added.

To view this notebook start a terminal window and "cd" to the directory containing these files. Type "jupyter notebook" at the shell prompt and a browser window should appear. Click on the PyUedge notebook. You can click the first code cell and type Control-Return to run the code. Repeat for cells going down the page. You may also select "Run All" from the "Cell" menu.

#include "../mppl.h"
#include "../sptodp.h"
      SUBROUTINE SHEQR (A, LDA, N, Q, INFO, IJOB)
      real A, Q
      INTEGER LDA, N, INFO, IJOB
      DIMENSION A(LDA, *), Q(*)
C-----------------------------------------------------------------------
C     This routine performs a QR decomposition of an upper
C     Hessenberg matrix A.  There are two options available:
C
C          (1)  Performing a fresh decomposition.
C          (2)  Updating the QR factors by adding a row and a
C               column to the matrix A.
C-----------------------------------------------------------------------
C     SHEQR decomposes an upper Hessenberg matrix by using Givens
C     rotations.
C
C     On entry
C
C        A       real(LDA, N)
C                The matrix to be decomposed.
C
C        LDA     integer
C                The leading dimension of the array  A.
C
C        N       integer
C                A is an (N+1) by N Hessenberg matrix.
C
C        IJOB    integer
C                = 1     means that a fresh decomposition of the
C                        matrix A is desired.
C                .ge. 2  means that the current decomposition of A
C                        will be updated by the addition of a row
C                        and a column.
C     On return
C
C        A       The upper triangular matrix R.
C                The factorization can be written Q*A = R, where
C                Q is a product of Givens rotations and R is upper
C                triangular.
C
C        Q       real(2*N)
C                the factors c and s of each Givens rotation used
C                in decomposing A.
C
C        INFO    integer
C                = 0  normal value.
C                = k  if  A(k,k) .eq. 0.0 .  This is not an error
C                     condition for this subroutine, but it does
C                     indicate that SHELS will divide by zero
C                     if called.
C
C     This version dated 1/13/86.
C     Peter Brown, University of Houston, Lawrence Livermore Natl. Lab.
C
C-----------------------------------------------------------------------
C
C Type declarations for local variables --------------------------------
C
      real C, S, T, T1, T2
      INTEGER I, IQ, J, K, KM1, KP1, NM1
C
      IF (IJOB .GT. 1) GO TO 70
C-----------------------------------------------------------------------
C A new facorization is desired.
C-----------------------------------------------------------------------
C
C     QR decomposition without pivoting
C
      INFO = 0
      DO 60 K = 1, N
         KM1 = K - 1
         KP1 = K + 1
C
C           Compute kth column of R.
C           First, multiply the kth column of A by the previous
C           k-1 Givens rotations.
C
            IF (KM1 .LT. 1) GO TO 20
            DO 10 J = 1, KM1
              I = 2*(J-1) + 1
              T1 = A(J,K)
              T2 = A(J+1,K)
              C = Q(I)
              S = Q(I+1)
              A(J,K) = C*T1 - S*T2
              A(J+1,K) = S*T1 + C*T2
   10         CONTINUE
C
C           Compute Givens components c and s
C
   20       CONTINUE
            IQ = 2*KM1 + 1
            T1 = A(K,K)
            T2 = A(KP1,K)
            IF (T2 .NE. 0.0E0) GO TO 30
              C = 1.0E0
              S = 0.0E0
              GO TO 50
   30       CONTINUE
            IF (ABS(T2) .LT. ABS(T1)) GO TO 40
              T = T1/T2
              S = -1.0E0/SQRT(1.0E0+T*T)
              C = -S*T
              GO TO 50
   40       CONTINUE
              T = T2/T1
              C = 1.0E0/SQRT(1.0E0+T*T)
              S = -C*T
   50       CONTINUE
            Q(IQ) = C
            Q(IQ+1) = S
            A(K,K) = C*T1 - S*T2
            IF (A(K,K) .EQ. 0.0E0) INFO = K
   60 CONTINUE
      RETURN
C-----------------------------------------------------------------------
C The old factorization of A will be updated.  A row and a column
C have been added to the matrix A.
C N by N-1 is now the old size of the matrix.
C-----------------------------------------------------------------------
  70  CONTINUE
      NM1 = N - 1
C-----------------------------------------------------------------------
C Multiply the new column by the N previous Givens rotations.
C-----------------------------------------------------------------------
      DO 100 K = 1, NM1
        I = 2*(K-1) + 1
        T1 = A(K,N)
        T2 = A(K+1,N)
        C = Q(I)
        S = Q(I+1)
        A(K,N) = C*T1 - S*T2
        A(K+1,N) = S*T1 + C*T2
 100    CONTINUE
C-----------------------------------------------------------------------
C Complete update of decomposition by forming last Givens rotation,
C and multiplying it times the column vector (A(N,N),A(NP1,N)).
C-----------------------------------------------------------------------
      INFO = 0
      T1 = A(N,N)
      T2 = A(N+1,N)
      IF (T2 .NE. 0.0E0) GO TO 110
        C = 1.0E0
        S = 0.0E0
        GO TO 130
 110  CONTINUE
      IF (ABS(T2) .LT. ABS(T1)) GO TO 120
        T = T1/T2
        S = -1.0E0/SQRT(1.0E0+T*T)
        C = -S*T
        GO TO 130
 120  CONTINUE
        T = T2/T1
        C = 1.0E0/SQRT(1.0E0+T*T)
        S = -C*T
 130  CONTINUE
      IQ = 2*N - 1
      Q(IQ) = C
      Q(IQ+1) = S
      A(N,N) = C*T1 - S*T2
      IF (A(N,N) .EQ. 0.0E0) INFO = N
      RETURN
C----------------------- End of Subroutine SHEQR -----------------------
      END
      SUBROUTINE SHELS (A, LDA, N, Q, B)
      real A, B, Q
      INTEGER LDA, N
      DIMENSION A(LDA, *), B(*), Q(*)
C-----------------------------------------------------------------------
C This is part of the LINPACK routine SGESL with changes
C due to the fact that  A  is an upper Hessenberg matrix.
C-----------------------------------------------------------------------
C     SHELS solves the least squares problem
C
C           min ( b - A*x , b - A*x )
C
C     using the factors computed by SHEQR.
C
C     On entry
C
C        A       Real array of dimension LDA by N
C                The output from SHEQR which contains the upper
C                triangular factor R in the QR decomposition of A.
C
C        LDA     integer
C                The leading dimension of the array  a .
C
C        N       integer
C                A is originally an (N+1) by N matrix.
C
C        Q       Real vector of dimension 2*N
C                The coefficients of the N Givens rotations
C                used in the QR factorization of A.
C
C        B       Real vector of dimension N+1
C                The right hand side vector.
C
C
C     On return
C
C        B       the solution vector  x .
C
C
C     Modification of LINPACK. This version dated 1/13/86.
C     Peter Brown, University of Houston, Lawrence Livermore Natl. Lab.
C     Revised, Aug. 9, 1989 to make dimension and real declarations
C     comply with ANSI standard. GDB
C     BLAS SAXPY
C-----------------------------------------------------------------------
C
C Type declarations for local variables --------------------------------
C
      real C, S, T, T1, T2
      INTEGER IQ, K, KB, KP1
C
C        Minimize ( b - A*x , b - A*x )
C        First form Q*b.
C
         DO 20 K = 1, N
            KP1 = K + 1
            IQ = 2*(K-1) + 1
            C = Q(IQ)
            S = Q(IQ+1)
            T1 = B(K)
            T2 = B(KP1)
            B(K) = C*T1 - S*T2
            B(KP1) = S*T1 + C*T2
   20    CONTINUE
C
C        Now solve  R*x = Q*b.
C
         DO 40 KB = 1, N
            K = N + 1 - KB
            B(K) = B(K)/A(K,K)
            T = -B(K)
            CALL SAXPY (K-1, T, A(1,K), 1, B(1), 1)
   40    CONTINUE
      RETURN
C----------------------- End of Subroutine SHELS -----------------------
      END
      SUBROUTINE SVRORTHOG (VNEW, V,  HES , N, LL, LDHES, KMP, SNORMW)
      real VNEW, V,  HES , SNORMW
      INTEGER N, LL, LDHES, KMP
      DIMENSION VNEW(*), V(N, *),  HES(LDHES, *)
C-----------------------------------------------------------------------
C This routine orthogonalizes the vector VNEW against the previous
C KMP vectors in the V array.  It uses a modified Gram-Schmidt
C orthogonalization procedure with conditional reorthogonalization.
C This is the version of 28 May 1986.
C-----------------------------------------------------------------------
C
C      On entry
C
C         VNEW = the vector of length N containing a scaled product
C                of the Jacobian and the vector V(*,LL).
C
C         V    = the N x LL array containing the previous LL
C                orthogonal vectors V(*,1) to V(*,ll).
C
C         HES  = an LL x LL upper Hessenberg matrix containing,
C                in HES(i,k), k.lt.ll, scaled inner products of
C                A*V(*,k) and V(*,i).
C
C        LDHES = the leading dimension of the HES array.
C
C         N    = the order of the matrix A, and the length of VNEW.
C
C         LL   = the current order of the matrix HES .
C
C          KMP = the number of previous vectors the new vector VNEW
C                must be made orthogonal to (KMP .le. MAXL).
C
C
C      On return
C
C         VNEW = the new vector orthogonal to V(*,I0) to V(*,LL),
C                where I0 = max(1, LL-KMP+1).
C
C         HES  = upper Hessenberg matrix with column LL filled in with
C                scaled inner products of A*V(*,ll) and V(*,i).
C
C      SNORNMW = l-2 norm of VNEW.
C
C-----------------------------------------------------------------------
C
C Type declarations for local variables --------------------------------
C
      real ARG, SUMDSQ, TEM, VNRM
      INTEGER I, I0
C
C Type declaration for function subroutines called ---------------------
C
      real SDOT, SNRM2
C-----------------------------------------------------------------------
C Get norm of unaltered VNEW for later use. ----------------------------
      VNRM = SNRM2 (N, VNEW, 1)
C-----------------------------------------------------------------------
C Do modified Gram-Schmidt on VNEW = A*V(ll).
C Scaled inner products give new column of HES .
C Projections of earlier vectors are subtracted from VNEW.
C-----------------------------------------------------------------------
      I0 = max(1,LL-KMP+1)
      DO 10 I = I0, LL
         HES (I,LL) = SDOT (N, V(1,I), 1, VNEW, 1)
        TEM = - HES (I,LL)
        CALL SAXPY (N, TEM, V(1,I), 1, VNEW, 1)
 10     CONTINUE
C-----------------------------------------------------------------------
C Compute SNORNMW = norm of VNEW.
C If VNEW is small compared to its input value (in norm), then
C reorthogonalize VNEW to V(*,1) through V(*,ll).
C correct if relative correction exceeds 1000*(unit roundoff).
C Finally, correct SNORNMW using the dot products involved.
C-----------------------------------------------------------------------
      SNORMW = SNRM2 (N, VNEW, 1)
      IF (VNRM + 0.001E0*SNORMW .NE. VNRM) RETURN
      SUMDSQ = 0.0E0
      DO 30 I = I0, LL
        TEM = -SDOT (N, V(1,I), 1, VNEW, 1)
        IF ( HES (I,LL) + 0.001E0*TEM .EQ.  HES (I,LL)) GO TO 30
         HES (I,LL) =  HES (I,LL) - TEM
        CALL SAXPY (N, TEM, V(1,I), 1, VNEW, 1)
        SUMDSQ = SUMDSQ + TEM**2
 30     CONTINUE
      IF (SUMDSQ .EQ. 0.0E0) RETURN
      ARG = max(0.0E0,SNORMW**2 - SUMDSQ)
      SNORMW = SQRT(ARG)
C
      RETURN
C----------------------- End of Subroutine SVRORTHOG ----------------------
      END
      subroutine precond5(nn,ndiag,ndiagm,a,am,rowvec,colvec,id1,id2,
     .                    sigma,fmu,idiag)
c
c   This subroutine builds the pre-conditioning matrix, am.
c   It is assumed that it has the same structure as the
c   Jacobian matrix and so it is stored in the same way, i.e.
c   by storing the non-zero diagonals as colums.
c
c    input variables
c
      integer nn, ndiag, ndiagm
      integer id1(0:ndiagm), id2(0:ndiagm), idiag(ndiagm)
      integer k, mdiag, iprcnd
      integer i, ii, j, m, irow, jcol, l, icnt1, icnt2
c
      real a(nn,ndiag),am(0:nn,ndiagm),
     .          rowvec(0:nn),colvec(0:nn),
     .          sigma(nn),
     .          fmu(nn)
c
      real tacc, parm, test
c
c ***************************************************
c
c   Find the column in A where the main diagonal is stored
c
      do 1  k=1,ndiag
 1    if(idiag(k).eq.0) mdiag=k
c
      iprcnd=0
      if(iprcnd.eq.1) then
c
c   Use the identity matrix as the pre-conditioner
c
      do 111 i=1,nn
      do 111 k=1,ndiag
 111  am(i,k) = 0.e0
c
      do 2 i=1,nn
 2    am(i,mdiag) = 1.e0
c
      else
c
c   This algorithm computes an approximate LU factorization of the
c   Jacobian matrix.  The algorithm assumes the resulting matrix
c   structure of (LU) is the same as the original Jacobian.
c
c   Initialize the pre-conditioning matrix and work vectors
c
      do 15 i=1,nn
       colvec(i) = 0.e0
       rowvec(i) = 0.e0
       do 5 k=1,ndiag
         am(i,k) = a(i,k)
  5    continue
       do 6 k=ndiag+1,ndiagm
         am(i,k) = 0.e0
  6    continue
 15   continue
c
c
      do 10 ii=1,nn
c
        sigma(ii) = 0.e0
        fmu(ii)   = 0.e0
c
c=========================
c   Lower Diagonal Matrix
c=========================
c
        j = ii
c
c   Load the column vector for use in computing the recursive terms
c
        icnt2 = 0
        do 38 m=mdiag+1,ndiagm
c
          irow = j - idiag(m)
          if((irow.ge.1).and.(irow.lt.j)) then
            icnt2 = icnt2 + 1
            colvec(irow) = am(irow,m)
            id2(icnt2) = irow
          endif
c
 38     continue
c
c   Compute the jth column of L - first sweeping over the
c   original non-zero diagonals
c
        do 30 k=1,mdiag
c
          i = j - idiag(k)
c
          if(i.le.nn) then
c
c   Load the row vector for use in computing the recursive terms
c
c        original non-zero diagonals
c
            icnt1 = 0
            do 35 m=1,k-1
c
              jcol = i + idiag(m)
              if(jcol.ge.1) then
                icnt1 = icnt1 + 1
                rowvec(jcol) = am(i,m)
                id1(icnt1) = jcol
              endif
c
 35         continue
c
c        new non-zero diagonals resulting from ILU fill-in
c
            do 36 m=ndiag+1,ndiagm
c
              jcol = i + idiag(m)
              if((jcol.ge.1).and.(jcol.lt.i)) then
                icnt1 = icnt1 + 1
                rowvec(jcol) = am(i,m)
                id1(icnt1) = jcol
              endif
c
 36         continue
c
c   Compute the recursive terms in the ILU factorization
c
            do 45 l=1,icnt1
c
              am(i,k) = am(i,k) - rowvec(id1(l))*colvec(id1(l))
              rowvec(id1(l)) = 0.e0
c
 45         continue
c
c   Compute sigma(i) to be used in testing for
c   unstable pivots
c
            sigma(ii) = max(sigma(ii),abs(am(i,k)))
c
c
          endif
c
 30     continue
c
c   Now sweep over the non-zero diagonals generated from the
c   ILU fill-in
c
        do 32 k=ndiag+1,ndiagm
c
           i = j - idiag(k)
           if((i.le.nn).and.(i.ge.j)) then
c
c   Load the row vector for use in computing the recursive terms
c
            icnt1 = 0
            do 55 m=1,ndiagm
c
              jcol = i + idiag(m)
              if((jcol.ge.1).and.(jcol.lt.j)) then
                icnt1 = icnt1 + 1
                rowvec(jcol) = am(i,m)
                id1(icnt1) = jcol
              endif
c
 55         continue
c
c   Compute the recursive terms in the ILU factorization
c
            do 65 l=1,icnt1
c
              am(i,k) = am(i,k) - rowvec(id1(l))*colvec(id1(l))
              rowvec(id1(l)) = 0.e0
c
 65         continue
c
c   Compute sigma(i) to be used in testing for
c   unstable pivots
c
            sigma(ii) = max(sigma(ii),abs(am(i,k)))
c
c
           endif
c
 32     continue
c
c   Zero the remaining entries in the row and column work vectors
c
        do 41 l=1,icnt2
          colvec(id2(l)) = 0.e0
 41     continue
c
c
c=========================
c   Upper Diagonal Matrix
c=========================
c
        i = ii
c
c   Load the row vector for use in computing the recursive terms
c
c      original non-zero diagonals
c
        icnt1 = 0
        do 25 m=1,mdiag-1
c
          jcol = i + idiag(m)
          if(jcol.ge.1) then
            icnt1 = icnt1 + 1
            rowvec(jcol) = am(i,m)
            id1(icnt1) = jcol
          endif
c
 25     continue
c
c      new non-zero diagonals generated from ILU fill-in
c
        do 26 m=ndiag+1,ndiagm
c
          jcol = i + idiag(m)
          if((jcol.ge.1).and.(jcol.lt.i)) then
            icnt1 = icnt1 + 1
            rowvec(jcol) = am(i,m)
            id1(icnt1) = jcol
          endif
c
 26     continue
c
c   Compute the ith row of U - original non-zero diagonals first
c
        do 20 k=mdiag+1,ndiag
c
          j = i + idiag(k)
c
          if(j.le.nn) then
c
c   Load the column vector for use in computing the recursive terms
c
            icnt2 = 0
            do 28 m=k+1,ndiagm
c
              irow = j - idiag(m)
              if((irow.ge.1).and.(irow.lt.j)) then
                icnt2 = icnt2 + 1
                colvec(irow) = am(irow,m)
                id2(icnt2) = irow
              endif
c
 28         continue
c
c   Compute the recursive terms in the ILU factorization
c
            do 29 l=1,icnt2
c
              am(i,k) = am(i,k) - rowvec(id2(l))*colvec(id2(l))
              colvec(id2(l)) = 0.e0
c
 29         continue
c
c   Compute fmu(i) to be used in testing for
c   unstable pivots
c
            fmu(ii) = max(fmu(ii),abs(am(i,k)))
c
c
          endif
c
  20    continue
c
c   Now the new non-zero diagonals generated from the ILU fill-in
c
        do 21 k = ndiag+1,ndiagm
c
          j = i + idiag(k)
          if((j.le.nn).and.(j.gt.i)) then
c
c   Load the column vector for use in computing the recursive terms
c
            icnt2 = 0
            do 88 m=1,ndiagm
c
              irow = j - idiag(m)
              if((irow.ge.1).and.(irow.lt.j)) then
                icnt2 = icnt2 + 1
                colvec(irow) = am(irow,m)
                id2(icnt2) = irow
              endif
c
 88         continue
c
c   Compute the recursive terms in the ILU factorization
c
            do 89 l=1,icnt2
c
              am(i,k) = am(i,k) - rowvec(id2(l))*colvec(id2(l))
              colvec(id2(l)) = 0.e0
c
 89         continue
c
c   Compute fmu(i) to be used in testing for
c   unstable pivots
c
            fmu(ii) = max(fmu(ii),abs(am(i,k)))
c
c
          endif
c
 21     continue
c
c   Zero the remaining entries in the row and column work vectors
c
        do 31 l=1,icnt1
c
          rowvec(id1(l)) = 0.e0
c
 31     continue
c 
c
c   Test for unstable pivots and adjust if necessary before
c   dividing through to obtain U
c
        tacc = 51
c       tacc = 21
        parm = 2.e0**(-tacc)
        test = parm*sigma(ii)*fmu(ii)
        if(am(ii,mdiag)**2.lt.test) then
c         write(*,*) 'pivot adjusted, row  = ',ii
c         write(*,*) '      before-   diag = ',am(ii,mdiag)
          am(ii,mdiag) = sign(1.e0,am(ii,mdiag))*sqrt(test)
c         write(*,*) '                test = ',test
c         write(*,*) '      after-    diag = ',am(ii,mdiag)
c         write(*,*) '                fmu  = ',fmu(ii)
c         write(*,*) '                sigma= ',sigma(ii)
        endif
 
        do 70 k=mdiag+1,ndiagm
          if(idiag(k).gt.0) then
            if(am(ii,mdiag).eq.0.e0) then
              write(*,*) 'zero diagonal in preconditioner'
              stop
            endif
            am(ii,k) = am(ii,k)/am(ii,mdiag)
          endif
 70     continue
c
 10   continue
c
      endif
c
      return
      end
      subroutine minvmul(nn,ndiag,ndiagm,am,idiag,x,y)
c
c   This subroutine solves, (LU)x = y for the vector x
c   where am is an approximate LU decomposition of
c   the Jacobian matrix
c
c   The integer array idiag contains the information
c   that relates the actual column to the main diagonal
c   since only the non-zero diagonals of A are stored, i.e.,
c
c     i = row number
c     j = column number = i + idiag(k)
c     k = non-zero diagonal index numbered from left to right
c
      implicit none
c
c    input variables
c
      integer nn, ndiag, ndiagm, k, mdiag, i, jcol
c
      real am(0:nn,ndiagm), x(nn),
     .          y(nn), sum
      integer idiag(ndiagm)
c
c
c ***************************************************
c
c   Find column in am(i,j) where main diagonal is located
c
      do 10 k=1,ndiag
 10   if(idiag(k).eq.0) mdiag=k
c
c   Compute the b' vector which is the solution to L(b')=y
c
      x(1) = y(1)/am(1,mdiag)
c
      do 20 i = 2,nn
c
        sum = 0.e0
c
        do 30 k=1,mdiag-1
c
          jcol = i + idiag(k)
          if(jcol.ge.1) sum = sum + am(i,k)*x(jcol)
c
 30     continue
c
        do 35 k = ndiag+1,ndiagm
c
          jcol = i + idiag(k)
          if((idiag(k).lt.0).and.(jcol.ge.1)) then
            sum = sum + am(i,k)*x(jcol)
          endif
c
 35     continue
c
        x(i) = (y(i) - sum)/am(i,mdiag)
c
 20   continue
c
c   Now compute x which is the solution to Ux = b'
c
      do 50 i=nn-1,1,-1
c
        sum = 0.e0
c
        do 60 k=mdiag+1,ndiag
c
          jcol = i + idiag(k)
          if(jcol.le.nn) sum = sum + am(i,k)*x(jcol)
c
 60     continue
c
        do 65 k = ndiag+1,ndiagm
c
          jcol = i + idiag(k)
          if((idiag(k).gt.0).and.(jcol.le.nn)) then
            sum = sum + am(i,k)*x(jcol)
          endif
c
 65     continue
c
        x(i) = x(i) - sum
c
 50   continue
c
c
      return
      end
c  end of minvmul
c-----------------------------------------------------------------------
      subroutine cdiagsrt (n,adiag,ndiag,ioff,iwork1,iwork2,rwork) 
      integer n, ndiag, iwork1(2*n-1), iwork2(ndiag), ioff(ndiag)
      real adiag(n,ndiag), rwork(ndiag)
c-----------------------------------------------------------------------
c This routine sorts the elements of a matrix (stored in Diagonal
c Format) in increasing order of their column indices within 
c each row. 
c-----------------------------------------------------------------------
c on entry:
c--------- 
c n      = the row dimension of the matrix
c adiag  = the matrix A in diagonal format.
c ndiag  = the number of non-zero diagonals in A
c ioff   = integer array of length idiag, containing the offsets of the
c          diagonals
c iwork1 = integer work array of length 2*n-1.
c iwork2 = integer work array of length ndiag.
c rwork  = real work array of length ndiag.
c 
c on return:
c----------
c the matrix stored in the structure adiag is permuted in such a
c way that the column indices are in increasing order within each row.
c iwork2(1:ndiag) contains the permutation used to rearrange the
c elements.
c----------------------------------------------------------------------- 
c P. Brown 3-19-93.
c-----------------------------------------------------------------------
c local variables
      integer i, k
c
c calculate permutation.
c
      do 10 i = 1,ndiag
         iwork1(n+ioff(i)) = i
 10   continue
c delete zero entries from iwork1.
      k = 1
      do 20 i = 1,2*n-1
         if (iwork1(i) .ne. 0) then
            iwork1(k) = iwork1(i)
            k = k + 1
         endif
 20   continue
c calculate inverse permutation of that in iwork1.
      do 25 i = 1,ndiag
         iwork2(iwork1(i)) = i
 25   continue
c perform an in-place permutation of the arrays ioff and adiag.
      call ivperm (ndiag, ioff, iwork2) 
      do 50 k = 1,n
         do 30 i = 1,ndiag
            rwork(i) = adiag(k,i)
 30      continue
         call dvperm (ndiag, rwork, iwork2) 
         do 40 i = 1,ndiag
            adiag(k,i) = rwork(i)
 40      continue
 50   continue
c
      return 
c---------------end-of-cdiagsrt----------------------------------------- 
c-----------------------------------------------------------------------
      end

c     ------------------------------------------------------------------

      subroutine flxrun
      use Dimflxgrd 
      use Comflxgrd 

!     main driver routine for flx package
      implicit none
      call inflx
      call flxgen
!!! No need to write flx-grd file (MER 08 Feb 2010)
!!! These variables are now in com package and accessible to both flx and grd
      if (isfw==1) call flxfin

      return
      end

! newuoa.m,v 1.6 2006/08/12 18:27:06 bulmer Exp

      subroutine xnewuoa(n,npt,x,rhobeg,rhoend,maxfun,iprint)

            use UOA 
      implicit real (a-h,o-z), integer (i-n)
      dimension x(*)

    ! This subroutine seeks the least value of a function of many variables,
    ! by a trust region method that forms quadratic models by interpolation.
    ! There can be some freedom in the interpolation conditions, which is
    ! taken up by minimizing the Frobenius norm of the change to the second
    ! derivative of the quadratic model, beginning with a zero matrix. The
    ! arguments of the subroutine are as follows.
    !
    ! N must be set to the number of variables and must be at least two.
    ! NPT is the number of interpolation conditions. Its value must be in the
    !   interval [N+2,(N+1)(N+2)/2].
    ! Initial values of the variables must be set in X(1),X(2),...,X(N). They
    !   will be changed to the values that give the least calculated F.
    ! RHOBEG and RHOEND must be set to the initial and final values of a trust
    !   region radius, so both must be positive with RHOEND<=RHOBEG. Typically
    !   RHOBEG should be about one tenth of the greatest expected change to a
    !   variable, and RHOEND should indicate the accuracy that is required in
    !   the final values of the variables.
    ! MAXFUN must be set to an upper bound on the number of calls of CALFUN.
    ! The value of IPRINT should be set to 0, 1, 2 or 3, which controls the
    !   amount of printing. Specifically, there is no output if IPRINT=0 and
    !   there is output only at the return if IPRINT=1. Otherwise, each new
    !   value of RHO is printed, with the best vector of variables so far and
    !   the corresponding value of the objective function. Further, each new
    !   value of F with its variables are output if IPRINT=3.
    !
    ! SUBROUTINE CALFUN (N,X,F) must be provided by the user. It must set F to
    ! the value of the objective function for the variables X(1),X(2),...,X(N).
    !
    ! Partition the working space array, so that different parts of it can be
    ! treated separately by the subroutine that performs the main calculation.

      np=n+1
      nptm=npt-np

    ! Allocate workspace
      n_uoa=n
      npt_uoa=npt
      m_uoa=(npt+13)*(npt+n)+3*n*(n+3)/2
      call gchange("UOA",0)

    ! Provide a partition of W for subroutine NEWUOB.
    ! The partition requires the first NPT*(NPT+N)+5*N*(N+3)/2 elements of
    ! W plus the space that is needed by the last array of NEWUOB.
      ndim=npt+n
      ixb=1
      ixo=ixb+n
      ixn=ixo+n
      ixp=ixn+n
      ifv=ixp+n*npt
      igq=ifv+npt
      ihq=igq+n
      ipq=ihq+(n*np)/2
      ibmat=ipq+npt
      izmat=ibmat+ndim*n
      id=izmat+npt*nptm
      ivl=id+n
      iw=ivl+ndim

      call newuob(n, npt, x, rhobeg, rhoend, iprint, maxfun, 
     .            w_uoa(ixb), w_uoa(ixo), w_uoa(ixn), w_uoa(ixp), 
     .            w_uoa(ifv), w_uoa(igq), w_uoa(ihq), w_uoa(ipq), 
     .            w_uoa(ibmat), w_uoa(izmat), ndim, w_uoa(id), 
     .            w_uoa(ivl), w_uoa(iw))

      return

      end ! newuoa

c----------------------------------------------------------------------
! newuob.m,v 1.4 2006/08/12 18:27:06 bulmer Exp

      subroutine newuob(n,npt,x,rhobeg,rhoend,iprint,maxfun,xbase, 
     .             xopt,xnew,xpt,fval,gq,hq,pq,bmat,zmat,ndim,d,vlag,w)

            use UOA 
      implicit real (a-h,o-z), integer (i-n)
      dimension x(*),xbase(*),xopt(*),xnew(*),xpt(npt,*),fval(*)
      dimension gq(*),hq(*),pq(*),bmat(ndim,*),zmat(npt,*),d(*),vlag(*),w(*)

    ! The arguments N, NPT, X, RHOBEG, RHOEND, IPRINT and MAXFUN are identical
    !   to the corresponding arguments in SUBROUTINE NEWUOA.
    ! XBASE will hold a shift of origin that should reduce the contributions
    !   from rounding errors to values of the model and Lagrange functions.
    ! XOPT will be set to the displacement from XBASE of the vector of
    !   variables that provides the least calculated F so far.
    ! XNEW will be set to the displacement from XBASE of the vector of
    !   variables for the current calculation of F.
    ! XPT will contain the interpolation point coordinates relative to XBASE.
    ! FVAL will hold the values of F at the interpolation points.
    ! GQ will hold the gradient of the quadratic model at XBASE.
    ! HQ will hold the explicit second derivatives of the quadratic model.
    ! PQ will contain the parameters of the implicit second derivatives of
    !   the quadratic model.
    ! BMAT will hold the last N columns of H.
    ! ZMAT will hold the factorization of the leading NPT by NPT submatrix of
    !   H, this factorization being ZMAT times Diag(DZ) times ZMAT^T, where
    !   the elements of DZ are plus or minus one, as specified by IDZ.
    ! NDIM is the first dimension of BMAT and has the value NPT+N.
    ! D is reserved for trial steps from XOPT.
    ! VLAG will contain the values of the Lagrange functions at a new point X.
    !   They are part of a product that requires VLAG to be of length NDIM.
    ! The array W will be used for working space. Its length must be at least
    !   10*NDIM = 10*(NPT+N).

      half=0.5
      one=1.0
      tenth=0.1
      zero=0.0
      np=n+1
      nh=(n*np)/2
      nptm=npt-np
      nftest=max0(maxfun,1)

    ! Set the initial elements of XPT, BMAT, HQ, PQ and ZMAT to zero.

      do  j=1,n
            xbase(j)=x(j)
          do k=1,npt
              xpt(k,j)=zero
          enddo
          do i=1,ndim
              bmat(i,j)=zero
          enddo
      enddo
      do ih=1,nh
          hq(ih)=zero
      enddo
      do k=1,npt
          pq(k)=zero
          do j=1,nptm
              zmat(k,j)=zero
          enddo
      enddo

    ! Begin the initialization procedure. NF becomes one more than the number
    ! of function values so far. The coordinates of the displacement of the
    ! next initial interpolation point from XBASE are set in XPT(NF,.).

      rhosq=rhobeg*rhobeg
      recip=one/rhosq
      reciq=sqrt(half)/rhosq
      nf=0
 50   nfm=nf
      nfmm=nf-n
      nf=nf+1
      if (nfm <= 2*n) then
        if (nfm >= 1 .and. nfm <= n) then
            xpt(nf,nfm)=rhobeg
        elseif (nfm > n) then
            xpt(nf,nfmm)=-rhobeg
        endif
      else
        itemp=(nfmm-1)/n
        jpt=nfm-itemp*n-n
        ipt=jpt+itemp
        if (ipt > n) then
            itemp=jpt
            jpt=ipt-n
            ipt=itemp
        endif
        xipt=rhobeg
        if (fval(ipt+np) < fval(ipt+1)) xipt=-xipt
        xjpt=rhobeg
        if (fval(jpt+np) < fval(jpt+1)) xjpt=-xjpt
        xpt(nf,ipt)=xipt
        xpt(nf,jpt)=xjpt
      endif

    ! Calculate the next value of F, label 70 being reached immediately
    ! after this calculation. The least function value so far and its index
    ! are required.

      do j=1,n
        x(j)=xpt(nf,j)+xbase(j)
      enddo
      goto 310
 70   fval(nf)=f
      if (nf == 1) then
        fbeg=f
        fopt=f
        kopt=1
      elseif (f < fopt) then
        fopt=f
        kopt=nf
      endif

    ! Set the nonzero initial elements of BMAT and the quadratic model in
    ! the cases when NF is at most 2*N+1.

      if (nfm <= 2*n) then
        if (nfm >= 1 .and. nfm <= n) then
            gq(nfm)=(f-fbeg)/rhobeg
            if (npt < nf+n) then
                bmat(1,nfm)=-one/rhobeg
                bmat(nf,nfm)=one/rhobeg
                bmat(npt+nfm,nfm)=-half*rhosq
            endif
          elseif (nfm > n) then
            bmat(nf-n,nfmm)=half/rhobeg
            bmat(nf,nfmm)=-half/rhobeg
            zmat(1,nfmm)=-reciq-reciq
            zmat(nf-n,nfmm)=reciq
            zmat(nf,nfmm)=reciq
            ih=(nfmm*(nfmm+1))/2
            temp=(fbeg-f)/rhobeg
            hq(ih)=(gq(nfmm)-temp)/rhobeg
            gq(nfmm)=half*(gq(nfmm)+temp)
        endif

      else
        ! Set the off-diagonal second derivatives of the Lagrange functions and
        ! the initial quadratic model.
            ih=(ipt*(ipt-1))/2+jpt
          if (xipt < zero) ipt=ipt+n
          if (xjpt < zero) jpt=jpt+n
          zmat(1,nfmm)=recip
          zmat(nf,nfmm)=recip
            zmat(ipt+1,nfmm)=-recip
          zmat(jpt+1,nfmm)=-recip
          hq(ih)=(fbeg-fval(ipt+1)-fval(jpt+1)+f)/(xipt*xjpt)
      endif
      if (nf < npt) goto 50

    ! Begin the iterative procedure, because the initial model is complete.

      rho=rhobeg
      rho_uoa=rho
      delta=rho
      idz=1
      diffa=zero
      diffb=zero
      itest=0
      xoptsq=zero
      do i=1,n
        xopt(i)=xpt(kopt,i)
        xoptsq=xoptsq+xopt(i)**2
      enddo
 90   nfsav=nf

    ! Generate the next trust region step and test its length. Set KNEW
    ! to -1 if the purpose of the next F will be to improve the model.

100   knew=0
      call trsapp(n,npt,xopt,xpt,gq,hq,pq,delta,d,w,w(np), 
     .            w(np+n),w(np+2*n),crvmin)
      dsq=zero
      do i=1,n
        dsq=dsq+d(i)**2
      enddo
      dnorm=min(delta,sqrt(dsq))
      if (dnorm < half*rho) then
        knew=-1
        delta=tenth*delta
        ratio=-1.0
        if (delta <= 1.5*rho) delta=rho
        if (nf <= nfsav+2) goto 460
        temp=0.125*crvmin*rho*rho
        if (temp <= max(diffa,diffb,diffc)) goto 460
        goto 490
      endif

    ! Shift XBASE if XOPT may be too far from XBASE. First make the changes
    ! to BMAT that do not depend on ZMAT.

120   if (dsq <= 1.0e-3*xoptsq) then
        tempq=0.25*xoptsq
        do k=1,npt
            sum=zero
            do i=1,n
                sum=sum+xpt(k,i)*xopt(i)
            enddo
            temp=pq(k)*sum
            sum=sum-half*xoptsq
            w(npt+k)=sum
            do i=1,n
                gq(i)=gq(i)+temp*xpt(k,i)
                xpt(k,i)=xpt(k,i)-half*xopt(i)
                vlag(i)=bmat(k,i)
                w(i)=sum*xpt(k,i)+tempq*xopt(i)
                ip=npt+i
                do j=1,i
                    bmat(ip,j)=bmat(ip,j)+vlag(i)*w(j)+w(i)*vlag(j)
                enddo
            enddo
        enddo

        ! Then the revisions of BMAT that depend on ZMAT are calculated.

        do k=1,nptm
            sumz=zero
            do i=1,npt
                sumz=sumz+zmat(i,k)
                w(i)=w(npt+i)*zmat(i,k)
            enddo
            do j=1,n
                sum=tempq*sumz*xopt(j)
                do i=1,npt
                    sum=sum+w(i)*xpt(i,j)
                enddo
                vlag(j)=sum
                if (k < idz) sum=-sum
                do i=1,npt
                    bmat(i,j)=bmat(i,j)+sum*zmat(i,k)
                enddo
            enddo
            do i=1,n
                ip=i+npt
                temp=vlag(i)
                if (k < idz) temp=-temp
                do j=1,i
                    bmat(ip,j)=bmat(ip,j)+temp*vlag(j)
                enddo
            enddo
        enddo

        ! The following instructions complete the shift of XBASE, including
        ! the changes to the parameters of the quadratic model.

          ih=0
          do j=1,n
            w(j)=zero
            do k=1,npt
                w(j)=w(j)+pq(k)*xpt(k,j)
                xpt(k,j)=xpt(k,j)-half*xopt(j)
            enddo
            do i=1,j
                ih=ih+1
                if (i < j) gq(j)=gq(j)+hq(ih)*xopt(i)
                gq(i)=gq(i)+hq(ih)*xopt(j)
                hq(ih)=hq(ih)+w(i)*xopt(j)+xopt(i)*w(j)
                bmat(npt+i,j)=bmat(npt+j,i)
            enddo
          enddo
        do j=1,n
            xbase(j)=xbase(j)+xopt(j)
            xopt(j)=zero
        enddo
        xoptsq=zero
      endif

    ! Pick the model step if KNEW is positive. A different choice of D
    ! may be made later, if the choice of D by BIGLAG causes substantial
    ! cancellation in DENOM.

      if (knew > 0) then
          call biglag(n,npt,xopt,xpt,bmat,zmat,idz,ndim,knew,dstep, 
     .                d,alpha,vlag,vlag(npt+1),w,w(np),w(np+n))
      endif

    ! Calculate VLAG and BETA for the current choice of D. The first NPT
    ! components of W_check will be held in W.

      do k=1,npt
        suma=zero
        sumb=zero
        sum=zero
        do j=1,n
            suma=suma+xpt(k,j)*d(j)
            sumb=sumb+xpt(k,j)*xopt(j)
            sum=sum+bmat(k,j)*d(j)
        enddo
        w(k)=suma*(half*suma+sumb)
        vlag(k)=sum
      enddo
      beta=zero
      do k=1,nptm
        sum=zero
        do i=1,npt
            sum=sum+zmat(i,k)*w(i)
        enddo
        if (k < idz) then
            beta=beta+sum*sum
            sum=-sum
        else
            beta=beta-sum*sum
        endif
        do i=1,npt
            vlag(i)=vlag(i)+sum*zmat(i,k)
        enddo
      enddo
      bsum=zero
      dx=zero
      do j=1,n
        sum=zero
        do i=1,npt
            sum=sum+w(i)*bmat(i,j)
        enddo
        bsum=bsum+sum*d(j)
        jp=npt+j
        do k=1,n
            sum=sum+bmat(jp,k)*d(k)
        enddo
        vlag(jp)=sum
        bsum=bsum+sum*d(j)
        dx=dx+d(j)*xopt(j)
      enddo
      beta=dx*dx+dsq*(xoptsq+dx+dx+half*dsq)+beta-bsum
      vlag(kopt)=vlag(kopt)+one

    ! If KNEW is positive and if the cancellation in DENOM is unacceptable,
    ! then BIGDEN calculates an alternative model step, XNEW being used for
    ! working space.

      if (knew > 0) then
        temp=one+alpha*beta/vlag(knew)**2
        if (abs(temp) <= 0.8) then
            call bigden(n,npt,xopt,xpt,bmat,zmat,idz,ndim,kopt, 
     .                  knew,d,w,vlag,beta,xnew,w(ndim+1),w(6*ndim+1))
        endif
      endif

    ! Calculate the next value of the objective function.

290   do i=1,n
        xnew(i)=xopt(i)+d(i)
        x(i)=xbase(i)+xnew(i)
      enddo
      nf=nf+1
310   if (nf > nftest) then
        nf=nf-1
        if (iprint > 0) then
            call remark("newuoa: CALFUN has been called MAXFUN times.")
        endif
        goto 530
      endif
      call calfun(n,x,f)
      if (iprint == 3) then
        print 330, nf,f,(x(i),i=1,n)
330     format (/4x,'Function number',i6,'    F =',1pd18.10, 
     .               '    The corresponding X is:'/(2x,5d15.6))
      endif
      if (nf <= npt) goto 70
      if (knew == -1) goto 530

    ! Use the quadratic model to predict the change in F due to the step D,
    ! and set DIFF to the error of this prediction.

      vquad=zero
      ih=0
      do j=1,n
        vquad=vquad+d(j)*gq(j)
        do i=1,j
            ih=ih+1
            temp=d(i)*xnew(j)+d(j)*xopt(i)
            if (i == j) temp=half*temp
            vquad=vquad+temp*hq(ih)
        enddo
      enddo
      do k=1,npt
        vquad=vquad+pq(k)*w(k)
      enddo
      diff=f-fopt-vquad
      diffc=diffb
      diffb=diffa
      diffa=abs(diff)
      if (dnorm > rho) nfsav=nf

    ! Update FOPT and XOPT if the new F is the least value of the objective
    ! function so far. The branch when KNEW is positive occurs if D is not
    ! a trust region step.

      fsave=fopt
      if (f < fopt) then
        fopt=f
        xoptsq=zero
        do i=1,n
            xopt(i)=xnew(i)
            xoptsq=xoptsq+xopt(i)**2
        enddo
      endif
      ksave=knew
      if (knew > 0) goto 410

    ! Pick the next value of DELTA after a trust region step.

      if (vquad >= zero) then
        if (iprint > 0) then
            call remark("newuoa: a trust region step has failed to reduce Q.")
        endif
        goto 530
      endif
      ratio=(f-fsave)/vquad
      if (ratio <= tenth) then
        delta=half*dnorm
      elseif (ratio <= 0.7) then
        delta=max(half*delta,dnorm)
      else
        delta=max(half*delta,dnorm+dnorm)
      endif
      if (delta <= 1.5*rho) delta=rho

    ! Set KNEW to the index of the next interpolation point to be deleted.

      rhosq=max(tenth*delta,rho)**2
      ktemp=0
      detrat=zero
      if (f >= fsave) then
        ktemp=kopt
        detrat=one
      endif
      do k=1,npt
        hdiag=zero
        do j=1,nptm
            temp=one
            if (j < idz) temp=-one
            hdiag=hdiag+temp*zmat(k,j)**2
        enddo
        temp=abs(beta*hdiag+vlag(k)**2)
        distsq=zero
        do j=1,n
            distsq=distsq+(xpt(k,j)-xopt(j))**2
        enddo
        if (distsq > rhosq) temp=temp*(distsq/rhosq)**3
        if (temp > detrat .and. k .ne. ktemp) then
            detrat=temp
            knew=k
        endif
      enddo
      if (knew == 0) goto 460

    ! Update BMAT, ZMAT and IDZ, so that the KNEW-th interpolation point
    ! can be moved. Begin the updating of the quadratic model, starting
    ! with the explicit second derivative term.

410   call update(n,npt,bmat,zmat,idz,ndim,vlag,beta,knew,w)
      fval(knew)=f
      ih=0
      do i=1,n
          temp=pq(knew)*xpt(knew,i)
        do j=1,i
            ih=ih+1
            hq(ih)=hq(ih)+temp*xpt(knew,j)
        enddo
      enddo
      pq(knew)=zero

    ! Update the other second derivative parameters, and then the gradient
    ! vector of the model. Also include the new interpolation point.

      do j=1,nptm
        temp=diff*zmat(knew,j)
        if (j < idz) temp=-temp
        do k=1,npt
            pq(k)=pq(k)+temp*zmat(k,j)
        enddo
      enddo
      gqsq=zero
      do i=1,n
        gq(i)=gq(i)+diff*bmat(knew,i)
        gqsq=gqsq+gq(i)**2
        xpt(knew,i)=xnew(i)
      enddo

    ! If a trust region step makes a small change to the objective function,
    ! then calculate the gradient of the least Frobenius norm interpolant at
    ! XBASE, and store it in W, using VLAG for a vector of right hand sides.

      if (ksave == 0 .and. delta == rho) then
        if (abs(ratio) > 1.0e-2) then
            itest=0
        else
            do k=1,npt
                vlag(k)=fval(k)-fval(kopt)
            enddo
            gisq=zero
            do i=1,n
                sum=zero
                do k=1,npt
                    sum=sum+bmat(k,i)*vlag(k)
                enddo
                gisq=gisq+sum*sum
                w(i)=sum
            enddo

            ! Test whether to replace the new quadratic model by the
            ! least Frobenius norm interpolant, making the replacement
            ! if the test is satisfied.

            itest=itest+1
            if (gqsq < 1.0e+2*gisq) itest=0
            if (itest >= 3) then
                do i=1,n
                    gq(i)=w(i)
                enddo
                do ih=1,nh
                    hq(ih)=zero
                enddo
                do j=1,nptm
                    w(j)=zero
                    do k=1,npt
                        w(j)=w(j)+vlag(k)*zmat(k,j)
                    enddo
                    if (j < idz) w(j)=-w(j)
                enddo
                do k=1,npt
                    pq(k)=zero
                    do j=1,nptm
                        pq(k)=pq(k)+zmat(k,j)*w(j)
                    enddo
                enddo
                itest=0
            endif
        endif
      endif
      if (f < fsave) kopt=knew

    ! If a trust region step has provided a sufficient decrease in F, then
    ! branch for another trust region calculation. The case KSAVE>0 occurs
    ! when the new function value was calculated by a model step.

      if (f <= fsave+tenth*vquad) goto 100
      if (ksave > 0) goto 100

    ! Alternatively, find out if the interpolation points are close enough
    ! to the best point so far.

      knew=0
460   distsq=4.0*delta*delta
      do k=1,npt
        sum=zero
        do j=1,n
            sum=sum+(xpt(k,j)-xopt(j))**2
        enddo
        if (sum > distsq) then
            knew=k
            distsq=sum
        endif
      enddo

    ! If KNEW is positive, then set DSTEP, and branch back for the next
    ! iteration, which will generate a "model step".

      if (knew > 0) then
        dstep=max(min(tenth*sqrt(distsq),half*delta),rho)
        dsq=dstep*dstep
        goto 120
      endif
      if (ratio > zero) goto 100
      if (max(delta,dnorm) > rho) goto 100

    ! The calculations with the current value of RHO are complete. Pick the
    ! next values of RHO and DELTA.

490   if (rho > rhoend) then
        delta=half*rho
        ratio=rho/rhoend
        if (ratio <= 16.0) then
            rho=rhoend
        elseif (ratio <= 250.0) then
            rho=sqrt(ratio)*rhoend
        else
            rho=tenth*rho
        endif
        rho_uoa=rho
        delta=max(delta,rho)
        if (iprint >= 2) then
            if (iprint >= 3) print 500
500         format (5x)
            print 510, rho,nf
510         format (/4x,'New RHO =',1pd11.4,5x,'Number of', 
     .                  ' function values =',i6)
            print 520, fopt,(xbase(i)+xopt(i),i=1,n)
520         format (4x,'Least value of F =',1pd23.15,9x, 
     .                 'The corresponding X is:'/(2x,5d15.6))
        endif
        goto 90
      endif

    ! Return from the calculation, after another Newton-Raphson step, if
    ! it is too short to have been tried before.

      if (knew == -1) goto 290
530   if (fopt <= f) then
        do i=1,n
            x(i)=xbase(i)+xopt(i)
        enddo
        f=fopt
      endif
      if (iprint >= 1) then
        print 550, nf
550     format (/4x,'At the return from NEWUOA',5x, 
     .               'Number of function values =',i6)
        print 520, f,(x(i),i=1,n)
      endif
      return

      end ! newuob

c----------------------------------------------------------------------
! bigden.m,v 1.3 2006/08/12 18:27:06 bulmer Exp

      subroutine bigden (n,npt,xopt,xpt,bmat,zmat,idz,ndim,kopt, 
     .              knew,d,w,vlag,beta,s,wvec,prod)

      implicit real*8 (a-h,o-z), integer (i-n)

      dimension xopt(*),xpt(npt,*),bmat(ndim,*),zmat(npt,*),d(*)
      dimension w(*),vlag(*),s(*),wvec(ndim,*),prod(ndim,*)
      dimension den(9),denex(9),par(9)

    ! N is the number of variables.
    ! NPT is the number of interpolation equations.
    ! XOPT is the best interpolation point so far.
    ! XPT contains the coordinates of the current interpolation points.
    ! BMAT provides the last N columns of H.
    ! ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
    ! NDIM is the first dimension of BMAT and has the value NPT+N.
    ! KOPT is the index of the optimal interpolation point.
    ! KNEW is the index of the interpolation point that is going to be moved.
    ! D will be set to the step from XOPT to the new point, and on entry it
    !   should be the D that was calculated by the last call of BIGLAG. The
    !   length of the initial D provides a trust region bound on the final D.
    ! W will be set to Wcheck for the final choice of D.
    ! VLAG will be set to Theta*Wcheck+e_b for the final choice of D.
    ! BETA will be set to the value that will occur in the updating formula
    !   when the KNEW-th interpolation point is moved to its new position.
    ! S, WVEC, PROD and the private arrays DEN, DENEX and PAR will be used
    !   for working space.
    !
    ! D is calculated in a way that should provide a denominator with a large
    ! modulus in the updating formula when the KNEW-th interpolation point is
    ! shifted to the new position XOPT+D.

      half=0.5
      one=1.0
      quart=0.25
      two=2.0
      zero=0.0
      twopi=8.0*atan(one)
      nptm=npt-n-1

    ! Store the first NPT elements of the KNEW-th column of H in W(N+1)
    ! to W(N+NPT).

      do k=1,npt
        w(n+k)=zero
      enddo
      do j=1,nptm
        temp=zmat(knew,j)
        if (j < idz) temp=-temp
        do k=1,npt
            w(n+k)=w(n+k)+temp*zmat(k,j)
        enddo
      enddo
      alpha=w(n+knew)

    ! The initial search direction D is taken from the last call of BIGLAG,
    ! and the initial S is set below, usually to the direction from X_OPT
    ! to X_KNEW, but a different direction to an interpolation point may
    ! be chosen, in order to prevent S from being nearly parallel to D.

      dd=zero
      ds=zero
      ss=zero
      xoptsq=zero
      do i=1,n
        dd=dd+d(i)**2
        s(i)=xpt(knew,i)-xopt(i)
        ds=ds+d(i)*s(i)
        ss=ss+s(i)**2
        xoptsq=xoptsq+xopt(i)**2
      enddo
      if (ds*ds > 0.99*dd*ss) then
        ksav=knew
        dtest=ds*ds/ss
        do k=1,npt
            if (k .ne. kopt) then
                dstemp=zero
                sstemp=zero
                do i=1,n
                    diff=xpt(k,i)-xopt(i)
                    dstemp=dstemp+d(i)*diff
                    sstemp=sstemp+diff*diff
                enddo
                if (dstemp*dstemp/sstemp < dtest) then
                    ksav=k
                    dtest=dstemp*dstemp/sstemp
                    ds=dstemp
                    ss=sstemp
                endif
            endif
        enddo
        do i=1,n
            s(i)=xpt(ksav,i)-xopt(i)
        enddo
      endif
      ssden=dd*ss-ds*ds
      iterc=0
      densav=zero

    ! Begin the iteration by overwriting S with a vector that has the
    ! required length and direction.

70    iterc=iterc+1
      temp=one/sqrt(ssden)
      xoptd=zero
      xopts=zero
      do i=1,n
        s(i)=temp*(dd*s(i)-ds*d(i))
        xoptd=xoptd+xopt(i)*d(i)
        xopts=xopts+xopt(i)*s(i)
      enddo

    ! Set the coefficients of the first two terms of BETA.

      tempa=half*xoptd*xoptd
      tempb=half*xopts*xopts
      den(1)=dd*(xoptsq+half*dd)+tempa+tempb
      den(2)=two*xoptd*dd
      den(3)=two*xopts*dd
      den(4)=tempa-tempb
      den(5)=xoptd*xopts
      do i=6,9
        den(i)=zero
      enddo

    ! Put the coefficients of Wcheck in WVEC.

      do k=1,npt
        tempa=zero
        tempb=zero
        tempc=zero
        do i=1,n
            tempa=tempa+xpt(k,i)*d(i)
            tempb=tempb+xpt(k,i)*s(i)
            tempc=tempc+xpt(k,i)*xopt(i)
        enddo
        wvec(k,1)=quart*(tempa*tempa+tempb*tempb)
        wvec(k,2)=tempa*tempc
        wvec(k,3)=tempb*tempc
        wvec(k,4)=quart*(tempa*tempa-tempb*tempb)
        wvec(k,5)=half*tempa*tempb
      enddo
      do i=1,n
        ip=i+npt
        wvec(ip,1)=zero
        wvec(ip,2)=d(i)
        wvec(ip,3)=s(i)
        wvec(ip,4)=zero
        wvec(ip,5)=zero
      enddo

    ! Put the coefficents of THETA*Wcheck in PROD.

      do jc=1,5
        nw=npt
        if (jc == 2 .or. jc == 3) nw=ndim
        do k=1,npt
            prod(k,jc)=zero
        enddo
        do j=1,nptm
            sum=zero
            do k=1,npt
                sum=sum+zmat(k,j)*wvec(k,jc)
            enddo
            if (j < idz) sum=-sum
            do k=1,npt
                prod(k,jc)=prod(k,jc)+sum*zmat(k,j)
            enddo
        enddo
        if (nw == ndim) then
            do k=1,npt
                sum=zero
                do j=1,n
                    sum=sum+bmat(k,j)*wvec(npt+j,jc)
                enddo
                prod(k,jc)=prod(k,jc)+sum
            enddo
        endif
        do  j=1,n
            sum=zero
            do i=1,nw
                sum=sum+bmat(i,j)*wvec(i,jc)
            enddo
            prod(npt+j,jc)=sum
        enddo
      enddo

    ! Include in DEN the part of BETA that depends on THETA.

      do k=1,ndim
        sum=zero
        do i=1,5
            par(i)=half*prod(k,i)*wvec(k,i)
            sum=sum+par(i)
        enddo
        den(1)=den(1)-par(1)-sum
        tempa=prod(k,1)*wvec(k,2)+prod(k,2)*wvec(k,1)
        tempb=prod(k,2)*wvec(k,4)+prod(k,4)*wvec(k,2)
        tempc=prod(k,3)*wvec(k,5)+prod(k,5)*wvec(k,3)
        den(2)=den(2)-tempa-half*(tempb+tempc)
        den(6)=den(6)-half*(tempb-tempc)
        tempa=prod(k,1)*wvec(k,3)+prod(k,3)*wvec(k,1)
        tempb=prod(k,2)*wvec(k,5)+prod(k,5)*wvec(k,2)
        tempc=prod(k,3)*wvec(k,4)+prod(k,4)*wvec(k,3)
        den(3)=den(3)-tempa-half*(tempb-tempc)
        den(7)=den(7)-half*(tempb+tempc)
        tempa=prod(k,1)*wvec(k,4)+prod(k,4)*wvec(k,1)
        den(4)=den(4)-tempa-par(2)+par(3)
        tempa=prod(k,1)*wvec(k,5)+prod(k,5)*wvec(k,1)
        tempb=prod(k,2)*wvec(k,3)+prod(k,3)*wvec(k,2)
        den(5)=den(5)-tempa-half*tempb
        den(8)=den(8)-par(4)+par(5)
        tempa=prod(k,4)*wvec(k,5)+prod(k,5)*wvec(k,4)
        den(9)=den(9)-half*tempa
      enddo

      ! Extend DEN so that it holds all the coefficients of DENOM.

      sum=zero
      do i=1,5
        par(i)=half*prod(knew,i)**2
        sum=sum+par(i)
      enddo
      denex(1)=alpha*den(1)+par(1)+sum
      tempa=two*prod(knew,1)*prod(knew,2)
      tempb=prod(knew,2)*prod(knew,4)
      tempc=prod(knew,3)*prod(knew,5)
      denex(2)=alpha*den(2)+tempa+tempb+tempc
      denex(6)=alpha*den(6)+tempb-tempc
      tempa=two*prod(knew,1)*prod(knew,3)
      tempb=prod(knew,2)*prod(knew,5)
      tempc=prod(knew,3)*prod(knew,4)
      denex(3)=alpha*den(3)+tempa+tempb-tempc
      denex(7)=alpha*den(7)+tempb+tempc
      tempa=two*prod(knew,1)*prod(knew,4)
      denex(4)=alpha*den(4)+tempa+par(2)-par(3)
      tempa=two*prod(knew,1)*prod(knew,5)
      denex(5)=alpha*den(5)+tempa+prod(knew,2)*prod(knew,3)
      denex(8)=alpha*den(8)+par(4)-par(5)
      denex(9)=alpha*den(9)+prod(knew,4)*prod(knew,5)

    ! Seek the value of the angle that maximizes the modulus of DENOM.

      sum=denex(1)+denex(2)+denex(4)+denex(6)+denex(8)
      denold=sum
      denmax=sum
      isave=0
      iu=49
      temp=twopi/real(iu+1)
      par(1)=one
      do i=1,iu
        angle=real(i)*temp
        par(2)=cos(angle)
        par(3)=sin(angle)
        do j=4,8,2
            par(j)=par(2)*par(j-2)-par(3)*par(j-1)
            par(j+1)=par(2)*par(j-1)+par(3)*par(j-2)
        enddo
        sumold=sum
        sum=zero
        do j=1,9
            sum=sum+denex(j)*par(j)
        enddo
        if (abs(sum) > abs(denmax)) then
            denmax=sum
            isave=i
            tempa=sumold
        elseif (i == isave+1) then
            tempb=sum
        endif
      enddo
      if (isave == 0) tempa=sum
      if (isave == iu) tempb=denold
      step=zero
      if (tempa .ne. tempb) then
        tempa=tempa-denmax
        tempb=tempb-denmax
        step=half*(tempa-tempb)/(tempa+tempb)
      endif
      angle=temp*(real(isave)+step)

    ! Calculate the new parameters of the denominator, the new VLAG vector
    ! and the new D. Then test for convergence.

      par(2)=cos(angle)
      par(3)=sin(angle)
      do j=4,8,2
        par(j)=par(2)*par(j-2)-par(3)*par(j-1)
        par(j+1)=par(2)*par(j-1)+par(3)*par(j-2)
      enddo
      beta=zero
      denmax=zero
      do j=1,9
        beta=beta+den(j)*par(j)
        denmax=denmax+denex(j)*par(j)
      enddo
      do k=1,ndim
        vlag(k)=zero
        do j=1,5
            vlag(k)=vlag(k)+prod(k,j)*par(j)
        enddo
      enddo
      tau=vlag(knew)
      dd=zero
      tempa=zero
      tempb=zero
      do i=1,n
        d(i)=par(2)*d(i)+par(3)*s(i)
        w(i)=xopt(i)+d(i)
        dd=dd+d(i)**2
        tempa=tempa+d(i)*w(i)
        tempb=tempb+w(i)*w(i)
      enddo
      if (iterc >= n) goto 340
      if (iterc > 1) densav=max(densav,denold)
      if (abs(denmax) <= 1.1*abs(densav)) goto 340
      densav=denmax

    ! Set S to half the gradient of the denominator with respect to D.
    ! Then branch for the next iteration.

      do i=1,n
        temp=tempa*xopt(i)+tempb*d(i)-vlag(npt+i)
        s(i)=tau*bmat(knew,i)+alpha*temp
      enddo
      do k=1,npt
        sum=zero
        do j=1,n
            sum=sum+xpt(k,j)*w(j)
        enddo
        temp=(tau*w(n+k)-alpha*vlag(k))*sum
        do i=1,n
            s(i)=s(i)+temp*xpt(k,i)
        enddo
      enddo
      ss=zero
      ds=zero
      do i=1,n
        ss=ss+s(i)**2
        ds=ds+d(i)*s(i)
      enddo
      ssden=dd*ss-ds*ds
      if (ssden >= 1.0e-8*dd*ss) goto 70

    ! Set the vector W before the RETURN from the subroutine.

340   do k=1,ndim
          w(k)=zero
          do j=1,5
            w(k)=w(k)+wvec(k,j)*par(j)
          enddo
      enddo
      vlag(kopt)=vlag(kopt)+one

      return

      end ! bigden

c----------------------------------------------------------------------
! biglag.m,v 1.3 2006/08/12 18:27:06 bulmer Exp

      subroutine biglag(n,npt,xopt,xpt,bmat,zmat,idz,ndim,knew, 
     .             delta,d,alpha,hcol,gc,gd,s,w)

      implicit real (a-h,o-z), integer (i-n)
      dimension xopt(*),xpt(npt,*),bmat(ndim,*),zmat(npt,*),d(*)
      dimension hcol(*),gc(*),gd(*),s(*),w(*)

    ! N is the number of variables.
    ! NPT is the number of interpolation equations.
    ! XOPT is the best interpolation point so far.
    ! XPT contains the coordinates of the current interpolation points.
    ! BMAT provides the last N columns of H.
    ! ZMAT and IDZ give a factorization of the first NPT by NPT submatrix of H.
    ! NDIM is the first dimension of BMAT and has the value NPT+N.
    ! KNEW is the index of the interpolation point that is going to be moved.
    ! DELTA is the current trust region bound.
    ! D will be set to the step from XOPT to the new point.
    ! ALPHA will be set to the KNEW-th diagonal element of the H matrix.
    ! HCOL, GC, GD, S and W will be used for working space.
    !
    ! The step D is calculated in a way that attempts to maximize the modulus
    ! of LFUNC(XOPT+D), subject to the bound ||D|| <= DELTA, where LFUNC is
    ! the KNEW-th Lagrange function.

      half=0.5
      one=1.0
      zero=0.0
      twopi=8.0*atan(one)
      delsq=delta*delta
      nptm=npt-n-1

    ! Set the first NPT components of HCOL to the leading elements of the
    ! KNEW-th column of H.

      iterc=0
      do k=1,npt
        hcol(k)=zero
      enddo
      do j=1,nptm
        temp=zmat(knew,j)
        if (j < idz) temp=-temp
        do k=1,npt
            hcol(k)=hcol(k)+temp*zmat(k,j)
        enddo
      enddo
      alpha=hcol(knew)

    ! Set the unscaled initial direction D. Form the gradient of LFUNC at
    ! XOPT, and multiply D by the second derivative matrix of LFUNC.

      dd=zero
      do i=1,n
        d(i)=xpt(knew,i)-xopt(i)
        gc(i)=bmat(knew,i)
        gd(i)=zero
        dd=dd+d(i)**2
      enddo
      do k=1,npt
        temp=zero
        sum=zero
        do j=1,n
            temp=temp+xpt(k,j)*xopt(j)
            sum=sum+xpt(k,j)*d(j)
        enddo
        temp=hcol(k)*temp
        sum=hcol(k)*sum
        do i=1,n
            gc(i)=gc(i)+temp*xpt(k,i)
            gd(i)=gd(i)+sum*xpt(k,i)
        enddo
      enddo

    ! Scale D and GD, with a sign change if required. Set S to another
    ! vector in the initial two dimensional subspace.

      gg=zero
      sp=zero
      dhd=zero
      do i=1,n
        gg=gg+gc(i)**2
        sp=sp+d(i)*gc(i)
        dhd=dhd+d(i)*gd(i)
      enddo
      scale=delta/dsqrt(dd)
      if (sp*dhd < zero) scale=-scale
      temp=zero
      if (sp*sp > 0.99*dd*gg) temp=one
      tau=scale*(abs(sp)+half*scale*abs(dhd))
      if (gg*delsq < 0.01*tau*tau) temp=one
      do i=1,n
        d(i)=scale*d(i)
        gd(i)=scale*gd(i)
        s(i)=gc(i)+temp*gd(i)
      enddo

    ! Begin the iteration by overwriting S with a vector that has the
    ! required length and direction, except that termination occurs if
    ! the given D and S are nearly parallel.

 80   iterc=iterc+1
      dd=zero
      sp=zero
      ss=zero
      do i=1,n
        dd=dd+d(i)**2
        sp=sp+d(i)*s(i)
        ss=ss+s(i)**2
      enddo
      temp=dd*ss-sp*sp
      if (temp <= 1.0e-8*dd*ss) goto 160
      denom=sqrt(temp)
      do i=1,n
        s(i)=(dd*s(i)-sp*d(i))/denom
        w(i)=zero
      enddo

    ! Calculate the coefficients of the objective function on the circle,
    ! beginning with the multiplication of S by the second derivative matrix.

      do k=1,npt
        sum=zero
        do j=1,n
            sum=sum+xpt(k,j)*s(j)
        enddo
        sum=hcol(k)*sum
        do i=1,n
            w(i)=w(i)+sum*xpt(k,i)
        enddo
      enddo
      cf1=zero
      cf2=zero
      cf3=zero
      cf4=zero
      cf5=zero
      do i=1,n
        cf1=cf1+s(i)*w(i)
        cf2=cf2+d(i)*gc(i)
        cf3=cf3+s(i)*gc(i)
        cf4=cf4+d(i)*gd(i)
        cf5=cf5+s(i)*gd(i)
      enddo
      cf1=half*cf1
      cf4=half*cf4-cf1

    ! Seek the value of the angle that maximizes the modulus of TAU.

      taubeg=cf1+cf2+cf4
      taumax=taubeg
      tauold=taubeg
      isave=0
      iu=49
      temp=twopi/real(iu+1)
      do i=1,iu
        angle=real(i)*temp
        cth=cos(angle)
        sth=sin(angle)
        tau=cf1+(cf2+cf4*cth)*cth+(cf3+cf5*cth)*sth
        if (abs(tau) > abs(taumax)) then
            taumax=tau
            isave=i
            tempa=tauold
        elseif (i == isave+1) then
            tempb=tau
        endif
        tauold=tau
      enddo
      if (isave == 0) tempa=tau
      if (isave == iu) tempb=taubeg
      step=zero
      if (tempa .ne. tempb) then
        tempa=tempa-taumax
        tempb=tempb-taumax
        step=half*(tempa-tempb)/(tempa+tempb)
      endif
      angle=temp*(real(isave)+step)

    ! Calculate the new D and GD. Then test for convergence.

      cth=cos(angle)
      sth=sin(angle)
      tau=cf1+(cf2+cf4*cth)*cth+(cf3+cf5*cth)*sth
      do i=1,n
        d(i)=cth*d(i)+sth*s(i)
        gd(i)=cth*gd(i)+sth*w(i)
        s(i)=gc(i)+gd(i)
      enddo

      if (dabs(tau) <= 1.1*abs(taubeg)) goto 160
      if (iterc < n) goto 80
160   return

      end ! biglag

c----------------------------------------------------------------------
! trsapp.m,v 1.5 2006/08/12 18:27:06 bulmer Exp

      subroutine trsapp(n,npt,xopt,xpt,gq,hq,pq,delta,step,d,g,hd,hs,crvmin)

      implicit real (a-h,o-z), integer (i-n)
      dimension xopt(*),xpt(npt,*),gq(*),hq(*),pq(*),step(*),d(*),g(*),hd(*),hs(*)

    ! N is the number of variables of a quadratic objective function, Q say.
    ! The arguments NPT, XOPT, XPT, GQ, HQ and PQ have their usual meanings,
    !   in order to define the current quadratic model Q.
    ! DELTA is the trust region radius, and has to be positive.
    ! STEP will be set to the calculated trial step.
    ! The arrays D, G, HD and HS will be used for working space.
    ! CRVMIN will be set to the least curvature of H along the conjugate
    ! directions that occur, except that it is set to zero if STEP goes
    ! all the way to the trust region boundary.
    !
    ! The calculation of STEP begins with the truncated conjugate gradient
    ! method. If the boundary of the trust region is reached, then further
    ! changes to STEP may be made, each one being in the 2D space spanned
    ! by the current STEP and the corresponding gradient of Q. Thus STEP
    ! should provide a substantial reduction to Q within the trust region.
    !
    ! Initialization, which includes setting HD to H times XOPT.

      half=0.5
      zero=0.0
      twopi=8.0*atan(1.0)
      delsq=delta*delta
      iterc=0
      itermax=n
      itersw=itermax
      do i=1,n
          d(i)=xopt(i)
      enddo
      goto 170

    ! Prepare for the first line search.

 20   qred=zero
      dd=zero
      do i=1,n
        step(i)=zero
        hs(i)=zero
        g(i)=gq(i)+hd(i)
        d(i)=-g(i)
        dd=dd+d(i)**2
      enddo
      crvmin=zero
      if (dd == zero) goto 160
      ds=zero
      ss=zero
      gg=dd
      ggbeg=gg

    ! Calculate the step to the trust region boundary and the product HD.

 40   iterc=iterc+1
      temp=delsq-ss
      arg=ds*ds+dd*temp
      if (arg <= 0.0) then
        call remark('***FATAL in UOA (trsapp: divide-by-zero, reduce rhobeg')
        call kaboom(0)
      endif
      bstep=temp/(ds+sqrt(ds*ds+dd*temp))
      goto 170
 50   dhd=zero
      do j=1,n
        dhd=dhd+d(j)*hd(j)
      enddo

    ! Update CRVMIN and set the step-length ALPHA.

      alpha=bstep
      if (dhd > zero) then
        temp=dhd/dd
        if (iterc == 1) crvmin=temp
        crvmin=min(crvmin,temp)
        alpha=min(alpha,gg/dhd)
      endif
      qadd=alpha*(gg-half*alpha*dhd)
      qred=qred+qadd

    !  Update STEP and HS.

      ggsav=gg
      gg=zero
      do i=1,n
        step(i)=step(i)+alpha*d(i)
        hs(i)=hs(i)+alpha*hd(i)
        gg=gg+(g(i)+hs(i))**2
      enddo

    !  Begin another conjugate direction iteration if required.

      if (alpha < bstep) then
        if (qadd <= 0.01*qred) goto 160
        if (gg <= 0.0001*ggbeg) goto 160
        if (iterc == itermax) goto 160
        temp=gg/ggsav
        dd=zero
        ds=zero
        ss=zero
        do i=1,n
            d(i)=temp*d(i)-g(i)-hs(i)
            dd=dd+d(i)**2
            ds=ds+d(i)*step(i)
            ss=ss+step(i)**2
        enddo
        if (ds <= zero) goto 160
        if (ss < delsq) goto 40
      endif
      crvmin=zero
      itersw=iterc

    ! Test whether an alternative iteration is required.

 90   if (gg <= 1.0e-4*ggbeg) goto 160
      sg=zero
      shs=zero
      do i=1,n
        sg=sg+step(i)*g(i)
        shs=shs+step(i)*hs(i)
      enddo
      sgk=sg+shs
      angtest=sgk/sqrt(gg*delsq)
      if (angtest <= -0.99) goto 160

    !  Begin the alternative iteration by calculating D and HD and some
    !  scalar products.

      iterc=iterc+1
      temp=sqrt(delsq*gg-sgk*sgk)
      tempa=delsq/temp
      tempb=sgk/temp
      do i=1,n
        d(i)=tempa*(g(i)+hs(i))-tempb*step(i)
      enddo
      goto 170
120   dg=zero
      dhd=zero
      dhs=zero
      do i=1,n
        dg=dg+d(i)*g(i)
        dhd=dhd+hd(i)*d(i)
        dhs=dhs+hd(i)*step(i)
      enddo

    ! Seek the value of the angle that minimizes Q.

      cf=half*(shs-dhd)
      qbeg=sg+cf
      qsav=qbeg
      qmin=qbeg
      isave=0
      iu=49
      temp=twopi/real(iu+1)
      do i=1,iu
        angle=real(i)*temp
        cth=cos(angle)
        sth=sin(angle)
        qnew=(sg+cf*cth)*cth+(dg+dhs*cth)*sth
        if (qnew < qmin) then
            qmin=qnew
            isave=i
            tempa=qsav
        elseif (i == isave+1) then
            tempb=qnew
        endif
        qsav=qnew
      enddo
      if (isave == zero) tempa=qnew
      if (isave == iu) tempb=qbeg
      angle=zero
      if (tempa .ne. tempb) then
        tempa=tempa-qmin
        tempb=tempb-qmin
        angle=half*(tempa-tempb)/(tempa+tempb)
      endif
      angle=temp*(real(isave)+angle)
    
    ! Calculate the new STEP and HS. Then test for convergence.

      cth=cos(angle)
      sth=sin(angle)
      reduc=qbeg-(sg+cf*cth)*cth-(dg+dhs*cth)*sth
      gg=zero
      do i=1,n
        step(i)=cth*step(i)+sth*d(i)
        hs(i)=cth*hs(i)+sth*hd(i)
        gg=gg+(g(i)+hs(i))**2
      enddo
      qred=qred+reduc
      ratio=reduc/qred
      if (iterc < itermax .and. ratio > 0.01) goto 90
160   return

    ! The following instructions act as a subroutine for setting the vector
    ! HD to the vector D multiplied by the second derivative matrix of Q.
    ! They are called from three different places, which are distinguished
    ! by the value of ITERC.

170   do i=1,n
        hd(i)=zero
      enddo
      do k=1,npt
        temp=zero
        do j=1,n
            temp=temp+xpt(k,j)*d(j)
        enddo
        temp=temp*pq(k)
        do i=1,n
            hd(i)=hd(i)+temp*xpt(k,i)
        enddo
      enddo
      ih=0
      do j=1,n
        do i=1,j
            ih=ih+1
            if (i < j) hd(j)=hd(j)+hq(ih)*d(i)
            hd(i)=hd(i)+hq(ih)*d(j)
        enddo
      enddo
      if (iterc == 0) goto 20
      if (iterc <= itersw) goto 50
      goto 120
    
      end ! trsapp

c----------------------------------------------------------------------
! update.m,v 1.3 2006/08/12 18:27:06 bulmer Exp

      subroutine update(n,npt,bmat,zmat,idz,ndim,vlag,beta,knew,w)

      implicit real (a-h,o-z), integer (i-n)
      dimension bmat(ndim,*),zmat(npt,*),vlag(*),w(*)

    ! The arrays BMAT and ZMAT with IDZ are updated, in order to shift the
    ! interpolation point that has index KNEW. On entry, VLAG contains the
    ! components of the vector Theta*Wcheck+e_b of the updating formula
    ! (6.11), and BETA holds the value of the parameter that has this name.
    ! The vector W is used for working space.
    ! 
    ! Set some constants.

      one=1.0
      zero=0.0
      nptm=npt-n-1

    ! Apply the rotations that put zeros in the KNEW-th row of ZMAT.

      jl=1
      do j=2,nptm
        if (j == idz) then
            jl=idz
        elseif (zmat(knew,j) .ne. zero) then
            temp=sqrt(zmat(knew,jl)**2+zmat(knew,j)**2)
            tempa=zmat(knew,jl)/temp
            tempb=zmat(knew,j)/temp
            do i=1,npt
                temp=tempa*zmat(i,jl)+tempb*zmat(i,j)
                zmat(i,j)=tempa*zmat(i,j)-tempb*zmat(i,jl)
                zmat(i,jl)=temp
            enddo
            zmat(knew,j)=zero
        endif
      enddo

    ! Put the first NPT components of the KNEW-th column of HLAG into W,
    ! and calculate the parameters of the updating formula.

      tempa=zmat(knew,1)
      if (idz >= 2) tempa=-tempa
      if (jl > 1) tempb=zmat(knew,jl)
      do i=1,npt
        w(i)=tempa*zmat(i,1)
        if (jl > 1) w(i)=w(i)+tempb*zmat(i,jl)
      enddo
      alpha=w(knew)
      tau=vlag(knew)
      tausq=tau*tau
      denom=alpha*beta+tausq
      vlag(knew)=vlag(knew)-one
    
    ! Complete the updating of ZMAT when there is only one nonzero element
    ! in the KNEW-th row of the new matrix ZMAT, but, if IFLAG is set to one,
    ! then the first column of ZMAT will be exchanged with another one later.

      iflag=0
      if (jl == 1) then
        temp=sqrt(abs(denom))
        tempb=tempa/temp
        tempa=tau/temp
        do i=1,npt
            zmat(i,1)=tempa*zmat(i,1)-tempb*vlag(i)
        enddo
        if (idz == 1 .and. temp < zero) idz=2
        if (idz >= 2 .and. temp >= zero) iflag=1
      else
        ! Complete the updating of ZMAT in the alternative case.
        ja=1
        if (beta >= zero) ja=jl
        jb=jl+1-ja
        temp=zmat(knew,jb)/denom
        tempa=temp*beta
        tempb=temp*tau
        temp=zmat(knew,ja)
        scala=one/sqrt(abs(beta)*temp*temp+tausq)
        scalb=scala*sqrt(abs(denom))
        do i=1,npt
            zmat(i,ja)=scala*(tau*zmat(i,ja)-temp*vlag(i))
            zmat(i,jb)=scalb*(zmat(i,jb)-tempa*w(i)-tempb*vlag(i))
        enddo
        if (denom <= zero) then
            if (beta < zero) idz=idz+1
            if (beta >= zero) iflag=1
        endif
      endif

    ! IDZ is reduced in the following case, and usually the first column
    ! of ZMAT is exchanged with a later one.

      if (iflag == 1) then
        idz=idz-1
        do i=1,npt
            temp=zmat(i,1)
            zmat(i,1)=zmat(i,idz)
            zmat(i,idz)=temp
        enddo
      endif

    ! Finally, update the matrix BMAT.

      do j=1,n
        jp=npt+j
        w(jp)=bmat(knew,j)
        tempa=(alpha*vlag(jp)-tau*w(jp))/denom
        tempb=(-beta*w(jp)-tau*vlag(jp))/denom
        do i=1,jp
            bmat(i,j)=bmat(i,j)+tempa*vlag(i)+tempb*w(i)
            if (i > npt) bmat(jp,i-npt)=bmat(i,j)
        enddo
      enddo

      return

      end ! update

c----------------------------------------------------------------------
! calfun.m,v 1.2 2004/10/10 19:51:43 bulmer Exp


      subroutine calfun(n,x,f)

            use UOA 

    ! This routine, which was the user-supplied object function evaluator
    ! in the original Fortran NEWUOA, now executes a Basis script function
    ! which is a wrapper for the new user-supplied script (of arbitrary
    ! name) that evaluates the object function.

      implicit real (a-h,o-z), integer (i-n)
      dimension x(*)

      do i=1,n
        x_uoa(i)=x(i)
      enddo
c_tdr      call parsestr("f_uoa=objfcn_newuoa(x_uoa)")
      call remark('***Must provide functionality just above to use')
      call remark('***parsestr does not work for c++ uedge')
      call kaboom(0)
      f=f_uoa

      return

      end ! calfun

      subroutine glbwrlog(ioun)
 
c This is extracted from basis' subroutine glbdone in files.m in order to
c to get the timing info into the log-file. (At some point, they moved the
c line call baspecho(0) in subroutine glbdone before the call glbwrtim.)
C Note that since ostime is re-called here, the numbers in the log may differ
c slightly from what appears on the screen, and that glbwrtim in fact writes
c only cpu and sys.
 
      real cpu,io,sys,mem
      integer ioun
      call ostime(cpu,io,sys,mem)
      call glbwrtim(ioun,cpu,io,sys,mem)
      return
      end

      subroutine xerrab (msg)
      character*(*) msg
c ... Output the message in character string "msg" to standard out,
c     and then return control to the user.
c     Note that "remark" and "kaboom" are part of the Basis runtime
c     library.
      call remark(msg)
      call kaboom(0)
      return
      end
*DECK XERMShG
      SUBROUTINE XERMShG (LIBRAR, SUBROU, MESSG, NERR, LEVEL)
C-----------------------------------------------------------------------
C Subroutines XERMShG, XSETFP, XSETUNP, and parmsetget, as
C given here, constitute a simplified version of the SLATEC error
C handling package.  Written by A. C. Hindmarsh, 18 November 1992.
c Modified by Gary R. Smith, 5 January 1994.
C
C All arguments are input arguments.
C LIBRAR = Library name (character array).  Prefixed to message.
C SUBROU = Routine name (character array).  Prefixed to message.
C MESSG  = The message (character array).
C NERR   = Integer error number.  Prefixed to message.
C LEVEL  = The error level..
C          0 or 1 means recoverable (control returns to caller).
C          2 means fatal (run is aborted--see note below).
C
C Note..  This routine has been simplified in the following ways..
C 1. A single prefix line is printed with NERR, SUBROU, and LIBRAR.
C 2. The message in MESSG is printed, unaltered, on lines of up to 72
C    characters each using a format of (A).
C 3. If LEVEL = 2, control passes to the statement   STOP
C    to abort the run.  This statement may be machine-dependent.
C
C For a different default logical unit number, change the data
C statement in subroutine parmsetget.
C For a different run-abort command, change the statement following
C statement 100 at the end.
C-----------------------------------------------------------------------
C Subroutine called by XERMShG.. parmsetget
C Function routines called by XERMShG.. None
C Intrinsic function used by XERMShG.. LEN
C-----------------------------------------------------------------------
      CHARACTER*(*) LIBRAR, SUBROU, MESSG
      INTEGER NERR, LEVEL
      INTEGER I1, I2, IL, LENMSG, LLEN, LUNIT, MESFLG, NLINES
      PARAMETER (LLEN = 72)
C
C Get message print flag and logical unit number. ----------------------
      call parmsetget (1, LUNIT, .false.)
      call parmsetget (2, MESFLG, .false.)
      IF (MESFLG .EQ. 0) GO TO 100
C Write NERR, SUBROU, and LIBRAR. --------------------------------------
      I1 = LEN(SUBROU)
      I2 = LEN(LIBRAR)
      WRITE (LUNIT, 10) NERR, SUBROU(1:I1), LIBRAR(1:I2)
  10  FORMAT(/,'***Error number ',I6,' from ',A,' in library ',A,'***')
C Write the message. ---------------------------------------------------
      LENMSG = LEN(MESSG)
      NLINES = ( (LENMSG - 1)/LLEN ) + 1
      DO 20 IL = 1,NLINES
        I1 = 1 + (IL - 1)*LLEN
        I2 = MIN(IL*LLEN,LENMSG)
        WRITE (LUNIT,'(A)') MESSG(I1:I2)
  20    CONTINUE
C Abort the run if LEVEL = 2. ------------------------------------------
 100  IF (LEVEL .NE. 2) RETURN
      call kaboom(0)
C----------------------- End of Subroutine XERMShG ----------------------
      END
*DECK XSETUNP
      SUBROUTINE XSETUNP (LUN)
C-----------------------------------------------------------------------
C This routine resets the logical unit number for messages.
C
C Subroutine called by XSETUNP.. parmsetget
C Function routines called by XSETUNP.. None
C-----------------------------------------------------------------------
      INTEGER LUN
C
      IF (LUN .GT. 0) call parmsetget (1,LUN,.true.)
      RETURN
C----------------------- End of Subroutine XSETUNP ---------------------
      END
*DECK XSETFP
      SUBROUTINE XSETFP (MFLAG)
C-----------------------------------------------------------------------
C This routine resets the print control flag MFLAG.
C
C Subroutine called by XSETFP.. parmsetget
C Function routines called by XSETFP.. None
C-----------------------------------------------------------------------
      INTEGER MFLAG
C
      IF (MFLAG .EQ. 0 .OR. MFLAG .EQ. 1)
     .   call parmsetget (2,MFLAG,.true.)
      RETURN
C----------------------- End of Subroutine XSETFP ----------------------
      END
*DECK parmsetget
      SUBROUTINE parmsetget (IPAR, IVALUE, ISET)
      LOGICAL ISET
      INTEGER IPAR, IVALUE
C-----------------------------------------------------------------------
C parmsetget saves and recalls one of two error message parameters:
C   LUNIT, the logical unit number to which messages are printed, and
C   MESFLG, the message print flag.
C This is a modification of the SLATEC library routine J4SAVE.
C
C Saved local variables..
C  LUNIT  = Logical unit number for messages.
C           The default is 6 (machine-dependent).
C  MESFLG = Print control flag..
C           1 means print all messages (the default).
C           0 means no printing.
C
C On input..
C   IPAR   = Parameter indicator (1 for LUNIT, 2 for MESFLG).
C   IVALUE = The value to be set for the parameter, if ISET = .true.
c            or the existing value of the parameter, if ISET = .false.
C   ISET   = Logical flag to indicate whether to read or write.
C            If ISET = .true., the parameter will be given
C            the value IVALUE.  If ISET = .false., the parameter
C            will be unchanged, and IVALUE contains the parameter
c            value on exit.
C
C Subroutines/functions called by parmsetget.. None
C-----------------------------------------------------------------------
      INTEGER LUNIT, MESFLG
C-----------------------------------------------------------------------
C The following Fortran-77 declaration is to cause the values of the
C listed (local) variables to be saved between calls to this routine.
C-----------------------------------------------------------------------
      SAVE LUNIT, MESFLG
      DATA LUNIT/6/, MESFLG/1/
C
      IF (IPAR .EQ. 1) THEN
        IF (ISET) THEN
           LUNIT = IVALUE
        ELSE
           IVALUE = LUNIT
        ENDIF
      ENDIF
C
      IF (IPAR .EQ. 2) THEN
        IF (ISET) THEN
           MESFLG = IVALUE
        ELSE
           IVALUE = MESFLG
        ENDIF
      ENDIF
C
      RETURN
C----------------------- End of Subroutine parmsetget -------------------------
      END

       program junk

       double precision a


       a = float(30)/float(140)
       print *,sizeof(float(30)),a
       a = real(30)/real(140)
       print *,sizeof(real(30)),a
       a = dble(30)/dble(140)
       print *,sizeof(dble(30)),a
       stop
       end

MODULE PETSc_Snes_Param
  implicit none
#include "finclude/petscdef.h"
#include "finclude/petscvecdef.h"
#include "finclude/petscmatdef.h"
  SAVE
  PetscInt :: psp_nsnes=0
  Vec :: psp_snes=0
  Mat :: psp_Jmat=0
  Mat :: psp_Jmf=0
  PetscInt :: psp_JmatType=1
  PetscInt :: psp_fdcoloring=0
  PetscInt :: psp_usecolor=0
  Vec :: psp_F=0
  Vec :: psp_Floc=0
  Vec :: psp_X=0
  Vec :: psp_Xtmp=0
  Vec :: psp_Xloc=0
  Vec :: psp_SFVEC=0
  Vec :: psp_SUVEC=0
  Vec :: psp_ISUVEC=0
  PetscInt :: psp_isf=1
  PetscInt :: psp_ijnr=0
  PetscInt :: psp_iscolnorm=0
  PetscInt :: psp_skipJacobian=0
  PetscReal :: psp_jacMaxdtChange
  PetscReal :: psp_olddt=0.0
  PetscInt :: snesdebug=0 ! Does this do anything?
  PetscInt, PARAMETER :: psp_snesits=30
  PetscReal, DIMENSION(psp_snesits+1) :: nksolfnrm
  PetscReal, DIMENSION(psp_snesits+1) :: nksoltime
  PetscInt,  DIMENSION(psp_snesits+1) :: nksollinits
  PetscInt,  DIMENSION(psp_snesits+1) :: nksolfeval

  PetscInt, PARAMETER :: psp_jaclag_DEFAULT = 5
  PetscInt            :: psp_jaclag         = psp_jaclag_DEFAULT
END MODULE PETSc_Snes_Param

MODULE PETSc_Snes_Param_Monitor
  implicit none
#include "finclude/petscdef.h"
  SAVE
  PetscTruth :: psp_mon_on
  PetscTruth :: psp_mon_print_snes
  PetscInt   :: psp_mon_arrlen=1

  character*30, PARAMETER :: psp_mon_file_DEFAULT     = "trialuedge.m"
  character*30, PARAMETER :: psp_mon_sfile_DEFAULT    = "snesout.txt"
  PetscInt,     PARAMETER :: psp_mon_allocInc_DEFAULT = 10
  character*30            :: psp_mon_file             = psp_mon_file_DEFAULT
  character*30            :: psp_mon_sfile            = psp_mon_sfile_DEFAULT
  PetscInt                :: psp_mon_allocInc         = psp_mon_allocInc_DEFAULT

  PetscLogDouble :: psp_mon_colortime

  PetscReal,      ALLOCATABLE, DIMENSION(:) :: psp_mon_fnrm
  PetscReal,      ALLOCATABLE, DIMENSION(:) :: psp_mon_dtreal
  PetscLogDouble, ALLOCATABLE, DIMENSION(:) :: psp_mon_time
  PetscLogDouble, ALLOCATABLE, DIMENSION(:) :: psp_mon_ftime
  PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_kspits
  PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_fevals
  PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_fcalls
  PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_snesit
END MODULE PETSc_Snes_Param_Monitor

!
! $Id: petsc-uedge.F90,v 7.1 2019/05/30 22:18:16 meyer8 Exp $
!

!  Module used within a single call of PetscSnes()
! ------------------------------------------------
      module Petscmod
        implicit none
#include "finclude/petsc.h90"
!!#include "finclude/petscvec.h"
!!#include "finclude/petscvec.h90"
!!#include "finclude/petscmat.h"
!!#include "finclude/petscmat.h90"
!!#include "finclude/petscviewer.h"
!!#include "finclude/petscksp.h"
!!#include "finclude/petscpc.h"
!!#include "finclude/petscsnes.h"
!!#include "finclude/petscis.h"

      type Petscctx
        PetscScalar,pointer :: savfpoint(:),ylpoint(:)
        PetscScalar,pointer :: wkpoint(:)
        PetscInt,pointer :: icnstrpoint(:)
        PetscReal :: rlx
        PetscInt :: nnzmx    !maximum nom of nonzeros in Jacobian matrix, see Use(Jacobian)
        PetscInt :: incpset  !maximum num of Jacobian reevaluation, see Use(Lsode)
      end type Petscctx
      PetscLogStage :: stages(5)
      end module Petscmod

! ---------------------------------------------------------------------
      module Petscmodinterfaces
        use Petscmod
        implicit none

      Interface SNESSetApplicationContext
        Subroutine SNESSetApplicationContext(snes,ctx,ierr)
        use Petscmod
          SNES ::           snes
          type(Petscctx) :: ctx
          PetscErrorCode :: ierr
        End Subroutine
      End Interface SNESSetApplicationContext

      Interface SNESGetApplicationContext
        Subroutine SNESGetApplicationContext(snes,ctx,ierr)
        use Petscmod
          SNES ::           snes
          type(Petscctx), pointer :: ctx
          PetscErrorCode :: ierr
        End Subroutine
      End Interface SNESGetApplicationContext

      end module Petscmodinterfaces

! ---------------------------------------------------------------------
      module Petscmodinterface2
        use Petscmod
        implicit none

      Interface PetscSnesCreateObjs
        Subroutine PetscSnesCreateObjs(comm,n,neqg,nnzmx,ierr)
        use Petscmod
          integer4 ::       comm
          PetscInt ::       n,neqg,nnzmx
          PetscErrorCode :: ierr
        End Subroutine
      End Interface PetscSnesCreateObjs

      Interface PetscSnesApply
        Subroutine PetscSnesApply(n,yl,savf,suscal,sfscal,nnzmx,ireorder,incpset,icflag,rlx,icnstr,dtreal,iterm,ierr)
        use Petscmod
        PetscInt ::           n,nnzmx,ireorder,incpset
        PetscScalar,target :: yl(n),savf(n),suscal(n),sfscal(n)
        PetscInt,target ::    icnstr(n)
        PetscInt ::           icflag
        PetscReal ::          rlx,dtreal
        PetscInt ::           iterm
        PetscErrorCode ::     ierr
        End Subroutine
      End Interface PetscSnesApply
      end module Petscmodinterface2

! ---------------------------------------------------------------------
      module Snesmonitormod
      use Petscmod
      implicit none
      save
      type monctx
        PetscInt ::      buildJacobian,JacWasJustRebuilt
        PetscReal ::     thisdt
      end type monctx
      end module Snesmonitormod

! ---------------------------------------------------------------------
      subroutine PetscInitWrap()
      use Petscmod
      implicit none

      PetscErrorCode :: ierr
      PetscTruth     :: isInit
      call PetscInitialized(isInit, ierr)
      if (.not. isInit) then
        call PetscInitialize(PETSC_NULL_CHARACTER,ierr)
        call PetscLogStageRegister("PetscSnesCreateObjs",stages(1),ierr)
        call PetscLogStageRegister("PetscSnesSetup",stages(2),ierr)
        call PetscLogStageRegister("PetscSnesApply",stages(3),ierr)
        call PetscLogStageRegister("PetscSnesFinalize",stages(4),ierr)
      end if

      end subroutine PetscInitWrap
! ---------------------------------------------------------------------
      subroutine PetscFinalizeWrap()
      use PETSc_Snes_Param
      implicit none

      PetscErrorCode :: ierr

!     Destroy global objects
      if (psp_F .ne. 0) then
        call VecDestroy(psp_F,ierr)
      endif
      if (psp_X .ne. 0) then
        call VecDestroy(psp_X,ierr)
      endif
      if (psp_Xtmp .ne. 0) then
        call VecDestroy(psp_Xtmp,ierr)
      endif
      if (psp_Jmat .ne. 0) then
        call MatDestroy(psp_Jmat,ierr)
      endif
      if (psp_Jmf .ne. 0) then
        call MatDestroy(psp_Jmf,ierr)
      endif
      if (psp_ISUVEC .ne. 0) then
        call VecDestroy(psp_ISUVEC,ierr)
      endif
      if (psp_SUVEC .ne. 0) then
        call VecDestroy(psp_SUVEC,ierr)
      endif
      if (psp_SFVEC .ne. 0) then
        call VecDestroy(psp_SFVEC,ierr)
      endif
      if (psp_usecolor .ne. 0) then
        !write(6,*) ' MatFDColoringDestroy'
        !call flush(6)
        call MatFDColoringDestroy(psp_fdcoloring,ierr)
      end if
      if (psp_snes .ne. 0) then
        call SNESDestroy(psp_snes,ierr)
      endif

      call PetscFinalize(ierr)
!      write(6,*) ' PetscFinalizeWrap'
!      call flush(6)
      end subroutine PetscFinalizeWrap

! ---------------------------------------------------------------------
      subroutine PetscInsertOpts()
!      use MpiVars
      use Npes_mpi
      use UEpar
      PetscErrorCode ::  ierr
      PetscInt ::           uedgeComm
      PetscTruth PETSC_TRUE,PETSC_FALSE
      parameter (PETSC_TRUE = .true.,PETSC_FALSE = .false.)


!     insert options from file
      if (petscoptfile .ne. '') then
        call PetscOptionsInsertFile(uedgeComm,petscoptfile,PETSC_TRUE,ierr)
      endif
!     insert options from the specified options string
      if (petscopts .ne. '') then
        call PetscOptionsInsertString(petscopts,ierr)
      endif
      end subroutine PetscInsertOpts

! ---------------------------------------------------------------------
      subroutine RhsCmp_Debug(comm,cmp_rhs,snes,pctx,n,yl)

      use Petscmod
      use PETSc_Snes_Param
      use Indices_loc_glob_map !ivloc2sdg,ivloc2mdg,ivl2gstnl - rm later!
      use Indices_domain_dcl   !ivloc2sdgl,ivloc2mdgl

      implicit none

      integer4 ::           comm
      PetscReal ::          cmp_rhs
      SNES ::               snes
      type(Petscctx) ::     pctx
      PetscScalar,target :: yl(n)

      PetscErrorCode ::     ierr
      integer4 ::           mype,npes
      Vec                   Vseq,Vmpi,Xseq,Xmpi
      VecScatter            scatter
      PetscScalar, pointer :: array(:),array_seq(:)
      PetscInt ::           id,i,j,n,neqg
      PetscScalar ::        error
      PetscReal ::          delta,norm
      PetscViewer ::        viewer
      PetscScalar,target :: yldot(n),yl_tmp(n)
      PetscTruth ::         flg
      PetscInt ::           uedgeComm

      external FormUedgeFunction

      call MPI_Comm_size(comm,npes,ierr)
      call MPI_Comm_rank(comm,mype,ierr)
!      write(6,*)" RhsCmp_Debug() npes,mype: ",npes,mype
!      call flush(6)

      call VecNorm(psp_X,NORM_2,norm,ierr)
      if (mype .eq. 0) then
        write(6,*)" initial Xnorm: ",norm
        call flush(6)
      end if
      call VecGetSize(psp_X,neqg,ierr)
      call VecGetLocalSize(psp_X,n,ierr)

      psp_isf = 0
      delta   = 0.0
      call PetscOptionsGetReal(PETSC_NULL_CHARACTER,'-cmp_Frhs_delta',delta,flg,ierr)
      delta = 1.0 + delta
      if (flg .and. (mype .eq. 0)) then
        write(6,*)" scale X with",delta
        call flush(6)
      endif
      call VecScale(psp_X,delta,ierr)
      call FormUedgeFunction(snes,psp_X,psp_F,pctx,ierr)
      !write(6,*)" psp_F:"
      !call flush(6)
      !call VecView(psp_F,PETSC_VIEWER_STDOUT_WORLD,ierr)
      !write(6,*)" psp_SUVEC:"
      !call flush(6)
      !call VecView(psp_SUVEC,PETSC_VIEWER_STDOUT_WORLD,ierr)

      if (npes .eq. 1) then
        write(6,*)"write X in binary to datafile/X ..."
        call flush(6)
        call PetscViewerBinaryOpen(comm,"datafile/X",FILE_MODE_WRITE,viewer,ierr)
        call VecView(psp_X,viewer,ierr)
        call PetscViewerDestroy(viewer,ierr)

        write(6,*)"write F in binary to datafile/Frhs ..."
        write(6,*)" "
        call flush(6)
        call PetscViewerBinaryOpen(comm,"datafile/Frhs",FILE_MODE_WRITE,viewer,ierr)
        call VecView(psp_F,viewer,ierr)
        call PetscViewerDestroy(viewer,ierr)
      else
        ! compare parallel F with the sequential F
#if defined(DEBUG_rhs_1)
!     Only compare values in proc[0]
      if (mype .eq. 0) then
        write(6,*)"[",mype,"] load F from datafile/Frhs ..."
        write(6,*)" "
        call flush(6)
        call PetscViewerBinaryOpen(MPI_COMM_SELF,"datafile/Frhs",FILE_MODE_READ,viewer,ierr)
        call VecLoad(viewer, VECSEQ, Vseq,ierr)
        call PetscViewerDestroy(viewer,ierr)

        call VecGetArrayF90(psp_F,array,ierr)
        call VecGetArrayF90(Vseq,array_seq,ierr)
        if (mype .eq. 0) then
          write(6,*)"[",mype,"] Compare rhs function  F_mpi and F_seq.........."
          call flush(6)
        endif
        do i=1,n
          error = array(i) - array_seq(ivloc2sdgl(i))
          !error = (array(i) - array_seq(ivloc2sdgl(i)))/(array_seq(ivloc2sdgl(i)))
          if (error .lt. 0.0) then
            error = -error
          endif
          if (error .gt. cmp_rhs) then
            write(6,*) "[",mype,"]F_mpi(",i,")",array(i),"F_seq(",ivloc2sdgl(i),")",array_seq(ivloc2sdgl(i)),"diff",error
            call flush(6)
          end if
        enddo
          call flush(6)
          call VecRestoreArrayF90(Vseq,array_seq,ierr)
          call VecRestoreArrayF90(psp_F,array,ierr)
          call VecDestroy(Vseq,ierr)
      endif !(mype .eq. 0) then
#endif

!#if defined(DEBUG_rhs_2)
!       Compare all X and F values
!-------------------------------------
        call VecScatterCreateToZero(psp_X,scatter,Xmpi,ierr)
        call VecScatterBegin(scatter,psp_X,Xmpi,INSERT_VALUES,SCATTER_FORWARD,ierr)
        call VecScatterEnd(scatter,psp_X,Xmpi,INSERT_VALUES,SCATTER_FORWARD,ierr)
        call VecScatterDestroy(scatter,ierr)

        call VecScatterCreateToZero(psp_F,scatter,Vmpi,ierr)
        call VecScatterBegin(scatter,psp_F,Vmpi,INSERT_VALUES,SCATTER_FORWARD,ierr)
        call VecScatterEnd(scatter,psp_F,Vmpi,INSERT_VALUES,SCATTER_FORWARD,ierr)
        call VecScatterDestroy(scatter,ierr)
        !if (mype .eq. 0) then
        !  write(6,*)" Vmpi=psp_F:"
        !  call flush(6)
        !  call VecView(Vmpi,PETSC_VIEWER_STDOUT_SELF,ierr)
        !end if

        if (mype .eq. 0) then
          write(6,*)"[",mype,"] load X from datafile/X ..."
          call flush(6)
          call PetscViewerBinaryOpen(MPI_COMM_SELF,"datafile/X",FILE_MODE_READ,viewer,ierr)
          call VecLoad(viewer, VECSEQ, Xseq,ierr)
          call PetscViewerDestroy(viewer,ierr)
          !call VecView(Vseq,PETSC_VIEWEVR_STDOUT_SELF,ierr)

          call VecGetArrayF90(Xmpi,array,ierr)
          call VecGetArrayF90(Xseq,array_seq,ierr)
          write(6,*)"[",mype,"] Compare solution vector Xmpi and Xseq with tol",cmp_rhs
          call flush(6)
          do i=1,neqg
            id = (i-1)/n
            j  = i - id*n
            id = id+1
            !write(6,*) array(i),"X_np1(",ivloc2sdg(j,id),")",array_seq(ivloc2sdg(j,id))
            error = (array(i) - array_seq(ivloc2sdg(j,id)))
            if (error .lt. 0.0) then
              error = -error
            endif
            if (error .gt. cmp_rhs) then
              write(6,*) "Xmpi(",i,")",array(i),"Xseq(",ivloc2sdg(j,id),")",array_seq(ivloc2sdg(j,id)),"diff",error
            end if
          enddo
          call flush(6)
          call VecRestoreArrayF90(Xseq,array_seq,ierr)
          call VecRestoreArrayF90(Xmpi,array,ierr)

          write(6,*)" "
          write(6,*)"[",mype,"] load F from datafile/Frhs ..."
          call flush(6)
          call PetscViewerBinaryOpen(MPI_COMM_SELF,"datafile/Frhs",FILE_MODE_READ,viewer,ierr)
          call VecLoad(viewer, VECSEQ, Vseq,ierr)
          call PetscViewerDestroy(viewer,ierr)
          !call VecView(Vseq,PETSC_VIEWEVR_STDOUT_SELF,ierr)

          call VecGetArrayF90(Vmpi,array,ierr)
          call VecGetArrayF90(Vseq,array_seq,ierr)
          write(6,*)"[",mype,"] Compare rhs Fmpi and Fseq with tol",cmp_rhs
          call flush(6)
          do i=1,neqg
            id = (i-1)/n
            j  = i - id*n
            id = id+1
            !write(6,*) array(i),"F_np1(",ivloc2sdg(j,id),")",array_seq(ivloc2sdg(j,id))
            error = (array(i) - array_seq(ivloc2sdg(j,id)))/(array_seq(ivloc2sdg(j,id)))
            if (error .lt. 0.0) then
              error = -error
            endif
            if (error .gt. cmp_rhs) then
              write(6,*) "F_mpi(",i,")",array(i),"F_seq(",ivloc2sdg(j,id),")",array_seq(ivloc2sdg(j,id)),"rel_diff",error
              !write(6,*) "F_mpi(",i,")",array(i),"F_seq(",ivloc2sdg(j,id),")",array_seq(ivloc2sdg(j,id)),"diff",error
            end if
          enddo
          call flush(6)
          call VecRestoreArrayF90(Vseq,array_seq,ierr)
          call VecRestoreArrayF90(Vmpi,array,ierr)
          call VecDestroy(Vseq,ierr)
          call VecDestroy(Xseq,ierr)
        endif
        call VecDestroy(Xmpi,ierr)
        call VecDestroy(Vmpi,ierr)
!#endif
      endif

      psp_isf = 1
      call VecNorm(psp_F,NORM_2,norm,ierr)
      if (mype .eq. 0) then
        write(6,*)" initial Fnorm without sf scaling: ",norm
        call flush(6)
      end if
      call MPI_Barrier(comm,ierr)

      return
      end subroutine RhsCmp_Debug

! ---------------------------------------------------------------------
!  FormInitialGuess - Form initial approximation
!    Copy Uedge yl into X and scale X
!
!  Input Parameters:
!    neq  - local num of equations
!    yl   - initial approximate solution local array provided by Uedge
!    X    - vector
!
!  Output Parameter:
!    X - vector
! ---------------------------------------------------------------------
      subroutine FormInitialGuess(neq,yl,X,ierr)
      use Petscmod
      use PETSc_Snes_Param
      implicit none

      PetscInt,       INTENT(IN)    :: neq
      PetscScalar,    INTENT(IN)    :: yl(neq)
      Vec,            INTENT(INOUT) :: X
      PetscErrorCode, INTENT(OUT)   :: ierr
      PetscInt                      :: i
      PetscScalar,pointer           :: xx(:),su(:)

      call VecGetArrayF90(X,xx,ierr)
      if (psp_iscolnorm.gt.0) then
        call VecGetArrayF90(psp_SUVEC,su,ierr)
        do i=1,neq
           xx(i) = su(i)*yl(i)
        end do
        call VecRestoreArrayF90(psp_SUVEC,su,ierr)
      else
        do i=1,neq
           xx(i) = yl(i)
        end do
      endif
      call VecRestoreArrayF90(X,xx,ierr)

      end subroutine FormInitialGuess

! ---------------------------------------------------------------------
!  FormFinalSolution - Form final approximation for Uedge
!    Recover X with scaling suscal and convert it back to Uedge yl
!
!  Input Parameters:
!    n    - local num of equations
!    X    - vector
!
!  Output Parameter:
!    yl - Uedge solution local array without suscal scaling
! ---------------------------------------------------------------------
      subroutine FormFinalSolution(n,X,yl,ierr)
      use Petscmod
      use PETSc_Snes_Param
      implicit none

      PetscInt,       INTENT(IN)    :: n
      PetscScalar,    INTENT(OUT)   :: yl(n)
      Vec,            INTENT(IN)    :: X
      PetscErrorCode, INTENT(OUT)   :: ierr
      PetscInt                      :: i
      PetscScalar,pointer           :: xx(:),su(:)

      call VecGetArrayF90(X,xx,ierr)
      if (psp_iscolnorm.gt.0) then   
        call VecGetArrayF90(psp_SUVEC,su,ierr)     
        do i = 1,n
          yl(i) = xx(i)/su(i)
        end do   
        call VecRestoreArrayF90(psp_SUVEC,su,ierr)    
      else
        do i = 1,n
          yl(i) = xx(i)
        end do
      end if
      call VecRestoreArrayF90(X,xx,ierr)
      end subroutine FormFinalSolution

! ---------------------------------------------------------------------
!  FormUedgeFunction - Evaluates nonlinear function, F(x).
!
!    Note that psp_mon_ftime is never manually initialized.  It is automatically
!    initialized to 0 during the allocation.  If you're coming across a problem
!    it may be that the compiler doesn't do this.
!
!  Input Parameters:
!    snes - the SNES context
!    X    - input vector
!    pctx - defined in Petscmod to carry info to this function
!
!  Output Parameter:
!    F - function vector
! ---------------------------------------------------------------------
      subroutine FormUedgeFunction(snes,X,F,pctx,ierr)
      use Petscmod
      use PETSc_Snes_Param
      use PETSc_SNES_Param_Monitor
      implicit none

      SNES,       INTENT(IN)    :: snes
      Vec,            INTENT(IN)    :: X
      Vec,            INTENT(OUT)   :: F
      type(Petscctx), INTENT(INOUT) :: pctx
      PetscErrorCode, INTENT(OUT)   :: ierr

      integer             :: n,i
      PetscInt            :: nn
      PetscScalar,pointer :: xx(:),ff(:),sf(:),su(:),yl(:)
      PetscLogDouble      :: tstart, tend

      call PetscGetTime(tstart,ierr)

      yl=>pctx%ylpoint
      call VecGetLocalSize(X,nn,ierr)
      n = nn
      call VecGetArrayF90(X,xx,ierr)
      if (psp_iscolnorm.gt.0) then  ! scaling with ISUVEC
        call VecGetArrayF90(psp_SUVEC,su,ierr)
        do i=1,n
          yl(i) = xx(i)/su(i)  !scale with su^-1
        end do
        call VecRestoreArrayF90(psp_SUVEC,su,ierr)
      else
        do i=1,n
          yl(i) = xx(i)
        end do
      end if
      call VecRestoreArrayF90(X,xx,ierr)

      call VecGetArrayF90(F,ff,ierr)
      call rhsnk(n, yl, ff)

      if (psp_isf.eq.1) then
        call VecGetArrayF90(psp_SFVEC,sf,ierr)
        do i = 1,n
          ff(i) = sf(i)*ff(i)
        end do
        call VecRestoreArrayF90(psp_SFVEC,sf,ierr)
      end if
      call VecRestoreArrayF90(F,ff,ierr)

      call PetscGetTime(tend,ierr)
      if (psp_mon_on) then
        psp_mon_fcalls(psp_mon_arrlen) = psp_mon_fcalls(psp_mon_arrlen) + 1
        psp_mon_ftime(psp_mon_arrlen) = psp_mon_ftime(psp_mon_arrlen) + (tend-tstart)
      end if

      end subroutine FormUedgeFunction

!----------------------------------------------------------------------------------------
      subroutine PetscJac_calc(neq,t,yl,yldot0,ml,mu,wk,nnzmx,flag,Jmat,ierr)

!     Modified from jac_calc ()

! ... Common blocks:
            use Dim                      ! nx,ny,
                                         ! nusp[for fnorm not used here]
            use Timing                   ! istimingon,ttjstor,ttotjf,ttimpjf
            use Math_problem_size        ! neqmx,numvar
            use Grid                     ! ngrid,ig,ijac,ijactot
            use Indexes                  ! igyl,iseqalg
            use Variable_perturbation    ! del,dylconst
            use Jacobian_clipping        ! jaccliplim,istopjac,irstop,icstop
            use Jacobian_csc             ! rcsc,jcsc,icsc,yldot_pert
            use Ynorm                    ! suscal,sfscal
            use UEpar                    ! isphion,isnewpot,svrpkg,isbcwdt
            use Model_choice             ! iondenseqn
            use Imprad                   ! isimpon
            use Bcond                    ! isextrnpf,isextrtpf,isextrngc,
                                         ! isextrnw,isextrtw
            use Time_dep_nwt             ! nufak,dtreal,ylodt,dtuse
            use Selec                    ! yinc
            use Npes_mpi                 ! npes,mype,ismpion

            use Petscmod

! ... Functions:
      implicit none

! ... Input arguments:
      integer neq         ! local number of equations (all grid points)
      real :: t           ! physical time
      real :: yl(*)       ! dependent variables
      real :: yldot0(neq) ! right-hand sides evaluated at yl
      integer :: ml, mu   ! lower and upper bandwidths
      PetscInt :: nnzmx    ! maximum number of nonzeros in Jacobian

! ... Work-array argument:
      real :: wk(neq)     ! work space available to this subroutine

! ... Output arguments:
      real :: jac(nnzmx)     ! nonzero Jacobian elements
      integer :: ja(nnzmx)   ! col indices of nonzero Jacobian elements
      integer :: ia(neq+1)   ! pointers to beginning of each row in jac,ja

      logical tstguardc
      real(kind=4) :: gettime

! ... Local variables:
      integer :: nnz, ii, iv, ii1, ii2, xc, yc, ix, iy
      real :: yold, dyl, jacelem
      real(kind=4) :: sec4, tsjstor, tsimpjf, dtimpjf

      Mat ::            Jmat
      PetscErrorCode :: ierr
      PetscInt ::       npandf,rstart,rend
      PetscLogDouble :: ptstart,tfinal,etime
      MatStructure ::   flag

! ... Get initial value of system cpu timer.
      if (istimingon .eq. 1) tsjstor = gettime(sec4)

!      write(6,*) " PetscJac_calc: MatStructure flag =  ", flag,"nx,ny: ",nx,ny
!      call flush(6)
      call MatGetOwnershipRange(Jmat,rstart,rend,ierr)

! ... Set up diagnostic arrays for debugging
      do iv = 1, neq
        yldot_unpt(iv) = yldot0(iv)  ! for diagnostic only
        yldot_pert(iv) = 0.
      enddo

! ... Begin loop over dependent variables.
      npandf = 0
      etime  = 0.0
      nnz = 1
      do iv = 1, neq !for each local column

! ... Set beginning and ending indices of right-hand sides that might be perturbed.
         ii1 = max(iv-mu, 1)
         ii2 = min(iv+ml, neq)
! ... Reset range if this is a potential perturbation with isnewpot=1
         if (isphion*isnewpot.eq.1) then
            ii1 = max(iv-4*numvar*nx, 1)      ! 3*nx may be excessive
            ii2 = min(iv+4*numvar*nx, neq)    ! 3*nx may be excessive
         endif
! ... Reset range if extrapolation boundary conditions are used
         if (isextrnpf+isextrtpf+isextrngc+isextrnw+isextrtw.gt.0) then
            ii1 = max(iv-2*numvar*(nx+3), 1)      ! guess to include extrap. bc
            ii2 = min(iv+2*numvar*(nx+3), neq)    ! guess to include extrap. bc
         endif

! ... Initialize all of those right-hand sides to their unperturbed values.
         do ii = ii1, ii2   ! below wk is reset, but only over limited range
            wk(ii) = yldot0(ii)
         enddo

! ... Set spatial-location indices for this dependent variable.
         xc = igyl(iv,1)
         yc = igyl(iv,2)
!         write(6,*)"[",mype,"] iv,xc, yc: ",iv,xc,yc,"rstart,rend: ",rstart,rend
!         call flush(6)

! ... Save value of dependent variable, then perturb it.
!    The perturbation to the variable is proportional to parameter
!    del and to a measure of the size of the variable.  That measure
!    increases with the absolute value of the variable if it exceeds
!    the typical size given by dylconst/suscal but can never be less
!    than that typical size.
         yold = yl(iv)
         dyl = del * (abs(yold) + dylconst / suscal(iv))
         yl(iv) = yold + dyl

! ... Calculate right-hand sides near location of perturbed variable.

         call PetscGetTime(ptstart,ierr)
         call pandf1 (xc, yc, iv, neq, t, yl, wk)
         call PetscGetTime(tfinal,ierr)
         npandf = npandf + 1
         etime  = etime + (tfinal - ptstart)

! ... Calculate possibly nonzero Jacobian elements for this variable,
!c     and store nonzero elements in compressed sparse column format.
         jcsc(iv) = nnz      ! sets index for first Jac. elem. of var. iv
         do ii = ii1, ii2    !for each local row
            jacelem = (wk(ii) - yldot0(ii)) / dyl

! ...  Add diagonal 1/dt for nksol - PetscSnes()
            if (iv.eq.ii) then !diagonal entry
              if (iseqalg(iv)*(1-isbcwdt).eq.0) then
                jacelem = jacelem - 1/dtuse(iv)
              endif
              ix = igyl(iv,1)
              iy = igyl(iv,2)
              if (idxphi(ix,iy)==iv .and. dtphi<1e10) then !selects phi eqn
                jacelem = jacelem - 1/dtphi
              endif
            endif

! ...  Add a pseudo timestep to the diagonal !! if eqn is not algebraic
            if (nufak .gt. 0) then
               if (iv.eq.ii .and. yl(neq+1).eq.1) then
                 jacelem = jacelem - nufak  !omit .and. iseqalg(iv).eq.0)
               endif
            endif

          if (flag .eq. DIFFERENT_NONZERO_PATTERN) then
! ...       Add a nonzero entry into Jmat
            if (abs(jacelem*sfscal(iv)) .gt. jaccliplim) then
               if (nnz .gt. nnzmx) then
                  write(6,*) '*** jac_calc - Storage exceeded at (i,j)=',ii,iv,' nnz=',nnz,' nnzmx=',nnzmx
                 call kaboom(0)
               endif
!               if (rdoff.ne.0.e0) jacelem=jacelem*(1.0e0+ranf()*rdoff)
               rcsc(nnz) = jacelem
               icsc(nnz) = ii
               nnz       = nnz + 1
#if defined(DEBUG_SNES)
               if (mype .eq. 1) then
                 write(6,*) "[",mype,"] MatSetValues at ",ii-1+rstart,iv-1+rstart
                 call flush(6)
               endif
#endif
               call MatSetValues(Jmat,1,ii-1+rstart,1,iv-1+rstart,jacelem,INSERT_VALUES,ierr)
            endif
          else
            write(6,*) "use same NONZERO_PATTERN"
          end if

            if (istopjac.gt.0 .and. ii.eq.irstop .and. iv.eq.icstop) then
               yldot_pert(ii) = wk(ii)      ! for diagnostic only
               if (istopjac == 2) then
                 yl(iv) = yold

                 call PetscGetTime(ptstart,ierr)
                 call pandf1 (xc, yc, iv, neq, t, yl, wk)
                 call PetscGetTime(tfinal,ierr)
                 etime  = etime + (tfinal - ptstart)
                 npandf = npandf + 1

               endif

               call remark("***** non-zero jac_elem at irstop,icstop")
               write(6,*) 'irstop = ', irstop, ', icstop = ', icstop
               call kaboom(0)
            endif

         enddo  ! end of ii loop over equations

! ... Restore dependent variable and plasma variables near its location.
         yl(iv) = yold

         call PetscGetTime(ptstart,ierr)
         call pandf1 (xc, yc, iv, neq, t, yl, wk)
         call PetscGetTime(tfinal,ierr)
         etime  = etime + (tfinal - ptstart)
         npandf = npandf + 1

! ... End loop over dependent variables and finish Jacobian storage.
! 18   continue
!...  If this is the last variable before jumping to new cell, reset pandf
         if (mod(iv,numvar).eq.0 .and. isjacreset.ge.1) then
            call PetscGetTime(ptstart,ierr)
            call pandf1 (xc, yc, iv, neq, t, yl, wk)
            call PetscGetTime(tfinal,ierr)
            etime  = etime + (tfinal - ptstart)
            npandf = npandf + 1
         endif
      enddo             ! end of main loop over yl variables
      call MatAssemblyBegin(Jmat,MAT_FINAL_ASSEMBLY,ierr)
      call MatAssemblyEnd(Jmat,MAT_FINAL_ASSEMBLY,ierr)

      jcsc(neq+1) = nnz

! ... Accumulate cpu time spent here.
      if (istimingon .eq. 1) ttjstor = ttjstor + gettime(sec4) - tsjstor

      return
      end subroutine PetscJac_calc

!-----------------------------------------------------------------------
!  This is the subroutine to sequentially compute the Jacobian for PETSc purposes
!  It utilizes the jac_calc routine from the UEDGE package
!
!  Input Parameters:
!    snes     - SNES context for solving the problem
!    X        - Value at which the Jacobian will be evaluated
!    pctx     - Petscmod defined data structure to get us information
!
!  Output Parameters:
!    Jmat     - Jacobian matrix
!    jac_prec - Preconditioner matrix for the nonlinear system (may be same as Jmat)
!    flag     - Nonzero Pattern flag
! ---------------------------------------------------------------------
      subroutine FormUedgeJacobian(snes,X,Jmat,jac_prec,flag,pctx,ierr)
      use Petscmod
      use Decomp        ! lbw,ubw
      use Time_dep_nwt  ! nufak,ydt_max,ydt_max0,alfnuf,expnuf,nufak0
                        ! inufaknk,dtoptx,dtoptv
      use PETSc_Snes_Param
      implicit none

      integer*8 :: temp1, temp2

      PetscInt ::        snes
      Vec ::             X,F
      Mat ::             Jmat,jac_prec
      MatStructure ::    flag
      type(Petscctx) ::  pctx
      PetscErrorCode ::  ierr
      PetscLogDouble ::  tstart,tfinal,etime

! ... Local variables:
      PetscReal        tp
      PetscInt         i,nn,nnzmx,incpset
      integer          n
      PetscScalar,pointer :: xx(:),f0(:),wk(:),su(:),ff(:),yl(:)

      write(6,*) "    build UedgeJacobian ..."
      call flush(6)
! ... Now we need to allocate space so that the UEDGE functions can do their thing
! ... Also we need to move the variables to Fortran variables
      wk=>pctx%wkpoint
      yl=>pctx%ylpoint
      nnzmx   = pctx%nnzmx
      incpset = pctx%incpset

      call VecGetLocalSize(X,nn,ierr)
      n = nn

!  Copy input vector array into yl (for n+2 considerations)
      call VecGetArrayF90(X,xx,ierr)
      if (psp_iscolnorm .ge. 0) then
        call VecGetArrayF90(psp_SUVEC,su,ierr)
        do i=1,n
          yl(i) = xx(i)/su(i)  !scale with su^-1
        end do
        call VecRestoreArrayF90(psp_SUVEC,su,ierr)
      else
        do i=1,n
          yl(i) = xx(i)
        end do
      end if
      call VecRestoreArrayF90(X,xx,ierr)

! ... Calculate ydt_max = max(f*sf) to control yl(n+2) = nufak (was in psetnk)
      call VecNorm(psp_F,NORM_INFINITY,ydt_max,ierr)
      if (ydt_max < 1.e-16) ydt_max = 1.e-16
      if (ydt_max0 .eq. 0) ydt_max0 = ydt_max
      nufak = min(nufak*alfnuf*(ydt_max/ydt_max0)**expnuf, nufak0)
      if (inufaknk .eq. 1) then   ! deter. if nufak is used in Krylov step
        yl(n+2) = nufak
      else
        yl(n+2) = 0.
      endif
      if (expnuf.ne.0.) write(6,*) ' nufak = ', nufak
      ydt_max0 = ydt_max

! ... Call pandf to set terms with yl(n+1) flag on for Jacobian
      f0=>pctx%savfpoint
      call rhsnk(n, yl, f0)

! ... Calculate Jacobian matrix.
      tp = 0.
!      call PetscGetTime(tstart,ierr)
      flag=DIFFERENT_NONZERO_PATTERN
      call Petscjac_calc (n,tp,yl,f0,lbw,ubw,wk,nnzmx,flag,jac_prec,ierr)
      if (Jmat .ne. jac_prec) then
        call MatAssemblyBegin(Jmat,MAT_FINAL_ASSEMBLY,ierr)
        call MatAssemblyEnd(Jmat,MAT_FINAL_ASSEMBLY,ierr)
      endif
!      call PetscGetTime(tfinal,ierr)
!      write(6,*) "    Time for Petscjac_calc: ",tfinal-tstart

!  Do the sf scaling
      if (psp_isf.eq.1) then
        call MatDiagonalScale(jac_prec,psp_SFVEC,PETSC_NULL_OBJECT,ierr)
      end if
!  Do ISUVEC=su^-1 scaling.
      if (psp_iscolnorm .gt. 0) then
        call MatDiagonalScale(jac_prec,PETSC_NULL_OBJECT,psp_ISUVEC,ierr)
      end if
      end subroutine FormUedgeJacobian

! ---------------------------------------------------------------------
!  This function imposes the constraints required by UEDGE on the variables
!  These constraints are found in icnstr, icflag, rlx
!  If icflag==1, icnstr is imposed: icnstr(i)>0 -> yl(i) = x(i) - minchange*y(i) >0
!                                   icnstr(i)<0 -> yl(i) = x(i) - minchange*y(i) <0
!                                   icnstr(i)==0 -> no constraint
!
!  rlx defines the inequality: abs(u_step/u)<rlx
!  If the rlx constraint is violated, the step size is scaled back to satisfy it
!
!  Input Parameters:
!    snes - SNES context for solving the problem
!    X    - Current Newton iterate
!    Y    - Current Newton step
!    pctx - Petscmod defined structure to pass data to this function
!
!  Output Parameters:
!    changed_y      - Boolean saying that the length of search has been changed
! ---------------------------------------------------------------------
      subroutine FormPreCheck(snes,X,Y,pctx,changed_y,ierr)
      use Petscmod
      use Npes_mpi         ! npes,mype,ismpion
      implicit none

      SNES,           INTENT(IN)    :: snes
      Vec,            INTENT(IN)    :: X
      Vec,            INTENT(INOUT) :: Y
      type(Petscctx), INTENT(INOUT) :: pctx
      PetscErrorCode, INTENT(OUT)   :: ierr
      PetscScalar,    INTENT(OUT)   :: changed_y

      PetscInt ::       i,neq
      PetscReal ::      rlx
      PetscInt,pointer :: icnstr(:)
      PetscScalar ::    minchange,w,tiny,sbuf(3),rbuf(3)
      integer4 ::       comm
      PetscScalar,pointer :: xp(:),yp(:)

      minchange = 1.0
      tiny      = 1.0e-16

      icnstr=>pctx%icnstrpoint
      rlx = pctx%rlx

      call PetscObjectGetComm(snes,comm,ierr)

!  As of right now, this function will never changed the search direction, just the length
      changed_y = 0.0

      call VecGetLocalSize(X,neq,ierr)
      call VecGetArrayF90(X,xp,ierr)
      call VecGetArrayF90(Y,yp,ierr)
      do i=1,neq
        if (icnstr(i).ne.0) then
          w = xp(i) - yp(i)
          if ((icnstr(i).gt.0 .and. w.le.0) .or. (icnstr(i).lt.0 .and. w.ge.0)) then
            changed_y = 1.0
            minchange = min(minchange,xp(i)/yp(i))    ! yp(i) cannot be 0
          end if
        end if
      end do
      call VecRestoreArrayF90(X,xp,ierr)
      call VecRestoreArrayF90(Y,yp,ierr)

      call MPI_Comm_size(comm,npes,ierr)
      if (npes .gt. 1) then
        sbuf(1) = changed_y
        sbuf(2) = 1.0/minchange
        call MPI_ALLREDUCE(sbuf,rbuf,2,MPIU_SCALAR,MPI_MAX,comm,ierr)
        changed_y = rbuf(1)
        minchange = 1.0/rbuf(2)
      end if

!...  scale direction Y by minchange
      if (changed_y .eq. 1.0) then
        minchange = rlx*minchange + tiny
#if defined(DEBUG_SNES)
        if (mype .eq. 0) then
          write(6,*)  "  FormPreCheck: scale direction Y with minchange",minchange,"rlx",rlx
          call flush(6)
        end if
#endif
        call VecScale(Y,minchange,ierr)
      end if

!      if(pctx%countoutloud.eq.1) write(6,*) "FormPreCheck called for ",pctx%icniter,"time"
!      pctx%icniter=pctx%icniter+1
      end subroutine FormPreCheck

! ---------------------------------------------------------------------
!  subroutine psp_monAdjustSize(sizeIncrease,ierr)
!
!  This subroutine allows for an adjustment in the size of the monitor
!  arrays.  Because we don't know ahead of time how many SNES steps will
!  be needed, these arrays may need to be lengthened over time.  Of course
!  if we were using a real programming language there would be an object
!  that would do this for us.  But whatever...
!
!  Also, now passing sizeIncrease=0 will delete any data in 
!
!  Note that I think values are always initialized to 0 by Fortran after
!  allocating.  Even though this is my belief I still initialize ftime
!  and fcalls to 0 in the first array location.  Then future initializations
!  take place in FormMonitor.
! ---------------------------------------------------------------------
      subroutine psp_monAdjustSize(sizeIncrease,ierr)
      use Petscmod
      use PETSc_Snes_Param
      use PETSc_Snes_Param_Monitor
      implicit none

      PetscInt,       INTENT(IN)  :: sizeIncrease
      PetscErrorCode, INTENT(OUT) :: ierr
      
      integer i,allocInc,arrLen ! I think these are needed cuz Fortran's not cool with Petsc vars

      PetscReal,      ALLOCATABLE, DIMENSION(:) :: psp_mon_fnrm_tmp
      PetscReal,      ALLOCATABLE, DIMENSION(:) :: psp_mon_dtreal_tmp
      PetscLogDouble, ALLOCATABLE, DIMENSION(:) :: psp_mon_time_tmp
      PetscLogDouble, ALLOCATABLE, DIMENSION(:) :: psp_mon_ftime_tmp
      PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_kspits_tmp
      PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_fevals_tmp
      PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_fcalls_tmp
      PetscInt,       ALLOCATABLE, DIMENSION(:) :: psp_mon_snesit_tmp

      arrLen = SIZE(psp_mon_fnrm) ! All arrays have the same length
      allocInc = sizeIncrease

      ! If we are decreasing the size of the arrays we need to consider that
      ! by only allocating the space we need
      arrLen = MIN(arrLen,arrLen+allocInc)

      ! If the user passes a negative value smaller than the length of the data
      ! this makes sure the function just deletes everything rather than a
      ! negative allocation which may have unstable results
      if (arrLen .le. 0) then
        allocInc = 0
      end if

      if (allocInc .eq. 0) then ! Delete the existing data
        if (ALLOCATED(psp_mon_fnrm)) then ! Make sure there is data to be deleted
          DEALLOCATE(psp_mon_fnrm)
          DEALLOCATE(psp_mon_dtreal)
          DEALLOCATE(psp_mon_time)
          DEALLOCATE(psp_mon_ftime)
          DEALLOCATE(psp_mon_kspits)
          DEALLOCATE(psp_mon_fevals)
          DEALLOCATE(psp_mon_fcalls)
          DEALLOCATE(psp_mon_snesit)
        end if
      else if (ALLOCATED(psp_mon_fnrm)) then ! Anything except the first SNES solve
        ALLOCATE(psp_mon_fnrm_tmp(1:arrLen))
        ALLOCATE(psp_mon_dtreal_tmp(1:arrLen))
        ALLOCATE(psp_mon_time_tmp(1:arrLen))
        ALLOCATE(psp_mon_ftime_tmp(1:arrLen))
        ALLOCATE(psp_mon_kspits_tmp(1:arrLen))
        ALLOCATE(psp_mon_fevals_tmp(1:arrLen))
        ALLOCATE(psp_mon_fcalls_tmp(1:arrLen))
        ALLOCATE(psp_mon_snesit_tmp(1:arrLen))
        do i=1,arrLen
          psp_mon_fnrm_tmp(i)   = psp_mon_fnrm(i)
          psp_mon_dtreal_tmp(i) = psp_mon_dtreal(i)
          psp_mon_time_tmp(i)   = psp_mon_time(i)
          psp_mon_ftime_tmp(i)  = psp_mon_ftime(i)
          psp_mon_kspits_tmp(i) = psp_mon_kspits(i)
          psp_mon_fevals_tmp(i) = psp_mon_fevals(i)
          psp_mon_fcalls_tmp(i) = psp_mon_fcalls(i)
          psp_mon_snesit_tmp(i) = psp_mon_snesit(i)
        end do
        DEALLOCATE(psp_mon_fnrm)
        DEALLOCATE(psp_mon_dtreal)
        DEALLOCATE(psp_mon_time)
        DEALLOCATE(psp_mon_ftime)
        DEALLOCATE(psp_mon_kspits)
        DEALLOCATE(psp_mon_fevals)
        DEALLOCATE(psp_mon_fcalls)
        DEALLOCATE(psp_mon_snesit)
        
        ! Now we need to move the data back from the temporary arrays
        
        ALLOCATE(psp_mon_fnrm(1:arrLen+allocInc))
        ALLOCATE(psp_mon_dtreal(1:arrLen+allocInc))
        ALLOCATE(psp_mon_time(1:arrLen+allocInc))
        ALLOCATE(psp_mon_ftime(1:arrLen+allocInc))
        ALLOCATE(psp_mon_kspits(1:arrLen+allocInc))
        ALLOCATE(psp_mon_fevals(1:arrLen+allocInc))
        ALLOCATE(psp_mon_fcalls(1:arrLen+allocInc))
        ALLOCATE(psp_mon_snesit(1:arrLen+allocInc))
        do i=1,arrLen ! Still use the old
          psp_mon_fnrm(i)   = psp_mon_fnrm_tmp(i)
          psp_mon_dtreal(i) = psp_mon_dtreal_tmp(i)
          psp_mon_time(i)   = psp_mon_time_tmp(i)
          psp_mon_ftime(i)  = psp_mon_ftime_tmp(i)
          psp_mon_kspits(i) = psp_mon_kspits_tmp(i)
          psp_mon_fevals(i) = psp_mon_fevals_tmp(i)
          psp_mon_fcalls(i) = psp_mon_fcalls_tmp(i)
          psp_mon_snesit(i) = psp_mon_snesit_tmp(i)
        end do
        DEALLOCATE(psp_mon_fnrm_tmp)
        DEALLOCATE(psp_mon_dtreal_tmp)
        DEALLOCATE(psp_mon_time_tmp)
        DEALLOCATE(psp_mon_ftime_tmp)
        DEALLOCATE(psp_mon_kspits_tmp)
        DEALLOCATE(psp_mon_fevals_tmp)
        DEALLOCATE(psp_mon_fcalls_tmp)
        DEALLOCATE(psp_mon_snesit_tmp)
      else ! If this is the first SNES solve, the arrays aren't allocated
        ALLOCATE(psp_mon_fnrm(1:allocInc))
        ALLOCATE(psp_mon_dtreal(1:allocInc))
        ALLOCATE(psp_mon_time(1:allocInc))
        ALLOCATE(psp_mon_ftime(1:allocInc))
        ALLOCATE(psp_mon_kspits(1:allocInc))
        ALLOCATE(psp_mon_fevals(1:allocInc))
        ALLOCATE(psp_mon_fcalls(1:allocInc))
        ALLOCATE(psp_mon_snesit(1:allocInc))
        psp_mon_fcalls(1) = 0
        psp_mon_ftime(1) = 0
      end if

      end subroutine psp_monAdjustSize
      
! ---------------------------------------------------------------------
!  subroutine DetermineJacRebuild
!  This subroutine looks at the evolution of the time stepping and the
!  SNES solve to determine if the Jacobian needs to be rebuilt
!  It will internally set the function SNESSetLagJacobian, and it will
!  also update values in snesmonitor.  It returns a string output
!  to the screen.
! ---------------------------------------------------------------------
      subroutine DetermineJacRebuild(snes,snesmonitor,its,rebuild,jac_rebuild_output,ierr)
      use Snesmonitormod
      use PETSc_Snes_Param ! Anything with a psp_ header is stored in here
      implicit none
      
      SNES,           INTENT(INOUT) :: snes
      type(monctx),   INTENT(INOUT) :: snesmonitor
      PetscInt,       INTENT(IN)    :: its
      PetscInt,       INTENT(OUT)   :: rebuild
      character*80,   INTENT(OUT)   :: jac_rebuild_output
      PetscErrorCode, INTENT(OUT)   :: ierr
      
      PetscReal :: dt_factor,max_dtchange
      PetscInt  :: newdt
      
      max_dtchange = psp_jacMaxdtChange
      if (max_dtchange .le. 1e-15) then
        newdt = 0 ! max_dt=0 means never reevaluate for time step
      else
        dt_factor = max(snesmonitor%thisdt/psp_olddt,psp_olddt/snesmonitor%thisdt)
        if (dt_factor .le. max_dtchange) then
          newdt = 0
        else
          newdt = 1
        end if
      end if

      rebuild = -1
!      if (its.gt.1) then
!        if (mod(its-1,psp_jaclag).eq.0) then
!          rebuild = 1
!        end if
!      end if
      if ((its.gt.0) .and. (mod(its,psp_jaclag).eq.0)) then
        rebuild = 1
      end if

      if ((psp_skipJacobian .eq. 1) .and. (its.eq.0)) then
        if (psp_nsnes .eq. 0) then
          rebuild = 2
        elseif (newdt .eq. 1) then
          rebuild = 5
        end if
      elseif (its.eq.0) then
        rebuild = 3
      end if
      if (snesmonitor%buildJacobian .eq. 1) then
        snesmonitor%buildJacobian = 0 ! Reset after linear solve failure
        rebuild = 4
      end if

      if (rebuild .gt. 0) then
        call SNESSetLagJacobian(snes,1,ierr)
        snesmonitor%JacWasJustRebuilt = 1
      else
        call SNESSetLagJacobian(snes,-1,ierr)
        snesmonitor%JacWasJustRebuilt = 0
      end if

      if (rebuild .eq. 1) then
        write(jac_rebuild_output,*) "Rebuilding Jacobian, Lag =",psp_jaclag
      elseif (rebuild .eq. 2) then
        write(jac_rebuild_output,*) "Building Jacobian for first time step"
      elseif (rebuild .eq. 3) then
        if (psp_nsnes .eq. 0) then
         print *,jac_rebuild_output
         write(jac_rebuild_output,*) "Building Jacobian for first time step"
        else
          write(jac_rebuild_output,*) "Rebuilding Jacobian, Required at each SNES step"
        endif
      elseif (rebuild .eq. 4) then
        write(jac_rebuild_output,*) "Rebuilding Jacobian, Previous Linear Solve Failed"
      elseif (rebuild .eq. 5) then
        write(jac_rebuild_output,1001) snesmonitor%thisdt,psp_olddt,max_dtchange
1001   format("Rebuilding Jacobian: newdt=",ES8.2E2,", olddt=",ES8.2E2,", max_dtfactor=",F6.2)
      end if
      
      end subroutine DetermineJacRebuild

! ---------------------------------------------------------------------
!  Subroutine FormMonitor
!  This function lets up keep track of the SNES progress at each step
!  Eventually all the data recorded by this will be output to a file
!  This function is only used if the option
!     -print_stats <string>
!  is used at runtime from the file petscopt
!  string should be the name of the variable that you want to use in Matlab
!  The Matlab file will be f<string>.m
!
!  This function calls DetermineJacRebuild and passes that infor along to
!  SNES to tell it when the Jacobian needs rebuilt.  No PETSc specific
!  Jacobian rebuilding options are valid; any options are handled manually
!  in PetscSnes and then dealt with here.
!
!  At the end of each SNES step, this function is called by SNES.  The
!  psp_mon_ftime and psp_mon_fcalls values for the next SNES solve are
!  initialized to 0.
!
!  Input Parameters:
!    snes    - SNES nonlinear solver context
!    its     - current nonlinear iteration
!    norm    - 2-norm of current residual (may be approximate)
!    snesmonitor - monctx designed module (included in Snesmonitormod)
! ---------------------------------------------------------------------
      subroutine FormMonitor(snes,its,norm,snesmonitor,ierr)
      use Npes_mpi          ! npes,mype,ismpion - rm later!
      use Snesmonitormod
      use PETSc_Snes_Param
      use PETSc_Snes_Param_Monitor
      implicit none

      SNES,       INTENT(INOUT) :: snes
      PetscInt,       INTENT(IN)    :: its
      PetscScalar,    INTENT(IN)    :: norm
      type(monctx),   INTENT(INOUT) :: snesmonitor
      PetscErrorCode, INTENT(OUT)   :: ierr
      
      PetscInt     :: rebuild
      KSP          :: ksp
      character*80 :: jac_rebuild_output

      if (psp_mon_on) then
        call SNESGetKSP(snes,ksp,ierr)
        psp_mon_fnrm(psp_mon_arrlen) = norm
        psp_mon_dtreal(psp_mon_arrlen) = snesmonitor%thisdt
        psp_mon_snesit(psp_mon_arrlen) = its
        call PetscGetTime(psp_mon_time(psp_mon_arrlen),ierr)
        if (its .eq. 0) then
          psp_mon_kspits(psp_mon_arrlen) = 0
        else
          call KSPGetIterationNumber(ksp,psp_mon_kspits(psp_mon_arrlen),ierr)
        end if
        call SNESGetNumberFunctionEvals(snes,psp_mon_fevals(psp_mon_arrlen),ierr)

        psp_mon_arrlen = psp_mon_arrlen + 1
        if (psp_mon_arrlen .gt. SIZE(psp_mon_fnrm)) then
          call psp_monAdjustSize(psp_mon_allocInc,ierr)
        end if
        psp_mon_fcalls(psp_mon_arrlen) = 0
        psp_mon_ftime(psp_mon_arrlen) = 0
      end if

      call DetermineJacRebuild(snes,snesmonitor,its,rebuild,jac_rebuild_output,ierr)
      if (rebuild.gt.0 .and. mype.eq.0) then
        write(6,*) jac_rebuild_output
        call flush(6)
      end if

      end subroutine FormMonitor

! ---------------------------------------------------------------------
!  Subroutine PetscSnesSetSf
!     Calculate the scaling vector of function values.
!     The Jacobian at X is calculated, and sf(i) is set
!     to the reciprocal of the max_norm of row i.
!     This routine is written based on bbb/oderhs.m/sfsetnk()
!
!  Input Parameters:
!    snes - SNES nonlinear solver context
!    X    - vector at which the Jacobian is evaluated
!  Output Parameter:
!    SF   - scaling vector for the rhs function
! ---------------------------------------------------------------------
      subroutine PetscSnesSetSf(snes,X,SF,ierr)
      use Petscmod
      use PETSc_Snes_Param
      use Npes_mpi         ! npes,mype,ismpion - rm later!
      implicit none

      SNES,           INTENT(INOUT) :: snes
      Vec,            INTENT(INOUT) :: X,SF
      PetscErrorCode, INTENT(OUT)   :: ierr

      MatStructure                        :: Jstruct
      PetscInt                            :: i,n,nt
      PetscInt, ALLOCATABLE, DIMENSION(:) :: idx
      PetscReal                           :: norm
      PetscScalar,pointer                 :: xx(:),xxtmp(:)

      call SNESComputeJacobian(snes,X,psp_Jmat,psp_Jmat,Jstruct,ierr)
#if defined(DEBUG_SF)
      write(6,*) "PetscSnesSetSf- Jmat: "
      call flush(6)
      call MatView(psp_Jmat,PETSC_VIEWER_STDOUT_SELF,ierr)
#endif
      call VecGetSize(SF,nt,ierr)
      ALLOCATE(idx(1:nt))
      call MatGetDiagonal(psp_Jmat,psp_Xtmp,ierr)
      call MatGetRowMaxAbs(psp_Jmat,SF,idx,ierr)
      DEALLOCATE(idx)
#if defined(DEBUG_SNES)
      if (mype .eq. 0) then 
        write(6,*) "SF: "
        flush(6)
      endif
      call VecView(SF,PETSC_VIEWER_STDOUT_WORLD,ierr)
      write(6,*) "[",mype,"] PetscSnesSetSf() SNESComputeJacobian is done "
      call VecNorm(SF,NORM_2,norm,ierr)
      write(6,*) "[",mype,"] ...MaxRowNorm",norm
      call flush(6)
#endif

      call VecGetLocalSize(SF,n,ierr)
      call VecGetArrayF90(SF,xx,ierr)
        do i=1,n
          if (xx(i) .ne. 0.0) then
            xx(i) = 1.0/xx(i)
            if (xx(i) .lt. 0.0) xx(i) = - xx(i)
          else
            write(6,*) "[",mype,"] ***Error: Jrowmax(",i,")=",xx(i)
            call flush(6)
            SETERRQ(1,' ',ierr)
          endif
        end do
      call VecRestoreArrayF90(SF,xx,ierr)
      end subroutine PetscSnesSetSf

!************************************************************
!  subroutine PetscSnesFillSf()
!
! -------------------------------------------------------------------
      subroutine PetscSnesFillSf(neq,sfscal,SF,ierr)
      use Petscmod
      use PETSc_Snes_Param
      implicit none

      PetscInt,       INTENT(IN)    :: neq
      PetscScalar,    INTENT(IN)    :: sfscal(neq)
      Vec,            INTENT(INOUT) :: SF
      PetscErrorCode, INTENT(OUT)   :: ierr
      
      PetscInt            :: i
      PetscScalar,pointer :: xx(:)

      call VecGetArrayF90(SF,xx,ierr)
      do i=1,neq
        xx(i) = sfscal(i)
      end do
      call VecRestoreArrayF90(SF,xx,ierr)
      end subroutine PetscSnesFillSf

!************************************************************
!  subroutine PetscSnesFillSu()
!
! -------------------------------------------------------------------
      subroutine PetscSnesFillSu(neq,suscal,SU,ISU,ierr)
      use Petscmod
      use PETSc_Snes_Param
      implicit none

      PetscInt,       INTENT(IN)    :: neq
      PetscScalar,    INTENT(INOUT) :: suscal(neq)
      Vec,            INTENT(INOUT) :: SU,ISU
      PetscErrorCode, INTENT(OUT)   :: ierr
      
      PetscInt            :: i
      PetscScalar,pointer :: xx(:),xx1(:)

      call VecGetArrayF90(ISU,xx,ierr)
      call VecGetArrayF90(SU,xx1,ierr)
      do i=1,neq
        if (suscal(i) .gt. -0.000001) then
          if (suscal(i) .lt. 0.000001) then
            write(6,*)"su",i,suscal(i)," reset su=1.e-6!"
            call flush(6)
            suscal(i) = 0.000001
          end if
        end if
        xx1(i) = suscal(i)
        xx(i) = 1.0/suscal(i)
      end do
      call VecRestoreArrayF90(SU,xx1,ierr)
      call VecRestoreArrayF90(ISU,xx,ierr)
!      write(6,*)"SUVEC: "
!      call flush(6)
!      call VecView(SU,PETSC_VIEWER_STDOUT_WORLD,ierr)
      end subroutine PetscSnesFillSu

!************************************************************
!  subroutine PetscSnesApply()
!
! -------------------------------------------------------------------
      subroutine PetscSnesApply(n,yl,savf,suscal,sfscal,nnzmx,ireorder,incpset,icflag,rlx,icnstr,dtreal,iterm,ierr)
      use Petscmod
      use Petscmodinterfaces
      use Snesmonitormod
      use PETSc_Snes_Param
      implicit none

      PetscInt ::           n,nnzmx,ireorder,incpset
      PetscScalar,target :: yl(n),savf(n),suscal(n),sfscal(n)
      PetscInt,target ::    icnstr(n)
      PetscInt ::           icflag
      PetscReal ::          rlx,dtreal
      PetscInt ::           iterm

      PetscInt ::           i,its
      MatStructure ::       flag
      PetscErrorCode ::     ierr
      PetscInt ::           ksp
      PC ::                 pc
      Vec ::                X1
      PetscScalar,target :: wk(n+2)
      PetscViewer ::        output

      type(Petscctx), pointer:: pctx

      type(monctx) ::       snesmonitor
      SNESConvergedReason :: snesreason

      PetscScalar ::        neg_one
      PetscReal ::          norm
      PetscScalar, pointer ::  xx(:),xx1(:)
      real ::               gettime, sec4

      external FormPreCheck,FormMonitor

!      write(6,*)"*********************************"
!      write(6,*)"Apply: neq=",n
!      write(6,*)"................................."
!      call flush(6)

!      call SNESGetApplicationContext(psp_snes,pctx,ierr)

      return
      end subroutine PetscSnesApply

!************************************************************
!  subroutine PetscSnesCreateObjs()
!
! -------------------------------------------------------------------
      subroutine PetscSnesCreateObjs(comm,n,neqg,nnzmx,ierr)

      use Petscmod
      use PETSc_Snes_Param
      use Npes_mpi         ! npes,mype,ismpion
      use Dim              ! nx,ny    - rm later!
      use Math_problem_size  ! neqmx,numvar - rm later!
      Use Indices_loc_glob_map ! ivcum,ivloc2sdg,ivloc2mdg,ivl2gstnl - rm later!

      implicit none

      integer4 ::           comm
      PetscInt ::           n,neqg,nnzmx
      PetscErrorCode ::     ierr

      PetscInt ::           i,bs,rstart,rend,j,k,id
      PetscViewer ::        viewer
      PetscReal  ::         norm
      PetscInt    ::        mycols(neqg),nmycols,band,row,col,rows(numvar),cols(9*numvar),bcols(9),bj
      PetscScalar ::        zeros(9*numvar*numvar),zero
      PetscTruth ::         flg

!      write(6,*)"[",mype,"] Create: neq, neqg=",n,neqg," numvar",numvar
!      write(6,*)"................................."
!      call flush(6)

!     Create SNES objects 
!----------------------------------------------------------
      call SNESCreate(comm,psp_snes,ierr)

!     Create vectors for holding solutions and rhsfunc
!----------------------------------------------------
      ! write(6,*) "PetscSnesCreateObjs: comm =", comm
      ! call flush(6)
      call VecCreate(comm,psp_F,ierr)
      call VecSetSizes(psp_F,n,neqg,ierr)
      call VecSetFromOptions(psp_F,ierr)
      call VecDuplicate(psp_F,psp_X,ierr)
      call VecDuplicate(psp_F,psp_Xtmp,ierr)

!     Create scaling vectors
!--------------------------------------------
      if (psp_iscolnorm .gt. 0) then
        call VecDuplicate(psp_X,psp_ISUVEC,ierr)
        call VecDuplicate(psp_X,psp_SUVEC,ierr)
      endif

      if (psp_isf.eq.1) then
        call VecDuplicate(psp_F,psp_SFVEC,ierr)
      endif

!     Create Jacobian matrix Jmat used as preconditioner
!-------------------------------------------------------
      call MatCreate(comm,psp_Jmat,ierr)
      call MatSetSizes(psp_Jmat,n,n,PETSC_DECIDE,PETSC_DECIDE,ierr)

!     default JmatType:
      if (npes .eq. 1) then
        psp_JmatType = 0
      else
        psp_JmatType = 2
      endif
      call PetscOptionsGetInt(PETSC_NULL_CHARACTER,'-Jmat_type',psp_JmatType,PETSC_NULL_INTEGER,ierr)

!     default usecolor
      psp_usecolor = 0
      call PetscOptionsHasName(PETSC_NULL_CHARACTER,"-Jmat_coloring",flg,ierr)
      if (flg .or. (psp_JmatType .eq. 2)) then !or Boxed sparse pattern is provided
        psp_usecolor = 1
      endif

      call MatSetType(psp_Jmat,MATAIJ,ierr)
      call MatSetFromOptions(psp_Jmat,ierr)
      i = 9*numvar
      call MatSeqAIJSetPreallocation(psp_Jmat,i,PETSC_NULL_INTEGER,ierr)
      call MatMPIAIJSetPreallocation(psp_Jmat,i,PETSC_NULL_INTEGER,i,PETSC_NULL_INTEGER,ierr)
     
      if (psp_JmatType .eq. 2) then
!         set sparse pattern of Jmat using info from the domain decomposition
!         -------------------------------------------------------------------
          if (mype == 0) then
            zero = 0.0
            do i=1,numvar*numvar*9
               zeros(i) = 0.0
            end do
            do id=1,npes
              do i=1,n,numvar         ! loop over local equations/rows
                row = (id-1)*n + i-1  ! global row index - assume all proc have same num of local rows
                do k=1,numvar
                  rows(k) = row + (k-1)
                end do

                k = 0
                do j=1,9*numvar       ! loop over possible neighbors -tmp!
                  if (ivl2gstnl(i,j,id) .eq. 0) then
                    exit
                  endif
                  cols(j) = ivl2gstnl(i,j,id) - 1
                  k = k+1
                end do !j=1,9*numvar
                call PetscSortInt(k,cols,ierr)

                bj = 1
                do j=1,k,numvar   ! loop over possible neighbors -tmp!
                  bcols(bj) = cols(j)/numvar
                  !write(6,*) "row=",row,cols(j), bcols(bj)
                  !call flush(6)
                  bj = bj+1
                end do !j=1,k
                !k = k/numvar  for MatSetValuesBlocked()
                !write(6,*) "k",k,"bj-1",bj-1
                !call flush(6)

                if (k .gt. 0) then
                  call MatSetValues(psp_Jmat,numvar,rows,k,cols,zeros,INSERT_VALUES,ierr)
                  !call MatSetValuesBlocked(psp_Jmat,1,row/numvar,k,bcols,zeros,INSERT_VALUES,ierr)
                endif

              end do      !i=1,n,numvar
            end do        !id=1,npes
          end if !(mype == 0)
          call MatAssemblyBegin(psp_Jmat,MAT_FINAL_ASSEMBLY,ierr)
          call MatAssemblyEnd(psp_Jmat,MAT_FINAL_ASSEMBLY,ierr)
      end if ! (psp_JmatType .eq. 2)

      return
      end subroutine PetscSnesCreateObjs

! ----------------------------------------------------------------------------------------
!     subroutine AnalyzePostSNESSolve(snes,snesmonitor,nsnessolve,snes_conv_output,iterm)
!
! This is just a function to take the results of a SNES solve and determine what the
! appropriate output message and return value should be.  In reality, all this could
! be in the function PetscSNES, but I like encapsulation.  If you don't like this,
! complain to Mike McCourt, we'll talk.
! ----------------------------------------------------------------------------------------
      subroutine AnalyzePostSNESSolve(snes,snesmonitor,nsnessolve,snes_conv_output,iterm,ierr)
      use Petscmod
      use Snesmonitormod
      use PETSc_Snes_Param
      implicit none

      SNES,           INTENT(IN)    :: snes
      type(monctx),   INTENT(INOUT) :: snesmonitor
      PetscInt,       INTENT(INOUT) :: nsnessolve
      character*80,   INTENT(OUT)   :: snes_conv_output
      PetscInt,       INTENT(OUT)   :: iterm
      PetscErrorCode, INTENT(OUT)   :: ierr

      KSP            :: ksp
      PetscInt       :: snesreason,kspreason
      iterm = 4

      call SNESGetConvergedReason(snes,snesreason,ierr)

      if (snesreason .eq. -3) then
        call SNESGetKSP(snes,ksp,ierr) ! Not called earlier if not in time step 0
        call KSPGetConvergedReason(ksp,kspreason,ierr)
        if (psp_nsnes.eq.0) then ! Don't reevaluate Jacobian at time step 0
          snes_conv_output = "    Linear Solve failed in first SNES solve , reducing time step"
        else
          nsnessolve = nsnessolve - 1
          if (kspreason .eq. -3) then
            if (snesmonitor%JacWasJustRebuilt .eq. 0) then
              snes_conv_output =  "    Linear Solve max iterations exceeded, Jacobian will be rebuilt"
            else
              snes_conv_output =  "    Linear Solve max iterations exceeded, reducing time step"
              nsnessolve = nsnessolve + 1 ! Failure after a rebuild means cut time step
            end if
          elseif (kspreason .eq. -9) then
            snes_conv_output =  "    Linear Solve NAN encountered, Jacobian will be rebuilt"
          else
            snes_conv_output =  "    Unknown Linear Solve failure encountered, Jacobian will be rebuilt"
          end if
        end if
        iterm = 4
        snesmonitor%buildJacobian = 1
      elseif (snesreason .eq. -5) then
        snes_conv_output = "    Max SNES steps exceeded, time step will be reduced"
        iterm = 4
      elseif (snesreason .eq. -6) then
        if (snesmonitor%JacWasJustRebuilt .eq. 0) then
          snes_conv_output = "    Line Search failed, Jacobian will be rebuilt"
          snesmonitor%buildJacobian = 1
          nsnessolve = nsnessolve - 1 ! Try a rebuild before cutting the time step
        else
          snes_conv_output = "    Line Search failed, time step will be reduced"
        end if
        iterm = 6
      elseif (snesreason .eq. -8) then
        if (snesmonitor%JacWasJustRebuilt .eq. 0) then
          snes_conv_output = "    Local Minimum found, Jacobian will be rebuilt"
          snesmonitor%buildJacobian = 1
          nsnessolve = nsnessolve - 1 ! Try a rebuild before cutting the time step
        else
          snes_conv_output = "    Local Minimum found, time step will be reduced"
        end if
        iterm = 7
      else
!           Do not know what value iterm should be set???
        snes_conv_output = "    Unknown SNES failure, time step will be reduced"
        iterm = 4
      endif

      end subroutine AnalyzePostSNESSolve

!************************************************************
!  subroutine PetscSnes()
!  The petscmod module is declared above
!  Include files for petsc routines in fortran
!
!  Input Parameters:
!    n      - num of local equations
!    neqg   - num of global equations
!    yl     - local array for field variable
!    savf   - f(u), function values at u
!    suscal - local scale factors for yl, see Use(Ynorm)
!    sfscal - local scale factors for f, see Use(Ynorm)
!    nnzmx  - maximum no. of nonzeros in Jacobian matrix, see Use(Jacobian)
!    ireorder - flag for reordering Jacobain, see Use(Jacreorder)
!    incpset - maximum num of Jacobian reevaluation, see Use(Lsode)
!    icflag - flag for icnstr
!    icnstr - local interger array. If icflag==1, icnstr is imposed:
!                           icnstr(i)>0 -> yl(i)>0
!                           icnstr(i)<0 -> yl(i)<0
!                           icnstr(i)==0 -> no constraint
!    rlx    - defines the inequality: abs(u_step/u)<rlx
!    dtreal - see Use(Time_dep_nwt)
!  Output Parameter:
!    iterm  - output flag for nksol, see Use(Lsode)
! ----------------------------------------------------------------------------------------------
      subroutine PetscSnes(comm,n,neqg,yl,savf,iscolnorm,suscal,sfscal,nnzmx,ireorder,incpset,icflag,rlx,icnstr,dtreal,mmaxu,iterm)
      use Petscmod
      use Petscmodinterfaces
      use Petscmodinterface2
      use Snesmonitormod
      use PETSc_Snes_Param
      use PETSc_Snes_Param_Monitor

      use Math_problem_size    ! neqmx,numvar
      use Indices_loc_glob_map !ivloc2sdg,ivloc2mdg,ivl2gstnl - rm later!
      use Indices_domain_dcl   !ivloc2sdgl,ivloc2mdgl

      implicit none

      integer4 ::           comm
      PetscInt ::           n,neqg,nnzmx,ireorder,incpset,iscolnorm,mmaxu
      PetscScalar,target :: yl(n+2),savf(n),suscal(n),sfscal(n)
      PetscInt,target ::    icnstr(n)
      PetscInt ::           icflag,jmat_file_val
      PetscReal ::          rlx,dtreal
      PetscInt ::           iterm,isf

      integer4 ::           mype,npes
      SNES ::               snes
      PetscInt ::           ksprestart,snesmaxit,snesfcts
      PetscReal ::          snesatol,snesrtol,snesstol
      PetscInt ::           i,its,j,row,col,ntime
      MatStructure ::       flag
      PetscErrorCode ::     ierr
      KSP ::                ksp
      PC ::                 pc
      Vec ::                X1,Vseq
      PetscScalar,target :: wk(n+2),yldot(n),yl_tmp(n)
      PetscViewer ::        output
      type(Petscctx) ::     pctx

      type(monctx) ::       snesmonitor
      PetscTruth ::         writeJmat,flg
      SNESConvergedReason :: snesreason
      KSPConvergedReason :: kspreason

      ISColoring ::         iscoloring

      PetscScalar ::        neg_one,zero
      PetscReal ::          norm,dtholder,cmp_rhs,delta
      PetscScalar, pointer ::  xx(:),xx1(:),array(:)
      real ::               gettime, sec4
      PetscViewer ::        viewer
      MatStructure ::       Jstruct

      PetscInt ::           id
      PetscLogDouble ::     time_loc(30),tstart,tend
      PetscInt ::           idx(3000),nsnessolve,nsnessolve_max,nsnesiter
      character*4           npes_str
      character*80          snes_conv_output
      character*10          snes_jmat_file
      PetscReal, ALLOCATABLE, DIMENSION(:) :: time_diff

!  All pctx-defined Fortran routines are declared external
      external FormUedgeFunction,FormUedgeJacobian,FormPreCheck
      external PetscSnesSetSf,PetscSnesFillSf,PetscSnesFillSu
      external FormMonitor
      external rhsnk

      Interface FormInitialGuess
        subroutine FormInitialGuess(neq,yl,X,ierr)
        use Ynorm                    ! suscal,sfscal,iscolnorm
        use Petscmod
        use PETSc_Snes_Param

        implicit none
        PetscInt ::           neq
        PetscScalar,target :: yl(neq)
        Vec ::                X
        PetscErrorCode ::     ierr
        end subroutine
      End Interface
      Interface FormFinalSolution
        subroutine FormFinalSolution(n,X,yl,ierr)
        use Ynorm                    ! suscal,sfscal,iscolnorm
        use Petscmod
        use PETSc_Snes_Param
        implicit none
        PetscInt ::           n
        PetscScalar,target :: yl(n)
        Vec ::                X
        PetscErrorCode ::     ierr
        end subroutine
      End Interface
      Interface  RhsCmp_Debug
        subroutine RhsCmp_Debug(comm,cmp_rhs,snes,pctx,n,yl)
        use Petscmod
        use PETSc_Snes_Param
        use Indices_loc_glob_map !ivloc2sdg,ivloc2mdg,ivl2gstnl - rm later!
        use Indices_domain_dcl   !ivloc2sdgl,ivloc2mdgl
        implicit none
        integer4 ::           comm
        PetscReal ::          cmp_rhs
        SNES ::               snes
        type(Petscctx) ::     pctx
        PetscScalar,target :: yl(n)
        PetscErrorCode ::     ierr
        PetscInt ::           n
        end subroutine
      End Interface

      call MPI_Barrier(comm,ierr)
      call PetscGetTime(time_loc(1),ierr)

      call MPI_Comm_size(comm,npes,ierr)
      call MPI_Comm_rank(comm,mype,ierr)
!      write(6,*) "comm = ", comm, ", npes = ", npes, ", mype = ", mype
!      call flush(6)

      if (npes .eq. 1) neqg = n
      if (mype .eq. 0) then
        write(6,*)"*****************************************************************"
        write(6,1000)psp_nsnes,n,neqg,numvar,dtreal
1000    format(I2,"-th PetscSnes: neq neqg=",I6,I7,",  numvar=",I2,", dtreal=",EN10.2)
        write(6,*)"................................................................."
        call flush(6)
      endif

      if (psp_nsnes .eq. 0) then !************************************

!     Create snes, vectors and Jacobian matrix
!     Note that iscolnorm is needed in PetscSnesCreateObjs
!---------------------------------------------------
        psp_iscolnorm = iscolnorm
        call PetscLogStagePush(stages(1),ierr)
        call PetscSnesCreateObjs(comm,n,neqg,nnzmx,ierr)
        call PetscLogStagePop(ierr)

!       Fill scaling vectors
!----------------------------------------------
!        call PetscLogStagePush(stages(2),ierr)
        if (psp_iscolnorm .gt. 0) then
          call PetscSnesFillSu(n,suscal,psp_SUVEC,psp_ISUVEC,ierr)
        endif

!       sfscal is provided by Uedge when using Uedge Jacobian
        if ((psp_isf.eq.1) .and. (psp_JmatType.eq.0)) then
          call PetscSnesFillSf(n,sfscal,psp_SFVEC,ierr)
        endif

!       Form initial guess
!------------------------------
        call FormInitialGuess(n,yl,psp_X,ierr)

!       Setup SNES context
!----------------------------------------------------------
        call SNESGetKSP(psp_snes,ksp,ierr)
        ksprestart  = mmaxu
        snesatol    = 1.e-10
        snesrtol    = 0.0
        snesstol    = 0.0
        snesmaxit   = 40
        snesfcts    = 10000
        call KSPGMRESSetRestart(ksp,ksprestart,ierr)
        call SNESSetTolerances(psp_snes,snesatol,snesrtol,snesstol,snesmaxit,snesfcts,ierr)

!  Determine if we need to use a reordering on the Jacobian
!---------------------------------------------------------------
        if (ireorder.eq.1) then
          call KSPGetPC(ksp,pc,ierr)
          call PCFactorSetMatOrderingType(pc,MATORDERING_RCM,ierr)
        endif

!  Determine what the Jacobian lag should be
!  This is passed with the option -snes_lag_jac <int>
!  Note this is different than the standard Jacobian option -snes_lag_lacobian,
!    which prevent PETSc from throwing an error that we already handle here
!  Default is likely 5, which is set in com/petsc-mod.F90
!-------------------------------------------------------------------
      call PetscOptionsGetInt(PETSC_NULL_CHARACTER,'-snes_lag_jac',psp_jaclag,flg,ierr)
      if (psp_jaclag .le. 0) then
        if (mype .eq. 0) then
1006  format("**NOTE** Nonsensical Jacobian lag, ",I5," passed, being reset to ",I2)
          write(6,1006)psp_jaclag,psp_jaclag_DEFAULT
        end if
        psp_jaclag = psp_jaclag_DEFAULT
      end if

!  Prepare the stats if needed 
!  To activate the stats collection and write to a file <str>, pass -stats_print <str>
!  The psp_mon_file default is likely 'trialuedge.m', defined in com/petcsMod.F90
!
!  To write the SNESView() from the final SNES solve to <str>, pass -snes_print <str>
!  The psp_mon_sfile default is likely 'snesout.txt', defined in com/petscMod.F90
!
!  To change the size of the dynamic memory allocation needed for statistics, pass -dynamic_alloc_increment <int> 
!  The psp_mon_allocInc default is likely 10, defined in com/petscMod.F90
!--------------------------------------------------------
        call PetscOptionsGetInt(PETSC_NULL_CHARACTER,'-dyanmic_alloc_increment',psp_mon_allocInc,flg,ierr)

        psp_mon_on = PETSC_FALSE
        call PetscOptionsHasName(PETSC_NULL_CHARACTER,'-stats_print',psp_mon_on,ierr)
        if (psp_mon_on) then
          if (psp_mon_allocInc .lt. 1) then
            psp_mon_allocInc = psp_mon_allocInc_DEFAULT ! Found in com/petscMod.F90
          end if
          call psp_monAdjustSize(psp_mon_allocInc,ierr)

          call PetscOptionsGetString(PETSC_NULL_CHARACTER,'-stats_print',psp_mon_file,psp_mon_on,ierr)
          if (psp_mon_file .eq. '') then
            psp_mon_file = psp_mon_file_DEFAULT
          end if
          psp_mon_on = PETSC_TRUE ! This may not be needed, but was once so I'm leaving it in
        end if

        psp_mon_print_snes = PETSC_FALSE
        call PetscOptionsHasName(PETSC_NULL_CHARACTER,'-snes_print',psp_mon_print_snes,ierr)
        if (psp_mon_print_snes) then
          call PetscOptionsGetString(PETSC_NULL_CHARACTER,'-snes_print',psp_mon_sfile,psp_mon_print_snes,ierr)
          if (psp_mon_sfile .eq. '') then
            psp_mon_sfile = psp_mon_sfile_DEFAULT ! Found in com/petscMod.F90
          end if
          psp_mon_print_snes = PETSC_TRUE ! In case the user wants to use the default
        end if

      endif              !************************************

      snes = psp_snes
     
      call SNESSetApplicationContext(snes,pctx,ierr)

!  Moving the data to the workspace for FormUedgeJacobian
!--------------------------------------------------------
      pctx%savfpoint=>savf
      pctx%wkpoint=>wk
      pctx%ylpoint=>yl
      pctx%nnzmx   = nnzmx
      pctx%incpset = incpset
      pctx%rlx     = rlx
      pctx%icnstrpoint=>icnstr
!      call MPI_Barrier(comm,ierr)

!     Set the rhs function 
!-----------------------------------------
      call SNESSetFunction(snes,psp_F,FormUedgeFunction,pctx,ierr)

!     Set the monitor object
!----------------------------------------
      call SNESMonitorSet(snes,FormMonitor,snesmonitor,PETSC_NULL_FUNCTION,ierr)

!     Create matrix-free matrix Jmf used for Jacobian*vector
!-----------------------------------------------------------
      if (psp_nsnes .eq. 0) then
        call MatCreateSNESMF(snes,psp_Jmf,ierr)
        call MatMFFDSetFromOptions(psp_Jmf,ierr)
      end if

!     Set the function to compute Jacobian
!-----------------------------------------
      if (psp_JmatType .eq. 0) then
        if ((mype .eq. 0) .and. (psp_nsnes .eq. 0)) write(6,*) " Use Uedge jacobian..."
        call SNESSetJacobian(snes,psp_Jmf,psp_Jmat,FormUedgeJacobian,pctx,ierr)
      else if (psp_JmatType .eq. 1) then
        if ((mype .eq. 0) .and. (psp_nsnes .eq. 0)) write(6,*) " Use PETSc slow fd jacobian ..."
        call SNESSetJacobian(snes,psp_Jmf,psp_Jmat,SNESDefaultComputeJacobian,pctx,ierr)
      else
        if ((mype .eq. 0) .and. (psp_nsnes .eq. 0)) write(6,*) " Use Uedge sparse patten with PETSc coloring ..."
      endif
      call flush(6)

      if (psp_nsnes .eq. 0) then
      end if

!  Handle changes in the time step if necessary
!----------------------------------------------
!  In call set_dt(n,yl,wk) we incur a function evaluation which gets
!  stored in wk, but it's not needed which is why wk is just a workspace
!
!  Also, these values get used in FormMonitor to determine when a
!  Jacobian update needs to occur because of a time step change

      snesmonitor%thisdt = dtreal
      if (snesmonitor%thisdt .ne. psp_olddt) then
        call set_dt(n,yl,wk)
      end if

!  Debugging: compare Frhs at the beginning of ntime time steps
!--------------------------------------------------------------
      ntime = 0
      call PetscOptionsGetInt(PETSC_NULL_CHARACTER,'-cmp_Frhs_ntime',ntime,flg,ierr)
      cmp_rhs = 1.e-16
      flg     = PETSC_FALSE
      call PetscOptionsGetReal(PETSC_NULL_CHARACTER,'-cmp_Frhs',cmp_rhs,flg,ierr)
      if (flg .and. (psp_nsnes .eq. ntime)) then !************************************
        !write(6,*) "nsnes",psp_nsnes," ntime",ntime
        !call flush(6)
        call RhsCmp_Debug(comm,cmp_rhs,snes,pctx,n,yl)
      endif

!   Create coloring context. Set the function to evaluate Jacobian
!----------------------------------------------------------------
      if (psp_usecolor .eq. 1) then
        if ((mype .eq. 0) .and. (psp_nsnes .eq. 0)) then
          write(6,*) " use coloring, JmatType", psp_JmatType," isf",psp_isf
          call flush(6)
        endif
        if (psp_nsnes .eq. 0) then !************************************
          call PetscGetTime(tstart,ierr)
          if (psp_JmatType .lt. 2) then
!           Assemble Jmat
            isf = psp_isf
            psp_isf = 0 !if psp_isf=1, set it as 0 because sf is not available until Jacobian is ready
            call SNESComputeJacobian(snes,psp_X,psp_Jmat,psp_Jmat,Jstruct,ierr)
            psp_isf = isf
          endif

          call MatGetColoring(psp_Jmat,MATCOLORING_SL,iscoloring,ierr)
          call MatFDColoringCreate(psp_Jmat,iscoloring,psp_fdcoloring,ierr)
          call ISColoringDestroy(iscoloring,ierr)
          call MatFDColoringSetFromOptions(psp_fdcoloring,ierr)
          call PetscGetTime(tend,ierr)
          psp_mon_colortime = tend - tstart
        endif                      !************************************

        call MatFDColoringSetFunction(psp_fdcoloring,FormUedgeFunction,pctx,ierr)
        call SNESSetJacobian(snes,psp_Jmf,psp_Jmat,SNESDefaultComputeJacobianColor,psp_fdcoloring,ierr)
      endif

!      write(6,*) "psp_usecolor = 1 block concluded. npes = ", npes
!      call flush(6)

!  Enable runtime options
!---------------------------------------------------------
      if (psp_nsnes .eq. 0) then !************************************
        call SNESSetFromOptions(snes,ierr)  ! must be called prior to SNESLineSearchSetPreCheck()
      endif                      !************************************

      if (icflag .eq. 1) then !icflag=1:  flag to use constraint that ni, etc. not < 0
        call SNESLineSearchSetPreCheck(snes,FormPreCheck,pctx,ierr)
      endif

!  Set sfscal (sfscal is not provided by uedge when psp_Jmat_type>0)
!--------------------------------------------------------------------
      if ((psp_JmatType .gt. 0) .and. (psp_nsnes .eq. 0) .and. (psp_isf .eq. 1)) then !************************************
        psp_isf = 0
        call PetscSnesSetSf(snes,psp_X,psp_SFVEC,ierr)
        psp_isf = 1
      
#if defined(SetSf_Debugging)
        write(6,*)" sfscal, SFVEC:"
        write(6,*)" -----------------"
        call VecGetArrayF90(psp_SFVEC,xx,ierr)
        do i=1,n
          write(6,*) i,sfscal(i),xx(i),(sfscal(i) - xx(i))
        end do
        call flush(6)
        call VecRestoreArrayF90(psp_SFVEC,xx,ierr)
#endif
      endif                                                    !************************************

!  Determine whether the first Jacobian needs to be skipped
!  Get frequency of rebuilding Jacobian; then set it to the monitoring parameter
!  Also store the max time step change allowed before a Jac reevaluation is needed
!
!    Note: Passing -jac_max_dt_change 0 means never reevaluate for time step reasons
!----------------------------------------------------------------------------
      psp_skipJacobian  = 0 ! default
      snesmonitor%buildJacobian = 0 ! default
      call PetscOptionsHasName(PETSC_NULL_CHARACTER,"-skip_1st_jacobian",flg,ierr)
      if (flg) then
        psp_skipJacobian = 1
      endif
      call PetscOptionsGetReal(PETSC_NULL_CHARACTER,"-jac_max_dt_change",dtholder,flg,ierr)
      if (flg) then
        if (dtholder .lt. 0) then
          dtholder = -dtholder
        end if
        if ((dtholder .lt. 1) .and. (dtholder .ne. 0)) then
          dtholder = 1/dtholder
        end if
        psp_jacMaxdtChange = dtholder+.001 ! Allowing for some roundoff
      else
        psp_jacMaxdtChange = 1.001 ! Allowing for some roundoff
      end if
!      call PetscLogStagePop(ierr)

!  Solve the system
!  Note that snesmonitor%buildJacobian = 1 for a linear solve fail
!  Other SNES failures also incur a Jac reevaluation, but that is handled in FormMonitor
!---------------------------------------------------------
      call PetscLogStagePush(stages(3),ierr)
      nsnessolve = 0
      do while (nsnessolve .le. 1)
        nsnessolve = nsnessolve + 2
        call SNESSolve(snes,PETSC_NULL_OBJECT,psp_X,ierr)

        call SNESGetConvergedReason(snes,snesreason,ierr)
        if (snesreason .gt. 0) then
          iterm = 1
!          exit
        else ! not converge
          call AnalyzePostSNESSolve(snes,snesmonitor,nsnessolve,snes_conv_output,iterm,ierr)
          if (mype .eq. 0) then
            write(6,*) snes_conv_output
            call flush(6)
          endif
        endif
      end do
      call PetscLogStagePop(ierr)

!  Recover X with scaling suscal and convert it back to Uedge yl
!---------------------------------------------------------------
      call PetscLogStagePush(stages(4),ierr)
!      write(6,*) "Calling FormFinalSolution."
!      call flush(6)
      call FormFinalSolution(n,psp_X,yl,ierr)

!      write(6,*) "Calling SNESGetIterationNumber."
!      call flush(6)
      call SNESGetIterationNumber(snes,its,ierr);
      call SNESGetFunctionNorm(snes,norm,ierr);
      if (mype .eq. 0) then
        write(6,*)"SNES its ",its," fnorm ",norm," convergedReason ",snesreason, "iterm ",iterm
        call flush(6)
      endif

!  Store the current time step to compare to the next time step
!  This value will be needed to determine if the Jacobian needs updated
!----------------------------------------------------------------------
      psp_olddt = snesmonitor%thisdt

!  Write the Jacobian matrix at time ntime
!
!  You may have to manually make a directory jacobians before you use this option the first time
!  That directory must be in the same location as the driver script
!
!  The format for the output of the Jacobian is
!    Jv<int>c<int>n<int>.s<int>
!      v : number of variables (1-6)
!      c : coloring choice (0-3)
!          0 : UEDGE Jacobian
!          1 : Dense Jacobian Only
!          2 : Tom's Sparse Boxed Pattern
!          3 : First Dense Evaluation and Future PETSc Colorings
!      n : number of processors (1,2,4,8)
!      s : snes solve number 
!  If you ran in parallel there would also be a permutation file:
!    Pv<int>c<int>n<int>.s<int>
!  So for example, Jv4c2n1.s0 has 4 variables, Tom's coloring, 1 processor and the first Jacobian
!
!  The s term is the term passed in uedgepetscopt with -write_Jmat <int>
!  The default value is zero, so -write_Jmat 0 is equivalent to -write_Jmat
!  If you pass a value which never gets reached, then no Jacobian is printed
!  It's tempting to call this term the time step, but it isn't because the time step can be split
!--------------------------------------------------------------------------
      writeJmat = PETSC_FALSE
      call PetscOptionsHasName(PETSC_NULL_CHARACTER,'-write_Jmat',writeJmat,ierr)
      if (writeJmat) then
        ntime = 0
        call PetscOptionsGetInt(PETSC_NULL_CHARACTER,'-write_Jmat',ntime,writeJmat,ierr)
        writeJmat = PETSC_TRUE ! May be set to false if no integer is passed
      end if
      if (writeJmat .and. (psp_nsnes .eq. ntime)) then
        if (psp_JmatType .eq. 1) then
          if (psp_usecolor .eq. 1) then
            jmat_file_val = 3
          else
            jmat_file_val = 1
          endif
        elseif (psp_JmatType .eq.2) then
          jmat_file_val = 2 ! This is the boxed sparse pattern
        else
          jmat_file_val = 0 ! I guess we could still run with Uedge Jacobian
        endif
 1002   format('v',I1,'c',I1,'n',I1,'.s',I1)
 1003   format('v',I1,'c',I1,'n',I1,'.s',I2)
        if (ntime .le. 9) then
          write(snes_jmat_file,1002) numvar,jmat_file_val,npes,ntime
        else
          write(snes_jmat_file,1003) numvar,jmat_file_val,npes,ntime
        endif
        if (mype .eq. 0) then
          write(6,*)' write Jmat in binary to jacobians/J'//snes_jmat_file
          call flush(6)
        endif

        call PetscViewerBinaryOpen(comm,'jacobians/J'//snes_jmat_file,FILE_MODE_WRITE,viewer,ierr)
        call MatView(psp_Jmat,viewer,ierr)
        call PetscViewerDestroy(viewer,ierr)

        if ((mype .eq. 0) .and. (npes .gt. 1)) then ! Write Permutation to file
          write(6,*)" write permutation ivloc2sdg to jacobians/P"//snes_jmat_file
          call flush(6)
          call VecCreateSeq(MPI_COMM_SELF,neqg,Vseq,ierr)
          call VecGetArrayF90(Vseq,array,ierr)
          do i=1,neqg
            id = (i-1)/n
            j  = i - id*n
            id = id+1
            array(i) = ivloc2sdg(j,id)
          end do
          call VecRestoreArrayF90(Vseq,array,ierr)

          call PetscViewerBinaryOpen(MPI_COMM_SELF,"jacobians/P"//snes_jmat_file,FILE_MODE_WRITE,viewer,ierr)
          call VecView(Vseq,viewer,ierr)
          call PetscViewerDestroy(viewer,ierr)
          call VecDestroy(Vseq,ierr)
        end if

      endif

      if (mype .eq. 0) then
        call PetscGetTime(time_loc(2),ierr)
        write(6,2000) psp_nsnes,time_loc(2)-time_loc(1)
2000    format("*****",i3,"-th PetscSnes is done, Time:",f6.2,"  *****")
        call flush(6)
      endif
      psp_nsnes = psp_nsnes + 1

      call PetscLogStagePop(ierr)

      return
      end subroutine PetscSnes

! ---------------------------------------------------------------------------------
!  subroutine outputstatspetsc
!
!  The info for this function is activated at runtime by -print_stats <int>
!  These statistics will be output to the file snesout.m
!  Eventually I'll add an output to say what file you want the stats written to
!  All the values will be updated in the function FormMonitor
!  Note that the default value for psp_mon_allocInc is 10, defined in com/petscMod.F90
!
!  Since we sometimes do a final run of dt 1e-9 to output the variable values to an hd5
!  file, this function sets psp_mon_on=PETSC_FALSE at the end.  This prevents SNES from
!  trying to write to arrays that are no longer allocated.  If this needs to be
!  changed at some points, we'll figure it out, but for right now this seems like the
!  easiest way to make sure the memory is freed.
! ----------------------------------------------------------------------------------
      subroutine outputstatspetsc
      use Petscmod
      use PETSc_Snes_Param
      use PETSc_Snes_Param_Monitor
      use Npes_mpi         ! npes,mype,ismpion
      use Math_problem_size    ! neqmx,numvar
      implicit none

      PetscInt       :: i,n
      PetscReal      :: time0,time00,ftime0,ftime00
      PetscErrorCode :: ierr

      PetscReal      :: atol,rtol,stol,alpha,maxstep
      PetscInt       :: maxit,maxf
      SNES           :: snes
      KSP            :: ksp
      PetscViewer    :: snesview_output
      character*10   :: name

      snes = psp_snes
      call VecGetSize(psp_X,n,ierr)

      if (.not. psp_mon_on) then ! Can't do anything if you haven't collected any stats
        if (mype .eq. 0) then
          write(6,*) "bbb.outputstats() called but -stats_print <str> not activated"
          write(6,*) "If -stats_print <str> is not activated, data is not collected during the solve"
          write(6,*) "The <str> value gives the file you want the statistics written to"
          write(6,*) "The default value of ",psp_mon_file," will be actived if -stats_print is passed"
          call flush(6)
        end if
      else if (mype .eq. 0) then ! Only have one core do the output
        open(unit=5,file=psp_mon_file,action="write",status="replace")
        write(5,*) "% This data was output from UEDGE"
        write(5,*) "%"
        write(5,*) "pspm_np=",npes,"; % number of processors"
        write(5,*) "pspm_numvar=",numvar,"; % number of variables"
        write(5,*) "pspm_neq=",n,"; % number of equations"
        write(5,*) "%"

        call SNESGetTolerances(snes,atol,rtol,stol,maxit,maxf,ierr)
        write(5,*) "% SNES tolerances and such"
        write(5,*) "pspm_atol=",atol,"; % SNES absolute convergence"
        write(5,*) "pspm_rtol=",rtol,"; % SNES relative convergence"
        write(5,*) "pspm_stol=",stol,"; % SNES step change convergence"
        write(5,*) "pspm_maxit=",maxit,"; % max SNES its before divergence"
        write(5,*) "pspm_maxf=",maxf,"; % max f evals before divergence"
        write(5,*) "%"

        call SNESLineSearchGetParams(snes,alpha,maxstep,ierr)
        call SNESGetType(snes,name,ierr)
        write(5,*) "% SNESLS tolerances and such"
        write(5,*) "pspm_snestype='",name,"'; % Should always be Line Search"
        write(5,*) "pspm_alpha=",alpha,"; % minimum LS reduction factor"
        write(5,*) "pspm_maxstep=",maxstep,"; % maximum norm of Newton step"
        write(5,*) "%"

        call SNESGetKSP(snes,ksp,ierr)
        call KSPGetType(ksp,name,ierr)
        call KSPGetTolerances(ksp,rtol,atol,stol,maxit,ierr)
        write(5,*) "% KSP tolerances and such"
        write(5,*) "pspm_ksp_type='",name,"'; % Should be GMRES"
        write(5,*) "pspm_ksp_rtol=",rtol,"; % KSP relative convergence"
        write(5,*) "pspm_ksp_atol=",atol,"; % KSP absolute convergence"
        write(5,*) "pspm_ksp_dtol=",stol,"; % KSP divergence"
        write(5,*) "pspm_ksp_maxit=",maxit,"; % max KSP its before divergence"
        write(5,*) "%"

        write(5,*) "% Jacobian parameters (specified from uedgepetscopt)"
        write(5,*) "pspm_jac_lag=",psp_jaclag,"; % Jacobian rebuild lag"
        write(5,*) "pspm_jac_type=",psp_JmatType,"; % Method for computing Jacobian"
        write(5,*) "pspm_jac_color=",psp_usecolor,"; % Jacobian coloring activated"
        write(5,*) "pspm_jac_skip1=",psp_skipJacobian,"; % Don't always reevaluated at 1st SNES step"
        write(5,*) "pspm_jac_maxdt=",psp_jacMaxDtChange,"; % dt factor for reevaluating Jacobian"
        write(5,*) "%"

! The last value never gets used, so don't count it
        psp_mon_arrlen = psp_mon_arrlen - 1

! Output the time required to create the coloring, which could be significant for -Jmat_type 1
        write(5,*) "pspm_colortime=",psp_mon_colortime,"; % Time for creating the coloring context"

        write(5,*) "% Col  1: index"
        write(5,*) "% Col  2: Time step size (dtreal)"
        write(5,*) "% Col  3: SNES step"
        write(5,*) "% Col  4: Function norm (residual)"
        write(5,*) "% Col  5: KSP Its in this SNES solve"
        write(5,*) "% Col  6: Cumulative function evals in the time step"
        write(5,*) "% Col  7: Calls to FormUedgeFunction this SNES step"
        write(5,*) "% Col  8: Time spent in FormUedgeFunction this SNES step"
        write(5,*) "% Col  9: Cumulative time in the time step"
        write(5,*) "% Col 10: Cumulative time overall"
        write(5,*) "uedgepetscData=["
        time00 = psp_mon_time(1)
        ftime00 = psp_mon_ftime(1)
1004  format("% Col",I3,", ",I8  ,", ",I2,", ",I10  ,", ",I5,", ",I6,", ",I7,", ",I9  ,", ",I9  ,", ",I9)
1005  format("     ",I3,", ",E8.2,", ",I2,", ",E10.3,", ",I5,", ",I6,", ",I7,", ",F9.3,", ",F9.3,", ",F9.3)
        write(5,1004) 1,2,3,4,5,6,7,8,9,10
        do i=1,psp_mon_arrlen
          if (psp_mon_snesit(i) .eq. 0) then
            time0 = psp_mon_time(i)
            ftime0 = psp_mon_ftime(i)
          end if
          write(5,1005) i,psp_mon_dtreal(i),psp_mon_snesit(i),psp_mon_fnrm(i),psp_mon_kspits(i), &
                        psp_mon_fevals(i),psp_mon_fcalls(i),psp_mon_ftime(i),psp_mon_time(i)-time0+ftime0, &
                        psp_mon_time(i)-time00+ftime00
        end do      
        write(5,*) "];"

        call flush(5)
        close(unit=5)

        write(6,*) "Writing stats to ",psp_mon_file
        call flush(6)
        call psp_monAdjustSize(int(0,4),ierr)
        psp_mon_on = PETSC_FALSE ! So that hd5 runs don't write to psp_mon arrays
      end if

      if (psp_mon_print_snes) then
        if (mype .eq. 0) then
          write(6,*) "Writing SNESView() to ",psp_mon_sfile
          call flush(6)
        end if
        call PetscViewerASCIIOpen(PETSC_COMM_WORLD,psp_mon_sfile,snesview_output,ierr)
        call SNESView(snes,snesview_output,ierr)
        call PetscViewerDestroy(snesview_output,ierr)
      end if

      end subroutine outputstatspetsc

*  ---------------------------------------------------------------------
* @file: dvshdf5.m
*
* @purpose: dump data
*
* @version $Id: dvshdf5.m,v 7.0 2018/02/28 18:32:53 meyer8 Exp $
*
*  ---------------------------------------------------------------------

*  ---------------------------------------------------------------------
*     Initialize hdf5 by calling initialization methods in vshdf5.
*  ---------------------------------------------------------------------
      subroutine init_hdf5()
            use hdf5_api       ! hdf5 types
      CALL vshdf5_fcinit()
      return
      end

*  ---------------------------------------------------------------------
*     Setup and initialization
*     For parallel runs, we are only going to do it on node 0.
*  ---------------------------------------------------------------------
      subroutine dump_vshdf5(filename,intime,doTransposeFlag)
            use Dim            ! nisp,nusp,nfsp,ngsp, nhgsp
            use Interp         ! nis,ups,tes,tis,ngs,phis
            use Jacreorder     ! ireorder
            use Jacobian       ! nnzmx
            use Xpoint_indices   ! ixpt2
            use RZ_grid_info   ! rm, zm
            use hdf5_api       ! nnzmx
            use Neqdskv        ! zmagx
            use UEint          ! mhdgeo
            use Share          ! nxleg,nxcore
c_mpi      Use(MpiVars)
c_mpi      Use(Npes_mpi)
            use Conduc         ! dif_use, tra_use, ...
            use Comtra         ! isbohmcalc facbni, facbup, facbni2, facbee
      implicit none
      character*(*), intent(in) :: filename
      integer, intent(in) :: doTransposeFlag
      real, intent(in) :: intime
      TYPE(hdf5ErrorType) :: h5err
      TYPE(hdf5InOpts) :: h5in
      character(60) :: description
      real, dimension(:,:,:), allocatable :: vs3d
      real, dimension(:,:), allocatable :: vs2d
      integer i,ifld,lid, lenx, leny, ixs, ixe, iys, iye
      real(kind=4):: gettime, sec4
      INTEGER(HID_T) :: root_gid,bbbid,fid, runInfoId
      logical :: dumpPriv, dumpCore, dumpSOL, dumpPrivRite
      logical :: dumpPrivLeft,dumpCoreLeftCell,dumpCoreRiteCell
      integer ::  lxs, lxe, lys, lye, rxs, rxe, rys, rye
*  ---------------------------------------------------------------------
*     Setup and initialization
*     For parallel runs, we are only going to do it on node 0.
*  ---------------------------------------------------------------------
      ! write(*,*) "dump_vshdf5: mype = ", mype
      IF(mype/=0) THEN
        ! write(*,*) "dump_vshdf5: returning as mype = ", mype
        return
      ENDIF
      call vshdf5_inith5vars(h5in, h5err)
      h5in%wrd_type=H5T_NATIVE_DOUBLE
      h5in%doTranspose=.true.
      h5in%vsCentering="zonal"
      h5in%vsTime=intime
      h5in%wrVsTime=.true.
      h5in%verbose=.false.
      h5in%vstimegroup = "ue_time"
c      h5in%logUnit=99   ! Need to fix

c The below are done with -Dc__MPI= , which is the case for truly parallel
c__MPI      h5in%comm=MPI_COMM_SELF
c__MPI      h5in%info=MPI_INFO_NULL

*  ---------------------------------------------------------------------
*     Write the variables to an hdf5 file
*  ---------------------------------------------------------------------
      description=" "
      write(*,*) "dump_vshdf5: opening ", filename,
     &    ", with h5in%comm = ", h5in%comm
c JRC, xlf:(E) Null literal string is not permitted.  A single blank is assumed.
      CALL open_newh5file(filename,fid,description,root_gid,h5in,h5err)
      IF(h5err%errBool) THEN
        WRITE(*, *) "dump_vshdf5: open_newh5file failed with '",
     &  h5err%errorMsg, "'"
      ENDIF
      ! Put time group at the top level.  The references to this group
      ! get added automatically
      call make_time_group(root_gid,h5in,h5err)
      ! Put everything into the bbb subdirectory
      CALL make_group(root_gid,"bbb",bbbid,h5in,h5err)
      IF(h5err%errBool) THEN
        WRITE(*, *) "dump_vshdf5: make_group for bbb failed with '",
     &  h5err%errorMsg, "'"
      ENDIF

*  ---------------------------------------------------------------------
*     Write the run information
*  ---------------------------------------------------------------------
      CALL make_group(root_gid, "runInfo", runInfoId, h5in, h5err)
      IF(h5err%errBool) THEN
        WRITE(*, *) "dump_vshdf5: make_group for runInfo failed with '",
     &  h5err%errorMsg, "'"
      ENDIF
      CALL write_attribute(runInfoId, "vsSoftware", "UEDGE", h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      CALL write_attribute(runInfoId, "vsVsSoftware", "2.9.9", h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      CALL close_group("runInfo", runInfoId, h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg

*  ---------------------------------------------------------------------
*     Basic dumping of raw arrays
*  ---------------------------------------------------------------------
      h5in%units="m^-3"
      CALL dump_h5(bbbid,"nis",nis,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      h5in%units="m^-3"
      CALL dump_h5(bbbid,"ngs",ngs,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      h5in%units=" "
c JRC, xlf:(E) Null literal string is not permitted.  A single blank is assumed.
      CALL dump_h5(bbbid,"tes",tes,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      CALL dump_h5(bbbid,"tis",tis,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      CALL dump_h5(bbbid,"ups",ups,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      CALL dump_h5(bbbid,"psi",psi,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      CALL dump_h5(bbbid,"phis",phis,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      ! diffusivities if need !-------------------------------------
      ! It is hard to tell what to use and what not to use
      IF(read_diffs==1) THEN
      h5in%units="m^2/s"
      CALL dump_h5(bbbid,"dif_use", dif_use,h5in,h5err)
      CALL dump_h5(bbbid,"kye_use", kye_use,h5in,h5err)
      CALL dump_h5(bbbid,"kyi_use", kyi_use,h5in,h5err)
!      CALL dump_h5(bbbid,"tra_use", tra_use,h5in,h5err)
!      CALL dump_h5(bbbid,"dutm_use",dutm_use,h5in,h5err)
!      CALL dump_h5(bbbid,"vy_use",  vy_use,h5in,h5err)
!      CALL dump_h5(bbbid,"vyup_use",vyup_use,h5in,h5err)
!      CALL dump_h5(bbbid,"vyte_use",vyte_use,h5in,h5err)
!      CALL dump_h5(bbbid,"vyti_use",vyti_use,h5in,h5err)
!      CALL dump_h5(bbbid,"fniyos_use", fniyos_use,h5in,h5err)
!      CALL dump_h5(bbbid,"feeyosn_use",feeyosn_use,h5in,h5err)
!      CALL dump_h5(bbbid,"feiyosn_use",feiyosn_use,h5in,h5err)
      ENDIF

*  ---------------------------------------------------------------------
*  Figure out what to dump
*  ---------------------------------------------------------------------
      dumpPriv=.true.; dumpCore=.true.; dumpSOL=.true.
      dumpPrivLeft=.true.;     dumpCoreLeftCell=.true.
      dumpPrivRite=.true.;     dumpCoreRiteCell=.true.
      if (mhdgeo <= 0 .and. isgrdsym .ne. 1) then
*       omit dumping the poloidal left leg and left core cell data - because there is none
        dumpPrivLeft=.false.;  dumpCoreLeftCell=.false.
      elseif (nxomit>=nxleg(1,1).and.nxomit<nxleg(1,1)+nxcore(1,1)) then
*       omit dumping only the poloidal left leg region
        dumpPrivLeft=.false.
      elseif (nxomit >= nxleg(1,1)+nxcore(1,1)+nxcore(1,2)) then
*       omit dumping left leg, left core, and right core; only dump right leg
        dumpPrivLeft=.false.;  dumpCoreLeftCell=.false.
        dumpPrivRite=.false.;  dumpCoreRiteCell=.false.
      endif
*  ---------------------------------------------------------------------
*     Core grid
*     painful because we have to find the nodes of a cell-based grid
*  ---------------------------------------------------------------------
*    Write out the core grid
      ixs=ixpt1(1)+1;            ixe=ixpt2(1)
      iys=0;                     iye=iysptrx1(1)
      lenx=ixe-ixs+1;            leny=iye-iys+1
      ALLOCATE(vs3d(0:lenx, 0:leny, 2)) ! 1 = R, 2 = Z
*    Left lower block
      vs3d(0:lenx-1,0:leny-1,1)=rm(ixs:ixe,0:iye, 1)
      vs3d(0:lenx-1,0:leny-1,2)=zm(ixs:ixe,0:iye, 1) - zmagx
*    Right line (same as left from periodicity)
      vs3d(lenx,0:leny-1,1)=rm(ixe,0:iye, 2)
      vs3d(lenx,0:leny-1,2)=zm(ixe,0:iye, 2) - zmagx
*    Inner line
      vs3d(0:lenx-1,leny,1)=rm(ixs:ixe,iye, 3)
      vs3d(0:lenx-1,leny,2)=zm(ixs:ixe,iye, 3) - zmagx
*    Right Inner node
      vs3d(lenx,leny,1)    =rm(ixe,iye, 4)
      vs3d(lenx,leny,2)    =zm(ixe,iye, 4) - zmagx

*    Dump
      h5in%units="m"; h5in%mesh="mesh-structured"; h5in%vsMD="mesh"
      CALL dump_h5(bbbid,"coreMesh",vs3d,h5in,h5err)
      DEALLOCATE(vs3d)
*  ---------------------------------------------------------------------
*     Core variables
*  ---------------------------------------------------------------------
      h5in%mesh="coreMesh"       ! Everybody as the same mesh here
      !-----------------------------------------------------------
      ! psi (dump all cell data
      !-----------------------------------------------------------
      ALLOCATE(vs2d(0:lenx, 0:leny))
*    Left lower block
      vs2d(0:lenx-1,0:leny-1)=psi(ixs:ixe,0:iye, 1)
*    Right line (same as left from periodicity)
      vs2d(lenx,0:leny-1)=psi(ixe,0:iye, 2)
*    Inner line
      vs2d(0:lenx-1,leny)=psi(ixs:ixe,iye, 3)
*    Right Inner node
      vs2d(lenx,leny)    =psi(ixe,iye, 4)
      h5in%units="Wb";    h5in%vsMD="psi";  h5in%vsCentering="nodal"
      CALL dump_h5(bbbid,"psiCore",vs2d,h5in,h5err)
      DEALLOCATE(vs2d)
      lenx=lenx-1;             leny = leny-1
      !-----------------------------------------------------------
      ! nis and ups are both for 1:nisp
      !-----------------------------------------------------------
      h5in%vsCentering="zonal"
      ALLOCATE(vs3d(0:lenx, 0:leny, nisp))
      vs3d(:,:,:)=nis(ixs:ixe,0:iye,:)
      h5in%units="m^-3";    h5in%vsMD="nis"
      CALL dump_h5(bbbid,"nisCore",vs3d,h5in,h5err)
      vs3d(:,:,:)=ups(ixs:ixe,0:iye,:)
      h5in%units="m/s";    h5in%vsMD="ups"
      CALL dump_h5(bbbid,"upsCore",vs3d,h5in,h5err)
      IF(read_diffs==1) THEN
      h5in%units="m^2/s"
      vs3d(:,:,:)=dif_use(ixs:ixe,0:iye,:); h5in%vsMD="ndiff"
      CALL dump_h5(bbbid,"dif_useCore", vs3d,h5in,h5err)
      ENDIF
      DEALLOCATE(vs3d)
      !-----------------------------------------------------------
      ! ngs  - dimension 1:ngsp
      !-----------------------------------------------------------
      ALLOCATE(vs3d(0:lenx, 0:leny, ngsp))
      vs3d(:,:,:)=ngs(ixs:ixe,0:iye,:)
      h5in%units="m^-3";    h5in%vsMD="ngs"
      CALL dump_h5(bbbid,"ngsCore",vs3d,h5in,h5err)
      DEALLOCATE(vs3d)
      !-----------------------------------------------------------
      ! tes, tis, phis
      !-----------------------------------------------------------
      ALLOCATE(vs2d(0:lenx, 0:leny))
      vs2d(:,:)=tes(ixs:ixe,0:iye)/1.602176487e-19
      h5in%units="eV";    h5in%vsMD="tes"
      CALL dump_h5(bbbid,"tesCore",vs2d,h5in,h5err)
      vs2d(:,:)=tis(ixs:ixe,0:iye)/1.602176487e-19
      h5in%units="eV";    h5in%vsMD="tis"
      CALL dump_h5(bbbid,"tisCore",vs2d,h5in,h5err)
      vs2d(:,:)=phis(ixs:ixe,0:iye)
      h5in%units="V";     h5in%vsMD="phis"
      CALL dump_h5(bbbid,"phisCore",vs2d,h5in,h5err)
      IF(read_diffs==1) THEN
      h5in%units="m^2/s"
      vs2d(:,:)=kye_use(ixs:ixe,0:iye); h5in%vsMD="kye"
      CALL dump_h5(bbbid,"kye_useCore", vs2d,h5in,h5err)
      vs2d(:,:)=kyi_use(ixs:ixe,0:iye); h5in%vsMD="kyi"
      CALL dump_h5(bbbid,"kyi_useCore", vs2d,h5in,h5err)
      ENDIF
      DEALLOCATE(vs2d)

*  ---------------------------------------------------------------------
*     Write out the sol grid
*  ---------------------------------------------------------------------
      lenx=nx+2;       leny=ny+2-iysptrx1(1)-1
      ixs=0;            ixe=nx+1  !=lenx-2
      iys=iysptrx1(1)+1;    iye=ny+1  !=leny+iysptrx1(1)
      ALLOCATE(vs3d(0:lenx, 0:leny, 2)) ! 1 = R, 2 = Z
*    Left lower block
      vs3d(0:lenx-1,0:leny-1,1)=rm(:,iys:iye, 1)
      vs3d(0:lenx-1,0:leny-1,2)=zm(:,iys:iye, 1) - zmagx
*    Right line (same as left from periodicity)
      vs3d(lenx,0:leny-1,1)=rm(ixe,iys:iye, 2)
      vs3d(lenx,0:leny-1,2)=zm(ixe,iys:iye, 2) - zmagx
*    Inner line
      vs3d(0:lenx-1,leny,1)=rm(ixs:ixe,iye, 3)
      vs3d(0:lenx-1,leny,2)=zm(ixs:ixe,iye, 3) - zmagx
*    Right Inner node
      vs3d(lenx,leny,1)=rm(ixe,iye, 4)
      vs3d(lenx,leny,2)=zm(ixe,iye, 4) - zmagx

*    Dump
      h5in%units="m";     h5in%mesh="mesh-structured";  h5in%vsMD="mesh"
      CALL dump_h5(bbbid,"solMesh",vs3d,h5in,h5err)
      DEALLOCATE(vs3d)
*  ---------------------------------------------------------------------
*     Sol variables
*  ---------------------------------------------------------------------
      h5in%mesh="solMesh"

      ! psi (dump entire cell data) !------------------------------
      ALLOCATE(vs2d(0:lenx, 0:leny))
*    Left lower block
      vs2d(0:lenx-1,0:leny-1)=psi(:,iys:iye, 1)
*    Right line (same as left from periodicity)
      vs2d(lenx,0:leny-1)=psi(ixe,iys:iye, 2)
*    Inner line
      vs2d(0:lenx-1,leny)=psi(ixs:ixe,iye, 3)
*    Right Inner node
      vs2d(lenx,leny)=psi(ixe,iye, 4)
      h5in%units="Wb";    h5in%vsMD="psi";  h5in%vsCentering="nodal"
      CALL dump_h5(bbbid,"psiSol",vs2d,h5in,h5err)
      DEALLOCATE(vs2d)

      lenx=lenx-1;               leny=leny-1

      h5in%vsCentering="zonal"
      ! nis and ups are both for 1:nisp !--------------------------
      ALLOCATE(vs3d(0:lenx, 0:leny, nisp))
      vs3d(:,:,:)=nis(ixs:ixe,iys:iye,:)
      h5in%units="m^-3";    h5in%vsMD="nis"
      CALL dump_h5(bbbid,"nisSol",vs3d,h5in,h5err)
      vs3d(:,:,:)=ups(ixs:ixe,iys:iye,:)
      h5in%units="m/s";    h5in%vsMD="ups"
      CALL dump_h5(bbbid,"upsSol",vs3d,h5in,h5err)
      IF(read_diffs==1) THEN
      h5in%units="m^2/s"; h5in%vsMD="ndiff"
      vs3d(:,:,:)=dif_use(ixs:ixe,iys:iye,:)
      CALL dump_h5(bbbid,"dif_useSol", vs3d,h5in,h5err)
      ENDIF
      DEALLOCATE(vs3d)

      ! ngs !------------------------------------------------------
      ALLOCATE(vs3d(0:lenx, 0:leny, ngsp))
      vs3d(:,:,:)=ngs(ixs:ixe,iys:iye,:)
      h5in%units="m^-3";    h5in%vsMD="ngs"
      CALL dump_h5(bbbid,"ngsSol",vs3d,h5in,h5err)
      DEALLOCATE(vs3d)
      ! WRITE(*,*) 'v---------------------------'
      ! WRITE(*,*) "tesSol"
      ! WRITE(*,*) ixs,ixe
      ! WRITE(*,*) iys,iye
      ! WRITE(*,*) 'v---------------------------'

      ! tes, tis, phis !-------------------------------------------
      ALLOCATE(vs2d(0:lenx, 0:leny))
      vs2d(:,:)=tes(ixs:ixe,iys:iye)/1.602176487e-19
      h5in%units="eV";    h5in%vsMD="tes"
      CALL dump_h5(bbbid,"tesSol",vs2d,h5in,h5err)
      vs2d(:,:)=tis(ixs:ixe,iys:iye)/1.602176487e-19
      h5in%units="eV";    h5in%vsMD="tis"
      CALL dump_h5(bbbid,"tisSol",vs2d,h5in,h5err)
      vs2d(:,:)=phis(ixs:ixe,iys:iye)
      h5in%units="V";     h5in%vsMD="phis"
      CALL dump_h5(bbbid,"phisSol",vs2d,h5in,h5err)
      IF(read_diffs==1) THEN
      h5in%units="m^2/s"
      vs2d(:,:)=kye_use(ixs:ixe,iys:iye); h5in%vsMD="kye"
      CALL dump_h5(bbbid,"kye_useSol", vs2d,h5in,h5err)
      vs2d(:,:)=kyi_use(ixs:ixe,iys:iye); h5in%vsMD="kyi"
      CALL dump_h5(bbbid,"kyi_useSol", vs2d,h5in,h5err)
      ENDIF
      DEALLOCATE(vs2d)

*  ---------------------------------------------------------------------
*    Set up dimensional quantities for getting the array indices right
*    Getting all of the geometries (slab, cylinder, etc.) is very tricky
*  ---------------------------------------------------------------------
      IF (dumpPrivLeft .AND. dumpPrivRite) THEN
        lenx=nx+2 +ixpt1(1)-ixpt2(1);       leny=iysptrx1(1)+1
        lxs=0;             lxe=ixpt1(1);    lys=0;     lye=leny-1
        rxs=ixpt1(1)+1;    rxe=lenx-1;      rys=0;     rye=leny-1
      ELSEIF (dumpPrivLeft .AND. .NOT. dumpPrivRite) THEN
        !SEK - Just return at this point since I don't have it working
        CALL close_group("bbb",bbbid,h5err)
        CALL close_h5file(fid,root_gid,h5err)
        RETURN
        !SEK
        lenx=ixpt1(1)+1;                    leny=iysptrx1(1)+1
        lxs=0;             lxe=ixpt1(1);    lys=0;     lye=leny-1
      ELSEIF (.NOT. dumpPrivLeft .AND. dumpPrivRite) THEN
        !SEK - Just return at this point since I don't have it working
        CALL close_group("bbb",bbbid,h5err)
        CALL close_h5file(fid,root_gid,h5err)
        RETURN
        !SEK
        !ixs=ixpt2(1)+1;            ixe=nx+1
        lenx=nx+1-ixpt2(1);                 leny=iysptrx1(1)+1
        rxs=0;             rxe=lenx-1;      rys=0;    rye=leny-1
      ENDIF
*  ---------------------------------------------------------------------
*    Write out the Priv grid
*  ---------------------------------------------------------------------
      ALLOCATE(vs3d(0:lenx, 0:leny, 2)) ! 1 = R, 2 = Z
      iys=0;                              iye =iysptrx1(1)
      IF (dumpPrivLeft) THEN
*    Left lower block
        ixs=0;            ixe=ixpt1(1)
        vs3d(lxs:lxe,lys:lye,1)=rm(ixs:ixe,iys:iye, 1)
        vs3d(lxs:lxe,lys:lye,2)=zm(ixs:ixe,iys:iye, 1) - zmagx
*    Inner line
        vs3d(lxs:lxe,lye+1,1)=rm(ixs:ixe,iye, 3)
        vs3d(lxs:lxe,lye+1,2)=zm(ixs:ixe,iye, 3) - zmagx
*    Right line (same as left from periodicity)
        vs3d(lxe+1,lys:lye,1)=rm(ixe,iys:iye, 2)
        vs3d(lxe+1,lys:lye,2)=zm(ixe,iys:iye, 2) - zmagx
*    Right Inner node
        vs3d(lxe+1,lye+1,1)=rm(ixe,iye, 4)
        vs3d(lxe+1,lye+1,2)=zm(ixe,iye, 4) - zmagx
      ENDIF
      IF (dumpPrivRite) THEN
        ixs=ixpt2(1)+1;            ixe=nx+1
*    Right lower block -- skip redundant line
        vs3d(rxs:rxe,rys:rye,1)=rm(ixs:ixe,iys:iye, 1)
        vs3d(rxs:rxe,rys:rye,2)=zm(ixs:ixe,iys:iye, 1)-zmagx
*    Right line
        vs3d(rxe+1,rys:rye,1)=rm(ixe,iys:iye, 2)
        vs3d(rxe+1,rys:rye,2)=zm(ixe,iys:iye, 2) - zmagx
*    Inner line
        vs3d(rxs:rxe,rye+1,1)=rm(ixs:ixe,iye, 3)
        vs3d(rxs:rxe,rye+1,2)=zm(ixs:ixe,iye, 3) - zmagx
*    Upper right corner of lower right block
        vs3d(rxe+1,rye+1,1)=rm(ixe,iye, 4)
        vs3d(rxe+1,rye+1,2)=zm(ixe,iye, 4) - zmagx
      ENDIF
*    Dump
      h5in%units="m";     h5in%mesh="mesh-structured";  h5in%vsMD="mesh"
      CALL dump_h5(bbbid,"privMesh",vs3d,h5in,h5err)
      DEALLOCATE(vs3d)
*  ---------------------------------------------------------------------
*     Priv variables
*  ---------------------------------------------------------------------
      h5in%mesh="privMesh"
      !-----------------------------------------------------------
      ! psi (dump entire cell data)
      !-----------------------------------------------------------
      ALLOCATE(vs2d(0:lenx, 0:leny))
      iys=0;                              iye =iysptrx1(1)
      IF (dumpPrivLeft) THEN
*    Left lower block
        ixs=0;            ixe=ixpt1(1)
        vs2d(lxs:lxe,lys:lye)=psi(ixs:ixe,iys:iye, 1)
*    Inner line
        vs2d(lxs:lxe,lye+1)=psi(ixs:ixe,iye, 3)
*    Right line (same as left from periodicity)
        vs2d(lxe+1,lys:lye)=psi(ixe,iys:iye, 2)
*    Right Inner node
        vs2d(lxe+1,lye+1)=psi(ixe,iye, 4)
      ENDIF
      IF (dumpPrivRite) THEN
        ixs=ixpt2(1)+1;            ixe=nx+1
*    Right lower block -- skip redundant line
        vs2d(rxs:rxe,rys:rye)=psi(ixs:ixe,iys:iye, 1)
*    Right line
        vs2d(rxe+1,rys:rye)=psi(ixe,iys:iye, 2)
*    Inner line
        vs2d(rxs:rxe,rye+1)=psi(ixs:ixe,iye, 3)
*    Upper right corner of lower right block
        vs2d(rxe+1,rye+1)=psi(ixe,iye, 4)
      ENDIF
      h5in%units="Wb";    h5in%vsMD="psi"; h5in%vsCentering="nodal"
      CALL dump_h5(bbbid,"psiPriv",vs2d,h5in,h5err)
      DEALLOCATE(vs2d)

      lenx=lenx-1;               leny = leny-1
      h5in%vsCentering="zonal"
*    Left lower block
      !-----------------------------------------------------------
      ! nis and ups are both for 1:nisp
      !-----------------------------------------------------------
      ALLOCATE(vs3d(0:lenx, 0:leny, nisp))
      ixs=0;            ixe=ixpt1(1)
      IF (dumpPrivLeft) vs3d(lxs:lxe,:,:)=nis(ixs:ixe,iys:iye,:)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs3d(rxs:rxe,:,:)=nis(ixs:ixe,iys:iye,:)
      h5in%units="m^-3";    h5in%vsMD="nis"
      CALL dump_h5(bbbid,"nisPriv",vs3d,h5in,h5err)
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs3d(lxs:lxe,:,:)=ups(ixs:ixe,iys:iye,:)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs3d(rxs:rxe,:,:)=ups(ixs:ixe,iys:iye,:)
      h5in%units="m/s";    h5in%vsMD="ups"
      CALL dump_h5(bbbid,"upsPriv",vs3d,h5in,h5err)
      IF(read_diffs==1) THEN
      h5in%units="m^2/s"; h5in%vsMD="ndiff"
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs3d(lxs:lxe,:,:)=dif_use(ixs:ixe,iys:iye,:)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs3d(rxs:rxe,:,:)=dif_use(ixs:ixe,iys:iye,:)
      CALL dump_h5(bbbid,"dif_usePriv",vs3d,h5in,h5err)
      ENDIF
      DEALLOCATE(vs3d)
      !-----------------------------------------------------------
      ! ngs
      !-----------------------------------------------------------
      ALLOCATE(vs3d(0:lenx, 0:leny, ngsp))
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs3d(lxs:lxe,:,:)=ngs(ixs:ixe,iys:iye,:)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs3d(rxs:rxe,:,:)=ngs(ixs:ixe,iys:iye,:)
      h5in%units="m^-3";    h5in%vsMD="ngs"
      CALL dump_h5(bbbid,"ngsPriv",vs3d,h5in,h5err)
      DEALLOCATE(vs3d)
      !-----------------------------------------------------------
      ! tes, tis, phis, psi
      ! WRITE(*,*) 'v---------------------------'
      ! WRITE(*,*) "tesPriv"
      ! WRITE(*,*) ixs,ixe
      ! WRITE(*,*) iys,iye
      ! WRITE(*,*) 'v---------------------------'

      !-----------------------------------------------------------
      ALLOCATE(vs2d(0:lenx, 0:leny))
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs2d(lxs:lxe,:)=tes(ixs:ixe,iys:iye)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs2d(rxs:rxe,:)=tes(ixs:ixe,iys:iye)
      vs2d=vs2d/1.602176487e-19
      h5in%units="eV";    h5in%vsMD="tes"
      CALL dump_h5(bbbid,"tesPriv",vs2d,h5in,h5err)
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs2d(lxs:lxe,:)=tis(ixs:ixe,iys:iye)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs2d(rxs:rxe,:)=tis(ixs:ixe,iys:iye)
      vs2d=vs2d/1.602176487e-19
      h5in%units="eV";    h5in%vsMD="tis"
      CALL dump_h5(bbbid,"tisPriv",vs2d,h5in,h5err)
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs2d(lxs:lxe,:)=phis(ixs:ixe,iys:iye)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs2d(rxs:rxe,:)=phis(ixs:ixe,iys:iye)
      h5in%units="V";     h5in%vsMD="phis"
      CALL dump_h5(bbbid,"phisPriv",vs2d,h5in,h5err)

      IF(read_diffs==1) THEN
      h5in%units="m^2/s"
      h5in%vsMD="kye"
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs2d(lxs:lxe,:)=kye_use(ixs:ixe,iys:iye)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs2d(rxs:rxe,:)=kye_use(ixs:ixe,iys:iye)
      CALL dump_h5(bbbid,"kye_usePriv",vs2d,h5in,h5err)
      h5in%vsMD="kyi"
      ixs=0; ixe=ixpt1(1)
      IF (dumpPrivLeft) vs2d(lxs:lxe,:)=kyi_use(ixs:ixe,iys:iye)
      ixs=ixpt2(1)+1;            ixe=nx+1
      IF (dumpPrivRite) vs2d(rxs:rxe,:)=kyi_use(ixs:ixe,iys:iye)
      CALL dump_h5(bbbid,"kyi_usePriv",vs2d,h5in,h5err)
      ENDIF
      DEALLOCATE(vs2d)
      !-----------------------------------------------------------
      ! Done!
      !-----------------------------------------------------------
      CALL close_group("bbb",bbbid,h5err)
      CALL close_h5file(fid,root_gid,h5err)
      WRITE(*,*) 'Dump of ', filename, ' concluded.'
      call flush(6)

      return
      end
c****** end of subroutine dump_vshdf5 *********************

c ------------------------------------------------------------------------
      subroutine restore_vshdf5(filename,doTransposeFlag,errval)
            use Dim            ! nisp,nusp,nfsp,ngsp, nhgsp
            use Interp         ! nis,ups,tes,tis,ngs,phis
            use Jacreorder     ! ireorder
            use Jacobian       ! nnzmx
            use Xpoint_indices   ! ixpt2
            use RZ_grid_info   ! rm, zm
            use hdf5_api 
            use hdf5 
            use Neqdskv        ! zmagx
c_mpi      Use(MpiVars)
c_mpi      Use(Npes_mpi)
            use Conduc         ! dif_use, tra_use, ...
            use Comtra         ! isbohmcalc facbni, facbup, facbni2, facbee
            use Ueint          ! diffread
      implicit none
      character*(*), intent(in) :: filename
      integer, intent(in) :: doTransposeFlag
      integer, intent(out) :: errval
      TYPE(hdf5InOpts) :: h5in
      TYPE(hdf5ErrorType) :: h5err
      character(60) :: description
      real, dimension(:,:,:), allocatable :: vs3d
      real, dimension(:,:), allocatable :: vs2d
      integer i,ifld,lid
      integer lenx, leny, ixs, ixe, iys, iye
      real(kind=4):: gettime, sec4
      integer(int4) :: ierr
      INTEGER(HID_T) :: root_gid,bbbid,fid
*  ---------------------------------------------------------------------
*     Setup and initialization
*  ---------------------------------------------------------------------
c_mpi      call mpi_barrier(uedgeComm, ierr)
      ! WRITE(*,*) " Calling vshdf5_fcinit."
      ! CALL vshdf5_fcinit(h5in,h5err)  ! IMPORTANT
      ! WRITE(*,*) " vshdf5_fcinit returned."
      IF(mype/=0) return
      call vshdf5_inith5vars(h5in, h5err)
      ! WRITE(*,*) " vshdf5_inith5vars returned."
      h5in%wrd_type=H5T_NATIVE_DOUBLE
      h5in%doTranspose=.true.
      h5in%vsCentering="zonal"
      h5in%wrVsTime=.true.
      ! h5in%logUnit=99
      h5in%verbose=.false.
! c_mpi      WRITE(*,*) " mpi_comm_world = ", mpi_comm_world
! c_mpi      WRITE(*,*) " uedgeComm = ", uedgeComm
! c_mpi      WRITE(*,*) " mpi_comm_self = ", mpi_comm_self
c_mpi      h5in%comm = mpi_comm_self
! c__MPI      WRITE(*,*) " mpi_info_null = ", mpi_info_null
      h5in%info = 0
c__MPI      h5in%info=mpi_info_null
! c__MPI      WRITE(*,*) " h5in%info = ", h5in%info
*  ---------------------------------------------------------------------
*     Open the file and get to the right group
*  ---------------------------------------------------------------------
      ! WRITE(*, fmt='(a)I3') "restore_vshdf5: opening file '", filename,
      WRITE(*, *) "restore_vshdf5: opening file '", filename,
     &    "' with h5in%comm = ", h5in%comm
      CALL open_oldh5file(filename,fid,root_gid,h5in,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
      ! everything is in the bbb subdirectory
      CALL open_group(root_gid,"bbb",bbbid,h5err)
      IF(h5err%errBool) WRITE(*,fmt='(/,a,/)') h5err%errorMsg
* jrc 12may09: How can one continue if there is an error opening the group?

*  ---------------------------------------------------------------------
*     Fill the fundamental arrays
*  ---------------------------------------------------------------------
* fmt='(a)' removes leading blank
      errval = 0
      WRITE(*, fmt='(a)') "Restoring the fundamental arrays."
      h5in%verbose=.true.
      CALL read_h5(bbbid,"nis",nis,h5in,h5err)
      IF(h5err%errBool) CALL dvshdf5_restore_stop("nis", errval)
      WRITE(*, fmt='(a)') "nis restored."
      CALL read_h5(bbbid,"ngs",ngs,h5in,h5err)
      IF(h5err%errBool) CALL dvshdf5_restore_stop("ngs", errval)
      WRITE(*, fmt='(a)') "ngs restored."
      CALL read_h5(bbbid,"tes",tes,h5in,h5err)
      IF(h5err%errBool) CALL dvshdf5_restore_stop("tes", errval)
      WRITE(*, fmt='(a)') "tes restored."
      CALL read_h5(bbbid,"tis",tis,h5in,h5err)
      IF(h5err%errBool) CALL dvshdf5_restore_stop("tis", errval)
      WRITE(*, fmt='(a)') "tis restored."
      CALL read_h5(bbbid,"ups",ups,h5in,h5err)
      IF(h5err%errBool) CALL dvshdf5_restore_stop("ups", errval)
      WRITE(*, fmt='(a)') "ups restored."
      CALL read_h5(bbbid,"phis",phis,h5in,h5err)
      IF(h5err%errBool) CALL dvshdf5_restore_stop("phis", errval)
      WRITE(*, fmt='(a)') "phis restored."

      IF ( errval .NE. 0 )  THEN
            CALL close_group("bbb",bbbid,h5err)
            CALL close_h5file(fid,root_gid,h5err)
            RETURN
      ENDIF

*  ---------------------------------------------------------------------
      CALL dvshdf5_diff_restore3d("dif_use",dif_use)
      CALL dvshdf5_diff_restore2d("kye_use",kye_use)
      CALL dvshdf5_diff_restore2d("kyi_use",kyi_use)
!      CALL dvshdf5_diff_restore3d("tra_use",tra_use)
!      CALL dvshdf5_diff_restore3d("vy_use",vy_use)
!      CALL dvshdf5_diff_restore2d("vyup_use",vyup_use)
!      CALL dvshdf5_diff_restore2d("vyte_use",vyte_use)
!      CALL dvshdf5_diff_restore2d("vyti_use",vyti_use)
!      CALL dvshdf5_diff_restore3d("fniyos_use",fniyos_use)
!      CALL dvshdf5_diff_restore2d("feeyosn_use",feeyosn_use)
!      CALL dvshdf5_diff_restore2d("feiyosn_use",feiyosn_use)
      !-----------------------------------------------------------
      ! Done!
      !-----------------------------------------------------------
      CALL close_group("bbb",bbbid,h5err)
      CALL close_h5file(fid,root_gid,h5err)

      CALL common_setup(1)

      return
      contains
c ------------------------------------------------------------------------
c      All of the diffusivities have the same structure.
c ------------------------------------------------------------------------
       SUBROUTINE dvshdf5_diff_restore2d(varName,array)
       CHARACTER(*), INTENT(IN) :: varName
       REAL, DIMENSION(:,:), INTENT(INOUT) :: array

       IF(read_diffs==1) THEN
       CALL read_h5(bbbid,TRIM(varName),array,h5in,h5err)
       IF(h5err%errBool) THEN

        WRITE(*, fmt='(a)') "Warning: Problem restoring "//TRIM(varNAME)
        WRITE(*, fmt='(a)') "         Possible inconsistent with inputs"
        WRITE(*, fmt='(a)') TRIM(h5err%errorMsg)
       ENDIF
       ENDIF
       RETURN
       END SUBROUTINE dvshdf5_diff_restore2d
       SUBROUTINE dvshdf5_diff_restore3d(varName,array)
       CHARACTER(*), INTENT(IN) :: varName
       REAL, DIMENSION(:,:,:), INTENT(INOUT) :: array

       IF(read_diffs==1) THEN
        CALL read_h5(bbbid,TRIM(varName),array,h5in,h5err)
        IF(h5err%errBool) THEN
         WRITE(*,fmt='(a)') "Warning: Problem restoring "//TRIM(varNAME)
         WRITE(*,fmt='(a)') "         Possible inconsistent with inputs"
         WRITE(*,fmt='(a)') TRIM(h5err%errorMsg)
        ENDIF
       ENDIF
       RETURN
       END SUBROUTINE dvshdf5_diff_restore3d


c ------------------------------------------------------------------------
c     If I fail on a restore then I want to stop
c ------------------------------------------------------------------------
       SUBROUTINE dvshdf5_restore_stop(varName, errval)
       CHARACTER(*), INTENT(IN) :: varName
       INTEGER, INTENT(OUT) :: errval

       WRITE(*,fmt='(a)') "ERROR: Problem restoring "//TRIM(varNAME)
       WRITE(*,fmt='(a)') TRIM(h5err%errorMsg)
       WRITE(*,fmt='(a)') "EXITING"
       errval = 1
       RETURN
       END SUBROUTINE dvshdf5_restore_stop
      end
c****** end of subroutine restore_vshdf5 *********************
c ------------------------------------------------------------------------
c     This is from uefacets.py.
c ------------------------------------------------------------------------
      subroutine common_setup(in_restart)
            use Ueint        ! zmagx
 c_mpi           use Npes_mpi        ! zmagx
      implicit none
      integer, intent(in) :: in_restart
*  ---------------------------------------------------------------------
*     Setup and initialization
*  ---------------------------------------------------------------------

*     Set up mass and charge arrays and flux surface average arrays needed
*     for the variable setting methods.  Must have arrays allocated and so must
*     be called after buildData.  Must know whether this is a restart,
*     to set bbb.restart in order to be able to call this from
*     initialize() or from restore()
      restart=in_restart

      if (ismpion==1 .and. restart == 1) then
        write(*,*)  "WARNING: For parallel run, averages "
        write(*,*)  "are NOT computed by commonsetup."
cc        return
      endif

* If bbb.ueinit is here, then uedge runs
      if (ismpion == 0) then
        call ueinit
      elseif (mype == 0) then
        call globalmesh
      endif

* SEK: There was a lot of stuff here that is confusing me.
* I don't think it was needed, but who knows

* In above, making use of thin-ness of guard cell so  needn't worry
*  abut using centered cell value of r.

      return
      end
c****** end of subroutine common_setup *********************
c ------------------------------------------------------------------------

c-----------------------------------------------------------------------
      real function erl1 (te, ne, tau)
      use Dim 
      use Share                 ! istabon
      use Physical_constants    ! ev
      use Data_input 
      use Rtdata 
      use Rtdegas 

c     local variables --
      implicit none
      real te, ne, tau
      integer je,jd,jr
      real zloge,zlogd,zlogr,rle,rld,fje,fjd,fjr,
     .     erl111,erl112,erl121,erl122,erl11,erl12

c     procedures --
      real rqa, rsa
      external remark, kaboom, rqa, rsa

c     Compute electron radiation loss rate per neutral H atom due to
c     "ionization" processes - D. Stotler's "coupling to the ground state"
c     te [J]          = electron temperature
c     ne [/m**3]      = electron density
c     erl1 [J/sec]    = radiation rate

c----------------------------------------------------------------------c
      if (istabon .le. 7) then   ! various older models

         erl1 = (rqa(te,ne,0)-13.6*ev*rsa(te,ne,0.,0))*ne

c----------------------------------------------------------------------c
      elseif (istabon .eq. 8 .or. istabon .eq. 9) then ! linear interpolation

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     radiation rate --
         erl111=welms1(je,jd,jr)
         erl112=welms1(je,jd+1,jr)
         erl121=welms1(je+1,jd,jr)
         erl122=welms1(je+1,jd+1,jr)
         erl11=erl111+fjd*(erl112-erl111)
         erl12=erl121+fjd*(erl122-erl121)
         erl1 = erl11 + fje*(erl12-erl11)

c----------------------------------------------------------------------c
      elseif (istabon>9 .and. istabon<14) then ! logarith. interp on Stotler-95

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     radiation rate --
         erl111=log( welms1(je,jd,jr) )
         erl112=log( welms1(je,jd+1,jr) )
         erl121=log( welms1(je+1,jd,jr) )
         erl122=log( welms1(je+1,jd+1,jr) )
         erl11=erl111+fjd*(erl112-erl111)
         erl12=erl121+fjd*(erl122-erl121)
         erl1 = exp( erl11 + fje*(erl12-erl11) )

c----------------------------------------------------------------------c
      elseif (istabon>13 .and. istabon<16) then ! spatially-dependent

         if (tau.le.taumin) then
            jr  = 1
            fjr = tau/taumin
         else
            zlogr = log10(tau/taumin)/deltau + 2.
            zlogr = min(zlogr,real(mpr-1))
            jr  = int(zlogr)
            fjr = zlogr - jr
         endif

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     radiation rate --
         if (istabon .eq. 14) then
            erl111=(1.-fjr)*welms1(je,jd,jr)     +
     .                 fjr *welms1(je,jd,jr+1)
            erl112=(1.-fjr)*welms1(je,jd+1,jr)   +
     .                 fjr *welms1(je,jd+1,jr+1)
            erl121=(1.-fjr)*welms1(je+1,jd,jr)   +
     .                 fjr *welms1(je+1,jd,jr+1)
            erl122=(1.-fjr)*welms1(je+1,jd+1,jr) +
     .                 fjr *welms1(je+1,jd+1,jr+1)
            erl11=erl111+fjd*(erl112-erl111)
            erl12=erl121+fjd*(erl122-erl121)
            erl1 = erl11 + fje*(erl12-erl11)
         elseif (istabon .eq. 15) then
            erl111=(1.-fjr)*log( welms1(je,jd,jr) )     +
     .                 fjr *log( welms1(je,jd,jr+1) )
            erl112=(1.-fjr)*log( welms1(je,jd+1,jr) )   +
     .                 fjr *log( welms1(je,jd+1,jr+1) )
            erl121=(1.-fjr)*log( welms1(je+1,jd,jr) )   +
     .                 fjr *log( welms1(je+1,jd,jr+1) )
            erl122=(1.-fjr)*log( welms1(je+1,jd+1,jr) ) +
     .                 fjr *log( welms1(je+1,jd+1,jr+1) )
            erl11=erl111+fjd*(erl112-erl111)
            erl12=erl121+fjd*(erl122-erl121)
            erl1 = exp( erl11 + fje*(erl12-erl11) )
         endif

c----------------------------------------------------------------------c
      else				! write error message
         call remark('function erl1 not defined for istabon > 15')
         call kaboom(0)
      endif

      return
      end

c-----------------------------------------------------------------------
      real function erl2 (te, ne, tau)
      use Dim 
      use Share                 ! istabon
      use Physical_constants    ! ev
      use Data_input 
      use Rtdata 
      use Rtdegas 

c     local variables --
      implicit none
      real te, ne, tau
      integer je,jd,jr
      real zloge,zlogd,zlogr,rle,rld,fje,fjd,fjr,
     .     erl211,erl212,erl221,erl222,erl21,erl22

c     procedures --
      real rra
      external remark, kaboom, rra

c     Compute electron radiation loss rate per H ion due to
c     "recombination" processes - D. Stotler's "coupling to the continuum"
c     te [J]          = electron temperature
c     ne [/m**3]      = electron density
c     erl2 [J/sec]    = radiation rate

c----------------------------------------------------------------------c
      if (istabon .le. 7) then   ! various older models

	 erl2 = (13.6*ev+1.5*te)*ne*rra(te,ne,0.,1)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 8 .or. istabon .eq. 9) then ! linear interpolation

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     radiation rate --
         erl211=welms2(je,jd,jr)
         erl212=welms2(je,jd+1,jr)
         erl221=welms2(je+1,jd,jr)
         erl222=welms2(je+1,jd+1,jr)
         erl21=erl211+fjd*(erl212-erl211)
         erl22=erl221+fjd*(erl222-erl221)
         erl2 = erl21 + fje*(erl22-erl21)

c----------------------------------------------------------------------c
      elseif (istabon>9 .and. istabon<14) then ! log. interp. of Stotler-95

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     radiation rate --  now logarithm of rate
         erl211=log( welms2(je,jd,jr) )
         erl212=log( welms2(je,jd+1,jr) )
         erl221=log( welms2(je+1,jd,jr) )
         erl222=log( welms2(je+1,jd+1,jr) )
         erl21=erl211+fjd*(erl212-erl211)
         erl22=erl221+fjd*(erl222-erl221)
         erl2 = exp( erl21 + fje*(erl22-erl21) )

c----------------------------------------------------------------------c
      elseif (istabon>13 .and. istabon<16) then ! spatially-dependent

         if (tau.le.taumin) then
            jr  = 1
            fjr = tau/taumin
         else
            zlogr = log10(tau/taumin)/deltau + 2.
            zlogr = min(zlogr,real(mpr-1))
            jr  = int(zlogr)
            fjr = zlogr - jr
         endif

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     radiation rate --
         if (istabon .eq. 14) then
            erl211=(1.-fjr)*welms2(je,jd,jr)     +
     .                 fjr *welms2(je,jd,jr+1)
            erl212=(1.-fjr)*welms2(je,jd+1,jr)   +
     .                 fjr *welms2(je,jd+1,jr+1)
            erl221=(1.-fjr)*welms2(je+1,jd,jr)   +
     .                 fjr *welms2(je+1,jd,jr+1)
            erl222=(1.-fjr)*welms2(je+1,jd+1,jr) +
     .                 fjr *welms2(je+1,jd+1,jr+1)
            erl21=erl211+fjd*(erl212-erl211)
            erl22=erl221+fjd*(erl222-erl221)
            erl2 = erl21 + fje*(erl22-erl21)
        elseif (istabon .eq. 15) then
            erl211=(1.-fjr)*log( welms2(je,jd,jr) )     +
     .                 fjr *log( welms2(je,jd,jr+1) )
            erl212=(1.-fjr)*log( welms2(je,jd+1,jr) )   +
     .                 fjr *log( welms2(je,jd+1,jr+1) )
            erl221=(1.-fjr)*log( welms2(je+1,jd,jr) )   +
     .                 fjr *log( welms2(je+1,jd,jr+1) )
            erl222=(1.-fjr)*log( welms2(je+1,jd+1,jr) ) +
     .                 fjr *log( welms2(je+1,jd+1,jr+1) )
            erl21=erl211+fjd*(erl212-erl211)
            erl22=erl221+fjd*(erl222-erl221)
            erl2 = exp( erl21 + fje*(erl22-erl21) )
        endif

c-----------------------------------------------------------------------
      else				! write error message
         call remark('function erl2 not defined for istabon > 15')
         call kaboom(0)
      endif

      return
      end

c-----------------------------------------------------------------------
      real function rcx (t0, n0, k)
      use Dim 
      use Share                 ! istabon
      use Physical_constants    ! ev,m_prot
      use Data_input            ! issgvcxc,sgvcxc
      use Rtdata 
      use Rtdegas 

c     local variables --
      implicit none
      integer k
      real t0, n0
      real a
      integer ini,iti
      real rlni,rlti,fxni,fxti,a0,a1
      integer je,j0
      real zloge,rle,fje,rcx1,rcx2
      real kdum
      integer zn,za,zamax
      external mcrates

c     Compute rate parameter for k--->k-1 charge exchange on neutral hydrogen
c     k               = initial charge state
c     t0 [J]          = effective hydrogen temperature (per AMU)
c     n0 [/m**3]      = density (not used)
c     rcx [m**3/sec]  = <sigma v>

c----------------------------------------------------------------------c
      if ((istabon .eq. 1) .or. (istabon .eq. 2)) then
c			use ADPAK/STRAHL table look-up

c     indices for interpolation --
         iti = 0
         ini = 0
c     compute abscissae --
         rlti = log(t0/ev)
         rlni = max(htln(0),min(htln(htnn),log(n0)))
c     find iti --
 51      if (iti .lt. htnt-1) then
            if (htlt(iti+1) .le. rlti) then
               iti = iti + 1
               goto 51
            endif
         endif
 52      if (0 .lt. iti) then
            if (rlti .lt. htlt(iti)) then
               iti = iti - 1
               goto 52
            endif
         endif
c     find ini --
 53      if (ini .lt. htnn-1) then
            if (htln(ini+1) .le. rlni) then
               ini = ini + 1
               goto 53
            endif
         endif
 54      if (0 .lt. ini) then
            if (rlni .lt. htln(ini)) then
               ini = ini - 1
               goto 54
            endif
         endif
c     compute coefficients for linear interpolation --
         fxni = (rlni-htln(ini))/(htln(ini+1)-htln(ini))
         fxti = (rlti-htlt(iti))/(htlt(iti+1)-htlt(iti))
c     compute charge exchange rate parameter for k --> k-1 process --
         a0 = (1-fxni)*htlcx(iti,ini,k) + fxni*htlcx(iti,ini+1,k)
         a1 = (1-fxni)*htlcx(iti+1,ini,k) + fxni*htlcx(iti+1,ini+1,k)
         rcx = exp((1-fxti)*a0+fxti*a1)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 3) then
c			use DEGAS table look-up

c     compute abscissa --
         zloge=log(t0/ev)
         rle=max(rlemin, min(zloge,rlemax))
c     table index for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
c     fractional part of interval (je,je+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
c     charge exchange rate --
         j0=je		! assume neutral temperature is same as ions
         rcx1=svphcx(je,j0)
         rcx2=svphcx(je+1,j0)
         rcx = rcx1 + fje*(rcx2-rcx1)

c----------------------------------------------------------------------c
      elseif (istabon==16) then  ! For data in b2frates format (B2,SOLPS)
         zn=1     ! nuclear charge for hydrogenic species
         zamax=1  ! maximum atomic charge for hydrogenic species
         za=1     ! compute c-x rate for this charge state
         call mcrates(n0,t0,t0,za,zamax,zn,kdum,kdum,rcx)

c----------------------------------------------------------------------c
      else     !     use analytic model (hydrogen) for all other istabon

         a = 3*t0 / (10*ev)
         rcx = 1.7e-14 * a**0.333
         if (issgvcxc.eq.1) rcx = sgvcxc ! use fixed sig-v 
         if (issgvcxc.eq.2) rcx = sgvcxc*sqrt(t0/m_prot) ! fixed sig

c----------------------------------------------------------------------c
      endif

      return
      end
c-----------------------------------------------------------------------
      real function rqa (te, ne, k)
      use Dim 
      use Share                 ! istabon
      use Physical_constants    ! ev
      use Data_input 
      use Ionization_energy     ! erad
      use Rtdata 
      use Rtdegas 
      use Aphwrk 
            use Timespl 
      implicit none
      integer k
      real te, ne
      real(kind=4):: sec4, gettime, tsval

c     external procedures --
      real rsa, svradp, B2VAhL
      external rsa, svradp, B2VAhL, remark, kaboom, gettime

c     local variables --
      real a
      integer ine,ite
      real rlne,rlte,fxne,fxte,t0,t1
      integer je,jd,jr
      real zloge,zlogd,rle,rld,fje,fjd,w11,w12,w21,w22,w1,w2,w,vlogw
      integer nxcoef,nycoef
      real xuse,yuse

c     Compute electron energy loss rate parameter for processes
c     starting from charge state k --
c     k                = initial charge state
c     te [J]           = electron temperature
c     ne [/m**3]       = electron density
c     rqa [J*m**3/sec] = <sigma*v>*dE where dE is electron energy loss

c----------------------------------------------------------------------c
      if (istabon .eq. 0) then   ! use analytic model (hydrogen) with
c                                  ! constant energy loss per ionization
         a = te / (10*ev)
         rqa = erad * ev * 3.0e-14 * a*a / (3.0 + a*a)

c----------------------------------------------------------------------c
      elseif ((istabon .eq. 1) .or. (istabon .eq. 2)) then
c			use ADPAK table look-up

c     indices for interpolation --
         ite = 0
         ine = 0
c     compute abscissae --
         rlte = log(te/ev)
         rlne = max(htln(0),min(htln(htnn),log(ne)))
c     find ite --
 51      if (ite .lt. htnt-1) then
            if (htlt(ite+1) .le. rlte) then
               ite = ite + 1
               goto 51
            endif
         endif
 52      if (0 .lt. ite) then
            if (rlte .lt. htlt(ite)) then
               ite = ite - 1
               goto 52
            endif
         endif
c     find ine --
 53      if (ine .lt. htnn-1) then
            if (htln(ine+1) .le. rlne) then
               ine = ine + 1
               goto 53
            endif
         endif
 54      if (0 .lt. ine) then
            if (rlne .lt. htln(ine)) then
               ine = ine - 1
               goto 54
            endif
         endif
c     compute coefficients for linear interpolation --
         fxne = (rlne-htln(ine))/(htln(ine+1)-htln(ine))
         fxte = (rlte-htlt(ite))/(htlt(ite+1)-htlt(ite))
c     compute electron energy loss rate parameter --
         t0 = (1-fxne)*htlqa(ite,ine,k) + fxne*htlqa(ite,ine+1,k)
         t1 = (1-fxne)*htlqa(ite+1,ine,k) + fxne*htlqa(ite+1,ine+1,k)
         rqa = ev*exp((1-fxte)*t0+fxte*t1)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 3) then
c			use DEGAS table look-up

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     electron energy loss per ionization --
         w11=welms(je,jd)
         w12=welms(je,jd+1)
         w21=welms(je+1,jd)
         w22=welms(je+1,jd+1)
         w1=w11+fjd*(w12-w11)
         w2=w21+fjd*(w22-w21)
         w = w1 + fje*(w2-w1)
c     electron energy loss rate parameter --
         rqa = ev * w * rsa(te,ne,0.,k)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 4) then
c			use POST93 table look-up

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     hydrogen line radiation rate --
         w11=wlemiss(je,jd)
         w12=wlemiss(je,jd+1)
         w21=wlemiss(je+1,jd)
         w22=wlemiss(je+1,jd+1)
         w1=w11+fjd*(w12-w11)
         w2=w21+fjd*(w22-w21)
         w = w1 + fje*(w2-w1)
c     electron energy loss rate parameter --
         rqa = w + 13.6 * ev * rsa(te,ne,0.,k)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 5) then
c			use spline fit to POST93 table data
c      xuse=min(max(xdata(1),log(te/ev)),xdata(nxdata))
c      yuse=min(max(ydata(1),log10(ne)),ydata(nydata))

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))

      xuse=rle
      yuse=rld

      nxcoef=nxdata
      nycoef=nydata

      vlogw = B2VAhL(xuse, yuse, 0, 0, xknots, yknots, nxcoef,
     .          nycoef, kxords, kyords, rqacoef, ldf, workh, iflag)
      w=10**vlogw
c     electron energy loss rate parameter --
         rqa = w + 13.6 * ev * rsa(te,ne,0.,k)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 6) then
c			use spline fit to POST93 table data
c      xuse=min(max(xdata(1),log(te/ev)),xdata(nxdata))
c      yuse=min(max(ydata(1),log10(ne)),ydata(nydata))

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))

      xuse=rle
      yuse=rld

      nxcoef=nxdata
      nycoef=nydata

      tsval = gettime(sec4)
      w = B2VAhL(xuse, yuse, 0, 0, xknots, yknots, nxcoef, nycoef,
     .          kxords, kyords, rqacoef, ldf, workh, iflag)
      totb2val = totb2val + gettime(sec4) - tsval
c     electron energy loss rate parameter --
         rqa = w + 13.6 * ev * rsa(te,ne,0.,k)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 7) then
c                       use polynomial fit from Bob Campbell -  8/93
c     Note that the 13.6 * ev * rsa(te,ne,k) is omitted here as Campbell
c     has already added it in
         rqa = svradp(te/ev,ne)

c----------------------------------------------------------------------c
      elseif (istabon .gt. 7) then	! write error message 
         call remark('**** function rqa is not defined for istabon > 7')
         call kaboom(0)

c----------------------------------------------------------------------c
      endif

      return
      end
c-----------------------------------------------------------------------
      real function rra (te, ne, tau, k)
      use Dim 
      use Share                 ! istabon
      use Physical_constants    ! ev
      use Data_input 
      use Rtdata 
      use Rtdegas 
      use Aphwrk 
            use Timespl 
      implicit none
      integer k
      real te, ne, tau
      real(kind=4):: sec4, gettime, tsval

c     external procedures --
      real srecf, B2VAhL
      external srecf, B2VAhL, gettime

c     local variables --
      integer ine,ite
      real rlne,rlte,fxne,fxte,t0,t1
      integer je,jd,jr
      real zloge,zlogd,zlogr,rle,rld,fje,fjd,fjr,
     .     rra11,rra12,rra21,rra22,rra1,rra2
      integer nxcoef,nycoef
      real xuse,yuse,vlog10rra
      real kdum
      integer zn,za,zamax

c     Compute rate parameter for k--->k-1 recombination
c     k               = initial charge state
c     te [J]          = electron temperature
c     ne [/m**3]      = electron density
c     rra [m**3/sec]  = <sigma v>

c----------------------------------------------------------------------c
      if (istabon .eq. 0) then   ! use analytic model
         rra = 0.

c----------------------------------------------------------------------c
      elseif ((istabon .eq. 1) .or. (istabon .eq. 2)) then
c			use ADPAK table look-up

c     indices for interpolation --
         ite = 0
         ine = 0
c     compute abscissae --
         rlte = log(te/ev)
         rlne = max(htln(0),min(htln(htnn),log(ne)))
c     find ite --
 51      if (ite .lt. htnt-1) then
            if (htlt(ite+1) .le. rlte) then
               ite = ite + 1
               goto 51
            endif
         endif
 52      if (0 .lt. ite) then
            if (rlte .lt. htlt(ite)) then
               ite = ite - 1
               goto 52
            endif
         endif
c     find ine --
 53      if (ine .lt. htnn-1) then
            if (htln(ine+1) .le. rlne) then
               ine = ine + 1
               goto 53
            endif
         endif
 54      if (0 .lt. ine) then
            if (rlne .lt. htln(ine)) then
               ine = ine - 1
               goto 54
            endif
         endif
c     compute coefficients for linear interpolation --
         fxne = (rlne-htln(ine))/(htln(ine+1)-htln(ine))
         fxte = (rlte-htlt(ite))/(htlt(ite+1)-htlt(ite))
c     compute recombination rate parameter for k --> k-1 process  --
         t0 = (1-fxne)*htlra(ite,ine,k) + fxne*htlra(ite,ine+1,k)
         t1 = (1-fxne)*htlra(ite+1,ine,k) + fxne*htlra(ite+1,ine+1,k)
         rra = exp((1-fxte)*t0+fxte*t1)

c----------------------------------------------------------------------c
c             use DEGAS or POST93 or DEGAS93 or Stotler95 table look-up
      elseif ((istabon .eq. 3) .or. (istabon .eq. 4)
     .   .or. (istabon .eq. 8) .or. (istabon .eq. 9)) then

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     recombination rate parameter --
         rra11=wsveh0(je,jd,jr)
         rra12=wsveh0(je,jd+1,jr)
         rra21=wsveh0(je+1,jd,jr)
         rra22=wsveh0(je+1,jd+1,jr)
         rra1=rra11+fjd*(rra12-rra11)
         rra2=rra21+fjd*(rra22-rra21)
         rra = rra1 + fje*(rra2-rra1)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 5) then
c			use spline fit to POST93 table data
c      xuse=min(max(xdata(1),log(te/ev)),xdata(nxdata))
c      yuse=min(max(ydata(1),log10(ne)),ydata(nydata))

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))

      xuse=rle
      yuse=rld

      nxcoef=nxdata
      nycoef=nydata

      vlog10rra = B2VAhL(xuse, yuse, 0, 0, xknots, yknots, nxcoef,
     .          nycoef, kxords, kyords, rracoef, ldf, workh, iflag)
      rra=10**vlog10rra

c----------------------------------------------------------------------c
      elseif (istabon .eq. 6) then
c			use spline fit to POST93 table data
c      xuse=min(max(xdata(1),log(te/ev)),xdata(nxdata))
c      yuse=min(max(ydata(1),log10(ne)),ydata(nydata))

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))

      xuse=rle
      yuse=rld

      nxcoef=nxdata
      nycoef=nydata

      tsval = gettime(sec4)
      rra = B2VAhL(xuse, yuse, 0, 0, xknots, yknots, nxcoef, nycoef,
     .          kxords, kyords, rracoef, ldf, workh, iflag)
      totb2val = totb2val + gettime(sec4) - tsval
c----------------------------------------------------------------------c
      elseif (istabon .eq. 7) then
c                       use polynomial fit from Bob Campbell -  8/93
         rra = srecf(te/ev,ne)

c----------------------------------------------------------------------c
      elseif (istabon>9 .and. istabon<14) then  ! use log interp on Stotler
         jr = 1
c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     recombination rate parameter --
         rra11=log( wsveh0(je,jd,jr) )
         rra12=log( wsveh0(je,jd+1,jr) )
         rra21=log( wsveh0(je+1,jd,jr) )
         rra22=log( wsveh0(je+1,jd+1,jr) )
         rra1=rra11+fjd*(rra12-rra11)
         rra2=rra21+fjd*(rra22-rra21)
         rra = exp( rra1 + fje*(rra2-rra1) )

c----------------------------------------------------------------------c
      elseif (istabon>13 .and. istabon<16) then ! spatially-dep opt-depth

         if (tau.le.taumin) then
            jr  = 1
            fjr = tau/taumin
         else
            zlogr = log10(tau/taumin)/deltau + 2.
            zlogr = min(zlogr,real(mpr-1))
            jr  = int(zlogr)
            fjr = zlogr - jr
         endif

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     recombination rate parameter --
         if (istabon .eq. 14) then
            rra11=(1.-fjr)*wsveh0(je,jd,jr)     +
     .                fjr *wsveh0(je,jd,jr+1)
            rra12=(1.-fjr)*wsveh0(je,jd+1,jr)   +
     .                fjr *wsveh0(je,jd+1,jr+1)
            rra21=(1.-fjr)*wsveh0(je+1,jd,jr)   +
     .                fjr *wsveh0(je+1,jd,jr+1)
            rra22=(1.-fjr)*wsveh0(je+1,jd+1,jr) +
     .                fjr *wsveh0(je+1,jd+1,jr+1)
            rra1=rra11+fjd*(rra12-rra11)
            rra2=rra21+fjd*(rra22-rra21)
            rra =rra1 + fje*(rra2-rra1)
         elseif (istabon .eq. 15) then
            rra11=(1.-fjr)*log( wsveh0(je,jd,jr) )     +
     .                fjr *log( wsveh0(je,jd,jr+1) )
            rra12=(1.-fjr)*log( wsveh0(je,jd+1,jr) )   +
     .                fjr *log( wsveh0(je,jd+1,jr+1) )
            rra21=(1.-fjr)*log( wsveh0(je+1,jd,jr) )   +
     .                fjr *log( wsveh0(je+1,jd,jr+1) )
            rra22=(1.-fjr)*log( wsveh0(je+1,jd+1,jr) ) +
     .                fjr *log( wsveh0(je+1,jd+1,jr+1) )
            rra1=rra11+fjd*(rra12-rra11)
            rra2=rra21+fjd*(rra22-rra21)
            rra = exp( rra1 + fje*(rra2-rra1) )
         endif

c----------------------------------------------------------------------c
         elseif (istabon==16) then
            zn=1     ! nuclear charge for hydrogenic species
            zamax=1  ! maximum atomic charge for hydrogenic species
            za=1     ! compute recombination rate for this charge state
            call mcrates(ne,te,te,za,zamax,zn,kdum,rra,kdum)

c----------------------------------------------------------------------c
      endif

      return
      end
c-----------------------------------------------------------------------
      real function rsa (te, ne, tau, k)
      use Dim 
      use Share                 ! istabon
      use Physical_constants    ! ev
      use Data_input 
      use Rtdata 
      use Rtdegas 
      use Aphwrk 
            use Timespl 
      implicit none
      integer k
      real te, ne, tau
      real(kind=4):: sec4, gettime, tsval

c     external procedures --
      real sionf, B2VAhL
      external sionf, B2VAhL, gettime

c     local variables --
      real a
      integer ine,ite
      real rlne,rlte,fxne,fxte,t0,t1
      integer je,jd,jr
      real zloge,zlogd,zlogr,rle,rld,fje,fjd,fjr,
     .     rsa11,rsa12,rsa21,rsa22,rsa1,rsa2
      integer nxcoef,nycoef
      real xuse,yuse,vlog10rsa
      real kdum
      integer zn,za,zamax
      external mcrates

c     Compute rate parameter for k--->k+1 ionization by electrons
c     k               = initial charge state
c     te [J]          = electron temperature
c     ne [/m**3]      = electron density
c     rsa [m**3/sec]  = <sigma v>

c----------------------------------------------------------------------c
      if (istabon .eq. 0) then   ! use analytic model (hydrogen)
         a = te / (10*ev)
         rsa = 3.0e-14 * a*a / (3.0 + a*a)

c----------------------------------------------------------------------c
      elseif ((istabon .eq. 1) .or. (istabon .eq. 2)) then
c			use ADPAK table look-up

c     indices for interpolation --
         ite = 0
         ine = 0
c     compute abscissae --
         rlte = log(te/ev)
         rlne = max(htln(0),min(htln(htnn),log(ne)))
c     find ite --
 51      if (ite .lt. htnt-1) then
            if (htlt(ite+1) .le. rlte) then
               ite = ite + 1
               goto 51
            endif
         endif
 52      if (0 .lt. ite) then
            if (rlte .lt. htlt(ite)) then
               ite = ite - 1
               goto 52
            endif
         endif
c     find ine --
 53      if (ine .lt. htnn-1) then
            if (htln(ine+1) .le. rlne) then
               ine = ine + 1
               goto 53
            endif
         endif
 54      if (0 .lt. ine) then
            if (rlne .lt. htln(ine)) then
               ine = ine - 1
               goto 54
            endif
         endif
c     compute coefficients for linear interpolation --
         fxne = (rlne-htln(ine))/(htln(ine+1)-htln(ine))
         fxte = (rlte-htlt(ite))/(htlt(ite+1)-htlt(ite))
c     compute ionization rate parameter for k --> k+1 process --
         t0 = (1-fxne)*htlsa(ite,ine,k) + fxne*htlsa(ite,ine+1,k)
         t1 = (1-fxne)*htlsa(ite+1,ine,k) + fxne*htlsa(ite+1,ine+1,k)
         rsa = exp((1-fxte)*t0+fxte*t1)

c----------------------------------------------------------------------c
c       	use DEGAS or POST93 or DEGAS93 or Stotler95 table look-up
      elseif ((istabon .eq. 3) .or. (istabon .eq. 4)
     .   .or. (istabon .eq. 8) .or. (istabon .eq. 9)) then

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     ionization rate parameter --
         rsa11=wsveh(je,jd,jr)
         rsa12=wsveh(je,jd+1,jr)
         rsa21=wsveh(je+1,jd,jr)
         rsa22=wsveh(je+1,jd+1,jr)
         rsa1=rsa11+fjd*(rsa12-rsa11)
         rsa2=rsa21+fjd*(rsa22-rsa21)
         rsa = rsa1 + fje*(rsa2-rsa1)

c----------------------------------------------------------------------c
      elseif (istabon .eq. 5) then
c			use spline fit to POST93 table data
c      xuse=min(max(xdata(1),log(te/ev)),xdata(nxdata))
c      yuse=min(max(ydata(1),log10(ne)),ydata(nydata))

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))

      xuse=rle
      yuse=rld

      nxcoef=nxdata
      nycoef=nydata

      vlog10rsa = B2VAhL(xuse, yuse, 0, 0, xknots, yknots, nxcoef,
     .          nycoef, kxords, kyords, rsacoef, ldf, workh, iflag)
      rsa=10**vlog10rsa

c----------------------------------------------------------------------c
      elseif (istabon .eq. 6) then
c			use spline fit to POST93 table data
c      xuse=min(max(xdata(1),log(te/ev)),xdata(nxdata))
c      yuse=min(max(ydata(1),log10(ne)),ydata(nydata))

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))

      xuse=rle
      yuse=rld

      nxcoef=nxdata
      nycoef=nydata

      tsval = gettime(sec4)
      rsa = B2VAhL(xuse, yuse, 0, 0, xknots, yknots, nxcoef, nycoef,
     .          kxords, kyords, rsacoef, ldf, workh, iflag)
      totb2val = totb2val + gettime(sec4) - tsval      
c----------------------------------------------------------------------c
      elseif (istabon .eq. 7) then
c                       use polynomial fit from Bob Campbell -  8/93
         rsa = sionf(te/ev,ne)

c----------------------------------------------------------------------c
      elseif (istabon>9 .and. istabon<14) then  ! log interp on Stotler

         jr = 1

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     ionization rate parameter -- now logarithm of rates
         rsa11=log( wsveh(je,jd,jr) )
         rsa12=log( wsveh(je,jd+1,jr) )
         rsa21=log( wsveh(je+1,jd,jr) )
         rsa22=log( wsveh(je+1,jd+1,jr) )
         rsa1=rsa11 + fjd*(rsa12-rsa11) 
         rsa2=rsa21 + fjd*(rsa22-rsa21) 
         rsa = exp( rsa1 + fje*(rsa2-rsa1) )

c----------------------------------------------------------------------c
      elseif (istabon>13 .and. istabon<16) then ! spatially-dep opt-depth

         if (tau.le.taumin) then
            jr  = 1
            fjr = tau/taumin
         else
            zlogr = log10(tau/taumin)/deltau + 2.
            zlogr = min(zlogr,real(mpr-1))
            jr  = int(zlogr)
            fjr = zlogr - jr
         endif

c     compute abscissae --
         zloge=log(te/ev)
         rle=max(rlemin, min(zloge,rlemax))
         zlogd=log10(ne)
         rld=max(rldmin, min(zlogd,rldmax))
c     table indicies for interpolation --
         je=int((rle-rlemin)/delekpt) + 1
         je=min(je,mpe-1)
         jd=int((rld-rldmin)/deldkpt) + 1
         jd=min(jd,mpd-1)
c     fractional parts of intervals (je,je+1) and (jd,jd+1) --
         fje=(rle-ekpt(je))/(ekpt(je+1)-ekpt(je))
         fjd=(rld-dkpt(jd))/(dkpt(jd+1)-dkpt(jd))
c     ionization rate parameter
         if (istabon .eq. 14) then
            rsa11=(1.-fjr)*wsveh(je,jd,jr)     +
     .                fjr *wsveh(je,jd,jr+1)
            rsa12=(1.-fjr)*wsveh(je,jd+1,jr)   +
     .                fjr *wsveh(je,jd+1,jr+1)
            rsa21=(1.-fjr)*wsveh(je+1,jd,jr)   +
     .                fjr *wsveh(je+1,jd,jr+1)
            rsa22=(1.-fjr)*wsveh(je+1,jd+1,jr) +
     .                fjr *wsveh(je+1,jd+1,jr+1)
            rsa1=rsa11+fjd*(rsa12-rsa11)
            rsa2=rsa21+fjd*(rsa22-rsa21)
            rsa =rsa1 + fje*(rsa2-rsa1)
         elseif (istabon .eq. 15) then
            rsa11=(1.-fjr)*log( wsveh(je,jd,jr) )     +
     .                fjr *log( wsveh(je,jd,jr+1) )
            rsa12=(1.-fjr)*log( wsveh(je,jd+1,jr) )   +
     .                fjr *log( wsveh(je,jd+1,jr+1) )
            rsa21=(1.-fjr)*log( wsveh(je+1,jd,jr) )   +
     .                fjr *log( wsveh(je+1,jd,jr+1) )
            rsa22=(1.-fjr)*log( wsveh(je+1,jd+1,jr) ) +
     .                fjr *log( wsveh(je+1,jd+1,jr+1) )
            rsa1=rsa11+fjd*(rsa12-rsa11)
            rsa2=rsa21+fjd*(rsa22-rsa21)
            rsa = exp( rsa1 + fje*(rsa2-rsa1) )
         endif

c----------------------------------------------------------------------c
         elseif (istabon==16) then
            zn=1     ! nuclear charge for hydrogenic species
            zamax=1  ! maximum atomic charge for hydrogenic species
            za=0     ! compute ionization rate for this charge state
            call mcrates(ne,te,te,za,zamax,zn,rsa,kdum,kdum)

c----------------------------------------------------------------------c
      endif

      return
      end

c----------------------------------------------------------------------c
      real function sionf(temp,den)
c
c  this function is the new H ionization curve fit from
c  R.B. Campbell 1/94
c
c    0.1 eV < te < 500 eV
c
c    1.0e18 1/m3 < ne < 1.022 1/m3
c
c    y = log10(te(eV))
c    x = log10(ne(1/m3))
c caution: other version may reverse x,y and then correct later
c 
c Both ionization and recombination rates are in m3/sec.
c Etai is in eV.
c
      implicit none

      real temp,den,x,y,ain,bin,cin,din,ein,gin,hin,riin

c Fit for Ionization Rate

      ain(x) = -49.05905 + 2.51313783 * x - 0.049159714*x*x
      bin(x) = 41.1855162  - 2.3298672 * x + 4.24769144e-2*x*x
      cin(x) = -32.798921+1.72102919*x-0.038692357*x*x
      din(x) = 27.370466-1.6824361*x+0.0462317894*x*x
      ein(x) = -7.9990454+0.127573157*x-6.3586911e-3*x*x
      gin(x) = -4.5832951+0.776264783*x-1.8866089e-2*x*x
      hin(x) = 3.08056833-0.39114789*x+9.86833304e-3*x*x
      riin(x) = -0.4648639+0.0551428018*x-1.404213e-3*x*x
c
c *************************************************************
c
      x = min(22.e0,log10(den))
      y = log10(temp)
c
c
      sionf = 10**( ain(x)+bin(x)*y+cin(x)*y*y+din(x)*y*y*y
     .             + ein(x)*y*y*y*y + gin(x)*y*y*y*y*y
     .             + hin(x)*y*y*y*y*y*y + riin(x)*y*y*y*y*y*y*y )

c
      return
      end
c
c----------------------------------------------------------------------c

      real function srecf(temp,den)
c
c  this function is the H recombination curve fit from
c  R.B. Campbell 8/93
c
c    0.1 eV < te < 500 eV
c
c    1.0e18 1/m3 < ne < 1.022 1/m3
c
c    y = log10(te(eV))
c    x = log10(ne(1/m3))
c caution: other version may reverse x,y and then correct later
c 
c Both ionization and recombination rates are in m3/sec.
c Etai is in eV.
c
c
      implicit none

      real temp,den,x,y,ar,br,cr,dr,er,gr
c
c Fit for Recombination Rate
c
      ar(x) = -0.4575652 - 2.144012 * x + 6.7072142e-2 * x * x
     .        -1.391667e-4 * x * x * x
      br(x) = -121.8401 + 18.001822 * x -0.8679488 * x * x
     .        + 1.33165e-2 * x * x * x
      cr(x) = 80.897256 -13.29602 * x + 0.71881414 * x * x
     .        -0.0126549 * x * x * x
      dr(x) = 56.406823 - 7.301996 * x + 0.29339793 * x * x
     .       -3.50898e-3 * x * x * x
      er(x) = -55.73559 + 7.9634283 * x - 0.370274 * x * x
     .       + 5.567961e-3 * x * x * x
      gr(x) = 10.866692 - 1.584193 * x + 0.07563791 * x * x
     .       -1.177562e-3 * x * x * x
c
c *************************************************************
c
      x = min(22.e0,log10(den))
      y = log10(temp)
c
c
      srecf = 10**( ar(x)+br(x)*y+cr(x)*y*y+dr(x)*y*y*y
     .                 + er(x)*y*y*y*y + gr(x)*y*y*y*y*y )
c
      return
      end

c----------------------------------------------------------------------c

      real function svradp(temp,den)
c
c  this function is the H radiation curve fit from
c  R.B. Campbell 8/93
c
c    0.1 eV < te < 500 eV
c
c    1.0e18 1/m3 < ne < 1.022 1/m3
c
c    y = log10(te(eV))
c    x = log10(ne(1/m3))
c caution: other version may reverse x,y and then correct later
c 
c Both ionization and recombination rates are in m3/sec.
c Etai is in eV.
c

      implicit none

      real temp,den,x,y,ai,bi,ci,di,ei,gi,ae,be,ce,de,ee,ge,sionfl,etai

c Fit for Ionization Rate

      ai(x) = -275.845 + 37.010817 * x -1.788045 * x * x
     .      +  0.029078333 * x * x * x
      bi(x) = 2200.9478 - 326.1153 * x + 16.148655 * x * x
     .       - 0.2660702 * x * x * x
      ci(x) = -2.935221e3 + 4.3757698e2 * x -21.73964 * x * x
     .       + 0.358962 * x * x * x
      di(x) = 1604.1466 - 239.6959 * x + 11.923707 * x * x
     .       - 0.1970501 * x * x * x
      ei(x) = -390.8635 + 58.474495 * x -2.910997 * x * x
     .       + 0.048133829 * x * x * x
      gi(x) = 35.012574 - 5.24202 * x + 0.26109962 * x * x
     .       -4.319238e-3 * x * x * x
c
c Fit for (Erad-13.6)*svion Net hydrogenic  energy loss / ionization

      ae(x) = 2860.4173 - 610.2452 * x + 48.275821 * x * x
     .   -1.687994 * x * x * x + 0.02201375 * x * x * x * x
      be(x) = 10612.067 - 2046.397 * x + 147.73914 * x * x
     .       - 4.729973 * x * x * x + 0.056671796 * x * x * x * x
      ce(x) = -4.231708e4 + 8494.6102 * x - 639.0226 * x * x
     . + 21.350311 * x * x * x -0.2673466 * x * x * x * x
      de(x) = -8.385144e3 + 1887.6244 * x -157.8502 * x * x
     .  + 5.820501 * x * x * x - 0.07992837 * x * x * x * x
      ee(x) = 3.938282e4 -8.131339e3 * x + 628.8119 * x * x
     . -21.58636 * x * x * x + 0.27756029 * x * x * x * x
      ge(x) = -1.038281e4 + 2.1349333e3 * x -164.4201 * x * x
     .  + 5.6210487 * x * x * x - 0.07197622 * x * x * x * x
c
      sionfl(x,y) = 10**( ai(x)+bi(x)*y+ci(x)*y*y+di(x)*y*y*y
     .                 + ei(x)*y*y*y*y + gi(x)*y*y*y*y*y )
c
      etai(x,y) =( 10**( ae(x)+be(x)*y+ce(x)*y*y+de(x)*y*y*y
     .                 + ee(x)*y*y*y*y + ge(x)*y*y*y*y*y ) )
     .           / sionfl(x,y)
c
c *************************************************************
c
      x = min(22.e0,log10(den))
      y = log10(temp)
c
c
c Above 100eV, etai is constant at the 100eV value
c
      svradp = max( 0.e0,(13.6e0+etai(x,min(2.e0,y))) ) * 
     .         1.602e-19 * sionfl(x,y)
c
      return
      end

c----------------------------------------------------------------------c

      real function svdiss (te)
      use Physical_constants    ! ev

c     Compute rate parameter for molecular dissociation by electrons
c        input:  te [J]   =  electron temperature (J)
c        output: svdiss   = <sigma v> (m**3/s)

c     Polynomial fit from HYDHEL data file of EIRENE Monte Carlo code,
c     reaction number 2.2.5, attributed to preprint by Janev.

c     local variables --
      implicit none
      real te

      real logt, logsv
      real b0,b1,b2,b3,b4,b5,b6,b7,b8

      b0 = -2.787217511174e+01
      b1 =  1.052252660075e+01
      b2 = -4.973212347860e+00   
      b3 =  1.451198183114e+00
      b4 = -3.062790554644e-01
      b5 =  4.433379509258e-02   
      b6 = -4.096344172875e-03
      b7 =  2.159670289222e-04
      b8 = -4.928545325189e-06   

      logt = log (te/ev)
      logsv = b0+logt*(b1+logt*(b2+logt*(b3+logt*(b4
     .          +logt*(b5+logt*(b6+logt*(b7+logt*b8)))))))
      svdiss = (1e-6)*exp(logsv)
      return
      end

c----------------------------------------------------------------------c

#include "../mppl.h"
c     ------------------------------------------------------------------

      subroutine inflx
      use Share             ! geometry,nycore,nysol,nyout,isfrc
      use Dim               ! nxpt
      use Xpoint_indices 
      use Dimflxgrd 	!jdim,npts,nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Dimflx 	!nsearch
      use Polflx            ! mrfac
      use Flxin             ! psi0sep1,psi0sep2,iseqdskr

c     This subroutine allocates arrays, sets some indices and reads the
c     eqdsk files.

c     Set the number of x-points in the mesh:
      implicit none
      if (geometry=="dnull") then
         nxpt = 2
      else
         nxpt = 1
      endif
      call gchange("Xpoint_indices",0)
 
! Read EFIT data from aeqdsk and neqdsk files
      if (mdsefit .eq. 0) then 
         call readefit
      endif
! Set contour data array dimensions
      npts = 4*mrfac*(nxefit+nyefit)
      if (nycore(igrid) .eq. 0) then
         nsearch = 2
      else
         nsearch = 4
      endif
      if (kymesh==0 .or. geometry=="dnull") then
         nym = nycore(igrid) + nysol(igrid) + nyout(igrid)
      else
         nym = nycore(igrid) + nysol(igrid)
      endif
      jdim = 2*(nym+1) + 1       ! includes magnetic axis point
! Allot storage space for arrays
      call gchange("Comflxgrd",0)
      call gallot("Inpf0",0)
      call gallot("Inpf",0)
      call gallot("Polflx",0)
      call gchange("Flxin",0)    ! save existing psitop,psibot when kymesh=0

! Set characteristic indices in radial direction
      jmin(1) = 1
      if (kymesh==0 .or. geometry=="dnull") then
c
c     psi0sep1 refers to the lower x-point
c     psi0sep2 refers to the upper x-point
cccMER NOTE: psi0sep1 and psi0sep2 must be supplied by the user; these
cccMER       both default to zero, in which case we get the usual
cccMER       results based on nycore and nysol (nyout=0 is default).
c
         if (iseqdskr==0) then  ! we are doing the lower half mesh
            if (psi0sep1 .gt. psi0sep2) then
               jsptrx(1) = jmin(1) + nyout(igrid)
               jmax(1) = jsptrx(1) + nysol(igrid) + nycore(igrid)
               jaxis = jmax(1) + 1
               jmin(2) = jaxis + 1
               jsptrx(2) = jmin(2) + nycore(igrid) + nysol(igrid)
               jmax(2) = jsptrx(2) + nyout(igrid)
            else
               jsptrx(1) = jmin(1) + nyout(igrid) + nysol(igrid)
               jmax(1) = jsptrx(1) + nycore(igrid)
               jaxis = jmax(1) + 1
               jmin(2) = jaxis + 1
               jsptrx(2) = jmin(2) + nycore(igrid)
               jmax(2) = jsptrx(2) + nysol(igrid) + nyout(igrid)
            endif
         else                   ! we are doing the upper half mesh
            if (psi0sep2 .gt. psi0sep1) then
               jsptrx(1) = jmin(1) + nyout(igrid)
               jmax(1) = jsptrx(1) + nysol(igrid) + nycore(igrid)
               jaxis = jmax(1) + 1
               jmin(2) = jaxis + 1
               jsptrx(2) = jmin(2) + nycore(igrid) + nysol(igrid)
               jmax(2) = jsptrx(2) + nyout(igrid)
            else
               jsptrx(1) = jmin(1) + nyout(igrid) + nysol(igrid)
               jmax(1) = jsptrx(1) + nycore(igrid)
               jaxis = jmax(1) + 1
               jmin(2) = jaxis + 1
               jsptrx(2) = jmin(2) + nycore(igrid)
               jmax(2) = jsptrx(2) + nysol(igrid) + nyout(igrid)
            endif
         endif  ! end if-test on iseqdskr
      else  ! use only nycore and nysol for kymesh > 0
         jsptrx(1) = jmin(1) + nysol(igrid)
         jmax(1) = jsptrx(1) + nycore(igrid)
         jaxis = jmax(1) + 1	! There is a dummy surface
				! between jmax(1) and jmin(2)
				! that represents the magnetic axis.
         jmin(2) = jaxis + 1
         jsptrx(2) = jmin(2) + nycore(igrid)
         jmax(2) = jsptrx(2) + nysol(igrid)
      endif  ! end if-test on kymesh and geometry

! Special coding for field-reversed configuration
      if (isfrc==1) jmin(1)=jsptrx(1)

! Define flux contour values
      call inflx1

      return
      end

c     ------------------------------------------------------------------

      subroutine readefit
      implicit none

c     read in aeqdsk file from EFIT code --
      call aeqdsk

c     read in neqdsk file from EFIT code --
      call neqdsk

      call procefit

      return
      end

c     ------------------------------------------------------------------

      subroutine procefit
      use Dim 
      use Dimflxgrd 	!jdim,nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Share 
      use Aeqflxgrd 
      use Flxin     ! iseqdskr
      implicit none
      integer i, j
      real dxdim, dydim
      real B2VAhL
      external B2INhT, B2VAhL

      if (geometry=="uppersn" .or. iseqdskr==1) call convert_eqdsk

c...  Now can pass simagxs and sibdrys to Share group for use in other pkgs
      simagxs = simagx
      sibdrys = sibdry

c   rcentr = major radius of the point where btoroidal = bcentr
c   rgrid1 = distance between major axis and the left side of
c   EFIT computational grid

c     Reconstruct the EFIT mesh -- with shift of vertical coordinate
      dxdim=xdim/(nxefit-1)
      dydim=zdim/(nyefit-1)
      do 10 i=1,nxefit
         xold(i)=(i-1)*dxdim+rgrid1
  10  continue
      do 20 j=1,nyefit
         yold(j)=(j-1)*dydim
 20   continue

c     Construct the 2-d spline interpolant for the flux
      call s2copy (nxefit,nyefit,fold,1,nxefit,bscoef,1,nxefit) 
      ldf = nxefit
      iflag = 1	! let B2INhT define the knots
      call B2INhT (xold, nxefit, yold, nyefit, kxord, kyord,
     .             xknot, yknot, bscoef, ldf, work, iflag)

c     shift vertical coordinate data from EFIT so as to make z=0 at the
c     bottom of the mesh (as in definition of yold above) --
      zshift = zdim/2. - zmid
      do 8 i=1,nbdry
         zbdry(i) = zbdry(i) + zshift
    8 continue
      do 9 i=1,nlim
         ylim(i)  = ylim(i)  + zshift
    9 continue
      zmid    = zmid   + zshift
      zmagx   = zmagx  + zshift
      zseps   = zseps  + zshift
      zseps2  = zseps2 + zshift
      zvsin   = zvsin  + zshift
      zvsout  = zvsout + zshift

      rseps1 = rseps
      zseps1 = zseps
c     compute the flux value, sibdry1, at the lower x-point --
      if (rseps1 .gt. 0) then
         sibdry1 = B2VAhL(rseps1, zseps1, 0, 0, xknot, yknot, nxefit,
     .              nyefit, kxord, kyord, bscoef, ldf, work, iflag)
      endif

c     compute the flux value, sibdry2, at the upper x-point --
      if (rseps2 .gt. 0) then
         sibdry2 = B2VAhL(rseps2, zseps2, 0, 0, xknot, yknot, nxefit,
     .              nyefit, kxord, kyord, bscoef, ldf, work, iflag)
      endif

      return
      end

c     ------------------------------------------------------------------

      subroutine aeqdsk
      use Aeqflxgrd    ! vmonth,vday,vyear
              ! eshot,etime
              ! mco2v,mco2r
              ! rseps,zseps,rseps2,zseps2
              ! rvsin,zvsin,rvsout,zvsout
              ! nsilop,magpri,nfcoil,nesum

! The array dimensioning parameters nsilop, magpri, nfcoil and nesum
! are defaulted to DIII-D values as of 10/15/92.
!
! The format for the aeqdsk and neqdsk files is given in the file
! and dimensioning declarations contained in files efit:parmd.for
! and efit:ecomd1.for and efit:ecomd2.for.
!
      implicit none
      integer ktime1, jflag, lflag
! Change to magpri=29 for old aeqdsk files (e.g., APS '88 work)
! Change to nsilop=26, magpri=26, nfcoil=13 and nesum=3 for C-MOD
! efit:weqdsk.for on the GA VAX's.  One also needs the parameter
      character*10 uday
      character*3 limloc
      character*3 qmflag
      integer iunit, ios
      integer efitvers
      external efitvers

c ***************** read the output of the EFIT code *****************
      data iunit /55/
      open (iunit, file='aeqdsk', form='formatted', iostat=ios,
     .      status='old')
      if (ios .ne. 0) then
         call remark("**** aeqdsk file not found")
         call kaboom(0)
      endif

        read (iunit,1056) uday,vmonth,vday,vyear
c       Convert from 2-digit to 4-digit year for old EFIT --
        if ( (75 .le. vyear) .and. (vyear .le. 99) ) then
           vyear = 1900 + vyear
        endif
c       Special case is the widely-used ITER aeqdsk file, aeqibm1,
c       which contains a faulty day and date format --
        if (uday=="06.1./94  ") then
           vday = 12
           vmonth = 6
           vyear = 1994
        endif
        read (iunit,*) eshot,ktime1
        read (iunit,1040) etime
c     The following allows for the possibility of reading 2 additional
c     flags from newer versions of EFIT, but the read statement has
c     not yet been changed here (MER 97/06/03).
      if (efitvers(vmonth,vday,vyear) .ge. 1) then
        read (iunit,1060) etime,jflag,lflag,limloc,mco2v,mco2r,qmflag
      else
        read (iunit,1060) etime,jflag,lflag,limloc,mco2v,mco2r,qmflag
      endif

        call gchange("Aeqflxgrd",0)

        call aeqdsk1(iunit)

      close (iunit)

c     convert coordinate units from [cm] to [m] --
      rseps  = .01 * rseps
      zseps  = .01 * zseps
      rseps2 = .01 * rseps2
      zseps2 = .01 * zseps2
      rvsin  = .01 * rvsin
      zvsin  = .01 * zvsin
      rvsout = .01 * rvsout
      zvsout = .01 * zvsout

c     NOTE : simagx and sibdry flux values from aeqdsk and neqdsk
c            have opposite signs; the neqdsk values are consistent
c            with the EFIT flux array, fold(xold,yold).

 1040 format (1x,4e16.9)
 1050 format (1x,i5,11x,i5)
 1056 format (1x,a10,i2,1x,i2,1x,i4)
 1060 format (1x,f7.2,10x,i5,11x,i5,1x,a3,1x,i3,1x,i3,1x,a3)

      return
      end

c     ------------------------------------------------------------------

      subroutine aeqdsk1 (iunit)
      use Aeqflxgrd    ! rseps,zseps,rseps2,zseps2
              ! rvsin,zvsin,rvsout,zvsout
              ! nsilop,magpri,nfcoil,nesum
      implicit none
      integer iunit, k
      real tsaisq, rcencm, bcentr, pasmat, cpasma, rout, zout
      real aout, eout, doutu, doutl, vout, rcurrt, zcurrt, qsta
      real betat, betap, ali, oleft, oright, otop, obott, qpsib
      real vertn, shearb, bpolav, s1, s2, s3, qout, olefs, orighs
      real otops, sibdry, areao, wplasm, terror, elongm, qqmagx
      real cdflux, alpha, rttt, psiref, xndnt, sepexp, obots
      real btaxp, btaxv, aaq1, aaq2, aaq3, seplim, rmagx, zmagx
      real simagx, taumhd, betapd, betatd, wplasmd, fluxx, vloopt
      real taudia, qmerci, tavem, pbinj, vsurfa, wpdot, wbdot
      real slantu, slantl, zuperts, chipre, cjor95, pp95, xdum
      real xxxxxx, xxx
      character*42 header
      integer efitvers
      external efitvers

        read (iunit,1040) tsaisq,rcencm,bcentr,pasmat
        read (iunit,1040) cpasma,rout,zout,aout
        read (iunit,1040) eout,doutu,doutl,vout
        read (iunit,1040) rcurrt,zcurrt,qsta,betat
        read (iunit,1040) betap,ali,oleft,oright
        read (iunit,1040) otop,obott,qpsib,vertn
        read (iunit,1040) (rco2v(k),k=1,mco2v)
        read (iunit,1040) (dco2v(k),k=1,mco2v)
        read (iunit,1040) (rco2r(k),k=1,mco2r)
        read (iunit,1040) (dco2r(k),k=1,mco2r)
        read (iunit,1040) shearb,bpolav,s1,s2
        read (iunit,1040) s3,qout,olefs,orighs
        read (iunit,1040) otops,sibdry,areao,wplasm
        read (iunit,1040) terror,elongm,qqmagx,cdflux
        read (iunit,1040) alpha,rttt,psiref,xndnt
        read (iunit,1040) rseps,zseps,rseps2,zseps2
        read (iunit,1040) sepexp,obots,btaxp,btaxv
        read (iunit,1040) aaq1,aaq2,aaq3,seplim
        read (iunit,1040) rmagx,zmagx,simagx,taumhd
        read (iunit,1040) betapd,betatd,wplasmd,fluxx
        read (iunit,1040) vloopt,taudia,qmerci,tavem
        if (efitvers(vmonth,vday,vyear) .ge. 1) 
     .     read (iunit,1044) nsilop,magpri,nfcoil,nesum
        call gchange("Aeqflxgrd",0)
        call aeqdsk2 (iunit)
        read (iunit,1040) pbinj,rvsin,zvsin,rvsout
        read (iunit,1040) zvsout,vsurfa,wpdot,wbdot
        read (iunit,1040) slantu,slantl,zuperts,chipre
        read (iunit,1040) cjor95,pp95,xdum,xdum
        read (iunit,1040) xxxxxx,xxx,xxx,xxx
        read (iunit,1042) header

 1040 format (1x,4e16.9)
 1042 format (1x,a42)
 1044 format (1x,4i5)

      return
      end

c     ------------------------------------------------------------------

      subroutine aeqdsk2 (iunit)
      use Aeqflxgrd 

      implicit none
      integer iunit,k
        read (iunit,1040) (csilop(k),k=1,nsilop),(cmpr2(k),k=1,magpri)
        read (iunit,1040) (ccbrsp(k),k=1,nfcoil)
        read (iunit,1040) (eccurt(k),k=1,nesum)

 1040 format (1x,4e16.9)

      return
      end

c     ------------------------------------------------------------------

      integer function efitvers (month, day, year)
      implicit none
      integer month, day, year

      efitvers = 0

c     New version of EFIT on 05/24/97 writes aeqdsk that includes
c     data values for parameters nsilop,magpri,nfcoil and nesum.
      if ( ((year .eq. 1997).and.(month .eq. 05).and.(day .ge. 24))
     .      .or. ((year .eq. 1997).and.(month .gt. 05))
     .      .or. (year .gt. 1997) ) efitvers = 1

      return
      end

c     ------------------------------------------------------------------

      subroutine neqdsk
      use Dimflxgrd 	!jdim,npts,nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Polflx 
      implicit none
      integer i, idum
      integer iunit, ios
      external gallot, kaboom, remark
      character*8 label(6)

c *************** read the output of the EFIT code ******************
      data iunit /55/
      open (iunit, file='neqdsk', form='formatted', iostat=ios,
     .      status='old')
      if (ios .ne. 0) then
         call remark("**** neqdsk file not found")
         call kaboom(0)
      endif

      read(iunit,2000) (label(i),i=1,6),idum,nxefit,nyefit
      runid=label(1)//label(2)//label(3)//label(4)//label(5)//label(6)

c     set length for 2-d spline workspace --
      nwork = nxefit*nyefit + 2*max(kxord*(nxefit+1),kyord*(nyefit+1))
      call gallot("Comflxgrd",0)
      nx4 = mrfac*(nxefit-1) + 1
      ny4 = mrfac*(nyefit-1) + 1
      call gallot("Polflx",0)
      call rdgrp1(iunit)

      read(iunit,2022) nbdry,nlim
      call gchange("Comflxgrd",0)
      call rdgrp2(iunit)

      close (iunit)

 2000 format(6a8,3i4)
 2022 format(2i5)

      return
      end

c     ------------------------------------------------------------------

      subroutine rdgrp1(iunit)
      use Dimflxgrd 	!nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      implicit none
      integer iunit
      real xdum
      integer i, j
      read(iunit,2020) xdim,zdim,rcentr,rgrid1,zmid
      read(iunit,2020) rmagx,zmagx,simagx,sibdry,bcentr
      read(iunit,2020) cpasma,simagx,xdum,rmagx,xdum
      read(iunit,2020) zmagx,xdum,sibdry,xdum,xdum
      read(iunit,2020) (fpol(i),i=1,nxefit)
      read(iunit,2020) (pres(i),i=1,nxefit)
      read(iunit,2020) (workk(i),i=1,nxefit)
      read(iunit,2020) (workk(i),i=1,nxefit)
      read(iunit,2020) ((fold(i,j),i=1,nxefit),j=1,nyefit)
      read(iunit,2020) (qpsi(i),i=1,nxefit)
 2020 format(5e16.9)

      return
      end

c     ------------------------------------------------------------------

      subroutine rdgrp2(iunit)
      use Dimflxgrd 	!nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      integer iunit
      integer i

      read(iunit,2020) (rbdry(i),zbdry(i),i=1,nbdry)
      read(iunit,2020) (xlim(i),ylim(i),i=1,nlim)
 2020 format(5e16.9)

      return
      end

c     ------------------------------------------------------------------

      subroutine convert_eqdsk
      use Share     ! geometry
      use Dimflxgrd 	!nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Aeqflxgrd 
      implicit none
      integer i,j
      real temp,tempr,tempz

c     This subroutine converts eqdsk data for an upper-single-null
c     configuration to make it look like a lower-single-null.
c     Effectively, the observer is rotated by 180 degrees about
c     the midplane of the EFIT domain, so (R,Z)-->(R,-Z) and the
c     signs of the toroidal current and magnetic field are reversed.

      zseps  = 2*zmid - zseps
      zseps2 = 2*zmid - zseps2
      zmagx  = 2*zmid - zmagx
      zvsin  = 2*zmid - zvsin
      zvsout = 2*zmid - zvsout
      do i=1,nlim
         ylim(i) = 2*zmid - ylim(i)
      enddo
      do i=1,nbdry
         zbdry(i) = 2*zmid - zbdry(i)
      enddo

C     Change signs of toroidal current and magnetic field:
      cpasma = - cpasma
      bcentr = - bcentr

c     Change poloidal magnetic flux data:
c        (1) interchange top and bottom
c        (2) change sign of psi
      do i=1,nxefit
         do j=1,nyefit/2
            temp = fold(i,j)
            fold(i,j) = - fold(i,nyefit-j+1)
            fold(i,nyefit-j+1) = - temp
         enddo
c     if nyefit is odd, middle row must be treated separately:
         if (mod(nyefit,2) .eq. 1) then
            fold(i,nyefit/2+1) = - fold(i,nyefit/2+1)
         endif
      enddo
      simagx = - simagx

c     Interchange upper and lower x-point data:
      if ( (geometry=="dnbot") .or. (geometry=="dnull") .or.
     .     (geometry=="isoleg") ) then
c     We're doing the upper half of a double-null configuration
         sibdry = - sibdry2
      else
c     We're doing an upper single-null configuration
         sibdry = - sibdry
      endif

      tempr=rseps
      tempz=zseps
      rseps=rseps2
      zseps=zseps2
      rseps2=tempr
      zseps2=tempz

      return
      end

c     ------------------------------------------------------------------

      subroutine inflx1
      use Share       ! geometry,islimon,theta_split
      use Dim 
      use Dimflxgrd 	!jdim,npts,nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Dimflx 	!nsearch
      use Inpf0 	! istcvon,altsearch,isetpath
      use Inpf 
      use Aeqflxgrd 
      use Polflx 
      use Flxin       ! psi0lim,sfaclim,kymesh,xcutoff1,icutoff1,
                ! ycutoff1,jcutoff1,ymax1fac,ymax2fac
      use Limiter     ! nlimu,rlimu,zlimu,nptnma,rptnma,zptnma

c     local variables --
      implicit none
      integer i, j, n, ns, nmax, nc2, nc3
      real dxefit, dyefit, alfcy_outer, alfold, alfnew, b
      real eps, dpsidt_inner, dpsidt_outer
      real t1, t2, t3, r1, r2, r3, r2p, dx, dy, pi, twopi

      external remark, kaboom, rho1

      data nmax /30/	! maximum number of newton iterations for alfcy
      data eps /1.0e-10/	! convergence criterion for alfcy

      psi0max_outer = psi0max
      alfcy_outer   = alfcy
! For single-null, ensure that SOL flux contours have same
! values on inboard and outboard halves of mesh:
      if ((geometry .eq. 'snull').or.(geometry .eq. "uppersn")) then
         psi0max_inner = psi0max_outer
         alfcy_inner = alfcy_outer
      endif

! Check psi0max to avoid possible upper x-point for single nulls
      if (((geometry .eq. 'snull').or.(geometry .eq. "uppersn"))
     &          .and. (rseps2 .gt. 0)) then
         psi0sep2 = (sibdry2-simagx)/(sibdry-simagx)
         if (psi0max .gt. psi0sep2) then
	    psi0max = 0.999 * psi0sep2
	    call remark(" ")
	    call remark("***    a second x-point exists    ***")
	    call remark("***  psi0max has been re-defined  ***")
	    call remark(" ")
	    write (STDOUT,801) psi0max
 801        format (5x,"psi0max = ",1p1e14.6)
	    call remark(" ")
            psi0max_inner = psi0max
            psi0max_outer = psi0max
	 endif
      endif

c     Flux contour values for radial mesh:
c----------------------------------------------------------------------c
      if (kymesh==0) then   ! use existing psitop and psibot arrays
c----------------------------------------------------------------------c
         continue
c----------------------------------------------------------------------c
      else                  ! compute new psitop and psibot arrays
c----------------------------------------------------------------------c
! Define distribution of radial mesh points via analytic function
! rho(t) where t is mesh index and rho is normalized flux.
      do i=0,nym
         tflx(i) = i
      enddo
      t1 = tflx(0)
      t2 = tflx(nycore(igrid))
      t3 = tflx(nycore(igrid)+nysol(igrid))

c     Set some parameters for various mesh forms:
      if (kymesh==1) then ! Set SOL exponential factors

! First, to avoid overflow from 1/sinh(alfcy):
        alfcy_outer = max (alfcy_outer, 1.0e-07)
        alfcy_inner = max (alfcy_inner, 1.0e-07)
! When psi0max_inner differs from psi0max_outer we ensure that the core 
! (and  private-flux) distributions on the two halves of the mesh are
! the same by requiring that d(psi)/d(t) at the separatrix has the same
! value on the inboard and outboard halves of the mesh.
        dpsidt_outer = ((psi0max_outer - psi0sep)/(t3-t2))
     &               * alfcy_outer / sinh (alfcy_outer)
        dpsidt_inner = ((psi0max_inner - psi0sep)/(t3-t2))
     &               * alfcy_inner / sinh (alfcy_inner)
        if (psi0max_outer .eq. psi0max_inner) then	! use alfcy_outer
         alfcy_inner = alfcy_outer			! for both halves
         if ( (geometry .eq. 'dnbot').or.(geometry .eq. 'dnull') .or.
     .        (geometry == 'isoleg') ) then
	    call remark(" ")
            call remark("***  alfcy_inner is set to alfcy_outer  ***")
	    call remark(" ")
            write (STDOUT,804) alfcy_inner
 804        format (5x,"alfcy_inner = ",1p1e14.6)
	    call remark(" ")
         endif
        elseif (psi0max_outer .lt. psi0max_inner) then	! re-compute alfcy_inner
	 b = ((psi0max_outer - psi0sep)/(psi0max_inner - psi0sep))
     &       * alfcy_outer / sinh (alfcy_outer)
	 alfold = 1.1 * log ((1+sqrt(1-b**2))/b)	! this initial guess
							! ensures the non-zero
							! root is obtained
	 do n=1,nmax
	    alfnew = alfold - (alfold-b*sinh(alfold))/(1.-b*cosh(alfold))
	    if (abs((alfnew-alfold)/alfcy_outer) .le. eps) goto 555
	    alfold = alfnew
	 enddo
  555    alfcy_inner = alfnew     
	 call remark(" ")
         call remark("***  alfcy_inner has been re-defined  ***")
	 call remark(" ")
         write (STDOUT,802) alfcy_inner
 802     format (5x,"alfcy_inner = ",1p1e14.6)
	 call remark(" ")
        elseif (psi0max_inner .lt. psi0max_outer) then	! re-compute alfcy_outer
	 b = ((psi0max_inner - psi0sep)/(psi0max_outer - psi0sep))
     &       * alfcy_inner / sinh (alfcy_inner)
	 alfold = 1.1 * log ((1+sqrt(1-b**2))/b)	! this initial guess
							! ensures the non-zero
							! root is obtained
	 do n=1,nmax
	    alfnew = alfold - (alfold-b*sinh(alfold))/(1.-b*cosh(alfold))
	    if (abs((alfnew-alfold)/alfcy_inner) .le. eps) goto 666
	    alfold = alfnew
	 enddo
  666    alfcy_outer = alfnew
         alfcy = alfcy_outer     
	 call remark(" ")
         call remark("***  alfcy has been re-defined  ***")
	 call remark(" ")
         write (STDOUT,803) alfcy
 803     format (5x,"alfcy = ",1p1e14.6)
	 call remark(" ")
        endif

      elseif (kymesh==2) then   ! Set radial mesh slope factor at separatrix
        r2p = (psi0sep-psi0min1)/real(nycore(igrid))   ! rho'(t2)
      endif     ! end if-test on kymesh for setting mesh parameters

! For inboard half of mesh:
! In core region + SOL
      t1 = tflx(0)
      t2 = tflx(nycore(igrid))
      t3 = tflx(nycore(igrid)+nysol(igrid))
      r1 = psi0min1
      r2 = psi0sep
      r3 = psi0max_inner
      if (kymesh==1) then    ! rational + exponential function rho1(t)
         call rho1(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,alfcy_inner)
      elseif (kymesh==2) then ! uniform radial mesh in core 
         call rho5(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,r2p)
      endif
! Core region may be modified for limiter configuration --
      if ((islimon .ne. 0) .and. (sfaclim .ne. 1.) .and.
     .    (psi0lim .le. psi0sep) .and. (psi0lim .ge. psi0min1)) then
         nc2 = int(((psi0lim-psi0min1)/(psi0sep-psi0min1))*nycore(igrid))
         nc3 = nycore(igrid)
         t1 = tflx(0)
         t2 = tflx(nc2)
         t3 = tflx(nc3)
         r1 = psi0min1
         r2 = psi0lim
         r3 = psi0sep
         call rho4(tflx,rho,nc3+1,t1,t2,t3,r1,r2,r3,sfaclim)
      endif
      do i=0,nym
	 psitop(i+1) = simagx+(sibdry-simagx)*rho(nym-i)
      enddo
      psitop(nym+2) = simagx

! In private region + SOL
      t1 = tflx(0)
      t2 = tflx(nycore(igrid))
      t3 = tflx(nycore(igrid)+nysol(igrid))
      r1 = psi0min2
      r2 = psi0sep
      r3 = psi0max_inner
      if (kymesh==1) then    ! rational + exponential function rho1(t)
         call rho1(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,alfcy_inner)
      elseif (kymesh==2) then ! uniform radial mesh in core 
         call rho5(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,r2p)
      endif
      do i=0,nym
	 psibot(i+1) = simagx+(sibdry-simagx)*rho(nym-i)
      enddo
      psibot(nym+2) = simagx

! For outboard half of mesh:
! In core region + SOL
      t1 = tflx(0)
      t2 = tflx(nycore(igrid))
      t3 = tflx(nycore(igrid)+nysol(igrid))
      r1 = psi0min1
      r2 = psi0sep
      r3 = psi0max_outer
      if (kymesh==1) then    ! rational + exponential function rho1(t)
         call rho1(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,alfcy_outer)
      elseif (kymesh==2) then ! uniform radial mesh in core 
         call rho5(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,r2p)
      endif
! Core region may be modified for limiter configuration --
      if ((islimon .ne. 0) .and. (sfaclim .ne. 1.) .and.
     .    (psi0lim .le. psi0sep) .and. (psi0lim .ge. psi0min1)) then
         nc2 = int(((psi0lim-psi0min1)/(psi0sep-psi0min1))*nycore(igrid))
         nc3 = nycore(igrid)
         t1 = tflx(0)
         t2 = tflx(nc2)
         t3 = tflx(nc3)
         r1 = psi0min1
         r2 = psi0lim
         r3 = psi0sep
         call rho4(tflx,rho,nc3+1,t1,t2,t3,r1,r2,r3,sfaclim)
      endif
      do i=0,nym
	 psitop(jdim-i) = simagx+(sibdry-simagx)*rho(nym-i)
      enddo

! In private region + SOL
      t1 = tflx(0)
      t2 = tflx(nycore(igrid))
      t3 = tflx(nycore(igrid)+nysol(igrid))
      r1 = psi0min2
      r2 = psi0sep
      r3 = psi0max_outer
      if (kymesh==1) then    ! rational + exponential function rho1(t)
         call rho1(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,alfcy_outer)
      elseif (kymesh==2) then ! uniform radial mesh in core 
         call rho5(tflx,rho,nym+1,t1,t2,t3,r1,r2,r3,r2p)
      endif
      do i=0,nym
	 psibot(jdim-i) = simagx+(sibdry-simagx)*rho(nym-i)
      enddo
c----------------------------------------------------------------------c
      endif ! end if-test on kymesh
c----------------------------------------------------------------------c

! define some search bounds for contouring -
      xlbnd = max(rgrid1,xcutoff1)
      xubnd = rgrid1+xdim
      ylbnd = max(0.,ycutoff1)
      yubnd = zdim
      pi = 4*atan2(1.,1.)
      twopi = 2*pi
      if (islimon .ne. 0) then  ! compute theta_split
         istchkon=1
         if (nlimu .lt. 2) then
            call remark("***")
            call remark("*** inflx1: limiter surface r,zlimu not defined")
            call remark("***")
            call kaboom(1)
         endif
         ! find point on limiter that is nearest the magnetic axis:
         call findptnma(nlimu,rlimu,zlimu,rmagx,zmagx,
     .                                    nptnma,rptnma,zptnma)
         ! define poloidal angle to limiter contact point:
         theta_split=atan2 (zptnma-zmagx, rptnma-rmagx)
      endif
      if (istchkon .gt. 0) then
         ! do not limit radial search in regions 1 and 2:
         xoverlap(1)=1000
         xoverlap(2)=1000
         ! compute angular bounds:
         thetax = atan2 (zseps-zmagx, rseps-rmagx)
         if ( (geometry=="dnbot" .or. geometry=="dnull" .or.
     .         geometry=="isoleg") .and. isthmmxn==1) then
            thetamin(1)=pi-dtheta_overlap_sol(1)
            thetamax(2)=twopi+dtheta_overlap_sol(2)
         else
            thetamin(1)=theta_split-dtheta_overlap_sol(1)
            thetamax(2)=theta_split+dtheta_overlap_sol(2)
         endif
         thetamax(1)=thetamin(1)+twopi-dtheta_exclude(1)
         thetamin(2)=thetamax(2)-twopi+dtheta_exclude(2)
      endif

! minimum and maximum cell indices on the refined EFIT grid --
      imin = 1
      imax = mrfac*(nxefit-1)+1
      jmins = 1
      jmaxs = mrfac*(nyefit-1)+1

! define indices of cells containing the magnetic axis and the x-point :
      dxefit = xdim/(nxefit-1)
      dyefit = zdim/(nyefit-1)
      dx = dxefit/real(mrfac)
      dy = dyefit/real(mrfac)
      imagx = (rmagx-rgrid1)/dx+1
      jmagx = (zmagx)/dy+1
      iseps = (rseps-rgrid1)/dx+1
      jseps = (zseps)/dy+1
      icutoff1 = max(0.,xcutoff1-rgrid1)/dx+1
      jcutoff1 = max(0.,ycutoff1)/dy+1


      ns=0    ! temporary counter for number of search regions
      ns=ns+1
! Search region 1 (inboard half of scrape-off layer and core plasma) :
      ncmin0(ns) = jmin(1)
      ncmax0(ns) = jmax(1)
      do n=1,ncmax0(ns)-ncmin0(ns)+1
         plflux0(n,ns) = psitop(ncmin0(ns)+n-1)
      enddo
      xminf0(ns) = xlbnd
      xmaxf0(ns) = min( xubnd, max(rmagx,rseps)+xoverlap(1)*dxefit )
      yminf0(ns) = ylbnd
      if ((geometry .eq. 'snull').or.(geometry .eq. "uppersn")) then
         ymaxf0(ns) = yubnd
      else
         ymaxf0(ns) = ymax1fac*zmagx + 5*dyefit
      endif
! Set initial search position and direction:
      if (isetpath==0) then   ! search radially outward from left boundary
      iserch0(ns) = icutoff1
      jserch0(ns) = jmagx
      istepf0(ns) = 1
      jstepf0(ns) = 0
      else                    ! search radially inward from magnetic axis
      iserch0(ns) = imagx
      jserch0(ns) = jmagx
      istepf0(ns) = -1
      jstepf0(ns) = 0
      endif

      if (nycore(igrid) .gt. 0) then
         ns=ns+1
! Search region 2 (inboard half of divertor triangle) :
	 ncmin0(ns) = jsptrx(1) + 1
	 ncmax0(ns) = jmax(1)
         do n=1,ncmax0(ns)-ncmin0(ns)+1
            plflux0(n,ns) = psibot(ncmin0(ns)+n-1)
         enddo
         xminf0(ns) = xlbnd
         xmaxf0(ns) = min( xubnd, rseps+xoverlap(1)*dxefit )
	 yminf0(ns)=ylbnd
	 ymaxf0(ns) = ymax2fac*zseps
cccMER (28 Mar 2002) fix for Ignitor config'n with inner strike pt above xpt
ccc	 ymaxf0(ns)=zseps
cccTDR (24 Feb 2008) fix for snowflake
ccc	 ymaxf0(ns)=zseps*1.1
! Set initial search position and direction:
         if (istcvon==1) then
            write(*,*) "**WARNING: istcvon=1 OBSOLETE; setting altsearch=2"
            altsearch = 2
         endif
         if (altsearch==0) then       ! search upward toward x-point
            iserch0(ns) = iseps
            jserch0(ns) = jcutoff1
            istepf0(ns) = 0
            jstepf0(ns) = 1
         elseif (altsearch==1) then   ! search downward from x-point
            iserch0(ns) = iseps
            jserch0(ns) = jseps
            istepf0(ns) = 0
            jstepf0(ns) = -1
         elseif (altsearch==2) then   ! search diagonally from x-point
            iserch0(ns) = iseps
            jserch0(ns) = jseps
	    istepf0(ns) = -2          ! MER (28 Aug 2012) fix for NSTX
            jstepf0(ns) = -1
         endif
      endif  ! end if-test on nycore for region 2

      ns=ns+1
! Search region 3 (outboard half of core plasma and scrape-off layer) :
      ncmin0(ns) = jmin(2)
      ncmax0(ns) = jmax(2)
      do n=1,ncmax0(ns)-ncmin0(ns)+1
         plflux0(n,ns) = psitop(ncmin0(ns)+n-1)
      enddo
      xmaxf0(ns) = xubnd
      xminf0(ns) = max( xlbnd, min(rmagx,rseps)-xoverlap(2)*dxefit )
      yminf0(ns) = ylbnd
      if ((geometry .eq. 'snull').or.(geometry .eq. "uppersn")) then
         ymaxf0(ns) = yubnd
      else
         ymaxf0(ns) = zmagx + 5*dyefit
      endif
! Set initial search position and direction:
      iserch0(ns) = imagx+1
      jserch0(ns) = jmagx
      istepf0(ns) = 1
      jstepf0(ns) = 0

      if (nycore(igrid) .gt. 0) then
         ns=ns+1
! Search region 4 (outboard half of divertor triangle) 
	 ncmin0(ns) = jmin(2)
	 ncmax0(ns) = jsptrx(2) - 1
         do n=1,ncmax0(ns)-ncmin0(ns)+1
            plflux0(n,ns) = psibot(ncmin0(ns)+n-1)
         enddo
         xminf0(ns) = max( xlbnd, rseps-xoverlap(2)*dxefit )
         xmaxf0(ns) = xubnd
	 yminf0(ns) = ylbnd
	 ymaxf0(ns) = zseps
! Set initial search position and direction:
         if (istcvon==1) then
            write(*,*) "**WARNING: istcvon=1 OBSOLETE; setting altsearch=2"
            altsearch = 2
         endif
         if (altsearch==0) then       ! search upward toward x-point
            iserch0(ns) = iseps
            jserch0(ns) = jcutoff1
            istepf0(ns) = 0
            jstepf0(ns) = 1
         elseif (altsearch==1) then   ! search downward from x-point
            iserch0(ns) = iseps
            jserch0(ns) = jseps
            istepf0(ns) = 0
            jstepf0(ns) = -1
         elseif (altsearch==2) then   ! search diagonally from x-point
            iserch0(ns) = iseps
            jserch0(ns) = jseps
            istepf0(ns) = -2          ! MER (28 Aug 2012) fix for NSTX
            jstepf0(ns) = -1
         endif
      endif  ! end if-test on nycore for region 4

      if (ns .ne. nsearch) then
	 call remark(" ")
	 call remark("*** inflx1 : search region indexing error")
	 call remark(" ")
	 call kaboom(0)
      endif

      return
      end

c     ------------------------------------------------------------------

      subroutine rho1(t,rho,nt,t1,t2,t3,r1,r2,r3,alf)
      implicit none

c     input/output arguments --
      integer nt
      real rho(nt),r1,r2,r3,alf
      real t(nt),t1,t2,t3

c     local variables --
      integer n
      real epslon
      real a,b
      real r2p

c     procedures --
      external kaboom

c     initialization --
      data epslon /1.0e-7/

c     rho(t) is a rational function of the form (f+gt)/(p+qt) on
c     the interval t1 < t < t2 and has an exponential form on the 
c     interval t2 < t < t3 with continuous first derivative at t2.

      if (t3 .le. t2) then
         write (STDOUT,900)
         call kaboom(0)
      endif
  900 format("error in subroutine rho1; bad input parameters: t3 .le. t2")

      alf = max (epslon,alf)

      r2p = ((r3-r2)/(t3-t2)) * (2*alf)/(exp(alf)-exp(-alf))
      a = r2p * (t2-t1)**2 / (r2-r1)**2
      b = ((r2-r1) - r2p*(t2-t1)) / (r2-r1)**2

      do n = 1, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r1 + (t(n)-t1) / (a + b*(t(n)-t1))
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + r2p * ((t3-t2)/(2*alf)) *
     &           ( exp(+alf*(t(n)-t2)/(t3-t2)) -
     &             exp(-alf*(t(n)-t2)/(t3-t2)) )
         elseif (t3 .le. t(n)) then
            rho(n) = r3
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho1dn(t,rho,nt,t1,t2,t3,t4,r1,r2,r3,r4,alf)
      implicit none

c     input/output arguments --
      integer nt
      real rho(0:nt),r1,r2,r3,r4,alf
      real t(0:nt),t1,t2,t3,t4

c     local variables --
      integer n
      real epslon
      real a,b,c,d
      real r2p,r3p

c     initialization --
      data epslon /1.0e-10/

c     rho(t) is a rational function of the form (f+gt)/(p+qt) on
c     the interval t1 < t < t2 and also on the interval t2 < t < t3,
c     and has an exponential form on the interval t3 < t < t4
c     with rho(t) and rho'(t) continuous at t2 and t3.

      if (t4 .le. t3) then
         call remark("error in subroutine rho1dn; bad input parameters:")
         write (STDOUT,901) t4, t3
         call kaboom(0)
      endif
  901 format("t4=",f4.1," .le. t3=",f4.1)
      if (r2 .le. r1) then
         call remark("error in subroutine rho1dn; bad input parameters:")
         write (STDOUT,902) r2, r1
         call kaboom(0)
      endif
  902 format("r2=",f9.6," .le. r1=",f9.6)
      if (r3 .le. r2) then
         call remark("error in subroutine rho1dn; bad input parameters:")
         write (STDOUT,903) r3, r2
         call kaboom(0)
      endif
  903 format("r3=",f9.6," .le. r2=",f9.6)

      alf = max (epslon,alf)

c     Assume rho(t) has the form:
c		rho(t)=rho(t1)+(t-t1)/(a+b*(t-t1))
c     on the interval t1 < t < t2 (in the core), and
c		rho(t)=rho(t2)+(t-t2)/(c+d*(t-t2))
c     on the interval t2 < t < t3 (between separatrices), and
c		rho(t)=rho(t3)+k*sinh(alf*(t-t3)/(t4-t3))
c     on the interval t3 < t < t4 (in outer SOL)  where
c		k=(rho(t4)-rho(t3))/sinh(alf)
c
c     Choose coefficients (a,b) and (c,d) so that rho(t) and rho'(t)
c     are continuous at t2 and t3 :
      r3p = ((r4-r3)/(t4-t3)) * alf/sinh(alf)	! rho'(t3)
      d = ((r3-r2) - r3p*(t3-t2)) / (r3-r2)**2
      c = (1-d*(r3-r2))*(t3-t2)/(r3-r2)
      r2p=1/c					! rho'(t2)
      b = ((r2-r1) - r2p*(t2-t1)) / (r2-r1)**2
      a = (1-b*(r2-r1))*(t2-t1)/(r2-r1)

      do n = 0, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r1 + (t(n)-t1) / (a + b*(t(n)-t1))
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + (t(n)-t2) / (c + d*(t(n)-t2))
         elseif (t3 .le. t(n) .and. t(n) .lt. t4) then
            rho(n) = r3 + r3p*(t4-t3)*sinh(alf*(t(n)-t3)/(t4-t3))/alf
         elseif (t4 .le. t(n)) then
            rho(n) = r4
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho2dn(t,rho,nt,t1,t2,t3,t4,r1,r2,r3,r4,fac)
      implicit none

c     input/output arguments --
      integer nt
      real rho(0:nt),r1,r2,r3,r4,fac
      real t(0:nt),t1,t2,t3,t4

c     local variables --
      integer n
      real a,b,c,d,e,f
      real r2p,r3p

c     rho(t) is a piece-wise rational function of the form (f+gt)/(p+qt)
c     on the intervals t1 < t < t2, t2 < t < t3 and t3 < t < t4 with
c     rho(t) and rho'(t) continuous at t2 and t3.
c     The slopes rho'(t2) and rho'(t3) scale with input argument fac
c     according to the relations:
c                     rho'(t2) = ((r3-r2)/(t3-t2))*fac
c     and
c                     rho'(t3) = ((r3-r2)/(t3-t2))/fac
c     
c     NOTE: For fac=1, rho(t) is linear on the interval t2 < t < t3.

      if (t2 .le. t1) then
         call remark("error in subroutine rho2dn; bad input parameters:")
         write (STDOUT,899) t2, t1
         call kaboom(0)
      endif
  899 format("t2=",f4.1," .le. t1=",f4.1)
      if (t3 .le. t2) then
         call remark("error in subroutine rho2dn; bad input parameters:")
         write (STDOUT,900) t3, t2
         call kaboom(0)
      endif
  900 format("t3=",f4.1," .le. t2=",f4.1)
      if (t4 .le. t3) then
         call remark("error in subroutine rho2dn; bad input parameters:")
         write (STDOUT,901) t4, t3
         call kaboom(0)
      endif
  901 format("t4=",f4.1," .le. t3=",f4.1)
      if (r2 .le. r1) then
         call remark("error in subroutine rho2dn; bad input parameters:")
         write (STDOUT,902) r2, r1
         call kaboom(0)
      endif
  902 format("r2=",f9.6," .le. r1=",f9.6)
      if (r3 .le. r2) then
         call remark("error in subroutine rho2dn; bad input parameters:")
         write (STDOUT,903) r3, r2
         call kaboom(0)
      endif
  903 format("r3=",f9.6," .le. r2=",f9.6)
      if (r4 .le. r3) then
         call remark("error in subroutine rho2dn; bad input parameters:")
         write (STDOUT,904) r4, r3
         call kaboom(0)
      endif
  904 format("r4=",f9.6," .le. r3=",f9.6)

c     Assume rho(t) has the form:
c		rho(t)=rho(t1)+(t-t1)/(a+b*(t-t1))
c     on the interval t1 < t < t2 (in the core), and
c		rho(t)=rho(t2)+(t-t2)/(c+d*(t-t2))
c     on the interval t2 < t < t3 (between separatrices), and
c		rho(t)=rho(t3)+(t-t3)/(e+f*(t-t3))
c     on the interval t3 < t < t4 (beyond outer separatrix).
c
c     Choose coefficients (a,b),(c,d) and (e,f) so that rho(t) and rho'(t)
c     are continuous at t2 and t3 :
      r2p = ((r3-r2)/(t3-t2))*fac               ! rho'(t2)
      r3p = ((r3-r2)/(t3-t2))/fac               ! rho'(t3)

      b = ((r2-r1) - r2p*(t2-t1)) / (r2-r1)**2
      a = (1-b*(r2-r1))*(t2-t1)/(r2-r1)

      c = 1/r2p
      d = (1-c*(r3-r2)/(t3-t2))/(r3-r2)

      e = 1/r3p
      f = (1-e*(r4-r3)/(t4-t3))/(r4-r3)

      do n = 0, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r1 + (t(n)-t1) / (a + b*(t(n)-t1))
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + (t(n)-t2) / (c + d*(t(n)-t2))
         elseif (t3 .le. t(n) .and. t(n) .lt. t4) then
            rho(n) = r3 + (t(n)-t3) / (e + f*(t(n)-t3))
         elseif (t4 .le. t(n)) then
            rho(n) = r4
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho3dn(t,rho,nt,t1,t2,t3,t4,r1,r2,r3,r4,slp2fac,slp3fac,
     .                         r2p,r3p)
      implicit none

c     input/output arguments --
      integer nt
      real rho(0:nt),r1,r2,r3,r4,slp2fac,slp3fac,r2p,r3p
      real t(0:nt),t1,t2,t3,t4

c     local variables --
      integer n
      real a,b,c,d,e,f,g

c     rho(t) is a cubic function on the interval t2 < t < t3 and a
c     piece-wise rational function of the form (f+gt)/(p+qt)
c     on the intervals t1 < t < t2 and t3 < t < t4 with
c     rho(t) and rho'(t) continuous at t2 and t3.
c     The slopes rho'(t2) and rho'(t3) scale with input arguments
c     slp2fac and slp3fac according to the relations:
c                     rho'(t2) = ((r3-r2)/(t3-t2))*slp2fac
c     and
c                     rho'(t3) = ((r3-r2)/(t3-t2))*slp3fac
c     
c     so for slp2fac=slp3fac=1, rho(t) is strictly linear on t2 < t < t3.

      if (t2 .le. t1) then
         call remark("error in subroutine rho3dn; bad input parameters:")
         write (STDOUT,899) t2, t1
         call kaboom(0)
      endif
  899 format("t2=",f4.1," .le. t1=",f4.1)
      if (t3 .le. t2) then
         call remark("error in subroutine rho3dn; bad input parameters:")
         write (STDOUT,900) t3, t2
         call kaboom(0)
      endif
  900 format("t3=",f4.1," .le. t2=",f4.1)
      if (t4 .le. t3) then
         call remark("error in subroutine rho3dn; bad input parameters:")
         write (STDOUT,901) t4, t3
         call kaboom(0)
      endif
  901 format("t4=",f4.1," .le. t3=",f4.1)
      if (r2 .le. r1) then
         call remark("error in subroutine rho3dn; bad input parameters:")
         write (STDOUT,902) r2, r1
         call kaboom(0)
      endif
  902 format("r2=",f9.6," .le. r1=",f9.6)
      if (r3 .le. r2) then
         call remark("error in subroutine rho3dn; bad input parameters:")
         write (STDOUT,903) r3, r2
         call kaboom(0)
      endif
  903 format("r3=",f9.6," .le. r2=",f9.6)
      if (r4 .le. r3) then
         call remark("error in subroutine rho3dn; bad input parameters:")
         write (STDOUT,904) r4, r3
         call kaboom(0)
      endif
  904 format("r4=",f9.6," .le. r3=",f9.6)

c     Assume rho(t) has the form:
c		rho(t)=rho(t1)+(t-t1)/(a+b*(t-t1))
c     on the interval t1 < t < t2 (in the core), and
c		rho(t)=rho(t2)+c*(t-t2)+d*(t-t2)**2+g*(t-t2)**3
c     on the interval t2 < t < t3 (between separatrices), and
c		rho(t)=rho(t3)+(t-t3)/(e+f*(t-t3))
c     on the interval t3 < t < t4 (beyond outer separatrix).
c
c     Choose coefficients (a,b),(c,d,g) and (e,f) so that rho(t) and rho'(t)
c     are continuous at t2 and t3 with slopes given by:
      r2p = ((r3-r2)/(t3-t2))*slp2fac               ! rho'(t2)
      r3p = ((r3-r2)/(t3-t2))*slp3fac               ! rho'(t3)

      b = ((r2-r1) - r2p*(t2-t1)) / (r2-r1)**2
      a = (1-b*(r2-r1))*(t2-t1)/(r2-r1)

      c = r2p
      d = (-2*c - r3p + 3*(r3-r2)/(t3-t2))/(t3-t2)
      g = (c + r3p -2*(r3-r2)/(t3-t2))/(t3-t2)**2

      e = 1/r3p
      f = (1-e*(r4-r3)/(t4-t3))/(r4-r3)

      do n = 0, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r1 + (t(n)-t1) / (a + b*(t(n)-t1))
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + c*(t(n)-t2) + d*(t(n)-t2)**2 + g*(t(n)-t2)**3
         elseif (t3 .le. t(n) .and. t(n) .lt. t4) then
            rho(n) = r3 + (t(n)-t3) / (e + f*(t(n)-t3))
         elseif (t4 .le. t(n)) then
            rho(n) = r4
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho1l(t,rho,nt,t1,t2,r1,r2,r1p)
      implicit none

c     input/output arguments --
      integer nt
      real rho(0:nt),r1,r2,r1p
      real t(0:nt),t1,t2

c     local variables --
      integer n
      real a,b

c     procedures --
      external kaboom

c     rho1l(t) is a rational function of the form (f+gt)/(p+qt) on
c     the interval t1 < t < t2 with fixed slope at t1

      if (t2 .le. t1) then
         write (STDOUT,900)
         call kaboom(0)
      endif
  900 format("error in subroutine rho1l; bad input parameters: t2 .le. t1")

      a = 1/r1p
      b = -a/(t2-t1) + 1./(r2-r1)

      do n = 0, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r1 + (t(n)-t1) / (a + b*(t(n)-t1))
         elseif (t2 .le. t(n)) then
            rho(n) = r2
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho1r(t,rho,nt,t1,t2,r1,r2,r2p)
      implicit none

c     input/output arguments --
      integer nt
      real rho(0:nt),r1,r2,r2p
      real t(0:nt),t1,t2

c     local variables --
      integer n
      real a,b

c     procedures --
      external kaboom

c     rho1r(t) is a rational function of the form (f+gt)/(p+qt) on
c     the interval t1 < t < t2 with fixed slope at t2

      if (t2 .le. t1) then
         write (STDOUT,900)
         call kaboom(0)
      endif
  900 format("error in subroutine rho1r; bad input parameters: t2 .le. t1")

      a = 1/r2p
      b = -a/(t1-t2) + 1./(r1-r2)

      do n = 0, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r2 + (t(n)-t2) / (a + b*(t(n)-t2))
         elseif (t2 .le. t(n)) then
            rho(n) = r2
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho2(t,rho,nt,t1,t2,t3,r1,r2,r3)
      implicit none

c     input/output arguments --
      integer nt
      real rho(nt),r1,r2,r3
      real t(nt),t1,t2,t3

c     local variables --
      integer n
      real a,b,c

c     procedures --
      external kaboom

c     rho(t) is quadratic on the interval t1 < t < t2
c     and linear on the interval t2 < t < t3 with continuous
c     first derivative at t2.

      if (t3 .le. t2) then
         write (STDOUT,900)
         call kaboom(0)
      endif
  900 format("error in subroutine rho2; bad input parameters: t3 .le. t2")

      do n = 1, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            a = r1
            b = 2*(r2-r1)/(t2-t1) - (r3-r2)/(t3-t2)
            c = ((r3-r2)/(t3-t2) - (r2-r1)/(t2-t1))/(t2-t1)
            rho(n) = a + b*(t(n)-t1) + c*(t(n)-t1)**2
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + (r3-r2)*(t(n)-t2)/(t3-t2)
         elseif (t3 .le. t(n)) then
            rho(n) = r3
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho3(t,rho,nt,t1,t2,t3,r1,r2,r3)
      implicit none

c     input/output arguments --
      integer nt
      real rho(nt),r1,r2,r3
      real t(nt),t1,t2,t3

c     local variables --
      integer n
      real a,b,c,d

c     procedures --
      external kaboom

c     rho(t) is cubic on the interval t1 < t < t2 and linear on
c     the interval t2 < t < t3 with continuous first and second
c     derivatives at t2.

      if (t3 .le. t2) then
         write (STDOUT,900)
         call kaboom(0)
      endif
  900 format("error in subroutine rho3; bad input parameters: t3 .le. t2")

      do n = 1, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            a = r1
            b = 3*(r2-r1)/(t2-t1) - 2*(r3-r2)/(t3-t2)
            c = -3*((r2-r1)/(t2-t1) - (r3-r2)/(t3-t2))/(t2-t1)
            d = ((r2-r1)/(t2-t1) - (r3-r2)/(t3-t2))/(t2-t1)**2
            rho(n) = a + b*(t(n)-t1) + c*(t(n)-t1)**2 + d*(t(n)-t1)**3
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + (r3-r2)*(t(n)-t2)/(t3-t2)
         elseif (t3 .le. t(n)) then
            rho(n) = r3
         endif
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine rho4(t,rho,nt,t1,t2,t3,r1,r2,r3,s2)
      implicit none

c     input/output arguments --
      integer nt
      real rho(nt),r1,r2,r3,s2
      real t(nt),t1,t2,t3

c     local variables --
      integer n
      real r2p_quadratic,d

c     procedures --
      external kaboom

c     rho(t) is cubic on the interval t1 < t < t3 with the slope
c     at t2 enhanced by a factor s2 over that obtained for a quadratic
c     form.

      if (t3 .le. t2) then
         write (STDOUT,901)
  901 format("error in subroutine rho4; bad input parameters: t3 .le. t2")
         call kaboom(0)
      elseif (t2 .le. t1) then
         write (STDOUT,902)
  902 format("error in subroutine rho4; bad input parameters: t2 .le. t1")
         call kaboom(0)
      endif

c     For a quadratic form, the slope at t2 would be
      r2p_quadratic = r1*(t2-t3)/((t1-t3)*(t1-t2))
     .              + r2*(2*t2-t1-t3)/((t2-t1)*(t2-t3))
     .              + r3*(t2-t1)/((t3-t1)*(t3-t2))

c     A cubic term, + d*(t-t1)*(t-t2)*(t-t3), adds to the slope at t=t2:
c     r2p = r2p_quadratic + d*(t2-t1)*(t2-t3), so in order to get
c     r2p = s2*r2p_quadratic we should choose

      d = (s2-1.)*r2p_quadratic/((t2-t1)*(t2-t3))

      do n = 1, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r1 *((t(n)-t2)*(t(n)-t3))/((t1-t2)*(t1-t3))
     .             + r2 *((t(n)-t1)*(t(n)-t3))/((t2-t1)*(t2-t3))
     .             + r3 *((t(n)-t1)*(t(n)-t2))/((t3-t1)*(t3-t2))
     .             + d*(t(n)-t1)*(t(n)-t2)*(t(n)-t3)
         elseif (t3 .le. t(n)) then
            rho(n) = r3
         endif
      enddo

      return
      end

c----------------------------------------------------------------------c

      subroutine rho5(t,rho,nt,t1,t2,t3,r1,r2,r3,r2p)
      implicit none

c     input/output arguments --
      integer nt
      real rho(0:nt),r1,r2,r3,r2p
      real t(0:nt),t1,t2,t3

c     local variables --
      integer n
      real a,b,c,d

c     procedures --
      external kaboom

c     This defines rho(t) as a piece-wise rational function of the form
c          rho = r1 + (t-t1)/(a + b*(t-t1))
c     on the interval t1 < t < t2 and
c          rho = r2 + (t-t2)/(c + d*(t-t2))
c     on the interval t2 < t < t3 
c     with a specified derivative rho'(t2) = r2p

      if (t2 .le. t1) then
         write (STDOUT,900)
         call kaboom(0)
      endif
  900 format("error in subroutine rho5; bad input parameters: t2 .le. t1")
      if (t3 .le. t2) then
         write (STDOUT,901)
         call kaboom(0)
      endif
  901 format("error in subroutine rho5; bad input parameters: t3 .le. t2")

      a = r2p*((t2-t1)/(r2-r1))**2
      b = (-a+(t2-t1)/(r2-r1))/(t2-t1)
      c = 1/r2p
      d = (-c+(t3-t2)/(r3-r2))/(t3-t2)

      do n = 0, nt
         if (t(n) .lt. t1) then
            rho(n) = r1
         elseif (t1 .le. t(n) .and. t(n) .lt. t2) then
            rho(n) = r1 + (t(n)-t1) / (a + b*(t(n)-t1))
         elseif (t2 .le. t(n) .and. t(n) .lt. t3) then
            rho(n) = r2 + (t(n)-t2) / (c + d*(t(n)-t2))
         elseif (t3 .le. t(n)) then
            rho(n) = r3
         endif
      enddo

      return
      end

c----------------------------------------------------------------------c

      subroutine findptnma(nlim,rlim,zlim,rmagx,zmagx,
     .                                    nptnma,rptnma,zptnma)
      implicit none
      integer nlim,nptnma
      real rlim(1:nlim),zlim(1:nlim),rmagx,zmagx,rptnma,zptnma

! find the coordinates of the point on the limiter surface that is
! nearest the magnetic axis
      integer n
      real ds, dsmin

      dsmin=sqrt((rlim(1)-rmagx)**2 +(zlim(1)-zmagx)**2)
      nptnma=1
      do n=2,nlim
         ds=sqrt((rlim(n)-rmagx)**2 +(zlim(n)-zmagx)**2)
         if (ds .lt. dsmin) then
            dsmin=ds
            nptnma=n
         endif
      enddo

      rptnma=rlim(nptnma)
      zptnma=zlim(nptnma)

      return
      end

c----------------------------------------------------------------------c

      subroutine findstrike(js,rs,zs)
      use Dimflxgrd 	!jdim,npts,nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Polflx 

c     procedures --
      implicit none

c     input/output arguments --
      integer js	! flux surface index (input)
      real rs,zs	! strike point coordinates (output)

c     common blocks --
      external intersect2

c     local variables --
      integer icurv,ilim,ierr
      real fuzzf

      data fuzzf /1.0e-06/
 
c     This procedure finds the first intersection of a poloidal
c     flux surface with the limiter surface from EFIT.  The flux 
c     surface index label is js; the flux surface coordinates are
c     xcurve(,js) and ycurve(,js); the limiter surface coordinates
c     are xlim and ylim.

      ierr=0
      call intersect2(xcurve(1,js),ycurve(1,js),1,npoint(js),
     .                xlim,ylim,1,nlim,rs,zs,icurv,ilim,fuzzf,ierr)

c     Also put output into rs_com and zs_com for python version
      rs_com = rs
      zs_com = zs

      if (ierr .ne. 0) then
         call remark("*************************")
         call remark("no intersection was found")
         call remark("*************************")
      endif

      return
      end

      real function ssum(n, x, incx)
c ... Sums the n elements of a single precision vector x.  The increment
c     incx between elements of x must be non-zero but can be positive or
c     negative to cause elements to be added in either the forward or
c     reverse directions.

      implicit none

      integer n, incx
      real x(*)
      integer ib, ie, i

      ssum = 0.
      if (n .lt. 0) return
      ib = 1
      ie = 1 + (n-1) * abs(incx)
      if (incx .lt. 0) then
         ib = ie
         ie = 1
      endif
      do i = ib, ie, incx
         ssum = ssum + x(i)
      enddo

      return
      end

      INTEGER FUNCTION IDAMAX(N,DX,INCX)
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
*  Purpose
*  =======
*
*     finds the index of element having max. absolute value.
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*
*     .. Local Scalars ..
      DOUBLE PRECISION DMAX
      INTEGER I,IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS
*     ..
      IDAMAX = 0
      IF (N.LT.1 .OR. INCX.LE.0) RETURN
      IDAMAX = 1
      IF (N.EQ.1) RETURN
      IF (INCX.EQ.1) GO TO 20
*
*        code for increment not equal to 1
*
      IX = 1
      DMAX = DABS(DX(1))
      IX = IX + INCX
      DO 10 I = 2,N
          IF (DABS(DX(IX)).LE.DMAX) GO TO 5
          IDAMAX = I
          DMAX = DABS(DX(IX))
    5     IX = IX + INCX
   10 CONTINUE
      RETURN
*
*        code for increment equal to 1
*
   20 DMAX = DABS(DX(1))
      DO 30 I = 2,N
          IF (DABS(DX(I)).LE.DMAX) GO TO 30
          IDAMAX = I
          DMAX = DABS(DX(I))
   30 CONTINUE
      RETURN
      END
*DECK DASUM
      DOUBLE PRECISION FUNCTION DASUM (N, DX, INCX)
C***BEGIN PROLOGUE  DASUM
C***PURPOSE  Compute the sum of the magnitudes of the elements of a
C            vector.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1A3A
C***TYPE      DOUBLE PRECISION (SASUM-S, DASUM-D, SCASUM-C)
C***KEYWORDS  BLAS, LINEAR ALGEBRA, SUM OF MAGNITUDES OF A VECTOR
C***AUTHOR  Lawson, C. L., (JPL)
C           Hanson, R. J., (SNLA)
C           Kincaid, D. R., (U. of Texas)
C           Krogh, F. T., (JPL)
C***DESCRIPTION
C
C                B L A S  Subprogram
C    Description of Parameters
C
C     --Input--
C        N  number of elements in input vector(s)
C       DX  double precision vector with N elements
C     INCX  storage spacing between elements of DX
C
C     --Output--
C    DASUM  double precision result (zero if N .LE. 0)
C
C     Returns sum of magnitudes of double precision DX.
C     DASUM = sum from 0 to N-1 of ABS(DX(IX+I*INCX)),
C     where IX = 1 if INCX .GE. 0, else IX = 1+(1-N)*INCX.
C
C***REFERENCES  C. L. Lawson, R. J. Hanson, D. R. Kincaid and F. T.
C                 Krogh, Basic linear algebra subprograms for Fortran
C                 usage, Algorithm No. 539, Transactions on Mathematical
C                 Software 5, 3 (September 1979), pp. 308-323.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   791001  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900821  Modified to correct problem with a negative increment.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DASUM
      DOUBLE PRECISION DX(*)
      INTEGER I, INCX, IX, M, MP1, N
C***FIRST EXECUTABLE STATEMENT  DASUM
      DASUM = 0.0D0
      IF (N .LE. 0) RETURN
C
      IF (INCX .EQ. 1) GOTO 20
C
C     Code for increment not equal to 1.
C
      IX = 1
      IF (INCX .LT. 0) IX = (-N+1)*INCX + 1
      DO 10 I = 1,N
        DASUM = DASUM + ABS(DX(IX))
        IX = IX + INCX
   10 CONTINUE
      RETURN
C
C     Code for increment equal to 1.
C
C     Clean-up loop so remaining vector length is a multiple of 6.
C
   20 M = MOD(N,6)
      IF (M .EQ. 0) GOTO 40
      DO 30 I = 1,M
        DASUM = DASUM + ABS(DX(I))
   30 CONTINUE
      IF (N .LT. 6) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,6
        DASUM = DASUM + ABS(DX(I)) + ABS(DX(I+1)) + ABS(DX(I+2)) +
     1          ABS(DX(I+3)) + ABS(DX(I+4)) + ABS(DX(I+5))
   50 CONTINUE
      RETURN
      END
      subroutine daxpy(n,da,dx,incx,dy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*),da
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dy(i) + da*dx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        dy(i) = dy(i) + da*dx(i)
        dy(i + 1) = dy(i + 1) + da*dx(i + 1)
        dy(i + 2) = dy(i + 2) + da*dx(i + 2)
        dy(i + 3) = dy(i + 3) + da*dx(i + 3)
   50 continue
      return
      end
      subroutine  dcopy(n,dx,incx,dy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        dy(i) = dx(i)
        dy(i + 1) = dx(i + 1)
        dy(i + 2) = dx(i + 2)
        dy(i + 3) = dx(i + 3)
        dy(i + 4) = dx(i + 4)
        dy(i + 5) = dx(i + 5)
        dy(i + 6) = dx(i + 6)
   50 continue
      return
      end
      double precision function ddot(n,dx,incx,dy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      ddot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) +
     *   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
      return
      end
      DOUBLE PRECISION FUNCTION DNRM2 ( N, X, INCX )
*     .. Scalar Arguments ..
      INTEGER                           INCX, N
*     .. Array Arguments ..
      DOUBLE PRECISION                  X( * )
*     ..
*
*  DNRM2 returns the euclidean norm of a vector via the function
*  name, so that
*
*     DNRM2 := sqrt( x'*x )
*
*
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to DLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*
*     .. Parameters ..
      DOUBLE PRECISION      ONE         , ZERO
      PARAMETER           ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     .. Local Scalars ..
      INTEGER               IX
      DOUBLE PRECISION      ABSXI, NORM, SCALE, SSQ
*     .. Intrinsic Functions ..
      INTRINSIC             ABS, SQRT
*     ..
*     .. Executable Statements ..
      IF( N.LT.1 .OR. INCX.LT.1 )THEN
         NORM  = ZERO
      ELSE IF( N.EQ.1 )THEN
         NORM  = ABS( X( 1 ) )
      ELSE
         SCALE = ZERO
         SSQ   = ONE
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
*
         DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
            IF( X( IX ).NE.ZERO )THEN
               ABSXI = ABS( X( IX ) )
               IF( SCALE.LT.ABSXI )THEN
                  SSQ   = ONE   + SSQ*( SCALE/ABSXI )**2
                  SCALE = ABSXI
               ELSE
                  SSQ   = SSQ   +     ( ABSXI/SCALE )**2
               END IF
            END IF
   10    CONTINUE
         NORM  = SCALE * SQRT( SSQ )
      END IF
*
      DNRM2 = NORM
      RETURN
*
*     End of DNRM2.
*
      END
*DECK DSCAL
      SUBROUTINE DSCAL (N, DA, DX, INCX)
C***BEGIN PROLOGUE  DSCAL
C***PURPOSE  Multiply a vector by a constant.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1A6
C***TYPE      DOUBLE PRECISION (SSCAL-S, DSCAL-D, CSCAL-C)
C***KEYWORDS  BLAS, LINEAR ALGEBRA, SCALE, VECTOR
C***AUTHOR  Lawson, C. L., (JPL)
C           Hanson, R. J., (SNLA)
C           Kincaid, D. R., (U. of Texas)
C           Krogh, F. T., (JPL)
C***DESCRIPTION
C
C                B L A S  Subprogram
C    Description of Parameters
C
C     --Input--
C        N  number of elements in input vector(s)
C       DA  double precision scale factor
C       DX  double precision vector with N elements
C     INCX  storage spacing between elements of DX
C
C     --Output--
C       DX  double precision result (unchanged if N.LE.0)
C
C     Replace double precision DX by double precision DA*DX.
C     For I = 0 to N-1, replace DX(IX+I*INCX) with  DA * DX(IX+I*INCX),
C     where IX = 1 if INCX .GE. 0, else IX = 1+(1-N)*INCX.
C
C***REFERENCES  C. L. Lawson, R. J. Hanson, D. R. Kincaid and F. T.
C                 Krogh, Basic linear algebra subprograms for Fortran
C                 usage, Algorithm No. 539, Transactions on Mathematical
C                 Software 5, 3 (September 1979), pp. 308-323.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   791001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900821  Modified to correct problem with a negative increment.
C           (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DSCAL
      DOUBLE PRECISION DA, DX(*)
      INTEGER I, INCX, IX, M, MP1, N
C***FIRST EXECUTABLE STATEMENT  DSCAL
      IF (N .LE. 0) RETURN
      IF (INCX .EQ. 1) GOTO 20
C
C     Code for increment not equal to 1.
C
      IX = 1
      IF (INCX .LT. 0) IX = (-N+1)*INCX + 1
      DO 10 I = 1,N
        DX(IX) = DA*DX(IX)
        IX = IX + INCX
   10 CONTINUE
      RETURN
C
C     Code for increment equal to 1.
C
C     Clean-up loop so remaining vector length is a multiple of 5.
C
   20 M = MOD(N,5)
      IF (M .EQ. 0) GOTO 40
      DO 30 I = 1,M
        DX(I) = DA*DX(I)
   30 CONTINUE
      IF (N .LT. 5) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I+1) = DA*DX(I+1)
        DX(I+2) = DA*DX(I+2)
        DX(I+3) = DA*DX(I+3)
        DX(I+4) = DA*DX(I+4)
   50 CONTINUE
      RETURN
      END
*DECK DSWAP
      SUBROUTINE DSWAP (N, DX, INCX, DY, INCY)
C***BEGIN PROLOGUE  DSWAP
C***PURPOSE  Interchange two vectors.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1A5
C***TYPE      DOUBLE PRECISION (SSWAP-S, DSWAP-D, CSWAP-C, ISWAP-I)
C***KEYWORDS  BLAS, INTERCHANGE, LINEAR ALGEBRA, VECTOR
C***AUTHOR  Lawson, C. L., (JPL)
C           Hanson, R. J., (SNLA)
C           Kincaid, D. R., (U. of Texas)
C           Krogh, F. T., (JPL)
C***DESCRIPTION
C
C                B L A S  Subprogram
C    Description of Parameters
C
C     --Input--
C        N  number of elements in input vector(s)
C       DX  double precision vector with N elements
C     INCX  storage spacing between elements of DX
C       DY  double precision vector with N elements
C     INCY  storage spacing between elements of DY
C
C     --Output--
C       DX  input vector DY (unchanged if N .LE. 0)
C       DY  input vector DX (unchanged if N .LE. 0)
C
C     Interchange double precision DX and double precision DY.
C     For I = 0 to N-1, interchange  DX(LX+I*INCX) and DY(LY+I*INCY),
C     where LX = 1 if INCX .GE. 0, else LX = 1+(1-N)*INCX, and LY is
C     defined in a similar way using INCY.
C
C***REFERENCES  C. L. Lawson, R. J. Hanson, D. R. Kincaid and F. T.
C                 Krogh, Basic linear algebra subprograms for Fortran
C                 usage, Algorithm No. 539, Transactions on Mathematical
C                 Software 5, 3 (September 1979), pp. 308-323.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   791001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920310  Corrected definition of LX in DESCRIPTION.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DSWAP
      DOUBLE PRECISION DX(*), DY(*), DTEMP1, DTEMP2, DTEMP3
      integer n,incx,incy,ix,iy,i,m,mp1,ns
C***FIRST EXECUTABLE STATEMENT  DSWAP
      IF (N .LE. 0) RETURN
      IF (INCX .EQ. INCY) IF (INCX-1) 5,20,60
C
C     Code for unequal or nonpositive increments.
C
    5 IX = 1
      IY = 1
      IF (INCX .LT. 0) IX = (-N+1)*INCX + 1
      IF (INCY .LT. 0) IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        DTEMP1 = DX(IX)
        DX(IX) = DY(IY)
        DY(IY) = DTEMP1
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      RETURN
C
C     Code for both increments equal to 1.
C
C     Clean-up loop so remaining vector length is a multiple of 3.
C
   20 M = MOD(N,3)
      IF (M .EQ. 0) GO TO 40
      DO 30 I = 1,M
        DTEMP1 = DX(I)
        DX(I) = DY(I)
        DY(I) = DTEMP1
   30 CONTINUE
      IF (N .LT. 3) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,3
        DTEMP1 = DX(I)
        DTEMP2 = DX(I+1)
        DTEMP3 = DX(I+2)
        DX(I) = DY(I)
        DX(I+1) = DY(I+1)
        DX(I+2) = DY(I+2)
        DY(I) = DTEMP1
        DY(I+1) = DTEMP2
        DY(I+2) = DTEMP3
   50 CONTINUE
      RETURN
C
C     Code for equal, positive, non-unit increments.
C
   60 NS = N*INCX
      DO 70 I = 1,NS,INCX
        DTEMP1 = DX(I)
        DX(I) = DY(I)
        DY(I) = DTEMP1
   70 CONTINUE
      RETURN
      END

#include "../mppl.h"
c----------------------------------------------------------------------c

      subroutine ingrd
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 
      use Dimensions 
      use Curves 
      use Inmesh 	!isspnew,rstrike,zstrike
      use Linkco 
      use Mmod 	! delmax
      use Xmesh 
      use Share 

c     local variables --
      implicit none
		!istpnew,rtpnew,ztpnew
		!x0g,y0g,xlast,ylast
      integer n
      real dxefit,dyefit,rmin,rmax

c     Set input parameters for the grd package --

      dxefit = xdim/(nxefit-1)
      dyefit = zdim/(nyefit-1)
      if (dsmin .eq. 0) then  ! use this value if user does not supply one
         dsmin = 0.25*dxefit
      endif
      dsminx = 2.0*dsmin
      dyjump = 1.0*dyefit
      delmax = 0.01*dxefit

c     Set data for first and last seedpoints on the separatrix
c     for inboard and outboard regions of the mesh --

c     First seedpoints --
c     The uppermost point for each region
      if (istpnew .eq. 0) then		! use default specification
         if ((geometry .eq. 'snull').or.(geometry .eq. "uppersn")) then
c           choose radial position of magnetic axis
            x0g(1) = rmagx
            x0g(2) = rmagx
         else	! geometry="dnbot"
c           assume up/down symmetric double-null configuration
c           choose innermost and outermost points on the separatrix
            rmin=rgrid1+xdim
            do n=1,npointg(jsptrx(1))
               if (xcurveg(n,jsptrx(1)) .lt. rmin) then
                  rmin=xcurveg(n,jsptrx(1))
               else
                  exit
               endif
            enddo
            rmax=rgrid1
            do n=1,npointg(jsptrx(2))
               if (xcurveg(n,jsptrx(2)) .gt. rmax) then
                  rmax=xcurveg(n,jsptrx(2))
               else
                  exit
               endif
            enddo
            x0g(1)=rmin
            x0g(2)=rmax
         endif	! end if-test on "geometry"
      elseif (istpnew .eq. 1) then	! user-specified values
         x0g(1) = rtpnew(1)
         y0g(1) = ztpnew(1)
         x0g(2) = rtpnew(2)
         y0g(2) = ztpnew(2)
      endif

c     Last seedpoints --
c     at the strike point for each region
      if (isspnew .eq. 0) then		! use eqdsk values
ccc Temporary code for FRC mesh generation --
         if (nxleg(igrid,1)==0) then
            xlast(1) = rseps
            ylast(1) = zseps
         else
            xlast(1) = rvsin
            ylast(1) = zvsin
         endif
         xlast(2) = rvsout
         ylast(2) = zvsout
      elseif (isspnew .eq. 1) then	! user-specified values
         xlast(1) = rstrike(1)
         ylast(1) = zstrike(1)
         xlast(2) = rstrike(2)
         ylast(2) = zstrike(2)
      endif

c     Definition of "conjugate magnetic axis" (in private region) --
      rtanpl=(rvsin+rvsout)/2
      ztanpl=(zvsin+zvsout)/2

      return
      end

c     ------------------------------------------------------------------

      subroutine idealgrd

*  -- Subroutine for initializing the arrays rm, zm, etc. in group
*  -- RZ_grid_info for cylindrical IDEAL. Re-allocation does not take
*  -- effect in the same routine where nxm and nym are changed; thus, the
*  -- computations are done in a following routine, called idlcomp.

            use Share       ! igrid,nxomit

      implicit none

      external com_set_dims, gallot

c ... Compute dimension variables nx, nym, and nxm.
      igrid = 1
      nxomit = 0
      call com_set_dims

c ... Allocate space, then compute.
      call gallot("RZ_grid_info",0)
      call idlcomp

      return
      end

c     --------------------------------------------------------------------

      subroutine idlcomp

*  -- Subroutine for computing the vertex locations of the cylindrical
*  -- or rectangular grid (formerly, the IDEAL grid)

            use Dim               ! nxm,nym
            use RZ_grid_info      ! rm,zm,psi,br,bz,bpol,bphi,b
            use Xpoint_indices    ! ixpt2,iysptrx1
            use Analgrd           ! alfyt,alfxt,tctr,za0,zaxpt,zax,radm,radx,rad0,
                            ! btfix,bpolfix,isgdistort,ixdstar,iynod,rnod
                            ! agsidx,agsrsp,sratiopf,rscalcore,tnoty,isadjalfxt
            use Share             ! nxcore,nxleg,isgrdsym

      implicit none

*  -- local variables
      real dznl, dznr, dznu, t1x, t2x, t1y, t2y, rixm, adrt, 
     .     xshift, radmu, ta_r,drn1,drn2,drnu1,drnu2
      character*60 runidl
      integer ix, iy, n, ixm, ixpt2_init
      real lpi
      data lpi/3.141592654/

      runidl = 'ideal geometry'

      ixpt2_init = nxcore(1,2)  ! define to allow isgrdsym=1 case to work
      if (iysptrx1(1) .eq. 0) rad0 = radm  !allows old cases without rad0 to run
      if (ixpt2_init .gt. 0) dznu = (zaxpt - za0) / real(ixpt2_init)
      if (tctr .gt. 0.0000001) dznl = tctr*(zax - zaxpt - za0) / 
     .                               (1 - exp(+alfxt*tctr))
      if (tctr .lt. 0.9999999) dznr = (1 - tctr)*(zax - zaxpt - za0) / 
     .                               (1 - exp(-alfxt*(1-tctr)))
cc      write(*,*) 'dznu, dznr =',dznu,dznr
      if (isadjalfxt > 0) then  !change alfxt slightly so dznr=dznu
        alfxt = -log(1. - (1.-tctr)*(zax - zaxpt - za0)*
     .                      (1.-exp(-alfxt/real(nxm-ixpt2_init)))/dznu)
     ,                                                      /(1.-tctr)
        write(*,*) '*****'
        write(*,*) 'alfxt adjusted, smooth dx at ixpt2: alfxt=',alfxt
        write(*,*) '*****'
      endif
      
      rixm = tctr * real(nxm-ixpt2_init) + .5
      ixm = int(rixm)
      
      do 20 iy = nym, 1, -1
         if (iy .gt. iysptrx1(1)) then
            t1y = real(iy-1-iysptrx1(1)) / real(nym-iysptrx1(1))
            t2y = real(iy-iysptrx1(1)) / real(nym-iysptrx1(1))
            radmu = rad0
            if (tnoty .eq. 0) then
              drn1=(radx - rad0)*(1-exp(-alfyt*t1y))/(1 - exp(-alfyt))
              drn2=(radx - rad0)*(1-exp(-alfyt*t2y))/(1 - exp(-alfyt))
            else  ! new (6/99) generalized form; note, make alfyt=-alfyt
              drn1=(radx-rad0)*
     .                 (tanh(alfyt*tnoty)+tanh(alfyt*(t1y-tnoty)))/
     .                   (tanh(alfyt*tnoty)+tanh(alfyt*(1-tnoty)))
              drn2=(radx-rad0)*
     .                 (tanh(alfyt*tnoty)+tanh(alfyt*(t2y-tnoty)))/
     .                   (tanh(alfyt*tnoty)+tanh(alfyt*(1-tnoty)))
            endif
         else
            if (sratiopf .eq. 0.) sratiopf = (rad0-radm)/(radx-rad0)   
                                      !gives same expan. rate around sep.
            radmu = rad0
            if (tnoty.eq.0) then
              t1y = -sratiopf*real(iy-1-iysptrx1(1)) / real(iysptrx1(1))
              t2y = -sratiopf*real(iy-iysptrx1(1)) / real(iysptrx1(1))
              drn1 = (radm - rad0)*(1-exp(-alfyt*t1y)) / 
     .                                       (1 - exp(-sratiopf*alfyt))
              drn2 = (radm - rad0)*(1-exp(-alfyt*t2y)) / 
     .                                       (1 - exp(-sratiopf*alfyt))
            else  ! new (6/99) generalized form; note, not sratiopf
              drn1 = (rm(1,iysptrx1(1)+1,2)-rm(1,2*iysptrx1(1)+1-iy,3))
              drn1 = -drn1*(rad0-radm)/
     .                    (rm(1,iysptrx1(1)+1,2)-rm(1,2*iysptrx1(1),3))
              drn2 = (rm(1,iysptrx1(1)+1,2)-rm(1,2*iysptrx1(1)+1-iy,2))
              drn2 = -drn2*(rad0-radm)/
     .                    (rm(1,iysptrx1(1)+1,2)-rm(1,2*iysptrx1(1),3))
             endif
         endif          

         do 10 ix = 1, nxm
            if (ix.le.ixpt2_init .and. iy.le.iysptrx1(1)) then
               drnu1 = rscalcore*drn1  ! give diff radial range to core region
               drnu2 = rscalcore*drn2  
            else
               drnu1 = drn1
               drnu2 = drn2
            endif
            rm(ix,iy,1) = radmu + drnu1
            rm(ix,iy,2) = rm(ix,iy,1)
            rm(ix,iy,3) = radmu + drnu2
            rm(ix,iy,4) = rm(ix,iy,3)
            rm(ix,iy,0) = 0.25 * ( rm(ix,iy,1) + rm(ix,iy,2) +
     .                             rm(ix,iy,3) + rm(ix,iy,4) )

            if (ix .le. ixpt2_init) then      ! uniform grid region
               zm(ix,iy,1) = za0 + dznu * (ix-1)
               zm(ix,iy,2) = za0 + dznu * ix
            elseif (ix .gt. ixm) then    ! nonuniform grid with decreasing dx
               t1x = real(ix-ixpt2_init-1) / real(nxm-ixpt2_init)
               t2x = real(ix-ixpt2_init) / real(nxm-ixpt2_init)
               zm(ix,iy,1) = zaxpt + dznr * (1-exp(-alfxt*(t1x-tctr))) 

               zm(ix,iy,2) = zaxpt + dznr * (1-exp(-alfxt*(t2x-tctr))) 
            else                         ! nonuniform grid with increasing dx
               t1x = real(ix-ixpt2_init-1) / real(nxm-ixpt2_init)
               t2x = real(ix-ixpt2_init) / real(nxm-ixpt2_init)
               zm(ix,iy,1) = zaxpt + dznl * (1-exp(+alfxt*t1x)) 
               zm(ix,iy,2) = zaxpt + dznl * (1-exp(+alfxt*t2x)) 
            endif
            zm(ix,iy,3) = zm(ix,iy,1)
            zm(ix,iy,4) = zm(ix,iy,2)

            zm(ix,iy,0) = 0.25 * ( zm(ix,iy,1) + zm(ix,iy,2) +
     .                             zm(ix,iy,3) + zm(ix,iy,4) )
  10     continue
  20  continue

ccc      write(*,*) 'zm(,1,1)]',zm(1:nxm,1,1)

c...  Tilt the mesh in the poloidal direction from ixsnog if tiltang.ne.0
      if (tiltang.ne.0.) then
         do iy = 1, nym
            do ix = ixsnog, nx
               ta_r = (zm(ix,1,2)-zm(ixsnog,1,1))*tiltang*(lpi/180.) /
     .                (zm(nx,1,2)-zm(ixsnog,1,1))
               zm(ix,iy,4) = zm(ix,1,2) + (rm(ix,iy,3)-rm(ix,1,1)) *
     .                                                       tan(ta_r)
               if (ix.gt.1) zm(ix,iy,3) = zm(ix-1,iy,4)
               if (iy.gt.1) then
                  zm(ix,iy,1) = zm(ix,iy-1,3)
                  zm(ix,iy,2) = zm(ix,iy-1,4)
               endif
               zm(ix,iy,0) = 0.25 * ( zm(ix,iy,1) + zm(ix,iy,2) +
     .                                zm(ix,iy,3) + zm(ix,iy,4) )
            enddo
         enddo
      endif

c...  Distort mesh poloidally to test nonorthogonal coding/performance
      if (isgdistort .eq. 1) then   ! only zm changes, rm the same
         do iy = 1, nym
            adrt = agsindx*(iy-iynod)/nym + 
     .                            agsrsp*(rm(1,iy,3)-rnod)/rm(1,nym,3)
            do ix = ixdstar, nx
               xshift = adrt*sin((ix-ixdstar+1)*lpi/(nx-ixdstar+1))
               zm(ix,iy,4) = zm(ix,iy,4) + (zm(ix,iy,4)-zm(ix,iy,3))*
     .                                     0.1*real(nx-ixdstar)*xshift
            ! 0.1*(nx-ixdstar) factor keeps distortion ~same as nx increases
               if (ix.gt.1) zm(ix,iy,3) = zm(ix-1,iy,4)
               if (iy.gt.1) then 
                  zm(ix,iy,1) = zm(ix,iy-1,3)
                  zm(ix,iy,2) = zm(ix,iy-1,4)
               elseif (iy.eq.1) then   ! need to do bottom face as iy=0
                  xshift = ( agsindx*(-iynod)/nym + 
     .                           agsrsp*(rm(1,1,1)-rnod)/rm(1,nym,3) ) *
     .                        sin((ix-ixdstar+1)*lpi/(nx-ixdstar+1)) 
                  zm(ix,1,2) = zm(ix,1,2) + (zm(ix,1,2)-zm(ix,1,1))*
     .                                      0.1*real(nx-ixdstar)*xshift
            ! 0.1*(nx-ixdstar) factor keeps distortion ~same as nx increases
                  if (ix.gt.1) zm(ix,1,1) = zm(ix-1,1,2)
               endif
               zm(ix,iy,0) = 0.25 * ( zm(ix,iy,1) + zm(ix,iy,2) +
     .                                zm(ix,iy,3) + zm(ix,iy,4) )
            enddo
         enddo
      endif

c...  Make a symmetric grid in zm if isgrdsym=1; redistribute zm's and
      if (isgrdsym .eq. 1) then
         if ((nxm-1)/2.eq.nxm/2 .or. 
     .                          (ixpt2_init-1)/2.eq.ixpt2_init/2) then
            call remark('*** nxm or ixpt2_init odd, cannot use isgrdsym ***')
            call kaboom(0)
         endif
         do iy = 1, nym  !don't change points ,2 and ,4 until second ix loop
            do ix = 1, nx/2
               zm(ix,iy,1) = -zm((nx-2*(ix-1)),iy,2)
               zm(ix,iy,3) = -zm((nx-2*(ix-1)),iy,4)
               if (ix .eq. 1) then
                  zm(ix+nx/2,iy,1) = 0.
                  zm(ix+nx/2,iy,3) = 0.
               else
                  zm(ix+nx/2,iy,1) = zm(2*(ix-1),iy,2)
                  zm(ix+nx/2,iy,3) = zm(2*(ix-1),iy,4)
               endif
            enddo
            do ix = 1, nx
               if (ix .ne. nx) then   ! ix=nx case satisfied from orgin. grid
                  zm(ix,iy,2) = zm(ix+1,iy,1)
                  zm(ix,iy,4) = zm(ix+1,iy,3)
               endif
               zm(ix,iy,0) = 0.25 * ( zm(ix,iy,1) + zm(ix,iy,2) +
     .                                zm(ix,iy,3) + zm(ix,iy,4) )
            enddo
         enddo
      endif          

c...  Reset x-point index ixpt2 if the zxpt_reset is positive; used for
c...  one continuous mesh (zaxpt=0, ncore=0) with no uniform dz region
      if (zxpt_reset .ge. 1.e-10) then
         do ix = 1, nx
            if (zm(ix,1,1).lt.zxpt_reset .and. 
     .                                zm(ix,1,2).ge.zxpt_reset) then
               ixpt2(1) = ix
            endif
         enddo
      endif      

c...  Set constant values for B-fields

      do 40 iy = 1, nym
         do 30 ix = 1, nxm
            do 25 n = 0, 4
               psi (ix,iy,n) = 1.   ! not used for this case
               bpol(ix,iy,n) = bpolfix
               b   (ix,iy,n) = btfix
               bphi(ix,iy,n) = sqrt( b(ix,iy,n)**2 - bpol(ix,iy,n)**2 )
! IJ 2016/10/04: radial and vertical components must be set for MCN conversions
               br  (ix,iy,n) = 0.    
               bz  (ix,iy,n) = - bpol (ix,iy,n) 
 25         continue
 30      continue
 40   continue
 
c ... Uncomment the following line to write out the data.
ccc      call writedata ('grididl', runidl)

      return
      end

c     ------------------------------------------------------------------

      subroutine grdgen

      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 	!ylbnd
      use Dimensions 
      use Share        !ishalfm
      use Inmesh 
      use Linkco 

c     local variables --
      implicit none

      integer region,rbegin

c     procedures --
      external prune,extend,splfit,sow,meshgen,meshfin

      call prune

      if (yextend .lt. ylbnd) call extend

      if (dxleft .gt. 0) call exleft		! extrapolate to smaller R

      call splfit

      call sow

      rbegin = 1
      if (ishalfm==1) rbegin = 2
      do 90 region=rbegin,noregs
         call meshgen(region)
   90 continue

      call meshfin

ccc   call remark("***** subroutine grdgen completed")

      return
      end

c     ------------------------------------------------------------------
c     ------------------------------------------------------------------

      subroutine torangrd

*  -- Subroutine for initializing the arrays rm, zm, etc. in group
*  -- RZ_grid_info for a toroidal annulus
*  -- effect in the same routine where nxm and nym are changed; thus, the
*  -- computations are done in a following routine, called torancomp.

            use Share       ! igrid,nxomit

      implicit none

      external com_set_dims, gallot

c ... Compute dimension variables nx, nym, and nxm.
      igrid = 1
      nxomit = 0
      call com_set_dims

c ... Allocate space, then compute.
      call gallot("RZ_grid_info",0)
      call gallot("Torannulus",0)
      call torancomp

      return
      end

c     --------------------------------------------------------------------
c     ------------------------------------------------------------------
      subroutine torancomp

*  -- Subroutine for computing the vertex locations of a simple
*  -- toroidal annulus

            use Dim               ! nxm,nym
            use RZ_grid_info      ! rm,zm,psi,br,bz,bpol,bphi,b
            use Xpoint_indices    ! ixpt2,iysptrx1
            use Torannulus        ! acore,edgewid,dthlim,rm0,bpol0,btor0,
                            ! radf,thpf
            use Share             ! nxcore,nysol,islimon

      implicit none

*  -- local variables
      real dely, delthp, wshf
      character*60 runtoran
      integer ix, iy, ij
      real pi  ! local pi to avoid using full Phyvar group
      data pi/3.14159265358979323/
      runtoran = 'Circular toroidal annulus'

c ... Compute the poloidal angle and radial position of cell faces
      dely = edgewid/(real(nycore(1)))
      if (islimon==0) then   ! bottom of annulus is theta=pi/2; clockwise
        delthp = 2*pi/(real(nxcore(1,1)+nxcore(1,2)))
	thpf(1,1) = 0.5*pi  
	thpf(1,2) = 0.5*pi + delthp
	thpf(1,3) = 0.5*pi  
	thpf(1,4) = 0.5*pi + delthp
	thpf(1,0) = 0.5*pi + 0.5*delthp
      else  
        delthp = 2*(pi-dthlim)/(real(nxcore(1,1)+nxcore(1,2)-2)) 
        wshf = 2*real(nxcore(1,2)-1)/real(nxcore(1,1)+nxcore(1,2)-2)           
	thpf(1,1) = 0.5*pi + wshf*dthlim 
	thpf(1,2) = 0.5*pi + wshf*dthlim + delthp
	thpf(1,3) = 0.5*pi + wshf*dthlim 
	thpf(1,4) = 0.5*pi + wshf*dthlim + delthp
        thpf(1,0) = 0.5*(thpf(1,1)+thpf(1,2))
      endif
      do iy = 0, ny
        radf(iy,1) = acore + dely*real(max(iy-1,0))
	radf(iy,2) = acore + dely*real(max(iy-1,0))
        radf(iy,3) = acore + dely*real(iy  )
        radf(iy,4) = acore + dely*real(iy  )
        radf(iy,0) = 0.5*(radf(iy,1)+radf(iy,3))
      enddo

c ... Compute poloidal angles
      do ix = 2, nxcore(1,1)-islimon   ! ix=1 set above
        thpf(ix,1) = thpf(ix-1,2)
        thpf(ix,2) = thpf(ix-1,2) + delthp
        thpf(ix,3) = thpf(ix-1,4)
        thpf(ix,4) = thpf(ix-1,4) + delthp
        thpf(ix,0) = 0.5*(thpf(ix,1)+thpf(ix,2))
      enddo
c ... Insert limiter angles if switched on
      if (islimon==1) then
        do ix = nxcore(1,1), nxcore(1,1)+1
          thpf(ix,1) = thpf(ix-1,2) 
          thpf(ix,2) = thpf(ix-1,2) + dthlim
          thpf(ix,3) = thpf(ix-1,4)
          thpf(ix,4) = thpf(ix-1,4) + dthlim
          thpf(ix,0) = 0.5*(thpf(ix,1)+thpf(ix,2))
        enddo
      endif
c ... Finish angles
      do ix = nxcore(1,1)+1+islimon, nxm   ! ix=nx set above
        thpf(ix,1) = thpf(ix-1,2)
        thpf(ix,2) = thpf(ix-1,2) + delthp
        thpf(ix,3) = thpf(ix-1,4)
        thpf(ix,4) = thpf(ix-1,4) + delthp
        thpf(ix,0) = 0.5*(thpf(ix,1)+thpf(ix,2))
      enddo

c ... Compute coordinates (rm,zm) for mesh vertices and centers
      do iy = 1, nym
        do ix = 1, nxm
	  do ij = 0, 4
	    rm(ix,iy,ij) = rm0 + radf(iy,ij)*cos(thpf(ix,ij))
	    zm(ix,iy,ij) = -radf(iy,ij)*sin(thpf(ix,ij))
          enddo
        enddo
      enddo

c...  Set B-fields
      do iy = 1, nym
        do ix = 1, nxm
          do ij= 0, 4
            bpol(ix,iy,ij) = bpol0*(rm0/rm(ix,iy,ij))**ibpmodel
            psi (ix,iy,ij) = bpol0*rm0*radf(iy,ij)*
     .                  (1-(radf(iy,ij)*cos(thpf(ix,ij))/rm0)**ibpmodel)
            br  (ix,iy,ij) = -bpol(ix,iy,ij)*sin(thpf(ix,ij))
            bz  (ix,iy,ij) = -bpol(ix,iy,ij)*cos(thpf(ix,ij))
            bphi(ix,iy,ij) = btor0*rm0/rm(ix,iy,ij)
            b   (ix,iy,ij) = sqrt(bphi(ix,iy,ij)**2 + bpol(ix,iy,ij)**2)
          enddo
        enddo
      enddo
 
c ... Uncomment the following line to write out the data.
      call writedata ('gridue', runtoran)

      return
      end
c     ------------------------------------------------------------------

      subroutine mirrorgrd

*  -- Subroutine for initializing the arrays rm, zm, etc. in group
*  -- RZ_grid_info for the annulus of a mirror B-field initially for an FRC
*  -- effect in the same routine where nxm and nym are changed; thus, the
*  -- computations are done in a following routine, called mirrorcomp.

            use Share       ! igrid,nxomit
            use Dim         ! nx,ny,nxm,nym
            use Magmirror   ! zu,ru,bru,bzu,bmag

      implicit none

      external com_set_dims, gallot

c ... Compute dimension variables nx, nym, and nxm.
      igrid = 1
      nxomit = 0
      nxm = nzc
      nym = nrc
      nx = nxm
      ny = nym
!!      call com_set_dims

c ... Allocate space, then compute.
      call gallot("RZ_grid_info",0)
      call mirrorcomp

      return
      end
c     --------------------------------------------------------------------

      subroutine mirrorcomp

*  -- Subroutine for computing the vertex locations of a mirror field

            use Dim               ! nxm,nym
            use RZ_grid_info      ! rm,zm,psi,br,bz,bpol,bphi,b
            use Magmirror         ! zu,ru,bru,bzu,bmag

      implicit none

*  -- local variables
      character*60 runmirror
      integer ix, iy, ij
      runmirror = 'Magnetic mirror (FRC-annulus)'

c ... Compute coordinates (rm,zm) for mesh vertices and centers
      do iy = 1, nym
        do ix = 1, nxm
	  do ij = 0, 4
	    rm(ix,iy,ij) = ru(ix,iy,ij)
	    zm(ix,iy,ij) = zu(ix,iy,ij)
          enddo
        enddo
      enddo

c...  Set B-fields
      do iy = 1, nym
        do ix = 1, nxm
          do ij= 0, 4
            br  (ix,iy,ij) = bru(ix,iy,ij)
            bz  (ix,iy,ij) = bzu(ix,iy,ij)
            bpol(ix,iy,ij) = bmag(ix,iy,ij)
            b   (ix,iy,ij) = bmag(ix,iy,ij)
            bphi(ix,iy,ij) = 1.e-20*b(ix,iy,ij)
          enddo
        enddo
      enddo
 
c ... Uncomment the following line to write out the data.
      call writedata ('gridue', runmirror)

      return
      end

c     --------------------------------------------------------------------
      subroutine clear
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Spline 
      use System 
      use Transfm 
      use Transit 

c     local variables --
      implicit none
      integer region,j,k,l

c     This subroutine clears the output and working arrays used in          
c     construction of the mesh

c     loop over all regions --
      do 800 region=1,noregs

      do 2208 j=jmin(region),jmax(region)
         do 2208 l=1,mseg
            do 2208 k=1,npts
               splcoef(k,l,j)=0.0
               xknts(k,l,j)=0.0
 2208 continue
c
      do 2212 j=jmin(region),jmax(region)
         do 2212 l=1,npts
            isegment(l,j)=0
 2212 continue
c
      do 2209 j=jmin(region),jmax(region)
         nseg(j)=0
         do 2209 l=1,mseg
            isys(l,j)=0
            istartg(l,j)=0
            iendg(l,j)=0
            ncap7(l,j)=0
            m(l,j)=0
 2209 continue
c
      do 2210 k=1,npts
         wg(k)=1.0
         xtrans(k)=0.0
         ytrans(k)=0.0
 2210 continue
  800 continue          ! end of loop over regions

      return
      end

c     ------------------------------------------------------------------

      subroutine codsys(j,icood,iseg,is,dy,region,alpha1)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Curves 
      use Transfm 
      use Spline 
      use Inmesh    ! dalpha
      use Transit 
      use System 
      use Argfc 
      use Share     ! cutlo
      implicit none
      integer j		! flux surface index for this contour
      integer icood	! gives the initial "direction" of the contour
			! trajectory at input data point is
      integer iseg	! on input, this is the index of the previous segment
			! of this contour
			! on output, this is the index of the current segment
			! of this contour
      integer is	! on input, this is the index of the first data point
			! on the current segment of this contour
			! on output, this is the index of the first data point
			! on the next segment of this contour
      real dy		! the "jump" criterion
      integer region	! the inboard/outboard designator
      real alpha1	! the "direction" criterion
c
      logical jump
      integer ibeg, irun, istart1, iend1, irange, i, k, nkint
      real rlimit, z1, z2, tau, s, t, dy1, beta
      external kaboom

c     icood=1, flux curve goes right, transform to system beta=0.
c     icood=2, flux curve goes up, transform to system beta=Pi/2.
c     icood=3, flux curve goes left, transform to system beta=Pi.
c     icood=4, flux curve goes down, transform to system, beta=3*Pi/2.

c     a small real number whose reciprocal does not overflow --
      rlimit = cutlo

c     find the index of the last data point for this spline segment --

         jump=.false.
         ibeg=is
         irun=is
 22      continue
         irun=irun+1
         z1=ycurveg(irun,j)-ycurveg(irun-1,j)
         z2=xcurveg(irun,j)-xcurveg(irun-1,j)

         if(abs(z1) .gt. dy) jump=.true.

         if ((j .eq. jsptrx(region)) .and.
     &             (irun .eq. ixpointc(2,region))) then
            jump=.true.
            z2=1.
         endif

         if (abs(z2) .le. abs(z1)*rlimit) then
            tau=90.
         else
            s=z1/z2
            t=atan(s)
            tau=(180./Pi)*t
         endif
c
         if (jump .or. (irun .gt. npointg(j)))  then
            if (icood.eq.1) tau=1000.
            if (icood.eq.2) tau=0.
            if (icood.eq.3) tau=1000.
            if (icood.eq.4) tau=0.
         endif
      if ((icood .eq. 1) .or. (icood .eq. 3)) then
         if (abs(tau) .le. alpha1+dalpha) goto 22
      endif
      if ((icood .eq. 2) .or. (icood .eq. 4)) then
         if(abs(tau) .gt. alpha1-dalpha) goto 22
      endif
      if ((j .eq. jsptrx(region)) .and.
     &    (irun .eq. ixpointc(1,region)))  goto 22

c     When we leave loop 22, irun-1 is the index of the last point
c     for the spline segment being constructed --

c     Set the starting index for the next spline segment --
         is=irun
         if (jump .and. (irun .le. npointg(j))) then
            ijump(j)=irun-1
            if (j .eq. jsptrx(region)) then
               is=irun+3        ! to allow inclusion of data at is-1
                                ! and is-2 for next spline segment
            else
               is=irun+2        ! to allow inclusion of data at is-1
                                ! and is-2 for next spline segment
            endif
         endif

c     Temporary definition of end points for spline data
      istart1 = max(1,ibeg-2)   ! extra data points at ibeg-1 and ibeg-2 are
                                ! included (for overlap with previous segment)
				! unless this is the first segment of the contour 
      if (jump .or. (irun .gt. npointg(j))) then
         iend1 = irun - 1       ! jump occurs at irun-1
                                ! no additional data points are included
      else
         dy1=ycurveg(irun+1,j)-ycurveg(irun,j)
         if (abs(dy1) .gt. dy) then
            iend1 = irun        ! jump occurs at irun
                                ! data point at irun is included
         else
            iend1 = irun + 1    ! data is continuous
                                ! data points at irun and irun+1 are included
         endif
      endif

c     Transform into system icood (xcurveg,ycurveg) ---> (xtrans,ytrans)
      beta = (icood-1)*90.
      call transys(beta,istart1,iend1,j)
      irange = iend1 - istart1 -1
      if (irange .lt. 5) goto 1000  ! insufficient range for spline fit

c     Test for monotonicity of end-point data
      if ( (xtrans(1) .gt. xtrans(2)) .or.
     &                    (xtrans(2) .gt. xtrans(3)) ) then
         istart1=istart1+1
         call transys(beta,istart1,iend1,j)
      endif
      if (xtrans(1) .gt. xtrans(2)) then
         istart1=istart1+1
         call transys(beta,istart1,iend1,j)
      endif
      irange = iend1 - istart1 + 1
      if ( (xtrans(irange) .lt. xtrans(irange-1)) .or.
     &           (xtrans(irange-1) .lt. xtrans(irange-2)) ) then
         iend1 = iend1-1
         irange = irange-1
         call transys(beta,istart1,iend1,j)
      endif
      if (xtrans(irange) .lt. xtrans(irange-1)) then
         iend1 = iend1-1
         irange = irange-1
         call transys(beta,istart1,iend1,j)
      endif
      if (irange .lt. 5) goto 1000  ! insufficient range for spline fit

c     Definitions for this spline segment --
       iseg=iseg+1
       if (iseg .gt. mseg) then
          write (STDOUT,901) mseg,j
  901     format ("more than mseg = ",i2," segments on",
     &            " flux contour j = ",i2)
          write (STDOUT,*) "Try changing the value of alpha1 or"
          write (STDOUT,*) "increase psi0sep or increase psi0min1."
          call kaboom(0)
       endif
       isys(iseg,j)=icood
       istartg(iseg,j)=istart1
       iendg(iseg,j)=iend1
       do 10 i=ibeg,irun-1
          isegment(i,j)=iseg
  10   continue
       m(iseg,j)=iendg(iseg,j)-istartg(iseg,j)+1

c     Call SLATEC subroutine FC to do least squares fit --
      ndata=m(iseg,j)
      do i=1,ndata
         xdatag(i)=xtrans(i)
         ydatag(i)=ytrans(i)
      enddo
      do i=1,nord			! end knots
         bkpt(i)=xtrans(1)
      enddo
c     Define interior knots --
      nkint=0
      do i=3,m(iseg,j)-2,2		! Note stride=2 for definition of knots
					! Also note that 2 data points on each
					! end are excluded as interior knots
         nkint=nkint+1
         bkpt(nkint+nord)=xtrans(i)
      enddo
      do i=nkint+nord+1,nkint+2*nord	! end knots
         bkpt(i)=xtrans(m(iseg,j))
      enddo
      nbkpt=nkint+2*nord		! total number of knots
      mode=1
      iwsla(1)=nwdim
      iwsla(2)=niwdim
      call fch(ndata,xdatag,ydatag,sddata,nord,nbkpt,bkpt,
     &        nconst,xconst,yconst,nderiv,mode,coeff,wsla,iwsla)
      if (mode .ne. 0) then
         call remark("  *** subroutine codsys ***")
         call remark("error from SLATEC routine FC")
         call kaboom(0)
      endif
c     Store the spline data --
      ncap7(iseg,j)=nbkpt
      do k=1,nbkpt
         xknts(k,iseg,j)=bkpt(k)
         splcoef(k,iseg,j)=coeff(k)
      enddo

 1000 continue

      return
      end

c     ------------------------------------------------------------------

      subroutine evalspln(iseg,j,x,y)
      use Dimflxgrd 	!,jdim,npts
      use Dimensions 
      use Spline 
      implicit none
      integer iseg, j
      real x, y(4)
      integer k, ideriv, inbv, iflagv, ncoef
      real workv(12)
      real B1VAhL
      external B1VAhL

      external kaboom

c     evaluates the (iseg,j) spline at x :
c     returns array y(k) = k-1 th derivative for k=1,4

      ncoef = ncap7(iseg,j)-4
      inbv = 1
      iflagv = 0
      do k=1,4
         ideriv = k-1
         y(k) = B1VAhL (x, ideriv, xknts(1,iseg,j), ncoef, 4,
     &                  splcoef(1,iseg,j), inbv, workv, iflagv)
      enddo
      if (iflagv .ne. 0) then
         write (STDOUT,901) iseg,j
  901    format ("spline evaluation error on segment ",i2," of flux",
     &           " contour ",i2)
         write (STDOUT,902) x
  902    format ("   x = ",1p1e14.6," in rotated coordinate system")
         call kaboom(0)
      endif

      return
      end

c     ------------------------------------------------------------------

      subroutine extend
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Curves 
      use Inmesh 
      use Linkco 

c     local variables --
      implicit none
      integer region,j,nex

c     procedures --
      external remark,kaboom

c     This subroutine ensures that each contour extends to (or below)
c     a lower boundary at y = yextend by linearly extrapolating if
c     necessary.

c     loop over all regions --
      do 800 region=1,noregs

      do 10 j=jmin(region),jmax(region)
      nex=npointg(j)-1
  11  continue
      nex=nex+1
      if (nex .ge. npts) then
         call remark("***** error in subroutine extend")
         call remark("***** number of data points exceeds npts")
         call kaboom(0)
      endif
      npointg(j)=nex
      ycurveg(nex+1,j)=2.*ycurveg(nex,j)-ycurveg(nex-1,j)
      xcurveg(nex+1,j)=2.*xcurveg(nex,j)-xcurveg(nex-1,j)
      if ((ycurveg(nex+1,j) .gt. yextend) .and.
     &    (xcurveg(nex+1,j) .gt. xlbnd) .and.
     &    (xcurveg(nex+1,j) .lt. xubnd)) goto 11
  10  continue

  800 continue          ! end of loop over regions

      return
      end

c     ------------------------------------------------------------------

      subroutine findalph(nsys,iseg,j,xob,yob,alphab)
      use Dimflxgrd 	!jdim,npts
      use Dimensions 
      use Transfm 
      use Spline 
      implicit none
      integer nsys, iseg, j
      real xob, yob, alphab
      real alphaf,sinalpf,cosalpf,tanalp,alpha
      real xo, yo(4)

c     this subroutine finds the rotation angle of the moving system
c     relative to the basic system, given the coordinates of the
c     point (on the spline) in the basic system.

c     find the rotation angle of the fixed system in which the
c     spline was fitted.
      alphaf=alphasys(nsys)

c     transform the x of the point into the fixed system.
      sinalpf=sin(alphaf)
      cosalpf=cos(alphaf)
      xo=xob*cosalpf+yob*sinalpf

c     find the slope of the spline at xo.
c     check for possible out-of-range error condition:
         if (xo .lt. xknts(1,iseg,j)) then
            call remark("*** error from s.r. findalph")
            write (STDOUT,901) iseg,j,xob,yob
            call kaboom(0)
         elseif (xo .gt. xknts(ncap7(iseg,j),iseg,j)) then
            call remark("*** error from s.r. findalph")
            write (STDOUT,901) iseg,j,xob,yob
            call kaboom(0)
         endif
 901     format("iseg,j,xob,yob = ",i3,i3,f11.4,f11.4)

      call evalspln(iseg,j,xo,yo)
      tanalp=yo(2)

c     transform back to the moving system.
      alpha=atan(tanalp)
      alphab=alpha+alphaf

      return
      end

c     ------------------------------------------------------------     c

      subroutine intersect (x,y,i1,i2,xfp,yfp,thetafp,xc,yc,ic)
      implicit none
      integer i1,i2,ic
      real x(*),y(*),xfp,yfp,thetafp,xc,yc

c     Find the intersection of the curve (x(i),y(i)) i=i1,i2
c     with the straight line y = yfp + (x-xfp)*tan(thetafp);
c     Return the intersection point (xc,yc) and the node index ic
c     such that the intersection point lies between nodes ic and ic+1.

      integer i
      real bignum,tanfp,tanic
      data bignum /1.0e+6/
      tanfp=min(tan(thetafp),+bignum)
      tanfp=max(tanfp,-bignum)

      ic=0		! return this 'error' flag value if no intersection

      do i=i1,i2-1	! search forward from x-point; should also consider
			! backward search from end of original mesh ?
         if ( (y(i)-yfp-(x(i)-xfp)*tanfp)*\
                  (y(i+1)-yfp-(x(i+1)-xfp)*tanfp) .le. 0) then
c     line falls between point i and point i+1
            ic=i
            tanic=(y(i+1)-y(i))/(x(i+1)-x(i))
            xc=((y(i)-x(i)*tanic)-(yfp-xfp*tanfp))/(tanfp-tanic)
            yc=yfp+(xc-xfp)*tanfp
            exit
         endif
      enddo

      return
      end

c     ------------------------------------------------------------     c

      subroutine intrcept(iseg,j,xo,yo,alpha,xm,sguess,s,isegalt)
      use Dimflxgrd 	!jdim,npts
      use Dimensions 
      use Spline 

c     *** this routine finds the intercept of the spline and the straight
c     *** line through the point (xm,0) parallel to the y axis of the
c     *** moving system.

ccc   If a potential out-of-range spline evaluation error is encountered,
ccc   then isegalt suggests an alternative value for iseg to avoid the error.

c
c     *** transform xm and sguess into the fixed system (of the spline).
      implicit none
      integer iseg, j, noiter, iter, isegalt
      real xo, yo, alpha, xm, sguess, s, sinalp, cosalp, xf, yf
      real x1, y1, slope, dx, xlimit, xfold, sfold, s1, xfnew
      real ss(4),sfnew(4)
         sinalp=sin(alpha)
         cosalp=cos(alpha)
c
         xf=xo+xm*cosalp-sguess*sinalp
         yf=yo+xm*sinalp+sguess*cosalp
c     *** transform (xm,0) into the fixed system.
         x1=xo+xm*cosalp
         y1=yo+xm*sinalp
c
c     ***
      if (abs(alpha).gt.0.001) then
         slope=-1.0/tan(alpha)
         dx=0.01*abs(sguess)
         xlimit=0.1*dx
c
c     *** obtain the solution of the equation s-y1-slope*(x-x1)=0.
         xfold=xf
         sfold=yf
         noiter=10
c
      isegalt=iseg
      do 10 iter=1,noiter

c     find the derivative of s at xfold
ccc   begin error check
         if (xfold .lt. xknts(1,iseg,j)) then
            isegalt=iseg-1	! switch to previous spline segment
            goto 12
         elseif (xfold .gt. xknts(ncap7(iseg,j),iseg,j)) then
            isegalt=iseg+1	! switch to next spline segment
            goto 12
         endif
ccc   end error check
         call evalspln(iseg,j,xfold,ss)
         s1=ss(2)

         xfnew=xfold-(sfold-y1-slope*(xfold-x1))/(s1-slope)
ccc   begin error check
         if (xfnew .lt. xknts(1,iseg,j)) then
            isegalt=iseg-1	! switch to previous spline segment
            goto 12
         elseif (xfnew .gt. xknts(ncap7(iseg,j),iseg,j)) then
            isegalt=iseg+1	! switch to next spline segment
            goto 12
         endif
ccc   end error check
         call evalspln(iseg,j,xfnew,sfnew)

         if(abs(xfnew-xfold).lt.xlimit) goto 11
            xfold=xfnew
            sfold=sfnew(1)
c
   10 continue
   11 continue
c
         else
            xfnew=x1
ccc   begin error check
            if (xfnew .lt. xknts(1,iseg,j)) then
               isegalt=iseg-1	! switch to previous spline segment
               goto 12
            elseif (xfnew .gt. xknts(ncap7(iseg,j),iseg,j)) then
               isegalt=iseg+1	! switch to next spline segment
               goto 12
            endif
ccc   end error check
            call evalspln(iseg,j,xfnew,sfnew)
         endif
c
c     *** transform the answer into the moving system.
         s=-(xfnew-xo)*sinalp+(sfnew(1)-yo)*cosalp
c
   12 continue
      return
      end

c     ------------------------------------------------------------------

      subroutine meshfin
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Curves 
      use Linkco 
      use Inmesh 
      use Mmod 
      use Share    ! ismmon,ishalfm
      implicit none
      integer ix1,ix2,i,irange,i1,i2,region
      integer j,jrange,j1,j2,jj
      real xavg,yavg,cmx,cmy

      external meshmod1,meshmod2,meshmod3

      if ( (geometry .eq. "dnbot") .or. (geometry .eq. "dnull") .or.
     .    (geometry == "isoleg") ) then
         if (istpnew==0) then	! 1st seed point is NOT user-specified
c     Move the first angle-like surface to the exact magnetic midplane
            do j=jmin(1),jmax(2)
               cmeshy(1,j) = zmagx
            enddo
         endif
      endif

c     Corrections at cut interfaces where two halves of the mesh
c     are joined together:
      if (ishalfm==0) then

c     Correct the curve going from the x-point to the center.
      ix1=ixpoint(1,1)-1
      ix2=ixpoint(1,2)-1
      irange=ixpoint(2,1)-ixpoint(1,1)+1
      jrange=jmax(1)-jsptrx(1)
      do i=1,irange
         i1=ix1+i
         i2=ix2+i
         do j=0,jrange
            j1=jsptrx(1)+j
            j2=jsptrx(2)-j
            xavg=0.5*(cmeshx(i1,j1)+cmeshx(i2,j2))
            yavg=0.5*(cmeshy(i1,j1)+cmeshy(i2,j2))
            cmeshx(i1,j1)=xavg
            cmeshy(i1,j1)=yavg
            cmeshx(i2,j2)=xavg
            cmeshy(i2,j2)=yavg
         enddo
      enddo

c     Correct the curve going from the x-point to the private region.
      jrange=jmax(1)-jsptrx(1)
      i1=ixpoint(3,1)
      i2=ixpoint(3,2)
      do j=0,jrange
         j1=jsptrx(1)+j
         j2=jsptrx(2)-j
         xavg=0.5*(cmeshx(i1,j1)+cmeshx(i2,j2))
         yavg=0.5*(cmeshy(i1,j1)+cmeshy(i2,j2))
         cmeshx(i1,j1)=xavg
         cmeshy(i1,j1)=yavg
         cmeshx(i2,j2)=xavg
         cmeshy(i2,j2)=yavg
      enddo

c     Correct the curve through the top of the mesh.
      if ( ((geometry .eq. "snull").or.(geometry .eq. "uppersn"))
     .                      .and. (islimon==0) ) then
         do jj = jmin(1),jmax(1)
            cmx = 0.5 * (cmeshx(1,jj)+cmeshx(1,jmax(2)-jj+jmin(1)))
            cmy = 0.5 * (cmeshy(1,jj)+cmeshy(1,jmax(2)-jj+jmin(1)))
            cmeshx(1,jj) = cmx
            cmeshx(1,jmax(2)-jj+jmin(1)) = cmx
            cmeshy(1,jj) = cmy
            cmeshy(1,jmax(2)-jj+jmin(1)) = cmy
         enddo
      endif

      endif   ! end corrections on cut interfaces

! Options for creating non-orthogonal mesh:
      if (ismmon .ne. 0) then		! save copy of orthogonal mesh
         call s2copy(idim,jdim,cmeshx,1,idim,cmeshx0,1,idim)
         call s2copy(idim,jdim,cmeshy,1,idim,cmeshy0,1,idim)
      endif
      if (ismmon .eq. 1) then
c..      set flag to pass to nphygeo in package bbb via the Share group
         isnonog = 1
c        define upstream and plate arrays, if necessary
         if (istream .eq. 0) call getu	! default upstream definition
         if (iplate  .eq. 0) call getp	! default orthogonal definition
         do region=1,noregs
            call meshmod1(region)
         enddo
c        smooth angle-like surfaces, if desired
         call smoother
      elseif (ismmon .eq. 2) then
c..      set flag to pass to nphygeo in package bbb via the Share group
         isnonog = 1
c        define upstream and plate arrays, if necessary
         if (istream .eq. 0) call getu	! default upstream definition
         if (iplate  .eq. 0) call getp	! default orthogonal definition
         do region=1,noregs
            call meshmod2(region)
         enddo
c        smooth angle-like surfaces, if desired
         call smoother
      elseif (ismmon .eq. 3) then
c..      set flag to pass to nphygeo in package bbb via the Share group
         isnonog = 1
         call gett			! top-of-mesh definition
         call getd			! downstream definition
c        define upstream and plate arrays, if necessary
         if (istream .eq. 0) call getu	! default upstream definition
         if (iplate  .eq. 0) call getp	! default orthogonal definition
         do region=1,noregs
            call meshmod3(region)
         enddo
c        smooth angle-like surfaces, if desired
         call smoother
      endif

! Option for including limiter surface:
      if ((islimon .ne. 0) .and. ((geometry .eq. 'snull')
     .        .or. (geometry .eq. 'uppersn'))) then
         call s2copy(idim,jdim,cmeshx,1,idim,cmeshx0,1,idim)
         call s2copy(idim,jdim,cmeshy,1,idim,cmeshy0,1,idim)
         isnonog = 1   ! non-orthog mesh: pass this flag to bbb.nphygeo
         call getlim   ! define limiter interface with in/outboard regions
         do region=1,noregs
            call meshlim(region)
         enddo
c        do smoothing on angle-like surfaces ????
         call setlimindex      ! before or after smoothing ???
      endif

! Assign values to cmesh for the "axis" flux surface :
!
      j = jaxis
!
! above the x-point (magnetic axis) :
      i1=1
      i2=ixpoint(2,1)
      do i=i1,i2
            cmeshx(i,j) = rmagx
            cmeshy(i,j) = zmagx
      enddo
!
! below the x-point (conjugate axis) :
      i1=ixpoint(3,1)
      i2=max(ilmax(1),ilmax(2))
      do i=i1,i2
         cmeshx(i,j) = 0.5 * ( cmeshx(ilmax(1),jmax(1))
     &                      +  cmeshx(ilmax(2),jmin(2)) )
         cmeshy(i,j) = 0.5 * ( cmeshy(ilmax(1),jmax(1))
     &                      +  cmeshy(ilmax(2),jmin(2)) )
      enddo

! assign values to cmesh when ilmax(1) and ilmax(2) are different by
! creating zero-volume cells at the plates :
	if (ilmax(1) .lt. ilmax(2)) then
	   do i=ilmax(1)+1,ilmax(2)
	      do j=jmin(1),jmax(1)
	         cmeshx(i,j) = cmeshx(ilmax(1),j)
	         cmeshy(i,j) = cmeshy(ilmax(1),j)
	      enddo
	   enddo
	elseif (ilmax(2) .lt. ilmax(1)) then
	   do i=ilmax(2)+1,ilmax(1)
	      do j=jmin(2),jmax(2)
	         cmeshx(i,j) = cmeshx(ilmax(2),j)
	         cmeshy(i,j) = cmeshy(ilmax(2),j)
	      enddo
	   enddo
	endif

      return
      end

c----------------------------------------------------------------------c

      subroutine meshgen (region)
      use Share         !isfrc
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 
      use Dimensions 
      use Curves 
      use Linkco 
      use Transfm 
      use Inmesh 

c     local variables --
      implicit none
      integer region
      integer i,ii,iseg,isptrx,j,jj,j1,j2,nsys
      real alphab,alphab1,alphab2,alphabsx,distance,distmin,
     &     xob,xosptrx,yob,yosptrx

c     procedures ---
      external findalph, kaboom, orthogrd, orthogx, remark

c     initialization --
      data alphab /0./
      data alphab1 /0./
      data alphab2 /0./
      data alphabsx /0./
      data distance /0./
      data distmin /0./
      data xob /0./
      data yob /0./
      data xosptrx /0./
      data yosptrx /0./

c     This subroutine generates a mesh by finding an orthogonal set
c     of curves to (xcurveg,ycurveg)

         jj=jsptrx(region)

c     loop over the seed points --
      do 20 i=1,ilmax(region)
         xosptrx=cmeshx(i,jj)
         yosptrx=cmeshy(i,jj)


      if((i.lt.ixpoint(1,region)).or.(i.gt.ixpoint(3,region))) then
c     *** find which segment this point is on
         distmin=(xubnd-xlbnd)+(yubnd-ylbnd)
         do 30 ii=1,npointg(jj)
            distance = sqrt((xcurveg(ii,jj)-xosptrx)**2
     .                     +(ycurveg(ii,jj)-yosptrx)**2)
            if(distance.gt.distmin) goto 30
            distmin=distance
            isptrx=ii
   30    continue
c     *** we now know the nearest point on the curve.
c     *** find the segment and the corresponding system.
         iseg=isegment(isptrx,jj)
         if (iseg .eq. 0) then
            call remark ("*** error in subroutine meshgen")
            write (STDOUT,899) isptrx,jj
  899       format ("data point i=",i3," on contour j=",i3," is not",
     &              " assigned to a spline segment")
            call kaboom(0)
         endif
         nsys=isys(iseg,jj)
c     *** find the rotation angle of the moving system.
         call findalph(nsys,iseg,jj,xosptrx,yosptrx,alphabsx)
         alphab=alphabsx
      endif


c     *** next go in the direction of smaller j and find the nearest
c     *** point on the next curve satisfying the orthogonality
c     *** condition
c     Finding the first point off the separatrix requires special 
c     treatment when starting from the x-point because the slope there 
c     is not uniquely defined => use s.r. orthogx vs orthogrd
      if (jj .gt. jmin(region)) then
        xob=xosptrx
        yob=yosptrx
        j1=jj
        j2=jj-1
        j=j2
        if (i.lt.ixpoint(1,region)) then
           call orthogrd(ityp(1,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
        elseif (i.eq.ixpoint(1,region)) then
           call orthogx(ityp(1,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
           alphab1=alphab
        elseif (i.eq.ixpoint(2,region)) then
           cmeshx(i,j)=cmeshx(i-1,j)
           cmeshy(i,j)=cmeshy(i-1,j)
           xob=cmeshx(i,j)
           yob=cmeshy(i,j)
           alphab=alphab1
ccc Modification for field-reversed configuration
ccc        elseif (i.eq.ixpoint(3,region)) then
        elseif (i.eq.ixpoint(3,region) .and. isfrc==0) then
           call orthogx(ityp(3,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
ccc Modification for field-reversed configuration
ccc	elseif (i.gt.ixpoint(3,region)) then
	elseif (i.gt.ixpoint(3,region) .and. isfrc==0) then
           call orthogrd(ityp(3,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
        endif

        do 50 j=jj-2,jmin(region),-1
           j1=j+1
           j2=j
	   if (i.le.ixpoint(2,region)) then
              call orthogrd(ityp(1,region),i,j1,j2,xob,yob,alphab)
              cmeshx(i,j)=xob
              cmeshy(i,j)=yob
ccc Modification for field-reversed configuration
ccc	   elseif (i.ge.ixpoint(3,region)) then
	   elseif (i.ge.ixpoint(3,region) .and. isfrc==0) then
              call orthogrd(ityp(3,region),i,j1,j2,xob,yob,alphab)
              cmeshx(i,j)=xob
              cmeshy(i,j)=yob
	   endif
   50   continue
      endif


c     *** repeat the process for j greater than jsptrx.
      if (jj .lt. jmax(region)) then
        xob=xosptrx
        yob=yosptrx
        alphab=alphabsx
        j1=jj
        j2=jj+1
        j=j2
        if (i.lt.ixpoint(1,region)) then
           call orthogrd(ityp(4,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
        elseif (i.eq.ixpoint(1,region)) then
           call orthogx(ityp(4,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
           alphab2=alphab
        elseif (i.eq.ixpoint(2,region)) then
           cmeshx(i,j)=cmeshx(i-1,j)
           cmeshy(i,j)=cmeshy(i-1,j)
           xob=cmeshx(i,j)
           yob=cmeshy(i,j)
           alphab=alphab2
        elseif (i.eq.ixpoint(3,region)) then
           call orthogx(ityp(6,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
	elseif (i.gt.ixpoint(3,region)) then
           call orthogrd(ityp(6,region),i,j1,j2,xob,yob,alphab)
           cmeshx(i,j)=xob
           cmeshy(i,j)=yob
        endif

        do 60 j=jj+2,jmax(region),+1
           j1=j-1
           j2=j
	   if (i.le.ixpoint(2,region)) then
              call orthogrd(ityp(4,region),i,j1,j2,xob,yob,alphab)
              cmeshx(i,j)=xob
              cmeshy(i,j)=yob
	   elseif (i.ge.ixpoint(3,region)) then
              call orthogrd(ityp(6,region),i,j1,j2,xob,yob,alphab)
              cmeshx(i,j)=xob
              cmeshy(i,j)=yob
	   endif
   60   continue
      endif


c     *** close the loop along the seed points.
   20 continue

      return
      end

c----------------------------------------------------------------------c

      subroutine meshmod1 (region)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 
      use Dimensions 
      use Curves 
      use Inmesh 
      use Linkco 
      use Mmod 
      use Transfm 
      implicit none
      integer region
      external intersect2, remark, kaboom

c     Local variables --
      integer i,istart,iend,ii,ii1,ii2,j,j1,j2,k,ierr
      integer i1crv,i2crv,i1msh,i2msh,imu,kmu,icu,kcu,icp,kcp
      real xmu,ymu,xcu,ycu,xcp,ycp
      real dsmp0,dscp,frac,eps

c     This subroutine modifies the original orthogonal mesh by
c     expanding or compressing the grid along each flux surface between
c     the divertor plate and some upstream reference surface.

      data eps/1.0e-06/		! extrapolation parameter

      j1=jmin(region)
      j2=jmax(region)
      iend=ilmax(region)

c     Define the upstream reference surface that stays fixed:
      if (region .eq. 1) then
         nupstream=nupstream1
         if (nupstream .gt. nptmp) then
            call remark("dimension of r,zupstream1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream1(k)
            zupstream(k)=zupstream1(k)
         enddo
      elseif (region .eq. 2) then
         nupstream=nupstream2
         if (nupstream .gt. nptmp) then
            call remark("dimension of r,zupstream2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream2(k)
            zupstream(k)=zupstream2(k)
         enddo
      endif

c     Define the surface that coincides with the new divertor plate:
      if (region .eq. 1) then
         nplate=nplate1
         if (nplate .gt. nptmp) then
            call remark("dimension of r,zplate1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate1(k)
            zplate(k)=zplate1(k)
         enddo
      elseif (region .eq. 2) then
         nplate=nplate2
         if (nplate .gt. nptmp) then
            call remark("dimension of r,zplate2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate2(k)
            zplate(k)=zplate2(k)
         enddo
      endif

c     Define the surface that coincides with the original divertor plate:
      nplate0=j2-j1+1
         if (nplate0 .gt. nptmp) then
            call remark("dimension of r,zplate0 exceeds nptmp")
            call kaboom(0)
         endif
      do k=j1,j2
         rplate0(k-j1+1)=cmeshx(iend,k)
         zplate0(k-j1+1)=cmeshy(iend,k)
      enddo
c     extrapolate end points slightly beyond the the original plate
      rplate0(1)=2*rplate0(1)-rplate0(2)
      zplate0(1)=2*zplate0(1)-zplate0(2)
      rplate0(nplate0)=2*rplate0(nplate0)-rplate0(nplate0-1)
      zplate0(nplate0)=2*zplate0(nplate0)-zplate0(nplate0-1)

c----------------------------------------------------------------------c
c     Loop over all flux surfaces:
      do j=j1,j2

c     Define some temporary variables for (xcurveg,ycurveg) surface data
         i1crv=ijump(j)+1	! start index
         i2crv=npointg(j)	! end index
         if (j .eq. jsptrx(region)) i1crv=1
         do i=i1crv,i2crv
            xcrv(i)=xcurveg(i,j)
            ycrv(i)=ycurveg(i,j)
         enddo

c     Define some temporary variables for (cmeshx,y) surface data
         i1msh=1			! start at top of SOL
         i2msh=ilmax(region)		! end index
         if ( (j .gt. jsptrx(1)) .and. (j .lt. jsptrx(2)) ) then
            i1msh=ixpoint(3,region)	! start at p.f. cut
         endif
         do i=i1msh,i2msh
            xmsh(i)=cmeshx(i,j)
            ymsh(i)=cmeshy(i,j)
         enddo
c     extrapolate upstream slightly from the initial point
         xmsh(i1msh)=xmsh(i1msh)+eps*(xmsh(i1msh)-xmsh(i1msh+1))
         ymsh(i1msh)=ymsh(i1msh)+eps*(ymsh(i1msh)-ymsh(i1msh+1))

c     Intersection of (cmeshx,y) with upstream reference surface
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xmsh(i1msh),ymsh(i1msh),i1msh,i2msh,
     &                   xmu,ymu,kmu,imu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,885) j
 885        format ("no upstream intersection for cmeshx,y on j=",i3)
            call kaboom(0)
         endif

c        ensure that separatrix points are not modified above x-point:
         if ( (j .eq. jsptrx(region)) .and. 
     &        (imu .lt. ixpoint(3,region)) ) then
            imu=ixpoint(3,region)
            xmu=rseps
            ymu=zseps
         endif

         istart=imu+1	! index of first point below reference surface
         iend=i2msh	! index of last point below reference surface

c     Distance from upstream reference to each (cmeshx,y) point
         dsm(istart-1)=0.
         dsm(istart)=sqrt( (xmsh(istart)-xmu)**2 +
     &                        (ymsh(istart)-ymu)**2 )
         do i=istart+1,iend
            dsm(i)=dsm(i-1) +
     &                   sqrt( (xmsh(i)-xmsh(i-1))**2 +
     &                         (ymsh(i)-ymsh(i-1))**2 )
         enddo
c     Total distance from upstream reference to old divertor plate
c     along the cmeshx,y representation of the flux surface
         dsmp0=dsm(iend)
c     Normalize
         do i=istart,iend
            dsm(i)=dsm(i)/dsmp0
         enddo

c     Intersection of (x,ycurveg) with upstream reference surface
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcu,ycu,kcu,icu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,886) j
 886        format ("no upstream intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif

c        ensure that separatrix points are not modified above x-point:
         if ( (j .eq. jsptrx(region)) .and. 
     &        (icu .lt. ijump(j)) ) then
            icu=ijump(j)
            xcu=rseps
            ycu=zseps
         endif

         ii1=icu+1	! index of first point below reference surface
c     Re-define the data point at index ii1-1 to lie exactly on the
c     reference surface:
         xcrv(ii1-1)=xcu
         ycrv(ii1-1)=ycu

c     Intersection of (x,ycurveg) with new divertor plate
         call intersect2(rplate,zplate,1,nplate,
     &                    xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                    xcp,ycp,kcp,icp,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,887) j
 887        format ("no new plate intersection for x,ycurveg on j=",i3)
            write (STDOUT,889)
 889        format ("*** You may have to extend the plate end points")
            call kaboom(0)
         endif
         ii2=icp+1	! index of first point below new divertor plate

c     Distance from upstream reference to each (x,ycurveg) point
         dsc(ii1-1)=0.
         do ii=ii1,i2crv
            dsc(ii)=dsc(ii-1) +
     &                   sqrt( (xcrv(ii)-xcrv(ii-1))**2 +
     &                         (ycrv(ii)-ycrv(ii-1))**2 )
         enddo

c     Total distance from upstream reference to new divertor plate
         dscp=dsc(ii2)-sqrt( (xcrv(ii2)-xcp)**2 +
     &                               (ycrv(ii2)-ycp)**2 )


c     Compute new arc lengths --
         do i=istart,iend
            dsmesh(i)=dsm(i)*dscp
         enddo

c     Modified cmeshx,cmeshy values --
            do i=istart,iend
               do ii=ii1,ii2
                  if (dsmesh(i) .le. dsc(ii)) then
c     modified point i lies between (x,ycurveg) points ii-1 and ii
                     frac=(dsmesh(i)-dsc(ii-1))/
     &                    (dsc(ii)-dsc(ii-1))
                     cmeshx(i,j)=xcrv(ii-1) + frac*(xcrv(ii)-xcrv(ii-1))
                     cmeshy(i,j)=ycrv(ii-1) + frac*(ycrv(ii)-ycrv(ii-1))
                     exit
                  endif
               enddo
            enddo

      enddo	! end of loop over all j flux surfaces
c----------------------------------------------------------------------c

      return
      end

c----------------------------------------------------------------------c

      subroutine meshmod2 (region)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 	! nix,idim
      use Curves 	! xcurveg,ycurveg
      use Inmesh 	! ilmax
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	! 
      use Transfm 	! ijump
      implicit none
      integer region
      external intersect2, remark, kaboom

c     local variables --
      integer i,ii,istart,iend,j,jj,k
      integer i1crv,i2crv,kcu,icu,ierr,ii1,kcp,icp,ii2
      real xcu,ycu,xcp,ycp
      real dstotal,dscp,frac

c     This subroutine places mesh points on flux surfaces
c     using the same normalized distribution as the seed points
c     on the separatrix.

c----------------------------------------------------------------------c
c     Define the upstream reference surface:
      if (region .eq. 1) then
         nupstream=nupstream1
         if (nupstream .gt. nptmp) then
            call remark("meshmod2: dim'n of r,zupstream1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream1(k)
            zupstream(k)=zupstream1(k)
         enddo
      elseif (region .eq. 2) then
         nupstream=nupstream2
         if (nupstream .gt. nptmp) then
            call remark("meshmod2: dim'n of r,zupstream2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream2(k)
            zupstream(k)=zupstream2(k)
         enddo
      endif

c----------------------------------------------------------------------c
c     Define the divertor plate surface:
      if (region .eq. 1) then
         nplate=nplate1
         if (nplate .gt. nptmp) then
            call remark("meshmod2: dimension of r,zplate exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate1(k)
            zplate(k)=zplate1(k)
         enddo
      elseif (region .eq. 2) then
         nplate=nplate2
         if (nplate .gt. nptmp) then
            call remark("meshmod2: dimension of r,zplate exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate2(k)
            zplate(k)=zplate2(k)
         enddo
      endif

c----------------------------------------------------------------------c
c     Loop over all flux surfaces:
      do j=jmin(region),jmax(region)

c     Define some temporary variables for (xcurveg,ycurveg) surface data
         i1crv=ijump(j)+1	! start index
         i2crv=npointg(j)	! end index
         if (j .eq. jsptrx(region)) i1crv=1
         do i=i1crv,i2crv
            xcrv(i)=xcurveg(i,j)
            ycrv(i)=ycurveg(i,j)
         enddo

c     Intersection of reference surface with x,ycurveg
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcu,ycu,kcu,icu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,886) j
 886        format 
     & ("meshmod2: no reference intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
         ii1=icu+1	! index of first point below reference surface
c     Re-define the data point at index ii1-1 to lie exactly on the
c     reference surface:
         xcrv(ii1-1)=xcu
         ycrv(ii1-1)=ycu

c     Intersection of divertor plate surface with x,ycurveg)
         call intersect2(rplate,zplate,1,nplate,
     &                    xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                    xcp,ycp,kcp,icp,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,887) j
 887        format 
     & ("meshmod2: no plate intersection for x,ycurveg on j=",i3)
            write (STDOUT,889)
 889        format ("*** You may have to extend the plate end points")
            call kaboom(0)
         endif
         ii2=icp+1	! index of first point below divertor plate

c     Distance from reference surface to each (x,ycurveg) point
         dsc(ii1-1)=0.
         do ii=ii1,i2crv
            dsc(ii)=dsc(ii-1) +
     &                   sqrt( (xcrv(ii)-xcrv(ii-1))**2 +
     &                         (ycrv(ii)-ycrv(ii-1))**2 )
         enddo

c     Total distance from reference surface to divertor plate
         dscp=dsc(ii2)-sqrt( (xcrv(ii2)-xcp)**2 +
     &                               (ycrv(ii2)-ycp)**2 )

c     Normalized distance along the separatrix:

ccc   NOTE: The following assumes that the upstream reference surface 
ccc         coincides with the i=1 surface in the SOL and the 
ccc         i=ixpoint(3,region) in the private flux region.  This 
ccc         may NOT be consistent with the upstream data that the 
ccc         user supplies !!!

         if ( (j .ge. jsptrx(1)) .and. (j .le. jsptrx(2)) ) then
            istart=ixpoint(3,region)	! for psi<=1 flux surfaces
         else
            istart=1			! for psi>1 flux surfaces
         endif
         iend=ilmax(region)
         jj=jsptrx(region)
         dsnorm(istart)=0.
         do i=istart+1,iend
            dsnorm(i)=dsnorm(i-1) +
     &                sqrt( (cmeshx(i,jj)-cmeshx(i-1,jj))**2 +
     &                      (cmeshy(i,jj)-cmeshy(i-1,jj))**2 )
         enddo
         dstotal=dsnorm(iend)
         do i=istart,iend
            dsnorm(i)=dsnorm(i)/dstotal
         enddo

c     Find cmeshx,y by interpolation along x,ycurveg
         do i=istart+1,iend
            dsmesh(i)=dsnorm(i)*dscp
            do ii=ii1,ii2
               if (dsmesh(i) .le. dsc(ii)) then
c           modified point i lies between (x,ycurveg) points ii-1 and ii
                  frac=(dsmesh(i)-dsc(ii-1))/
     &                 (dsc(ii)-dsc(ii-1))
                  cmeshx(i,j)=xcrv(ii-1) + frac*(xcrv(ii)-xcrv(ii-1))
                  cmeshy(i,j)=ycrv(ii-1) + frac*(ycrv(ii)-ycrv(ii-1))
                  exit
               endif
            enddo
         enddo

      enddo		! end of loop over flux surfaces

      return
      end

c----------------------------------------------------------------------c

      subroutine meshmod3 (region)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 	! rseps,zseps
      use Dimensions  ! nptmp
      use Curves      ! npointg,xcurveg,ycurveg
      use Inmesh      ! ilmax
      use Linkco      ! ixpoint,cmeshx,cmeshy
      use Mmod        ! ntop,ntop1,ntop2,rtop,rtop1,rtop2,ztop,ztop1,ztop2,
                ! nupstream,nupstream1,nupstream2,rupstream,rupstream1,
                ! rupstream2,zupstream,zupstream1,zupstream2,ndnstream,
                ! ndnstream1,ndnstream2,rdnstream,rdnstream1,rdnstream2,
                ! zdnstream,zdnstream1,zdnstream2,nplate,nplate1,
                ! nplate2,rplate,rplate1,rplate2,zplate,zplate1,zplate2,
                ! nplate0,rplate0,zplate0,cmeshx0,cmeshy0,fuzzm,xmsh,
                ! ymsh,dss,dssleg,xcrv,ycrv,dsm,dsc,dmix0,delmax,
                ! dsmesh0,dsmesh1,dsmesh2,dsmesh,wtmesh1
      use Transfm     ! ijump
      implicit none
      integer region
      external intersect2, remark, kaboom, twixt
      logical twixt

c     Local variables --
      integer i,iend,ii,j,j1,j2,k,ierr,i0,i0leg
      integer i1crv,i2crv,i1msh,i2msh,imu,kmu,icu,kcu,icp,kcp
      integer ict,kct,imt,icp0,kcp0,icd,kcd,imd,im12d
      integer na,ica,kca
      real xmu,ymu,xcu,ycu,xcp,ycp,xct,yct,xmt,ymt,xcp0,ycp0,dscp0
      real dsmu,dsmp0,dscu,dscp,frac,eps,dssp0,dsslegp0,dssu,fracu
      real xcd,ycd,xmd,ymd,dscd,len,dscmi
      real ra(3),za(3),xca,yca

c     This subroutine modifies the original orthogonal mesh by
c     re-distributing the mesh points along each flux surface.
c     It combines features of the ismmon=0,1,2 options via
c     weight factor wtmesh1 and normalized mixing length dmix0.

      data eps/1.0e-06/		! extrapolation parameter

      j1=jmin(region)
      j2=jmax(region)
      iend=ilmax(region)

c     Define the top-of-mesh surface :
      if (region .eq. 1) then
         ntop=ntop1
         if (ntop .gt. nptmp) then
            call remark("dimension of r,ztop1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ntop
            rtop(k)=rtop1(k)
            ztop(k)=ztop1(k)
         enddo
      elseif (region .eq. 2) then
         ntop=ntop2
         if (ntop .gt. nptmp) then
            call remark("dimension of r,ztop2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ntop
            rtop(k)=rtop2(k)
            ztop(k)=ztop2(k)
         enddo
      endif

c     Define the upstream reference surface :
      if (region .eq. 1) then
         nupstream=nupstream1
         if (nupstream .gt. nptmp) then
            call remark("dimension of r,zupstream1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream1(k)
            zupstream(k)=zupstream1(k)
         enddo
      elseif (region .eq. 2) then
         nupstream=nupstream2
         if (nupstream .gt. nptmp) then
            call remark("dimension of r,zupstream2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream2(k)
            zupstream(k)=zupstream2(k)
         enddo
      endif

c     Define the downstream reference surface :
      if (region .eq. 1) then
         ndnstream=ndnstream1
         if (ndnstream .gt. nptmp) then
            call remark("dimension of r,zdnstream1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ndnstream
            rdnstream(k)=rdnstream1(k)
            zdnstream(k)=zdnstream1(k)
         enddo
      elseif (region .eq. 2) then
         ndnstream=ndnstream2
         if (ndnstream .gt. nptmp) then
            call remark("dimension of r,zdnstream2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ndnstream
            rdnstream(k)=rdnstream2(k)
            zdnstream(k)=zdnstream2(k)
         enddo
      endif

c     Define the new divertor plate surface :
      if (region .eq. 1) then
         nplate=nplate1
         if (nplate .gt. nptmp) then
            call remark("dimension of r,zplate1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate1(k)
            zplate(k)=zplate1(k)
         enddo
      elseif (region .eq. 2) then
         nplate=nplate2
         if (nplate .gt. nptmp) then
            call remark("dimension of r,zplate2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate2(k)
            zplate(k)=zplate2(k)
         enddo
      endif

c     Define the old (orthogonal) divertor plate surface :
      nplate0=j2-j1+1
         if (nplate0 .gt. nptmp) then
            call remark("dimension of r,zplate0 exceeds nptmp")
            call kaboom(0)
         endif
      do k=j1,j2
         rplate0(k-j1+1)=cmeshx0(iend,k)
         zplate0(k-j1+1)=cmeshy0(iend,k)
      enddo
c     extrapolate end points slightly beyond the the original plate
      rplate0(1)=2*rplate0(1)-rplate0(2)
      zplate0(1)=2*zplate0(1)-zplate0(2)
      rplate0(nplate0)=2*rplate0(nplate0)-rplate0(nplate0-1)
      zplate0(nplate0)=2*zplate0(nplate0)-zplate0(nplate0-1)

c----------------------------------------------------------------------c
c     Compute original meshpoint distribution along separatrix
c     for use with ismmon=2 option.

      j=jsptrx(region)

c     Define some temporary variables for (cmeshx,y) surface data
         i1msh=1			! start index
         i2msh=ilmax(region)		! end index
         do i=i1msh,i2msh
            xmsh(i)=cmeshx0(i,j)
            ymsh(i)=cmeshy0(i,j)
         enddo

c     Distance from top-of-mesh to each downstream meshpoint along separatrix
         i0=1				! index of top-of-mesh surface
					! for psi > 1
         dss(i0)=0.
         do i=i0+1,i2msh
            dss(i)=dss(i-1) +
     &                   sqrt( (xmsh(i)-xmsh(i-1))**2 +
     &                         (ymsh(i)-ymsh(i-1))**2 )
         enddo
         i0leg=ixpoint(3,region)	! index of top-of-mesh surface
					! for psi < 1
         dssleg(i0leg)=0.
         do i=i0leg+1,i2msh
            dssleg(i)=dssleg(i-1) +
     &                   sqrt( (xmsh(i)-xmsh(i-1))**2 +
     &                         (ymsh(i)-ymsh(i-1))**2 )
         enddo

c     Distance from top-of-mesh to orthogonal divertor plate
         dssp0=dss(i2msh)
         dsslegp0=dssleg(i2msh)

c----------------------------------------------------------------------c
c     Loop over all flux surfaces:
      do j=j1,j2

c     Define some temporary variables for (xcurveg,ycurveg) surface data
         i1crv=ijump(j)+1	! start index
         i2crv=npointg(j)	! end index
         if (j .eq. jsptrx(region)) i1crv=1
         do i=i1crv,i2crv
            xcrv(i)=xcurveg(i,j)
            ycrv(i)=ycurveg(i,j)
         enddo

c     Define some temporary variables for (cmeshx,y) surface data
         i1msh=1			! start at top of SOL
         i2msh=ilmax(region)		! end index
         if ( (j .gt. jsptrx(1)) .and. (j .lt. jsptrx(2)) ) then
            i1msh=ixpoint(3,region)	! start at p.f. cut
         endif
         do i=i1msh,i2msh
            xmsh(i)=cmeshx0(i,j)
            ymsh(i)=cmeshy0(i,j)
         enddo
c     extrapolate upstream slightly from the initial point
         xmsh(i1msh)=xmsh(i1msh)+eps*(xmsh(i1msh)-xmsh(i1msh+1))
         ymsh(i1msh)=ymsh(i1msh)+eps*(ymsh(i1msh)-ymsh(i1msh+1))

c     Top-of-mesh for cmeshx,y:
         if ( (jsptrx(1) .le. j) .and. (j .le. jsptrx(2)) ) then
            imt=ixpoint(3,region)
         else
            imt=1
         endif
         xmt=xmsh(imt)
         ymt=ymsh(imt)
c        index of first point below top-of-mesh is imt+1

c     Intersection of (cmeshx,y) with upstream reference surface
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xmsh(i1msh),ymsh(i1msh),i1msh,i2msh,
     &                   xmu,ymu,kmu,imu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,880) j
 880        format ("no upstream intersection for cmeshx,y on j=",i3)
            call kaboom(0)
         endif
         if (imu .lt. imt) then
            imu=imt
            xmu=xmt
            ymu=ymt
         endif

c     Downstream reference surface for cmeshx,y:
      imd=ixpoint(3,region)
      xmd=xmsh(imd)
      ymd=ymsh(imd)

c     Distance from top-of-mesh to each meshpoint along cmeshx,y
         dsm(imt)=0.
         do i=imt+1,i2msh
            dsm(i)=dsm(i-1) +
     &                   sqrt( (xmsh(i)-xmsh(i-1))**2 +
     &                         (ymsh(i)-ymsh(i-1))**2 )
         enddo

c     Distance from top-of-mesh to upstream reference surface
         dsmu=dsm(imu)+sqrt( (xmu-xmsh(imu))**2 +
     &                       (ymu-ymsh(imu))**2 )

c     Distance from top-of-mesh to orthogonal divertor plate
         dsmp0=dsm(i2msh)

c----------------------------------------------------------------------c

c     Intersection of (x,ycurveg) with top-of-mesh surface
         call intersect2(rtop,ztop,1,ntop,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xct,yct,kct,ict,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,884) j
 884        format ("no top-of-mesh intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
         if (j .eq. jsptrx(region)) then	! top is at x-point
            ict=ijump(j)+2	! there are 3 identical data points here
            xct=rseps
            yct=zseps
         endif
c        index of first point below top-of-mesh is ict+1

c     Intersection of (x,ycurveg) with upstream reference surface
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcu,ycu,kcu,icu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,885) j
 885        format ("no upstream intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below reference surface is icu+1
c        Ensure that upstream surface lies "below" top-of-mesh surface
         if (icu .lt. ict) then
            icu=ict
            xcu=xct
            ycu=yct
         endif

c     Intersection of (x,ycurveg) with downstream reference surface
         call intersect2(rdnstream,zdnstream,1,ndnstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcd,ycd,kcd,icd,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,886) j
 886        format ("no dnstream intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below reference surface is icd+1
c        Ensure that downstream surface lies "below" upstream surface
         if (icd .lt. icu) then
            icd=icu
            xcd=xcu
            ycd=ycu
         endif

c     Intersection of (x,ycurveg) with new divertor plate
c     NOTE: start the search at the top-of-mesh index, ict, to avoid
c           a possible problem with multiple intersections (MER 95/09/05)
         call intersect2(rplate,zplate,1,nplate,
     &                    xcrv(ict),ycrv(ict),ict,i2crv,
     &                    xcp,ycp,kcp,icp,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,888) j
 888        format ("no new plate intersection for x,ycurveg on j=",i3)
            write (STDOUT,889)
 889        format ("*** You may have to extend the plate end points")
            call kaboom(0)
         endif
c        index of first point below new divertor plate is icp+1

c     Intersection of (x,ycurveg) with old divertor plate
         call intersect2(rplate0,zplate0,1,nplate0,
     &                    xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                    xcp0,ycp0,kcp0,icp0,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,890) j
 890        format ("no old plate intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below old divertor plate is icp0+1

c     Distance from top-of-mesh to each data point along x,ycurveg
         xcrv(ict)=xct
         ycrv(ict)=yct
         dsc(ict)=0.
         do ii=ict+1,i2crv
            dsc(ii)=dsc(ii-1) +
     &                   sqrt( (xcrv(ii)-xcrv(ii-1))**2 +
     &                         (ycrv(ii)-ycrv(ii-1))**2 )
         enddo

c     Distance from top-of-mesh to upstream reference
         dscu=dsc(icu)+sqrt( (xcu-xcrv(icu))**2 +
     &                       (ycu-ycrv(icu))**2 )

c     Distance from top-of-mesh to downstream reference
         dscd=dsc(icd)+sqrt( (xcd-xcrv(icd))**2 +
     &                       (ycd-ycrv(icd))**2 )

c     Distance from top-of-mesh to new divertor plate
         dscp=dsc(icp)+sqrt( (xcp-xcrv(icp))**2 +
     &                       (ycp-ycrv(icp))**2 )

c     Distance from top-of-mesh to old divertor plate
         dscp0=dsc(icp0)+sqrt( (xcp0-xcrv(icp0))**2 +
     &                         (ycp0-ycrv(icp0))**2 )

c     Ensure that downstream reference is above new divertor plate
         if (dscp .lt. dscd) then
            icd=icp
            xcd=xcp
            ycd=ycp
            dscd=dscp
         endif

c     Use dmix0 to define length of mesh transition region
         len = dmix0*(dscd-dscu)
         dscd = dscu + len
         ! find new icd,xcd,ycd
         do i=icu,icp
            if ( (dsc(i) .le. dscd) .and. (dscd .lt. dsc(i+1)) ) then
               icd=i
               frac=(dscd-dsc(i))/(dsc(i+1)-dsc(i))
               xcd=xcrv(i)+frac*(xcrv(i+1)-xcrv(i))
               ycd=ycrv(i)+frac*(ycrv(i+1)-ycrv(i))
               exit
            endif
         enddo
         ! find new imd (index of first cmeshx,y point upstream of x,ycd)
         ! Strategy: compute the distance along x,ycurveg to ith meshpoint
         ! and when this distance exceeds dscd we have identified imd+1
         do i=imu+1,i2msh
            dscmi=0.
            do ii=ict,i2crv
               if ( twixt(xcrv(ii),xmsh(i),xcrv(ii+1),delmax) .and.
     &              twixt(ycrv(ii),ymsh(i),ycrv(ii+1),delmax) ) then
                  dscmi=dsc(ii)+sqrt( (xmsh(i)-xcrv(ii))**2
     &                               +(ymsh(i)-ycrv(ii))**2 )
                  exit
               endif
            enddo
            if (dscmi .gt. dscd) then
               imd=i-1
               exit
            endif
         enddo

c----------------------------------------------------------------------c
c     Compute new meshpoints (along x,ycurveg) for each grid option
c----------------------------------------------------------------------c
c     First, the ismmon=0 option:
         dsmesh0(imt)=0.
         do i=imt+1,i2msh
c     Intersection of x,ycurveg with ith angle (orthogonal) surface
            na=3
            if (j .eq. jmin(region)) then
               ra(1)=2*cmeshx0(i,j)-cmeshx0(i,j+1)
               za(1)=2*cmeshy0(i,j)-cmeshy0(i,j+1)
            else
               ra(1)=cmeshx0(i,j-1)
               za(1)=cmeshy0(i,j-1)
            endif
            ra(2)=cmeshx0(i,j)
            za(2)=cmeshy0(i,j)
            if (j .eq. jmax(region)) then
               ra(3)=2*cmeshx0(i,j)-cmeshx0(i,j-1)
               za(3)=2*cmeshy0(i,j)-cmeshy0(i,j-1)
            else
               ra(3)=cmeshx0(i,j+1)
               za(3)=cmeshy0(i,j+1)
            endif
            call intersect2(ra,za,1,na,
     &                    xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                    xca,yca,kca,ica,fuzzm,ierr)
            if (ierr .ne. 0) then
               write (STDOUT,891) j,i
 891           format ("no angle intersection for x,ycurveg on j=",i3,
     &                 " at i=",i3)
               call kaboom(0)
            endif
c     Index of first (x,ycrv) point below angle surface is ica+1
            dsmesh0(i)=dsc(ica)+sqrt( (xca-xcrv(ica))**2
     &                               +(yca-ycrv(ica))**2 )
         enddo
c----------------------------------------------------------------------c
c     Then, the ismmon=1 option:
         do i=imt,i2msh
            if (i .le. imu) then
               dsmesh1(i)=dsmesh0(i)
            else
               dsmesh1(i)=dscu+(dscp-dscu)*
     &                     (dsmesh0(i)-dscu)/(dscp0-dscu)
            endif
         enddo
c----------------------------------------------------------------------c
c     Then, the ismmon=2 option:
         fracu=(dsmu-dsm(imu))/(dsm(imu+1)-dsm(imu))
         dssu=dss(imu)+fracu*(dss(imu+1)-dss(imu))
         do i=imt,i2msh
            if (i .le. imu) then
               dsmesh2(i)=dsmesh0(i)
            else
               if ( (jsptrx(1) .le. j) .and. (j .le. jsptrx(2)) ) then
                  dsmesh2(i)=dscu+(dscp-dscu)*
     &              (dssleg(i)-dssleg(imu))/(dssleg(i2msh)-dssleg(imu))
               else
                  dsmesh2(i)=dscu+(dscp-dscu)*
     &              (dss(i)-dssu)/(dss(i2msh)-dssu)
               endif
            endif
         enddo
c----------------------------------------------------------------------c

c     Combine the 1 & 2 meshes according to weight factor wtmesh1:
	    do i=imt,i2msh
	       dsmesh(i)=wtmesh1*dsmesh1(i)+(1-wtmesh1)*dsmesh2(i)
	    enddo
c     Find the index of the mesh point just above the downstream surface
            do i=imt+1,i2msh
               im12d=i-1
               if ( (dsmesh(i)   .ge. dscd) .and. 
     &              (dsmesh(i-1) .le. dscd) ) exit
            enddo

c     Mix in the 0 mesh, starting with weight factor 0 at the downstream
c     position and increasing linearly to weight factor 1 at the upstream
c     position:

	 do i=imt,i2msh
            if (i .le. imu) then
               dsmesh(i)=dsmesh0(i)
            elseif ( (imu .lt. i) .and. (i .le. im12d) ) then
               dsmesh(i)=dscu+(dscd-dscu)*
     &            (dsmesh0(i)-dscu)/(dsmesh0(i)-dscu+dscd-dsmesh(i))
            else
		! use dsmesh as is
            endif
	 enddo


c     Modified cmeshx,cmeshy values --
            do i=imt+1,i2msh
               do ii=ict+1,i2crv
                  if (dsmesh(i) .le. dsc(ii)) then
c     modified point i lies between (x,ycurveg) points ii-1 and ii
                     frac=(dsmesh(i)-dsc(ii-1))/
     &                    (dsc(ii)  -dsc(ii-1))
                     cmeshx(i,j)=xcrv(ii-1) + frac*(xcrv(ii)-xcrv(ii-1))
                     cmeshy(i,j)=ycrv(ii-1) + frac*(ycrv(ii)-ycrv(ii-1))
                     exit
                  endif
               enddo
            enddo

      enddo	! end of loop over all j flux surfaces


      return
      end

c----------------------------------------------------------------------c

      subroutine smooth(i,j1,j2)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Curves 	! npointg,xcurveg,ycurveg
      use Linkco 	! cmeshx,cmeshy
      use Mmod 	! nupstream,rupstream,zupstream as temporary arrays
                ! ndnstream,rdnstream,zdnstream as temporary arrays
      use Transfm 	! ijump
      implicit none
      integer i,j1,j2
		! xcrv,ycrv,dsc,fuzzm,wtold
      external intersect2, remark, kaboom

c     Local variables --
      integer ii,j,i1crv,i2crv,icu,kcu,icp,kcp,ierr,region,istart,iend
      real xcu,ycu,xcp,ycp,xjm1,yjm1,distnew,frac

c     Smooth spatial irregularities in angle-like surfaces of the mesh

      xjm1=cmeshx(i,j1)
      yjm1=cmeshy(i,j1)

      do j=j1+1,j2-1

	 if (j .lt. jaxis) then
	    region=1
	 elseif (j .gt. jaxis) then
	    region=2
	 else
	    call remark("smooth: region not defined")
	    call kaboom(0)
	 endif

c     Temporary variables for (xcurveg,ycurveg) surface data
         i1crv=1		! start index
         i2crv=npointg(j)	! end index
         do ii=i1crv,i2crv
            xcrv(ii)=xcurveg(ii,j)
            ycrv(ii)=ycurveg(ii,j)
         enddo
   
c     Straight line between j-1 and j+1 points on angle-like surface
	 nupstream=2
	 rupstream(1)=cmeshx(i,j-1)
	 zupstream(1)=cmeshy(i,j-1)
	 rupstream(2)=cmeshx(i,j+1)
	 zupstream(2)=cmeshy(i,j+1)

c     Intersection of straight line with x,ycurveg is (xcu,ycu):
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcu,ycu,kcu,icu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,886) j,i
 886        format 
     & ("smooth: no intersection for x,ycurveg on j=",i3," with i=",i3)
            call kaboom(0)
         endif
c     The point (x,ycu) lies between icu and icu+1 on x,ycrv.

c     Segmented line through j-1, j and j+1 points on angle-like surface
         ndnstream=3
         rdnstream(1)=cmeshx(i,j-1)
         zdnstream(1)=cmeshy(i,j-1)
         rdnstream(2)=cmeshx(i,j)
         zdnstream(2)=cmeshy(i,j)
         rdnstream(3)=cmeshx(i,j+1)
         zdnstream(3)=cmeshy(i,j+1)

c     Intersection of segmented line with x,ycurveg is (xcp,ycp):
         call intersect2(rdnstream,zdnstream,1,ndnstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcp,ycp,kcp,icp,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,887) j,i
 887        format 
     & ("smooth: no intersection for x,ycurveg on j=",i3," with i=",i3)
            call kaboom(0)
         endif
c     The point (x,ycp) lies between icp and icp+1 on x,ycrv.

c     Update meshpoint at j-1, now that we are done using it:
         cmeshx(i,j-1)=xjm1
         cmeshy(i,j-1)=yjm1

         if (icp .lt. icu) then		! x,ycp is  upstream  from x,ycu
            istart=icp
            xcrv(istart)=xcp
            ycrv(istart)=ycp
            iend=icu+1
            xcrv(iend)=xcu
            ycrv(iend)=ycu
            dsc(istart)=0.
            do ii=istart+1,iend
               dsc(ii)=dsc(ii-1)
     &                     + sqrt( (xcrv(ii)-xcrv(ii-1))**2
     &                            +(ycrv(ii)-ycrv(ii-1))**2 )
            enddo
            distnew=(1-wtold)*dsc(iend)
            do ii=istart+1,iend
               if ( distnew .le. dsc(ii) ) then
c        new meshpoint lies between ii-1 and ii
                  frac = (distnew-dsc(ii-1))
     &                         /(dsc(ii)-dsc(ii-1))
                  xjm1=xcrv(ii-1) + frac*(xcrv(ii)-xcrv(ii-1))
                  yjm1=ycrv(ii-1) + frac*(ycrv(ii)-ycrv(ii-1))
                  exit
               endif
            enddo
         elseif (icp .gt. icu) then	! x,ycp is downstream from x,ycu
            istart=icu
            xcrv(istart)=xcu
            ycrv(istart)=ycu
            iend=icp+1
            xcrv(iend)=xcp
            ycrv(iend)=ycp
            dsc(istart)=0.
            do ii=istart+1,iend
               dsc(ii)=dsc(ii-1)
     &                     + sqrt( (xcrv(ii)-xcrv(ii-1))**2
     &                            +(ycrv(ii)-ycrv(ii-1))**2 )
            enddo
            distnew=wtold*dsc(iend)
            do ii=istart+1,iend
               if (distnew .le. dsc(ii)) then
c        new meshpoint lies between ii-1 and ii
                  frac = (distnew-dsc(ii-1))
     &                         /(dsc(ii)-dsc(ii-1))
                  xjm1=xcrv(ii-1) + frac*(xcrv(ii)-xcrv(ii-1))
                  yjm1=ycrv(ii-1) + frac*(ycrv(ii)-ycrv(ii-1))
                  exit
               endif
            enddo
         else	! both x,ycu and x,ycp lie on same segment of x,ycrv
            xjm1=(1-wtold)*xcu+wtold*xcp
            yjm1=(1-wtold)*ycu+wtold*ycp
         endif

      enddo

      cmeshx(i,j2-1)=xjm1
      cmeshy(i,j2-1)=yjm1

      return
      end

c----------------------------------------------------------------------c

      subroutine orthogrd(ixtyp,i,j0,j,xob,yob,alphab)
      use Dimflxgrd 	!jdim,npts
      use Comflxgrd 
      use Dimensions 
      use Curves 
      use Transfm 
      use Linkco 
      implicit none
      integer ixtyp, i, j0, j, ii, ipoint, iseg, nsys, noiter, iter
      integer isegalt,numerr,numerrmx
      real xob, yob, alphab, distmin, distance, alphaf, alpha
      real cosalpf, sinalpf, xo, yo, sinalpb, cosalpb, xb, yb, xm
      real ym, xoldv, sold, xlimit, dx, dxsq, xpdx, xmdx, s, sp
      real sm, s1, s2, xnew, tanbet, beta
      data numerrmx /2/
c     NOTE:
c     On entry, (xob,yob,alphab) give the (R,Z) coordinates and local
c     rotation angle for a mesh point on the j0th flux surface.
c
c     On exit, (xob,yob,alphab) give the (R,Z) coordinates and local
c     rotation angle for a mesh point on the jth flux surface.
c
c     These points define a segment of the ith orthogonal mesh surface
c     connecting the j0 and j flux surfaces.
c
c     Procedure:
c
c     *** find the nearest point to (xob,yob), on the xycurveg( ,j) :
c     *** ixtyp is a flag that tells us whether to search the upper,
c     *** lower, or entire range of flux surface data.
c
      distmin=(xubnd-xlbnd)+(yubnd-ylbnd)
c
      if (ixtyp.eq.0) then
      do 10 ii=1,npointg(j)
         distance=sqrt((xcurveg(ii,j)-xob)**2+(ycurveg(ii,j)-yob)**2)
         if(distance.gt.distmin) goto 10
         distmin=distance
         ipoint=ii
   10 continue
c
      elseif (ixtyp.eq.1) then
      do 30 ii=1,ijump(j)
         distance=sqrt((xcurveg(ii,j)-xob)**2+(ycurveg(ii,j)-yob)**2)
         if(distance.gt.distmin) goto 30
         distmin=distance
         ipoint=ii
   30 continue
c
      elseif (ixtyp.eq.2) then
      do 40 ii=ijump(j)+1,npointg(j)
         distance=sqrt((xcurveg(ii,j)-xob)**2+(ycurveg(ii,j)-yob)**2)
         if(distance.gt.distmin) goto 40
         distmin=distance
         ipoint=ii
   40 continue
c
      endif
c
c     *** determine the segment on which this point lies.
         iseg=isegment(ipoint,j)
         isegalt=iseg
         numerr=0
   44 continue	! possible re-start from here if out-of-range spline
		! evaluation error occurs in loop 20 from s.r. intrcept
         if (isegalt .ne. iseg) then
            numerr=numerr+1
            if (numerr .gt. numerrmx) then
               call remark ("*** error in subroutine orthogrd")
               call remark ("Too many out-of-range spline errors for")
               write (STDOUT,901) i,j
  901          format ("orthogonal surface i = ",i3,
     &                 " at flux surface j = ",i3)
               call kaboom(0)
            endif
            iseg=isegalt
         endif
         if (iseg .eq. 0) then
            call remark ("*** error in subroutine orthogrd")
            write (STDOUT,899) ipoint,j
  899       format ("data point i=",i3," on contour j=",i3," is not",
     &              " assigned to a spline segment")
            call kaboom(0)
         endif
         nsys=isys(iseg,j)
         alphaf=alphasys(nsys)
c     *** transform the moving system origin into the fixed system.
         alpha=alphab-alphaf
         cosalpf=cos(alphaf)
         sinalpf=sin(alphaf)
         xo= xob*cosalpf+yob*sinalpf
         yo=-xob*sinalpf+yob*cosalpf
c     *** transform the coordinates of the nearest point into the
c     *** moving system (from the basic system).
         sinalpb=sin(alphab)
         cosalpb=cos(alphab)
c
         xb=xcurveg(ipoint,j)
         yb=ycurveg(ipoint,j)
         xm=+(xb-xob)*cosalpb+(yb-yob)*sinalpb
         ym=-(xb-xob)*sinalpb+(yb-yob)*cosalpb
c
c     *** obtain the solution of the orthogonality equation using xm and ym
c     *** as the starting point.
         xoldv=xm
         sold=ym
         xlimit=0.001*distmin
         dx=0.01*distmin
         dxsq=dx*dx
c
c     *** start the iteration process.
         noiter=20
c
      do 20 iter=1,noiter
c     *** we need the first and the second derivatives of the spline.
c
         xpdx=xoldv+dx
         xmdx=xoldv-dx
      call intrcept(iseg,j,xo,yo,alpha,xoldv,sold,s,isegalt)
      if (isegalt .ne. iseg) then
         goto 44	! re-start with alternative spline representation
      endif
      call intrcept(iseg,j,xo,yo,alpha,xpdx,sold,sp,isegalt)
      if (isegalt .ne. iseg) then
         goto 44	! re-start with alternative spline representation
      endif
      call intrcept(iseg,j,xo,yo,alpha,xmdx,sold,sm,isegalt)
      if (isegalt .ne. iseg) then
         goto 44	! re-start with alternative spline representation
      endif
c
c     *** form the derivatives of s.
         s1=0.5*(sp-sm)/dx
         s2=(sp-2.0*s+sm)/dxsq
c
         xnew=xoldv-(2.*s*xoldv+(s*s-xoldv*xoldv)*s1)/
     &        (2.*s*(1.+s1*s1)+(s*s-xoldv*xoldv)*s2)
c
      if(abs(xnew-xoldv).lt.xlimit) goto 21
         xoldv=xnew
         sold=s
c
   20 continue
c
      goto 22
   21 continue
c     *** xnew and s are the desired solutions in the moving system.
c     *** transform into the basic system, and make this point the new
c     *** origin of the moving system.
         xob=xob+xnew*cosalpb-s*sinalpb
         yob=yob+xnew*sinalpb+s*cosalpb
c     *** compute the angle of the new moving coordinate system, as viewed
c     *** from the old moving coordinate system.
         tanbet=s1
         beta=atan(tanbet)
         alpha=alpha+beta
c     *** transform into the basic system.
         alphab=alpha+alphaf
c
      return
   22 continue
c     *** iterations have failed to converge
         write(STDOUT,900) i,j0,j
  900    format("orthogrd not converged for i=",i2," surface",
     &          " between j0=",i2," and j=",i2," flux contours")
c
      return
      end

c     ------------------------------------------------------------------

      subroutine orthogx(ixtyp,i,j0,j,xob,yob,alphab)
      use Dimflxgrd 	!jdim,npts
      use Comflxgrd 
      use Dimensions 
      use Curves 
      use Transfm 
      use Linkco 
      implicit none
      integer ixtyp, i, j0, j, ii, ipoint, iseg, nsys, noiter, iter
      integer isegalt, numerr, numerrmx
      real xob, yob, alphab, distmin, distance, alphaf, alpha
      real cosalpf, sinalpf, xo, yo, sinalpb, cosalpb, xb, yb, xm
      real ym, xoldv, sold, xlimit, dx, dxsq, xpdx, xmdx, s, sp
      real sm, s1, s2, xnew, tanbet, beta
      data numerrmx /2/
c     NOTE:
c     On entry, (xob,yob) give the (R,Z) coordinates for a point
c     (the x-point) on the j0th flux surface (the separatrix).
c
c     On exit,  (xob,yob,alphab) give the (R,Z) coordinates and local
c     rotation angle for a mesh point on the jth flux surface.
c     
c     *** finds the orthogonal set of curves.
c
c     *** find the nearest point to (xob,yob), on the xycurveg( ,j).
c
         distmin=(xubnd-xlbnd)+(yubnd-ylbnd)
c
c
      if(ixtyp.eq.0) then
      do 10 ii=1,npointg(j)
         distance=sqrt((xcurveg(ii,j)-xob)**2+(ycurveg(ii,j)-yob)**2)
      if(distance.gt.distmin) goto 10
         distmin=distance
         ipoint=ii
   10 continue
c
      else if(ixtyp.eq.1) then
      do 30 ii=1,ijump(j)
         distance=sqrt((xcurveg(ii,j)-xob)**2+(ycurveg(ii,j)-yob)**2)
      if(distance.gt.distmin) goto 30
         distmin=distance
         ipoint=ii
   30 continue
c
      else if(ixtyp.eq.2) then
      do 40 ii=ijump(j)+1,npointg(j)
         distance=sqrt((xcurveg(ii,j)-xob)**2+(ycurveg(ii,j)-yob)**2)
      if(distance.gt.distmin) goto 40
         distmin=distance
         ipoint=ii
   40 continue
c
      endif
c
         distmin=sqrt(distmin)
c
c     *** determine the segment on which this point lies.
         iseg=isegment(ipoint,j)
         isegalt=iseg
         numerr=0
   44 continue	! possible re-start from here if out-of-range spline
		! evaluation error occurs in loop 20 from s.r. intrcept
         if (isegalt .ne. iseg) then
            numerr=numerr+1
            if (numerr .gt. numerrmx) then
               call remark ("*** error in subroutine orthogx")
               call remark ("Too many out-of-range spline errors for")
               write (STDOUT,901) i,j
  901          format ("orthogonal surface i = ",i3,
     &                 " at flux surface j = ",i3)
               call kaboom(0)
            endif
            iseg=isegalt
         endif
         if (iseg .eq. 0) then
            call remark ("*** error in subroutine orthogx")
            write (STDOUT,899) ipoint,j
  899       format ("data point i=",i3," on contour j=",i3," is not",
     &              " assigned to a spline segment")
            call kaboom(0)
         endif
         nsys=isys(iseg,j)
         alphaf=alphasys(nsys)
c
c     *** orient the moving system the same way as the fixed system.
         alphab=alphaf
c
c     *** transform the moving system origin into the fixed system.
         alpha=alphab-alphaf
         cosalpf=cos(alphaf)
         sinalpf=sin(alphaf)
         xo= xob*cosalpf+yob*sinalpf
         yo=-xob*sinalpf+yob*cosalpf
c     *** transform the coordinates of the nearest point into the
c     *** moving system (from the basic system).
         sinalpb=sin(alphab)
         cosalpb=cos(alphab)
c
         xb=xcurveg(ipoint,j)
         yb=ycurveg(ipoint,j)
         xm=+(xb-xob)*cosalpb+(yb-yob)*sinalpb
         ym=-(xb-xob)*sinalpb+(yb-yob)*cosalpb
c
c     *** obtain the solution of the orthogonality equation using xm and ym
c     *** as the starting point.
         xoldv=xm
         sold=ym
         xlimit=0.001*distmin
         dx=0.01*distmin
         dxsq=dx*dx
c
c     *** start the iteration process.
         noiter=20
c
      do 20 iter=1,noiter
c     *** we need the first and the second derivatives of the spline.
c
         xpdx=xoldv+dx
         xmdx=xoldv-dx
      call intrcept(iseg,j,xo,yo,alpha,xoldv,sold,s,isegalt)
      if (isegalt .ne. iseg) then
         goto 44	! re-start with alternative spline representation
      endif
      call intrcept(iseg,j,xo,yo,alpha,xpdx,sold,sp,isegalt)
      if (isegalt .ne. iseg) then
         goto 44	! re-start with alternative spline representation
      endif
      call intrcept(iseg,j,xo,yo,alpha,xmdx,sold,sm,isegalt)
      if (isegalt .ne. iseg) then
         goto 44	! re-start with alternative spline representation
      endif
c
c     *** form the derivatives of s.
         s1=0.5*(sp-sm)/dx
         s2=(sp-2.0*s+sm)/dxsq
c
         xnew=xoldv-(xoldv+s*s1)/(1.+s1*s1+s*s2)
c
      if(abs(xnew-xoldv).lt.xlimit) goto 21
         xoldv=xnew
         sold=s
c
   20 continue
c
      goto 22
   21 continue
c     *** xnew and s are the desired solutions in the moving system.
c     *** transform into the basic system, and make this point the new
c     *** origin of the moving system.
         xob=xob+xnew*cosalpb-s*sinalpb
         yob=yob+xnew*sinalpb+s*cosalpb
c     *** compute the angle of the new moving coordinate system, as viewed
c     *** from the old moving coordinate system.
         tanbet=s1
         beta=atan(tanbet)
         alpha=alpha+beta
c     *** transform into the basic system.
         alphab=alpha+alphaf
c
      return
   22 continue
c     *** iterations have failed to converge
         write(STDOUT,900) i,j0,j
  900    format("orthogx not converged for i=",i2," surface",
     &          " between j0=",i2," and j=",i2," flux contours")

      return
      end

c     ------------------------------------------------------------------

      subroutine prune
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 
      use Dimensions 
      use Curves 
      use Inmesh 
      use Linkco 
      use System 

c     local variables --
      implicit none
      real ds,dstest
      integer i,j,k,ii,k1,ixpointb,numpoint,region

c     loop over all regions --
      do 800 region=1,noregs

c     Find the minimum distance between x-point and separatrix contour
      j=jsptrx(region)
      dstest=(xubnd-xlbnd)+(yubnd-ylbnd)
      do 10 k=1,npointg(j)
         ds=sqrt((xcurveg(k,j)-rseps)**2+(ycurveg(k,j)-zseps)**2)
         dstest=min(dstest,ds)
   10 continue

      dsminx = 2*max(dstest,dsmin)

c     First, prune the points which are within dsminx of the x-point
c     on the separatrix --

      j=jsptrx(region)
         i=0
         k=0
         ixpointb=0
   11 continue
      if ((k .eq. i+1) .and. (ixpointb .eq. 0)) then
c     *** insert the first x-point into the sequence.
         i=i+1
         ixpointb=i
         xwork(i)=rseps
         ywork(i)=zseps
      endif
c
         k=k+1
      if (k .gt. npointg(j)) goto 12
         ds=sqrt((xcurveg(k,j)-rseps)**2+(ycurveg(k,j)-zseps)**2)
      if (ds .lt. dsminx) goto 11
         i=i+1
         xwork(i)=xcurveg(k,j)
         ywork(i)=ycurveg(k,j)
      goto 11
   12 continue
         numpoint=i

c     Re-define the data for the separatrix contour --
      do 20 ii=1,npointg(j)
         xcurveg(ii,j)=0.0
         ycurveg(ii,j)=0.0
   20 continue
      do 30 ii=1,numpoint
         xcurveg(ii,j)=xwork(ii)
         ycurveg(ii,j)=ywork(ii)
   30 continue
      npointg(j)=numpoint

c     Now, for each contour, prune all points which are separated from
c     their neighbors by less than dsmin --

      do 100 j=jmin(region),jmax(region)
         i=1
         k=1
         xwork(i)=xcurveg(k,j)
         ywork(i)=ycurveg(k,j)
   40 continue
         k1=k
   50 continue
         k=k+1
      if (k .gt. npointg(j)) goto 60
         ds=sqrt((xcurveg(k,j)-xcurveg(k1,j))**2 +
     &           (ycurveg(k,j)-ycurveg(k1,j))**2)
      if (ds .lt. dsmin) goto 50
      if ((j .eq. jsptrx(region)) .and. (k1 .eq. ixpointb)) then
         ixpointc(1,region)=i
         i=i+1
         ixpointc(2,region)=i
         xwork(i)=xcurveg(k1,j)
         ywork(i)=ycurveg(k1,j)
         i=i+1
         ixpointc(3,region)=i
         xwork(i)=xcurveg(k1,j)
         ywork(i)=ycurveg(k1,j)
      endif
         i=i+1
         xwork(i)=xcurveg(k,j)
         ywork(i)=ycurveg(k,j)
      goto 40
   60 continue
         numpoint=i

c     Re-define the data for the jth flux contour --
         do 70 ii=1,npointg(j)
            xcurveg(ii,j)=0.0
            ycurveg(ii,j)=0.0
   70    continue
         do 80 ii=1,numpoint
            xcurveg(ii,j)=xwork(ii)
            ycurveg(ii,j)=ywork(ii)
   80    continue
         npointg(j)=numpoint

  100 continue

  800 continue          ! end of loop over regions

      return
      end

c     ------------------------------------------------------------------

      subroutine seed0(i,j,x0,y0,xcurveg,ycurveg,cmeshx,cmeshy,
     &                       nptsg,idimg,jdimg,lim1,lim2,km,kp,testflag)
      implicit none
      integer i, j, nptsg, idimg, jdimg, lim1, lim2, k, km, kp, testflag
      real x0, y0, dx1, dx2, dy1, dy2, delta
      real xcurveg(nptsg,jdimg),ycurveg(nptsg,jdimg)
      real cmeshx(idimg,jdimg),cmeshy(idimg,jdimg)

      external twixt,remark,kaboom
      logical twixt,xtest,ytest

c     This subroutine finds the indicies (km,kp) of the (x,ycurveg)
c     data points that straddle the top-of-mesh position (x0,y0)
c     on the jth flux contour.  For testflag=0, only the horizontal
c     coordinate is tested; for testflag=2, only the vertical
c     coordinate is tested; for testflag=1, a more stringent test
c     on both horizontal and vertical coordinates is used to
c     locate the end-of-mesh.  This is useful when there are multiple
c     solutions for the test on horizontal position only.  Finally, 
c     the coordinates of the top-of-mesh data point (x0,y0)
c     are put into the mesh arrays (cmeshx,y) for angle index i and
c     flux index j.

      data delta/0/	! treat data as exact in twixt tests

c     In the following,
c        xtest is TRUE if the k and k+1 data points straddle x0
c        ytest is TRUE if the k and k+1 data points straddle y0
c     Otherwise, xtest and ytest are FALSE.

      km=0
      kp=0
      if (testflag==0) then		! test on x only
         do k=lim1,lim2-1
            xtest=twixt(xcurveg(k,j), x0, xcurveg(k+1,j), delta)
            if (xtest) then
               km=k
               kp=k+1
               exit
            endif
         enddo
         if (km==0) then			! test not satisfied
            call remark("***     failure in subroutine seed0      ***")
            call remark("*** first point not found on separatrix ***")
            call kaboom(0)
         else				! interpolate to find y
            dx1=abs(xcurveg(km,j)-x0)
            dx2=abs(xcurveg(kp,j)-x0)
            cmeshx(i,j)=x0
            cmeshy(i,j)=(dx1*ycurveg(kp,j)+dx2*ycurveg(km,j))/(dx1+dx2)
         endif

      elseif (testflag==1) then		! test on x and y
         do k=lim1,lim2-1
            xtest=twixt(xcurveg(k,j), x0, xcurveg(k+1,j), delta)
            ytest=twixt(ycurveg(k,j), y0, ycurveg(k+1,j), delta)
            if (xtest .and. ytest) then
               km=k
               kp=k+1
               exit
            endif
         enddo
         if (km==0) then			! test not satisfied
            call remark("***     failure in subroutine seed0      ***")
            call remark("*** first point not found on separatrix ***")
            call kaboom(0)
         else				! put data in cmeshx,y
            cmeshx(i,j)=x0
            cmeshy(i,j)=y0
         endif

      elseif (testflag==2) then		! test on y only
         do k=lim1,lim2-1
            ytest=twixt(ycurveg(k,j), y0, ycurveg(k+1,j), delta)
            if (ytest) then
               km=k
               kp=k+1
               exit
            endif
         enddo
         if (km==0) then			! test not satisfied
            call remark("***     failure in subroutine seed0      ***")
            call remark("*** first point not found on separatrix ***")
            call kaboom(0)
         else				! interpolate to find x
            dy1=abs(ycurveg(km,j)-y0)
            dy2=abs(ycurveg(kp,j)-y0)
            cmeshx(i,j)=(dy1*xcurveg(kp,j)+dy2*xcurveg(km,j))/(dy1+dy2)
            cmeshy(i,j)=y0
         endif

      endif

      return
      end

c     ------------------------------------------------------------------

      subroutine seedl(i,j,xl,yl,xcurveg,ycurveg,cmeshx,cmeshy,
     &                       nptsg,idimg,jdimg,lim1,lim2,km,kp,testflag)
      implicit none
      integer i, j, nptsg, idimg, jdimg, lim1, lim2, k, km, kp, testflag
      real xl, yl, dx1, dx2, dy1, dy2, delta
      real xcurveg(nptsg,jdimg),ycurveg(nptsg,jdimg)
      real cmeshx(idimg,jdimg),cmeshy(idimg,jdimg)

      external twixt,remark,kaboom
      logical twixt,xtest,ytest

c     This subroutine finds the indicies (km,kp) of the (x,ycurveg)
c     data points that straddle the end-of-mesh position (xl,yl)
c     on the jth flux contour.  For testflag=0, only the horizontal
c     coordinate is tested; for testflag=2, only the vertical
c     coordinate is tested; for testflag=1, a more stringent test
c     on both horizontal and vertical coordinates is used to
c     locate the end-of-mesh.  This is useful when there are multiple
c     solutions for the test on horizontal position only.  Finally, 
c     the coordinates of the end-of-mesh data point (xl,yl)
c     are put into the mesh arrays (cmeshx,y) for angle index i and
c     flux index j.

      data delta/0/	! treat data as exact in twixt tests

c     In the following,
c        xtest is TRUE if the k and k+1 data points straddle xl
c        ytest is TRUE if the k and k+1 data points straddle yl
c     Otherwise, xtest and ytest are FALSE.

      km=0
      kp=0
      if (testflag==0) then		! test on x only
         do k=lim1,lim2-1
            xtest=twixt(xcurveg(k,j), xl, xcurveg(k+1,j), delta)
            if (xtest) then
               km=k
               kp=k+1
               exit
            endif
         enddo
         if (km==0) then			! test not satisfied
            call remark("***     failure in subroutine seedl      ***")
            call remark("*** strike point not found on separatrix ***")
            call kaboom(0)
         else				! interpolate to find y
            dx1=abs(xcurveg(km,j)-xl)
            dx2=abs(xcurveg(kp,j)-xl)
            cmeshx(i,j)=xl
            cmeshy(i,j)=(dx1*ycurveg(kp,j)+dx2*ycurveg(km,j))/(dx1+dx2)
         endif

      elseif (testflag==1) then		! test on x and y
         do k=lim1,lim2-1
            xtest=twixt(xcurveg(k,j), xl, xcurveg(k+1,j), delta)
            ytest=twixt(ycurveg(k,j), yl, ycurveg(k+1,j), delta)
            if (xtest .and. ytest) then
               km=k
               kp=k+1
               exit
            endif
         enddo
         if (km==0) then			! test not satisfied
            call remark("***     failure in subroutine seedl      ***")
            call remark("*** strike point not found on separatrix ***")
            call kaboom(0)
         else				! put data in cmeshx,y
            cmeshx(i,j)=xl
            cmeshy(i,j)=yl
         endif

      elseif (testflag==2) then		! test on y only
         do k=lim1,lim2-1
            ytest=twixt(ycurveg(k,j), yl, ycurveg(k+1,j), delta)
            if (ytest) then
               km=k
               kp=k+1
               exit
            endif
         enddo
         if (km==0) then			! test not satisfied
            call remark("***     failure in subroutine seedl      ***")
            call remark("*** strike point not found on separatrix ***")
            call kaboom(0)
         else				! interpolate to find x
            dy1=abs(ycurveg(km,j)-yl)
            dy2=abs(ycurveg(kp,j)-yl)
            cmeshx(i,j)=(dy1*xcurveg(kp,j)+dy2*xcurveg(km,j))/(dy1+dy2)
            cmeshy(i,j)=yl
         endif

      endif

      return
      end

c     ------------------------------------------------------------------

      subroutine sow
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 	! rseps,zseps
      use Dimensions 
      use Curves 
      use Inmesh 	! x0g,xlast,ylast,isztest
      use Linkco 
      use System 
      use Xmesh 
      use Share       ! islimon,theta_split,ishalfm
      use Mmod 

c     local variables --
      implicit none
      integer region,rbegin,ict,kct,ierr
      integer i,i0,i1,ic,ii,im,ip,ix,ixtop,j,lim1,lim2,nxtotal
      real x1,x2,xr0,xrl,xtop,y1,y2,yr0,yrl,ds,ds1,ds2,t,xct,yct

c     procedures --
      real xfcn,xfcn2,xfcn3,xfcn4
      external seedl,xfcn,xfcn2,xfcn3,xfcn4,intersect2

c     This subroutine generates the seed points along the separatrix.

c     Loop over regions --
      rbegin = 1
      if (ishalfm==1) rbegin = 2
      do 10 region=rbegin,noregs
         j=jsptrx(region)

c----------------------------------------------------------------------c
c     Insert the first seed point --

         i0=1
         xr0=x0g(region)
         yr0=y0g(region)
         lim1=1
         lim2=ixpointc(1,region)

         if (istpnew==1) then	! user-defined first-seed-point
            call seed0(i0,j,xr0,yr0,xcurveg,ycurveg,cmeshx,cmeshy,
     &              npts,idim,jdim,lim1,lim2,im,ip,istptest(region))
         else
c           Define top-of-mesh surface
	    ntop=2
	    if ((geometry .eq. 'snull').or.(geometry .eq. "uppersn")) then
                                                ! straight line outward
                                                ! from magnetic axis
                                                ! along theta_split
               rtop(1)=rmagx
               ztop(1)=zmagx
               rtop(2)=rtop(1)+max(xdim,zdim)*cos(theta_split)
               ztop(2)=ztop(1)+max(xdim,zdim)*sin(theta_split)
            else
						! horizontal line
						! through magnetic axis
               rtop(1)=0*rmagx
               ztop(1)=zmagx
               rtop(2)=2*rmagx
               ztop(2)=zmagx
	    endif
c           Intersection of (x,ycurveg) with top-of-mesh surface
            call intersect2(rtop,ztop,1,ntop,
     &                   xcurveg(lim1,j),ycurveg(lim1,j),lim1,lim2,
     &                   xct,yct,kct,ict,fuzzm,ierr)
            if (ierr .ne. 0) then
               write (STDOUT,884) j
 884           format ("sow: no top-of-mesh for x,ycurveg on j=",i3)
               call kaboom(0)
            endif
c           index of first point below top-of-mesh is ict+1
            cmeshx(i0,j)=xct
            cmeshy(i0,j)=yct
            im=ict
            ip=ict+1
         endif

c        Compute the distance along the separatrix as measured from
c        the first seed point
         dissep(1,region)=0.
         x1=cmeshx(i0,j)
         y1=cmeshy(i0,j)
         ii=1
         istartc(region)=ip	! from subroutine seed0 above
      do 30 i=istartc(region),npointg(j)
         ii=ii+1
         x2=xcurveg(i,j)
         y2=ycurveg(i,j)
         dissep(ii,region)=dissep(ii-1,region)+
     &                     sqrt((x2-x1)**2+(y2-y1)**2)
         x1=x2
         y1=y2
         if(i.eq.ixpointc(1,region)) ix=ii
   30 continue

c     Distance from first seed point to x-point is
         distxp(region)=dissep(ix,region)

c----------------------------------------------------------------------c
c     Insert the last seed point --

      if (nxleg(igrid,region)==0) then
c        Modification for FRC mesh generation
         cmeshx(ilmax(region),j) = rseps
         cmeshy(ilmax(region),j) = zseps
         distxpxl(region)=0.
      else
         i1=ilmax(region)
         xrl=xlast(region)
         yrl=ylast(region)
         lim1=ixpointc(3,region)
         lim2=npointg(j)
         call seedl(i1,j,xrl,yrl,xcurveg,ycurveg,cmeshx,cmeshy,
     &              npts,idim,jdim,lim1,lim2,im,ip,isztest(region))

c     Compute distance from x-point to last seed point --
         ds=sqrt((cmeshx(ilmax(region),j)-xcurveg(im,j))**2
     &          +(cmeshy(ilmax(region),j)-ycurveg(im,j))**2)
         iendc(region)=im+1
         dissep(iendc(region)-istartc(region)+2,region)=
     &               dissep(im-istartc(region)+2,region)+ds
         distxpxl(region)=
     &               dissep(iendc(region)-istartc(region)+2,region)
     &                 - distxp(region)
      endif

c     End of loop over regions
   10 continue



c     Compute data for xfcn(t) --
      ndat=5
      xdat(1)=0.
      xdat(2)=xdat(1)+distxpxl(1)
      xdat(3)=xdat(2)+distxp(1)
      xdat(4)=xdat(3)+distxp(2)
      xdat(5)=xdat(4)+distxpxl(2)
      nxtotal=nxleg(igrid,1)+nxuse(1)
     &                      +nxuse(2)+nxleg(igrid,2)
      tdat(1)=0.
      tdat(2)=tdat(1)+real(nxleg(igrid,1))/real(nxtotal)
      tdat(3)=tdat(2)+real(nxuse(1))/real(nxtotal)
      tdat(4)=tdat(3)+real(nxuse(2))/real(nxtotal)
      tdat(5)=tdat(4)+real(nxleg(igrid,2))/real(nxtotal)

      if (kxmesh .eq. 0) then           ! use manual x-mesh as for PLANET code

      rbegin = 1
      if (ishalfm==1) rbegin = 2
      do 53 region=rbegin,noregs
      do 51 i=1,ixpoint(1,region)
         seed(i,region)=0.01*seedxp(i,region)*distxp(region)
   51 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 52 i=ixpoint(3,region),ilmax(region)
         ii=i-ixpoint(2,region)
         seed(i,region)=seed(ixpoint(2,region),region)+
     &                  0.01*seedxpxl(ii,region)*distxpxl(region)
   52 continue
   53 continue

      elseif (kxmesh .eq. 1) then       ! use analytic x-mesh from xfcn(t)

      ixtop = nxuse(1) + nxleg(igrid,1)      ! B2 code poloidal index
                                        ! ix at PLANET code index i=1
      xtop = distxp(1) + distxpxl(1)    ! B2 code poloidal distance x at
                                        ! PLANET code index i=1
      if (ishalfm==0) then
         region=1
         do 61 i=1,ixpoint(1,region)
            ix = ixtop - (i-1)
            t = real(ix)/real(nxtotal)
            seed(i,region) = xtop - xfcn(t)
   61    continue
         seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
         do 62 i=ixpoint(3,region),ilmax(region)
            ix = ixtop - (i-3)
            t = real(ix)/real(nxtotal)
            seed(i,region) = xtop - xfcn(t)
   62    continue
      endif      ! end if-test on ishalfm

      region=2
      do 63 i=1,ixpoint(1,region)
         ix = ixtop + (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn(t) - xtop
   63 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 64 i=ixpoint(3,region),ilmax(region)
         ix = ixtop + (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn(t) - xtop
   64 continue

      elseif (kxmesh .eq. 2) then       ! use analytic x-mesh from xfcn2(t)

      ixtop = nxuse(1) + nxleg(igrid,1)      ! B2 code poloidal index
                                        ! ix at PLANET code index i=1
      xtop = distxp(1) + distxpxl(1)    ! B2 code poloidal distance x at
                                        ! PLANET code index i=1
      region=1
      do 71 i=1,ixpoint(1,region)
         ix = ixtop - (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xtop - xfcn2(t)
   71 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 72 i=ixpoint(3,region),ilmax(region)
         ix = ixtop - (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xtop - xfcn2(t)
   72 continue

      region=2
      do 73 i=1,ixpoint(1,region)
         ix = ixtop + (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn2(t) - xtop
   73 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 74 i=ixpoint(3,region),ilmax(region)
         ix = ixtop + (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn2(t) - xtop
   74 continue

      elseif (kxmesh .eq. 3) then       ! use analytic x-mesh from xfcn3(t)
c     insert extra data points --
         ndat=7
         ndatp2=ndat+2
         tdat(7)=tdat(5)
         xdat(7)=xdat(5)
         tdat(6)=tdat(7)-dt2
         xdat(6)=xdat(7)-dx2
         do i=5,3,-1
           tdat(i)=tdat(i-1)
           xdat(i)=xdat(i-1)
         enddo
         tdat(2)=tdat(1)+dt1
         xdat(2)=xdat(1)+dx1
c     set derivative values at endpoints --
         dleft  = dxgas(1) * nxtotal
         dright = dxgas(2) * nxtotal
c     compute spline coefficients for xfcn3(t) --
         call xcscoef

      ixtop = nxuse(1) + nxleg(igrid,1)       ! B2 code poloidal index ix at
                                        ! PLANET code index i=1
      xtop = distxp(1) + distxpxl(1)    ! B2 code poloidal distance x at
                                        ! PLANET code index i=1
      region=1
      do 81 i=1,ixpoint(1,region)
         ix = ixtop - (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xtop - xfcn3(t)
   81 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 82 i=ixpoint(3,region),ilmax(region)
         ix = ixtop - (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xtop - xfcn3(t)
   82 continue

      region=2
      do 83 i=1,ixpoint(1,region)
         ix = ixtop + (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn3(t) - xtop
   83 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 84 i=ixpoint(3,region),ilmax(region)
         ix = ixtop + (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn3(t) - xtop
   84 continue

      elseif (kxmesh .eq. 4) then       ! use analytic x-mesh from xfcn4(t)
         ndat=5
         ndatp2=ndat+2
c     re-define endpoints of data for spline
         alfx(1)=max(.0001,alfx(1))
         alfx(2)=max(.0001,alfx(2))
         tdat(1)=real(nxgas(1))/real(nxtotal)
         xdat(1)=dxgas(1)*(exp(alfx(1)*nxgas(1))-1.)
     &                   /(exp(alfx(1))-1.)
         tdat(5)=tdat(5)-real(nxgas(2))/real(nxtotal)
         xdat(5)=xdat(5)-dxgas(2)*(exp(alfx(2)*nxgas(2))-1.)
     &                           /(exp(alfx(2))-1.)
c     set derivative values at endpoints --
         ileft = 1
         dleft = dxgas(1)*alfx(1)*nxtotal*exp(alfx(1)*nxgas(1))
     &                                  /(exp(alfx(1))-1.)
         iright = 1
         dright = dxgas(2)*alfx(2)*nxtotal*exp(alfx(2)*nxgas(2))
     &                                   /(exp(alfx(2))-1.)
c     compute spline coefficients for xfcn4(t) --
         call xcscoef

      ixtop = nxuse(1) + nxleg(igrid,1)       ! B2 code poloidal index ix at
                                        ! PLANET code index i=1
      xtop = distxp(1) + distxpxl(1)    ! B2 code poloidal distance x at
                                        ! PLANET code index i=1
      region=1
      do 85 i=1,ixpoint(1,region)
         ix = ixtop - (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xtop - xfcn4(t,nxtotal)
   85 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 86 i=ixpoint(3,region),ilmax(region)
         ix = ixtop - (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xtop - xfcn4(t,nxtotal)
   86 continue

      region=2
      do 87 i=1,ixpoint(1,region)
         ix = ixtop + (i-1)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn4(t,nxtotal) - xtop
   87 continue
      seed(ixpoint(2,region),region) = seed(ixpoint(1,region),region)
      do 88 i=ixpoint(3,region),ilmax(region)
         ix = ixtop + (i-3)
         t = real(ix)/real(nxtotal)
         seed(i,region) = xfcn4(t,nxtotal) - xtop
   88 continue

      endif
c
c     *** finally obtain the coordinates of the seed points by interpolation.
c
c     Loop over regions --
      rbegin = 1
      if (ishalfm==1) rbegin = 2
      do 102 region=rbegin,noregs
      j=jsptrx(region)

      ii=1
      do 92 i=2,ilmax(region)-1
      ii=ii-1
   91 continue
      ii=ii+1
      if(dissep(ii,region).gt.seed(i,region)) then
         ds1=seed(i,region)-dissep(ii-1,region)
         ds2=dissep(ii,region)-seed(i,region)
         ds=ds1+ds2
         ic=ii+istartc(region)-2
         if(ic.eq.istartc(region)) then
            cmeshx(i,j)=(ds1*xcurveg(ic,j)+ds2*cmeshx(1,j))/ds
            cmeshy(i,j)=(ds1*ycurveg(ic,j)+ds2*cmeshy(1,j))/ds
         else if(ic.eq.iendc(region)) then
            cmeshx(i,j)=(ds1*cmeshx(ilmax(region),j)
     .                    +ds2*xcurveg(ic-1,j))/ds
            cmeshy(i,j)=(ds1*cmeshy(ilmax(region),j)
     .                    +ds2*ycurveg(ic-1,j))/ds
         else
            cmeshx(i,j)=(ds1*xcurveg(ic,j)+ds2*xcurveg(ic-1,j))/ds
            cmeshy(i,j)=(ds1*ycurveg(ic,j)+ds2*ycurveg(ic-1,j))/ds
         endif
      else
         goto 91
      endif
   92 continue

c     End loop over regions --
  102 continue

      return
      end

c     ------------------------------------------------------------------

      subroutine exponseed

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Calculate seed points using exponentials from plates and from X-pts  c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

            use Inmesh           !seedxp,seedxpxl
            use Dimflxgrd        !noregs,npts for use in Inmesh arrays
            use Dimensions       !idim for use in Inmesh arrays
            use Share            !geometry,nxcore
            use Comgeo           !xfs
            use Xpoint_indices   !ixpt1,ixpt2
            use UEgrid           !ixtop
            use Dim              !nxm
            use Expseed          !fraclplt,alfxdiv,alfxcore,rleg2core_len,
                           !shift_seed_leg,shift_seed_core,nxlplt,nxlixpt,
                           !fcorenunif

      implicit none
      integer im,ir,immax,isunifm,nxcore_use(2)
      real seedunifm,rleg2core_len(2)

      if (geometry=="snull") then
        nxcore_use(1) = nxcore(1,1)
        nxcore_use(2) = nxcore(1,2)
      elseif (geometry == "dnbot") then
        nxcore_use(1) = nxcore(1,1) - 1
        nxcore_use(2) = nxcore(1,2) - 1
      endif

c.. Compute seedxpxl in divertor legs
      rleg2core_len(1) = xfs(ixpt1(1))/(xfs(ixtop) - xfs(ixpt1(1)))
      rleg2core_len(2) = (xfs(nxm)-xfs(ixpt2(1)))/(xfs(ixpt2(1)) - 
     .                                                   xfs(ixtop))

c..  First do mesh near the plate (seeds large, start at 100)
c  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
      immax = nxlplt(1) + nxlxpt(1)
      seedxpxl(immax+1,1) = 100.
      do im = immax, nxlxpt(1), -1
        ir = immax - im
        seedxpxl(im,1) = 100. - 100.*fraclplt(1)*
     .                             (exp(alfxdiv(1)*(ir+1)) - 1) / 
     .                             (exp(alfxdiv(1)*nxlplt(1)) - 1)
      enddo
      immax = nxlplt(2) + nxlxpt(2)
      seedxpxl(immax+1,2) = 100.
      do im = immax, nxlxpt(2), -1
        ir = immax - im
        seedxpxl(im,2) = 100. - 100.*fraclplt(2)*
     .                             (exp(alfxdiv(2)*(ir+1)) - 1) / 
     .                             (exp(alfxdiv(2)*nxlplt(2)) - 1)
      enddo

c..  Do divertor legs near X-point (seeds small, start at 0)
c  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      seedxpxl(1,1) = 0.
      do im = 2, nxlxpt(1)
        seedxpxl(im,1) = shift_seed_leg(1) + \
                     (100.*(1.-fraclplt(1)) - shift_seed_leg(1))* 
     .                              (exp(alfxdiv(1)*(im-1)) - 1) / 
     .                              (exp(alfxdiv(1)*nxlxpt(1)) - 1)
      enddo

      seedxpxl(1,2) =0.
      do im = 2, nxlxpt(2)
        seedxpxl(im,2) = shift_seed_leg(2) + \
                     (100.*(1.-fraclplt(2)) - shift_seed_leg(2))* 
     .                              (exp(alfxdiv(2)*(im-1)) - 1) / 
     .                              (exp(alfxdiv(2)*nxlxpt(2)) - 1)
      enddo

c  Last, do in/out core regions; large seeds near x-point
c  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      seedxp(nxcore_use(1)+1,1) = 100.
      seedxp(nxcore_use(1),1) = 100.-rleg2core_len(1)*seedxpxl(2,1)-
     .                                      shift_seed_core(1)
      isunifm = 0
      do im = nxcore_use(1)-1, 2, -1
        if (isunifm == 0) then
          seedxp(im,1) = 100. - (100. - seedxp(im+1,1)) - 
     .                          rleg2core_len(1)*seedxpxl(2,1)* 
     .                         exp(alfxcore(1)*real(nxcore_use(1)-im))
          seedunifm = seedxp(im,1)/real(im-1)
          if (seedxp(im+1,1)-seedxp(im,1)>fcorenunif*seedunifm) isunifm=1
        elseif (isunifm == 1) then
          seedxp(im,1) = seedxp(im+1,1) - seedunifm
        endif
        seedxp(1,1) = 0.
      enddo

      seedxp(nxcore_use(2)+1,2) = 100.
      seedxp(nxcore_use(2),2) = 100. - rleg2core_len(2)*seedxpxl(2,2) - 
     .                                      shift_seed_core(2)
      isunifm = 0
      do im = nxcore_use(2)-1, 2, -1
        if (isunifm == 0) then
          seedxp(im,2) = 100. - (100. - seedxp(im+1,2)) - 
     .                          rleg2core_len(2)*seedxpxl(2,2)* 
     .                         exp(alfxcore(2)*real(nxcore_use(2)-im))
          seedunifm = seedxp(im,2)/real(im-1)
          if (seedxp(im+1,1)-seedxp(im,1)>fcorenunif*seedunifm) isunifm=1
        elseif (isunifm == 1) then
          seedxp(im,2) = seedxp(im+1,2) - seedunifm
        endif
        seedxp(1,2) = 0.
      enddo

      return
      end
c  end of subroutine exponseed
c     ------------------------------------------------------------------

      subroutine splfit
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Curves 
      use Inmesh 
      use Linkco 
      use System 
      use Transfm 
      use Share     ! cutlo,ishalfm

c     local variables --
      implicit none
      integer region,rbegin,j,iseg,is,icood,ii
      real z1,z2,s,t,alpha,rlimit

c     procedures --
      external clear,codsys

c     a small real number whose reciprocal does not overflow --
      rlimit = cutlo

c     initialization -- define rotation angles of fixed coordinate systems
      alphasys(1) = 0
      alphasys(2) = Pi/2
      alphasys(3) = Pi
      alphasys(4) = 3*Pi/2

c     clear the workspace and output arrays --
      call clear

c     loop over all regions --
      rbegin = 1
      if (ishalfm==1) rbegin = 2
      do 9696 region=rbegin,noregs

c     loop over all flux contours --
      do 1 j=jmin(region),jmax(region)

      iseg=0
      is=1

    2 continue          ! top of loop over spline-fit segments

      if(is.gt.npointg(j)) goto 1000    ! jump out of loop 2

c     icood=1, flux curve goes right, transform to system beta=0.
c     icood=2, flux curve goes up, transform to system beta=Pi/2.
c     icood=3, flux curve goes left, transform to system beta=Pi.
c     icood=4, flux curve goes down, transform to system, beta=3*Pi/2.

c     check the initial slope --
         z1=ycurveg(is,j)-ycurveg(is+1,j)
         z2=xcurveg(is,j)-xcurveg(is+1,j)
         if (abs(z2) .le. abs(z1)*rlimit) then
            alpha=90.
         else
            s=z1/z2
            t=atan(s)
            alpha=(180./Pi)*t
         endif
         if(abs(alpha) .le. alpha1) then
            if(xcurveg(is+1,j) .lt. xcurveg(is,j)) then
               icood=3
            else
               icood=1
            endif
         else
            if (ycurveg(is+1,j) .lt. ycurveg(is,j)) then
               icood=4
            else
               icood=2
            endif
         endif

      call codsys(j,icood,iseg,is,dyjump,region,alpha1)

      goto 2            ! end of loop over spline-fit segments


 1000 continue
      nseg(j)=iseg
      if(j.eq.jsptrx(region)) then
         ii=ixpointc(2,region)
         isegment(ii-2,j)=isegment(ii-3,j)
         isegment(ii-1,j)=isegment(ii-3,j)
         isegment(ii+1,j)=isegment(ii+3,j)
         isegment(ii+2,j)=isegment(ii+3,j)
      endif
      ii=npointg(j)
      isegment(ii,j)=isegment(ii-2,j)
      isegment(ii-1,j)=isegment(ii-2,j)

    1 continue          ! end of loop over flux contours

 9696 continue          ! end of loop over regions

      return
      end

c     ------------------------------------------------------------------

      subroutine transys(gamma,k1,k2,j)
      use Dimflxgrd 	!jdim,npts
      use Dimensions 
      use Curves 
      use Transit 
c
      implicit none
      integer k1, k2, j, k, l
      real gamma, rad, a, b
      do 233 k=1,npts
         xtrans(k)=0.0
         ytrans(k)=0.0
 233  continue
c
      rad=(Pi/180.)*gamma
c
      a=cos(rad)
      b=sin(rad)
c
      do 9299 l=k1,k2
         xtrans(l-k1+1)=xcurveg(l,j)*a+ycurveg(l,j)*b
         ytrans(l-k1+1)=-xcurveg(l,j)*b+ycurveg(l,j)*a
 9299 continue
c
      return
      end

c     ------------------------------------------------------------------

      real function xfcn(t)
      use Xmesh 
      implicit none
      real t
      real t1,t2,t3,t4,t5,x1,x2,x3,x4,x5,
     &     aa,beta2,beta4,x2p,x3p,x4p

      t1=tdat(1)
      t2=tdat(2)
      t3=tdat(3)
      t4=tdat(4)
      t5=tdat(5)
      x1=xdat(1)
      x2=xdat(2)
      x3=xdat(3)
      x4=xdat(4)
      x5=xdat(5)

c     Compute parameters for analytic representation of the x-mesh;
c     e.g., on t1 < t < t2 use the rational function
c
c           x(t) = x1 + (x2-x1)*(t-t1)*(beta2-t2)/((t2-t1)*(beta2-t))
c
c     and on t2 < t < t4  use a cubic that passes through points
c     (t2,x2), (t3,x3), and (t4,x4) with adjustable slope at (t3,x3)
c
c           x(t) =   x2*(t-t3)*(t-t4)/((t2-t3)*(t2-t4))
c                  + x3*(t-t2)*(t-t4)/((t3-t2)*(t3-t4))
c                  + x4*(t-t2)*(t-t3)/((t4-t2)*(t4-t3))
c                  + aa*(t-t2)*(t-t3)*(t-t4)
c
c     Choose beta2 so that x'(t) is continuous at t2.
c     And similarly for the outboard leg of the divertor,
c     on the interval t4 < t < t5 use the representation
c
c           x(t) = x5 + (x4-x5)*(t-t5)*(beta4-t4)/((t4-t5)*(beta4-t))
c
c     Choose beta4 so that x'(t) is continuous at t4.


c     The slope at t3 with only the quadratic terms included is

      x3p =      x2*(t3-t4)/((t2-t3)*(t2-t4))
     &    + x3*(2*t3-t2-t4)/((t3-t2)*(t3-t4))
     &         + x4*(t3-t2)/((t4-t2)*(t4-t3))

c     The cubic term enhances this slope by a factor slpxt if we choose

      aa = (slpxt-1)*x3p/((t3-t2)*(t3-t4))

c     The slopes at t2 and t4 are then given by

      x2p = x2*(2*t2-t3-t4)/((t2-t3)*(t2-t4))
     &         + x3*(t2-t4)/((t3-t2)*(t3-t4))
     &         + x4*(t2-t3)/((t4-t2)*(t4-t3)) + aa*(t2-t3)*(t2-t4)

      x4p =      x2*(t4-t3)/((t2-t4)*(t2-t3))
     &         + x3*(t4-t2)/((t3-t4)*(t3-t2))
     &    + x4*(2*t4-t3-t2)/((t4-t3)*(t4-t2)) + aa*(t4-t2)*(t4-t3)

c     For continuity at t2 and t4 we choose

      if (t2==t1) then
         beta2 = 999999999.   ! dummy value -- beta2 will not be used
      else
         beta2 = (x2p*t2*(t2-t1)-(x2-x1)*t1)/(x2p*(t2-t1)-(x2-x1))
      endif
      if (t5==t4) then
         beta4 = 999999999.   ! dummy value -- beta4 will not be used
      else
         beta4 = (x4p*t4*(t4-t5)-(x4-x5)*t5)/(x4p*(t4-t5)-(x4-x5))
      endif

c     Finally, x(t) is given by

      if (t .lt. t1) then
         xfcn=x1
      elseif ((t1 .le. t) .and. (t .lt. t2)) then
         xfcn=x1+(x2-x1)*(t-t1)*(beta2-t2)/((t2-t1)*(beta2-t))
      elseif ((t2 .le. t) .and. (t .le. t4)) then
         xfcn=x2*(t-t3)*(t-t4)/((t2-t3)*(t2-t4))
     &          + x3*(t-t2)*(t-t4)/((t3-t2)*(t3-t4))
     &             + x4*(t-t2)*(t-t3)/((t4-t2)*(t4-t3))
     &                + aa*(t-t2)*(t-t3)*(t-t4)
      elseif ((t4 .lt. t) .and. (t .le. t5)) then
         xfcn=x5+(x4-x5)*(t-t5)*(beta4-t4)/((t4-t5)*(beta4-t))
      elseif (t5 .lt. t) then
         xfcn=x5
      endif

      return
      end

c     ------------------------------------------------------------------

      real function xfcn2(t)
      use Xmesh 
      implicit none
      real t
      real t1,t2,t3,t4,t5,x1,x2,x3,x4,x5,
     &     aa,beta2,beta4,x2p,x3p,x4p

      t1=tdat(1)
      t2=tdat(2)
      t3=tdat(3)
      t4=tdat(4)
      t5=tdat(5)
      x1=xdat(1)
      x2=xdat(2)
      x3=xdat(3)
      x4=xdat(4)
      x5=xdat(5)

c     Compute parameters for analytic representation of the x-mesh;
c     e.g., on t1 < t < t2 use the exponential function
c
c           x(t) = x1 + (x2-x1)*(t-t1)*exp(beta2*(t-t2))/(t2-t1)
c
c     and on t2 < t < t4  use a cubic that passes through points
c     (t2,x2), (t3,x3), and (t4,x4) with adjustable slope at (t3,x3)
c
c           x(t) =   x2*(t-t3)*(t-t4)/((t2-t3)*(t2-t4))
c                  + x3*(t-t2)*(t-t4)/((t3-t2)*(t3-t4))
c                  + x4*(t-t2)*(t-t3)/((t4-t2)*(t4-t3))
c                  + aa*(t-t2)*(t-t3)*(t-t4)
c
c     Choose beta2 so that x'(t) is continuous at t2.
c     And similarly for the outboard leg of the divertor,
c     on the interval t4 < t < t5 use the representation
c
c           x(t) = x5 + (x4-x5)*(t-t5)*exp(beta4*(t-t4))/(t4-t5)
c
c     Choose beta4 so that x'(t) is continuous at t4.

c     The slope at t3 with only the quadratic terms included is

      x3p =      x2*(t3-t4)/((t2-t3)*(t2-t4))
     &    + x3*(2*t3-t2-t4)/((t3-t2)*(t3-t4))
     &         + x4*(t3-t2)/((t4-t2)*(t4-t3))

c     The cubic term enhances this slope by a factor slpxt if we choose

      aa = (slpxt-1)*x3p/((t3-t2)*(t3-t4))

c     The slopes at t2 and t4 are then given by

      x2p = x2*(2*t2-t3-t4)/((t2-t3)*(t2-t4))
     &         + x3*(t2-t4)/((t3-t2)*(t3-t4))
     &         + x4*(t2-t3)/((t4-t2)*(t4-t3)) + aa*(t2-t3)*(t2-t4)

      x4p =      x2*(t4-t3)/((t2-t4)*(t2-t3))
     &         + x3*(t4-t2)/((t3-t4)*(t3-t2))
     &    + x4*(2*t4-t3-t2)/((t4-t3)*(t4-t2)) + aa*(t4-t2)*(t4-t3)

c     For continuity at t2 and t4 we choose

      beta2 = (x2p*(t2-t1)-(x2-x1))/((t2-t1)*(x2-x1))
      beta4 = (x4p*(t4-t5)-(x4-x5))/((t4-t5)*(x4-x5))

c     Finally, x(t) is given by

      if (t .lt. t1) then
         xfcn2=x1
      elseif ((t1 .le. t) .and. (t .lt. t2)) then
         xfcn2=x1+(x2-x1)*(t-t1)*exp(beta2*(t-t2))/(t2-t1)
      elseif ((t2 .le. t) .and. (t .le. t4)) then
         xfcn2=x2*(t-t3)*(t-t4)/((t2-t3)*(t2-t4))
     &          + x3*(t-t2)*(t-t4)/((t3-t2)*(t3-t4))
     &             + x4*(t-t2)*(t-t3)/((t4-t2)*(t4-t3))
     &                + aa*(t-t2)*(t-t3)*(t-t4)
      elseif ((t4 .lt. t) .and. (t .le. t5)) then
         xfcn2=x5+(x4-x5)*(t-t5)*exp(beta4*(t-t4))/(t4-t5)
      elseif (t5 .lt. t) then
         xfcn2=x5
      endif

      return
      end

!----------------------------------------------------------------------!
      subroutine xcscoef
      use Xmesh 
c     compute spline interpolant for x(t)

      implicit none
      call BINTh4 (tdat, xdat, ndat, ileft, iright, dleft, dright,
     &            kntopt, tknt, z1cscoef, ndatp2, kord, z1work)

      return
      end

!----------------------------------------------------------------------!
      real function xfcn3(t)
      use Xmesh 
      implicit none
      real t
      real B1VAhL
      external B1VAhL
      integer inbv

c     evaluate the spline for x(t)

*
      inbv = 1		! initialization parameter for B1VAhL
         xfcn3 = B1VAhL (t, 0, tknt, ndatp2, kord, z1cscoef, inbv,
     &                  wrk1, iflag1)

      return
      end


!----------------------------------------------------------------------!
      real function xfcn4(t,nxtotal)
      use Xmesh 
      implicit none
      integer nxtotal
      real t
      real B1VAhL
      external B1VAhL
      integer inbv

      if ((0. .le. t) .and. (t .lt. tdat(1))) then
c     use exponential form --
         xfcn4 = dxgas(1)*(exp(alfx(1)*t*nxtotal)-1.)
     &                       /(exp(alfx(1))-1.)

      elseif ((tdat(1) .le. t) .and. (t .lt. tdat(5))) then
c     evaluate the spline for x(t) --
         inbv = 1
         xfcn4 = B1VAhL (t, 0, tknt, ndatp2, kord, z1cscoef, inbv,
     &                  wrk1, iflag1)

      elseif ((tdat(5) .le. t) .and. (t .le. 1.)) then
c     use exponential form --
         xfcn4 = xdat(5) + dxgas(2)*(exp(alfx(2)*nxgas(2))-
     &            exp(alfx(2)*(1.-t)*nxtotal))   /(exp(alfx(2))-1.)

      endif

      return
      end

!----------------------------------------------------------------------!
      subroutine intersect2 (x1,y1,i1min,i1max,x2,y2,i2min,i2max,
     .                     xc,yc,i1c,i2c,fuzz,ierr)
      implicit none
      integer i1min,i1max,i2min,i2max,i1c,i2c,ierr
      real x1(i1min:i1max),y1(i1min:i1max)
      real x2(i2min:i2max),y2(i2min:i2max),xc,yc,fuzz

c     Find the intersection of the two segmented curves :
c        (x1(i),y1(i)) i=i1min,i1max and (x2(i),y2(i)) i=i2min,i2max
c     Return the intersection point (xc,yc) and the node indices i1c
c     and i2c such that the intersection point lies between nodes 
c     i1c and i1c+1 of curve 1 and nodes ic2 and ic2+1 of curve 2.
c     Uncertainty in data points is specified by input parameter fuzz.
c     Return error flag ierr=1 if no intersection is found

      external remark,twixt
      logical twixt

c     local variables --
      integer i1,i2
      real tan1,tan2

c     initialize error flag --
      ierr=1

      do_i1: do i1=i1min,i1max-1
         i1c=i1
         if (x1(i1+1) .ne. x1(i1)) then
c           ! non-vertical segment of curve 1
	    tan1=(y1(i1+1)-y1(i1))/(x1(i1+1)-x1(i1))
	    do i2=i2min,i2max-1
	       i2c=i2
               if (x2(i2+1) .ne. x2(i2)) then
c                 ! non-vertical segment of curve 2
		  tan2=(y2(i2+1)-y2(i2))/(x2(i2+1)-x2(i2))
                  if (tan2 .ne. tan1) then
c                    ! compute intersection of extended line segments
		     xc=((y1(i1)-x1(i1)*tan1)-(y2(i2)-x2(i2)*tan2))
     .                  /(tan2-tan1)
		     yc=y2(i2)+(xc-x2(i2))*tan2
c                    ! test for actual intersection
                     if ( twixt(x2(i2),xc,x2(i2+1),fuzz) .and.
     .                    twixt(x1(i1),xc,x1(i1+1),fuzz) .and.
     .                    twixt(y2(i2),yc,y2(i2+1),fuzz) .and.
     .                    twixt(y1(i1),yc,y1(i1+1),fuzz) ) then
                        ierr=0
                        exit do_i1
                     endif
                  endif
               else
c                 ! vertical segment of curve 2
c                 ! compute intersection of extended line segments
                  xc=x2(i2)
                  yc=y1(i1)+(xc-x1(i1))*tan1
c                 ! test for actual intersection
                  if ( twixt(x2(i2),xc,x2(i2+1),fuzz) .and.
     .                 twixt(x1(i1),xc,x1(i1+1),fuzz) .and.
     .                 twixt(y2(i2),yc,y2(i2+1),fuzz) .and.
     .                 twixt(y1(i1),yc,y1(i1+1),fuzz) ) then
                     ierr=0
                     exit do_i1
                  endif
               endif
	    enddo
         else
c           ! vertical segment of curve 1
	    do i2=i2min,i2max-1
	       i2c=i2
               if (x2(i2+1) .ne. x2(i2)) then
c                 ! non-vertical segment of curve 2
		  tan2=(y2(i2+1)-y2(i2))/(x2(i2+1)-x2(i2))
c                 ! compute intersection of extended line segments
		  xc=x1(i1)
		  yc=y2(i2)+(xc-x2(i2))*tan2
c                 ! test for actual intersection
                  if ( twixt(x2(i2),xc,x2(i2+1),fuzz) .and.
     .                 twixt(x1(i1),xc,x1(i1+1),fuzz) .and.
     .                 twixt(y2(i2),yc,y2(i2+1),fuzz) .and.
     .                 twixt(y1(i1),yc,y1(i1+1),fuzz) ) then
                     ierr=0
                     exit do_i1
                  endif
               endif
	    enddo
         endif
      enddo do_i1

      return
      end
 
!----------------------------------------------------------------------!

      logical function twixt(x1,xc,x2,dx)
      implicit none
      real x1,xc,x2,dx

c     test for whether xc lies between x1 and x2

c     dx = magnitude of possible uncertainty in values of x1,xc,x2

      twixt=.false.

      if (x1 .le. x2) then
         if ( (x1-dx .le. xc) .and. (xc .le. x2+dx) ) twixt=.true.
      elseif (x1 .gt. x2) then
         if ( (x2-dx .le. xc) .and. (xc .le. x1+dx) ) twixt=.true.
      endif

      return
      end

c----------------------------------------------------------------------c

      subroutine getu
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Mmod 
      use Share       ! ismmon

      implicit none
      external gchange

! Define the default upstream reference surface arrays

      if (ismmon==2) then			! top+cut
c for the inboard half of the mesh:
	 nupstream1=jmax(1)-jmin(1)+3
	 call gchange("Mmod",0)
         call getu21
c for the outboard half of the mesh:
	 nupstream2=jmax(2)-jmin(2)+3
	 call gchange("Mmod",0)
         call getu22
      else
         if (isupstreamx==0) then               ! midplane+cut
c for the inboard half of the mesh:
            nupstream1=jmax(1)-jsptrx(1)+3
            call gchange("Mmod",0)
            call getu11
c for the outboard half of the mesh:
	    nupstream2=jsptrx(2)-jmin(2)+3
	    call gchange("Mmod",0)
            call getu12
         elseif (isupstreamx==1) then		! surface thru x-point
c for the inboard half of the mesh:
	    nupstream1=jmax(1)-jmin(1)+1
	    call gchange("Mmod",0)
            call getu41
c for the outboard half of the mesh:
	    nupstream2=jmax(2)-jmin(2)+1
	    call gchange("Mmod",0)
            call getu42
	 endif
      endif
      return
      end

c----------------------------------------------------------------------c

      subroutine getu11
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z upstream1

      implicit none
      integer iref1,j,k
      real eps
      data eps /1./

      iref1=ixpoint(3,1)			! the cut in the p.f. region
      k=0
      do j=jmax(1),jsptrx(1),-1
         k=k+1
         rupstream1(k)=cmeshx(iref1,j)
         zupstream1(k)=cmeshy(iref1,j)
      enddo
      k=k+1
      zupstream1(k)=zmagx			! the magnetic axis
      rupstream1(k)=rmagx
      k=k+1
      zupstream1(k)=zmagx			! the inboard midplane
      rupstream1(k)=0.
c extrapolate end point slightly:
      rupstream1(1)=rupstream1(1)+eps*(rupstream1(1)-rupstream1(2))
      zupstream1(1)=zupstream1(1)+eps*(zupstream1(1)-zupstream1(2))

      return
      end

c----------------------------------------------------------------------c

      subroutine getu12
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z upstream2

      implicit none
      integer iref2,j,k
      real eps
      data eps /1./

      iref2=ixpoint(3,2)		! the cut in the p.f. region
      k=0
      do j=jmin(2),jsptrx(2)
         k=k+1
         rupstream2(k)=cmeshx(iref2,j)
         zupstream2(k)=cmeshy(iref2,j)
      enddo
      k=k+1
      zupstream2(k)=zmagx		! the magnetic axis
      rupstream2(k)=rmagx
      k=k+1
      zupstream2(k)=zmagx		! the outboard midplane
      rupstream2(k)=2*rmagx
c extrapolate end point slightly:
      rupstream2(1)=rupstream2(1)+eps*(rupstream2(1)-rupstream2(2))
      zupstream2(1)=zupstream2(1)+eps*(zupstream2(1)-zupstream2(2))

      return
      end

c----------------------------------------------------------------------c

      subroutine getu41
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	! nupstream1, r,z upstream1

      implicit none
      integer iref1,j,k,m
      real eps
      data eps /1./

      iref1=ixpoint(3,1)		! the inboard PF cut surface
      k=0
      do j=jmax(1),jmin(1),-1
         k=k+1
         rupstream1(k)=cmeshx(iref1,j)
         zupstream1(k)=cmeshy(iref1,j)
      enddo
c extrapolate end points slightly:
      rupstream1(1)=rupstream1(1)+eps*(rupstream1(1)-rupstream1(2))
      zupstream1(1)=zupstream1(1)+eps*(zupstream1(1)-zupstream1(2))
      m=nupstream1
      rupstream1(m)=rupstream1(m)+eps*(rupstream1(m)-rupstream1(m-1))
      zupstream1(m)=zupstream1(m)+eps*(zupstream1(m)-zupstream1(m-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getu42
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	! nupstream2, r,z upstream2

      implicit none
      integer iref2,j,k,m
      real eps
      data eps /1./

      iref2=ixpoint(3,2)		! the outboard PF cut surface
      k=0
      do j=jmin(2),jmax(2)
         k=k+1
         rupstream2(k)=cmeshx(iref2,j)
         zupstream2(k)=cmeshy(iref2,j)
      enddo
c extrapolate end points slightly:
      rupstream2(1)=rupstream2(1)+eps*(rupstream2(1)-rupstream2(2))
      zupstream2(1)=zupstream2(1)+eps*(zupstream2(1)-zupstream2(2))
      m=nupstream2
      rupstream2(m)=rupstream2(m)+eps*(rupstream2(m)-rupstream2(m-1))
      zupstream2(m)=zupstream2(m)+eps*(zupstream2(m)-zupstream2(m-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getu21
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z upstream1

      implicit none
      integer iref1,j,k
      real eps
      data eps /1./

      iref1=ixpoint(3,1)		! the cut in the p.f. region
      k=0
      do j=jmax(1),jsptrx(1),-1
         k=k+1
         rupstream1(k)=cmeshx(iref1,j)
         zupstream1(k)=cmeshy(iref1,j)
      enddo
      k=k+1
      zupstream1(k)=zmagx		! the magnetic axis
      rupstream1(k)=rmagx
      iref1=1				! the top of the mesh
      do j=jsptrx(1),jmin(1),-1
         k=k+1
         rupstream1(k)=cmeshx(iref1,j)
         zupstream1(k)=cmeshy(iref1,j)
      enddo
c extrapolate end points slightly:
      rupstream1(1)=rupstream1(1)+eps*(rupstream1(1)-rupstream1(2))
      zupstream1(1)=zupstream1(1)+eps*(zupstream1(1)-zupstream1(2))
      rupstream1(nupstream1)=rupstream1(nupstream1)
     &          +eps*(rupstream1(nupstream1)-rupstream1(nupstream1-1))
      zupstream1(nupstream1)=zupstream1(nupstream1)
     &          +eps*(zupstream1(nupstream1)-zupstream1(nupstream1-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getu22
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z upstream2

      implicit none
      integer iref2,j,k
      real eps
      data eps /1./

      iref2=ixpoint(3,2)		! the cut in the p.f. region
      k=0
      do j=jmin(2),jsptrx(2)
         k=k+1
         rupstream2(k)=cmeshx(iref2,j)
         zupstream2(k)=cmeshy(iref2,j)
      enddo
      k=k+1
      zupstream2(k)=zmagx		! the magnetic axis
      rupstream2(k)=rmagx
      iref2=1				! the top of the mesh
      do j=jsptrx(2),jmax(2)
         k=k+1
         rupstream2(k)=cmeshx(iref2,j)
         zupstream2(k)=cmeshy(iref2,j)
      enddo
c extrapolate end points slightly:
      rupstream2(1)=rupstream2(1)+eps*(rupstream2(1)-rupstream2(2))
      zupstream2(1)=zupstream2(1)+eps*(zupstream2(1)-zupstream2(2))
      rupstream2(nupstream2)=rupstream2(nupstream2)\
                +eps*(rupstream2(nupstream2)-rupstream2(nupstream2-1))
      zupstream2(nupstream2)=zupstream2(nupstream2)\
                +eps*(zupstream2(nupstream2)-zupstream2(nupstream2-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getp
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Mmod 

      implicit none
      external gchange

! Define the default (orthogonal) divertor plate arrays


c for the inboard half of the mesh:
      nplate1=jmax(1)-jmin(1)+1
      call gchange("Mmod",0)
      call getp1

c for the outboard half of the mesh:
      nplate2=jmax(2)-jmin(2)+1
      call gchange("Mmod",0)
      call getp2

      return
      end

c----------------------------------------------------------------------c

      subroutine getp1
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 	! ilmax
      use Linkco 	! cmeshx,y
      use Mmod 	!  r,z plate1

      implicit none
      integer j,k,iref1
      real eps
      data eps /1./

      iref1=ilmax(1)		! the inboard-orthogonal-mesh plate

      k=0
      do j=jmax(1),jmin(1),-1
	 k=k+1
	 rplate1(k)=cmeshx(iref1,j)
	 zplate1(k)=cmeshy(iref1,j)
      enddo
c extrapolate end points slightly:
      rplate1(1)=rplate1(1)+eps*(rplate1(1)-rplate1(2))
      zplate1(1)=zplate1(1)+eps*(zplate1(1)-zplate1(2))
      rplate1(nplate1)=rplate1(nplate1)+eps*
     &                      (rplate1(nplate1)-rplate1(nplate1-1))
      zplate1(nplate1)=zplate1(nplate1)+eps*
     &                      (zplate1(nplate1)-zplate1(nplate1-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getp2
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 	! ilmax
      use Linkco 	! cmeshx,y
      use Mmod 	!  r,z plate2

      implicit none
      integer j,k,iref2
      real eps
      data eps /1./

      iref2=ilmax(2)		! the outboard-orthogonal-mesh plate

      k=0
      do j=jmin(2),jmax(2)
	 k=k+1
	 rplate2(k)=cmeshx(iref2,j)
	 zplate2(k)=cmeshy(iref2,j)
      enddo
c extrapolate end points slightly:
      rplate2(1)=rplate2(1)+eps*(rplate2(1)-rplate2(2))
      zplate2(1)=zplate2(1)+eps*(zplate2(1)-zplate2(2))
      rplate2(nplate2)=rplate2(nplate2)+eps*
     &                      (rplate2(nplate2)-rplate2(nplate2-1))
      zplate2(nplate2)=zplate2(nplate2)+eps*
     &                      (zplate2(nplate2)-zplate2(nplate2-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine smoother
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 	! ilmax
      use Linkco 	! ixpoint
      use Mmod 
      implicit none
      external smooth

      integer n,i

! Smooth all angle-like surfaces in the mesh
!	wtold   = weight parameter in smoothing algorithm
!	nsmooth = number of passes

      do n=1,nsmooth

c Above the x-point (SOL and core, inboard and outboard):
	 do i=2,ixpoint(1,1)-1
	    call smooth(i,jmin(1),jmax(1))
	 enddo
	 do i=2,ixpoint(1,2)-1
	    call smooth(i,jmin(2),jmax(2))
	 enddo

c Through the x-point (SOL only, inboard and outboard):
         call smooth(ixpoint(1,1),jmin(1),jsptrx(1))
         call smooth(ixpoint(2,1),jmin(1),jsptrx(1))
         call smooth(ixpoint(3,1),jmin(1),jsptrx(1))
         call smooth(ixpoint(1,2),jsptrx(2),jmax(2))
         call smooth(ixpoint(2,2),jsptrx(2),jmax(2))
         call smooth(ixpoint(3,2),jsptrx(2),jmax(2))

c Below the x-point (SOL and p.f., inboard and outboard):
	 do i=ixpoint(3,1)+1,ilmax(1)
	    call smooth(i,jmin(1),jmax(1))
	 enddo
	 do i=ixpoint(3,2)+1,ilmax(2)
	    call smooth(i,jmin(2),jmax(2))
	 enddo

      enddo

      return
      end

c----------------------------------------------------------------------c

      subroutine smoother2
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 	! ilmax
      use Linkco 	! ixpoint
      use Mmod 
      implicit none
      external smooth

      integer n,i

! Smooth all angle-like surfaces in the outer half of the mesh only
!	wtold   = weight parameter in smoothing algorithm
!	nsmooth = number of passes

      do n=1,nsmooth

c Above the x-point (SOL and core, inboard and outboard):
	 do i=2,ixpoint(1,2)-1
	    call smooth(i,jmin(2),jmax(2))
	 enddo

c Through the x-point (SOL only, inboard and outboard):
         call smooth(ixpoint(1,2),jsptrx(2),jmax(2))
         call smooth(ixpoint(2,2),jsptrx(2),jmax(2))
         call smooth(ixpoint(3,2),jsptrx(2),jmax(2))

c Below the x-point (SOL and p.f., inboard and outboard):
	 do i=ixpoint(3,2)+1,ilmax(2)
	    call smooth(i,jmin(2),jmax(2))
	 enddo

      enddo

      return
      end

c----------------------------------------------------------------------c

      subroutine gett
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Mmod 

      implicit none
      external gchange

! Define the top-of-mesh reference surface arrays

c for the inboard half of the mesh:
	 ntop1=jmax(1)-jmin(1)+3
	 call gchange("Mmod",0)
         call gett1

c for the outboard half of the mesh:
	 ntop2=jmax(2)-jmin(2)+3
	 call gchange("Mmod",0)
         call gett2

      return
      end

c----------------------------------------------------------------------c

      subroutine gett1
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z top1

      implicit none
      integer iref1,j,k
      real eps
      data eps /1./

      iref1=ixpoint(3,1)		! the cut in the p.f. region
					! for psi < 1
      k=0
      do j=jmax(1),jsptrx(1),-1
         k=k+1
         rtop1(k)=cmeshx(iref1,j)
         ztop1(k)=cmeshy(iref1,j)
      enddo
      k=k+1
      ztop1(k)=zmagx			! the magnetic axis
      rtop1(k)=rmagx
      iref1=1				! the top of the mesh
					! for psi > 1
      do j=jsptrx(1),jmin(1),-1
         k=k+1
         rtop1(k)=cmeshx(iref1,j)
         ztop1(k)=cmeshy(iref1,j)
      enddo
c extrapolate end points slightly:
      rtop1(1)=rtop1(1)+eps*(rtop1(1)-rtop1(2))
      ztop1(1)=ztop1(1)+eps*(ztop1(1)-ztop1(2))
      rtop1(ntop1)=rtop1(ntop1)
     &          +eps*(rtop1(ntop1)-rtop1(ntop1-1))
      ztop1(ntop1)=ztop1(ntop1)
     &          +eps*(ztop1(ntop1)-ztop1(ntop1-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine gett2
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z top2

      implicit none
      integer iref2,j,k
      real eps
      data eps /1./

      iref2=ixpoint(3,2)		! the cut in the p.f. region
      k=0
      do j=jmin(2),jsptrx(2)
         k=k+1
         rtop2(k)=cmeshx(iref2,j)
         ztop2(k)=cmeshy(iref2,j)
      enddo
      k=k+1
      ztop2(k)=zmagx			! the magnetic axis
      rtop2(k)=rmagx
      iref2=1				! the top of the mesh
      do j=jsptrx(2),jmax(2)
         k=k+1
         rtop2(k)=cmeshx(iref2,j)
         ztop2(k)=cmeshy(iref2,j)
      enddo
c extrapolate end points slightly:
      rtop2(1)=rtop2(1)+eps*(rtop2(1)-rtop2(2))
      ztop2(1)=ztop2(1)+eps*(ztop2(1)-ztop2(2))
      rtop2(ntop2)=rtop2(ntop2)\
                +eps*(rtop2(ntop2)-rtop2(ntop2-1))
      ztop2(ntop2)=ztop2(ntop2)\
                +eps*(ztop2(ntop2)-ztop2(ntop2-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getd
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Mmod 

      implicit none
      external gchange

! Define the downstream reference surface arrays

c for the inboard half of the mesh:
	 ndnstream1=jmax(1)-jmin(1)+1
	 call gchange("Mmod",0)
         call getd1

c for the outboard half of the mesh:
	 ndnstream2=jmax(2)-jmin(2)+1
	 call gchange("Mmod",0)
         call getd2

      return
      end

c----------------------------------------------------------------------c

      subroutine getd1
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z dnstream1

      implicit none
      integer iref1,j,k
      real eps
      data eps /1./

      iref1=ixpoint(3,1)
      k=0
      do j=jmax(1),jmin(1),-1
         k=k+1
         rdnstream1(k)=cmeshx(iref1,j)
         zdnstream1(k)=cmeshy(iref1,j)
      enddo
c extrapolate end points slightly:
      rdnstream1(1)=rdnstream1(1)+eps*(rdnstream1(1)-rdnstream1(2))
      zdnstream1(1)=zdnstream1(1)+eps*(zdnstream1(1)-zdnstream1(2))
      rdnstream1(ndnstream1)=rdnstream1(ndnstream1)
     &          +eps*(rdnstream1(ndnstream1)-rdnstream1(ndnstream1-1))
      zdnstream1(ndnstream1)=zdnstream1(ndnstream1)
     &          +eps*(zdnstream1(ndnstream1)-zdnstream1(ndnstream1-1))

      return
      end

c----------------------------------------------------------------------c

      subroutine getd2
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Inmesh 
      use Linkco 	! ixpoint,cmeshx,cmeshy
      use Mmod 	!  r,z dnstream2

      implicit none
      integer iref2,j,k
      real eps
      data eps /1./

      iref2=ixpoint(3,2)
      k=0
      do j=jmin(2),jmax(2)
         k=k+1
         rdnstream2(k)=cmeshx(iref2,j)
         zdnstream2(k)=cmeshy(iref2,j)
      enddo
c extrapolate end points slightly:
      rdnstream2(1)=rdnstream2(1)+eps*(rdnstream2(1)-rdnstream2(2))
      zdnstream2(1)=zdnstream2(1)+eps*(zdnstream2(1)-zdnstream2(2))
      rdnstream2(ndnstream2)=rdnstream2(ndnstream2)\
                +eps*(rdnstream2(ndnstream2)-rdnstream2(ndnstream2-1))
      zdnstream2(ndnstream2)=zdnstream2(ndnstream2)\
                +eps*(zdnstream2(ndnstream2)-zdnstream2(ndnstream2-1))

      return
      end

c     ------------------------------------------------------------------

      subroutine exleft
      use Dimflxgrd 	!nlim,nxefit,nyefit,jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 	!
      use Curves 	! xcurveg,ycurveg,npointg
      use Inmesh 
      use Linkco 	! dxleft,ndxleft

c     local variables --
      implicit none
      integer n,j,npt,j1,npt1
      real dx,dy,rleft,slope,yc1

      external remark,kaboom

c     This subroutine extrapolates flux contours beyond the left
c     boundary of the EFIT computational domain, to permit construction
c     of orthogonal meshes for high-triangularity TCV plasmas.
c
c     NDXLEFT data points are added to each flux surface in radial
c     steps of size DXLEFT.
c
c     Only the inboard flux surfaces are extrapolated at present.
c     In the future this may be modified to include outboard surfaces.

      rleft=rgrid1		! initialize left radial limit

      do n=1,ndxleft
         rleft=rleft-dxleft	! increment left radial limit

c     Extrapolate the separatrix: 
         j=jsptrx(1)
         npt=npointg(j)
         dx=rleft-xcurveg(npt,j)
         slope=(ycurveg(npt,j)-ycurveg(npt-1,j))/
     .            (xcurveg(npt,j)-xcurveg(npt-1,j))
         dy=slope*dx
         xcurveg(npt+1,j)=xcurveg(npt,j)+dx
         ycurveg(npt+1,j)=ycurveg(npt,j)+dy
         if (npointg(j) .lt. npts) then
            npointg(j)=npointg(j)+1
         else
            call remark("***  error in subroutine exleft  ***")
            call remark("*** npointg(j) exceeds npts limit ***")
            call kaboom(0)
         endif

c     Extrapolate SOL flux surfaces:
         do j=jsptrx(1)-1,jmin(1),-1
            npt=npointg(j)
            dx=rleft-xcurveg(npt,j)
            slope=(ycurveg(npt,j)-ycurveg(npt-1,j))/
     .            (xcurveg(npt,j)-xcurveg(npt-1,j))
            dy=slope*dx
            xcurveg(npt+1,j)=xcurveg(npt,j)+dx
            ycurveg(npt+1,j)=ycurveg(npt,j)+dy
c     Prevent flux surface intersection
            j1=j+1
            npt1=npointg(j1)
            yc1=ycurveg(npt1,j1)
            ycurveg(npt+1,j)=max(ycurveg(npt+1,j),yc1)
	    if (npointg(j) .lt. npts) then
	       npointg(j)=npointg(j)+1
	    else
	       call remark("***  error in subroutine exleft  ***")
	       call remark("*** npointg(j) exceeds npts limit ***")
	       call kaboom(0)
	    endif
         enddo

c     Extrapolate private flux surfaces:
         do j=jsptrx(1)+1,jmax(1)
            npt=npointg(j)
            dx=rleft-xcurveg(npt,j)
            slope=(ycurveg(npt,j)-ycurveg(npt-1,j))/
     .            (xcurveg(npt,j)-xcurveg(npt-1,j))
            dy=slope*dx
            xcurveg(npt+1,j)=xcurveg(npt,j)+dx
            ycurveg(npt+1,j)=ycurveg(npt,j)+dy
c     Prevent flux surface intersection
            j1=j-1
            npt1=npointg(j1)
            yc1=ycurveg(npt1,j1)
            ycurveg(npt+1,j)=min(ycurveg(npt+1,j),yc1)
	    if (npointg(j) .lt. npts) then
	       npointg(j)=npointg(j)+1
	    else
	       call remark("***  error in subroutine exleft  ***")
	       call remark("*** npointg(j) exceeds npts limit ***")
	       call kaboom(0)
	    endif
         enddo

      enddo

      return
      end

c----------------------------------------------------------------------c

      subroutine meshff (region)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Aeqflxgrd 	! rseps,zseps
      use Dimensions  ! nptmp
      use Curves      ! npointg,xcurveg,ycurveg
      use Inmesh      ! ilmax
      use Linkco      ! ixpoint,cmeshx,cmeshy
      use Mmod        ! ntop,ntop1,ntop2,rtop,rtop1,rtop2,ztop,ztop1,ztop2,
                ! nupstream,nupstream1,nupstream2,rupstream,rupstream1,
                ! rupstream2,zupstream,zupstream1,zupstream2,
                ! nplate,nplate1,nplate2,
                ! rplate,rplate1,rplate2,zplate,zplate1,zplate2,
                ! fuzzm,xmsh,ymsh,xcrv,ycrv,dsm,dsc,dsmesh,
                ! nff,nff1,nff2,rff,rff1,rff2,zff,zff1,zff2,
                ! cmeshx3,cmeshy3,dsmesh3,dsmeshff,
                ! isxtform,iswtform,cwtffu,cwtffd,
                ! wtff1,slpxff1,slpxffu1,slpxffd1,nxdff1,
                ! wtff2,slpxff2,slpxffu2,slpxffd2,nxdff2
      use Transfm     ! ijump

      implicit none
      integer region
      real xtform, wtform
      external intersect2, xtform, wtform
      external remark, kaboom

c     Local variables --
      integer i,iend,ii,j,j1,j2,k,ierr
      integer i1crv,i2crv,i1msh,i2msh,icu,kcu,icp,kcp
      integer ict,kct,imt,icff,kcff,imff,kmff,nxdff
      integer na,ica,kca
      real xcu,ycu,xcp,ycp,xct,yct,xmt,ymt
      real dscp,frac,eps
      real xcff,ycff,xmff,ymff,dscff
      real wtff,slpxff,slpxffu,slpxffd
      real ra(3),za(3),xca,yca
      real t,t1,t2,t3,x1,x2,x3,wt

c     This subroutine modifies the mesh stored in (cmeshx3,cmeshy3)
c     by re-distributing mesh points along each flux surface so
c     that the "flame front" region has better spatial resolution.

      data eps/1.0e-06/		! extrapolation parameter

      j1=jmin(region)
      j2=jmax(region)
      iend=ilmax(region)

c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
ccc
ccc   preparation procedures for subroutine meshff
ccc
c----------------------------------------------------------------------c

c     Define the top-of-mesh surface :
      if (region .eq. 1) then
         ntop=ntop1
         if (ntop .gt. nptmp) then
            call remark("dimension of r,ztop1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ntop
            rtop(k)=rtop1(k)
            ztop(k)=ztop1(k)
         enddo
      elseif (region .eq. 2) then
         ntop=ntop2
         if (ntop .gt. nptmp) then
            call remark("dimension of r,ztop2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ntop
            rtop(k)=rtop2(k)
            ztop(k)=ztop2(k)
         enddo
      endif

c     Define the upstream reference surface :
      if (region .eq. 1) then
         nupstream=nupstream1
         if (nupstream .gt. nptmp) then
            call remark("dimension of r,zupstream1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream1(k)
            zupstream(k)=zupstream1(k)
         enddo
      elseif (region .eq. 2) then
         nupstream=nupstream2
         if (nupstream .gt. nptmp) then
            call remark("dimension of r,zupstream2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nupstream
            rupstream(k)=rupstream2(k)
            zupstream(k)=zupstream2(k)
         enddo
      endif

c     Define the flamefront surface :
      if (region .eq. 1) then
         nff=nff1
         if (nff .gt. nptmp) then
            call remark("dimension of r,zff1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nff
            rff(k)=rff1(k)
            zff(k)=zff1(k)
         enddo
      elseif (region .eq. 2) then
         nff=nff2
         if (nff .gt. nptmp) then
            call remark("dimension of r,zff2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nff
            rff(k)=rff2(k)
            zff(k)=zff2(k)
         enddo
      endif

c     Define some flamefront mesh control parameters:
      if (region .eq. 1) then
         nxdff=nxdff1
         wtff=wtff1
         slpxff=slpxff1
         slpxffu=slpxffu1
         slpxffd=slpxffd1
      elseif (region .eq. 2) then
         wtff=wtff2
         slpxff=slpxff2
         slpxffu=slpxffu2
         slpxffd=slpxffd2
         nxdff=nxdff2
      endif

c     Define the divertor plate surface :
      if (region .eq. 1) then
         nplate=nplate1
         if (nplate .gt. nptmp) then
            call remark("dimension of r,zplate1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate1(k)
            zplate(k)=zplate1(k)
         enddo
      elseif (region .eq. 2) then
         nplate=nplate2
         if (nplate .gt. nptmp) then
            call remark("dimension of r,zplate2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,nplate
            rplate(k)=rplate2(k)
            zplate(k)=zplate2(k)
         enddo
      endif

c----------------------------------------------------------------------c

c     Determine flamefront position along the separatrix :
      j=jsptrx(region)
c     Define some temporary variables for (cmeshx,y) surface data
      i1msh=ixpoint(3,region)+1	! start index (just below x-point)
      i2msh=ilmax(region)	! end index (at plate)
      do i=i1msh,i2msh
         xmsh(i)=cmeshx3(i,j)
         ymsh(i)=cmeshy3(i,j)
      enddo
c     Intersection of (cmeshx,y) with flamefront surface
      call intersect2(rff,zff,1,nff,
     &                xmsh(i1msh),ymsh(i1msh),i1msh,i2msh,
     &                xmff,ymff,kmff,imff,fuzzm,ierr)
      if (ierr .ne. 0) then
         write (STDOUT,801) j
 801     format ("no flamefront intersection for cmeshx,y on j=",i3)
         call kaboom(0)
      endif
c     Allow the user to specify the number of cells downstream
c     between the flamefront and divertor plate
      if (nxdff .gt. 0) then
         imff=max(ixpoint(3,region)+1,ilmax(region)-nxdff)
      endif

c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c     Loop over all flux surfaces:
      do j=j1,j2

c     Define some temporary variables for (xcurveg,ycurveg) surface data
         i1crv=ijump(j)+1	! start index
         i2crv=npointg(j)	! end index
         if (j .eq. jsptrx(region)) i1crv=1
         do i=i1crv,i2crv
            xcrv(i)=xcurveg(i,j)
            ycrv(i)=ycurveg(i,j)
         enddo

c     Define some temporary variables for (cmeshx,y) surface data
         i1msh=1			! start at top of SOL
         i2msh=ilmax(region)		! end index
         if ( ((region .eq. 1) .and. (j .ge. jsptrx(1)))   .or.
     &        ((region .eq. 2) .and. (j .le. jsptrx(2))) ) then
            i1msh=ixpoint(3,region)	! start at p.f. cut
         endif
         do i=i1msh,i2msh
            xmsh(i)=cmeshx3(i,j)
            ymsh(i)=cmeshy3(i,j)
         enddo
c     extrapolate upstream slightly from the initial point
         xmsh(i1msh)=xmsh(i1msh)+eps*(xmsh(i1msh)-xmsh(i1msh+1))
         ymsh(i1msh)=ymsh(i1msh)+eps*(ymsh(i1msh)-ymsh(i1msh+1))

c     Top-of-mesh for cmeshx,y:
         if ( ((region .eq. 1) .and. (j .ge. jsptrx(1)))   .or.
     &        ((region .eq. 2) .and. (j .le. jsptrx(2))) ) then
            imt=ixpoint(3,region)
         else
            imt=1
         endif
         xmt=xmsh(imt)
         ymt=ymsh(imt)
c        index of first point below top-of-mesh is imt+1

c     Intersection of (x,ycurveg) with top-of-mesh surface
         call intersect2(rtop,ztop,1,ntop,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xct,yct,kct,ict,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,884) j
 884        format ("no top-of-mesh intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
         if (j .eq. jsptrx(region)) then	! top is at x-point
            ict=ijump(j)+2	! there are 3 identical data points here
            xct=rseps
            yct=zseps
         endif
c        index of first point below top-of-mesh is ict+1

c     Intersection of (x,ycurveg) with upstream reference surface
         call intersect2(rupstream,zupstream,1,nupstream,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcu,ycu,kcu,icu,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,885) j
 885        format ("no upstream intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below reference surface is icu+1
c        Ensure that upstream surface lies "below" top-of-mesh surface
         if (icu .lt. ict) then
            icu=ict
            xcu=xct
            ycu=yct
         endif

c     Intersection of (x,ycurveg) with flamefront surface
         call intersect2(rff,zff,1,nff,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcff,ycff,kcff,icff,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,886) j
 886        format ("no flamefront intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below flamefront surface is icff+1
c        Ensure that flamefront surface lies "below" upstream surface
         if (icff .lt. icu) then
            icff=icu
            xcff=xcu
            ycff=ycu
         endif

c     Intersection of (x,ycurveg) with divertor plate
c     NOTE: start the search at the top-of-mesh index, ict, to avoid
c     a possible problem with multiple intersections (MER 95/09/05)
         call intersect2(rplate,zplate,1,nplate,
     &                    xcrv(ict),ycrv(ict),ict,i2crv,
     &                    xcp,ycp,kcp,icp,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,888) j
 888        format ("no plate intersection for x,ycurveg on j=",i3)
            write (STDOUT,889)
 889        format ("*** You may have to extend the plate end points")
            call kaboom(0)
         endif
c        index of first point below divertor plate is icp+1

c     Distance from top-of-mesh to each data point along x,ycurveg
         xcrv(ict)=xct
         ycrv(ict)=yct
         dsc(ict)=0.
         do ii=ict+1,i2crv
            dsc(ii)=dsc(ii-1) +
     &                   sqrt( (xcrv(ii)-xcrv(ii-1))**2 +
     &                         (ycrv(ii)-ycrv(ii-1))**2 )
         enddo

c     Distance from top-of-mesh to flamefront
         dscff=dsc(icff)+sqrt( (xcff-xcrv(icff))**2 +
     &                       (ycff-ycrv(icff))**2 )

c     Distance from top-of-mesh to divertor plate
         dscp=dsc(icp)+sqrt( (xcp-xcrv(icp))**2 +
     &                       (ycp-ycrv(icp))**2 )

c     Ensure that flamefront is above divertor plate
         if (dscp .lt. dscff) then
            icff=icp
            xcff=xcp
            ycff=ycp
            dscff=dscp
         endif

c----------------------------------------------------------------------c
c     Compute new meshpoints (along x,ycurveg)
c----------------------------------------------------------------------c
c     First, the original distribution:
         dsmesh3(imt)=0.
         do i=imt+1,i2msh
c     Intersection of x,ycurveg with ith angle (orthogonal) surface
            na=3
            if (j .eq. jmin(region)) then
               ra(1)=2*cmeshx3(i,j)-cmeshx3(i,j+1)
               za(1)=2*cmeshy3(i,j)-cmeshy3(i,j+1)
            else
               ra(1)=cmeshx3(i,j-1)
               za(1)=cmeshy3(i,j-1)
            endif
            ra(2)=cmeshx3(i,j)
            za(2)=cmeshy3(i,j)
            if (j .eq. jmax(region)) then
               ra(3)=2*cmeshx3(i,j)-cmeshx3(i,j-1)
               za(3)=2*cmeshy3(i,j)-cmeshy3(i,j-1)
            else
               ra(3)=cmeshx3(i,j+1)
               za(3)=cmeshy3(i,j+1)
            endif
            call intersect2(ra,za,1,na,
     &                    xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                    xca,yca,kca,ica,fuzzm,ierr)
            if (ierr .ne. 0) then
               write (STDOUT,891) j,i
 891           format ("no angle intersection for x,ycurveg on j=",i3,
     &                 " at i=",i3)
               call kaboom(0)
            endif
c     Index of first (x,ycrv) point below angle surface is ica+1
            dsmesh3(i)=dsc(ica)+sqrt( (xca-xcrv(ica))**2
     &                               +(yca-ycrv(ica))**2 )
         enddo
c----------------------------------------------------------------------c
c     Then, the flamefront distribution:
         t1=ixpoint(3,region)
         x1=dsmesh3(ixpoint(3,region))
         t2=imff
         x2=dscff
         t3=i2msh
         x3=dscp
         do i=imt,i2msh
            if (i .le. ixpoint(3,region)) then
               dsmeshff(i)=dsmesh3(i)
            else
               t=i
               dsmeshff(i)=xtform(t,t1,t2,t3,x1,x2,x3,
     &                              slpxffu,slpxff,slpxffd,isxtform)
            endif
         enddo
c----------------------------------------------------------------------c

c     Combine the 3 & ff meshes according to weight factor wtff:
	 do i=imt,i2msh
            t=i
            wt=wtform(t,t1,t2,t3,wtff,cwtffu,cwtffd,iswtform)
	    dsmesh(i)=(1-wt)*dsmesh3(i)+wt*dsmeshff(i)
	 enddo

c     Modified cmeshx,cmeshy values --
         do i=imt+1,i2msh
            do ii=ict+1,i2crv
               if (dsmesh(i) .le. dsc(ii)) then
c     modified point i lies between (x,ycurveg) points ii-1 and ii
                  frac=(dsmesh(i)-dsc(ii-1))/
     &                 (dsc(ii)  -dsc(ii-1))
                  cmeshx(i,j)=xcrv(ii-1) + frac*(xcrv(ii)-xcrv(ii-1))
                  cmeshy(i,j)=ycrv(ii-1) + frac*(ycrv(ii)-ycrv(ii-1))
                  exit
               endif
            enddo
         enddo

      enddo	! end of loop over all j flux surfaces


      return
      end

c----------------------------------------------------------------------c

      real function wtform(t,t1,t2,t3,wtmax,gamma12,gamma23,iflag)
      implicit none
      integer iflag
      real t,t1,t2,t3,wtmax,gamma12,gamma23

      external remark,kaboom

      if (iflag .eq. 0) then
         wtform = wtmax
      elseif (iflag .eq. 1) then
         if (t .lt. t1) then
            wtform = 0.
         elseif ((t .ge. t1) .and. (t .le. t2)) then
            wtform = wtmax * ((t-t1)/(t2-t1))**gamma12
         elseif (t .gt. t2) then
            wtform = wtmax * ((t3-t)/(t3-t2))**gamma23
         endif
      else
         call remark("*** wtform: unknown iflag option ***")
         call kaboom(0)
      endif

      return
      end

c----------------------------------------------------------------------c

      real function xtform(t,t1,t2,t3,x1,x2,x3,
     &                       slopefac1,slopefac2,slopefac3,iflag)
      implicit none
      integer iflag
      real t,t1,t2,t3,x1,x2,x3,slopefac1,slopefac2,slopefac3

      real xtform1,xtform2,xtform3
      external xtform1,xtform2,xtform3,remark,kaboom

      if (iflag .eq. 1) then
         xtform = xtform1(t,t1,t2,t3,x1,x2,x3,
     &                      slopefac2)
      elseif (iflag .eq. 2) then
         xtform = xtform2(t,t1,t2,t3,x1,x2,x3,
     &                      slopefac1,slopefac2)
      elseif (iflag .eq. 3) then
         xtform = xtform3(t,t1,t2,t3,x1,x2,x3,
     &                      slopefac1,slopefac2,slopefac3)
      else
         call remark("*** xtform: unknown iflag option ***")
         call kaboom(0)
      endif

      return
      end

c----------------------------------------------------------------------c

      real function xtform1(t,t1,t2,t3,x1,x2,x3,slopefac2)
      implicit none
      real t,t1,t2,t3,x1,x2,x3,slopefac2

c     local variables --
      real alpha,beta,x2p

c     Compute parameters for analytic representation of the x-mesh;
c     On t1 < t < t2 use the rational function
c
c           x(t) = x1 + (x2-x1)*(t-t1)/((t2-t1)+alpha*(t2-t)
c
c     and on t2 < t < t3 use the rational function
c
c           x(t) = x2 + (x3-x2)*(t-t2)/((t3-t2)+beta*(t3-t))
c
c     where alpha and beta are chosen to give a specified slope
c     at t2.

c     Let the slope at t2 be some multiple of the average slope

      x2p = slopefac2*(x3-x1)/(t3-t1)

c     Then alpha and beta are given by

      alpha = (x2p*(t2-t1))/(x2-x1) - 1

      beta  = (x3-x2)/((t3-t2)*x2p) - 1

c     and x(t) is given by

      if (t .lt. t1) then
         xtform1=x1
      elseif ((t1 .le. t) .and. (t .lt. t2)) then
         xtform1=x1+(x2-x1)*(t-t1)/((t2-t1)+alpha*(t2-t))
      elseif ((t2 .le. t) .and. (t .le. t3)) then
         xtform1=x2+(x3-x2)*(t-t2)/((t3-t2)+beta*(t3-t))
      elseif (t3 .lt. t) then
         xtform1=x3
      endif

      return
      end

c----------------------------------------------------------------------c

      real function xtform2(t,t1,t2,t3,x1,x2,x3,slopefac1,slopefac2)
      implicit none
      real t,t1,t2,t3,x1,x2,x3,slopefac1,slopefac2

c     local variables --
      real alpha,beta,gamma,x1p,x2p

c     Compute parameters for analytic representation of the x-mesh;
c     On t1 < t < t2 use the rational function
c
c           x(t) = x1 + (x2-x1)*(t-t1)/((t2-t1)+alpha*(t2-t)+gamma*(t2-t)**2)
c
c     and on t2 < t < t3 use the rational function
c
c           x(t) = x2 + (x3-x2)*(t-t2)/((t3-t2)+beta*(t3-t))
c
c     where alpha, beta and gamma are chosen to give specified slopes
c     at t1 and t2.

c     Let the slope at t2 be some multiple of the average slope

      x2p = slopefac2*(x3-x1)/(t3-t1)

c     Then alpha and beta are given by

      alpha = (x2p*(t2-t1))/(x2-x1) - 1

      beta  = (x3-x2)/((t3-t2)*x2p) - 1

c     Let the slope at t1 be some multiple of the average slope

      x1p = slopefac1*(x3-x1)/(t3-t1)

c     Then gamma is given by

      gamma = (((x2-x1)/((t2-t1)*x1p))-1-alpha)/(t2-t1)

c     Finally, x(t) is given by

      if (t .lt. t1) then
         xtform2=x1
      elseif ((t1 .le. t) .and. (t .lt. t2)) then
         xtform2=x1+(x2-x1)*(t-t1)/((t2-t1)+alpha*(t2-t)+gamma*(t2-t)**2)
      elseif ((t2 .le. t) .and. (t .le. t3)) then
         xtform2=x2+(x3-x2)*(t-t2)/((t3-t2)+beta*(t3-t))
      elseif (t3 .lt. t) then
         xtform2=x3
      endif

      return
      end

c----------------------------------------------------------------------c

      real function xtform3(t,t1,t2,t3,x1,x2,x3,
     &                     slopefac1,slopefac2,slopefac3)
      implicit none
      real t,t1,t2,t3,x1,x2,x3,slopefac1,slopefac2,slopefac3

c     local variables --
      real alpha,beta,gamma,delta,x1p,x2p,x3p

c     Compute parameters for analytic representation of the x-mesh;
c     On t1 < t < t2 use the rational function
c
c           x(t) = x1 + (x2-x1)*(t-t1)/((t2-t1)+alpha*(t2-t)+gamma*(t2-t)**2)
c
c     and on t2 < t < t3 use the rational function
c
c           x(t) = x3 + (x2-x3)*(t-t3)/((t2-t3)+beta*(t2-t)+delta*(t2-t)**2)
c
c     where alpha, beta, gamma and delta are chosen to give specified
c     slopes at t1, t2 and t3.

c     Let the slope at t2 be some multiple of the average slope

      x2p = slopefac2*(x3-x1)/(t3-t1)

c     Then alpha and beta are given by

      alpha = (x2p*(t2-t1))/(x2-x1) - 1

      beta  = (x2p*(t2-t3))/(x2-x3) - 1

c     Let the slope at t1 be some multiple of the average slope

      x1p = slopefac1*(x3-x1)/(t3-t1)

c     Then gamma is given by

      gamma = (((x2-x1)/((t2-t1)*x1p))-1-alpha)/(t2-t1)

c     Let the slope at t3 be some multiple of the average slope

      x3p = slopefac3*(x3-x1)/(t3-t1)

c     Then delta is given by

      delta = (((x2-x3)/((t2-t3)*x3p))-1-beta)/(t2-t3)

c     Finally, x(t) is given by

      if (t .lt. t1) then
         xtform3=x1
      elseif ((t1 .le. t) .and. (t .lt. t2)) then
         xtform3=x1+(x2-x1)*(t-t1)/((t2-t1)+alpha*(t2-t)+gamma*(t2-t)**2)
      elseif ((t2 .le. t) .and. (t .le. t3)) then
         xtform3=x3+(x2-x3)*(t-t3)/((t2-t3)+beta*(t2-t)+delta*(t2-t)**2)
      elseif (t3 .lt. t) then
         xtform3=x3
      endif

      return
      end

c----------------------------------------------------------------------c

      subroutine getlim
      use Limiter     ! nlimu,nptnma,nsplit1,nsplit2

c     Define the limiter surfaces that interface with the inboard and
c     outboard regions of the mesh

      implicit none
      if (nptnma .eq. 0) then
         call remark("***")
         call remark("getlim: limiter point nma not defined")
         call remark("***")
         call kaboom(0)
      endif

c     For inboard region of the mesh:
      nsplit1=nptnma+1
      call gchange("com.Limiter",0)
      call getlim1

c     For outboard region of the mesh:
      nsplit2=nlimu-nptnma+2
      call gchange("com.Limiter",0)
      call getlim2

      return
      end

c----------------------------------------------------------------------c

      subroutine getlim1
      use Limiter     ! nlimu,rlimu,zlimu,nptnma,rptnma,zptnma
                ! rsplit1,zsplit1
      use Dimflxgrd 	!nlim,nxefit,nyefit
      use Comflxgrd 
      use Dimensions 

c     Define the limiter surface that interfaces with the inboard
c     region of the mesh

      implicit none
      integer n
      do n=1,nptnma
         rsplit1(n)=rlimu(n)
         zsplit1(n)=zlimu(n)
      enddo
      rsplit1(nptnma+1)=rmagx
      zsplit1(nptnma+1)=zmagx

      return
      end

c----------------------------------------------------------------------c

      subroutine getlim2
      use Limiter     ! nlimu,rlimu,zlimu,nptnma,rptnma,zptnma
                ! rsplit2,zsplit2
      use Dimflxgrd 	!nlim,nxefit,nyefit
      use Comflxgrd 
      use Dimensions 

c     Define the limiter surface that interfaces with the outboard
c     region of the mesh

      implicit none
      integer n
      do n=nlimu,nptnma,-1
         rsplit2(nlimu-n+1)=rlimu(n)
         zsplit2(nlimu-n+1)=zlimu(n)
      enddo
      rsplit2(nlimu-nptnma+2)=rmagx
      zsplit2(nlimu-nptnma+2)=zmagx

      return
      end

c----------------------------------------------------------------------c

      subroutine meshlim (region)
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions  ! nptmp
      use Curves      ! npointg,xcurveg,ycurveg
      use Inmesh 
      use Linkco      ! ixpoint,cmeshx,cmeshy
      use Mmod        ! ntop,rtop,ztop,ntop0,rtop0,ztop0,nbot,rbot,zbot,
                ! cmeshx0,cmeshy0,fuzzm,
                ! xmsh,ymsh,xcrv,ycrv,dsm,dsc,
                ! dsmesh0,dsmesh1,dsmesh,wtm1
      use Transfm     ! ijump
      use Limiter 	! nsplit1,rsplit1,zsplit1,nsplit2,rsplit2,zsplit2
      implicit none
      integer region
      external intersect2, remark, kaboom

c     Local variables --
      integer i,ii,j,j1,j2,k,ierr
      integer i1crv,i2crv,i1msh,i2msh,itop,ibot
      integer ict,kct,ict0,kct0,icb,kcb,imb
      integer na,ica,kca
      real xct,yct,xct0,yct0,xcb,ycb,xmb,ymb
      real frac,dsct,dsct0,dsmt0
      real ra(3),za(3),xca,yca

c     This subroutine modifies the original mesh by
c     re-distributing the mesh points along each flux surface.

      j1=jmin(region)
      j2=jmax(region)

c     Define the new (limiter interface) top-of-mesh surface :
      if (region .eq. 1) then
         ntop=nsplit1
         if (ntop .gt. nptmp) then
            call remark("meshlim:dimension of r,zsplit1 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ntop
            rtop(k)=rsplit1(k)
            ztop(k)=zsplit1(k)
         enddo
      elseif (region .eq. 2) then
         ntop=nsplit2
         if (ntop .gt. nptmp) then
            call remark("meshlim:dimension of r,zsplit2 exceeds nptmp")
            call kaboom(0)
         endif
         do k=1,ntop
            rtop(k)=rsplit2(k)
            ztop(k)=zsplit2(k)
         enddo
      endif

c     Define the original top-of-mesh surface :
      itop=1
      ntop0=j2-j1+1
         if (ntop0 .gt. nptmp) then
            call remark("meshlim:dimension of r,ztop0 exceeds nptmp")
            call kaboom(0)
         endif
      do k=j1,j2
         rtop0(k-j1+1)=cmeshx0(itop,k)
         ztop0(k-j1+1)=cmeshy0(itop,k)
      enddo
c     extrapolate end points slightly beyond the the original mesh
      rtop0(1)=2*rtop0(1)-rtop0(2)
      ztop0(1)=2*ztop0(1)-ztop0(2)
      rtop0(ntop0)=2*rtop0(ntop0)-rtop0(ntop0-1)
      ztop0(ntop0)=2*ztop0(ntop0)-ztop0(ntop0-1)

c----------------------------------------------------------------------c
c     Define the lower boundary separating the modified and unmodified
c     regions of the mesh; usually, the surface at i=ixpoint(1,region)
      ibot=ixpoint(1,region)
      nbot=j2-j1+1
         if (nbot .gt. nptmp) then
            call remark("meshlim:dimension of r,zbot exceeds nptmp")
            call kaboom(0)
         endif
      do k=j1,j2
         rbot(k-j1+1)=cmeshx0(ibot,k)
         zbot(k-j1+1)=cmeshy0(ibot,k)
      enddo
c     extrapolate end points slightly beyond the the original mesh
      rbot(1)=2*rbot(1)-rbot(2)
      zbot(1)=2*zbot(1)-zbot(2)
      rbot(nbot)=2*rbot(nbot)-rbot(nbot-1)
      zbot(nbot)=2*zbot(nbot)-zbot(nbot-1)

c----------------------------------------------------------------------c
c     Loop over all flux surfaces:
      do j=j1,j2

c     Define some temporary variables for (xcurveg,ycurveg) surface data
         i1crv=1			! start index
         if (ijump(j) .ne. 0) then
            i2crv=ijump(j)		! end at last core data point
         else
            i2crv=npointg(j)		! end at last SOL data point
         endif
         if (j .eq. jsptrx(region)) i2crv=npointg(j)
         do i=i1crv,i2crv
            xcrv(i)=xcurveg(i,j)
            ycrv(i)=ycurveg(i,j)
         enddo

c     Define some temporary variables for (cmeshx,y) surface data
         i1msh=1			! start at top of SOL
         i2msh=ixpoint(1,region)	! end index (at x-point)
         do i=i1msh,i2msh
            xmsh(i)=cmeshx0(i,j)
            ymsh(i)=cmeshy0(i,j)
         enddo

c     bottom-of-mesh for cmeshx,y:
         imb=ibot
         xmb=xmsh(imb)
         ymb=ymsh(imb)

c     Distance from bottom to each meshpoint along cmeshx,y
         dsm(imb)=0.
         do i=imb-1,i1msh,-1
            dsm(i)=dsm(i+1) +
     &                   sqrt( (xmsh(i)-xmsh(i+1))**2 +
     &                         (ymsh(i)-ymsh(i+1))**2 )
         enddo

c     Distance from bottom to old top-of-mesh
         dsmt0=dsm(i1msh)

c----------------------------------------------------------------------c

c     Intersection of (x,ycurveg) with new top-of-mesh surface
         call intersect2(rtop,ztop,1,ntop,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xct,yct,kct,ict,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,884) j
 884        format ("no top-of-mesh intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below top-of-mesh is ict+1

c     Intersection of (x,ycurveg) with old top-of-mesh surface
         call intersect2(rtop0,ztop0,1,ntop0,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xct0,yct0,kct0,ict0,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,885) j
 885        format ("no top-of-mesh intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below top-of-mesh is ict0+1

c     Intersection of (x,ycurveg) with bottom surface
         call intersect2(rbot,zbot,1,nbot,
     &                   xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                   xcb,ycb,kcb,icb,fuzzm,ierr)
         if (ierr .ne. 0) then
            write (STDOUT,886) j
 886        format ("no bot intersection for x,ycurveg on j=",i3)
            call kaboom(0)
         endif
c        index of first point below bottom surface is icb+1


c     Distance from bottom-of-mesh to each data point along x,ycurveg
         xcrv(icb+1)=xcb
         ycrv(icb+1)=ycb
         dsc(icb+1)=0.
         do ii=icb,i1crv,-1
            dsc(ii)=dsc(ii+1) +
     &                   sqrt( (xcrv(ii)-xcrv(ii+1))**2 +
     &                         (ycrv(ii)-ycrv(ii+1))**2 )
         enddo

c     Distance from bottom to new top-of-mesh
         dsct=dsc(ict)-sqrt( (xct-xcrv(ict))**2 +
     &                       (yct-ycrv(ict))**2 )

c     Distance from bottom to old top-of-mesh
         dsct0=dsc(ict0)-sqrt( (xct0-xcrv(ict0))**2 +
     &                         (yct0-ycrv(ict0))**2 )

c----------------------------------------------------------------------c
c     Compute new meshpoints (along x,ycurveg) for each grid option
c----------------------------------------------------------------------c
c     First, the islimon=0 option:
         dsmesh0(imb)=0.
         do i=imb-1,i1msh,-1
c     Intersection of x,ycurveg with ith angle (orthogonal) surface
            na=3
            if (j .eq. jmin(region)) then
               ra(1)=2*cmeshx0(i,j)-cmeshx0(i,j+1)
               za(1)=2*cmeshy0(i,j)-cmeshy0(i,j+1)
            else
               ra(1)=cmeshx0(i,j-1)
               za(1)=cmeshy0(i,j-1)
            endif
            ra(2)=cmeshx0(i,j)
            za(2)=cmeshy0(i,j)
            if (j .eq. jmax(region)) then
               ra(3)=2*cmeshx0(i,j)-cmeshx0(i,j-1)
               za(3)=2*cmeshy0(i,j)-cmeshy0(i,j-1)
            else
               ra(3)=cmeshx0(i,j+1)
               za(3)=cmeshy0(i,j+1)
            endif
            call intersect2(ra,za,1,na,
     &                    xcrv(i1crv),ycrv(i1crv),i1crv,i2crv,
     &                    xca,yca,kca,ica,fuzzm,ierr)
            if (ierr .ne. 0) then
               write (STDOUT,891) j,i
 891           format ("no angle intersection for x,ycurveg on j=",i3,
     &                 " at i=",i3)
               call kaboom(0)
            endif
c     Index of first (x,ycrv) point below angle surface is ica+1
            dsmesh0(i)=dsc(ica)-sqrt( (xca-xcrv(ica))**2
     &                               +(yca-ycrv(ica))**2 )
         enddo
c----------------------------------------------------------------------c
c     Then, the non-zero islimon option:
         do i=imb,i1msh,-1
            dsmesh1(i)=dsmesh0(i)*dsct/dsct0
         enddo
c----------------------------------------------------------------------c
c     Combine options:  weighting will be implemented later
         do i=imb,i1msh,-1
            wtm1(i)=1.
            dsmesh(i)=(1-wtm1(i))*dsmesh0(i) + wtm1(i)*dsmesh1(i)
         enddo
c----------------------------------------------------------------------c

c     Modified cmeshx,cmeshy values --
            do i=imb-1,i1msh,-1
               do ii=icb,i1crv,-1
                  if (dsmesh(i) .le. dsc(ii)) then
c     modified point i lies between (x,ycurveg) points ii and ii+1
                     frac=(dsmesh(i)-dsc(ii+1))/
     &                    (dsc(ii)  -dsc(ii+1))
                     cmeshx(i,j)=xcrv(ii+1) + frac*(xcrv(ii)-xcrv(ii+1))
                     cmeshy(i,j)=ycrv(ii+1) + frac*(ycrv(ii)-ycrv(ii+1))
                     exit
                  endif
               enddo
            enddo

      enddo	! end of loop over all j flux surfaces

      return
      end

c----------------------------------------------------------------------c

      subroutine setlimindex
      use Dimflxgrd 	!jdim,npts,noregs
      use Comflxgrd 
      use Dimensions 
      use Linkco   ! cmeshx,y
      use Inmesh 
      use Share    ! nxleg,nxcore,nxomit,nxxpt,ix_lim,iy_lims
      use Limiter  ! dslims
      implicit none
      integer j,jj,j1
      real ds

! Set the poloidal index, ix_lim, of the limiter interface:
      ix_lim = nxleg(1,1) + nxcore(1,1) + 2*nxxpt - max(0, nxomit)

! Starting at the innermost core flux surface, search radially
! outward for the index of the first flux surface that has a poloidal
! gap at the inboard/outboard mesh interface.  This defines the 
! starting index iy=iy_lims for limiter recycling boundary conditions.
      do j=jmin(2),jmax(2)
         jj = j - jmin(2)
         j1 = jmax(1) - jj
         ds = sqrt( (cmeshx(1,j)-cmeshx(1,j1))**2
     .             +(cmeshy(1,j)-cmeshy(1,j1))**2 )
         if (ds .ge. dslims) then
            iy_lims = jj
            exit
         endif
      enddo

      return
      end

c----------------------------------------------------------------------c

      real FUNCTION BRENT(iprint,ITMAX,AX,BX,CX,F,TOL,XMIN)
c ... Given a function F, and given a bracketing triplet of abscissas
c     AX, BX, CX (such that BX is between AX and CX, and F(BX) is less
c     than both F(AX) and F(CX)), this routine isolates the minimum to
c     a fractional precision of about TOL using Brent's method.  The
c     abscissa of the minimum is returned as XMIN, and the minimum
c     function value is returned as BRENT, the returned function value.
c ... This version of BRENT uses an additional (first) argument ITMAX,
c     the maximum allowed number of iterations, and returns to the
c     Basis parser by calling kaboom if convergence is not achieved in
c     ITMAX iterations.

      implicit none

c ... Input variables:
      integer iprint
      integer ITMAX
      real AX, BX, CX, TOL

c ... Output variable:
      real XMIN

c ... External function:
      external F
      real F

c ... Local variables:
      integer ITER
      real A, B, D, ETEMP, FU, FV, FW, FX, P, Q, R, TOL1, TOL2
      real U, V, W, X, XM, E

c ... CGOLD is the golden ratio; ZEPS is a small number that protects
c     against trying to achieve fractional accuracy for a minimum that
c     happens to be exactly zero.
      real CGOLD, ZEPS
      PARAMETER (CGOLD=.3819660)
      ZEPS = tol

c ... Description of the algorithm is in "Numerical Recipes in C" by
c     W.H. Press, et al., Sec. 10.2.
      A=MIN(AX,CX)
      B=MAX(AX,CX)
      V=BX
      W=V
      X=V
      E=0.
      FX=F(X)
      FV=FX
      FW=FX
      DO 11 ITER=1,ITMAX
        if (iprint .gt. 1) write(*,90) 'brent:  iteration ', ITER,
     .                        ' -- test point has f(', X, ') = ', FX
 90     format(a,i2,2(a,f11.7))
        XM=0.5*(A+B)
        TOL1=TOL*ABS(X)+ZEPS
        TOL2=2.*TOL1
        IF(ABS(X-XM).LE.(TOL2-.5*(B-A))) GOTO 3
        IF(ABS(E).GT.TOL1) THEN
          R=(X-W)*(FX-FV)
          Q=(X-V)*(FX-FW)
          P=(X-V)*Q-(X-W)*R
          Q=2.*(Q-R)
          IF(Q.GT.0.) P=-P
          Q=ABS(Q)
          ETEMP=E
          E=D
          IF(ABS(P).GE.ABS(.5*Q*ETEMP).OR.P.LE.Q*(A-X).OR. 
     *        P.GE.Q*(B-X)) GOTO 1
          D=P/Q
          U=X+D
          IF(U-A.LT.TOL2 .OR. B-U.LT.TOL2) D=SIGN(TOL1,XM-X)
          GOTO 2
        ENDIF
1       IF(X.GE.XM) THEN
          E=A-X
        ELSE
          E=B-X
        ENDIF
        D=CGOLD*E
2       IF(ABS(D).GE.TOL1) THEN
          U=X+D
        ELSE
          U=X+SIGN(TOL1,D)
        ENDIF
        FU=F(U)
        IF(FU.LE.FX) THEN
          IF(U.GE.X) THEN
            A=X
          ELSE
            B=X
          ENDIF
          V=W
          FV=FW
          W=X
          FW=FX
          X=U
          FX=FU
        ELSE
          IF(U.LT.X) THEN
            A=U
          ELSE
            B=U
          ENDIF
          IF(FU.LE.FW .OR. W.EQ.X) THEN
            V=W
            FV=FW
            W=U
            FW=FU
          ELSE IF(FU.LE.FV .OR. V.EQ.X .OR. V.EQ.W) THEN
            V=U
            FV=FU
          ENDIF
        ENDIF
11    CONTINUE
      call xerrab ('*** brent exceeded maximum iterations.')
3     XMIN=X
      BRENT=FX
      if (iprint .ge. 1) write(*,91) 'brent:  final point has f(',
     .                      X, ') = ', FX
 91   format(2(a,f11.7))
      RETURN
      END

      integer function ijmgetmr(msg,max,iwait,nbrcv)
c     
      character*(*) msg
      integer max, iwait, nbrcv
      character*80 chi
c     integer input(10)
      character*80 input
      equivalence(input,chi)
      integer i, rdfile, fcntl
      integer f_setfl, f_getfl, o_ndelay, fildes, args, curr_fl
      data fildes /0/, f_setfl /4/, f_getfl /3/, o_ndelay /4/, args /0/
c     
c     fildes=0
c     f_setfl=4
c     o_ndelay=4
c  GET CURRENT FLAGS FOR STDIN
      curr_fl=fcntl(fildes,f_getfl,args)
c     write(*,*) 'In ijmgetmr; curr_fl = ', curr_fl 
c  TURN ON O_NODELAY
      args = o_ndelay
ccc      args = curr_fl .or. o_ndelay
ccc TDR 5/26/03  replace previous line with similar that avoids some compile
c     write (*,*) 'In ijmgetmr (fcntl); args = ', args
      i=fcntl(fildes,f_setfl,args)
c     write(*,*) 'In ijmgetmr; i = ', i
      if (i.eq.-1) then
         write (102,*) "call to fcntl failed"
         stop 'fcntl'
      endif
c  DO READ 
      input = 'oops'
      i=rdfile(fildes,input,80)
c     write(*,*) 'In ijmgetmr (rdfile); i = ', i
c     if (i.eq.-1) then
c        write(102,*) "call to read failed"
c        ijmgetmr = 2
c        stop 'read'
c     elseif (i.eq.0) then
      if (i.le.0) then
	 ijmgetmr = 1
      else
	 msg = chi(1:i-1)
	 nbrcv = i-1
	 ijmgetmr = 0
      endif
c  RESET FLAGS   
      i=fcntl(fildes,f_setfl,curr_fl)
c     write(*,*) 'In ijmgetmr (reset); i = ', i
      return
      end

#include "bbb.h"
#include "../com/com.h"
#include "../mppl.h"
#include "../sptodp.h"


c-----------------------------------------------------------------------
c***************************************************
c Subroutine to initialize an external neutrals model
c***************************************************
      subroutine init_neutrals()

            use Ext_neutrals  !extneutopt

      implicit none

      if (extneutopt .eq. 1) then      	!EIRENE
        call init_eirene()
      else if (extneutopt .eq. 2) then 	!DEGAS2
        call init_degas2()
      end if
      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to initialize DEGAS2 neutrals model
c***************************************************
      subroutine init_degas2()

c ... Common blocks:
            use Ext_neutrals  !gecmd, geufile

c ... Local variables:
      implicit none

      character*256 :: cmd
      logical :: isechocmdon =.false.  !uses "echo cmd" for debugging purposes

c ... Set up atomic data files
      cmd="./datasetup"
      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
      call system(trim(cmd))

c ... Set problem specific files
      cmd="./problemsetup"
      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
      call system(trim(cmd))

c ... Process geometry file
      cmd=trim(gecmd)//" "//trim(geufile)
      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
      call system(trim(cmd))

c ... Set options for MC run
      cmd="./tallysetup"
      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
      call system(trim(cmd))

c ... If desired, process background file before flighttest


      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to initialize EIRENE neutrals model
c***************************************************
      subroutine init_eirene()

      character*80 :: cmd

      cmd="echo "//"Hello eirene!"
      call system(trim(cmd))

      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to call an external neutrals model
c***************************************************
      subroutine run_neutrals()

c ... Common blocks:
            use Ext_neutrals  !extneutopt

      implicit none

      if (extneutopt .eq. -1) then      !spawn external UEDGE
        call run_uedge
      else if (extneutopt .eq. 1) then  !spawn external EIRENE
        call run_eirene
      else if (extneutopt .eq. 2) then 	!spawn external DEGAS2
        call run_degas2
      else 							 	!internal UEDGE
        call uedge_neutrals
      end if

      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to call UEDGE from shell
c***************************************************
      subroutine run_uedge()

c ... Common blocks:
            use Ext_neutrals  !uedgesave, uedgefile, uedgescript, uedgecmd

c ... Local variables:
      implicit none

      integer :: s
      character*256 :: cmd
      character*1 :: backslash="\\"  !pgf90, ifort, gfortran
      logical :: isechocmdon =.false.  !uses "echo cmd" for debugging purposes

c ... External functions:
      integer uedge_save_pdb
c      integer uedge_read_pdb

c ... Save current state
      s=uedge_save_pdb(trim(uedgesave))

c ... Execute uedgecmd, read uedgescript, and exit
c      write(*,*) '*************************************'
      write(*,*) "------------------------------------------------"
      write(*,*) "Running a new UEDGE session"
      
c ... Run a new UEDGE session
 	  cmd = trim(uedgecmd//" ""read "//uedgescript//";quit""")
      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
	  call system(trim(cmd))

c ... Read output data from uedgefile
c      s=uedge_read_pdb(trim(uedgefile))

      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to call DEGAS2 neutrals model
c***************************************************
      subroutine run_degas2()

c ... Common blocks:
            use Dim       	!nisp, ngsp, ...
            use MCN_dim       !nstra
            use Ext_neutrals 

c ... Local variables:
      implicit none

      integer :: istra
      character*256 :: cmd
	  character*16 :: npextstr, nflightstr(nstra)
      character*1 :: backslash="\\"  !pgf90, ifort, gfortran
      logical :: isechocmdon =.false.  !uses "echo cmd" for debugging purposes

      if(ext_verbose) then
c       write(*,*) '*************************************'
        write(*,*) "------------------------------------------------"
        write(*,*) "Running DEGAS2 Monte Carlo neutrals"
        write(*,*) "... until steady state"	
      endif

c ... Allocate MNC data storage ???
c     call gchange("MCN_sources",0) !wsor, sni, ... see

c ... Write uedge plasma data
      if(isechocmdon) then
        cmd="call writemcnfile("""//trim(bkufile)//""","""//trim(runid)//""")"
        print *,trim(cmd)
      else
	    call writemcnfile(bkufile,runid)	  	  	 
      end if

c ... Process plasma data into degas2 background file format 
	  cmd = trim(bkcmd)//" "//trim(bkufile)
c      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
	  call system(trim(cmd))

c ... Set parameters in degas2 background file
      do istra=1,nstra
	    write(nflightstr(istra),'(i0)') mcnflights(istra)
      enddo
	  cmd = trim(ncsetcmd)//" "//trim(bkdfile)//" "//trim(ncsetvar)
	  if (isechocmdon) then
       cmd=trim(cmd)//" "//backslash//"'"
      else
       cmd=trim(cmd)//" '"
      endif
      cmd = trim(cmd)//trim(nflightstr(1))
      do istra=2,nstra
        cmd = trim(cmd)//" , "//trim(nflightstr(istra))
      enddo
	  if (isechocmdon) cmd=trim(cmd)//backslash
      cmd = trim(cmd)//"'"
c      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *, trim(cmd)
	  call system(trim(cmd))

c ... Run degas2 MC neutrals code
	  if(ismpicmdon) then
	    write(npextstr,'(i0)') npext 
 	    cmd = trim(degas2mpi)
		cmd=trim(mpicmd)//" "//trim(npopt)//" "//trim(npextstr)//" "//trim(cmd)
      else
 	    cmd = trim(degas2cmd)
	  end if
      if (istimecmdon) cmd="time "//trim(cmd)
      if (isechocmdon) cmd="echo "//trim(cmd)
      if (ext_verbose) print *,trim(cmd)
	  call system(trim(cmd))

c ... Read data and convert
      if(get_neutral_sources) then 
c ... Read source data
        if(isechocmdon) then
          cmd="call readmcnsor("""//trim(degas2file)//""")"
          print *,trim(cmd)
        else
          call readmcnsor(degas2file)
        end if
c ...  Convert source data
        if(isechocmdon) then
          cmd="call convertmcnsor"
          print *,trim(cmd)
        else
          call convertmcnsor
        end if
      end if 

      if(get_neutral_moments) then
c ... Generate moment data using outputbrowser
        cmd = trim(degas2outcmd) //" "//trim(degas2outscript)        
c        if (istimecmdon) cmd="time "//trim(cmd)
        if (isechocmdon) cmd="echo "//trim(cmd)
        if (ext_verbose) print *,trim(cmd)
        call system(trim(cmd))
c ... Filter moment data
        cmd="cd "//trim(neut_output_dir)
        cmd=trim(cmd)//"; ../"//trim(degas2outsh)
        cmd=trim(cmd)//"; cd .."
        if (ext_verbose) print *,trim(cmd)
        call system(trim(cmd))
c ... Read moment data
        if(isechocmdon) then
          cmd="call readmcnmoments("""//trim(neut_output_dir)//""")"
          print *,trim(cmd)
        else
          call readmcnmoments(trim(neut_output_dir))
        end if
c ... Convert moment data
        if(isechocmdon) then
          cmd="call convertmcnmoments"
          print *,trim(cmd)
        else
          call convertmcnmoments
        end if
      end if 

      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to call EIRENE neutrals model
c***************************************************
      subroutine run_eirene()

      implicit none

      character*80 :: cmd

      cmd="echo "//"Run eirene!"
      call system(trim(cmd))

      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to solve UEDGE fluid plasma model
c***************************************************

      subroutine uedge_plasma()

c ... Common blocks:
            use Dim       	!nisp, ngsp, nhsp ...
            use UEpar     	!isnion, isupon, ... 
	        use Math_problem_size  !neqmx
            use Time_dep_nwt  !dtreal
	        use PNC_params  	!dtplasma

c ... Local variables:
      implicit none

      integer isnionold(nispmx),isuponold(nispmx),istionold,isteonold,isphionold
      integer isngonold(ngspmx), isupgonold(ngspmx), nhspold, ngspold
      real dtrealold 

      if(pnc_verbose) then
c        write(*,*) "************************************************"
        write(*,*) "------------------------------------------------"
        write(*,*) "Solving UEDGE plasma model without neutral gas"
        write(*,*) "dtplasma=",dtplasma
      endif

c ... Save original settings
      dtrealold=dtreal
      isnionold=isnion
      isuponold=isupon
      istionold=istion
      isteonold=isteon
      isphionold=isphion
      isngonold=isngon
      isupgonold=isupgon
      nhspold=nhsp
      ngspold=ngsp

c ... Turn on fluid plasma model & turn off neutrals model
c ... The settings below correspond to the original model
c ... Now, assume the desired settings are specified by the user
c     isnion=1			 
c      isupon=1			 
c      istion=1		 
c      isteon=1			 
c      isphion=1	 
c      if (nhsp .gt. 1) then 
c        isnion(iigsp)=0
c        isupon(iigsp)=0
c      endif

c ... Solve fluid plasma model 
      dtreal=dtplasma
      call exmain

c ... Restore original settings  
      dtreal=dtrealold    
      isnion=isnionold
      isupon=isuponold
      istion=istionold
      isteon=isteonold
      isphion=isphionold
      isngon=isngonold
      isupgon=isupgonold
      nhsp=nhspold
      ngsp=ngspold

      end
c-----------------------------------------------------------------------
c***************************************************
c Subroutine to solve UEDGE fluid neutrals model
c***************************************************

      subroutine uedge_neutrals()
c ... This subroutine can be used with explicit PNC, but not with implicit JFNK

c ... Common blocks:
            use Dim       	!nisp, ngsp, ...
            use UEint         !ziin
            use UEpar     	!isnion, isupon, iigsp, ... 
	        use Math_problem_size  !neqmx
            use Time_dep_nwt   !dtreal
            use MCN_dim 
            use MCN_sources   !ismcnon
            use PNC_params  	!dtneut


c ... Local variables:
      implicit none

      integer isnionold(nispmx),isuponold(nispmx),istionold,isteonold,isphionold
      integer ismcnonold, nhspold, ngspold, ziinold(nispmx)
      integer isngonold(ngspmx), isupgonold(ngspmx)
      real dtrealold 

      if(pnc_verbose) then
c        write(*,*) "************************************************"
        write(*,*) "------------------------------------------------"
        write(*,*) "Solving UEDGE neutral gas model for ng, upg"
        write(*,*) "dtneut=", dtneut
      endif

c ... Save original settings
      dtrealold=dtreal
      isnionold=isnion
      isuponold=isupon
      istionold=istion
      isteonold=isteon
      isphionold=isphion
      ismcnonold=ismcnon

      isupgonold=isupgon
      isngonold=isngon
      ngspold=ngsp
      nhspold=nhsp
      ziinold=ziin

c ... Turn on fluid neutrals model & turn off fluid plasma model
      dtreal=dtneut
      isnion=0
      isupon=0
      istion=0
      isteon=0
      isphion=0
      isnion(iigsp)=1
      isupon(iigsp)=1
      ismcnon=0

      ngsp=1
      nhsp=2
      ziin(nhsp)=0
      isupgon(1)=1	!neutrals model with parallel flow
      isngon=0

c ... Solve fluid neutrals model 
      call exmain

c ... Restore original settings  
      dtreal=dtrealold    
      isnion=isnionold
      isupon=isuponold
      istion=istionold
      isteon=isteonold
      isphion=isphionold
      ismcnon=ismcnonold

      isupgon=isupgonold
      isngon=isngonold
      ngsp=ngspold
      nhsp=nhspold
      ziin=ziinold

      end
c-----------------------------------------------------------------------
c******************************************************
c Subroutine to convert DEGAS2 sources to UEDGE sources
c******************************************************
      subroutine convertmcnsor()
! This function converts the plasma source data in file sources.out
! from DEGAS2 to the proper form for the UEDGE plasma model.

c ... Common blocks:
            use Dim 
            use MCN_dim 
            use MCN_sources  !uesor_ni, ..., mcnsor_ni ...
            use MCN_bkgd  	!v2c,vyc,upc
            use Compla  		!upi,mi,v2,vy
            use Bfield  		!rbfbt
            use Comgeo  		!rr
            use RZ_grid_info  !br,bz,bpol
            use Selec   		!ixm1,ixp1


c ... Local Variables:
      implicit none

      integer ix,iy,ifld,istra,ix2
      real smox(0:nx+1,0:ny+1,1:nfl,1:nstra)
      real smop(0:nx+1,0:ny+1,1:nfl,1:nstra)
      real smov(0:nx+1,0:ny+1,1:nfl,1:nstra)
      real seit(0:nx+1,0:ny+1,1:nstra)
      real sinb1, cosb1
c     real sinbp(0:nx+1,0:ny+1),cosbp(0:nx+1,0:ny+1) 

c ... Allocate MCN_bkgd group
      call gchange("MCN_bkgd",0) 

c      cosb1=br(:,:,0)/bpol(:,:,0)
c      sinb1=bz(:,:,0)/bpol(:,:,0)


! compute UEDGE flow velocity at cell centers:
      do ifld=1,nisp
        do ix=1,nx
          do iy=1,ny
            !!! 3 orthogonal components of the velocity are:
            v2c(ix,iy,ifld)=(v2(ixm1(ix,iy),iy,ifld)+v2(ix,iy,ifld))/2.
	        vyc(ix,iy,ifld)=(vy(ix,iy-1,ifld)+vy(ix,iy,ifld))/2.
            upc(ix,iy,ifld)=(upi(ixm1(ix,iy),iy,ifld)+upi(ix,iy,ifld))/2.
          enddo
       enddo
      enddo
c      v2c=(v2)/2.
c      vyc(1:nx,1:ny,1:nisp)=(vy(1:nx,0:ny-1,1:nisp)+vy(1:nx,1:ny,1:nisp))/2.
c      upc=(upi)/2.

! Calculate parallel momentum source from components and interpolate
! onto UEDGE velocity mesh; convert from total ion energy source to
! ion thermal energy source:

      smox=0.;
      smop=0.;
      smov=0.;
      seit=sei;
      do istra=1,nstra
        do ifld=1,nfl
          do iy=1,ny
            do ix=1,nx
              cosb1=br(ix,iy,0)/bpol(ix,iy,0)
              sinb1=bz(ix,iy,0)/bpol(ix,iy,0)
              ix2=ixp1(ix,iy)
      	      ! poloidal component (on UEDGE density mesh) is:
      	      smox(ix,iy,ifld,istra) = smor(ix,iy,ifld,istra) * cosb1
     .                                  + smoz(ix,iy,ifld,istra) * sinb1
              ! parallel component (on UEDGE density mesh) is:
              smop(ix,iy,ifld,istra) = smox(ix,iy,ifld,istra) * rr(ix,iy)
     .                                + smophi(ix,iy,ifld,istra) * rbfbt(ix,iy)
              ! interpolate parallel component (on UEDGE velocity mesh) is:
              smov(ix,iy,ifld,istra) = 
     .                      0.5*(smop(ix,iy,ifld,istra)+smop(ix2,iy,ifld,istra))
              ! contribution to ion thermal energy
              seit(ix,iy,istra) = seit(ix,iy,istra)
     .                           -upc(ix,iy,ifld)*smop(ix,iy,ifld,istra)
     .                  +(0.5*mi(ifld)*upc(ix,iy,ifld)**2)*sni(ix,iy,ifld,istra)
            enddo
          enddo
        enddo
      enddo

!Fill in Border Data
      smov(0,:,:,:)=0.5*smop(1,:,:,:)
      smov(nx+1,:,:,:)=0.5*smop(nx,:,:,:)


! Put data in generic source arrays
      mcnsor_ni=sni
      mcnsor_up=smov 
      mcnsor_te=see
      mcnsor_ti=seit

! Set reference source strengths for each stratum:
!!! NOTE: This needs to be generalized for multi-species (nfl>1) !!!
      mcncurr = sum(sum(mcnsor_ni(:,:,1,:),dim=2),dim=1)

! Initialize plasma source terms; sum over strata:
      if (nisp==2*nfl) then
        uesor_ni(:,:,1:nfl)=sum(mcnsor_ni,dim=4)
        uesor_up(:,:,1:nfl)=sum(mcnsor_up,dim=4)
        uesor_ni(:,:,(nfl+1):2*nfl)=-uesor_ni(:,:,1:nfl)
        uesor_up(:,:,(nfl+1):2*nfl)=-uesor_up(:,:,1:nfl)
      else
        uesor_ni=sum(mcnsor_ni,dim=4)
        uesor_up=sum(mcnsor_up,dim=4)
      endif
      uesor_ti=sum(mcnsor_ti,dim=3)
      uesor_te=sum(mcnsor_te,dim=3)

      end

c----------------------------------------------------------------------c

c******************************************************
c Subroutine to convert components of DEGAS2 vector to UEDGE vector
c******************************************************
c     [Vx]            [   c  0   s   ] [Vr] 
c     [Vy] = R.V    = [  -s  0   s   ] [Vt] 
c     [Vp]            [bp*c  bt  s*bp] [Vz]
c
c     [Vr]            [  c    -s    0   ] [Vr] 
c     [Vt] = R^-1.V = [-bp/bt  0   1/bt ] [Vt] 
c     [Vz]            [  s     c    0   ] [Vz]

      subroutine convertmcnvec(mcvar,uevar,mcvar_rsd,uevar_rsd,sgn)

c ... Common blocks:
            use Dim           !nx,ny
            use MCN_dim       !nfl
            use Bfield  		!rbfbt
            use Comgeo  		!rr
            use RZ_grid_info  !br,bz,bpol

c ... Input Variables:
      implicit none

      integer, intent(in) :: sgn     ! sign of transformation: +1 for vector, -1 for transpose(vector)
      real, dimension(0:nx+1,0:ny+1,nfl,3), intent(in) :: mcvar,mcvar_rsd

c ... Output Variables:
      real, dimension(0:nx+1,0:ny+1,nfl,3), intent(out) :: uevar,uevar_rsd

c ... Local Variables:
      integer :: ifld
      real, dimension(0:nx+1,0:ny+1) :: sinb,cosb
      real, dimension(0:nx+1,0:ny+1,nfl,3) :: mcvar_sd

! Initialize
      mcvar_sd=mcvar_rsd*mcvar
      cosb=br(:,:,0)/bpol(:,:,0)
      sinb=bz(:,:,0)/bpol(:,:,0)

! Calculate field-aligned UEDGE components:
      if (sgn .ge. 0) then
        do ifld=1,nfl
          uevar(:,:,ifld,1) =   cosb*mcvar(:,:,ifld,1) +  sinb*mcvar(:,:,ifld,3)
          uevar(:,:,ifld,2) = - sinb*mcvar(:,:,ifld,1) +  cosb*mcvar(:,:,ifld,3)
          uevar(:,:,ifld,3) =     rr*uevar(:,:,ifld,1) + rbfbt*mcvar(:,:,ifld,2)

          uevar_rsd(:,:,ifld,1) = sqrt((cosb*mcvar_sd(:,:,ifld,1))**2  + (sinb*mcvar_sd(:,:,ifld,3))**2)  
          uevar_rsd(:,:,ifld,2) = sqrt((sinb*mcvar_sd(:,:,ifld,1))**2  + (cosb*mcvar_sd(:,:,ifld,3))**2)
          uevar_rsd(:,:,ifld,3) = sqrt( (rr*uevar_rsd(:,:,ifld,1))**2 + (rbfbt*mcvar_sd(:,:,ifld,2))**2 ) 
        enddo
      else
        do ifld=1,nfl
          uevar(:,:,ifld,1) =   cosb*mcvar(:,:,ifld,1) -  sinb*mcvar(:,:,ifld,2)
          uevar(:,:,ifld,3) =   sinb*mcvar(:,:,ifld,1) +  cosb*mcvar(:,:,ifld,2)
          uevar(:,:,ifld,2) =  (- rr*uevar(:,:,ifld,1) +       mcvar(:,:,ifld,3))/rbfbt

          uevar_rsd(:,:,ifld,1) = sqrt((cosb*mcvar_sd(:,:,ifld,1))**2  + (sinb*mcvar_sd(:,:,ifld,2))**2)  
          uevar_rsd(:,:,ifld,3) = sqrt((sinb*mcvar_sd(:,:,ifld,1))**2  + (cosb*mcvar_sd(:,:,ifld,2))**2)
          uevar_rsd(:,:,ifld,2) = sqrt( (rr*uevar_rsd(:,:,ifld,1))**2 + mcvar_sd(:,:,ifld,3)**2)/abs(rbfbt) 
        enddo
      endif

      where (uevar .ne. 0) uevar_rsd=uevar_rsd/abs(uevar)
      where (uevar .eq. 0) uevar_rsd=1

      end

c----------------------------------------------------------------------c

c******************************************************
c Subroutine to interpolate DEGAS2 vector to UEDGE vector
c******************************************************

      subroutine interpmcnvec(mcvar,uevar,mcvar_rsd,uevar_rsd)
! This function interpolates a vector from the centered grid to the velocity grid

c ... Common blocks:
            use Dim           !nx,ny
            use MCN_dim       !nfl
            use Comgeo  		!dx,dy
            use Selec   		!ixm1,ixp1

c ... Input Variables:
      implicit none

      real, dimension(0:nx+1,0:ny+1,nfl,3), intent(in) :: mcvar,mcvar_rsd

c ... Output Variables:
      real, dimension(0:nx+1,0:ny+1,nfl,3), intent(out) :: uevar,uevar_rsd

c ... Local Variables:
      integer ix,iy,ifld,ix2,iy2
      real dx2,dy2

! Interpolate to UEDGE velocity mesh:
      do ifld=1,nfl
        do iy=1,ny
          do ix=1,nx
            ix2=ixp1(ix,iy) 
            dx2=dx(ix,iy)+dx(ix2,iy)
            uevar(ix,iy,ifld,1) =     
     .        (mcvar(ix,iy,ifld,1)*dx(ix2,iy)+mcvar(ix2,iy,ifld,1)*dx(ix,iy))/dx2
            uevar_rsd(ix,iy,ifld,1) = 
     .        (mcvar_rsd(ix,iy,ifld,1)*dx(ix2,iy)+mcvar_rsd(ix2,iy,ifld,1)*dx(ix,iy))/dx2

            iy2 = iy+1
            dy2 = dy(ix,iy)+dy(ix,iy2)
            uevar(ix,iy,ifld,2) =
     .        (mcvar(ix,iy,ifld,2)*dy(ix,iy2) + mcvar(ix,iy2,ifld,2)*dy(ix,iy))/dy2
            uevar_rsd(ix,iy,ifld,2) =  
     .        (mcvar_rsd(ix,iy,ifld,2)*dy(ix,iy2) + mcvar_rsd(ix,iy2,ifld,2)*dy(ix,iy))/dy2
          enddo
        enddo
      enddo

      end
c----------------------------------------------------------------------c

c******************************************************************
c Subroutine to convert DEGAS2 vector to UEDGE vector on UEDGE mesh
c******************************************************************

      subroutine convertmcnvector(mcvar,uevar,mcvar_rsd,uevar_rsd)

c ... Common blocks:
            use Dim           !nx,ny
            use MCN_dim       !nfl

c ... Input Variables:
      implicit none

      real, dimension(0:nx+1,0:ny+1,nfl,3) :: mcvar,mcvar_rsd

c ... Output Variables:
      real, dimension(0:nx+1,0:ny+1,nfl,3) :: uevar,uevar_rsd

c ... Local Variables:
      real, dimension(0:nx+1,0:ny+1,nfl,3) :: uevec,uevec_rsd

c      write(*,*) "convertmcnvector: vec"
      call convertmcnvec(mcvar,uevec,mcvar_rsd,uevec_rsd,1)
c      write(*,*) "convertmcnvector: interp" 
      call  interpmcnvec(uevec,uevar,uevec_rsd,uevar_rsd)
c     write(*,*) "convertmcnvector: done"
      end

c----------------------------------------------------------------------c

c******************************************************
c Subroutine to convert DEGAS2 tensor to UEDGE tensor
c******************************************************

      subroutine convertmcntensor(mcvar,uevar,mcvar_rsd,uevar_rsd)
! This function converts the neutral data generated by outputbrowser
! from DEGAS2 to the proper form for the UEDGE plasma model.

c ... Common blocks:
            use Dim 
            use MCN_dim 

c ... Input Variables:
      implicit none

      real, dimension(0:nx+1,0:ny+1,nfl,3,3), intent(in) :: mcvar,mcvar_rsd

c ... Output Variables:
      real, dimension(0:nx+1,0:ny+1,nfl,3,3), intent(out) :: uevar,uevar_rsd

c ... Local Variables:
      integer :: idim 
      real, dimension(0:nx+1,0:ny+1,nfl,3,3) :: uevec,uevec_rsd
      real, dimension(0:nx+1,0:ny+1,nfl,3) :: vec,vec_rsd,var,var_rsd

c ... Calculate field-aligned UEDGE components:
c ...     [Vx] = R.v = [ cos, sin] [Vr]
c ...     [Vy]         [-sin, cos] [Vz]
c ...     ...   etc. 
c ...     [P]_xy = R . P_[rz] . R^T

c ... First multiply by R matrix
      do idim=1,3
        var=mcvar(:,:,:,idim,:)
        var_rsd=mcvar_rsd(:,:,:,idim,:)
        call convertmcnvec(var,vec,var_rsd,vec_rsd,1)
        uevec(:,:,:,idim,:)=vec
        uevec_rsd(:,:,:,idim,:)=vec_rsd
      end do

c ... Then multiply by Transpose(R) matrix
      do idim=1,3
        vec=uevec(:,:,:,idim,:)
        vec_rsd=uevec_rsd(:,:,:,idim,:)
        call convertmcnvec(vec,var,vec_rsd,var_rsd,-1)
        uevar(:,:,:,idim,:)=var
        uevar_rsd(:,:,:,idim,:)=var_rsd
      end do
c      write(*,*) "convertmcntensor: done"

      end

c----------------------------------------------------------------------c
      subroutine scale_mcnsor
            use Dim 	! nx,ny,nisp,nusp
            use UEpar       ! isupgon,iigsp
            use Comflo 	! fnix
            use MCN_dim 
            use MCN_sources 
            use Interp  ! nis
            use Compla  ! ni

      implicit none

      integer ix,iy,ifld,istra

      external remark
c 	  write(*,*) 'TEST SCALE_MCN START: ismcnvar=',ismcnvar

c     This subroutine scales plasma source terms obtained from the 
c     Monte-Carlo-Neutrals code.  These sources are assumed to scale
c     with the neutral source currents at the divertor plates.
c     The flag that controls the scaling is ismcnvar :
c         ismcnvar=0  -->  sources are fixed
c         ismcnvar=1  -->  sources scale with current
c
c     In the terminology of the EIRENE code, a stratum is a surface
c     or volume element where neutral particles originate.  Here
c     we consider only two possible strata: the inboard and outboard
c     divertor plates.  We neglect strata associated with gas puffing
c     or recombination.
c     
c     Plasma source terms from EIRENE are :
c         mcnsor_ni
c         mcnsor_up
c         mcnsor_te
c         mcnsor_ti
c     where mcnsor_ni(ix,iy,ifld,istra) is the particle source
c     for ion fluid 'ifld' at cell (ix,iy) due to neutral source
c     stratum 'istra'.
c
c     mcncurr(istra) is the incident ion current that
c     normalizes the plasma sources due to neutrals
c     that originate at stratum 'istra'.
c
c     The scaled plasma source terms for UEDGE are :
c         uesor_ni
c         uesor_up
c         uesor_te
c         uesor_ti
c     where uesor_ni is obtained by summing the scaled mcnsor_ni
c     over all strata, and similarly for up,te,ti.

ccc=================================================================
ccc     NOTE: For the cmod-box problem there is only ONE strata !!!
ccc     (in general, we need to devise a test to identify strata)
ccc=================================================================

      if (ismcnvar==0) return ! Already set by convertmcnsor
c=====else

c     Compute scale factors for each strata :
      strascal=1.	! default is no scaling
      uesor_ni=0.
      uesor_up=0.
      uesor_ti=0.
      uesor_te=0.

      if (ismcnvar==1) then	! sources scale with current
c		 call remark("ismcnvar=1")
c         write(*,*) 'ismcnvar=1' 
         do istra=1,nstra
            uecurr(istra)=0.
            if (istra==1) then	! for east target plate only
               do iy=1,ny
                  uecurr(istra)=uecurr(istra)+fnix(nx,iy,1)
               enddo
c            else
c               call remark("***")
c               call remark("***    subroutine scale_mcn    ***")
c               call remark("***  not defined for nstra > 1  ***")
c               call remark("***")
            endif
            if(mcncurr(istra) > 0) then
               strascal(istra)=uecurr(istra)/mcncurr(istra)
            endif
         enddo
c       Scale source terms and sum over strata :
        do istra=1,nstra
           do iy=0,ny+1
              do ix=0,nx+1
                 do ifld=1,nisp
                    uesor_ni(ix,iy,ifld)=uesor_ni(ix,iy,ifld)
     &                    +mcnsor_ni(ix,iy,ifld,istra)*strascal(istra)
                 enddo
                 do ifld=1,nusp
                    uesor_up(ix,iy,ifld)=uesor_up(ix,iy,ifld)
     &                    +mcnsor_up(ix,iy,ifld,istra)*strascal(istra)
                 enddo
                 uesor_te(ix,iy)=uesor_te(ix,iy)
     &                    +mcnsor_te(ix,iy,istra)*strascal(istra)
                 uesor_ti(ix,iy)=uesor_ti(ix,iy)
     &                    +mcnsor_ti(ix,iy,istra)*strascal(istra)
              enddo
           enddo
        enddo
      else if (ismcnvar==2) then	! sources scale with electron density
c	     call remark("ismcnvar=2")
c         write(*,*) 'ismcnvar=2' 
         ! Scale all sources to electron (ion) density 
         do istra=1,nstra
            do iy=0,ny+1
               do ix=0,nx+1
                  do ifld=1,nisp
                     uesor_ni(ix,iy,ifld)=uesor_ni(ix,iy,ifld)
     &                    +mcnsor_ni(ix,iy,ifld,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
                  enddo
                  do ifld=1,nusp
                     uesor_up(ix,iy,ifld)=uesor_up(ix,iy,ifld)
     &                    +mcnsor_up(ix,iy,ifld,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
                  enddo
                  uesor_te(ix,iy)=uesor_te(ix,iy)
     &                    +mcnsor_te(ix,iy,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
                  uesor_ti(ix,iy)=uesor_ti(ix,iy)
     &                    +mcnsor_ti(ix,iy,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
               enddo
            enddo
         enddo
      else if (ismcnvar==3) then	! sources scale with old UEDGE current
c        call remark("ismcnvar=3")
c        write(*,*) 'ismcnvar=3' 
         do istra=1,nstra
            uecurr(istra)=0.
            if (istra==1) then	! for east target plate only
               do iy=1,ny
                  uecurr(istra)=uecurr(istra)+fnix(nx,iy,1)
               enddo
c            else
c               call remark("***")
c               call remark("***    subroutine scale_mcn    ***")
c               call remark("***  not defined for nstra > 1  ***")
c               call remark("***")
            endif
            if(mcncurr(istra) > 0) then
               strascal(istra)=uecurr(istra)/olduecurr(istra)
            endif
         enddo
c       Scale source terms and sum over strata :
        do istra=1,nstra
           do iy=0,ny+1
              do ix=0,nx+1
                 do ifld=1,nisp
                    uesor_ni(ix,iy,ifld)=uesor_ni(ix,iy,ifld)
     &                    +mcnsor_ni(ix,iy,ifld,istra)*strascal(istra)
                 enddo
                 do ifld=1,nusp
                    uesor_up(ix,iy,ifld)=uesor_up(ix,iy,ifld)
     &                    +mcnsor_up(ix,iy,ifld,istra)*strascal(istra)
                 enddo
                 uesor_te(ix,iy)=uesor_te(ix,iy)
     &                    +mcnsor_te(ix,iy,istra)*strascal(istra)
                 uesor_ti(ix,iy)=uesor_ti(ix,iy)
     &                    +mcnsor_ti(ix,iy,istra)*strascal(istra)
              enddo
           enddo
        enddo
      else if (ismcnvar==4) then	
         ! Sources scale with electron density and target plate current (neutral density)
         ! This is a combination of ismcnvar = 2 and 3
c	     call remark("ismcnvar=4")
c         write(*,*) 'ismcnvar=4' 
         ! Scale all sources electron (ion) density 
         do iy=0,ny+1
            do ix=0,nx+1
               do ifld=1,nisp
                  uesor_ni(ix,iy,ifld)=0.
               enddo
               do ifld=1,nusp
                  uesor_up(ix,iy,ifld)=0.
               enddo
               uesor_te(ix,iy)=0.
               uesor_ti(ix,iy)=0.
            enddo
         enddo
         do istra=1,nstra
            do iy=0,ny+1
               do ix=0,nx+1
                  do ifld=1,nisp
                     uesor_ni(ix,iy,ifld)=uesor_ni(ix,iy,ifld)
     &                    +mcnsor_ni(ix,iy,ifld,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
                  enddo
                  do ifld=1,nusp
                     uesor_up(ix,iy,ifld)=uesor_up(ix,iy,ifld)
     &                    +mcnsor_up(ix,iy,ifld,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
                  enddo
                  uesor_te(ix,iy)=uesor_te(ix,iy)
     &                    +mcnsor_te(ix,iy,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
                  uesor_ti(ix,iy)=uesor_ti(ix,iy)
     &                    +mcnsor_ti(ix,iy,istra)*ni(ix,iy,ifld)/nis(ix,iy,ifld)
               enddo
            enddo
         enddo
      ! Scale sources linearly with old UEDGE current to target plate 
      ! This option corresponds to ismcnvar=3
         do istra=1,nstra
            uecurr(istra)=0.
            if (istra==1) then	! for east target plate only
               do iy=1,ny
                  uecurr(istra)=uecurr(istra)+fnix(nx,iy,1)
               enddo
c            else
c               call remark("***")
c               call remark("***    subroutine scale_mcn    ***")
c               call remark("***  not defined for nstra > 1  ***")
c               call remark("***")
            endif
            if(mcncurr(istra) > 0) then
               strascal(istra)=uecurr(istra)/olduecurr(istra)
            endif
         enddo
c       Scale source terms and sum over strata :
        do istra=1,nstra
           do iy=0,ny+1
              do ix=0,nx+1
                 do ifld=1,nisp
                    uesor_ni(ix,iy,ifld)=uesor_ni(ix,iy,ifld)
     &                    +mcnsor_ni(ix,iy,ifld,istra)*strascal(istra)
                 enddo
                 do ifld=1,nusp
                    uesor_up(ix,iy,ifld)=uesor_up(ix,iy,ifld)
     &                    +mcnsor_up(ix,iy,ifld,istra)*strascal(istra)
                 enddo
                 uesor_te(ix,iy)=uesor_te(ix,iy)
     &                    +mcnsor_te(ix,iy,istra)*strascal(istra)
                 uesor_ti(ix,iy)=uesor_ti(ix,iy)
     &                    +mcnsor_ti(ix,iy,istra)*strascal(istra)
              enddo
           enddo
        enddo
      endif


      return
      end

c-----------------------------------------------------------------------

c***************************************************
c Subroutine to run coupled plasma + neutrals models
c***************************************************
      subroutine run_pnc()

c ... Common blocks:
            use Dim   		! needed for PNC
            use Ext_neutrals  ! extneutopt
            use MCN_dim   	! needed for PNC
            use PNC_params 	! pnc_opt

      implicit none

      if (extneutopt .eq. 1) then      		!EIRENE
c        call uedge_eirene
      else if (extneutopt .eq. 2) then 		!DEGAS2
        call uedge_degas2
      else 							 		!UEDGE neutral fluid
        call uedge_uedge
      endif

      end

c-----------------------------------------------------------------------

c********************************************************
c Subroutine to run coupled uedge plasma + uedge neutrals
c********************************************************
      subroutine uedge_uedge()

c ... Common blocks:
            use Dim  			! nx, ny, nisp
            use Compla  		! ni, up, ...
            use Ext_neutrals 	! extneutopt
            use PNC_params 	! pnc_step
            use Math_problem_size 
            use MCN_dim 		! needed for PNC_data
            use PNC_data 		! ni_pnc, ... sni_pnc, ...
            use Time_dep_nwt  ! dtreal

c ... External functions:
      implicit none

      integer pnc_save_pdb

c ... Local variables:
      character*8 stepstr
      character*256 pnc_save_name

      write(*,*) '*************************************'
      write(*,*) 'UEDGE plasma + UEDGE neutral coupling'

c ... Allocate PNC_data group
      call gchange("PNC_data",0) 

      do pnc_step=pnc_step+1,pnc_maxstep
        pnc_time = pnc_time + dtplasma
        write(*,*) '*************************************'
        write(*,*) 'Step: ',pnc_step
        write(*,*) 'Time: ',pnc_time

        !Neutral Step      Use(PNC_params)	!dtneut
		call store_neutrals
        if (extneutopt .ge. 0) then
          dtreal=dtneut
          call uedge_neutrals
        else
          call run_uedge
        endif
		call update_neutrals

        !Plasma Step
        dtreal=dtplasma
        call store_plasma	
        call uedge_plasma	
c        call exmain  			!should use exmain to be consistent with other pnc routines
        call update_plasma

        call pnc_diagnostics    

        !Save PNC data
        if(mod(pnc_step,pnc_nsave)==0) then
          write(stepstr,'(i0)') pnc_step
          pnc_save_name=trim(pnc_savefile)//trim(stepstr)//'.pdb'
          if(.not.(pnc_save_pdb(pnc_save_name)==0)) 
     .      write(*,*) 'uedge_uedge: error writing '//pnc_save_name
        endif
      enddo
      pnc_step=pnc_step-1  !return value to pnc_maxstep

      end

c-----------------------------------------------------------------------

c*********************************************************************
c Subroutine to run coupled uedge plasma + degas2 monte carlo neutrals
c*********************************************************************
      subroutine uedge_degas2()

c ... Common blocks:
            use Dim  			! nx, ny, nisp
            use Compla  		! ni, up, ...
            use Math_problem_size 
            use MCN_dim   	! needed for PNC
            use PNC_params 	! pnc_step, dtneut, dtplasma
            use Time_dep_nwt  ! dtreal

c ... External functions:
      implicit none

      integer pnc_save_pdb

c ... Local variables:
      character*256 pnc_save_name
      character*8 stepstr
    

c      write(*,*) '**************************************'
c        write(*,*) "************************************************"
      
      write(*,*) "------------------------------------------------"
      write(*,*) 'UEDGE plasma + DEGAS2 neutral coupling'

c ... Allocate PNC_data group
      call gchange("PNC_data",0) 

      do pnc_step=pnc_step+1,pnc_maxstep
        pnc_time = pnc_time + dtplasma
        write(*,*) '**************************************'
        write(*,*) 'Step: ',pnc_step
        write(*,*) 'Time: ',pnc_time

        !Neutral step
        dtreal=dtneut
		call store_neutrals
        call run_neutrals
		call update_neutrals

        !Plasma step
		dtreal=dtplasma
        call store_plasma
c        write(*,*) "Solving UEDGE plasma model without neutral gas"
c        write(*,*) "dtreal=",dtplasma	
c        call exmain  			!not uedge_plasma to be consistent with other pnc routines
        call uedge_plasma
        call update_plasma
        call pnc_diagnostics    

        !Save PNC data
        if(mod(pnc_step,pnc_nsave)==0) then
          write(stepstr,'(i0)') pnc_step
          pnc_save_name=trim(pnc_savefile)//trim(stepstr)//'.pdb'
          if(.not.(pnc_save_pdb(pnc_save_name)==0)) 
     .      write(*,*) 'uedge_degas2: error writing '//pnc_save_name
        endif

      enddo
      pnc_step=pnc_step-1 !return value to pnc_maxstep

      end

c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to get fnrm
c*******************************************************************
      real function get_fnrm(dtreal_try)

c ... Common blocks:
            use Dim 			  ! neq 
            use Math_problem_size  ! neqmx
            use Lsode     	  ! yl, yldot
            use Time_dep_nwt    ! dtreal
            use Ynorm 		  ! sfscal

c ... Local variables:
      implicit none

      real dtreal_try, dtreal_save

      dtreal_save=dtreal
      dtreal=dtreal_try
      dtuse=dtreal_try
c      call convert() !convert ni,up, ti... to yl
      call pandf1(-1, -1, 0, neq, 1., yl, yldot)
      get_fnrm=sqrt(sum((yldot(1:neq)*sfscal(1:neq))**2))
      dtreal=dtreal_save
      
      end function get_fnrm

c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to get fnrm from pandf (infinite time step)
c   WARNING! there is often a rescaling b/w pandf and pandf1 results
c*******************************************************************
      real function get_fnrm_pandf()

c ... Common blocks:
            use Dim 			  ! neq 
            use Math_problem_size  ! neqmx
            use Lsode     	  ! yl, yldot
            use Time_dep_nwt    ! dtreal
            use Ynorm 		  ! sfscal

c ... Local variables:
      implicit none

      real dtreal_save

      dtreal_save=dtreal
      dtreal=1.0d20
c      call convert() !convert ni,up, ti... to yl
      call pandf(-1, -1, neq, 1., yl, yldot)
      get_fnrm_pandf=sqrt(sum((yldot(1:neq)*sfscal(1:neq))**2))
      dtreal=dtreal_save
      
      end function get_fnrm_pandf


c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to save neutrals during coupled plasma + neutrals run
c*******************************************************************
      subroutine pnc_diagnostics()

c ... Common blocks:
            use Dim  		! nx, ny, nisp
            use Ext_neutrals  !extneutopt
            use MCN_dim   ! needed for PNC
            use PNC_params  ! pnc_step, ...
            use PNC_data  ! ni_pnc, ..., sni_pnc
            use Phyvar    ! ev


c ... Local variables:
      implicit none

      integer ioerr
      real fnrm_new
      character*128 cmd
      logical :: isechocmdon =.false.  !uses "echo cmd" for debugging purposes

c ... External functions:
      real get_fnrm,get_fnrm_pandf 
c     basis subroutine dobalance must be predefined within basis parser

      fnrm_new=get_fnrm(1.0d20)

      if (pnc_step == 1) then	! Write header information into file
        open(unit=pnc_fp,file=trim(pnc_histfile),action="write", 
     .        status="replace",iostat=ioerr)
        if(ioerr .ne. 0) then 
          write(*,*) "Trouble opening ",trim(pnc_histfile)," iostat =",ioerr
        endif
        write(pnc_fp,*) "***************************************"
        write(pnc_fp,*) "TIME HISTORY OF RESIDUALS AND SUMMARIES"
        write(pnc_fp,*) "***************************************"
        write(pnc_fp,*) "relax_p  = ", relax_p
        write(pnc_fp,*) "relax_g  = ", relax_g
      endif

      open(unit=pnc_fp,file=trim(pnc_histfile),action="write",status="old",  
     .      position="append",iostat=ioerr)
      if(ioerr .ne. 0) then 
        write(*,*) "Trouble writing ",trim(pnc_histfile)," iostat =",ioerr
      endif

      write(pnc_fp,*) "***************************************"
      write(pnc_fp,*) 'step = ', pnc_step
      write(pnc_fp,*) 'time = ', pnc_time
      write(pnc_fp,*) "***************************************"
      write(pnc_fp,*) 'fnrm      = ', fnrm_new
      write(pnc_fp,*) 'res_ni    = ', res_ni
      write(pnc_fp,*) 'res_up    = ', res_up
      write(pnc_fp,*) 'res_ti    = ', res_ti
      write(pnc_fp,*) 'res_te    = ', res_te
      write(pnc_fp,*) 'res_phi   = ', res_phi

      if (extneutopt==0) then 
        write(pnc_fp,*) 'res_ng    = ', res_ng
        write(pnc_fp,*) 'res_upg   = ', res_upg
      else
        if (get_neutral_sources) then
          write(pnc_fp,*) 'res_sni   = ', res_sni
          write(pnc_fp,*) 'res_smor  = ', res_smor
          write(pnc_fp,*) 'res_smophi= ', res_smophi
          write(pnc_fp,*) 'res_smoz  = ', res_smoz
          write(pnc_fp,*) 'res_sei   = ', res_sei
          write(pnc_fp,*) 'res_see   = ', res_see
        endif
        if (get_neutral_moments) then
          write(pnc_fp,*) 'res_ng   = ', res_ng
          write(pnc_fp,*) 'res_tg   = ', res_tg
          write(pnc_fp,*) 'res_sng   = ', res_sng
          write(pnc_fp,*) 'res_seg   = ', res_seg
        endif
      endif

      close(unit=pnc_fp,iostat=ioerr)
      if(ioerr .ne. 0) then 
        write(*,*) "Trouble closing ",trim(pnc_histfile)," iostat =",ioerr
      endif

      if(pnc_dobalance) then
c       call parsestr('rundiagnostics()')
        call parsestr('dobalance(pnc_balancefile)')
c        call sleep(0.005)  !Need time lag before touching files
c       cmd="touch "//trim(pnc_histfile)
c       call system(trim(cmd))        
        cmd='cat '//trim(pnc_balancefile)//' >> '//trim(pnc_histfile)        
        if (isechocmdon) cmd="echo "//trim(cmd)
        if (ext_verbose) print *,trim(cmd)
        call system(trim(cmd)) 
      endif

      end

c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to save neutrals during coupled plasma + neutrals run
c*******************************************************************
      subroutine store_neutrals()

c ... Common blocks:
            use Dim  			! nx, ny, nisp
            use Ext_neutrals  ! extneutopt, get_neutral_moments
            use Interp 		! nis, ups
            use MCN_dim 
            use MCN_sources  	! sni, ..., see, ng_mc,... tg_mc
            use PNC_params 	! pnc_step
            use PNC_data 		! sni_pnc, ...

      implicit none

      if (extneutopt==0) then 
        ni_pnc=nis
        up_pnc=ups
      else 
        if (get_neutral_sources) then
          sni_pnc   =sni
          smor_pnc  =smor
          smophi_pnc=smophi
          smoz_pnc  =smoz
          sei_pnc   =sei
          see_pnc   =see
        endif
        if (get_neutral_moments) then 
          ng_pnc  = ng_ue
          upg_pnc = upg_ue
          tg_pnc  = tg_ue
        endif
      endif

      end

c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to update neutrals during coupled plasma + neutrals run
c*******************************************************************
      subroutine update_neutrals()

c ... Common blocks:
            use Dim  			! nx, ny, nisp
            use Compla 		! ni, up
            use Interp 		! nis, ups
            use Ext_neutrals  ! extneutopt
            use MCN_dim 
            use MCN_sources  	! sni, ..., see
            use PNC_params 	! pnc_step, ...
            use PNC_data      ! sni_pnc, ...
            use Phyvar    	! ev
            use UEpar 		! iigsp

c ... Local Variables
      implicit none

      integer ifld

      if(extneutopt==0) then 
        ni(:,:,iigsp)=relax_p*ni(:,:,iigsp)+(1-relax_p)*ni_pnc(:,:,iigsp)
        up(:,:,iigsp)=relax_p*up(:,:,iigsp)+(1-relax_p)*up_pnc(:,:,iigsp)

        nis(:,:,iigsp)=ni(:,:,iigsp)
        ups(:,:,iigsp)=up(:,:,iigsp)

        res_ng    = sqrt(sum((ni(:,:,iigsp)-ni_pnc(:,:,iigsp))**2/real(nx*ny)))
        res_upg   = sqrt(sum((up(:,:,iigsp)-up_pnc(:,:,iigsp))**2/real(nx*ny)))
        
        del_ng    = maxval(abs(ni(:,:,iigsp)-ni_pnc(:,:,iigsp)))
        del_upg   = maxval(abs(up(:,:,iigsp)-up_pnc(:,:,iigsp)))

        if (pnc_print_norm==1) then !normalize to maximum value
          res_ng     = res_ng/maxval(abs(ni(:,:,iigsp)))
          res_upg     = res_upg/maxval(abs(up(:,:,iigsp)))

          del_ng     = del_ng/maxval(abs(ni(:,:,iigsp)))
          del_upg     = del_upg/maxval(abs(up(:,:,iigsp)))
        else if (pnc_print_norm==2) then !normalize to previous maximum value
          res_ng     = res_ng/maxval(abs(ni_pnc))
          res_upg     = res_upg/maxval(abs(up_pnc))

          del_ng     = del_ng/maxval(abs(ni_pnc))
          del_upg     = del_upg/maxval(abs(up_pnc))
        end if
        if(pnc_verbose) then
          write(*,*) 'Variable           Max Res                        Std Dev Res'
          write(*,*) 'ng        ', del_ng,  res_ng
          write(*,*) 'upg       ', del_upg, res_upg
        endif
      endif
      if (get_neutral_sources) then
        sni   =relax_g*sni   +(1-relax_g)*sni_pnc
        smor  =relax_g*smor  +(1-relax_g)*smor_pnc
        smophi=relax_g*smophi+(1-relax_g)*smophi_pnc
        smoz  =relax_g*smoz  +(1-relax_g)*smoz_pnc
        sei   =relax_g*sei   +(1-relax_g)*sei_pnc
        see   =relax_g*see   +(1-relax_g)*see_pnc

        res_sni    = sqrt(sum((sni-sni_pnc)**2)/real(nx*ny*nfl*nstra))
        res_smor   = sqrt(sum((smor-smor_pnc)**2)/real(nx*ny*nfl*nstra))
        res_smophi = sqrt(sum((smophi-smophi_pnc)**2)/real(nx*ny*nfl*nstra))
        res_smoz   = sqrt(sum((smoz-smoz_pnc)**2)/real(nx*ny*nfl*nstra))
        res_sei    = sqrt(sum((sei-sei_pnc)**2)/real(nx*ny*nstra))
        res_see    = sqrt(sum((see-see_pnc)**2)/real(nx*ny*nstra))

        del_sni    = maxval(abs(sni-sni_pnc))
        del_smor   = maxval(abs(smor-smor_pnc))
        del_smophi = maxval(abs(smophi-smophi_pnc))
        del_smoz   = maxval(abs(smoz-smoz_pnc))
        del_sei    = maxval(abs(sei-sei_pnc))
        del_see    = maxval(abs(see-see_pnc))

        if (pnc_print_norm==1 .or. (pnc_step<=1 .and. pnc_print_norm==2) ) then
          res_sni    = res_sni/maxval(abs(sni))
          res_smor   = res_smor/maxval(abs(smor))
          res_smophi = res_smophi/maxval(abs(smophi))
          res_smoz   = res_smoz/maxval(abs(smoz))
          res_sei    = res_sei/maxval(abs(sei))
          res_see    = res_see/maxval(abs(see))

          del_sni    = del_sni/maxval(abs(sni))
          del_smor   = del_smor/maxval(abs(smor))
          del_smophi = del_smophi/maxval(abs(smophi))
          del_smoz   = del_smoz/maxval(abs(smoz))
          del_sei    = del_sei/maxval(abs(sei))
          del_see    = del_see/maxval(abs(see))
        else if (pnc_print_norm==2) then !normalize to previous maximum value
          res_sni    = res_sni/maxval(abs(sni_pnc))
          res_smor   = res_smor/maxval(abs(smor_pnc))
          res_smophi = res_smophi/maxval(abs(smophi_pnc))
          res_smoz   = res_smoz/maxval(abs(smoz_pnc))
          res_sei    = res_sei/maxval(abs(sei_pnc))
          res_see    = res_see/maxval(abs(see_pnc))

          del_sni    = del_sni/maxval(abs(sni_pnc))
          del_smor   = del_smor/maxval(abs(smor_pnc))
          del_smophi = del_smophi/maxval(abs(smophi_pnc))
          del_smoz   = del_smoz/maxval(abs(smoz_pnc))
          del_sei    = del_sei/maxval(abs(sei_pnc))
          del_see    = del_see/maxval(abs(see_pnc))
        end if

         if (pnc_verbose .and. pnc_step .gt. 1) then
          write(*,*) 'Variable           Max Res                         Std Dev Res'
          write(*,*) 'sni     ', del_sni,    res_sni
          write(*,*) 'smor    ', del_smor,   res_smor
          write(*,*) 'smophi  ', del_smophi, res_smophi
          write(*,*) 'smoz    ', del_smoz,   res_smoz
          write(*,*) 'sei     ', del_sei,    res_sei
          write(*,*) 'see     ', del_see,    res_see
        endif
      endif
      if (get_neutral_moments) then
        if(pnc_ngs_mc) then
          ngs = relax_g*ng_ue + (1-relax_g)*ng_pnc
        endif
        if(pnc_upgs_mc) then
            ups(:,:,iigsp) = relax_g*upg_ue(:,:,1) + (1-relax_g)*upg_pnc(:,:,1)
        endif
        if(pnc_tgs_mc) then
c         tgs = relax_g*tg_ue(:,:,1) + (1-relax_g)*tg_pnc(:,:,1)
        endif

        res_ng = sqrt(sum((ng_ue-ng_pnc)**2)/real(nx*ny*nfl*nstra))
        res_tg = sqrt(sum((tg_ue-tg_pnc)**2)/real(nx*ny*nfl*nstra))

        del_ng = maxval(abs(ng_ue-ng_pnc))
        del_tg = maxval(abs(tg_ue-tg_pnc))

        if (pnc_print_norm==1 .or. (pnc_step<=1 .and. pnc_print_norm==2) ) then       
          res_ng = res_ng/maxval(abs(ng_ue))
          res_tg = res_tg/maxval(abs(tg_ue))
          del_ng = del_ng/maxval(abs(ng_ue))
          del_tg = del_tg/maxval(abs(tg_ue))

        else if (pnc_print_norm==2) then !normalize to previous maximum value
          res_ng = res_ng/maxval(abs(ng_pnc))
          res_tg = res_tg/maxval(abs(tg_pnc))
          del_ng = del_ng/maxval(abs(ng_pnc))
          del_tg = del_tg/maxval(abs(tg_pnc))

        endif

         if (pnc_verbose .and. pnc_step .gt. 1) then
          if (.not. get_neutral_sources) then 
            write(*,*) 'Variable           Max Res                         Std Dev Res'
          endif
          write(*,*) 'ng     ', del_ng, res_ng
          write(*,*) 'tg     ', del_tg, res_tg
        endif
      endif
      if(pnc_verbose) then 
c        write(*,*) "************************************************"
        write(*,*) "------------------------------------------------"
      endif
      end

c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to store plasma data during coupled plasma + neutrals run
c*******************************************************************
      subroutine store_plasma()

c ... Common blocks:
            use Dim  		! nx, ny, nisp
            use Compla  	! ni, up, ...
            use Ext_neutrals 		! get_neutral_moments
            use MCN_dim   ! needed for PNC_data
            use MCN_sources   ! sng_ue, ...
            use PNC_params  ! pnc_step, ...
            use PNC_data  ! ni_pnc, ...

      implicit none

      ni_pnc=ni
      up_pnc=up
      ti_pnc=ti
      te_pnc=te
      phi_pnc=phi

c ... Store neutral sources calculated by pandf
      if (get_neutral_moments) then 
 	      sng_pnc = sng_ue
		  seg_pnc = seg_ue
      endif

      end

c-----------------------------------------------------------------------

c*******************************************************************
c Subroutine to update plasma during coupled plasma + neutrals run
c*******************************************************************
      subroutine update_plasma()

c ... Common blocks:
            use Dim  		! nx, ny, nisp
            use Compla  	! ni, up, ...
            use Ext_neutrals 		! get_neutral_moments
            use Interp  	! nis, ups, ...
            use MCN_dim   ! needed for PNC
            use MCN_sources   ! needed for PNC
            use PNC_params  ! pnc_step, ...
            use PNC_data  ! ni_pnc, ..., sni_pnc
            use Phyvar    ! ev

      !Perform update
      implicit none

      ni =relax_p*ni +(1-relax_p)*ni_pnc
      up =relax_p*up +(1-relax_p)*up_pnc
      ti =relax_p*ti +(1-relax_p)*ti_pnc
      te =relax_p*te +(1-relax_p)*te_pnc
      phi=relax_p*phi+(1-relax_p)*phi_pnc

      nis  = ni
      ups  = up 
      tis  = ti
      tes  = te
      phis = phi

      !Compute residuals
      res_ni   = sqrt(sum((ni-ni_pnc)**2)/real(nx*ny*nisp))
      res_up   = sqrt(sum((up-up_pnc)**2)/real(nx*ny*nisp))
      res_ti   = sqrt(sum((ti-ti_pnc)**2)/real(nx*ny))
      res_te   = sqrt(sum((te-te_pnc)**2)/real(nx*ny))
      res_phi  = sqrt(sum((phi-phi_pnc)**2)/real(nx*ny))
       
      del_ni   = maxval(abs(ni-ni_pnc))
      del_up   = maxval(abs(up-up_pnc))
      del_ti   = maxval(abs(ti-ti_pnc))
      del_te   = maxval(abs(te-te_pnc))
      del_phi  = maxval(abs(phi-phi_pnc))

c ... Calculate residuals for neutral sources calculated by pandf
      if (get_neutral_moments) then 
        res_sng = sqrt(sum((sng_ue-sng_pnc)**2)/real(nx*ny*nfl*nstra))
        res_seg = sqrt(sum((seg_ue-seg_pnc)**2)/real(nx*ny*nfl*nstra))
        del_sng = maxval(abs(sng_ue-sng_pnc))
        del_seg = maxval(abs(seg_ue-seg_pnc))

c       For debugging calculation
c		res_sng = maxval(abs(sng_ue))
c		res_seg = maxval(abs(seg_ue))
c		del_sng = maxval(abs(fngx_ue))
c	    del_seg = maxval(abs(fegx_ue))
      endif

      if (pnc_print_norm==1 .or. (pnc_step<=1 .and. pnc_print_norm==2)) then !normalize to maximum value
        res_ni     = res_ni/maxval(abs(ni))
        res_up     = res_up/maxval(abs(up))
        res_ti     = res_ti/maxval(abs(ti))
        res_te     = res_te/maxval(abs(te))
        res_phi    = res_phi/maxval(abs(phi))

        del_ni     = del_ni/maxval(abs(ni))
        del_up     = del_up/maxval(abs(up))
        del_ti     = del_ti/maxval(abs(ti))
        del_te     = del_te/maxval(abs(te))
        del_phi    = del_phi/maxval(abs(phi))

        if (get_neutral_moments) then
         res_sng = res_sng/maxval(abs(sng_ue))
         res_seg = res_seg/maxval(abs(seg_ue))
         del_sng = del_sng/maxval(abs(sng_ue))
         del_seg = del_seg/maxval(abs(seg_ue))
        endif  
      else if (pnc_print_norm==2) then !normalize to previous maximum value
        res_ni     = res_ni/maxval(abs(ni_pnc))
        res_up     = res_up/maxval(abs(up_pnc))
        res_ti     = res_ti/maxval(abs(ti_pnc))
        res_te     = res_te/maxval(abs(te_pnc))
        res_phi    = res_phi/maxval(abs(phi_pnc))

        del_ni     = del_ni/maxval(abs(ni_pnc))
        del_up     = del_up/maxval(abs(up_pnc))
        del_ti     = del_ti/maxval(abs(ti_pnc))
        del_te     = del_te/maxval(abs(te_pnc))
        del_phi    = del_phi/maxval(abs(phi_pnc))

        if (get_neutral_moments) then
          res_sng = res_sng/maxval(abs(sng_pnc))
          res_seg = res_seg/maxval(abs(seg_pnc))
          del_sng = del_sng/maxval(abs(sng_pnc))
          del_seg = del_seg/maxval(abs(seg_pnc))
        endif  
      end if
      if(pnc_verbose) then
        write(*,*) 'Variable           Max Res                         Std Dev Res'
          if (get_neutral_moments) then
            write(*,*) 'sng     ', del_sng, res_sng
            write(*,*) 'seg     ', del_seg, res_seg
          endif  

        write(*,*) 'ni      ', del_ni,  res_ni
        write(*,*) 'up      ', del_up,  res_up
        write(*,*) 'ti      ', del_ti,  res_ti
        write(*,*) 'te      ', del_te,  res_te
        write(*,*) 'phi     ', del_phi, res_phi
      endif
c      write(*,*) '************************************************'
       write(*,*) '------------------------------------------------'
      end

c-----------------------------------------------------------------------

c******************************************************
c Function for saving UEDGE data to PDB file
c******************************************************
      integer function uedge_save_pdb(filename)

c ... Common blocks:
            use Dim 
            use Interp  		!nis
            use PNC_params  	!pnc_savefile

c ... Local variables:
      implicit none

      character*256 filename,varstr
      character*8 nxstr,nystr,nispstr,ngspstr
      integer fileid, flen

c ... External functions: 
      integer pfopen, pfwrta, pfclos, pfgerr ! PDB API

      flen=len(trim(filename))
      fileid = pfopen(flen, trim(filename), 'w')
      if (fileid .eq. 0)
     .  write(*,*) pfgerr
cc     .   write(*,*) 'PDB error opening ', filename !call errproc
c     write(*,*) 'PDB open ',trim(filename)

      write(nxstr,'(i0)') nx+1
      write(nystr,'(i0)') ny+1
      write(nispstr,'(i0)') nisp
      write(ngspstr,'(i0)') ngsp

      varstr='ngs(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(ngspstr)//')'
c      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', ngs) == 0)
     .  write(*,*) 'PDB error writing ngs', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='nis(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nispstr)//')'
c      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', nis) == 0)
     .  write(*,*) 'PDB error writing nis', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='ups(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nispstr)//')'
c      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', ups) == 0)
     .  write(*,*) 'PDB error writing ups', pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='tis(0:'//trim(nxstr)//',0:'//trim(nystr)//')'
c      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', tis) == 0)
     .  write(*,*) 'PDB error writing tis', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='tes(0:'//trim(nxstr)//',0:'//trim(nystr)//')'
c      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', tes) == 0)
     .  write(*,*) 'PDB error writing tes', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='phis(0:'//trim(nxstr)//',0:'//trim(nystr)//')'
c      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', phis) == 0)
     .  write(*,*) 'PDB error writing phis', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      if (pfclos(fileid)==0) write(*,*) 'Error closing file', pfgerr
c     .   write(*,*) 'PDB error closing ', filename !call errproc
cc      write(*,*) 'PDB close ',trim(filename)

      uedge_save_pdb=fileid
      end function uedge_save_pdb

c-----------------------------------------------------------------------

c******************************************************
c Function for saving UEDGE variables to default PDB filename
c******************************************************
      integer function uedge_save()

c ... Common blocks:
            use Dim  		! for Interp
            use Interp  	! uedge_savefile

c ... External functions:
      implicit none

      integer uedge_save_pdb
     
      uedge_save=uedge_save_pdb(trim(uedge_savefile))

      end function uedge_save

c-----------------------------------------------------------------------

c******************************************************
c Function for reading UEDGE data from PDB file
c WARNING: Not working yet!!!
c******************************************************
      integer function uedge_read_pdb(filename)

c ... Common blocks:
            use Dim 
            use Interp  		!nis
            use PNC_params  	!pnc_savefile

c ... Local variables:
      implicit none

      character*256 filename,varstr
      character*8 nxstr,nystr,nispstr,ngspstr
      integer fileid, flen

c ... External functions: 
      integer pfopen, pfread, pfclos, pfgerr ! PDB API

      flen=len(trim(filename))
      fileid = pfopen(flen, trim(filename), 'r')
      if (fileid .eq. 0)
     .  write(*,*) 'PDB error opening file', pfgerr
cc     .   write(*,*) 'PDB error opening ', filename !call errproc
cc      write(*,*) 'PDB open ',trim(filename)

      varstr='ngs(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(ngspstr)//')'
c     write(*,*) trim(varstr), len(trim(varstr))
      if (pfread(fileid, len(trim(varstr)), trim(varstr), ngs)==0)
     .  write(*,*) 'PDB error reading ngs', pfgerr
cc     .   write(*,*) 'PDB error reading ', filename !call errproc

      write(nxstr,'(i0)') nx+1
      write(nystr,'(i0)') ny+1
      write(nispstr,'(i0)') nisp
      write(ngspstr,'(i0)') ngsp

      varstr='nis(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nispstr)//')'
c     write(*,*) trim(varstr), len(trim(varstr))
      if (pfread(fileid, len(trim(varstr)), trim(varstr), nis)==0)
     .  write(*,*) 'PDB error reading nis', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='ups(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nispstr)//')'
c     write(*,*) trim(varstr), len(trim(varstr))
      if (pfread(fileid, len(trim(varstr)), trim(varstr), ups)==0)
     .  write(*,*) 'PDB error reading ups', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='tis(0:'//trim(nxstr)//',0:'//trim(nystr)//')'
c     write(*,*) trim(varstr), len(trim(varstr))
      if (pfread(fileid, len(trim(varstr)), trim(varstr), tis)==0)
     .  write(*,*) 'PDB error reading tis', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='tes(0:'//trim(nxstr)//',0:'//trim(nystr)//')'
c     write(*,*) trim(varstr), len(trim(varstr))
      if (pfread(fileid, len(trim(varstr)), trim(varstr),tes)==0)
     .  write(*,*) 'PDB error reading tes', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='phis(0:'//trim(nxstr)//',0:'//trim(nystr)//')'
c     write(*,*) trim(varstr), len(trim(varstr))
      if (pfread(fileid, len(trim(varstr)), trim(varstr), phis)==0)
     .  write(*,*) 'PDB error reading phis', pfgerr
cc     .   write(*,*) 'PDB error writing ', filename !call errproc

      if (pfclos(fileid)==0) write(*,*) 'Error closing file', pfgerr
c     .   write(*,*) 'PDB error closing ', filename !call errproc
c     write(*,*) 'PDB close ',trim(filename)

      uedge_read_pdb=fileid
      end function uedge_read_pdb


c-----------------------------------------------------------------------

c******************************************************
c Function for reading UEDGE variables from default PDB filename
c******************************************************
      integer function uedge_read()

c ... Common blocks:
            use Dim  		! for Interp
            use Interp  	! uedge_savefile

c ... External functions:
      implicit none

      integer uedge_read_pdb
     
      uedge_read=uedge_read_pdb(trim(uedge_savefile))

      end function uedge_read

c-----------------------------------------------------------------------

c******************************************************
c Function for saving neutral source data to PDB file
c******************************************************
      integer function mcnsor_save_pdb(filename)

c ... Common blocks: 
            use Dim 
            use MCN_dim 
            use MCN_sources   !sni

c ... Local variables:
      implicit none

      character*256 filename,varstr
      character*8 nxstr,nystr,nflstr,nstrastr
      integer fileid, flen

c ... External functions: 
      integer pfopen, pfwrta, pfclos, pfgerr ! PDB API

      flen=len(trim(filename))

      fileid = pfopen(flen, trim(filename), 'w')
      if (fileid .eq. 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error opening ', filename !call errproc
      write(*,*) 'PDB open ',trim(filename)

      write(nxstr,'(i0)') nx+1
      write(nystr,'(i0)') ny+1
      write(nflstr,'(i0)') nfl
      write(nstrastr,'(i0)') nstra

      varstr='sni(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', sni) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='smor(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', smor) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='smophi(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', smophi) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='smoz(0:'//trim(nxstr)//',0:'//trim(nystr)//
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', smoz) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='sei(0:'//trim(nxstr)//',0:'//trim(nystr)//
     .  ',1:'//trim(nstrastr)//')pnc_save_pdb'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', sei) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='see(0:'//trim(nxstr)//',0:'//trim(nystr)//
     .  ',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', see) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      if (pfclos(fileid)==0) write(*,*) pfgerr
c     .   write(*,*) 'PDB error closing ', filename !call errproc
      write(*,*) 'PDB close ',trim(filename)

      mcnsor_save_pdb=fileid
      end function mcnsor_save_pdb

c-----------------------------------------------------------------------

c******************************************************
c Function for appending neutral source data to PDB file
c******************************************************
      integer function mcnsor_append_pdb(filename)

c ... Common blocks: 
            use Dim 
            use MCN_dim 
            use MCN_sources   !sni
            use PNC_params  	!pnc_savefile

c ... Local variables:
      implicit none

      character*256 filename,varstr
      character*8 nxstr,nystr,nflstr,nstrastr
      integer fileid, flen

c ... External functions: 
      integer pfopen, pfwrta, pfclos, pfgerr ! PDB API

      flen=len(trim(filename))
      fileid = pfopen(flen, trim(filename), 'a')
      if (fileid .eq. 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error opening ', filename !call errproc
      write(*,*) 'PDB open ',trim(filename)

      write(nxstr,'(i0)') nx+1
      write(nystr,'(i0)') ny+1
      write(nflstr,'(i0)') nfl
      write(nstrastr,'(i0)') nstra

      varstr='sni(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', sni) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='smor(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', smor) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='smophi(0:'//trim(nxstr)//',0:'//trim(nystr)// 
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', smophi) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='smoz(0:'//trim(nxstr)//',0:'//trim(nystr)//
     .  ',1:'//trim(nflstr)//',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', smoz) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='sei(0:'//trim(nxstr)//',0:'//trim(nystr)//
     .  ',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', sei) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      varstr='see(0:'//trim(nxstr)//',0:'//trim(nystr)//
     .  ',1:'//trim(nstrastr)//')'
      write(*,*) trim(varstr), len(trim(varstr))
      if (pfwrta(fileid, len(trim(varstr)), trim(varstr), 
     .   len('double'), 'double', see) == 0)
     .  write(*,*) pfgerr
c     .   write(*,*) 'PDB error writing ', filename !call errproc

      if (pfclos(fileid)==0) write(*,*) pfgerr
c     .   write(*,*) 'PDB error closing ', filename !call errproc
      write(*,*) 'PDB close ',trim(filename)

      mcnsor_append_pdb=fileid
      end function mcnsor_append_pdb

c-----------------------------------------------------------------------

c******************************************************
c Function for saving UEDGE variables and neutral sources to default PDB filename
c******************************************************
      integer function pnc_save_pdb(filename)

c ... Common blocks:
            use Ext_neutrals  ! extneutopt

c ... External functions:
      implicit none

      integer uedge_save_pdb, mcnsor_append_pdb

c ... Local variables:
      character*256 filename
     
      pnc_save_pdb=uedge_save_pdb(filename)

      if (extneutopt .gt. 0) then
        pnc_save_pdb=mcnsor_append_pdb(filename)
      endif

      end function pnc_save_pdb

c----------------------------------------------------------------------c

      subroutine readmcndens(fname)
            use Dim 		! nx,ny
            use MCN_dim 
            use MCN_sources 
            use Ext_neutrals  		 ! ext_verbose
      implicit none
      character*(*) fname

      integer nunit,ix,iy,ifl,idum
      real rdum

c     Read data from DEGAS2 code output data file 'density.out':

      call freeus (nunit)
      open (nunit, file=fname, form='formatted', status='unknown')

c     Plasma density and pressure:
         do ifl=1,1 !ngsp
           do ix=1,nx
             do iy=1,ny
               read (nunit,*) idum, idum,
     .              ng_mc(ix,iy,ifl), ng_mc_rsd(ix,iy,ifl),
     .              pg_mc(ix,iy,ifl), pg_mc_rsd(ix,iy,ifl),
     .              pxz_mc(ix,iy,ifl), pxz_mc_rsd(ix,iy,ifl)
             enddo
           enddo
         enddo

      close (nunit)
      if (ext_verbose)
     . call remark(" *** neutral density read from DEGAS2 file "
     .                                                  //fname//" ***")

      end

c----------------------------------------------------------------------c

      subroutine readmcnoutput(fname,hskip,var,rsd)
            use Dim 		! nx,ny
            use MCN_dim 
            use MCN_sources 
            use Ext_neutrals  		 ! ext_verbose

c ... Input Variables
      implicit none

      character*(*) fname
      integer hskip

c ... Output Variables
      real var(0:nx+1,0:ny+1,1:ngsp), rsd(0:nx+1,0:ny+1,1:ngsp)

c ... Local Variables
      integer nunit,ix,iy,ifl,idum,tskip,il
      real rdum 

c     Read data from DEGAS2 code outputbrowser data files such as 'neutral_density.dat':
      call freeus (nunit)
      open (nunit, file=fname, form='formatted', status='unknown')

      var=0
      rsd=0

      tskip=5
c     Skip header
      do il=1,hskip
        read(nunit,*)
      enddo
c     Read variable and rel. std. dev.
      do ifl=1,ngsp
c       write(*,*) "ifl =",ifl
        do ix=1,nx
          do iy=1,ny
            read (nunit,*) idum, idum,
     .        var(ix,iy,ifl), rsd(ix,iy,ifl)
c           if (abs(var(ix,iy,ifl)) .gt. 0)
c    .        write(*,*) ix, iy, ifl, var(ix,iy,ifl), rsd(ix,iy,ifl)
           enddo
        enddo
c       Skip trailing data
        do il=1,tskip
          read(nunit,*)
        enddo
      enddo


      close (nunit)
      if (ext_verbose)
     . call remark(" *** output read from DEGAS2 file "
     .                                                  //fname//" ***")

      end

c----------------------------------------------------------------------c

      subroutine readmcnmoments(dname)
            use Dim 				! nx,ny
            use MCN_dim 
            use MCN_sources 
            use Ext_neutrals  	! ext_verbose, moment filenames

c ... Input Variables
      implicit none

      character*(*) dname

c ... Local Variables      
      logical verbose
      character*512 fname
      integer sskip, vskip, idim
      real var1(0:nx+1,0:ny+1,nfl), rsd1(0:nx+1,0:ny+1,nfl)

c ... External Functions
      external readmcnoutput, mcndivide

c ... Read Data
      sskip=4
      vskip=5

      verbose=ext_verbose
      ext_verbose=.false.

c     Read data from DEGAS2 code outputbrowser data files such as 'neutral_density.dat':
      fname=dname//"/"//neut_ng_file
      call readmcnoutput(trim(fname),sskip,var1,rsd1)
      ng_mc=var1
      ng_mc_rsd=rsd1
      fname=dname//"/"//neut_pg_file
      call readmcnoutput(trim(fname),sskip,var1,rsd1)
      pg_mc=var1
      pg_mc_rsd=rsd1

      fname=dname//"/"//neut_jng1_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      jng_mc(:,:,:,1)=var1
      jng_mc_rsd(:,:,:,1)=rsd1
      fname=dname//"/"//neut_jng2_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      jng_mc(:,:,:,2)=var1
      jng_mc_rsd(:,:,:,2)=rsd1
      fname=dname//"/"//neut_jng3_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      jng_mc(:,:,:,3)=var1
      jng_mc_rsd(:,:,:,3)=rsd1

      fname=dname//"/"//neut_pg11_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      stressg_mc(:,:,:,1,1)=var1
      stressg_mc_rsd(:,:,:,1,1)=rsd1
      fname=dname//"/"//neut_pg22_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      stressg_mc(:,:,:,2,2)=var1
      stressg_mc_rsd(:,:,:,2,2)=rsd1
      fname=dname//"/"//neut_pg33_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      stressg_mc(:,:,:,3,3)=var1
      stressg_mc_rsd(:,:,:,3,3)=rsd1

      fname=dname//"/"//neut_pg23_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      stressg_mc(:,:,:,2,3)=var1
      stressg_mc_rsd(:,:,:,2,3)=rsd1
      stressg_mc(:,:,:,3,2)=var1
      stressg_mc_rsd(:,:,:,3,2)=rsd1
      fname=dname//"/"//neut_pg31_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      stressg_mc(:,:,:,3,1)=var1
      stressg_mc_rsd(:,:,:,3,1)=rsd1
      stressg_mc(:,:,:,1,3)=var1
      stressg_mc_rsd(:,:,:,1,3)=rsd1
      fname=dname//"/"//neut_pg12_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      stressg_mc(:,:,:,1,2)=var1
      stressg_mc_rsd(:,:,:,1,2)=rsd1
      stressg_mc(:,:,:,2,1)=var1
      stressg_mc_rsd(:,:,:,1,2)=rsd1

      fname=dname//"/"//neut_jeg1_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      jeg_mc(:,:,:,1)=var1
      jeg_mc_rsd(:,:,:,1)=rsd1
      fname=dname//"/"//neut_jeg2_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      jeg_mc(:,:,:,2)=var1
      jeg_mc_rsd(:,:,:,2)=rsd1
      fname=dname//"/"//neut_jeg3_file
      call readmcnoutput(trim(fname),vskip,var1,rsd1)
      jeg_mc(:,:,:,3)=var1
      jeg_mc_rsd(:,:,:,3)=rsd1

      ext_verbose=verbose
       if (ext_verbose)
     . call remark(" *** neutral moments read from DEGAS2 directory "
     .                                                  //dname//" ***")     

      end

c----------------------------------------------------------------------c

      subroutine convertmcnmoments()
            use Dim 				! nx,ny
            use Comflo  			! fngx,fngy,...
            use Comgeo 			! sx,sy
            use Compla 			! ng,tg
            use Interp 			! ngs,tis
            use MCN_dim 
            use MCN_sources       ! ng_mc,ng_mc_rsd,... 
            use Ext_neutrals  	! ext_verbose
            use PNC_params 		! pnc moment filenames

c ... Local Variables
      implicit none

      integer idim,ifld

c ... Scalars
c     write(*,*) "convertmcnmoments: scalar"
      call mcnblend(ng_ue,ngs,ng_mc,ng_ue_rsd,ng_mc_rsd,mcalpha_ng)
      call mcnblend(pg_ue,ngs(:,:,1)*tis,pg_mc,pg_ue_rsd,pg_mc_rsd,mcalpha_pg)
      call mcuedivide(tg_ue,pg_ue,ng_ue,tg_ue_rsd,pg_ue_rsd,ng_ue_rsd)

c ... Vectors
c ... 1. Convert vectors
c ... 2. Multiply current density by area in order to get current
c ... 3. Blend kinetic fluxes with fluid fluxes
c ... 4. Calculate velocity

c     write(*,*) "convertmcnmoments: vector"
      call convertmcnvector(jng_mc,jng_ue,jng_mc_rsd,jng_ue_rsd)
      do ifld=1,nfl
        fngx_mc(:,:,ifld)=sx*jng_ue(:,:,ifld,1) 
        fngy_mc(:,:,ifld)=sy*jng_ue(:,:,ifld,2)
      enddo
      fngx_mc_rsd=jng_ue_rsd(:,:,:,1)
      fngy_mc_rsd=jng_ue_rsd(:,:,:,2)
      call mcnblend(fngx_ue,fngx,fngx_mc,fngx_ue_rsd,fngx_mc_rsd,mcalpha_fng)
      call mcnblend(fngy_ue,fngy,fngy_mc,fngy_ue_rsd,fngy_mc_rsd,mcalpha_fng)
      fngx_ue=fngx
      fngy_ue=fngy

      do idim=1,3
      do ifld=1,nfl
        call mcuedivide(vg_mc(:,:,ifld,idim),jng_mc(:,:,ifld,idim),ng_ue,
     .                  vg_mc_rsd(:,:,ifld,idim),jng_mc_rsd(:,:,ifld,idim),ng_ue_rsd)
        call mcuedivide(vg_ue(:,:,ifld,idim),jng_ue(:,:,ifld,idim),ng_ue,
     .                  vg_ue_rsd(:,:,ifld,idim),jng_ue_rsd(:,:,ifld,idim),ng_ue_rsd)
      enddo
      enddo
      upg_ue = vg_ue(:,:,:,3)
      upg_ue_rsd = vg_ue_rsd(:,:,:,3)
     
      call convertmcnvector(jeg_mc,jeg_ue,jeg_mc_rsd,jeg_ue_rsd)
      do ifld=1,nfl
        fegx(:,:,ifld)=0.0
        fegy(:,:,ifld)=0.0
        fegx_mc(:,:,ifld)=sx*jeg_ue(:,:,ifld,1) 
        fegy_mc(:,:,ifld)=sy*jeg_ue(:,:,ifld,2)
      enddo
      fegx_mc_rsd=jeg_ue_rsd(:,:,:,1)
      fegy_mc_rsd=jeg_ue_rsd(:,:,:,2)
      call mcnblend(fegx_ue,fegx,fegx_mc,fegx_ue_rsd,fegx_mc_rsd,mcalpha_feg)
      call mcnblend(fegy_ue,fegy,fegy_mc,fegy_ue_rsd,fegy_mc_rsd,mcalpha_feg)
 
c ... Tensors
c ... 1. convertmcntensor
c ... 2. find parallel component, perpendicular curl, etc.
c ... 3. Blend kinetic and fluid results

c     write(*,*) "convertmcnmoments: tensor"
      call convertmcntensor(stressg_mc,stressg_ue,stressg_mc_rsd,stressg_ue_rsd)
      do ifld=1,nfl
        fmgx(:,:,ifld)=fmix(:,:,2*ifld)
        fmgy(:,:,ifld)=fmiy(:,:,2*ifld)
        fmgx_mc(:,:,ifld)=sx*stressg_ue(:,:,ifld,1,3) 
        fmgy_mc(:,:,ifld)=sy*stressg_ue(:,:,ifld,2,3)
      end do
      fmgx_mc_rsd=stressg_ue_rsd(:,:,:,1,3)
      fmgy_mc_rsd=stressg_ue_rsd(:,:,:,2,3)
      call mcnblend(fmgx_ue,fmgx,fmgx_mc,fmgx_ue_rsd,fmgx_mc_rsd,mcalpha_fmg)
      call mcnblend(fmgy_ue,fmgy,fmgy_mc,fmgy_ue_rsd,fmgy_mc_rsd,mcalpha_fmg)

c ... Finally, find contribution to vorticity ... is this already handled via friction forces?

      end

c----------------------------------------------------------------------

      subroutine mcndivide(out,var,dens,out_rsd,var_rsd,dens_rsd)
            use Dim 				! nx,ny
            use MCN_dim           ! nfl

c ... Input Variables
      implicit none

      real var(0:nx+1,0:ny+1,1:ngsp),dens(0:nx+1,0:ny+1,1:nfl)
      real var_rsd(0:nx+1,0:ny+1,1:ngsp),dens_rsd(0:nx+1,0:ny+1,1:nfl)

c ... Output Variables
      real out(0:nx+1,0:ny+1,1:nfl),out_rsd(0:nx+1,0:ny+1,1:nfl)     

      out=0.;out_rsd=1.;
      where(dens .gt. 0.0) out=var/dens
      where(dens .gt. 0.0) out_rsd=sqrt(var_rsd**2+dens_rsd**2) 
     
      end

c----------------------------------------------------------------------

      subroutine mcuedivide(out,var,dens,out_rsd,var_rsd,dens_rsd)
            use Dim 				! nx,ny
            use MCN_dim           ! nfl

c ... Input Variables
      implicit none

      real var(0:nx+1,0:ny+1,1:nfl),dens(0:nx+1,0:ny+1,1:nfl)
      real var_rsd(0:nx+1,0:ny+1,1:nfl),dens_rsd(0:nx+1,0:ny+1,1:nfl)

c ... Output Variables
      real out(0:nx+1,0:ny+1,1:nfl),out_rsd(0:nx+1,0:ny+1,1:nfl)     

      out=0.;out_rsd=1.;
      where(dens .ne. 0.0) out=var/dens
      where(dens .ne. 0.0) out_rsd=sqrt(var_rsd**2+dens_rsd**2)
     
      end

c----------------------------------------------------------------------

      subroutine mcnrsdfix(mcrsd)
            use Dim 				! nx,ny,ngsp
            use MCN_dim           ! nfl

c ... Input/Output Variables
      implicit none

      real mcrsd(0:nx+1,0:ny+1,1:nfl)

      where(mcrsd .le. 0 .or. mcrsd .gt. 1) mcrsd=1

      end

c----------------------------------------------------------------------

      subroutine mcnblend(out,uevar,mcvar,outrsd,mcrsd,alpha)
            use Dim 				! nx,ny,ngsp
            use MCN_dim           ! nfl

c ... Input Variables
      implicit none

      real, intent(in), dimension(0:nx+1,0:ny+1,1:nfl) :: uevar,mcvar,mcrsd 
      real, intent(in) :: alpha

c ... Output Variables
      real, intent(inout), dimension(0:nx+1,0:ny+1,1:nfl) :: outrsd  
      real, intent(out), dimension(0:nx+1,0:ny+1,1:nfl) :: out   

c ... Local Variables
      real, dimension(0:nx+1,0:ny+1,1:nfl) :: mcfrac 

      call mcnrsdfix(mcrsd)
      mcfrac=(1-mcrsd**2)**alpha
c      mcfrac=(1-mcrsd**alpha)
      out = (1-mcfrac)*uevar + mcfrac*mcvar 
      where(out .ne. 0) outrsd = mcrsd*mcfrac*mcvar/out
      where(out .eq. 1) outrsd = 1

c      write(*,*) "mcnblend ",out
      end

c-----------------------------------------------------------------------

      function mult23(var2,var3,n3)
            use Dim 				! nx,ny
            use MCN_dim 

c ... Input Variables
      implicit none

      integer n3
      real var2(0:nx+1,0:ny+1)
      real var3(0:nx+1,0:ny+1,n3)

c ... Output Variables
      real mult23(0:nx+1,0:ny+1,n3)    

c ... Local Variables
      integer i

      do i=1,n3
        mult23(:,:,i)=var3(:,:,i)*var2
      end do
      
      end function mult23

c-----------------------------------------------------------------------

      function mult24(var2,var4,n3,n4)
            use Dim 				! nx,ny

c ... Input Variables
      implicit none

      integer n3,n4
      real var2(0:nx+1,0:ny+1)
      real var4(0:nx+1,0:ny+1,n3,n4)

c ... Output Variables
      real mult24(0:nx+1,0:ny+1,n3,n4)   

c ... Local Variables
      integer i,j

      do i=1,n3
      do j=1,n4
        mult24(:,:,i,j)=var4(:,:,i,j)*var2
      end do
      end do

      end function mult24

c-----------------------------------------------------------------------

      function mult34(var3,var4,n3,n4)
            use Dim 				! nx,ny

c ... Input Variables
      implicit none

      integer n3, n4
      real var3(0:nx+1,0:ny+1,n3)
      real var4(0:nx+1,0:ny+1,n3,n4)

c ... Output Variables
      real mult34(0:nx+1,0:ny+1,n3,n4)    

c ... Local Variables
      integer i

      do i=1,n4
        mult34(:,:,:,i)=var4(:,:,:,i)*var3
      end do

      end function mult34

c-----------------------------------------------------------------------

c******************************************************
c Subroutines for testing external types in VDF file
c******************************************************

      subroutine testfunfun(f,x,y)
      implicit none
	  external f
      real x,y,f
      y=f(x)
      print *,'y=f(x)'
      end

      real function testfun(x)
      implicit none
      real x
      testfun=2*x
      end function testfun

c      real function norm(v)
c      implicit none
c      real :: v 
c      norm=sum(v**2)
c      norm=sqrt(norm)
c      end function norm
    
      subroutine test_opt(optarg)
c ... This fails when argument not present: parxfcn: incorrect number of argument 
      implicit none

      logical test

c      real opt, optarg
c      opt=3.14
c      if(optarg .ne. real(DEFAULT)) opt=optarg

      character*128 opt, optarg
      opt='test_string'
      test=(optarg==' y')
      write(*,*) "test =", test,", optarg=",optarg,", opt=",opt
      if(.not.(optarg==' y')) opt=trim(optarg)

      call remark(trim(opt))
      end

      subroutine test_parser(optarg)
c ... This fails when argument not present: parxfcn: incorrect number of argument 
            use PNC_params 

      implicit none

c     Use(Dim)
      character*128 opt, optarg

      opt=trim(adjustl(optarg))//char(0)
c     opt='remark 1'
c     opt='dobalance(pnc_balancefile)'

      write(*,*) "opt=",opt
      call parsestr(opt)

      end

      subroutine dewset (n, itol, rtol, atol, ycur, ewt)
clll. optimize
c-----------------------------------------------------------------------
c this subroutine sets the error weight vector ewt according to
c     ewt(i) = rtol(i)*abs(ycur(i)) + atol(i),  i = 1,...,n,
c with the subscript on rtol and/or atol possibly replaced by 1 above,
c depending on the value of itol.
c-----------------------------------------------------------------------
      integer*4 n, itol
      integer*4 i
      double precision rtol, atol, ycur, ewt
      dimension rtol(n), atol(n), ycur(n), ewt(n)
c
      go to (10, 20, 30, 40), itol
 10   continue
      do 15 i = 1,n
 15     ewt(i) = rtol(1)*dabs(ycur(i)) + atol(1)
      return
 20   continue
      do 25 i = 1,n
 25     ewt(i) = rtol(1)*dabs(ycur(i)) + atol(i)
      return
 30   continue
      do 35 i = 1,n
 35     ewt(i) = rtol(i)*dabs(ycur(i)) + atol(1)
      return
 40   continue
      do 45 i = 1,n
 45     ewt(i) = rtol(i)*dabs(ycur(i)) + atol(i)
      return
c----------------------- end of subroutine dewset ----------------------
      end
cc *********************************************cc
      double precision function d1mach9 (idum)
      integer*4 idum
c-----------------------------------------------------------------------
c this routine computes the unit roundoff of the machine in double
c precision.  this is defined as the smallest positive machine number
c u such that  1.0d0 + u .ne. 1.0d0 (in double precision).
c-----------------------------------------------------------------------
      double precision u, comp
      u = 1.0d0
 10   u = u*0.5d0
      comp = 1.0d0 + u
      if (comp .ne. 1.0d0) go to 10
      d1mach9 = u*2.0d0
      return
c----------------------- end of function d1mach9 ------------------------
      end
cc *******************************************************************cc
      subroutine dxerrwv(msg, nmes, nerr, level, ni, i1, i2, nr, r1, r2)
      integer*4 nmes, nerr, level, ni, i1, i2, nr,
     1   i, lun, mesflg
      double precision r1, r2
      character*(*) msg
c-----------------------------------------------------------------------
c subroutine dxerrwv as given here, constitutes
c a simplified version of the slatec error handling package.
c written by a. c. hindmarsh at llnl.  version of march 30, 1987.
c modified by Gary R. Smith on 7 January 1994.
c this version is in double precision.
c
c all arguments are input arguments.
c
c msg    = the message (character variable).
c nmes   = the length of msg (number of characters).
c nerr   = the error number (not used).
c level  = the error level..
c          0 or 1 means recoverable (control returns to caller).
c          2 means unrecoverable (control returns to user).
c ni     = number of integers (0, 1, or 2) to be printed with message.
c i1,i2  = integers to be printed, depending on ni.
c nr     = number of reals (0, 1, or 2) to be printed with message.
c r1,r2  = reals to be printed, depending on nr.
c
c note..  this routine is machine-dependent and specialized for use
c in limited context, in the following ways..
c 1. the argument msg is assumed to be of type character, and
c    substring (1:nmes) of the message is printed with a format of (1x,a).
c 2. the message is assumed to take only one line.
c    multi-line messages are generated by repeated calls.
c 3. if level = 2, control passes to the statement   call kaboom(0)
c    to return control to user.  subroutine kaboom is part of the
c    Basis runtime system.
c 4. r1 and r2 are assumed to be in double precision and are printed
c    in d21.13 format.
c-----------------------------------------------------------------------
c the following are instructions for installing this routine
c in different machine environments.
c
c to change the default output unit, insert the following statement
c in the calling program:  call xsetunp (lun)
c
c for a different level=2 behavior, change the statement following
c statement 100 at the end.
c-----------------------------------------------------------------------
c subroutine called by dxerrwv.. parmsetget
c function routines called by dxerrwv.. none
c-----------------------------------------------------------------------
c Get message print flag and logical unit number. ----------------------
      call parmsetget (1, lun, .false.)
      call parmsetget (2, mesflg, .false.)
      if (mesflg .eq. 0) go to 100
c write the message. ---------------------------------------------------
      write (lun, 10) msg(1:nmes)
  10  format(1x,a)
c-----------------------------------------------------------------------
      if (ni .eq. 1) write (lun, 20) i1
 20   format(6x,23hin above message,  i1 =,i10)
      if (ni .eq. 2) write (lun, 30) i1,i2
 30   format(6x,23hin above message,  i1 =,i10,3x,4hi2 =,i10)
      if (nr .eq. 1) write (lun, 40) r1
 40   format(6x,23hin above message,  r1 =,d21.13)
      if (nr .eq. 2) write (lun, 50) r1,r2
 50   format(6x,15hin above,  r1 =,d21.13,3x,4hr2 =,d21.13)
c abort the run if level = 2. ------------------------------------------
 100  if (level .ne. 2) return
      call kaboom(0)
c----------------------- end of subroutine dxerrwv ---------------------
      end
cc ************************************************cc
      subroutine dgefa(a,lda,n,ipvt,info)
      integer*4 lda,n,ipvt(n),info
      double precision a(lda,n)
c
c     dgefa factors a double precision matrix by gaussian elimination.
c
c     dgefa is usually called by dgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for dgeco) = (1 + 9/n)*(time for dgefa) .
c
c     on entry
c
c        a       double precision(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that dgesl or dgedi will divide by zero
c                     if called.  use  rcond  in dgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,idamax
c
c     internal variables
c
      double precision t
      integer*4 idamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = idamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0d0/a(k,k)
            call dscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call daxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n,n) .eq. 0.0d0) info = n
      return
      end
cc ****************************************************cc
      subroutine dgesl(a,lda,n,ipvt,b,job)
      integer*4 lda,n,ipvt(n),job
      double precision a(lda,n),b(n)
c
c     dgesl solves the double precision system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgeco or dgefa.
c
c     on entry
c
c        a       double precision(lda, n)
c                the output from dgeco or dgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from dgeco or dgefa.
c
c        b       double precision(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b  where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgeco has set rcond .gt. 0.0
c        or dgefa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgeco(a,lda,n,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call dgesl(a,lda,n,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,ddot
c
c     internal variables
c
      double precision ddot,t
      integer*4 k,kb,l,nm1
c
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve  l*y = b
c
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call daxpy(n-k,t,a(k+1,k),1,b(k+1),1)
   20    continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k,k)
            t = -b(k)
            call daxpy(k-1,t,a(1,k),1,b(1),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            t = ddot(k-1,a(1,k),1,b(1),1)
            b(k) = (b(k) - t)/a(k,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + ddot(n-k,a(k+1,k),1,b(k+1),1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end
cc ************************************************ cc
      subroutine dgbfa(abd,lda,n,ml,mu,ipvt,info)
      integer*4 lda,n,ml,mu,ipvt(n),info
      double precision abd(lda,n)
c
c     dgbfa factors a double precision band matrix by elimination.
c
c     dgbfa is usually called by dgbco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c
c     on entry
c
c        abd     double precision(lda, n)
c                contains the matrix in band storage.  the columns
c                of the matrix are stored in the columns of  abd  and
c                the diagonals of the matrix are stored in rows
c                ml+1 through 2*ml+mu+1 of  abd .
c                see the comments below for details.
c
c        lda     integer
c                the leading dimension of the array  abd .
c                lda must be .ge. 2*ml + mu + 1 .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c                0 .le. ml .lt. n .
c
c        mu      integer
c                number of diagonals above the main diagonal.
c                0 .le. mu .lt. n .
c                more efficient if  ml .le. mu .
c     on return
c
c        abd     an upper triangular matrix in band storage and
c                the multipliers which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that dgbsl will divide by zero if
c                     called.  use  rcond  in dgbco for a reliable
c                     indication of singularity.
c
c     band storage
c
c           if  a  is a band matrix, the following program segment
c           will set up the input.
c
c                   ml = (band width below the diagonal)
c                   mu = (band width above the diagonal)
c                   m = ml + mu + 1
c                   do 20 j = 1, n
c                      i1 = max0(1, j-mu)
c                      i2 = min0(n, j+ml)
c                      do 10 i = i1, i2
c                         k = i - j + m
c                         abd(k,j) = a(i,j)
c                10    continue
c                20 continue
c
c           this uses rows  ml+1  through  2*ml+mu+1  of  abd .
c           in addition, the first  ml  rows in  abd  are used for
c           elements generated during the triangularization.
c           the total number of rows needed in  abd  is  2*ml+mu+1 .
c           the  ml+mu by ml+mu  upper left triangle and the
c           ml by ml  lower right triangle are not referenced.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,idamax
c     fortran max0,min0
c
c     internal variables
c
      double precision t
      integer*4 i,idamax,i0,j,ju,jz,j0,j1,k,kp1,l,lm,m,mm,nm1
c
c
      m = ml + mu + 1
      info = 0
c
c     zero initial fill-in columns
c
      j0 = mu + 2
      j1 = min0(n,m) - 1
      if (j1 .lt. j0) go to 30
      do 20 jz = j0, j1
         i0 = m + 1 - jz
         do 10 i = i0, ml
            abd(i,jz) = 0.0d0
   10    continue
   20 continue
   30 continue
      jz = j1
      ju = 0
c
c     gaussian elimination with partial pivoting
c
      nm1 = n - 1
      if (nm1 .lt. 1) go to 130
      do 120 k = 1, nm1
         kp1 = k + 1
c
c        zero next fill-in column
c
         jz = jz + 1
         if (jz .gt. n) go to 50
         if (ml .lt. 1) go to 50
            do 40 i = 1, ml
               abd(i,jz) = 0.0d0
   40       continue
   50    continue
c
c        find l = pivot index
c
         lm = min0(ml,n-k)
         l = idamax(lm+1,abd(m,k),1) + m - 1
         ipvt(k) = l + k - m
c
c        zero pivot implies this column already triangularized
c
         if (abd(l,k) .eq. 0.0d0) go to 100
c
c           interchange if necessary
c
            if (l .eq. m) go to 60
               t = abd(l,k)
               abd(l,k) = abd(m,k)
               abd(m,k) = t
   60       continue
c
c           compute multipliers
c
            t = -1.0d0/abd(m,k)
            call dscal(lm,t,abd(m+1,k),1)
c
c           row elimination with column indexing
c
            ju = min0(max0(ju,mu+ipvt(k)),n)
            mm = m
            if (ju .lt. kp1) go to 90
            do 80 j = kp1, ju
               l = l - 1
               mm = mm - 1
               t = abd(l,j)
               if (l .eq. mm) go to 70
                  abd(l,j) = abd(mm,j)
                  abd(mm,j) = t
   70          continue
               call daxpy(lm,t,abd(m+1,k),1,abd(mm+1,j),1)
   80       continue
   90       continue
         go to 110
  100    continue
            info = k
  110    continue
  120 continue
  130 continue
      ipvt(n) = n
      if (abd(m,n) .eq. 0.0d0) info = n
      return
      end
cc ************************************************ cc
      subroutine dgbsl(abd,lda,n,ml,mu,ipvt,b,job)
      integer*4 lda,n,ml,mu,ipvt(n),job
      double precision abd(lda,n),b(n)
c
c     dgbsl solves the double precision band system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgbco or dgbfa.
c
c     on entry
c
c        abd     double precision(lda, n)
c                the output from dgbco or dgbfa.
c
c        lda     integer
c                the leading dimension of the array  abd .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c
c        mu      integer
c                number of diagonals above the main diagonal.
c
c        ipvt    integer(n)
c                the pivot vector from dgbco or dgbfa.
c
c        b       double precision(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b , where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgbco has set rcond .gt. 0.0
c        or dgbfa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgbco(abd,lda,n,ml,mu,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call dgbsl(abd,lda,n,ml,mu,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,ddot
c     fortran min0
c
c     internal variables
c
      double precision ddot,t
      integer*4 k,kb,l,la,lb,lm,m,nm1
c
      m = mu + ml + 1
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve l*y = b
c
         if (ml .eq. 0) go to 30
         if (nm1 .lt. 1) go to 30
            do 20 k = 1, nm1
               lm = min0(ml,n-k)
               l = ipvt(k)
               t = b(l)
               if (l .eq. k) go to 10
                  b(l) = b(k)
                  b(k) = t
   10          continue
               call daxpy(lm,t,abd(m+1,k),1,b(k+1),1)
   20       continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/abd(m,k)
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = -b(k)
            call daxpy(lm,t,abd(la,k),1,b(lb),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = ddot(lm,abd(la,k),1,b(lb),1)
            b(k) = (b(k) - t)/abd(m,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (ml .eq. 0) go to 90
         if (nm1 .lt. 1) go to 90
            do 80 kb = 1, nm1
               k = n - kb
               lm = min0(ml,n-k)
               b(k) = b(k) + ddot(lm,abd(m+1,k),1,b(k+1),1)
               l = ipvt(k)
               if (l .eq. k) go to 70
                  t = b(l)
                  b(l) = b(k)
                  b(k) = t
   70          continue
   80       continue
   90    continue
  100 continue
      return
      end
cc ********************************************************** cc
      subroutine dgbco(abd,lda,n,ml,mu,ipvt,rcond,z)
      integer*4 lda,n,ml,mu,ipvt(n)
      double precision abd(lda,n),z(n)
      double precision rcond
c
c     dgbco factors a double precision band matrix by gaussian
c     elimination and estimates the condition of the matrix.
c
c     if  rcond  is not needed, dgbfa is slightly faster.
c     to solve  a*x = b , follow dgbco by dgbsl.
c     to compute  inverse(a)*c , follow dgbco by dgbsl.
c     to compute  determinant(a) , follow dgbco by dgbdi.
c
c     on entry
c
c        abd     double precision(lda, n)
c                contains the matrix in band storage.  the columns
c                of the matrix are stored in the columns of  abd  and
c                the diagonals of the matrix are stored in rows
c                ml+1 through 2*ml+mu+1 of  abd .
c                see the comments below for details.
c
c        lda     integer
c                the leading dimension of the array  abd .
c                lda must be .ge. 2*ml + mu + 1 .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c                0 .le. ml .lt. n .
c
c        mu      integer
c                number of diagonals above the main diagonal.
c                0 .le. mu .lt. n .
c                more efficient if  ml .le. mu .
c
c     on return
c
c        abd     an upper triangular matrix in band storage and
c                the multipliers which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        rcond   double precision
c                an estimate of the reciprocal condition of  a .
c                for the system  a*x = b , relative perturbations
c                in  a  and  b  of size  epsilon  may cause
c                relative perturbations in  x  of size  epsilon/rcond .
c                if  rcond  is so small that the logical expression
c                           1.0 + rcond .eq. 1.0
c                is true, then  a  may be singular to working
c                precision.  in particular,  rcond  is zero  if
c                exact singularity is detected or the estimate
c                underflows.
c
c        z       double precision(n)
c                a work vector whose contents are usually unimportant.
c                if  a  is close to a singular matrix, then  z  is
c                an approximate null vector in the sense that
c                norm(a*z) = rcond*norm(a)*norm(z) .
c
c     band storage
c
c           if  a  is a band matrix, the following program segment
c           will set up the input.
c
c                   ml = (band width below the diagonal)
c                   mu = (band width above the diagonal)
c                   m = ml + mu + 1
c                   do 20 j = 1, n
c                      i1 = max0(1, j-mu)
c                      i2 = min0(n, j+ml)
c                      do 10 i = i1, i2
c                         k = i - j + m
c                         abd(k,j) = a(i,j)
c                10    continue
c                20 continue
c
c           this uses rows  ml+1  through  2*ml+mu+1  of  abd .
c           in addition, the first  ml  rows in  abd  are used for
c           elements generated during the triangularization.
c           the total number of rows needed in  abd  is  2*ml+mu+1 .
c           the  ml+mu by ml+mu  upper left triangle and the
c           ml by ml  lower right triangle are not referenced.
c
c     example..  if the original matrix is
c
c           11 12 13  0  0  0
c           21 22 23 24  0  0
c            0 32 33 34 35  0
c            0  0 43 44 45 46
c            0  0  0 54 55 56
c            0  0  0  0 65 66
c
c      then  n = 6, ml = 1, mu = 2, lda .ge. 5  and abd should contain
c
c            *  *  *  +  +  +  , * = not used
c            *  * 13 24 35 46  , + = used for pivoting
c            * 12 23 34 45 56
c           11 22 33 44 55 66
c           21 32 43 54 65  *
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     linpack dgbfa
c     blas daxpy,ddot,dscal,dasum
c     fortran dabs,dmax1,max0,min0,dsign
c
c     internal variables
c
      double precision ddot,ek,t,wk,wkm
      double precision anorm,s,dasum,sm,ynorm
      integer is,j,ju,k,kb,kp1,l,la,lm,lz,m,mm
      integer*4 info
c
c
c     compute 1-norm of a
c
      anorm = 0.0d0
      l = ml + 1
      is = l + mu
      do 10 j = 1, n
         anorm = dmax1(anorm,dasum(l,abd(is,j),1))
         if (is .gt. ml + 1) is = is - 1
         if (j .le. mu) l = l + 1
         if (j .ge. n - ml) l = l - 1
   10 continue
c
c     factor
c
      call dgbfa(abd,lda,n,ml,mu,ipvt,info)
c
c     rcond = 1/(norm(a)*(estimate of norm(inverse(a)))) .
c     estimate = norm(z)/norm(y) where  a*z = y  and  trans(a)*y = e .
c     trans(a)  is the transpose of a .  the components of  e  are
c     chosen to cause maximum local growth in the elements of w  where
c     trans(u)*w = e .  the vectors are frequently rescaled to avoid
c     overflow.
c
c     solve trans(u)*w = e
c
      ek = 1.0d0
      do 20 j = 1, n
         z(j) = 0.0d0
   20 continue
      m = ml + mu + 1
      ju = 0
      do 100 k = 1, n
         if (z(k) .ne. 0.0d0) ek = dsign(ek,-z(k))
         if (dabs(ek-z(k)) .le. dabs(abd(m,k))) go to 30
            s = dabs(abd(m,k))/dabs(ek-z(k))
            call dscal(n,s,z,1)
            ek = s*ek
   30    continue
         wk = ek - z(k)
         wkm = -ek - z(k)
         s = dabs(wk)
         sm = dabs(wkm)
         if (abd(m,k) .eq. 0.0d0) go to 40
            wk = wk/abd(m,k)
            wkm = wkm/abd(m,k)
         go to 50
   40    continue
            wk = 1.0d0
            wkm = 1.0d0
   50    continue
         kp1 = k + 1
         ju = min0(max0(ju,mu+ipvt(k)),n)
         mm = m
         if (kp1 .gt. ju) go to 90
            do 60 j = kp1, ju
               mm = mm - 1
               sm = sm + dabs(z(j)+wkm*abd(mm,j))
               z(j) = z(j) + wk*abd(mm,j)
               s = s + dabs(z(j))
   60       continue
            if (s .ge. sm) go to 80
               t = wkm - wk
               wk = wkm
               mm = m
               do 70 j = kp1, ju
                  mm = mm - 1
                  z(j) = z(j) + t*abd(mm,j)
   70          continue
   80       continue
   90    continue
         z(k) = wk
  100 continue
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
c
c     solve trans(l)*y = w
c
      do 120 kb = 1, n
         k = n + 1 - kb
         lm = min0(ml,n-k)
         if (k .lt. n) z(k) = z(k) + ddot(lm,abd(m+1,k),1,z(k+1),1)
         if (dabs(z(k)) .le. 1.0d0) go to 110
            s = 1.0d0/dabs(z(k))
            call dscal(n,s,z,1)
  110    continue
         l = ipvt(k)
         t = z(l)
         z(l) = z(k)
         z(k) = t
  120 continue
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
c
      ynorm = 1.0d0
c
c     solve l*v = y
c
      do 140 k = 1, n
         l = ipvt(k)
         t = z(l)
         z(l) = z(k)
         z(k) = t
         lm = min0(ml,n-k)
         if (k .lt. n) call daxpy(lm,t,abd(m+1,k),1,z(k+1),1)
         if (dabs(z(k)) .le. 1.0d0) go to 130
            s = 1.0d0/dabs(z(k))
            call dscal(n,s,z,1)
            ynorm = s*ynorm
  130    continue
  140 continue
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
      ynorm = s*ynorm
c
c     solve  u*z = w
c
      do 160 kb = 1, n
         k = n + 1 - kb
         if (dabs(z(k)) .le. dabs(abd(m,k))) go to 150
            s = dabs(abd(m,k))/dabs(z(k))
            call dscal(n,s,z,1)
            ynorm = s*ynorm
  150    continue
         if (abd(m,k) .ne. 0.0d0) z(k) = z(k)/abd(m,k)
         if (abd(m,k) .eq. 0.0d0) z(k) = 1.0d0
         lm = min0(k,m) - 1
         la = m - lm
         lz = k - lm
         t = -z(k)
         call daxpy(lm,t,abd(la,k),1,z(lz),1)
  160 continue
c     make znorm = 1.0
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
      ynorm = s*ynorm
c
      if (anorm .ne. 0.0d0) rcond = ynorm/anorm
      if (anorm .eq. 0.0d0) rcond = 0.0d0
      return
      end

#include "api.h"
      subroutine imp_sorc_walls (nxd, nzsptd, xcwi, xcwo, syi, syo,
     .                                     ixp1i, ixp1o, fnzysi, fnzyso)

c ... Calculate impurity-source profiles along the inner and outer walls
c     for a number of impurity sources.

c ... Common block:
            use Dim                 ! nxpt
            use Xpoint_indices      ! ixlb,ixrb
            use Sources_at_walls    ! nzsor,iszsorlb,ximpi,ximpo,wimpi,wimpo,
                              ! impsori,impsoro
                              ! jxzsori,jxzsoro
                              ! ixzbegi,ixbego,ixzendi,ixzendo

c ... Local variables:
      implicit none

c ... Input arguments:
      integer nxd               ! number of physical cells along wall
      integer nzsptd            ! total number of impurity species
      integer ixp1i(0:nxd+1)    ! poloidal index of cell physically adjacent
                                ! to right face of cells along inner wall
      integer ixp1o(0:nxd+1)    ! poloidal index of cell physically adjacent
                                ! to right face of cells along outer wall
      real xcwi(0:nxd+1)        ! x-coord. of cell center on inner wall
      real xcwo(0:nxd+1)        ! x-coord. of cell center on outer wall
      real syi(0:nxd+1)         ! surface areas of inner-wall cells
      real syo(0:nxd+1)         ! surface areas of outer-wall cells

c ... Output arguments:
      real fnzysi(0:nxd+1,nzsptd)   ! source profiles along inner wall
      real fnzyso(0:nxd+1,nzsptd)   ! source profiles along outer wall

      integer iz, ix, isor, jxlbi, jxrbi, jxlbo, jxrbo

c ... Check that array limits are not exceeded.
      if (nzsor .gt. NZSORMX) call xerrab(
     .  '*** nzsor > NZSORMX; enlarge impurity-source arrays.')

c ... Zero output arrays.
      do iz = 1, nzsptd
         do ix = 0, nxd+1
            fnzysi(ix,iz) = 0.
            fnzyso(ix,iz) = 0.
         enddo
      enddo

c ... Find the beginning and ending ix-indices for each wall
      do isor = 1, nzsor
         do iz = 1, nzsptd
            jxlbo = jxzsoro(iz,isor)
c     On the outboard wall, sources begin and end in the same mesh region:
            jxrbo = jxlbo
            ixzbego(iz,isor) = ixlb(jxlbo)
            ixzendo(iz,isor) = ixrb(jxrbo)+1

            jxlbi = jxzsori(iz,isor)
c     On private flux walls, sources may begin and end in different mesh regions
c     if nxpt > 1 as in a full double-null configuration.
            if (jxlbi==1) then
               jxrbi = nxpt
            else
               jxrbi = jxlbi - 1
            endif
            ixzbegi(iz,isor) = ixlb(jxlbi)
            ixzendi(iz,isor) = ixrb(jxrbi)+1
         enddo
      enddo

c ... Loop over impurity sources, doing the outer and inner walls.
      do isor = 1, nzsor
         call imp_sorc (nxd, nzsptd, iszsorlb(1,isor),
     .                  ixzbego(1,isor), ixzendo(1,isor), ixp1o,
     .                  ximpo(1,isor), wimpo(1,isor), impsoro(1,isor),
     .                                               xcwo, syo, fnzyso)
         call imp_sorc (nxd, nzsptd, iszsorlb(1,isor),
     .                  ixzbegi(1,isor), ixzendi(1,isor), ixp1i,
     .                  ximpi(1,isor), wimpi(1,isor), impsori(1,isor),
     .                                               xcwi, syi, fnzysi)
      enddo
   
      return
      end
c----------------------------------------------------------------------c
      subroutine imp_sorc (nx, nzspt, iszsorlb, ixbeg, ixend, ixplus1,
     .                           ximp, wimp, impsor, xgrd, sy, fnzys)

c ... Calculate impurity-source profiles along a single wall for a set
c     of impurities.

c ... Common block:
            use Physical_constants2  ! qe2

c ... Local variables:
      implicit none

c ... Input arguments:
      integer nx               ! number of physical cells along wall
      integer nzspt            ! number of impurity species
      integer iszsorlb(nzspt)  ! =1 if origin for ximp is at left bndry
      integer ixbeg(nzspt)     ! beginning ix-index for wall
      integer ixend(nzspt)     ! ending ix-index for wall
      integer ixplus1(0:nx+1)  ! poloidal index of cell physically adjacent
                               ! to right face
      real ximp(nzspt)         ! centers of impurity-source profiles
      real wimp(nzspt)         ! widths of impurity-source profiles
      real impsor(nzspt)       ! impurity source strengths (Amps)
      real xgrd(0:nx+1)        ! cell locations
      real sy(0:nx+1)          ! surface areas of cells

c ... In-out argument:
      real fnzys(0:nx+1,nzspt)

      integer iz, ix
      real pi, sycos, xnot, arg

      pi = Pi

c ... Begin loop over impurity species.
      do iz = 1, nzspt

c ... Initialize normalization factor and center of profile
         sycos = 0.
         xnot = iszsorlb(iz)*ximp(iz)
     .            + (1-iszsorlb(iz))*(xgrd(ixend(iz))-ximp(iz))

c ... Calculate normalization factor
         ix = ixbeg(iz)
         do
            arg = (xgrd(ix) - xnot) * pi / (wimp(iz) + 1.e-20)
            if (abs(arg) .lt. pi/2.) sycos = sycos + cos(arg) * sy(ix)
            if (ix==ixend(iz)) exit
            ix = ixplus1(ix)
         enddo

c ... Add impurity-source profile to any previous contributions.
         ix = ixbeg(iz)
         do
            arg = (xgrd(ix) - xnot) * pi / (wimp(iz) + 1.e-20)
            if (abs(arg) .lt. pi/2. .and. sycos .gt. 0.) then
               fnzys(ix,iz) = fnzys(ix,iz) +
     .                 impsor(iz) * cos(arg) * sy(ix) / (sycos * qe2)
            endif
            if (ix==ixend(iz)) exit
            ix = ixplus1(ix)
         enddo

c ... End loop over impurity species.
      enddo
         
      return
      end

ccc      FUNCTION SECOND()
ccc       SECOND = 0.
ccc      return
ccc      end

      subroutine basfilex(name, namex)
c ... Basis uses this to expand special characters ($,~); here just set equal
      character*(*) name, namex
      namex = name
      return
      end

      subroutine glbwrlog(ioun)
      integer ioun
      return
      end
cc *********************************************************** cc
	function basopen(name,spec)
c
c                              basopen
c
	character*(*) name, spec
	integer basopen
        integer fd
	
c open a file as a read or write file, or see if you could.
	if(spec .eq. 'w') then
		call freeus(fd)
		open(unit=fd,file=name,err=400,status='new')
	elseif(spec .eq. 'r') then
		call freeus(fd)
		open(unit=fd,file=name,err=300,status = "old")
	else
		write (6,*) 'unknow spec for basopen'
                stop
	endif
        basopen = fd
        write (6,*) 'OPENING UNIT ', fd
	return
300     continue
        write (6,*) ('basopen: cannot open file:')
        stop
400     continue
        write (6,*) ('basopen: cannot create file:')
        stop
	end

cc ************************************************************* cc
	subroutine basclose(us)
        integer iotable(999)
        common/iotable/iotable
        
	integer us
	iotable(us) = 0
	close(unit=us,err=100)
        write (6,*) 'CLOSING UNIT ', us
	return
100 	write(6,200) us
200 	format('basclose: error in attempting to close unit ',i6,'.')
        stop
	end

cc ************************************************************* cc
        subroutine freeus(ius)
        integer iotable(999)
        common/iotable/iotable
        integer i,ius
        do i = 10, 500
           if(iotable(i) .eq. 0) then
              ius = i
              iotable(i) = 1
              if(i==500) iotable(501:999)=0
              return
           endif
        enddo
        do i = 501, 999
           if(iotable(i) .eq. 0) then
              ius = i
              iotable(i) = 1
              if(i==999) iotable(10:500)=0
              return
           endif
        enddo
c---haven't found an available unit
cSEK        write (6, *) "You have all 999 I/O units in use"
cSEK        stop
        end
      
cc ************************************************************* cc
        subroutine glbwrtim(unit,cpu,io,sys,mem)
        integer unit
        real cpu,io,sys,mem
        
        return
        end

#include "../mppl.h"
c     ------------------------------------------------------------------

      subroutine copyflx
      use Dimflxgrd 
      use Comflxgrd 
      use Curves 
      implicit none
      integer j,n

      do j=1,jdim
        npointg(j)=npoint(j)
        do n=1,npoint(j)
          xcurveg(n,j)=xcurve(n,j)
          ycurveg(n,j)=ycurve(n,j)
        enddo
      enddo

      return
      end

c     ------------------------------------------------------------------

      subroutine readflx
      use Share 	!nycore,nysol,igrid
      use Dimflxgrd 	!jdim,noregs,npts,nxefit,nyefit,nlim,nwork
      use Comflxgrd 
      use Aeqflxgrd 
      use Dimensions 
      use Curves 
      use Linkco 
      use Transfm 
      use Spline 
      use Transit 
      use System 
      use Mmod 
      use Argfc 
      implicit none
      integer iunit, ios
      external remark, kaboom, gallot, gchange
      external rdflx1, rdflx2, rdflx3

c **************** read the output of the flx package ******************

      data iunit /55/
      open (iunit, file='flx-grd', form='unformatted', iostat=ios,
     &      status='old')
      if (ios .ne. 0) then
         call remark("**** flx-grd file not found")
         call kaboom(0)
      endif

c     read dimensioning parameters and allot storage space for arrays --

      read(iunit) jdim,noregs,npts,nycore(igrid),nysol(igrid)
      read(iunit) jmin,jmax,jsptrx,jaxis
      call gallot("Dimensions",0)
      call gallot("Curves",0)
      call rdflx1(iunit)

      read(iunit) nxefit,nyefit
c     set length for 2-d spline workspace --
      nwork = nxefit*nyefit + 
     .         2*max(kxord*(nxefit+1),kyord*(nyefit+1))
      call gallot("Comflxgrd",0)
      call rdflx2(iunit)

      read(iunit) nlim
      call gchange("Comflxgrd",0)
      call rdflx3(iunit)

      read(iunit) eshot,etime,rseps,zseps,
     &             rvsin,zvsin,rvsout,zvsout

      read(iunit) xlbnd,xubnd,ylbnd,yubnd
      read(iunit) runid
      read(iunit) geometry

      close (iunit)

      call setidim    ! sets angle-like indices and dimensioning parameters
                      ! for Inmesh, Linkco and Mmod groups
      call gchange("Inmesh",0)
      call gallot("Linkco",0)
      call gallot("Transfm",0)
      call gallot("Spline",0)
      call gallot("Transit",0)
      call gallot("System",0)
      call gchange("Mmod",0)
c     Arrays for SLATEC spline routine FC --
      ndata=npts
      nbkpt=npts
      nwdim=8*npts+11	! >=5*(nbkpt-1)+2*max(ndata,nbkpt)+nbkpt+16
      niwdim=2*npts-6	! >=2*(nbkpt-3)
      call gchange("Argfc",0)

      return
      end

c     ------------------------------------------------------------------

      subroutine rdflx1(iunit)
      use Dimflxgrd 	!jdim,npts
      use Dimensions 
      use Curves 
      implicit none
      integer iunit

      read(iunit) npointg,xcurveg,ycurveg

      return
      end

c     ------------------------------------------------------------------

      subroutine rdflx2(iunit)
      use Dimflxgrd 	!nlim,nxefit,nyefit
      use Comflxgrd 
      use Dimensions 
      implicit none
      integer iunit

      read(iunit) xold,yold,fold
      read(iunit) fpol
      read(iunit) bcentr,rcentr,rmagx,zmagx,simagx,sibdry,
     &             rgrid1,xdim,zdim,zmid

      return
      end

c     ------------------------------------------------------------------

      subroutine rdflx3(iunit)
      use Dimflxgrd 	!nlim,nxefit,nyefit
      use Comflxgrd 
      use Dimensions 
      implicit none
      integer iunit

      read(iunit) xlim,ylim

      return
      end

c     ------------------------------------------------------------------

      subroutine readgridpars(fname, runid)
      use Share             ! geometry
      use Dim               ! nxm,nym
      use Xpoint_indices    ! ixlb,ixpt1,ixmdp,ixpt2,ixrb,iysptrx1,iysptrx2
      implicit none
      character*(*) fname, runid
      integer nuno,ios
      external freeus,remark,kaboom,gallot,rdgrid

c     Read mesh parameters from a UEDGE code grid data file

      call freeus (nuno)
      open (nuno, file=fname, form='formatted', iostat=ios,
     &      status='old')
      if (ios .ne. 0) then
         call remark("**** requested grid data file not found")
         call kaboom(0)
      endif

      if (geometry=="dnull" .or. geometry=="snowflake15" .or.
     .    geometry=="snowflake45" .or. geometry=="snowflake75" .or.
     .    geometry=="dnXtarget" .or. geometry=="isoleg") then
         read(nuno,1999) nxm,nym
         read(nuno,1999) iysptrx1(1),iysptrx2(1)
         read(nuno,1999) ixlb(1),ixpt1(1),ixmdp(1),ixpt2(1),ixrb(1)
         read(nuno,1999) iysptrx1(2),iysptrx2(2)
         read(nuno,1999) ixlb(2),ixpt1(2),ixmdp(2),ixpt2(2),ixrb(2)
	 if (geometry=="dnXtarget") nxc = ixmdp(1)
      else
         read(nuno,1999) nxm,nym,ixpt1(1),ixpt2(1),iysptrx1(1)
         ixlb(1)=0
         ixrb(1)=nxm
         iysptrx2(1)=iysptrx1(1)
      endif

      close (nuno)

 1999 format(5i4)

      return
      end

c     ------------------------------------------------------------------

      subroutine readgrid(fname, runid)
      use Share             ! geometry
      use Dim               ! nxm,nym
      use Xpoint_indices    ! ixlb,ixpt1,ixmdp,ixpt2,ixrb,iysptrx1,iysptrx2
      implicit none
      character*(*) fname, runid
      integer nuno,ios
      external freeus,remark,kaboom,gallot,rdgrid

c     Read a UEDGE code grid data file

      call freeus (nuno)
      open (nuno, file=fname, form='formatted', iostat=ios,
     &      status='old')
      if (ios .ne. 0) then
         call remark("**** requested grid data file not found")
         call kaboom(0)
      endif

      if (geometry=="dnull" .or. geometry=="snowflake15" .or.
     .    geometry=="snowflake45" .or. geometry=="snowflake75" .or.
     .    geometry=="dnXtarget" .or. geometry=="isoleg") then
         read(nuno,1999) nxm,nym
         read(nuno,1999) iysptrx1(1),iysptrx2(1)
         read(nuno,1999) ixlb(1),ixpt1(1),ixmdp(1),ixpt2(1),ixrb(1)
         read(nuno,1999) iysptrx1(2),iysptrx2(2)
         read(nuno,1999) ixlb(2),ixpt1(2),ixmdp(2),ixpt2(2),ixrb(2)
	 if (geometry=="dnXtarget") nxc = ixmdp(1)
      else
         read(nuno,1999) nxm,nym,ixpt1(1),ixpt2(1),iysptrx1(1)
         ixlb(1)=0
         ixrb(1)=nxm
         iysptrx2(1)=iysptrx1(1)
      endif
 1999 format(5i4)
      call gallot("RZ_grid_info",0)
      call rdgrid(nuno, runid)

      close (nuno)

      return
      end

c     ------------------------------------------------------------------

      subroutine rdgrid(nuno, runid)
      use Dim             ! nxm,nym
      use RZ_grid_info    ! rm,zm,psi,br,bz,bpol,bphi,b

      implicit none
      integer nuno
      character*(*) runid

      integer ix,iy,n

      read(nuno,2000)
      read(nuno,2001) (((rm(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((zm(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((psi(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((br(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((bz(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((bpol(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((bphi(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2000)
      read(nuno,2001) (((b(ix,iy,n),ix=0,nxm+1),iy=0,nym+1),n=0,4)
      read(nuno,2002) runid
 2000 format()
#if WORDSIZE == 64
 2001 format(1p3e23.15)
#else
 2001 format(1p3d23.15)
#endif
 2002 format(a60)

      return
      end

!----------------------------------------------------------------------!
 
      subroutine setidim
      use Dimflxgrd 	!jdim,npts,noregs
      use Dimensions 
      use Share          ! islimon
      use Linkco 
      use Inmesh 
      use Mmod 
      use Xmesh 
      implicit none
      integer region
      external gchange
 
c     Set angle-like parameters and allocate space for arrays --
 
      if ( (geometry .eq. "dnbot") .or. (geometry .eq. "dnull") .or.
     .     (geometry == "isoleg") .or. (islimon .ne. 0) ) then
         nxuse(1) = max(0,nxcore(igrid,1)-1)  ! nxcore includes guard cells
         nxuse(2) = nxcore(igrid,2) - 1       ! at the internal mesh boundaries
      else
         nxuse(1) = nxcore(igrid,1)           ! nxcore specifies the number
         nxuse(2) = nxcore(igrid,2)           ! of finite-size cells
      endif
 
c     Set some angle-surface parameters --
      idim=0
      do region=1,noregs
         ixpoint(1,region) = nxuse(region) + 1
         ixpoint(2,region) = ixpoint(1,region) + 1
         ixpoint(3,region) = ixpoint(2,region) + 1
         ilmax(region) = ixpoint(3,region) + nxleg(igrid,region)
         idim = max( idim, ilmax(region) )
      enddo
 
c     Allocate space for angle-dependent arrays --
         call gchange("Linkco",0)
         call gchange("Inmesh",0)
         call gchange("Mmod",0)
 
c     and for poloidal mesh distribution data --
         call gchange("Xmesh",0)

      return
      end

#include "../mppl.h"
#include "../sptodp.h"
#include "api.h"
!	SEE FMOMBAL SUBROUTINE FOR INPUT PARAMETER SPECIFICATIONS
	subroutine coulfric(amu,denz2,dloglam,mntau,zi,capm,capn,
     >	ela,elab,tempa)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real capm(KXA,miso,KXA,miso),denz2(miso),
     >		 capn(KXA,KXA,miso,miso),mntau(miso,miso),
     >		amu(miso),tempa(miso),
     >		ela(*),elab(*),zi(miso,nzch)
c
c	COMPUTES COULOMB COLLISION FRICTION TERMS
c	ELA AND ELAB, WHERE THE FRICTION FORCE IS
c
c	R sub (ALPHA,Z) sup (M) == FRICTION FOR SPECIES ALPHA,
c					   CHARGE STATE Z (M-th FORCE)
c
c	= ZI(ALPHA,Z)*[ SUM(K) { ELA(M,K,ALPHA)*U sub (ALPHA,Z) (K) }
c
c			  + LAMBDA(ALPHA,M) ]
c
c	LAMBDA(ALPHA,M) = SUM(BETA) SUM(K) [ ELAB(M,K,ALPHA,BETA) *
c
c				    U sub (ALPHA) sup(2) (K) ]
c
c	ELA(M,K,ALPHA) = SUM(BETA)[ <<MA NA/TAU-AB>> CAPM(M,K,ALPHA,BETA) ]
c
c	ELAB(M,K,ALPHA,BETA) = <<MA NA/TAU-AB>> CAPN(M,K,ALPHA,BETA)
c
c*****	Calculate M''s and N''s for each isotope.
	call neomn(amu,capm,capn,tempa)
c*****	Evaluate calculating n/tauab.
	const=(4.0/3.0/sqrt(pi0))*4.0*pi0*(coulom/(4.0*pi0*epsilo))**2
     >	*dloglam
	do 100 misa=1,miso
c*****	Thermal velocity-m/s (TEMP in Joules)
	  vtherm=sqrt(2.0*tempa(misa)/amu(misa)/promas)
	  dza = (denz2(misa)*coulom) * ( const
     >	     /(promas*amu(misa)*vtherm**3))
	  do 90 misb=1,miso
	    mntau(misa,misb) = dza * (denz2(misb)*coulom)
   90   continue	
  100 continue
c*****	Calculate la(=ela) and lab (=elab)
	call neolab(mntau,capm,capn,ela,elab)
	return
	end
c---- End of subroutine coulfric ---------------------------------------
c-----------------------------------------------------------------------
	subroutine fmombal(amu,den,dloglam,epar,friction,gradp,gradt,
     >	nuion,nurec,qcond,qneut,ucond,uneut,umass,
     >	parcurrent,tempa,natomic,misotope,nchstate,ldir,fricc)
              use Reduced_ion_constants 
	      use Reduced_ion_variables 
              use Timing    ! istimingon,ttimpc
  	implicit real (a-h,o-z), integer (i-n)
        real(kind=4):: sec4, gettime, tsval
	real amu(misotope), den(misotope*(nchstate+1)),
     >	gradp(misotope*nchstate), gradt(misotope*nchstate),
     >	nurec(misotope*nchstate), nuion(misotope*(nchstate+1)),
     >	tempa(misotope), qcond(*),
     >	friction(*), ucond(*), uneut(*), qneut(*), fricc(*)
	real amat(KXA*(MXMISO1)*KXA*(MXMISO1)), denz2(MXMISO),
     >	caplams(KXA*MXMISO), uresp(NBA*KMXZ), usave(KXA*MXNZCH*MXMISO)
	integer natomic(misotope)
        integer ndima
	save uresp, usave, caplams
!
!	****	DESCRIPTION OF INPUT VARIABLES	****
!
!
!	ALL PHYSICAL QUANTITIES ARE IN MKS UNITS, INCLUDING
!	TEMPERATURE IN JOULES (1 eV = 1.6022E-19 Joule)
!	DENSITY IN 1/METERS**3
!	ELECTRIC FIELD IN VOLTS/METER
!	VELOCITY IN METERS/SEC
!	HEAT FLUX IN JOULE/(METER**2 - SEC)
!
!	INTEGERS:
!
!	  MISOTOPE
!		NUMBER OF DISTINCT ISOTOPES (DIFFERENT MASSES).
!		THE ORDERING OF ALL ARRAYS A(ISO) BELOW MUST BE AS FOLLOWS:
!		FIRST ISOTOPE (ISO=1) <==> ELECTRONS
!		SUBSEQUENT ISOTOPES (2 <= ISO <= MISOTOPE)
!
!	  NATOMIC(1:MISOTOPE)
!		FOR IONS, THE NUCLEAR CHARGE OF ISOTOPE (ISO). FOR ELECTRONS,
!		NATOMIC(1) == 1.
!
!	  NCHSTATE
!		THE MAXIMUM OF NATOMIC(ISO) OVER ALL MISOTOPE ISOTOPES
!
!	  LDIR
!		IF LDIR >= 2, THEN A COMPLETE (NEW) MATRIX INVERSION
!		IS DONE TO COMPUTE THE FLOWS. FOR LDIR < 2, AN INCREMENTAL
!		MATRIX INVERSION IS DONE, BASED ON A PREVIOUS CALL TO
!		FMOMBAL WITH LDIR >= 2. THIS SAVES CPU TIME AND IS USEFUL
!		WHEN SMALL VARIABLE PERTURBATIONS
!		ARE MADE TO COMPUTE THE NUMERICAL JACOBIAN.
!
!
!	REAL VARIABLES:
!
!	  AMU(1:MISOTOPE)
!		ATOMIC MASS OF ISOTOPE (ISO), RELATIVE TO THE PROTON MASS.
!		FOR EXAMPLE, AMU(1) = 5.45E-4.
!
!	  DEN(1:MISOTOPE,0:NCHSTATE)	[1/M**3]
!		DEN(ISO,NZ) IS THE DENSITY OF THE ISOTOPE
!		(ISO) AND CHARGE STATE (NZ). NOTE THAT NZ=0 CORRESPONDS
!		TO THE NEUTRAL DENSITY (NEEDED FOR ATOMIC PHYSICS), AND
!		NZ = NATOM(ISO) TO THE FULLY STRIPPED ION. DEN
!		SHOULD BE PRESCRIBED AT THE SAME SPATIAL GRID POINT
!		REQUIRED FOR THE VELOCITIES AND HEAT FLUXES.
!
!	  DLOGLAM
!		LOG(LAMBDA) REQUIRED FOR THE COULOMB COLLISION RATE
!
!	  EPAR		[VOLTS/METER]
!		PARALLEL ELECTRIC FIELD (INPUT)
!
!	  FRICTION(1:MISOTOPE,1:NCHSTATE)		[JOULES/METER**4]
!		FRICTION(ISO,NZ) IS THE PARALLEL COMPONENT OF
!		THE FRICTION FORCE (COULOMB+ATOMIC COLLISIONS)
!		FOR ISOTOPE ISO, CHARGE STATE NZ (NOT INCLUDING NEUTRALS)
!
!         FRICC(1:MISOPTE,1:NCHSTATE,1:4)                [JOULES/METER**4]
!               COMPONENTS OF FRICTION WITH 
!               FRICC(,,1) = ela(1,)*usol(1,,) for velocity
!               FRICC(,,2) = ela(2,)*usol(2,,) for qcond
!               FRICC(,,3) = ela(3,)*usol(3,,) for h
!               FRICC(,,4) = caplam ? same for all isotope charge states
!               FRICC(,,5) = ioniz and recomb totals
!
!	  GRADP,GRADT(1:MISOTOPE,1:NCHSTATE)		[JOULES/METER**4]
!		GRADP,GRADT(ISO,NZ) IS THE PARALLEL COMPONENT OF
!		THE PRESSURE(TEMPERATURE) GRADIENT,
!
!		GRADP,T  =  B dot Grad (P,T) / |B|
!
!		EVALUATED AT THE SAME SPATIAL GRID POINT WHERE THE
!		PARALLEL SPEEDS AND HEAT FLUXES ARE TO BE COMPUTED, OF
!		CHARGE STATE NZ OF ISOTOPE ISO. NEUTRAL GRADIENTS
!		ARE NOT INCLUDED HERE
!
!	  NUION(1:MISOTOPE,0:NCHSTATE)	[1/SEC]
!		NUION(ISO,NZ) IS THE IONIZATION RATE (DUE TO
!		ELECTRON IMPACT) FOR ISOTOPE ISO, STATE NZ, FOR NZ = 0
!		TO NZ = NATOM(ISO)-1
!
!	  NUREC(1:MISOTOPE,1:NCHSTATE)	[1/SEC]
!		NUREC(ISO,NZ) IS THE RECOMBINATION RATE (DUE TO
!		ELECTRON IMPACT) FOR ISOTOPE ISO, STATE NZ, FOR NZ = 1
!		TO NZ = NATOM(ISO)
!
!	  PARCURRENT			[A/METER**2]
!		PARALLEL CURRENT AT PRESENT GRID POINT (OUTPUT, COMPUTED FROM OHMS LAW)
!
!	  QCOND(1:MISOTOPE,1:NCHSTATE)	[JOULE/(METER**2-SEC)]
!		QCOND(ISO,NZ) IS THE PARALLEL RANDOM HEAT FLUX FOR CHARGE
!		STATE NZ OF ISOTOPE ISO IN RESPONSE TO THE ELECTRIC
!		AND PRESSURE FORCES. (NEUTRALS NOT INCLUDED HERE)
!		THIS, TOGETHER WITH UCOND AND EPAR, COMPRISES THE
!		OUTPUT FROM THIS CALCULATION
!
!	  UCOND(1:MISOTOPE,1:NCHSTATE)	[METER/SEC]
!		PARALLEL FLOW SPEED (ABSOLUTE, NOT RELATIVE TO UMASS)
!		OF EACH CHARGE STATE FOR EACH ISOTOPE (NOT
!		INCLUDING NEUTRALS)
!
!	  QNEUT(1:MISOTOPE), UNEUT(1:MISOTOPE)
!		HEAT FLUX AND PARALLEL FLOW SPEED OF NEUTRAL
!		SPECIES FOR EACH ISOTOPE. IF QNEUT UNKNOWN, USE 0 FOR NOW
!
!	  TEMPA(1:MISOTOPE)		[JOULES]
!		TEMPA(ISO) IS THE TEMPERATURE AT GRID POINT
!		FOR ISOTOPE ISO
!
!	  UMASS		[METERS/SEC]
!		THE (EXTERNALLY PROVIDED) MEAN MASS FLOW ALONG
!		MAGNETIC FIELD LINES, WHICH IS THE SUM OVER ALL
!		IONIZED SPECIES (AND ELECTRONS) OF THE INDIVIDUAL
!		MASS-DENSITY WEIGHTED FLOWS:
!
!		UMASS = SUM ( MASS*DENSITY*U|| )
! 		        ________________________
!		        SUM ( MASS*DENSITY )
!
!		THE EQUATION FOR EVOLVING UMASS IN TIME IS OBTAINED
!		BY SUMMING THE INDIVIDUAL MOMENTUM EQUATIONS FOR ALL
!		IONS. THIS SUMMATION ANNIHILATES THE DOMINANT COULOMB
!		FRICTION TERMS AND INCLUDES RESIDUAL COLLISIONAL
!		COUPLING (DUE TO ATOMIC PHYSICS) TO THE NEUTRALS
!		POPULATION (THROUGH UNEUT,QNEUT).
!

c ... Start timing impurity calculations.
      if (istimingon .eq. 1 .and. misotope .gt. 1) tsval = gettime(sec4)

c ... Initialize amat array.
        ndima=KXA*(MXMISO1)*KXA*(MXMISO1)
        do i=1,ndima
          amat(i)=zero
        enddo

c****	Setup zi, mass-density, Z*e*density arrays
	call setden(amu,den,denmass,denz,denz2,zi)

c****	Setup force arrays (gradp, gradt stuff)
	call setforce(den,denz,denmass,epar,gradp,gradt,
     >	tempa,uneut,qneut,umass,fmomenta,nuion)

c*****	Compute Coulomb friction coefficients la, lab
	call coulfric(amu,denz2,dloglam,mntau,zi,capm,capn,
     >	ela,elab,tempa)

c*****	Compute response matrices for inversion of momentum equations
c*****	in charge-state space
	call zrespond(den,denmass,zi,ela,nuion,nurec,uresp,
     >	usave,caplams,fmomenta,ldir)

c*****	Solve average-ion equations in mass-isotope space
	call mrespond(elab,zi,den,denmass,uresp,sbar,
     >	KXA*(miso+1),amat,nurec,umass,ldir)

c*****	Compute individual ion flows (for all charge states)
c
c	NOTE: USOL(m=1,Z,mass) = PARTICLE FLOW RELATIVE TO UMASS
c	
c	      USOL(m=2,Z,mass) = -(2/5)*CONDUCTIVE HEAT FLUX / PRESSURE
c
c	      USOL(m=3,Z,mass) = HIGHER-ORDER FLOW (H)
c
	call mzrespond(elab,uresp,sbar,caplam,caplams,usol,
     >	usave,den,denz,parcurrent,qcond,ucond,tempa,umass,ldir)
c
c	COMPUTE FRICTION FORCES
c	
	call getfrict(friction,fricc,caplam,denmass,ela,nuion,
     .  nurec,usol,zi)

c ... End timing impurity calculations.
        if (istimingon .eq. 1 .and. misotope .gt. 1)
     .     ttimpc = ttimpc + gettime(sec4) - tsval

	return
	end
c---- End of subroutine fmombal ----------------------------------------
c-----------------------------------------------------------------------
	subroutine getfrict(friction,fricc,caplam,denmass,ela,
     >	nuion,nurec,usol,zi)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real friction(miso,nzch), usol(KXA,nzch,miso), 
     .       fricc(miso,nzch,5)
	real nuion(miso,0:nzch), nurec(miso,nzch)
	real denmass(miso,0:nzch), caplam(KXA,miso),
     >	ela(3,3,miso), zi(miso,nzch)
	m = 1		!ONLY FRICTION FORCE
	do misa = 1,miso
	nzmax = natom(misa)
	  do nz = 1,nzmax
	  friction(misa,nz) =
     >	  zi(misa,nz) * ( ela(m,1,misa)*usol(1,nz,misa)
     >	  + ela(m,2,misa)*usol(2,nz,misa)
     >	  + ela(m,3,misa)*usol(3,nz,misa) + caplam(m,misa) )
            fricc(misa,nz,1) = zi(misa,nz)*ela(m,1,misa)*usol(1,nz,misa)
            fricc(misa,nz,2) = zi(misa,nz)*ela(m,2,misa)*usol(2,nz,misa)
            fricc(misa,nz,3) = zi(misa,nz)*ela(m,3,misa)*usol(3,nz,misa)
            fricc(misa,nz,4) = zi(misa,nz)*caplam(m,misa)
	  friction(misa,nz) = friction(misa,nz)
     >	  - denmass(misa,nz)*usol(m,nz,misa)*
     >	  (nuion(misa,nz) + nurec(misa,nz))*al32(m)
            fricc(misa,nz,5) = - denmass(misa,nz)*usol(m,nz,misa)*
     >	    (nuion(misa,nz) + nurec(misa,nz))*al32(m)
	  if( nz.gt.1 )
     >	  friction(misa,nz) = friction(misa,nz) + usol(m,nz-1,misa)
     >	  *denmass(misa,nz-1) * nuion(misa,nz-1) * al32(m)
            fricc(misa,nz,5) = fricc(misa,nz,5) + usol(m,nz-1,misa)
     >	    *denmass(misa,nz-1) * nuion(misa,nz-1) * al32(m)
	  if( nz.lt.nzmax )
     >	  friction(misa,nz) = friction(misa,nz) + usol(m,nz+1,misa)
     >	  *denmass(misa,nz+1) * nurec(misa,nz+1) * al32(m)
            fricc(misa,nz,5) = fricc(misa,nz,5) + usol(m,nz+1,misa)
     >	    *denmass(misa,nz+1) * nurec(misa,nz+1) * al32(m)
	  enddo
	enddo
	return
	end
c---- End of subroutine getfrict ---------------------------------------
c-----------------------------------------------------------------------
	subroutine inicon
c*****	******************************************************************
c*****	INICON loads the common block containing physical constants and  *
c*****	conversion constants.                                           *
c*****	Last Revision:12/85 W.A.Houlberg and S.E.Attenberger ORNL.       *
c*****	******************************************************************
	      use Reduced_ion_constants 
c****	Constants
	
  	implicit real (a-h,o-z), integer (i-n)
c*****	Physical constants.
c*****	Elementary charge - (coulomb).
	coulom=1.6022e-19
c*****	Permittivity of free space - (farad/meter).
	epsilo=8.8419e-12
c*****	Proton mass - (kilogram).
	promas=1.6726e-27
c*****	Unit conversions.
c*****	Joules per keV.
	xj7kv=1.6022e-16
	one = 1.0e0
c*****	Calculate pi0 for greatest accuracy.
	pi0=acos(-one)
c*****	Set zero for initializing arrays.
	zero=0.e0
c*****	Integer constants
	ilam1 = 1
	ilam2 = 2
	ilam3 = 3
	iacci = 4
	iforc = 5
	al32(1) = 1.
	al32(2) = 5./2.
	al32(3) = 35./8.
	return
	end
c---- End of subroutine inicon -----------------------------------------
c-----------------------------------------------------------------------
        subroutine initmombal(misotope,natomic,nchstate)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	integer natomic(misotope)

	mise = 1		!Electrons MUST be 1st element

c****	Load common block elements
	miso = misotope
	nzch = nchstate
	if( miso.gt.MXMISO ) call xerrab('MISO > MXMISO')
	if( nzch.gt.MXNZCH ) call xerrab('NZCH > MXNZCH')
	do misa = 1,miso
	   natom(misa) = natomic(misa)
        enddo

	return
	end
c---- End of subroutine initmombal -------------------------------------
c-----------------------------------------------------------------------
	subroutine mrespond(elab,zi,den,denmass,uresp,sbar,
     >	nmat,amat,nurec,umass,ldir)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
        integer nmat
	real elab(KXA,miso,KXA*miso),uresp(KXA,nzch,miso,NBA),
     >	sbar(KXA,miso+1), sbar0(KXA*(MXMISO1)), ubar0(KXA*(MXMISO1)),
     >	zi(miso,*),amat(nmat,nmat),denmass(miso,0:nzch)
	real den(miso,0:nzch), nurec(miso,nzch)
	real usum(MXNZCH), bmat(KXA*(MXMISO1)*KXA*(MXMISO1))
	integer nrow(KXA*(MXMISO1)), z1
        integer i, j
	save nrow, bmat, sbar0, ubar0
	macc = miso+1	!Space for acci = acceleration force
	mflow = 1	!Flow
	z1 = 1
	fanorm = one / (totmass * anorm)	!Norm for AI force
c
c	COMPUTE ZI,DENMASS-WEIGHTED AVERAGES OF RESPONSE FUNCTIONS
c	AND FORM INTER-ISOTOPIC COUPLING MATRIX
c	NOTE: FOR MISA = 1 (ELECTRONS), M = 1 (FLOW), REPLACE
c	WITH NO NET FLOW CONDITION SUM M(ALPHA)*DEN(ALPHA,Z)U(ALPHA,Z) = 0
c	TO AVOID SINGULAR MATRIX (IN REF. FRAME OF MASS FLOW)
c
c	AUGMENT (FOR MISA=MACC, K=1) SYSTEM WITH EQUATIONS FOR MEAN
c	ACCELERATION TERM AI [=ubar(1,macc)]
c
c	RHO*AI + SUM( M N NUrec U(1,Z=1,alpha) ) = NEUTRAL SOURCE
c	AND U(1,1,alpha) MUST BE EXPRESSED IN TERMS OF AI, UBAR
c
c	JPAR = SUM( DENZ * U(1,Z,alpha) )
c
c
c	NOTE THAT U(m,Z,alpha) = -BIGLAM(m,Z,alpha;mp,beta)*ubar(mp,beta)
c	WHERE BIGLAM = SUM(over kp) elab(kp,alpha,mp,beta)*uresp(m,Z,alpha;kp)
c
        j = KXA*(macc-1)
	do mmisb = 1,nmat
	  amat(mflow,mmisb) = zero   ! electron "isotope"
	  amat(1+j,mmisb) = zero
	  amat(2+j,mmisb) = zero
	  amat(3+j,mmisb) = zero
	enddo
	sbar(mflow,mise) = zero
	sbar(mflow,macc) = sumforce  * fanorm
	sbar(2,macc) = zero
	sbar(3,macc) = zero
	amat(1+j,1+j) = one   	!totmass*anorm * fanorm
	amat(2+j,2+j) = one	!NOT USED FOR ANYTHING PHYSICAL
	amat(3+j,3+j) = one	!NOT USED FOR ANYTHING PHYSICAL
	do 10 misa = 1,miso
	  nz = natom(misa)
	  dnur1 = (fanorm*denmass(misa,z1))*nurec(misa,z1)
c
c	COMPUTE ACCELERATION SOURCE, MATRIX ELEMENTS
c
	  sbar(1,macc) = sbar(1,macc) - dnur1*
     >	  uresp(mflow,z1,misa,iforc)
	  amat(1+j,1+j) = amat(1+j,1+j) + dnur1*
     >	  uresp(mflow,z1,misa,iacci)
	  do nzsum = 1,nz
c
c     	REPLACE ELECTRON MOMENTUM WITH NO NET FLOW CONDITION
c     	(IN REFERENCE FRAME MOVING WITH MASS FLOW)
c
	    rhomass = denmass(misa,nzsum)/totmass
	    sbar(mflow,mise) = sbar(mflow,mise) +
     >	    rhomass*uresp(mflow,nzsum,misa,iforc)
	    amat(mflow,1+j) = amat(mflow,1+j) -
     >	    rhomass*uresp(mflow,nzsum,misa,iacci)
	  enddo
          i = KXA*(misa-1)
	  do 10 m = 1,KXA
	    if( (misa.ne.mise) .or. (m.ne.mflow) )then
	      sbar(m,misa) =
     >	      sdot(nz,zi(misa,1),miso,uresp(m,z1,misa,iforc),KXA)
	      amat(m+i,1+j) =
     >	      -sdot(nz,zi(misa,1),miso,uresp(m,z1,misa,iacci),KXA)
	    endif
	  do 10 mpmisb = 1,KXA*miso
	    do nzb = 1,nz
	    usum(nzb) = uresp(m,nzb,misa,ilam1)*elab(ilam1,misa,mpmisb)
     >	              + uresp(m,nzb,misa,ilam2)*elab(ilam2,misa,mpmisb)
     >	              + uresp(m,nzb,misa,ilam3)*elab(ilam3,misa,mpmisb)
	    enddo
	    if( (misa.ne.mise) .or. (m.ne.mflow) )
     >	    amat(m+i,mpmisb) = sdot(nz,zi(misa,z1),miso,usum,1)
c
c	PERFORM SUMS OVER MISA (ISOTOPE MASS A)
c
	    if( m.eq.mflow )then
	      amat(1+j,mpmisb) = amat(1+j,mpmisb)
     >	      - dnur1*usum(z1)
	      do nzsum = 1,nz
	        amat(mflow,mpmisb) = amat(mflow,mpmisb)
     >	        + (denmass(misa,nzsum)/totmass)*usum(nzsum)
	      enddo
	    endif
 10	continue
c
c	ADD DIAGONAL ELEMENTS
c
	mmin = 1		!Ignore electron momentum balance here
	do 20 mmisa = mmin+1,KXA*miso
	  amat(mmisa,mmisa) = amat(mmisa,mmisa) + one
 20	continue
c
c	INVERT MATRIX TO OBTAIN REDUCED FLOWS
c
	if( ldir.gt.1 )then
	  call sgefa(amat,nmat,nmat,nrow,info)
	  nmat2 = nmat*nmat
	  call dcopy(nmat2,amat,1,bmat,1)
	  call dcopy(nmat,sbar,1,sbar0,1)
	  if( info.ne.0 )then
	    call xerrab('mrespond:  Condition No. = 0 in Solver')
	  endif
	else
	  do i = 1,nmat
	  sbar(i,1) = sbar(i,1) + sbar0(i) -
     >	      sdot(nmat,amat(i,1),nmat,ubar0,1)
	  enddo
	endif
        call sgesl(bmat,nmat,nmat,nrow,sbar,0)
	if( ldir.gt.1 )call dcopy(nmat,sbar,1,ubar0,1)
	return
	end
c---- End of subroutine mrespond ---------------------------------------
c-----------------------------------------------------------------------
	subroutine mzrespond(elab,uresp,ubar,caplam,caplams,usol,
     >	usave,den,denz,parcurrent,qcond,ucond,tempa,umass,ldir)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real elab(KXA*miso,KXA*miso),uresp(KXA*nzch,miso,NBA),
     >	ubar(KXA,miso+1), usol(KXA*nzch,miso), denz(miso,nzch),
     >	den(miso,0:nzch), qcond(miso,nzch), ucond(miso,nzch)
	real caplam(KXA,miso), caplams(KXA*miso), usave(*), tempa(miso)
	integer m,misa
	acci1 = ubar(1,miso+1)
	parcurrent = zero
	uscale = one	!/csnorm
	qscale = one	!/(csnorm * tempnorm * dennorm)
	mtotal = KXA*miso
	do mmisa = 1,mtotal
          misa = 1 + (mmisa-1)/KXA
          m = mmisa - (misa-1)*KXA
	  caplam(m,misa) =
     >	  sdot(mtotal,ubar,1,elab(mmisa,1),mtotal)
	enddo
	
	do misa = 1,miso
	  do knz = 1,KXA*natom(misa)
	    usol(knz,misa) = uresp(knz,misa,iforc)
     >  	- uresp(knz,misa,1)*caplam(1,misa)
     >  	- uresp(knz,misa,2)*caplam(2,misa)
     >  	- uresp(knz,misa,3)*caplam(3,misa)
     >  	+ uresp(knz,misa,iacci)*acci1
	  enddo
c
c	CONVERT BACK TO ABSOLUTE (NOT RELATIVE TO UMASS) FLOW
c	CONVERT TO RANDOM HEAT FLUX (MULT BY -2.5) FOR K=2
c	AND STORE NORMED FORM FOR EXTERNAL USE
c
	  k1 = 1
	  do nz = 1,natom(misa)
	    k2 = k1+1
	    ucond(misa,nz) = (usol(k1,misa) + umass) * uscale
	    qcond(misa,nz) = -2.5*usol(k2,misa)*den(misa,nz)
     >	                *tempa(misa) * qscale
	    parcurrent = parcurrent + denz(misa,nz)*ucond(misa,nz)
	    k1 = k1 + KXA
	  enddo
	enddo
c
c	STORE SOLUTION FOR INCREMENTAL MODE
c
	if( ldir.gt.1 )then
	mtot2 = mtotal*nzch
	call dcopy(mtot2,usol,1,usave,1)
	call dcopy(mtotal,caplam,1,caplams,1)
	acci0 = acci1
	endif
	return
	end
c---- End of subroutine mzrespond --------------------------------------
c-----------------------------------------------------------------------
      subroutine neolab(mntau,capm,capn,ela,elab)
c*****	******************************************************************
c*****	NEOLAB calculates the neoclassical friction coefficients.        *
c*****	References:                                                      *
c*****	Hirshman, Sigmar, Nucl Fusion 21 (1981) 1079 (H&S).              *
c*****	Last Revision: 5/94 W.A.Houlberg and S.P.Hirshman ORNL.          *
c*****	Input:                                                           *
c*****	miso-number of isotopes.                                         *
c*****	mntau(misb)-ma<<na/tauab>>-kg/m**3/s.                           *
c*****	     -Eqn 5.25 of H&S.                                    *
c*****	capm(3,miso,3,miso)-matrix of test particle elements.            *
c*****	capn(3,miso,3,miso)-matrix of field particle elements.           *
c*****	Output:                                                          *
c*****	ela(3,3,misa)-test particle component-kg/m**3/s.                 *
c*****	elab(3,misa,3,misb)-field particle component-kg/m**3/s.           *
c*****	******************************************************************
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
      real      mntau(miso,miso)
      real      ela(KXA,KXA,miso), elab(KXA,miso,KXA,miso)
      real      capm(KXA,miso,KXA,miso), capn(KXA,miso,KXA,miso)

c ... Initialize ela array.
      do i=1,KXA
        do j=1,KXA
          do k=1,miso
            ela(i,j,k)=zero
          enddo
        enddo
      enddo

      do 40 misb=1,miso
        do 30 misa=1,miso
          do 20 k=1,KXA
	    do 10 j=1,KXA
c*****	Sum over isotopes misb for test particle component.
              ela(j,k,misa)=ela(j,k,misa)
     >                  +mntau(misa,misb)*capm(j,misa,k,misb)
c*****	Field particle component.
              elab(j,misa,k,misb)=mntau(misa,misb)*capn(j,misa,k,misb)
 10	      continue
 20	    continue
 30	  continue
 40	continue
      return
      end
c---- End of subroutine neolab -----------------------------------------
c-----------------------------------------------------------------------
      subroutine neomn(amu,capm,capn,tempa)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
c*****	******************************************************************
c*****	NEOMN calculates the test particle (M) and field particle (N)    *
c*****	matrix elements of the collision operator using the Laguerre    *
c*****	polynomials of order 3/2 as basis functions for each isotopic   *
c*****	species combination.                                            *
c*****	References:                                                      *
c*****	Hirshman, Sigmar, Nucl Fusion 21 (1981) 1079 (H&S).              *
c*****	Hirshman, Phys Fluids 20 (1977) 589.                             *
c*****	Last Revision: 3/94 W.A.Houlberg and S.E.Attenberger ORNL.       *
c*****	Input:                                                           *
c*****	miso-number of isotopes.                                         *
c*****	amu(miso)-atomic mass of isotopes-arbitrary.                     *
c*****	tempa(miso)-temperature of isotopes-arbitrary.                      *
c*****	Output:                                                          *
c*****	capm(3,miso,3,miso)-matrix of test particle elements.            *
c*****	capn(3,miso,3,miso)-matrix of field particle elements.           *
c*****	Comments:                                                        *
c*****	The indices on the matrices are one greater than the notation in *
c*****	the review article so as to avoid 0 as an index.                *
c*****	******************************************************************
      real      capm(KXA,miso,KXA,miso),  capn(KXA,miso,KXA,miso)
	real amu(miso), tempa(miso)
c*****	Loop over isotope a.
      do 20 misa=1,miso
c*****	Loop over isotope b.
        do 10 misb=1,miso
c*****	Ratio of masses.
          xmab=amu(misa)/amu(misb)
c*****	Ratio of temperatures.
          xtab=tempa(misa)/tempa(misb)
c*****	Ratio of thermal velocities, vtb/vta.
          xab=sqrt(xmab/xtab)
c*****	Elements of M.
          xab2=xab**2
          yab32=(one+xab2)*sqrt(one+xab2)
          yab52=(one+xab2)*yab32
          yab72=(one+xab2)*yab52
          yab92=(one+xab2)*yab72
c*****	Eqn 4.11 for M00 H&S.
          capm(1,misa,1,misb)=-(one+xmab)/yab32
c*****	Eqn 4.12 for M01 H&S.
          capm(1,misa,2,misb)=-(3.0/2.0)*(one+xmab)/yab52
c*****	Eqn 4.15 for M02 H&S.
          capm(1,misa,3,misb)=-(15.0/8.0)*(one+xmab)/yab72
c*****	Eqn 4.8 for M10 H&S.
          capm(2,misa,1,misb)=capm(1,misa,2,misb)
c*****	Eqn 4.13 for M11 H&S.
          capm(2,misa,2,misb)=-(13.0/4.0+4.0*xab2+(15.0/2.0)*xab2**2)
     >                         /yab52
c*****	Eqn 4.16 for M12 H&S.
          capm(2,misa,3,misb)=-(69.0/16.0+6.0*xab2+(63.0/4.0)*xab2**2)
     >                         /yab72
c*****	Eqn 4.8 for M20 H&S.
          capm(3,misa,1,misb)=capm(1,misa,3,misb)
c*****	Eqn 4.8 for M21 H&S.
          capm(3,misa,2,misb)=capm(2,misa,3,misb)
c*****	Eqn 5.21 for M22 H&S.
          capm(3,misa,3,misb)=-(433.0/64.0+17.0*xab2+(459.0/8.0)*xab2**2
     >                        +28.0*xab2**3+(175.0/8.0)*xab2**4)/yab92
c*****	Elements of N.
c*****	Momentum conservation, Eqn 4.11 for N00 H&S.
          capn(1,misa,1,misb)=-capm(1,misa,1,misb)
c*****	Eqn 4.9 and 4.12 for N01 H&S.
          capn(1,misa,2,misb)=-xab2*capm(1,misa,2,misb)
c*****	Eqn 4.15 for N02 H&S - corrected by multiplying rhs by (Ta/Tb)
          capn(1,misa,3,misb)=-xab2**2*capm(1,misa,3,misb)
c*****	Momentum conservation, Eqn 4.12 for N10 H&S.
          capn(2,misa,1,misb)=-capm(2,misa,1,misb)
c*****	Eqn 4.14 for N11 H&S.
          capn(2,misa,2,misb)=(27.0/4.0)*xtab*xab2/yab52
c*****	Eqn 4.17 for N12 H&S.
          capn(2,misa,3,misb)=(225.0/16.0)*xtab*xab2**2/yab72
c*****	Momentum conservation for N20.
          capn(3,misa,1,misb)=-capm(3,misa,1,misb)
c*****	Eqn 4.9 and 4.17 for N21 H&S.
          capn(3,misa,2,misb)=(225.0/16.0)*xab2/yab72
c*****	Eqn 5.22 for N22 H&S.
          capn(3,misa,3,misb)=(2625.0/64.0)*xtab*xab2**2/yab92
   10   continue
   20 continue
      return
      end
c---- End of subroutine neomn ------------------------------------------
c-----------------------------------------------------------------------
	subroutine printit(amu,den,epar,zi,ela,
     >  caplam,sbar,usol,fmom,denmass,nuion,nurec,
     >	gradp,gradt,parcurrent,xirl,tempa,uneut,umass)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real sbar(KXA,miso+1), usol(KXA,nzch,miso)
	real den(miso,0:nzch), caplam(KXA,miso)
	real denmass(miso,0:nzch)
	real nuion(miso,0:nzch), nurec(miso,nzch),
     >	gradp(miso,*), gradt(miso,*), ela(3,3,miso),
     >	       zi(miso,nzch), fmom(KXA,nzch,miso), amu(miso),
     >	       tempa(miso), uneut(miso)
	
c*****	Print out average-ion quantities
	write(*,490)xirl,umass
 490	format(' XI(IGRID) = ',1pe10.3,' UMASS = ',1pe10.3,/,
     >	' NOTE: RESULTS ARE PHYSICALLY VALID IF |UBAR| < VTHERM AND',
     >	' |QBAR/P| < VTHERM')
	acci = acci0*anorm
	sumflow = 0.
	sumaflow= 0.
	do 55 misa = 1,miso
	  vtherm=sqrt(2.0*tempa(misa)/amu(misa)/promas)
	do 55 m = 1,2		!Only look at flow, heat flow
	if( m.eq.1 )then
	write(*,500)m,amu(misa),sbar(m,misa),
     >	1000.*tempa(misa)/xj7kv,vtherm,caplam(m,misa)
	  write(*,510)
	  if( misa.ne.1 )
     >	  write(*,520)0,uneut(misa),den(misa,0),nuion(misa,0)
	else if(m.eq.2)then
	  write(*,505)m,amu(misa),sbar(m,misa)
	  write(*,530)
	endif
	nzmax = natom(misa)
	do 55 nz = 1,nzmax
	force = fmom(m,nz,misa)
	friction = zi(misa,nz) * ( ela(m,1,misa)*usol(1,nz,misa)
     >	+ ela(m,2,misa)*usol(2,nz,misa)
     >	+ ela(m,3,misa)*usol(3,nz,misa) + caplam(m,misa) )
	friction = friction - denmass(misa,nz)*usol(m,nz,misa)*
     >	(nuion(misa,nz) + nurec(misa,nz))*al32(m)
	if( nz.gt.1 )friction = friction + usol(m,nz-1,misa)
     >	*denmass(misa,nz-1) * nuion(misa,nz-1) * al32(m)
	if( nz.lt.nzmax )friction = friction + usol(m,nz+1,misa)
     >	*denmass(misa,nz+1) * nurec(misa,nz+1) * al32(m)
	if( m.eq.1 )then
	  force = force + denmass(misa,nz)*acci
	  sumflow = sumflow + denmass(misa,nz)*usol(1,nz,misa)
	  sumaflow= sumaflow+ denmass(misa,nz)*abs(usol(1,nz,misa))
	  write(*,550)nz,usol(m,nz,misa),force,friction,
     >	  den(misa,nz),zi(misa,nz),nuion(misa,nz),nurec(misa,nz)
	else if( m.eq.2 )then
	  pres = den(misa,nz)*tempa(misa)
	  write(*,550)nz,-2.5*usol(m,nz,misa)*pres,
     >	  force,friction,gradp(misa,nz),den(misa,nz)*gradt(misa,nz)
	endif
 55	continue
	sumaflow = max(sumaflow,totmass*abs(umass))
 500	format(/' UBAR (m=',i1,', mass=',1pe9.2,') = ',1pe10.3,
     >	' (m/sec)  TEMP = ',1pe10.3,' (eV)  VTHERM = ',1pe10.3,
     >	' (m/sec)','  LAMBDA =',1pe10.3)
 505	format(/' QBAR/P(m=',i1,', mass=',1pe9.2,') = ',1pe10.3,
     >	' (m/sec)')
 510	format('  Z  U||-UMASS',
     >	'     FORCE    FRICTION',
     >	'       DEN         ZI     NU-ION     NU-REC')
 520	format(i3,1pe11.3,2(11x),1pe11.3,11x,1pe11.3)
 530	format('  Z      Q||',
     >	'       FORCE    FRICTION',
     >	'   GRAD||P   N*GRAD||T')
 550	format(i3,1p8e11.3)
	write(*,560)sumflow/sumaflow,parcurrent,
     >	totmass*acci,epar
 560	format(/' NORMALIZED NET MASS FLOW, SUM(RHO*U)/SUM(RHO*|U|)',
     >	' -> 0 (U = U||-UMASS) = ',1pe11.3,
     >	/' J||(calc) = ',1pe11.3,/,
     >	' MEAN INERTIAL TERM RHO*AI   = ',1pe11.3,/,
     >	' E||     = ',1pe11.3/)
	return	
	end
c---- End of subroutine printit ----------------------------------------
c-----------------------------------------------------------------------
	subroutine setden(amu,den,denmass,denz,denz2,zi)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real amu(miso), denz2(miso)
	real den(miso,0:nzch), denmass(miso,0:nzch), denz(miso,*)
	real zi(miso,*)
c*****	Sum over isotopes for electron density-isotope 1.
	do misa = 2,miso
	  do nza = 1,natom(misa)
	    denz(misa,nza) = den(misa,nza)*real(nza)*coulom
	  enddo
	enddo
	denz(1,1) = -den(1,1)*coulom
c*****	Compute mass-density, ZI, SUM(ZI), and total mass density
	totmass = zero
	do misa = 1,miso
	  bmass = amu(misa)*promas
	  denz2(misa)=zero
	  do nza = 1,natom(misa)
	    denmass(misa,nza) = bmass*den(misa,nza)
	    zi(misa,nza) = den(misa,nza)*real(nza)**2
	    denz2(misa)=denz2(misa) + zi(misa,nza)
	    totmass = totmass + denmass(misa,nza)
	  enddo
	enddo
c*****	Compute neutral mass-density
	do misa = 2,miso
	  denmass(misa,0) = amu(misa)*promas*den(misa,0)
	enddo
c*****	Provide pedestal for zi to avoid matrix inversion singularity
	ziped = 1.E-4
	do misa=1,miso
	  zisum = zero
	  do nza=1,natom(misa)
	    zi(misa,nza)=zi(misa,nza)/denz2(misa) + ziped
	    zisum = zisum + zi(misa,nza)
	  enddo
	  do nza = 1,natom(misa)	!zi normed to 1
	    zi(misa,nza) = zi(misa,nza)/zisum
	  enddo
	enddo
	return
	end
c---- End of subroutine setden -----------------------------------------
c-----------------------------------------------------------------------
	subroutine setforce(den,denz,denmass,epar,gradp,gradt,
     >	tempa,uneut,qneut,umass,fmom,nuion)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real gradp(miso,*), gradt(miso,*), nuion(miso,0:nzch),
     >	denmass(miso,0:nzch), den(miso,0:nzch), denz(miso,nzch),
     >	fmom(KXA,nzch,miso), tempa(miso), uneut(miso), qneut(miso)
c
c	COMPUTE FORCES PROPORTIONAL TO GRAD(P), GRAD(T)
c
c	FMOMENTA(1,ALPHA) = GRAD(P sub alpha) -e*N*E|| - M N NU(ion)( UN - U ) delta(Z,1)
c	FMOMENTA(2,ALPHA) =-2.5 N GRAD T
c	FMOMENTA(3,ALPHA) = 0
c
	sumforce = zero
	do misa = 1,miso
	  do nz = 1,natom(misa)
	    fmom(1,nz,misa) = gradp(misa,nz) - denz(misa,nz)*epar
	    fmom(2,nz,misa) = -2.5*den(misa,nz)*gradt(misa,nz)
	    fmom(3,nz,misa) = 0.
	    if( nz.eq.1 .and. misa.ne.mise )then
	    fmom(1,nz,misa)
     >	    = fmom(1,nz,misa) - al32(1)*denmass(misa,0)*	!(Neutral mass-density)
     >	    nuion(misa,0)*(uneut(misa) - umass)
	    presa = den(misa,nz)*tempa(misa)
	    fmom(2,nz,misa)
     >	    = fmom(2,nz,misa) - al32(2)*denmass(misa,0)*	!(Neutral mass-density)
     >	    nuion(misa,0)*(-2.*qneut(misa)/(5.*presa))
	   endif
	    sumforce = sumforce - fmom(1,nz,misa)
	  enddo
	enddo
	return
	end
c---- End of subroutine setforce ---------------------------------------
c-----------------------------------------------------------------------
	subroutine uinvm2(k,n,a,b,x,nrow,scas,lss,msbs,
     .	nbrt,istore,iflag)
c	ALSO, BE SURE TO LINK IN BLAS LIBRARY (-LBLAS)
	implicit real (a-h,o-z), integer(i-n)
c*****	******************************************************************
c*****	UINVM2 performs the matrix inversion for a system of k equations *
c*****	each having n points.                                           *
c*****	Previous Last Revision: 3/90 W.A.Houlberg ORNL.                  *
c*****	Last Revision: 5/94 S.P.Hirshman ORNL (multiple right sides)     *
c*****	        and BLAS routines                                 *
c*****	Input:                                                           *
c*****	k-number of equations per block.                                 *
c*****	n-number of nodes in each equation (number of blocks)            *
c*****	nbrt-number of right hand sides (independent source terms)       *
c*****	a(n*k*(3*k))-coefficient array.                                  *
c*****	b(n*k,nbrt)-right sides (sources) loaded as 1-D vector b(k,n,nbrt)   *
c*****	loaded as one dimensional x(n,k,nbrt).                           *
c*****	iflag: if non-zero, routine is being called with previously
c*****	istore: if non-zero, store for restart scas,lss,msb vectors
c*****	       computed values of nrow, a
c*****	       use iflag != 0 for incremental update
c*****	Output:                                                          *
c*****	x(n*k,nbrt)-solution array loaded as one dimensional x(k,n,nbrt).*
c*****	nrow(i)-record of row permutations for i-th row of matrix a      *
c*****	 during the gaussian elimination with partial pivoting.   *
c*****	 dimension in calling routine must be >= n*k              *
c*****	iflag-error flag for solution.                                   *
c*****	=0 normal solution.                                         *
c*****	=1 singular matrix found in inverting a.                    *
c*****	Comments:                                                        *
c*****	We wish to approximate the solution of the system of linear     *
c*****	equations fx=b where f is a block tridiagonal matrix of order n *
c*****	and each block is of order k. thus there n*k equations in the   *
c*****	system. Let f(i,j) represent the (i,j) block of the matrix f.   *
c*****	Let b(i) denote the corresponding k by 1 block of the vector b. *
c*****	Then the 3k X n*k array a contains on entry into UINVM the   *
c*****	nontrivial information to describe the coefficient matrix f.    *
c*****	The matrix "A"           is described more easily by displaying *
c*****	the transpose of "A" which follows (note: "A" is stacked            *
c*****	so that the diagonal elements are aligned in the same column)   *
c*****	0 block    f(1,1)      f(1,2)   b(1)   1st k eqns..             *
c*****	f(2,1)     f(2,2)     f(2,3)    b(2)   next k eqns..            *
c*****	...        ...        ...      ...    ...                       *
c*****	f(n-1,n-2) f(n-1,n-1) f(n-1,n)  b(n-1) next to last k eqns..    *
c*****	f(n,n-1)   f(n,n)     0 block   b(n)   last k eqns..            *
*	INDEXING OF MATRIX A
*	F(I,J,M,N)*X(N,J) = B(M,I)    ,   AMAT(L) = LMAT(I,J,M,N) strung out
*
*	HERE, 1 <= (M,N) <= J,  1 <= I <= N,  I-1 <= J <= I+1
*
*	THUS, A(L) = LMAT(I,J,M,N) FOR
*
*	L = N + (M-1)*KX3 + (J-I+1)*K + (I-1)*KSQ3
*
*	WHERE KX3 = 3*K (OR 3*K+1 for original version), KSQ3 = K * KX3
*
c*****	Partial pivoting is within a subblock of k rows.                *
c*****	For full partial pivoting we would have to search over 2k rows  *
c*****	for the pivot element.                                          *
c*****	Double precision may be required for s,sca,anor,raia,raig,x,a.  *
c*****	******************************************************************
	real a(3*n*k*k), b(n*k,nbrt), x(n*k,nbrt), scas(*)
	integer lss(*), msbs(*)
	integer nrow(n*k)
	nk=n*k
	km1=k-1
	k2m1=k+km1
	k2=k+k
	k3=k2+k
c*****	Previously computed a-matrix inversion
	if( iflag.ne.0 )goto 1000
c*****	Shift first row blocks 1 block to left (on input, 1st block = 0)
	na=0
	do 30 j=1,k
	  napk=na+k
	  call dcopy(k2,a(napk+1),1,a(na+1),1)
	  napk2=na+k2
	  do i=1,k
	    a(napk2+i)=0.0
	  enddo
	  na=na+k3
 30	continue
	na=0
	do i=1,nk
	  nrow(i)=na
	  na=na + k3
	enddo
 1000	continue
c*****	Begin loop through n blocks.
c*****	nl=(iblock-1)*k+1,  nh=(iblock+1)*k  for iblock=1,...,n-1.
	nl=1
	icount = 0
	do 50 iblock = 1,n
	  nh=nl+k2m1
	  nhs=nl+km1
	  kblock = k
	  krow = k3
	  if( iblock.eq.n )then
	    nh = nk
	    nhs= nk
	    kblock = km1
	    krow = k
	  endif
	  do 90 j=1,kblock
c*****	Determine element of maximum modulus in next column.
c*****	Only allow permutations within blocks of k rows.
	    if( iflag.ne.0 )goto 1010
	    s=0.0
	    do l=nl,nhs
	      sa=a(nrow(l)+j)
	      if(sa.lt.0.0) sa=-sa
	      if(s.lt.sa) then
	        ni=l   	    	    !Pivot row
	        s=sa
	      endif
	    enddo
	    if(s.eq.0.0) then
c*****	Singular matrix found.
	      iflag=1
	      return
	    endif
c*****	Row exchange (pivot)
	    ms=nrow(ni)
	    nrow(ni)=nrow(nl)
	    nrow(nl)=ms
	    anor=a(ms+j)
	    jp1=j+1
 1010	    continue
	    nl=nl+1
c*****	Gaussian elimination within block
	    do l=nl,nh
	      icount = icount+1
	      if( iflag.eq.0 )then
	        sca=a(nrow(l)+j)
	        if(sca.ne.0.0) then
	          sca=sca/anor
c*****	  Subtract pivot row elements (ms) from row (l) elements
	          call saxpy(krow-jp1+1,-sca,a(ms+jp1),1,
     >	          a(nrow(l)+jp1),1)
	        endif
	        ls = nrow(l)/k3 + 1
	        msb= ms/k3 + 1
	        if( istore.ne.0 )then
	          lss(icount) = ls
	          msbs(icount) = msb
	          scas(icount) = sca
	        endif
	      else
	        ls = lss(icount)
	        msb= msbs(icount)
	        sca = scas(icount)
	      endif
c*****	  Subtract pivot row right side from other right-hand side(s)
	      if(sca.ne.0.0)call saxpy(nbrt,-sca,b(msb,1),nk,b(ls,1),nk)
	    enddo
 90	  continue
c*****	Move block 2 to 1, block 3 to 2, 0 out block 3 of rows used in
c*****	this stage that will also be used in next.
	  if( iblock.ne.n .and. iflag.eq.0 )then
	    do l=nl,nh
	      call dcopy(k2,a(nrow(l)+k+1),1,a(nrow(l)+1),1)
	      do j=1,k
	        a(nrow(l)+j+k2)=0.0
	      enddo
	    enddo
	  endif
	  if(nh.gt.nk) call xerrab('uinvm2:  nh > nk')
 50	continue
	if( icount .gt. 2*k*k*n ) call xerrab('uinvm2:  icount > 2*k*k*n')
c*****	Process back substitution in blocks of k equations.  1st 2 blocks
c*****	are special, but have special coding only for the 1st block.
	if(a(nrow(nk)+k).eq.0.0) then
c*****	Singular matrix found.
	  iflag=1
	  return
	endif
	do 100 lb = 1,nbrt
	  nkb = nrow(nk)/k3 + 1
	  x(nk,lb)=b(nkb,lb)/a(nrow(nk)+k)
	  neq=nk-1
	  if(k.ne.1) then
	    ntrm=1
	    do lk=km1,1,-1
	      neqb = nrow(neq)/k3 + 1
	      s = b(neqb,lb) -
     >	      sdot(ntrm,x(neq+1,lb),1,a(nrow(neq)+lk+1),1)
	      x(neq,lb)=s/a(nrow(neq)+lk)
	      ntrm=ntrm+1
	      neq=neq-1
	    enddo
	  endif
	  if( neq.le.0 )goto 100
 180	  ntrm=k
	  do lk=k,1,-1
	    neqb = nrow(neq)/k3 + 1
	    s = b(neqb,lb) -
     >	    sdot(ntrm,x(neq+1,lb),1,a(nrow(neq)+lk+1),1)
	    x(neq,lb)=s/a(nrow(neq)+lk)
	    ntrm=ntrm+1
	    neq=neq-1
	  enddo
	  if(neq.gt.0) goto 180
 100	continue
	iflag=0
	return
	end
c---- End of subroutine uinvm2 -----------------------------------------
c-----------------------------------------------------------------------
	subroutine zrespond(den,denmass,zi,ela,nuion,nurec,
     >	uresp,usave,caplams,fmom,ldir)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	parameter( NSIZE = 2*KXA*KXA*MXNZCH )
	real zmat(KNX,MXMISO), source(KXA*MXNZCH,MXMISO)
	real amat(KNX), asource(KXA*MXNZCH*NBA)
	real den(miso,0:nzch), zi(miso,nzch), ela(KXA,KXA,miso)
	real nuion(miso,0:nzch), nurec(miso,nzch)
	real uresp(KXA,nzch,miso,NBA), usave(KXA,nzch,miso)
	real fmom(KXA,nzch,miso),denmass(miso,0:nzch)
	real caplams(KXA,miso), xsol(NBA*KXA*MXNZCH)
	real scaz(NSIZE,MXMISO)
	integer nrowz(KXA*MXNZCH,MXMISO), lsz(NSIZE,MXMISO),
     >	msz(NSIZE,MXMISO)
	save zmat, source, scaz, lsz, msz, nrowz
c
c	FOR LDIR > 1, DO COMPLETE NEW MATRIX INVERSION
c	FOR LDIR <=1, DO INCREMENTAL MATRIX INVERSION, USING
c
c	[ ZMAT(old) + del-ZMAT ][USOL(old) + del-U] = SOURCE + del-SOURCE
c
c	==>   ZMAT(old)*USOL(new) = S(new) + [S(old) - ZMAT(new)*USOL(old)]
c
c	HERE, ZMAT(new)*USOL(old) = ZMAT*USAVE - S(IACCI)*ACCI(old) -
c
c	 - S(1)*CAPLAM(1) - S(2)*CAPLAM(2) - S(3)*CAPLAM(3)
c
c
c	COMPUTE NORMS FOR AI
c	AI = ANORM * aI, WHERE
c	ANORM = SUM(ela(1,1,a))/SUM(DENMASS)
c
	elsum = zero
	do misa = 1,miso
	  elsum = elsum + ela(1,1,misa)
	enddo
	anorm = elsum / totmass
c
c	FOR EACH FIXED ISOTOPE, COMPUTE RESPONSE FUNCTIONS WHICH SOLVE
c	THE EQUATION (FOR ALPHA FIXED)
c
c	ZMAT(m,Z,mm,ZZ) u(mm,ZZ;k) = SOURCE(m,Z;k)
c
c	WHERE FOR
c
c	k = 1, 2, 3 [ uresp(m,Z;k) == ULAMk ]
c
c	SOURCE(m,Z;k)  = +ZI(alpha,Z) delta(m,k)
c
c	k = 4 [uresp(m,Z;k) == UACCI] SOURCE = DEN(alpha,Z)*MASS(alpha) delta(m,1)
c
c	k = 5 [uresp(m,Z;k) == UFORC] SOURCE = FORCE(alpha,m,Z)   (see paper...)
c
c	THEN, THE SOLUTION (IN TERMS OF THE INTER-SPECIES COUPLING TERMS
c	LAMBDA AND OTHER DRIVING TERMS) IS:
c
c	u(alpha,m,Z) =  SUM(k=1,2,3) [-ULAMk * LAMBDA(alpha,k) ]
c
c	          + UACCI * AI + UFORC
c
c	NOTE THAT THE ORDERING (STACKING) OF SOURCE AND URESP IS THE
c	SAME (SEE SUBROUTINE ZSOURCE FOR DETAILS)
c
	kx3 = 3*KXA
	kxsq3 = kx3 * KXA
	do 100 misa = 1,miso
	nz = natom(misa)
	nkz = nz * KXA
	nresp = NBA*nkz		!Number of response array elements per isotope
	nknz = kxsq3*nz
c
c	SET UP SOURCE TERMS: SOURCE(M,Z,k=1,NBA)
c	NOTE: Z = 1,NATOM IS DIFFERENT SIZE FOR EACH ISOTOPE
c

c ... Initalize asource array.
        do i=1,nresp
          asource(i)=zero
        enddo

	call zsource(asource,zi,den,fmom(1,1,misa),denmass,misa,nz)
	nforc = nkz*(iforc-1)
	nacci = nkz*(iacci-1)
	if( ldir.le.1 )then
	do i = 1,nkz
	asource(i+nforc) = asource(i+nforc) + ( source(i,misa) +
     >  asource(i+nacci)*acci0 -
     >	(asource(i)*caplams(1,misa) + asource(i+nkz)*caplams(2,misa)
     >	+asource(i+2*nkz)*caplams(3,misa)) )
	enddo
	endif
c
c	SET UP Z-MATRIX ARRAY ELEMENTS
c

c ... Initialize amat array.
        do i=1,nknz
          amat(i)=zero
        enddo

	do 10 m = 1,KXA
	do 10 mp= 1,KXA
	i1 = mp + kx3*(m-1)
	i2 = m + nforc
	do 10 jz= 1,nz
	index = i1 + (jz-1)*kxsq3	!consecutive block-by-block index
	is = i2 + (jz-1)*KXA
c
c	LOWER DIAGONAL ELEMENTS (IONIZATION FROM LOWER CHARGE STATE)
c
	ozi = al32(m)/zi(misa,jz)
	if (jz.gt.1)then
	  jp = jz-1
	  if( (m.eq.mp) )then
	  amat(index) = ozi*denmass(misa,jp)*nuion(misa,jp)
	  if( ldir.le.1 )
     >	  asource(is) = asource(is) - amat(index)*usave(mp,jp,misa)
	  endif
	endif
c
c	DIAGONAL ELEMENTS
c
	index = index + KXA
	amat(index) = ela(m,mp,misa)
	if( (m.eq.mp) )
     >	amat(index) = amat(index) - denmass(misa,jz)*
     >	( nuion(misa,jz) + nurec(misa,jz) )*ozi
	if( ldir.le.1 )
     >	asource(is) = asource(is) - amat(index)*usave(mp,jz,misa)
c
c	UPPER DIAGONAL ELEMENTS (RECOMBINATION FROM HIGHER CHARGE STATE)
c
	if (jz.lt.nz)then
	  index = index + KXA
	  jp = jz+1
	  if( (m.eq.mp) )then
	  amat(index) = ozi*denmass(misa,jp)*nurec(misa,jp)
	  if( ldir.le.1 )
     >	  asource(is) = asource(is) - amat(index)*usave(mp,jp,misa)
	  endif
	endif
 10	continue
c
c	SOLVE TRIDIAGONAL SYSTEM WITH NBA RIGHT SIDES STORED IN SOURCE
c	STORE FOR FAST (INCREMENTAL) RECALCULATION (LDIR = 0,1)
c
	noff = 1 + nforc
	istore = 1
	if( ldir.gt.1 )then
	  call dcopy(nkz,asource(noff),1,source(1,misa),1)
	  lflag = 1
	  noff = 1
	  nr = NBA
	  iflag = 0
	else
	  lflag = iforc
	  nr = 1
	  iflag = 1
	  call dcopy(nknz,zmat(1,misa),1,amat,1)
	endif
	call uinvm2(KXA,nz,amat,asource(noff),xsol(noff),
     >	nrowz(1,misa),scaz(1,misa),lsz(1,misa),msz(1,misa),
     >	nr,istore,iflag)
	if( ldir.gt.1 )call dcopy(nknz,amat,1,zmat(1,misa),1)
	if( iflag.ne.0 )then
	print *,' CALL TO UINVM2 FAILED! '
	call kaboom(0)
	endif
c
c	STORE SOLUTION VECTOR IN RESPONSE ARRAY URESP FOR EACH ISOTOPE
c	URESP(KXA=1,2,3,NATOM,n=1,..,NBA).
c	Note response arrays are arranged consecutively
c
	do ntype = lflag,NBA
	noff = 1 + nkz*(ntype-1)
	call dcopy(nkz,xsol(noff),1,uresp(1,1,misa,ntype),1)
	enddo
 100	continue
	return
	end
c---- End of subroutine zrespond ---------------------------------------
c-----------------------------------------------------------------------
	subroutine zsource(source,zi,den,fmom,denmass,misa,nz)
	      use Reduced_ion_constants 
  	implicit real (a-h,o-z), integer (i-n)
	real zi(miso,*), den(miso,0:nz), source(KXA,nz,NBA), fmom(KXA,*)
	real denmass(miso,0:nz)
	do 20 jz= 1,nz
	do 20 m = 1,KXA
	if( m.eq.1 )then
	  source(m,jz,ilam1) = one
	  source(m,jz,iacci) = denmass(misa,jz) * anorm / zi(misa,jz)
	else if( (m.eq.ilam2) .or. (m.eq.ilam3) )then
	  source(m,jz,m) = one
	endif
	source(m,jz,iforc) = fmom(m,jz)/zi(misa,jz)
 20	continue
	return
	end
c---- End of subroutine zsource ----------------------------------------
c-----------------------------------------------------------------------

      function scal10 (y)
*     ------------------------------------------------------------------
*     This service routine can be used to compute a proper scale for
*     graphical output. scal10(y) returns the least in magnitude
*     real value r with abs(r) .ge. abs(y) and which has a decimal
*     representation of the form
*           r  =  0,  or
*           r  =  sgn(y) * i1 * 10.0 ** i2
*     where i1 is 2 or 5 or 10, and i2 is an integer.
*     ------------------------------------------------------------------
      real y
      integer i1, i2
      real r1
      real scal10
      real one
      data one /1./
*     ------------------------------------------------------------------
      if (y .eq. 0) then
         scal10 = 0
      else
         i2 = nint (log10(abs(y)) - 0.5)
         r1 = abs(y) * 10.0e0 ** (-i2)
*        r1 is in the range (1 .. 10), to machine accuracy.
         if (r1 .le. 2) then
            i1 = 2
         else if (r1 .le. 5) then
            i1 = 5
         else
            i1 = 10
         end if
         scal10 = sign(one, y) * i1 * 10.0 ** (i2)
* xlf95 wants the above.  Cannot replace one by 1.0
      end if
*     ------------------------------------------------------------------
      return
*     ------------------------------------------------------------------
      end

c *********************************************************************
      subroutine quadsvr (neq,xs,xs1,xs2,xs3,ys1,ys2,ys3,yq1,yq2)

cc    This routine calculates two guesses to all of the plasma
cc    variables base on a quadratic for the control parameter xs.
cc    The solution closest to the present one is in yq1, and the
cc    second one is in yq2.

      implicit none

c **--input variables--**
      integer neq           ! number of equations
      real xs,xs1,xs2,xs3   ! new xs & previous values xs1,xs2, & xs3
      real ys1(neq),ys2(neq),ys3(neq)  ! previous solutions
                            	       ! correponding to xs1, xs2, xs3

c **--output variables--**    ! Two solutions to quadratic, yq1 and yq2
      real yq1(neq),yq2(neq)  ! yq1 is closest to solution ys1

c **--local variables--**
      integer iq
      real dn1,dn2,dn3,aq,bq,cq,discr,srt,yqtemp
      real epsi
      real zero
      data zero /0/
      data epsi/1.e-30/

      do iq = 1, neq
         dn1 = xs1 / ( (ys2(iq)-ys1(iq))*(ys3(iq)-ys1(iq)) + epsi)
         dn2 = xs2 / ( (ys1(iq)-ys2(iq))*(ys3(iq)-ys2(iq)) + epsi)
         dn3 = xs3 / ( (ys1(iq)-ys3(iq))*(ys2(iq)-ys3(iq)) + epsi)
         aq = dn1 + dn2 + dn3
         bq = - (ys2(iq)+ys3(iq))*dn1 - (ys1(iq)+ys3(iq))*dn2 - 
     .                                  (ys1(iq)+ys2(iq))*dn3
         cq = ys2(iq)*ys3(iq)*dn1 + ys1(iq)*ys3(iq)*dn2 + 
     .                              ys1(iq)*ys2(iq)*dn3 - xs
         discr = max( bq*bq - 4*aq*cq, zero)
* xlf95 wants the above.  Cannot replace zero by 0.
         srt = sqrt(discr)
         yq1(iq) = 0.5 * ( -bq + srt ) / aq
         yq2(iq) = 0.5 * ( -bq - srt ) / aq
         if ( abs(ys1(iq)-yq1(iq)) .gt. abs(ys1(iq)-yq2(iq)) ) then
            yqtemp = yq1(iq)
            yq1(iq) = yq2(iq)
            yq2(iq) = yqtemp
         endif
      enddo 

      return
      end
c ****end of subroutine quadsvr**********

c ****Function gettime ******************

      real(kind=4) function gettime(clk)
      real(kind=4):: clk, rcount, rrate
      integer count, rate
      gettime = 0
      call system_clock(count, rate)
      if (rate .ne. 0) then
         rcount = count
         rrate = rate
         gettime = rcount / rrate
      endif
      return
      end
c ****end of function gettime**********

#include "../mppl.h"
#include "../sptodp.h"
      function ssmin (n, sx, incx)
      integer           n, incx
      real              sx(*)
      real ssmin
*     ------------------------------------------------------------------
*     Compute minimum value in the s.p. real vector described by
*     (n, sx, incx). BLAS storage conventions.
*     n must be positive.
*     ------------------------------------------------------------------
      integer           i, ix, m
      real              t
ccc   intrinsic         min, max, mod
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         stop 'ssmin'
*        - - - - - - -
      else if (incx .eq. 1) then
*        use unrolled loops for unit increments.
         m = mod(n, 6)
         t = sx(1)
         do 1, i = 2, m
            t = min(t, sx(i))
    1    continue
         do 2, i = m+1, n, 6
            t = min(t, sx(i), sx(i+1), sx(i+2),
     .            sx(i+3), sx(i+4), sx(i+5))
    2    continue
         ssmin = t
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         t = sx(ix)
         ix = ix + incx
         do 3, i = 2, n
            t = min(t, sx(ix))
            ix = ix + incx
    3    continue
         ssmin = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/06/14---
      end
      function smax (n, sx, incx)
      integer           n, incx
      real              sx(*)
      real smax
*     ------------------------------------------------------------------
*     Compute maximum value in the s.p. real vector described by
*     (n, sx, incx). BLAS storage conventions.
*     n must be positive.
*     ------------------------------------------------------------------
      integer           i, ix, m
      real              t
ccc   intrinsic         max, mod
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         stop 'smax'
*        - - - - - - -
      else if (incx .eq. 1) then
*        use unrolled loops for unit increments.
         m = mod(n, 6)
         t = sx(1)
         do 1, i = 2, m
            t = max(t, sx(i))
    1    continue
         do 2, i = m+1, n, 6
            t = max(t, sx(i), sx(i+1), sx(i+2),
     .            sx(i+3), sx(i+4), sx(i+5))
    2    continue
         smax = t
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         t = sx(ix)
         ix = ix + incx
         do 3, i = 2, n
            t = max(t, sx(ix))
            ix = ix + incx
    3    continue
         smax = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/06/14---
      end
      function samax (n, sx, incx)
      integer           n, incx
      real              sx(*)
      real samax
*     ------------------------------------------------------------------
*     Compute maximum absolute value in the s.p. real vector described
*     by (n, sx, incx). BLAS storage conventions.
*     n must be positive.
*     ------------------------------------------------------------------
      integer           i, ix, m
      real              t
ccc   intrinsic         max, mod, abs
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         stop 'samax'
*        - - - - - - -
      else if (incx .eq. 1) then
*        use unrolled loops for unit increments.
         m = mod(n, 5)
         t = abs(sx(1))
         do 1, i = 2, m
            t = max(t, abs(sx(i)))
    1    continue
         do 2, i = m+1, n, 5
            t = max(t, abs(sx(i)), abs(sx(i+1)),
     .            abs(sx(i+2)), abs(sx(i+3)), abs(sx(i+4)))
    2    continue
         samax = t
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         t = abs(sx(ix))
         ix = ix + incx
         do 3, i = 2, n
            t = max(t, abs(sx(ix)))
            ix = ix + incx
    3    continue
         samax = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/06/14---
      end
      subroutine sfill (n, sa, sx, incx)
      integer           n, incx
      real              sa, sx(*)
*     ------------------------------------------------------------------
*     Set all elements of the s.p. real vector x equal to sa. x is
*     described by (n, sx, incx), with BLAS storage conventions.
*     Return without effects if n .lt. 1.
*     Undefined if incx .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         return
*        - - - - - - -
      else if (incx .eq. 1) then
         do 1, i = 1, n
            sx(i) = sa
    1    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         do 3, i = 1, n
            sx(ix) = sa
            ix = ix + incx
    3    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      subroutine sbias (n, sa, sx, incx)
      integer           n, incx
      real              sa, sx(*)
*     ------------------------------------------------------------------
*     Replace the s.p. real vector x by sa + x. x is described by
*     (n, sx, incx), with BLAS storage conventions.
*     Return without effects if n .lt. 1 or if sa .eq. 0.
*     Undefined if incx .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1 .or. sa .eq. 0) then
         return
*        - - - - - - -
      else if (incx .eq. 1) then
         do 1, i = 1, n
            sx(i) = sa + sx(i)
    1    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         do 3, i = 1, n
            sx(ix) = sa + sx(ix)
            ix = ix + incx
    3    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      function sadot (n, sx, incx, sy, incy)
      integer           n, incx, incy
      real              sx(*), sy(*)
      real sadot
*     ------------------------------------------------------------------
*     Compute the inner product of absolute values in two s.p. real
*     vectors described by (n, sx, incx) and (n, sy, incy).
*     BLAS storage conventions.
*     Return with sadot = 0 when n .lt. 1.
*     ------------------------------------------------------------------
      integer           i, ix, iy
      real              t
ccc   intrinsic         max, abs
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         sadot = 0
         return
*        - - - - - - -
      else if (incx .eq. 1 .and. incy .eq. 1) then
         t = 0
         do 1, i = 1, n
            t = t + abs(sx(i)*sy(i))
    1    continue
         sadot = t
         return
*        - - - - - - -
      else if (incx .eq. incy .and. incx .gt. 0) then
         t = 0
         do 3, i = 1, n*incx, incx
            t = t + abs(sx(i)*sy(i))
    3    continue
         sadot = t
         return
*        - - - - - - -
      else
         t = 0
         ix = ibase(n, incx)
         iy = ibase(n, incy)
         do 4, i = 1, n
            t = t + abs(sx(ix)*sy(iy))
            ix = ix + incx
            iy = iy + incy
    4    continue
         sadot = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-87/07/26---
      end
      subroutine sadd (n, sx, incx, sy, incy)
      integer           n, incx, incy
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Add two s.p. real vectors: y := y + x. x and y are described
*     by (n, sx, incx) and (n, sy, incy). BLAS storage conventions.
*     Return without effects if n .lt. 1.
*     Undefined if incy .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix, iy
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         return
*        - - - - - - -
      else if (incx .eq. 1 .and. incy .eq. 1) then
         do 1, i = 1, n
            sy(i) = sy(i) + sx(i)
    1    continue
         return
*        - - - - - - -
      else if (incx .eq. incy .and. incx .gt. 0) then
         do 3, i = 1, n*incx, incx
            sy(i) = sy(i) + sx(i)
    3    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         iy = ibase(n, incy)
         do 4, i = 1, n
            sy(iy) = sy(iy) + sx(ix)
            ix = ix + incx
            iy = iy + incy
    4    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      subroutine ssub (n, sx, incx, sy, incy)
      integer           n, incx, incy
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Subtract two s.p. real vectors: y := y - x. x and y are described
*     by (n, sx, incx) and (n, sy, incy). BLAS storage conventions.
*     Return without effects if n .lt. 1.
*     Undefined if incy .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix, iy
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         return
*        - - - - - - -
      else if (incx .eq. 1 .and. incy .eq. 1) then
         do 1, i = 1, n
            sy(i) = sy(i) - sx(i)
    1    continue
         return
*        - - - - - - -
      else if (incx .eq. incy .and. incx .gt. 0) then
         do 3, i = 1, n*incx, incx
            sy(i) = sy(i) - sx(i)
    3    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         iy = ibase(n, incy)
         do 4, i = 1, n
            sy(iy) = sy(iy) - sx(ix)
            ix = ix + incx
            iy = iy + incy
    4    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      subroutine scopym (n, sx, incx, sy, incy)
      integer           n, incx, incy
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Copy the negative of the s.p. real vector described by (n, sx,
*     incx) to the vector (n, sy, incy). BLAS storage conventions.
*     Return without effects if n .lt. 1.
*     Undefined if incy .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix, iy
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         return
*        - - - - - - -
      else if (incx .eq. 1 .and. incy .eq. 1) then
         do 1, i = 1, n
            sy(i) = - sx(i)
    1    continue
         return
*        - - - - - - -
      else if (incx .eq. incy .and. incx .gt. 0) then
         do 3, i = 1, n*incx, incx
            sy(i) = - sx(i)
    3    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         iy = ibase(n, incy)
         do 4, i = 1, n
            sy(iy) = - sx(ix)
            ix = ix + incx
            iy = iy + incy
    4    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      subroutine szpxy (n, sx, incx, sy, incy, sz, incz)
      integer           n, incx, incy, incz
      real              sx(*), sy(*), sz(*)
*     ------------------------------------------------------------------
*     Replace z by z + x * y. x, y, and z are s.p. real vectors,
*     described by (n, sx, incx), (n, sy, incy), and (n, sz, incz).
*     BLAS storage conventions.
*     The operations + and * are applied pointwise.
*     Return without effects if n .lt. 1.
*     Undefined if incz .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix, iy, iz
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         return
*        - - - - - - -
      else if (incx .eq. 1 .and. incy .eq. 1 .and. incz .eq. 1) then
         do 1, i = 1, n
            sz(i) = sz(i) + sx(i) * sy(i)
    1    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         iy = ibase(n, incy)
         iz = ibase(n, incz)
         do 3, i = 1, n
            sz(iz) = sz(iz) + sx(ix) * sy(iy)
            ix = ix + incx
            iy = iy + incy
            iz = iz + incz
    3    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      subroutine szmxy (n, sx, incx, sy, incy, sz, incz)
      integer           n, incx, incy, incz
      real              sx(*), sy(*), sz(*)
*     ------------------------------------------------------------------
*     Replace z by z - x * y. x, y, and z are s.p. real vectors,
*     described by (n, sx, incx), (n, sy, incy), and (n, sz, incz).
*     BLAS storage conventions.
*     The operations - and * are applied pointwise.
*     Return without effects if n .lt. 1.
*     Undefined if incz .eq. 0.
*     ------------------------------------------------------------------
      integer           i, ix, iy, iz
ccc   intrinsic         max
      integer           ibase
      ibase(n, incx)  = max(1, 1+(1-n)*incx)
*     ------------------------------------------------------------------
      if (n .lt. 1) then
         return
*        - - - - - - -
      else if (incx .eq. 1 .and. incy .eq. 1 .and. incz .eq. 1) then
         do 1, i = 1, n
            sz(i) = sz(i) - sx(i) * sy(i)
    1    continue
         return
*        - - - - - - -
      else
         ix = ibase(n, incx)
         iy = ibase(n, incy)
         iz = ibase(n, incz)
         do 3, i = 1, n
            sz(iz) = sz(iz) - sx(ix) * sy(iy)
            ix = ix + incx
            iy = iy + incy
            iz = iz + incz
    3    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      function s2min (n1, n2, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sx(*)
      real s2min
*     ------------------------------------------------------------------
*     Compute minimum value in the s.p. real matrix described by
*     (n1, n2, sx, inc1x, inc2x). BLAS**2 storage conventions.
*     n1 and n2 must be positive.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
      real              t, ssmin
ccc   intrinsic         max, min
      external          ssmin
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         stop 's2min'
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         s2min = ssmin (n1*n2, sx, inc1x)
         return
*        - - - - - - -
      else
         i2 = ibase(n2, inc2x)
         t = ssmin (n1, sx(i2), inc1x)
         i2 = i2 + inc2x
         do 1, i = 2, n2
            t = min (t, ssmin (n1, sx(i2), inc1x))
            i2 = i2 + inc2x
    1    continue
         s2min = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      function s2max (n1, n2, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sx(*)
      real s2max
*     ------------------------------------------------------------------
*     Compute maximum value in the s.p. real matrix described by
*     (n1, n2, sx, inc1x, inc2x). BLAS**2 storage conventions.
*     n1 and n2 must be positive.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
      real              t, smax
ccc   intrinsic         max
      external          smax
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         stop 's2max'
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         s2max = smax (n1*n2, sx, inc1x)
         return
*        - - - - - - -
      else
         i2 = ibase(n2, inc2x)
         t = smax (n1, sx(i2), inc1x)
         i2 = i2 + inc2x
         do 1, i = 2, n2
            t = max (t, smax (n1, sx(i2), inc1x))
            i2 = i2 + inc2x
    1    continue
         s2max = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      function s2amax (n1, n2, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sx(*)
      real s2amax
*     ------------------------------------------------------------------
*     Compute maximum absolute value in the s.p. real matrix described
*     by (n1, n2, sx, inc1x, inc2x). BLAS**2 storage conventions.
*     n1 and n2 must be positive.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
      real              t, samax
ccc   intrinsic         max
      external          samax
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         stop 's2amax'
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         s2amax = samax (n1*n2, sx, inc1x)
         return
*        - - - - - - -
      else
         i2 = ibase(n2, inc2x)
         t = samax (n1, sx(i2), inc1x)
         i2 = i2 + inc2x
         do 1, i = 2, n2
            t = max (t, samax (n1, sx(i2), inc1x))
            i2 = i2 + inc2x
    1    continue
         s2amax = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      function s2sum (n1, n2, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sx(*)
      real s2sum
*     ------------------------------------------------------------------
*     Compute sum of values in the s.p. real matrix described by
*     (n1, n2, sx, inc1x, inc2x). BLAS**2 storage conventions.
*     Return with s2sum = 0 when n1 .lt. 1 or n2 .lt. 1.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
      real              t, ssum
ccc   intrinsic         max
      external          ssum
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         s2sum = 0
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         s2sum = ssum (n1*n2, sx, inc1x)
         return
*        - - - - - - -
      else
         t = 0
         i2 = ibase(n2, inc2x)
         do 1, i = 1, n2
            t = t + ssum (n1, sx(i2), inc1x)
            i2 = i2 + inc2x
    1    continue
         s2sum = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      function s2asum (n1, n2, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sx(*)
      real s2asum
*     ------------------------------------------------------------------
*     Compute sum of absolute values in the s.p. real matrix described
*     by (n1, n2, sx, inc1x, inc2x). BLAS**2 storage conventions.
*     Return with s2asum = 0 when n1 .lt. 1 or n2 .lt. 1.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
      real              t, sasum
ccc   intrinsic         max
      external          sasum
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         s2asum = 0
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         s2asum = sasum (n1*n2, sx, inc1x)
         return
*        - - - - - - -
      else
         t = 0
         i2 = ibase(n2, inc2x)
         do 1, i = 1, n2
            t = t + sasum (n1, sx(i2), inc1x)
            i2 = i2 + inc2x
    1    continue
         s2asum = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2fill (n1, n2, sa, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sa, sx(*)
*     ------------------------------------------------------------------
*     Set all elements of the s.p. real matrix x equal to sa. x is
*     described by (n1, n2, sx, inc1x, inc2x), with BLAS**2 storage
*     conventions.
*     Return without effects if n1 .lt. 1 or n2 .lt. 1.
*     Undefined if inc1x .eq. 0 or inc2x .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
ccc   intrinsic         max
      external          sfill
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         call sfill (n1*n2, sa, sx, inc1x)
         return
*        - - - - - - -
      else
         i2 = ibase(n2, inc2x)
         do 1, i = 1, n2
            call sfill (n1, sa, sx(i2), inc1x)
            i2 = i2 + inc2x
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2scal (n1, n2, sa, sx, inc1x, inc2x)
      integer           n1, n2, inc1x, inc2x
      real              sa, sx(*)
*     ------------------------------------------------------------------
*     Replace the s.p. real matrix x by sa * x. x is described by
*     (n1, n2, sx, inc1x, inc2x), with BLAS**2 storage conventions.
*     Return without effects if min(n1, n2) .lt. 1 .or. sa .eq. 1.
*     Undefined if inc1x .eq. 0 or inc2x .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2, ibase
ccc   intrinsic         max
      external          sscal
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1 .or. sa .eq. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x) then
         call sscal (n1*n2, sa, sx, inc1x)
         return
*        - - - - - - -
      else
         i2 = ibase(n2, inc2x)
         do 1, i = 1, n2
            call sscal (n1, sa, sx(i2), inc1x)
            i2 = i2 + inc2x
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      function s2dot (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sx(*), sy(*)
      real s2dot
*     ------------------------------------------------------------------
*     Compute the inner product of two s.p. real matrices described
*     by (n1, n2, sx, inc1x, inc2x) and (n1, n2, sy, inc1y, inc2y).
*     BLAS**2 storage conventions.
*     Return with s2dot = 0 when n1 .lt. 1 .or. n2 .lt. 1.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
      real              t
ccc   intrinsic         max
      real              sdot
      external          sdot
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         s2dot = 0
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         s2dot = sdot (n1*n2, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         t = 0
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            t = t + sdot (n1, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         s2dot = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-86/02/21---
      end
      function s2adot (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sx(*), sy(*)
      real s2adot
*     ------------------------------------------------------------------
*     Compute the inner product of absolute values in two s.p. real
*     matrices described by (n1, n2, sx, inc1x, inc2x) and
*     (n1, n2, sy, inc1y, inc2y). BLAS**2 storage conventions.
*     Return with s2adot = 0 when n1 .lt. 1 .or. n2 .lt. 1.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
      real              t
ccc   intrinsic         max
      real              sadot
      external          sadot
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         s2adot = 0
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         s2adot = sadot (n1*n2, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         t = 0
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            t = t + sadot (n1, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         s2adot = t
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-87/07/26---
      end
      subroutine s2add (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Add two s.p. real matrices: y := y + x. x and y are described
*     by (n1, n2, sx, inc1x, inc2x) and (n1, n2, sy, inc1y, inc2y),
*     with BLAS**2 storage conventions.
*     Return without effects if n1 .lt. 1 .or. n2 .lt. 1.
*     Undefined if inc1y .eq. 0 or inc2y .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
ccc   intrinsic         max
      external          sadd
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         call sadd (n1*n2, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            call sadd (n1, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2sub (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Subtract two s.p. real matrices: y := y - x. x, y are described
*     by (n1, n2, sx, inc1x, inc2x) and (n1, n2, sy, inc1y, inc2y),
*     with BLAS**2 storage conventions.
*     Return without effects if n1 .lt. 1 .or. n2 .lt. 1.
*     Undefined if inc1y .eq. 0 or inc2y .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
ccc   intrinsic         max
      external          ssub
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         call ssub (n1*n2, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            call ssub (n1, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2copy (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Copy the s.p. real matrix described by (n1, n2, sx, inc1x,
*     inc2x) to the matrix described by (n1, n2, sy, inc1y, inc2y),
*     with BLAS**2 storage conventions.
*     Return without effects if n1 .lt. 1 .or. n2 .lt. 1.
*     Undefined if inc1y .eq. 0 or inc2y .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
ccc   intrinsic         max
      external          scopy
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         call scopy (n1*n2, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            call scopy (n1, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2copm (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sx(*), sy(*)
*     ------------------------------------------------------------------
*     Copy the negative of the s.p. real matrix described by
*     (n1, n2, sx, inc1x, inc2x) to the matrix described by
*     (n1, n2, sy, inc1y, inc2y), with BLAS**2 storage conventions.
*     Return without effects if n1 .lt. 1 .or. n2 .lt. 1.
*     Undefined if inc1y .eq. 0 or inc2y .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
ccc   intrinsic         max
      external          scopym
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         call scopym (n1*n2, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            call scopym (n1, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/09/30---
      end
      subroutine s2axpy (n1, n2, sa, sx, inc1x, inc2x,
     .                  sy, inc1y, inc2y)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y
      real              sa, sx(*), sy(*)
*     ------------------------------------------------------------------
*     Set y := y + sa * x. x and y are s.p. real matrices, described
*     by (n1, n2, sx, inc1x, inc2x) and (n1, n2, sy, inc1y, inc2y).
*     BLAS**2 storage conventions.
*     Return without effects if min(n1, n2) .lt. 1 or sa .eq. 0.
*     Undefined if inc1y .eq. 0 or inc2y .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, ibase
ccc   intrinsic         max
      external          saxpy
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y) then
         call saxpy (n1*n2, sa, sx, inc1x, sy, inc1y)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         do 1, i = 1, n2
            call saxpy (n1, sa, sx(i2x), inc1x, sy(i2y), inc1y)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2zpxy (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y,
     .                  sz, inc1z, inc2z)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y,
     .                  inc1z, inc2z
      real              sx(*), sy(*), sz(*)
*     ------------------------------------------------------------------
*     Set z := z + x * y (pointwise). x, y, and z are s.p. real
*     matrices, described by (n1, n2, sx, inc1x, inc2x), (n1, n2,
*     sy, inc1y, in2y), and (n1, n2, sz, inc1z, inc2z). BLAS**2 storage
*     conventions.
*     Return without effects if n1 .lt. 1 or n2 .lt. 1.
*     Undefined if inc1z .eq. 0 or inc2z .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, i2z, ibase
ccc   intrinsic         max
      external          szpxy
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y
     .      .and. n1*inc1z .eq. inc2z) then
         call szpxy (n1*n2, sx, inc1x, sy, inc1y, sz, inc1z)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         i2z = ibase(n2, inc2z)
         do 1, i = 1, n2
            call szpxy (n1, sx(i2x), inc1x, sy(i2y), inc1y,
     .            sz(i2z), inc1z)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
            i2z = i2z + inc2z
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      subroutine s2zmxy (n1, n2, sx, inc1x, inc2x, sy, inc1y, inc2y,
     .                  sz, inc1z, inc2z)
      integer           n1, n2, inc1x, inc2x, inc1y, inc2y,
     .                  inc1z, inc2z
      real              sx(*), sy(*), sz(*)
*     ------------------------------------------------------------------
*     Set z := z - x * y (pointwise). x, y, and z are s.p. real
*     matrices, described by (n1, n2, sx, inc1x, inc2x), (n1, n2,
*     sy, inc1y, in2y), and (n1, n2, sz, inc1z, inc2z). BLAS**2 storage
*     conventions.
*     Return without effects if n1 .lt. 1 or n2 .lt. 1.
*     Undefined if inc1z .eq. 0 or inc2z .eq. 0.
*     ------------------------------------------------------------------
      integer           i, i2x, i2y, i2z, ibase
ccc   intrinsic         max
      external          szmxy
      ibase(n1, inc1x) = max(1, 1+(1-n1)*inc1x)
*     ------------------------------------------------------------------
      if (n1 .lt. 1 .or. n2 .lt. 1) then
         return
*        - - - - - - -
      else if (n1*inc1x .eq. inc2x .and. n1*inc1y .eq. inc2y
     .      .and. n1*inc1z .eq. inc2z) then
         call szmxy (n1*n2, sx, inc1x, sy, inc1y, sz, inc1z)
         return
*        - - - - - - -
      else
         i2x = ibase(n2, inc2x)
         i2y = ibase(n2, inc2y)
         i2z = ibase(n2, inc2z)
         do 1, i = 1, n2
            call szmxy (n1, sx(i2x), inc1x, sy(i2y), inc1y,
     .            sz(i2z), inc1z)
            i2x = i2x + inc2x
            i2y = i2y + inc2y
            i2z = i2z + inc2z
    1    continue
         return
*        - - - - - - -
      end if
*     ---------------------------------------------------BJB-83/04/06---
      end
      INTEGER FUNCTION IDAMAX_U(N,DX,INCX)
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
*  Purpose
*  =======
*
*     IDAMAX finds the index of element having max. absolute value.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DMAX
      INTEGER I,IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS
*     ..
      IDAMAX_U = 0
      IF (N.LT.1 .OR. INCX.LE.0) RETURN
      IDAMAX_U = 1
      IF (N.EQ.1) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
         DMAX = DABS(DX(1))
         DO I = 2,N
            IF (DABS(DX(I)).GT.DMAX) THEN
               IDAMAX_U = I
               DMAX = DABS(DX(I))
            END IF
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         IX = 1
         DMAX = DABS(DX(1))
         IX = IX + INCX
         DO I = 2,N
            IF (DABS(DX(IX)).GT.DMAX) THEN
               IDAMAX_U = I
               DMAX = DABS(DX(IX))
            END IF
            IX = IX + INCX
         END DO
      END IF
      RETURN
      END
      DOUBLE PRECISION FUNCTION DASUM_U(N,DX,INCX)
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
*  Purpose
*  =======
*
*     DASUM takes the sum of the absolute values.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,M,MP1,NINCX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DABS,MOD
*     ..
      DASUM_U = 0.0d0
      DTEMP = 0.0d0
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*        code for increment equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,6)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DTEMP + DABS(DX(I))
            END DO
            IF (N.LT.6) THEN
               DASUM_U = DTEMP
               RETURN
            END IF
         END IF
         MP1 = M + 1
         DO I = MP1,N,6
            DTEMP = DTEMP + DABS(DX(I)) + DABS(DX(I+1)) +
     $              DABS(DX(I+2)) + DABS(DX(I+3)) +
     $              DABS(DX(I+4)) + DABS(DX(I+5))
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            DTEMP = DTEMP + DABS(DX(I))
         END DO
      END IF
      DASUM_U = DTEMP
      RETURN
      END
      SUBROUTINE DAXPY_U(N,DA,DX,INCX,DY,INCY)
*     .. Scalar Arguments ..
      DOUBLE PRECISION DA
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
*  Purpose
*  =======
*
*     DAXPY constant times a vector plus a vector.
*     uses unrolled loops for increments equal to one.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (DA.EQ.0.0d0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,4)
         IF (M.NE.0) THEN
            DO I = 1,M
               DY(I) = DY(I) + DA*DX(I)
            END DO
         END IF
         IF (N.LT.4) RETURN
         MP1 = M + 1
         DO I = MP1,N,4
            DY(I) = DY(I) + DA*DX(I)
            DY(I+1) = DY(I+1) + DA*DX(I+1)
            DY(I+2) = DY(I+2) + DA*DX(I+2)
            DY(I+3) = DY(I+3) + DA*DX(I+3)
         END DO
      ELSE
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
          DY(IY) = DY(IY) + DA*DX(IX)
          IX = IX + INCX
          IY = IY + INCY
         END DO
      END IF
      RETURN
      END
      SUBROUTINE DCOPY_U(N,DX,INCX,DY,INCY)
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
*  Purpose
*  =======
*
*     DCOPY copies a vector, x, to a vector, y.
*     uses unrolled loops for increments equal to one.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,7)
         IF (M.NE.0) THEN
            DO I = 1,M
               DY(I) = DX(I)
            END DO
            IF (N.LT.7) RETURN
         END IF   
         MP1 = M + 1
         DO I = MP1,N,7
            DY(I) = DX(I)
            DY(I+1) = DX(I+1)
            DY(I+2) = DX(I+2)
            DY(I+3) = DX(I+3)
            DY(I+4) = DX(I+4)
            DY(I+5) = DX(I+5)
            DY(I+6) = DX(I+6)
         END DO
      ELSE      
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DY(IY) = DX(IX)
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END
      DOUBLE PRECISION FUNCTION DDOT_U(N,DX,INCX,DY,INCY)
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
*  Purpose
*  =======
*
*     DDOT forms the dot product of two vectors.
*     uses unrolled loops for increments equal to one.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      DDOT_U = 0.0d0
      DTEMP = 0.0d0
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,5)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DTEMP + DX(I)*DY(I)
            END DO
            IF (N.LT.5) THEN
               DDOT_U=DTEMP
            RETURN
            END IF
         END IF
         MP1 = M + 1
         DO I = MP1,N,5
          DTEMP = DTEMP + DX(I)*DY(I) + DX(I+1)*DY(I+1) +
     $            DX(I+2)*DY(I+2) + DX(I+3)*DY(I+3) + DX(I+4)*DY(I+4)
         END DO
      ELSE
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DTEMP = DTEMP + DX(IX)*DY(IY)
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      DDOT_U = DTEMP
      RETURN
      END
      DOUBLE PRECISION FUNCTION DNRM2_U(N,X,INCX)
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION X(*)
*     ..
*
*  Purpose
*  =======
*
*  DNRM2 returns the euclidean norm of a vector via the function
*  name, so that
*
*     DNRM2 := sqrt( x'*x )
*
*  Further Details
*  ===============
*
*  -- This version written on 25-October-1982.
*     Modified on 14-October-1993 to inline the call to DLASSQ.
*     Sven Hammarling, Nag Ltd.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER (ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION ABSXI,NORM,SCALE,SSQ
      INTEGER IX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC ABS,SQRT
*     ..
      IF (N.LT.1 .OR. INCX.LT.1) THEN
          NORM = ZERO
      ELSE IF (N.EQ.1) THEN
          NORM = ABS(X(1))
      ELSE
          SCALE = ZERO
          SSQ = ONE
*        The following loop is equivalent to this call to the LAPACK
*        auxiliary routine:
*        CALL DLASSQ( N, X, INCX, SCALE, SSQ )
*
          DO 10 IX = 1,1 + (N-1)*INCX,INCX
              IF (X(IX).NE.ZERO) THEN
                  ABSXI = ABS(X(IX))
                  IF (SCALE.LT.ABSXI) THEN
                      SSQ = ONE + SSQ* (SCALE/ABSXI)**2
                      SCALE = ABSXI
                  ELSE
                      SSQ = SSQ + (ABSXI/SCALE)**2
                  END IF
              END IF
   10     CONTINUE
          NORM = SCALE*SQRT(SSQ)
      END IF
*
      DNRM2_U = NORM
      RETURN
*
*     End of DNRM2.
*
      END
      SUBROUTINE DSCAL_U(N,DA,DX,INCX)
*     .. Scalar Arguments ..
      DOUBLE PRECISION DA
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*)
*     ..
*
*  Purpose
*  =======
*
*     DSCAL scales a vector by a constant.
*     uses unrolled loops for increment equal to one.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,M,MP1,NINCX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
*
*        clean-up loop
*
         M = MOD(N,5)
         IF (M.NE.0) THEN
            DO I = 1,M
               DX(I) = DA*DX(I)
            END DO
            IF (N.LT.5) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,5
            DX(I) = DA*DX(I)
            DX(I+1) = DA*DX(I+1)
            DX(I+2) = DA*DX(I+2)
            DX(I+3) = DA*DX(I+3)
            DX(I+4) = DA*DX(I+4)
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            DX(I) = DA*DX(I)
         END DO
      END IF
      RETURN
      END
      SUBROUTINE DSWAP_U(N,DX,INCX,DY,INCY)
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DX(*),DY(*)
*     ..
*
*  Purpose
*  =======
*
*     interchanges two vectors.
*     uses unrolled loops for increments equal one.
*
*  Further Details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DTEMP
      INTEGER I,IX,IY,M,MP1
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MOD
*     ..
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*       code for both increments equal to 1
*
*
*       clean-up loop
*
         M = MOD(N,3)
         IF (M.NE.0) THEN
            DO I = 1,M
               DTEMP = DX(I)
               DX(I) = DY(I)
               DY(I) = DTEMP
            END DO
            IF (N.LT.3) RETURN
         END IF
         MP1 = M + 1
         DO I = MP1,N,3
            DTEMP = DX(I)
            DX(I) = DY(I)
            DY(I) = DTEMP
            DTEMP = DX(I+1)
            DX(I+1) = DY(I+1)
            DY(I+1) = DTEMP
            DTEMP = DX(I+2)
            DX(I+2) = DY(I+2)
            DY(I+2) = DTEMP
         END DO
      ELSE
*
*       code for unequal increments or equal increments not equal
*         to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            DTEMP = DX(IX)
            DX(IX) = DY(IY)
            DY(IY) = DTEMP
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END
c     subroutine checksizes
c 
c 
c     integer i
c     real x
c 
c     print *,"size of integer = ",sizeof(i)
c     print *,"size of real = ",sizeof(x)
c 
c     return
c     end


      

c     ------------------------------------------------------------------
      subroutine flxfin
      use Share 	!nycore,nysol,igrid
      use Dimflxgrd 	!jdim,noregs,npts,nxefit,nyefit,nlim,nwork
      use Comflxgrd 	!
      use Aeqflxgrd 	!
      use Dim 
      use Inpf 

      implicit none

      integer nunit
!
! ********* Write the file to be read by the grd package *************

      data nunit /66/
      open (nunit, file='flx-grd', form='unformatted', status='unknown')

      write(nunit) jdim,noregs,npts,nycore(igrid),nysol(igrid)
      write(nunit) jmin,jmax,jsptrx,jaxis
      write(nunit) npoint,xcurve,ycurve
      write(nunit) nxefit,nyefit
      write(nunit) xold,yold,fold
      write(nunit) fpol
      write(nunit) bcentr,rcentr,rmagx,zmagx,simagx,sibdry,
     &              rgrid1,xdim,zdim,zmid
      write(nunit) nlim
      write(nunit) xlim,ylim
      write(nunit) eshot,etime,rseps,zseps,
     &              rvsin,zvsin,rvsout,zvsout
      write(nunit) xlbnd,xubnd,ylbnd,yubnd
      write(nunit) runid
      write(nunit) geometry

      close (nunit)

ccc   call remark("***** subroutine flxfin completed")

      return
      end

c-----------------------------------------------------------------------

      subroutine grdrun
      use Dimflxgrd 	!npts
      use Comflxgrd 
      use Dimensions 	!ndata,nbkpt,nwdim,niwdim

      implicit none
      external grdinit,readflx,ingrd,grdgen,writeue,remark

c     main driver routine for grd package

      call grdinit

!!! No need to read flx-grd file (MER 08 Feb 2010)
!!! These variables are now in com package and accessible to both flx and grd
      if (isfw==1) then	! option to read flx-grd file 
         call readflx
      else		! option to transfer data via com package variables
         call gallot("Curves",0)	!uses npts,jdim
         call gallot("Transfm",0)	!uses npts,jdim,nalpha
         call gallot("Spline",0)	!uses npts,jdim,mseg
         call gallot("Transit",0)	!uses npts
         call gallot("System",0)	!uses mseg,jdim,npts,noregs
c     ...Set angle-like indices and dimensioning parameter idim
         call setidim
         call gchange("Inmesh",0)	!uses idim,noregs,npts
					!save seedxp,seedxpxl for kxmesh=0
         call gallot("Linkco",0)	!uses idim,jdim
         call gchange("Mmod",0)	!uses idim,jdim,npts
				!save nplate,rplate,zplate data when iplate=1
c     ...Set storage for SLATEC spline routine FC --
         ndata=npts
         nbkpt=npts
         nwdim=8*npts+11	! >=5*(nbkpt-1)+2*max(ndata,nbkpt)+nbkpt+16
         niwdim=2*npts-6	! >=2*(nbkpt-3)
         call gallot("Argfc",0)	!uses npts,nconst,nwdim,niwdim
c     ...Initialize x,ycurveg arrays with data from flx pkg in x,ycurve
         call copyflx
      endif		! end of option for flx-grd file

      call ingrd
      call grdgen
      call writeue

      write(*,*) '***** Grid generation has been completed'

      return
      end
